SystemOrganization addCategory: #'Refactory-AST-Nodes'!
SystemOrganization addCategory: #'Refactory-AST-Visitors'!
SystemOrganization addCategory: #'Refactory-AST-Tokens'!
SystemOrganization addCategory: #'Refactory-AST-ParseTree Matching'!
SystemOrganization addCategory: #'Refactory-AST-RBParser'!
SystemOrganization addCategory: #'Refactory-SqueakRB-UserInterface'!
SystemOrganization addCategory: #'Refactory-Lint'!
SystemOrganization addCategory: #'Refactory-Test data'!
SystemOrganization addCategory: #'Refactory-Testing'!
SystemOrganization addCategory: #'Refactory-SqueakRB-Tests'!
SystemOrganization addCategory: #'Refactory-Environments'!
SystemOrganization addCategory: #'Refactory-Model'!
SystemOrganization addCategory: #'Refactory-Conditions'!
SystemOrganization addCategory: #'Refactory-Support'!
SystemOrganization addCategory: #'Refactory-Refactorings'!
SystemOrganization addCategory: #'Refactory-Change Objects'!
SystemOrganization addCategory: #'Refactory-Info'!

!MenuMorph methodsFor: '*Refactory-override' stamp: 'sbw 3/11/2000 09:40'!
setInvokingView: invokingView 
	"Re-work every menu item of the form   
	<target> perform: <selector>   
	to the form   
	<target> perform: <selector> orSendTo: <invokingView>.   
	This supports MVC's vectoring of non-model messages to the editPane."
	self items do: [:item | item subMenu isNil
			ifTrue: ["sbw - This added check is to work around a bug in the base 
				system.  If the item holds a sub-menu we should ignore it here. "
				item arguments isEmpty
					ifTrue: 
						["only the simple messages"
						item arguments: (Array with: item selector with: invokingView).
						item selector: #perform:orSendTo:]]]! !

Error subclass: #RefactoringError
	instanceVariableNames: 'parameter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Support'!

!RefactoringError methodsFor: 'as yet unclassified' stamp: 'dvf 9/15/2001 16:28'!
parameter 
	self needsWork."what should we do?"
	^parameter.
	! !

!RefactoringError methodsFor: 'as yet unclassified' stamp: 'dvf 9/15/2001 16:28'!
parameter: anObject 
	self needsWork."what should we do?"
	parameter := anObject.
	! !

!RefactoringError class methodsFor: 'signalling' stamp: 'dvf 9/16/2003 20:23'!
raiseSignal: aString with: anObject 
	"Raise an an exception."

	^(self new)
		searchFrom: thisContext sender;
		messageText: aString;
		parameter: anObject;
		raiseSignal! !

Object subclass: #Refactoring
	instanceVariableNames: 'model options'
	classVariableNames: 'RefactoringOptions'
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

Refactoring subclass: #MethodRefactoring
	instanceVariableNames: 'class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

MethodRefactoring subclass: #InlineTemporaryRefactoring
	instanceVariableNames: 'sourceInterval selector sourceTree assignmentNode definingNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!InlineTemporaryRefactoring methodsFor: 'transforming' stamp: ''!
compileMethod
	class compileTree: sourceTree! !

!InlineTemporaryRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' inline: '.
	sourceInterval storeOn: aStream.
	aStream
		nextPutAll: ' from: #';
		nextPutAll: selector;
		nextPutAll: ' in: '.
	class storeOn: aStream.
	aStream nextPut: $)! !

!InlineTemporaryRefactoring methodsFor: 'preconditions' stamp: ''!
verifySelectedInterval
	sourceTree := class parseTreeFor: selector.
	sourceTree isNil ifTrue: [self refactoringError: 'Could not parse source'].
	assignmentNode := sourceTree whichNodeIsContainedBy: sourceInterval.
	assignmentNode isAssignment 
		ifFalse: 
			[self refactoringError: 'The selected node is not an assignment statement'].
	definingNode := assignmentNode whoDefines: assignmentNode variable name.
	self hasOnlyOneAssignment 
		ifFalse: 
			[self refactoringError: 'There are multiple assignments to the variable'].
	(RBReadBeforeWrittenTester isVariable: assignmentNode variable name
		writtenBeforeReadIn: definingNode) 
			ifFalse: 
				[self 
					refactoringError: 'The variable is possible read before it is assigned']! !

!InlineTemporaryRefactoring methodsFor: 'testing' stamp: ''!
hasOnlyOneAssignment
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher matches: assignmentNode variable name , ' := ``@object'
		do: [:aNode :answer | answer + 1].
	^(searcher executeTree: definingNode initialAnswer: 0) == 1! !

!InlineTemporaryRefactoring methodsFor: 'transforming' stamp: ''!
replaceReferences
	| rewriter |
	rewriter := ParseTreeRewriter new.
	rewriter replaceTree: assignmentNode variable
		withTree: assignmentNode value.
	definingNode removeTemporaryNamed: assignmentNode variable name.
	rewriter executeTree: definingNode! !

!InlineTemporaryRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition definesSelector: selector in: class) 
		& (RBCondition withBlock: 
					[self verifySelectedInterval.
					true])! !

!InlineTemporaryRefactoring class methodsFor: 'instance creation' stamp: ''!
inline: anInterval from: aSelector in: aClass 
	^self new 
		inline: anInterval
		from: aSelector
		in: aClass! !

!InlineTemporaryRefactoring methodsFor: 'transforming' stamp: ''!
replaceAssignment
	assignmentNode parent isSequence 
		ifTrue: [assignmentNode parent removeNode: assignmentNode]
		ifFalse: [assignmentNode replaceWith: assignmentNode value]! !

!InlineTemporaryRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self
		replaceAssignment;
		replaceReferences;
		compileMethod! !

!InlineTemporaryRefactoring methodsFor: 'initialize-release' stamp: ''!
inline: anInterval from: aSelector in: aClass 
	class := self classObjectFor: aClass.
	selector := aSelector.
	sourceInterval := anInterval! !

!InlineTemporaryRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk inline: anInterval from: aSelector in: aClass 
	^(self new)
		model: aRBSmalltalk;
		inline: anInterval
			from: aSelector
			in: aClass;
		yourself! !

!MethodRefactoring methodsFor: 'private' stamp: ''!
buildSelectorString: aSelector 
	aSelector numArgs = 0 ifTrue: [^aSelector].
	^self buildSelectorString: aSelector
		withPermuteMap: (1 to: aSelector numArgs)! !

!MethodRefactoring methodsFor: 'private' stamp: ''!
buildSelectorString: aSelector withPermuteMap: anIntegerCollection 
	| stream keywords |
	aSelector numArgs == 0 ifTrue: [^aSelector asString].
	stream := WriteStream on: String new.
	keywords := aSelector keywords.
	keywords with: anIntegerCollection
		do: 
			[:each :i | 
			stream
				nextPutAll: each;
				nextPutAll: ' ``@arg';
				nextPutAll: i printString;
				nextPut: $ ].
	^stream contents! !

MethodRefactoring subclass: #InlineAllSendersRefactoring
	instanceVariableNames: 'selector numberReplaced numberNotReplaced'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!InlineAllSendersRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^RBCondition canUnderstand: selector in: class! !

!InlineAllSendersRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self
		inlineSelfSends;
		removeMethod;
		checkInlinedMethods! !

!InlineAllSendersRefactoring methodsFor: 'transforming' stamp: ''!
numberOfSelfSendsIn: aParseTree 
	| search |
	search := ParseTreeSearcher new.
	search matches: self messagePattern do: [:aNode :answer | answer + 1].
	^search executeTree: aParseTree initialAnswer: 0! !

!InlineAllSendersRefactoring methodsFor: 'accessing' stamp: ''!
messagesNotReplaced
	^numberNotReplaced! !

!InlineAllSendersRefactoring methodsFor: 'initialize-release' stamp: ''!
sendersOf: aSelector in: aClass 
	class := self classObjectFor: aClass.
	selector := aSelector.
	numberReplaced := numberNotReplaced := 0! !

!InlineAllSendersRefactoring methodsFor: 'transforming' stamp: ''!
removeMethod
	self onError: 
			[self performComponentRefactoring: (RemoveMethodRefactoring 
						model: self model
						removeMethods: (Array with: selector)
						from: class)]
		do: []! !

!InlineAllSendersRefactoring methodsFor: 'transforming' stamp: ''!
inlineMessagesInClass: aClass andSelector: aSelector 
	| messagesToInline previousCountOfMessages |
	previousCountOfMessages := 4294967295.	"Some really large number > # of initial self sends."
	
	[messagesToInline := self 
				numberOfSelfSendsIn: (aClass parseTreeFor: aSelector).
	messagesToInline > 0 and: [previousCountOfMessages > messagesToInline]] 
			whileTrue: 
				[| node |
				previousCountOfMessages := messagesToInline.
				node := self selfSendIn: (aClass parseTreeFor: aSelector).
				self onError: 
						[self performComponentRefactoring: (InlineMethodRefactoring 
									model: self model
									inline: node sourceInterval
									inMethod: aSelector
									forClass: aClass).
						numberReplaced := numberReplaced + 1]
					do: []].
	numberNotReplaced := numberNotReplaced + messagesToInline! !

!InlineAllSendersRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream
		nextPutAll: ' sendersOf: #';
		nextPutAll: selector;
		nextPutAll: ' in: '.
	class storeOn: aStream.
	aStream nextPut: $)! !

!InlineAllSendersRefactoring class methodsFor: 'instance creation' stamp: ''!
sendersOf: aSelector in: aClass 
	^self new sendersOf: aSelector in: aClass! !

!InlineAllSendersRefactoring methodsFor: 'transforming' stamp: ''!
checkInlinedMethods
	numberReplaced = 0 
		ifTrue: [self refactoringError: 'Could not inline any senders']! !

!InlineAllSendersRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk sendersOf: aSelector in: aClass 
	^(self new)
		model: aRBSmalltalk;
		sendersOf: aSelector in: aClass;
		yourself! !

!InlineAllSendersRefactoring methodsFor: 'transforming' stamp: ''!
selfSendIn: aTree 
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher matches: self messagePattern do: [:aNode :answer | ^aNode].
	^searcher executeTree: aTree initialAnswer: nil! !

!InlineAllSendersRefactoring methodsFor: 'transforming' stamp: ''!
inlineSelfSends
	class withAllSubclasses do: 
			[:each | 
			| selectors |
			selectors := each selectors.
			selectors remove: selector ifAbsent: [].
			selectors do: [:sel | self inlineMessagesInClass: each andSelector: sel]]! !

!InlineAllSendersRefactoring methodsFor: 'transforming' stamp: ''!
messagePattern
	^'self ' , (self buildSelectorString: selector)! !

MethodRefactoring subclass: #RenameTemporaryRefactoring
	instanceVariableNames: 'selector interval oldName newName parseTree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!RenameTemporaryRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk renameTemporaryFrom: anInterval to: newName in: aClass selector: aSelector 
	^(self new)
		model: aRBSmalltalk;
		class: aClass
			selector: aSelector
			interval: anInterval
			newName: newName;
		yourself! !

!RenameTemporaryRefactoring methodsFor: 'tranforming' stamp: ''!
renameNode: aParseTree 
	(aParseTree whoDefines: newName) notNil 
		ifTrue: [self refactoringError: newName , ' is already defined'].
	(aParseTree allDefinedVariables includes: newName) 
		ifTrue: [self refactoringError: newName , ' is already defined'].
	(ParseTreeRewriter rename: oldName to: newName) executeTree: aParseTree! !

!RenameTemporaryRefactoring methodsFor: 'initialize-release' stamp: ''!
class: aClass selector: aSelector interval: anInterval newName: aString 
	class := self classObjectFor: aClass.
	selector := aSelector.
	interval := anInterval.
	newName := aString! !

!RenameTemporaryRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition definesSelector: selector in: class) 
		& (RBCondition isValidInstanceVariableName: newName for: class) 
			& (RBCondition definesInstanceVariable: newName in: class) not 
			& (RBCondition definesClassVariable: newName in: class) not 
			& (RBCondition withBlock: 
						[| methodSource |
						interval first > interval last 
							ifTrue: [self refactoringError: 'Invalid variable name'].
						methodSource := class sourceCodeFor: selector.
						methodSource size >= interval last 
							ifFalse: [self refactoringError: 'Invalid range for variable'].
						oldName := methodSource copyFrom: interval first to: interval last.
						true])! !

!RenameTemporaryRefactoring methodsFor: 'tranforming' stamp: ''!
transform
	| definingNode variableNode |
	parseTree := class parseTreeFor: selector.
	variableNode := self 
				whichVariableNode: parseTree
				inInterval: interval
				name: oldName.
	(variableNode isNil or: [variableNode isVariable not]) 
		ifTrue: [self refactoringError: oldName , ' isn''t a valid variable'].
	variableNode name = oldName 
		ifFalse: [self refactoringError: 'Invalid selection'].
	definingNode := variableNode whoDefines: oldName.
	definingNode isNil 
		ifTrue: [self refactoringError: oldName , ' isn''t defined by the method'].
	self renameNode: definingNode.
	class compileTree: parseTree! !

!RenameTemporaryRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' renameTemporaryFrom: '.
	interval storeOn: aStream.
	aStream
		nextPutAll: ' to: ''';
		nextPutAll: newName;
		nextPutAll: ''' in: '.
	class storeOn: aStream.
	aStream
		nextPutAll: ' selector: #';
		nextPutAll: selector.
	aStream nextPut: $)! !

!RenameTemporaryRefactoring class methodsFor: 'instance creation' stamp: ''!
renameTemporaryFrom: anInterval to: newName in: aClass selector: aSelector 
	^self new
		class: aClass
		selector: aSelector
		interval: anInterval
		newName: newName! !

MethodRefactoring subclass: #PushDownMethodRefactoring
	instanceVariableNames: 'selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!PushDownMethodRefactoring methodsFor: 'transforming' stamp: ''!
pushDown: aSelector 
	| code protocols refactoring |
	code := class sourceCodeFor: aSelector.
	protocols := class protocolsFor: aSelector.
	refactoring := ExpandReferencedPoolsRefactoring 
				model: self model
				forMethod: (class parseTreeFor: aSelector)
				fromClass: class
				toClasses: class subclasses.
	self performComponentRefactoring: refactoring.
	class subclasses do: 
			[:each | 
			(each directlyDefinesMethod: aSelector) 
				ifFalse: [each compile: code classified: protocols]]! !

!PushDownMethodRefactoring methodsFor: 'transforming' stamp: ''!
transform
	selectors do: [:each | self pushDown: each].
	selectors do: [:each | class removeMethod: each]! !

!PushDownMethodRefactoring methodsFor: 'initialize-release' stamp: ''!
pushDown: selectorCollection from: aClass 
	class := self classObjectFor: aClass.
	selectors := selectorCollection! !

!PushDownMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk pushDown: selectorCollection from: aClass 
	^(self new)
		model: aRBSmalltalk;
		pushDown: selectorCollection from: aClass;
		yourself! !

!PushDownMethodRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	| condition |
	condition := selectors inject: RBCondition empty
				into: 
					[:cond :each | 
					cond & (RBCondition definesSelector: each in: class) 
						& (RBCondition subclassesOf: class referToSelector: each) not].
	^condition & (RBCondition isAbstractClass: class)! !

!PushDownMethodRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' pushDown: '.
	selectors asArray storeOn: aStream.
	aStream nextPutAll: ' from: '.
	class storeOn: aStream.
	aStream nextPut: $)! !

!PushDownMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
pushDown: selectorCollection from: aClass 
	^self new pushDown: selectorCollection from: aClass! !

MethodRefactoring subclass: #ChangeMethodNameRefactoring
	instanceVariableNames: 'newSelector oldSelector permutation implementors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!ChangeMethodNameRefactoring methodsFor: 'testing' stamp: ''!
implementorsCanBePrimitives
	^false! !

!ChangeMethodNameRefactoring methodsFor: 'private' stamp: ''!
modifyImplementorParseTree: parseTree in: aClass 
	| oldArgs |
	oldArgs := parseTree arguments.
	parseTree arguments: (permutation collect: [:each | oldArgs at: each]).
	parseTree selector: newSelector! !

!ChangeMethodNameRefactoring methodsFor: 'private' stamp: ''!
implementors
	implementors isNil 
		ifTrue: [implementors := self model allImplementorsOf: oldSelector].
	^implementors! !

!ChangeMethodNameRefactoring methodsFor: 'transforming' stamp: ''!
renameImplementors
	self implementors do: 
			[:each | 
			| parseTree |
			parseTree := each parseTreeFor: oldSelector.
			parseTree isNil 
				ifTrue: [self refactoringError: 'Could not parse source code.'].
			self implementorsCanBePrimitives 
				ifFalse: 
					[parseTree isPrimitive 
						ifTrue: 
							[self refactoringError: ('<1p>''s implementation of #<2s> is a primitive' 
										expandMacrosWith: each
										with: oldSelector)]].
			self modifyImplementorParseTree: parseTree in: each.
			each compileTree: parseTree classified: (each protocolsFor: oldSelector)]! !

!ChangeMethodNameRefactoring methodsFor: 'testing' stamp: ''!
hasPermutedArguments
	oldSelector numArgs = newSelector numArgs ifFalse: [^true].
	1 to: oldSelector numArgs
		do: [:i | (permutation at: i) = i ifFalse: [^true]].
	^false! !

!ChangeMethodNameRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	"This refactoring only preserves behavior if all implementors are renamed."

	| conditions |
	conditions := self myConditions 
				& (RBCondition definesSelector: oldSelector in: class) 
					& (RBCondition isValidMethodName: newSelector for: class).
	conditions := self implementors inject: conditions
				into: 
					[:condition :each | 
					condition & (RBCondition hierarchyOf: each canUnderstand: newSelector) not].
	^conditions 
		& (RBCondition withBlock: 
					[self implementors size > 1 
						ifTrue: 
							[self refactoringWarning: ('This will modify all <1p> implementors.' 
										expandMacrosWith: self implementors size)].
					true])! !

!ChangeMethodNameRefactoring methodsFor: 'private' stamp: ''!
parseTreeRewriter
	| rewriteRule oldString newString |
	rewriteRule := ParseTreeRewriter new.
	oldString := self buildSelectorString: oldSelector.
	newString := self buildSelectorString: newSelector
				withPermuteMap: permutation.
	rewriteRule replace: '``@object ' , oldString
		with: '``@object ' , newString.
	^rewriteRule! !

!ChangeMethodNameRefactoring methodsFor: 'transforming' stamp: ''!
renameMessageSends
	self convertAllReferencesTo: oldSelector using: self parseTreeRewriter! !

ChangeMethodNameRefactoring subclass: #AddParameterRefactoring
	instanceVariableNames: 'initializer senders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!AddParameterRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream
		nextPutAll: ' addParameterToMethod: #';
		nextPutAll: oldSelector;
		nextPutAll: ' in: '.
	class storeOn: aStream.
	aStream
		nextPutAll: ' newSelector: #';
		nextPutAll: newSelector;
		nextPutAll: ' initializer: ''';
		nextPutAll: initializer;
		nextPutAll: ''')'! !

!AddParameterRefactoring methodsFor: 'preconditions' stamp: ''!
checkSendersAccessTo: name 
	| violatorClass |
	(#('self' 'super') includes: name) ifTrue: [^self].
	violatorClass := self senders 
				detect: [:each | (self canReferenceVariable: name in: each) not]
				ifNone: [nil].
	violatorClass notNil 
		ifTrue: 
			[self refactoringError: ('<1s> doesn''t appear to be defined in <2p>' 
						expandMacrosWith: name
						with: violatorClass)]! !

!AddParameterRefactoring methodsFor: 'preconditions' stamp: ''!
checkVariableReferencesIn: aParseTree 
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher matches: '`var'
		do: 
			[:aNode :answer | 
			| name |
			name := aNode name.
			(aNode whoDefines: name) isNil ifTrue: [self checkSendersAccessTo: name]].
	searcher executeTree: aParseTree! !

!AddParameterRefactoring class methodsFor: 'instance creation' stamp: ''!
addParameterToMethod: aSelector in: aClass newSelector: newSelector initializer: init 
	^self new addParameterToMethod: aSelector
		in: aClass
		newSelector: newSelector
		initializer: init! !

!AddParameterRefactoring methodsFor: 'private' stamp: ''!
safeVariableNameFor: aClass temporaries: allTempVars 
	| baseString i newString |
	newString := baseString := 'anObject'.
	i := 0.
	
	[(allTempVars includes: newString) 
		or: [aClass definesInstanceVariable: newString]] 
			whileTrue: 
				[i := i + 1.
				newString := baseString , i printString].
	^newString! !

!AddParameterRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk addParameterToMethod: aSelector in: aClass newSelector: newSelector initializer: init 
	^(self new)
		model: aRBSmalltalk;
		addParameterToMethod: aSelector
			in: aClass
			newSelector: newSelector
			initializer: init;
		yourself! !

!AddParameterRefactoring methodsFor: 'preconditions' stamp: ''!
myConditions
	^RBCondition withBlock: 
			[oldSelector numArgs + 1 = newSelector numArgs 
				ifFalse: 
					[self refactoringError: newSelector printString 
								, ' doesn''t have the proper number of arguments.'].
			self verifyInitializationExpression.
			true]! !

!AddParameterRefactoring methodsFor: 'private' stamp: ''!
parseTreeRewriter
	| rewriteRule oldString newString |
	rewriteRule := ParseTreeRewriter new.
	oldString := self buildSelectorString: oldSelector.
	newString := self newSelectorString.
	rewriteRule replace: '``@object ' , oldString
		with: '``@object ' , newString.
	^rewriteRule! !

!AddParameterRefactoring methodsFor: 'private' stamp: ''!
newSelectorString
	| stream keywords |
	stream := WriteStream on: String new.
	keywords := newSelector keywords.
	1 to: keywords size
		do: 
			[:i | 
			stream nextPutAll: (keywords at: i).
			i == keywords size 
				ifTrue: 
					[stream
						nextPut: $(;
						nextPutAll: initializer;
						nextPut: $)]
				ifFalse: 
					[stream
						nextPutAll: ' ``@arg';
						nextPutAll: i printString].
			stream nextPut: $ ].
	^stream contents! !

!AddParameterRefactoring methodsFor: 'private' stamp: ''!
senders
	senders isNil 
		ifTrue: 
			[senders := Set new.
			self model allReferencesTo: oldSelector
				do: [:each | senders add: each modelClass]].
	^senders! !

!AddParameterRefactoring methodsFor: 'initialize-release' stamp: ''!
addParameterToMethod: aSelector in: aClass newSelector: newSel initializer: init 
	self 
		renameMethod: aSelector
		in: aClass
		to: newSel
		permuation: (1 to: newSel numArgs).
	initializer := init! !

!AddParameterRefactoring methodsFor: 'private' stamp: ''!
modifyImplementorParseTree: parseTree in: aClass 
	| name newArg allTempVars |
	allTempVars := parseTree allDefinedVariables.
	name := self safeVariableNameFor: aClass temporaries: allTempVars.
	newArg := RBVariableNode named: name.
	parseTree arguments: parseTree arguments , (Array with: newArg).
	super modifyImplementorParseTree: parseTree in: aClass! !

!AddParameterRefactoring methodsFor: 'preconditions' stamp: ''!
verifyInitializationExpression
	| tree |
	tree := RBParser parseExpression: initializer
				onError: 
					[:msg :index | 
					self refactoringError: 'Illegal initialization code because:.' , msg].
	tree isValue 
		ifFalse: 
			[self 
				refactoringError: 'The initialization code cannot be a return node or a list of statements'].
	self checkVariableReferencesIn: tree! !

ChangeMethodNameRefactoring subclass: #RemoveParameterRefactoring
	instanceVariableNames: 'parameterIndex argument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!RemoveParameterRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream
		nextPutAll: ' removeParameter: ''';
		nextPutAll: argument;
		nextPutAll: ''' in: '.
	class storeOn: aStream.
	aStream
		nextPutAll: ' selector: #';
		nextPutAll: oldSelector.
	aStream nextPut: $)! !

!RemoveParameterRefactoring methodsFor: 'initialize-release' stamp: ''!
removeParameter: aString in: aClass selector: aSelector 
	oldSelector := aSelector.
	class := self classObjectFor: aClass.
	argument := aString! !

!RemoveParameterRefactoring methodsFor: 'transforming' stamp: ''!
getNewSelector
	| tree |
	(class directlyDefinesMethod: oldSelector)
		ifFalse: [self refactoringError: 'Method doesn''t exist'].
	tree := class parseTreeFor: oldSelector.
	tree isNil ifTrue: [self refactoringError: 'Cannot parse sources'].
	parameterIndex := tree argumentNames indexOf: argument ifAbsent: [self refactoringError: 'Select a parameter!!!!'].
	permutation := (1 to: oldSelector numArgs)
				copyWithout: parameterIndex.
	newSelector := self computeNewSelector! !

!RemoveParameterRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk removeParameter: aString in: aClass selector: aSelector 
	^(self new)
		model: aRBSmalltalk;
		removeParameter: aString
			in: aClass
			selector: aSelector;
		yourself! !

!RemoveParameterRefactoring class methodsFor: 'instance creation' stamp: ''!
removeParameter: aString in: aClass selector: aSelector
	^self new removeParameter: aString in: aClass selector: aSelector! !

!RemoveParameterRefactoring methodsFor: 'preconditions' stamp: ''!
myConditions
	| imps |
	imps := self model allImplementorsOf: oldSelector.
	self getNewSelector.
	^imps inject: (RBCondition definesSelector: oldSelector in: class)
		into: 
			[:cond :each | 
			cond 
				& (RBCondition withBlock: [(self hasReferencesToTemporaryIn: each) not]
						errorString: 'This argument is still referenced in atleast one implementor!!!!')]! !

RemoveParameterRefactoring subclass: #InlineParameterRefactoring
	instanceVariableNames: 'expressions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!InlineParameterRefactoring methodsFor: 'private' stamp: ''!
expressionsToInlineFrom: aTree 
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher matches: '``@obj ' , (self buildSelectorString: oldSelector)
		do: 
			[:aNode :answer | 
			answer
				add: (aNode arguments at: parameterIndex);
				yourself].
	^searcher executeTree: aTree initialAnswer: OrderedCollection new! !

!InlineParameterRefactoring class methodsFor: 'instance creation' stamp: ''!
inlineParameter: aString in: aClass selector: aSelector 
	^self new 
		inlineParameter: aString
		in: aClass
		selector: aSelector! !

!InlineParameterRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream
		nextPutAll: ' inlineParameter: ''';
		nextPutAll: argument;
		nextPutAll: ''' in: '.
	class storeOn: aStream.
	aStream
		nextPutAll: ' selector: #';
		nextPutAll: oldSelector;
		nextPut: $)! !

!InlineParameterRefactoring methodsFor: 'preconditions' stamp: ''!
myConditions
	self getNewSelector.
	expressions := self allExpressionsToInline.
	^(RBCondition definesSelector: oldSelector in: class) 
		& ((RBCondition withBlock: [expressions isEmpty not]) 
				errorMacro: 'No callers. Use Remove Method instead.') 
			& ((RBCondition withBlock: [expressions size = 1]) 
					errorMacro: 'All values passed as this argument must be identical.') 
			& ((RBCondition withBlock: [expressions first isLiteral]) 
					errorMacro: 'All values passed must be literal.')! !

!InlineParameterRefactoring methodsFor: 'private' stamp: ''!
allExpressionsToInline
	| coll |
	coll := Set new.
	self model allReferencesTo: oldSelector
		do: 
			[:each | 
			| tree |
			tree := each parseTree.
			tree notNil ifTrue: [coll addAll: (self expressionsToInlineFrom: tree)]].
	^coll asOrderedCollection! !

!InlineParameterRefactoring methodsFor: 'initialize-release' stamp: ''!
inlineParameter: aString in: aClass selector: aSelector
	oldSelector := aSelector.
	class := self classObjectFor: aClass.
	argument := aString! !

!InlineParameterRefactoring methodsFor: 'transforming' stamp: ''!
modifyImplementorParseTree: parseTree in: aClass 
	| node assignment |
	node := (parseTree arguments at: parameterIndex) copy.
	parseTree body addTemporaryNamed: node name.
	assignment := RBAssignmentNode variable: node copy value: expressions first.
	parseTree body addNodeFirst: assignment.
	super modifyImplementorParseTree: parseTree in: aClass! !

!InlineParameterRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk inlineParameter: aString in: aClass selector: aSelector 
	^(self new)
		model: aRBSmalltalk;
		inlineParameter: aString
			in: aClass
			selector: aSelector;
		yourself! !

!RemoveParameterRefactoring methodsFor: 'transforming' stamp: ''!
hasReferencesToTemporaryIn: each 
	| tree |
	tree := each parseTreeFor: oldSelector.
	tree isNil ifTrue: [self refactoringError: 'Cannot parse sources.'].
	^tree references: (tree argumentNames at: parameterIndex)! !

!RemoveParameterRefactoring methodsFor: 'private' stamp: ''!
computeNewSelector
	| keywords stream |
	oldSelector numArgs == 0 
		ifTrue: [self refactoringError: 'This method contains no arguments'].
	oldSelector isInfix 
		ifTrue: [self refactoringError: 'Cannot remove parameters of infix selectors'].
	keywords := oldSelector keywords asOrderedCollection.
	keywords size = 1 ifTrue: [^(keywords first copyWithout: $:) asSymbol].
	keywords removeAtIndex: parameterIndex.
	stream := WriteStream on: ''.
	keywords do: [:each | stream nextPutAll: each].
	^stream contents asSymbol! !

!ChangeMethodNameRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self renameImplementors.
	self renameMessageSends.
	oldSelector == newSelector ifTrue: [^self].
	self removeRenamedImplementors! !

!ChangeMethodNameRefactoring methodsFor: 'initialize-release' stamp: ''!
renameMethod: aSelector in: aClass to: newSel permuation: aMap 
	oldSelector := aSelector asSymbol.
	newSelector := newSel asSymbol.
	class := self classObjectFor: aClass.
	permutation := aMap! !

ChangeMethodNameRefactoring subclass: #RenameMethodRefactoring
	instanceVariableNames: 'hasPermutedArguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!RenameMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
renameMethod: aSelector in: aClass to: newSelector permuation: aMap 
	^self new renameMethod: aSelector
		in: aClass
		to: newSelector
		permuation: aMap! !

!RenameMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk renameMethod: aSelector in: aClass to: newSelector permuation: aMap 
	^(self new)
		model: aRBSmalltalk;
		renameMethod: aSelector
			in: aClass
			to: newSelector
			permuation: aMap;
		yourself! !

!RenameMethodRefactoring methodsFor: 'testing' stamp: ''!
implementorsCanBePrimitives
	^self hasPermutedArguments not! !

!RenameMethodRefactoring methodsFor: 'testing' stamp: ''!
hasPermutedArguments
	^hasPermutedArguments isNil 
		ifTrue: [hasPermutedArguments := super hasPermutedArguments]
		ifFalse: [hasPermutedArguments]! !

!RenameMethodRefactoring methodsFor: 'transforming' stamp: ''!
parseTreeRewriter
	| rewriteRule oldString newString |
	oldString := self buildSelectorString: oldSelector.
	newString := self buildSelectorString: newSelector
				withPermuteMap: permutation.
	rewriteRule := self hasPermutedArguments 
				ifTrue: [ParseTreeRewriter new]
				ifFalse: [ParseTreeRewriter replaceLiteral: oldSelector with: newSelector].
	rewriteRule replace: '``@object ' , oldString
		with: '``@object ' , newString.
	^rewriteRule! !

!RenameMethodRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream
		nextPutAll: ' renameMethod: #';
		nextPutAll: oldSelector;
		nextPutAll: ' in: '.
	class storeOn: aStream.
	aStream
		nextPutAll: ' to: #';
		nextPutAll: newSelector;
		nextPutAll: ' permuation: '.
	permutation storeOn: aStream.
	aStream nextPut: $)! !

!RenameMethodRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	| newCondition |
	newCondition := (RBCondition withBlock: [newSelector = oldSelector]
				errorString: 'The selectors are <1?:not >equivalent') & (RBCondition 
							withBlock: [permutation asArray ~= (1 to: oldSelector numArgs) asArray]
							errorString: 'The arguments are <1?:not >permuted').
	^newCondition | super preconditions! !

!RenameMethodRefactoring methodsFor: 'preconditions' stamp: ''!
myConditions
	^RBCondition withBlock: [oldSelector numArgs = newSelector numArgs]
		errorString: newSelector printString 
				, ' doesn''t have the correct number of arguments.'! !

!ChangeMethodNameRefactoring methodsFor: 'accessing' stamp: ''!
newSelector
	^newSelector! !

!ChangeMethodNameRefactoring methodsFor: 'preconditions' stamp: ''!
myConditions
	^self subclassResponsibility! !

!ChangeMethodNameRefactoring methodsFor: 'transforming' stamp: ''!
removeRenamedImplementors
	self implementors do: [:each | each removeMethod: oldSelector]! !

MethodRefactoring subclass: #AddMethodRefactoring
	instanceVariableNames: 'protocols source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!AddMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
addMethod: aString toClass: aClass inProtocols: protocolList 
	^self new addMethod: aString
		toClass: aClass
		inProtocols: protocolList! !

!AddMethodRefactoring methodsFor: 'initialize-release' stamp: ''!
addMethod: aString toClass: aClass inProtocols: protocolList 
	class := self classObjectFor: aClass.
	source := aString.
	protocols := protocolList! !

!AddMethodRefactoring methodsFor: 'transforming' stamp: ''!
transform
	class compile: source classified: protocols! !

!AddMethodRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	| selector method |
	method := RBParser parseMethod: source
				onError: 
					[:string :position | 
					^RBCondition 
						withBlock: [self refactoringError: 'The sources could not be parsed']].
	selector := method selector.
	selector isNil ifTrue: [self refactoringError: 'Invalid source.'].
	^(RBCondition canUnderstand: selector in: class) not! !

!AddMethodRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream
		nextPutAll: ' addMethod: ''';
		nextPutAll: source;
		nextPutAll: ''' toClass: '.
	class storeOn: aStream.
	aStream nextPutAll: ' inProtocols: '.
	protocols storeOn: aStream.
	aStream nextPut: $)! !

!AddMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk addMethod: aString toClass: aClass inProtocols: protocolList 
	^(self new)
		model: aRBSmalltalk;
		addMethod: aString
			toClass: aClass
			inProtocols: protocolList;
		yourself! !

MethodRefactoring subclass: #ExtractMethodRefactoring
	instanceVariableNames: 'selector extractionInterval extractedParseTree modifiedParseTree parameters needsReturn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!ExtractMethodRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition definesSelector: selector in: class) 
		& (RBCondition withBlock: 
					[self extractMethod.
					self checkSpecialExtractions.
					self checkReturn.
					needsReturn ifTrue: [extractedParseTree addReturn].
					self checkTemporaries.
					true])! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
isParseTreeEquivalentTo: aSelector 
	| tree definingClass |
	definingClass := class whoDefinesMethod: aSelector.
	tree := definingClass parseTreeFor: aSelector.
	tree isNil ifTrue: [^false].
	tree isPrimitive ifTrue: [^false].
	(tree body equalTo: extractedParseTree body
		exceptForVariables: (tree arguments collect: [:each | each name])) 
			ifFalse: [^false].
	(definingClass = class or: 
			[(tree superMessages detect: 
					[:each | 
					(class superclass whichClassIncludesSelector: aSelector) 
						~= (definingClass superclass whichClassIncludesSelector: each)]
				ifNone: [nil]) isNil]) 
		ifFalse: [^false].
	^self shouldUseExistingMethod: aSelector! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
checkTemporaries
	| temps accesses assigned |
	temps := self remainingTemporaries.
	accesses := temps select: [:each | extractedParseTree references: each].
	assigned := accesses select: [:each | extractedParseTree assigns: each].
	assigned isEmpty ifFalse: [self checkAssignments: assigned].
	^parameters := (accesses asOrderedCollection)
				removeAll: assigned;
				yourself! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
methodDelimiter
	^'#''place.holder.for.method'''! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
checkSpecialExtractions
	| node |
	node := self placeholderNode parent.
	node isNil ifTrue: [^self].
	(node isAssignment and: [node variable = self placeholderNode]) ifTrue: 
			[self refactoringError: 'Cannot extract left hand side of an assignment'].
	node isCascade ifTrue: 
			[self refactoringError: 'Cannot extract first message of a cascaded message']! !

!ExtractMethodRefactoring methodsFor: 'initialize-release' stamp: ''!
extract: anInterval from: aSelector in: aClass 
	class := self classObjectFor: aClass.
	selector := aSelector.
	extractionInterval := anInterval! !

!ExtractMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
extract: anInterval from: aSelector in: aClass 
	^self new
		extract: anInterval
		from: aSelector
		in: aClass! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
isMethodEquivalentTo: aSelector 
	selector == aSelector ifTrue: [^false].
	aSelector numArgs ~~ parameters size ifTrue: [^false].
	(self isParseTreeEquivalentTo: aSelector) ifFalse: [^false].
	self reorderParametersToMatch: aSelector.
	^true! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
reorderParametersToMatch: aSelector 
	| tree dictionary |
	tree := class parseTreeFor: aSelector.
	dictionary := Dictionary new.
	tree body equalTo: extractedParseTree body withMapping: dictionary.
	parameters := tree arguments collect: 
					[:each | 
					dictionary at: each name
						ifAbsent: 
							[self 
								refactoringError: 'An internal error occured, please report this error.']]! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
createTemporariesInExtractedMethodFor: assigned 
	assigned do: [:each | extractedParseTree body addTemporaryNamed: each]! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: 'dvf 9/29/2001 17:58'!
extractMethod
	| parseTree isSequence extractCode subtree newCode |
	extractCode := self getExtractedSource.
	extractedParseTree := RBParser parseExpression: extractCode
				onError: [:string :pos | self refactoringError: 'Invalid source to extract - ', string].
	extractedParseTree isNil 
		ifTrue: [self refactoringError: 'Invalid source to extract'].
	(extractedParseTree isSequence 
		and: [extractedParseTree statements isEmpty]) 
			ifTrue: [self refactoringError: 'Select some code to extract'].
	isSequence := extractedParseTree isSequence 
				or: [extractedParseTree isReturn].
	extractedParseTree := RBMethodNode 
				selector: #value
				arguments: #()
				body: (extractedParseTree isSequence 
						ifTrue: [extractedParseTree]
						ifFalse: 
							[RBSequenceNode temporaries: #()
								statements: (OrderedCollection with: extractedParseTree)]).
	extractedParseTree body temporaries isEmpty not 
		ifTrue: [extractedParseTree body temporaries: #()].
	extractedParseTree source: extractCode.
	parseTree := class parseTreeFor: selector.
	parseTree isNil 
		ifTrue: [self refactoringError: 'Could not parse ' , selector printString].
	subtree := isSequence 
				ifTrue: 
					[ParseTreeSearcher 
						treeMatchingStatements: extractedParseTree body formattedCode
						in: parseTree]
				ifFalse: [ParseTreeSearcher treeMatching: extractCode in: parseTree].
	subtree isNil 
		ifTrue: [self refactoringError: 'Could not extract code from method'].
	newCode := self methodDelimiter.
	isSequence 
		ifTrue: 
			[| stmts |
			stmts := extractedParseTree body statements.
			stmts isEmpty 
				ifFalse: 
					[stmts last isAssignment 
						ifTrue: 
							[| name |
							name := stmts last variable name.
							(self shouldExtractAssignmentTo: name) 
								ifFalse: 
									[newCode := '<1s> := <2s>' expandMacrosWith: name with: newCode.
									stmts at: stmts size put: stmts last value]]]].
	modifiedParseTree := isSequence 
				ifTrue: 
					[ParseTreeRewriter 
						replaceStatements: subtree formattedCode
						with: newCode
						in: parseTree
						onInterval: extractionInterval]
				ifFalse: 
					[ParseTreeRewriter 
						replace: subtree formattedCode
						with: newCode
						in: parseTree
						onInterval: extractionInterval]! !

!ExtractMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk extract: anInterval from: aSelector in: aClass 
	^(self new)
		model: aRBSmalltalk;
		extract: anInterval
			from: aSelector
			in: aClass;
		yourself! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
getExtractedSource
	| source |
	source := class sourceCodeFor: selector.
	((extractionInterval first between: 1 and: source size) 
		and: [extractionInterval last between: 1 and: source size]) 
			ifFalse: [self refactoringError: 'Invalid interval'].
	^source copyFrom: extractionInterval first to: extractionInterval last! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
getNewMethodName
	| newSelector methodName newMethodName |
	methodName := RBMethodName new.
	methodName arguments: parameters.
	
	[newMethodName := self requestMethodNameFor: methodName.
	newMethodName isNil 
		ifTrue: [self refactoringError: 'Did not extract code'].
	newSelector := newMethodName selector.
	(self checkMethodName: newSelector in: class) 
		ifFalse: 
			[self refactoringWarning: newSelector , ' is not a valid selector name.'.
			newSelector := nil].
	(class hierarchyDefinesMethod: newSelector asSymbol) 
		ifTrue: 
			[(self shouldOverride: newSelector in: class) ifFalse: [newSelector := nil]].
	newSelector isNil] 
			whileTrue: [].
	parameters := newMethodName arguments asOrderedCollection.
	^newSelector asSymbol! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
checkReturn
	needsReturn := self placeholderNode isUsed.
	extractedParseTree containsReturn ifFalse: [^self].
	extractedParseTree lastIsReturn ifTrue: [^self].
	(modifiedParseTree isLast: self placeholderNode) 
		ifFalse: 
			[self refactoringError: 'Couldn''t extract code since it contains a return.'].
	self checkSelfReturns! !

!ExtractMethodRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' extract: '.
	extractionInterval storeOn: aStream.
	aStream
		nextPutAll: ' from: #';
		nextPutAll: selector;
		nextPutAll: ' in: '.
	class storeOn: aStream.
	aStream nextPut: $)! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
checkSingleAssignment: varName 
	((RBReadBeforeWrittenTester isVariable: varName
		readBeforeWrittenIn: extractedParseTree) 
			or: [extractedParseTree containsReturn]) 
			ifTrue: 
				[self 
					refactoringError: 'Cannot extract assignments to temporaries without all references'].
	extractedParseTree 
		addNode: (RBReturnNode value: (RBVariableNode named: varName)).
	modifiedParseTree := ParseTreeRewriter 
				replace: self methodDelimiter
				with: varName , ' := ' , self methodDelimiter
				in: modifiedParseTree! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
placeholderNode
	| node |
	node := ParseTreeSearcher treeMatching: self methodDelimiter
				in: modifiedParseTree.
	node isNil ifTrue: [self refactoringError: 'Cannot extract code'].
	^node! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
remainingTemporaries
	| temps |
	temps := modifiedParseTree allDefinedVariables asSet.
	extractedParseTree allDefinedVariables 
		do: [:each | temps remove: each ifAbsent: []].
	^temps! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
checkSelfReturns
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher
		matches: '^self' do: [:aNode :answer | answer];
		matches: '^`@anything' do: [:aNode :answer | true].
	(searcher executeTree: extractedParseTree initialAnswer: false) 
		ifTrue: [self placeholderNode asReturn]! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
nameNewMethod: aSymbol 
	| args newSend |
	args := parameters collect: [:parm | RBVariableNode named: parm].
	extractedParseTree arguments: args asArray.
	extractedParseTree selector: aSymbol.
	aSymbol numArgs = 0 
		ifTrue: 
			[modifiedParseTree := ParseTreeRewriter 
						replace: self methodDelimiter
						with: 'self ' , aSymbol asString
						in: modifiedParseTree.
			^self].
	newSend := WriteStream on: ''.
	aSymbol keywords with: parameters
		do: 
			[:key :arg | 
			newSend
				nextPutAll: key asString;
				nextPut: $ ;
				nextPutAll: arg asString;
				nextPut: $ ].
	modifiedParseTree := ParseTreeRewriter 
				replace: self methodDelimiter
				with: 'self ' , newSend contents
				in: modifiedParseTree! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: 'bh 5/10/2000 21:56'!
transform
	| existingSelector |
	existingSelector := self existingSelector.
	self nameNewMethod: (existingSelector isNil 
				ifTrue: [self getNewMethodName]
				ifFalse: [existingSelector]).
	existingSelector isNil 
		ifTrue: 
			[class compileTree: extractedParseTree
				classified: (class protocolsFor: selector)].
	class compileTree: modifiedParseTree! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: 'bh 5/10/2000 21:58'!
existingSelector
	"Try to find an existing method instead of creating a new one"

	^class allSelectors detect: [:each | self isMethodEquivalentTo: each]
		ifNone: [nil]! !

!ExtractMethodRefactoring methodsFor: 'transforming' stamp: ''!
checkAssignments: variableNames 
	| node outsideVars removeAssigned |
	removeAssigned := variableNames copy.
	node := self placeholderNode.
	outsideVars := variableNames 
				select: [:each | (node whoDefines: each) references: each].
	outsideVars size == 1 
		ifTrue: [self checkSingleAssignment: outsideVars asArray first].
	outsideVars size > 1 
		ifTrue: 
			[self refactoringError: 'Cannot extract assignment without all references.'].
	removeAssigned removeAll: outsideVars.
	(RBReadBeforeWrittenTester readBeforeWritten: removeAssigned
		in: extractedParseTree) isEmpty 
		ifFalse: 
			[self refactoringError: 'Cannot extract assignment if read before written.'].
	removeAssigned 
		do: [:each | (node whoDefines: each) removeTemporaryNamed: each].
	self createTemporariesInExtractedMethodFor: variableNames! !

MethodRefactoring subclass: #ExtractToTemporaryRefactoring
	instanceVariableNames: 'sourceInterval selector newVariableName parseTree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!ExtractToTemporaryRefactoring methodsFor: 'transforming' stamp: ''!
compileNewMethod
	class compileTree: self parseTree! !

!ExtractToTemporaryRefactoring methodsFor: 'private-accessing' stamp: ''!
selectedSource
	| source |
	source := class sourceCodeFor: selector.
	source isNil ifTrue: [self refactoringError: 'Couldn''t find sources'].
	((sourceInterval first between: 1 and: source size) 
		and: [sourceInterval last between: 1 and: source size]) 
			ifFalse: [self refactoringError: 'Invalid interval'].
	^source copyFrom: sourceInterval first to: sourceInterval last! !

!ExtractToTemporaryRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition definesSelector: selector in: class) 
		& (RBCondition isValidInstanceVariableName: newVariableName for: class) 
			& (RBCondition withBlock: 
						[self verifySelectedInterval.
						self checkVariableName.
						true])! !

!ExtractToTemporaryRefactoring methodsFor: 'initialize-release' stamp: ''!
extract: anInterval to: aString from: aSelector in: aClass 
	class := self classObjectFor: aClass.
	selector := aSelector.
	sourceInterval := anInterval.
	newVariableName := aString! !

!ExtractToTemporaryRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' extract: '.
	sourceInterval storeOn: aStream.
	aStream
		nextPutAll: ' to: ''';
		nextPutAll: newVariableName;
		nextPutAll: ''' from: #';
		nextPutAll: selector;
		nextPutAll: ' in: '.
	class storeOn: aStream.
	aStream nextPut: $)! !

!ExtractToTemporaryRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self
		insertTemporary;
		compileNewMethod! !

!ExtractToTemporaryRefactoring methodsFor: 'private-accessing' stamp: ''!
parseTree
	parseTree isNil 
		ifTrue: 
			[parseTree := class parseTreeFor: selector.
			parseTree isNil ifTrue: [self refactoringError: 'Could not parse method']].
	^parseTree! !

!ExtractToTemporaryRefactoring methodsFor: 'preconditions' stamp: ''!
checkVariableName
	(class whoDefinesInstanceVariable: newVariableName) notNil 
		ifTrue: 
			[self refactoringError: ('<1p> defines an instance variable named <2s>' 
						expandMacrosWith: class
						with: newVariableName)].
	(class whoDefinesClassVariable: newVariableName) notNil 
		ifTrue: 
			[self refactoringError: ('<1p> defines a class variabled named <2s>' 
						expandMacrosWith: class
						with: newVariableName)].
	(self parseTree allDefinedVariables includes: newVariableName) 
		ifTrue: 
			[self refactoringError: ('<1s> is already a temporary variable name' 
						expandMacrosWith: newVariableName)]! !

!ExtractToTemporaryRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk extract: anInterval to: aString from: aSelector in: aClass 
	^(self new)
		model: aRBSmalltalk;
		extract: anInterval
			to: aString
			from: aSelector
			in: aClass;
		yourself! !

!ExtractToTemporaryRefactoring methodsFor: 'transforming' stamp: ''!
insertTemporary
	| node statementNode |
	node := self parseTree whichNodeIsContainedBy: sourceInterval.
	(node notNil and: [node isValue]) 
		ifFalse: [self refactoringError: 'Cannot assign to non-value nodes'].
	statementNode := node statementNode.
	node replaceWith: (RBVariableNode named: newVariableName).
	(statementNode parent)
		addNode: (self constructAssignmentFrom: node)
			before: (node == statementNode 
					ifTrue: [RBVariableNode named: newVariableName]
					ifFalse: [statementNode]);
		addTemporaryNamed: newVariableName! !

!ExtractToTemporaryRefactoring methodsFor: 'transforming' stamp: ''!
constructAssignmentFrom: aNode 
	| valueNode |
	valueNode := RBVariableNode named: newVariableName.
	^RBAssignmentNode variable: valueNode value: aNode! !

!ExtractToTemporaryRefactoring methodsFor: 'preconditions' stamp: ''!
verifySelectedInterval
	| selectedParseTree selectedSources |
	selectedSources := self selectedSource.
	selectedParseTree := RBParser parseExpression: selectedSources
				onError: [:message :position | self refactoringError: 'Invalid selection'].
	selectedParseTree isSequence 
		ifTrue: [self refactoringError: 'Cannot assign temp to multiple statements']! !

!ExtractToTemporaryRefactoring class methodsFor: 'instance creation' stamp: ''!
extract: anInterval to: aString from: aSelector in: aClass 
	^self new 
		extract: anInterval
		to: aString
		from: aSelector
		in: aClass! !

MethodRefactoring subclass: #MoveMethodRefactoring
	instanceVariableNames: 'selector variable moveToClasses parseTree hasOnlySelfReturns selfVariableName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!MoveMethodRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition definesSelector: selector in: class) 
		& (RBCondition withBlock: 
					[self buildParseTree.
					self checkForPrimitiveMethod.
					self checkForSuperReferences.
					self checkAssignmentsToVariable.
					self getClassesToMoveTo.
					self getArgumentNameForSelf.
					self checkTemporaryVariableNames.
					self getNewMethodName.
					true])! !

!MoveMethodRefactoring methodsFor: 'preconditions' stamp: 'rr 3/16/2004 15:14'!
getNewMethodName
	"rr 3/16/2004 15:12 : changed the code
	to really remove the variable which
	the extracted selector is moved to,
	as in the new location it is now the
	self pseudo-argument.
	
	The previous version was only removing
	it from the arguments, which was causing
	a bug."
	| newSelector parameters alreadyDefined methodName newMethodName |
	self removeArgument.
	parameters := parseTree argumentNames asOrderedCollection.
	"parameters remove: variable ifAbsent: []."
	self needsToReplaceSelfReferences 
		ifTrue: [parameters add: selfVariableName].
	methodName := RBMethodName selector: (self uniqueMethodNameFor: parameters size) arguments: parameters.
	
	[newMethodName := self requestMethodNameFor: methodName.
	newMethodName isNil ifTrue: [self refactoringError: 'Did not move method'].
	newMethodName isValid 
		ifTrue: [newSelector := newMethodName selector]
		ifFalse: [self refactoringWarning: 'Invalid method name'].
	parameters := newMethodName arguments.
	(self checkMethodName: newSelector in: class) 
		ifFalse: 
			[self refactoringWarning: newSelector , ' is not a valid selector name.'.
			newSelector := nil].
	alreadyDefined := moveToClasses 
				detect: [:each | each hierarchyDefinesMethod: newSelector]
				ifNone: [nil].
	alreadyDefined notNil 
		ifTrue: 
			[self 
				refactoringWarning: ('<1s> is already defined by <2p> or a super/subclass<n>Try another?' 
						expandMacrosWith: newSelector
						with: alreadyDefined).
			newSelector := nil].
	newSelector isNil] 
			whileTrue: [].
	parseTree
		arguments: (parameters collect: [:each | RBVariableNode named: each]) 
					asArray;
		selector: newSelector! !

!MoveMethodRefactoring methodsFor: 'initialize-release' stamp: ''!
selector: aSymbol class: aClass variable: aVariableName 
	selector := aSymbol.
	class := self classObjectFor: aClass.
	variable := aVariableName! !

!MoveMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkAssignmentsToVariable
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher matches: variable , ' := `@object' do: [:aNode :answer | true].
	(searcher executeTree: parseTree initialAnswer: false) 
		ifTrue: 
			[self refactoringError: ('Cannot move the method into <1s> since it is assigned' 
						expandMacrosWith: variable)]! !

!MoveMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
selector: aSymbol class: aClass variable: aVariableName 
	^(self new)
		selector: aSymbol
			class: aClass
			variable: aVariableName;
		yourself! !

!MoveMethodRefactoring methodsFor: 'transforming' stamp: ''!
addSelfReturn
	self hasOnlySelfReturns ifTrue: [^self].
	parseTree addSelfReturn! !

!MoveMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkForSuperReferences
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher matches: 'super `@message: `@args' do: [:aNode :answer | true].
	(searcher executeTree: parseTree initialAnswer: false) 
		ifTrue: 
			[self refactoringError: 'Cannot move the method since it has a super message send.']! !

!MoveMethodRefactoring methodsFor: 'testing' stamp: ''!
isMovingToInstVar
	^self isMovingToArgument not 
		and: [(class whoDefinesInstanceVariable: variable) notNil]! !

!MoveMethodRefactoring methodsFor: 'testing' stamp: ''!
needsToReplaceSelfReferences
	^self hasSelfReferences 
		or: [self abstractVariablesRefactoring hasVariablesToAbstract]! !

!MoveMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkForPrimitiveMethod
	parseTree isPrimitive 
		ifTrue: [self refactoringError: 'Cannot move primitive methods']! !

!MoveMethodRefactoring methodsFor: 'testing' stamp: ''!
isMovingToArgument
	^(parseTree arguments collect: [:each | each name]) includes: variable! !

!MoveMethodRefactoring methodsFor: 'private' stamp: ''!
buildParseTree
	parseTree := (class parseTreeFor: selector) copy.
	parseTree isNil ifTrue: [self refactoringError: 'Could not parse method']! !

!MoveMethodRefactoring methodsFor: 'private-accessing' stamp: ''!
getClassesForTemporaryVariable
	| types |
	types := RefactoryTyper 
				typesFor: variable
				in: parseTree
				model: self model.
	types isEmpty 
		ifTrue: [types := OrderedCollection with: (self model classNamed: #Object)].
	moveToClasses := self selectVariableTypesFrom: types selected: types.
	moveToClasses isNil ifTrue: [self refactoringError: 'Method not moved']! !

!MoveMethodRefactoring methodsFor: 'private-accessing' stamp: ''!
getClassForGlobalOrClassVariable
	| definingClass type |
	definingClass := class whoDefinesClassVariable: variable.
	definingClass isNil 
		ifTrue: 
			[type := self model classNamed: variable.
			type isNil ifTrue: [type := self model classNamed: #Object]]
		ifFalse: [type := definingClass typeOfClassVariable: variable].
	moveToClasses := self selectVariableTypesFrom: (Array with: type)
				selected: (Array with: type).
	moveToClasses isNil ifTrue: [self refactoringError: 'Method not moved']! !

!MoveMethodRefactoring methodsFor: 'transforming' stamp: ''!
hasOnlySelfReturns
	^hasOnlySelfReturns isNil 
		ifTrue: 
			[| searcher |
			searcher := ParseTreeSearcher new.
			searcher
				matches: '^self' do: [:aNode :answer | answer];
				matches: '^`@object' do: [:aNode :answer | false].
			hasOnlySelfReturns := searcher executeTree: parseTree initialAnswer: true]
		ifFalse: [hasOnlySelfReturns]! !

!MoveMethodRefactoring methodsFor: 'transforming' stamp: 'dvf 10/13/2001 23:19'!
replaceSelfReferences
	| replacer |
	self needsToReplaceSelfReferences ifTrue: [
		replacer := ParseTreeRewriter new.
		replacer replace: 'self' with: selfVariableName.
		self hasOnlySelfReturns ifTrue: 
			[replacer replace: '^self' with: '^self'].
		replacer executeTree: parseTree.
		parseTree := replacer tree].! !

!MoveMethodRefactoring methodsFor: 'private-accessing' stamp: ''!
getClassesForInstanceVariable
	| definingClass typer types |
	definingClass := class whoDefinesInstanceVariable: variable.
	typer := RefactoryTyper newFor: self model.
	typer runOn: definingClass.
	types := typer typesFor: variable.
	types isEmpty 
		ifTrue: [types := OrderedCollection with: (self model classNamed: #Object)].
	moveToClasses := self selectVariableTypesFrom: types
				selected: (typer guessTypesFor: variable).
	moveToClasses isNil ifTrue: [self refactoringError: 'Method not moved']! !

!MoveMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkTemporaryVariableNames
	| varNames |
	varNames := parseTree allDefinedVariables.
	selfVariableName notNil ifTrue: [varNames add: selfVariableName].
	varNames do: 
			[:name | 
			moveToClasses do: 
					[:each | 
					(self canReferenceVariable: name in: each) 
						ifTrue: 
							[self refactoringError: ('<1p> already defines a variable called <2s>' 
										expandMacrosWith: each
										with: name)]]]! !

!MoveMethodRefactoring methodsFor: 'transforming' stamp: ''!
compileNewMethods
	moveToClasses 
		do: [:each | each compileTree: parseTree classified: (class protocolsFor: selector)]! !

!MoveMethodRefactoring methodsFor: 'testing' stamp: ''!
hasSelfReferences
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher matches: 'self' do: [:aNode :answer | true].
	self hasOnlySelfReturns 
		ifTrue: [searcher matches: '^self' do: [:aNode :answer | answer]].
	^searcher executeTree: parseTree initialAnswer: false! !

!MoveMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk selector: aSymbol class: aClass variable: aVariableName 
	^(self new)
		model: aRBSmalltalk;
		selector: aSymbol
			class: aClass
			variable: aVariableName;
		yourself! !

!MoveMethodRefactoring methodsFor: 'transforming' stamp: ''!
getArgumentNameForSelf
	self needsToReplaceSelfReferences ifFalse: [^self].
	
	[selfVariableName := self requestSelfArgumentName.
	(self checkInstanceVariableName: selfVariableName in: class) 
		ifTrue: 
			[self verifyTemporaryVariableDoesNotOverride 
				ifFalse: 
					[self 
						refactoringWarning: 'The variable is already defined in one of the classes you''re moving the method to.<n>Try another?' 
								expandMacros.
					selfVariableName := nil]]
		ifFalse: 
			[self 
				refactoringWarning: 'The variable name is not a valid Smalltalk temporary variable name<n>Try again?' 
						expandMacros.
			selfVariableName := nil].
	selfVariableName isNil] 
			whileTrue: []! !

!MoveMethodRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self
		abstractVariables;
		addSelfReturn;
		replaceSelfReferences;
		replaceVariableReferences;
		compileNewMethods;
		compileDelagatorMethod! !

!MoveMethodRefactoring methodsFor: 'private-accessing' stamp: ''!
getClassesToMoveTo
	self isMovingToArgument 
		ifTrue: [self getClassesForTemporaryVariable]
		ifFalse: 
			[self isMovingToInstVar 
				ifTrue: [self getClassesForInstanceVariable]
				ifFalse: [self getClassForGlobalOrClassVariable]].
	moveToClasses isEmpty 
		ifTrue: [self refactoringError: 'No classes selected, method not moved.']! !

!MoveMethodRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream
		nextPutAll: ' selector: #';
		nextPutAll: selector;
		nextPutAll: ' class: '.
	class storeOn: aStream.
	aStream
		nextPutAll: ' variable: ''';
		nextPutAll: variable;
		nextPutAll: ''')'! !

!MoveMethodRefactoring methodsFor: 'transforming' stamp: 'rr 3/16/2004 15:15'!
removeArgument
	"Removes the excess argument if any.
	This argument is the variable which is
	referenced by self in the classes the
	method is moved to. "
	| removeIndex |
	removeIndex := parseTree argumentNames indexOf: variable.
	removeIndex = 0 ifFalse: 
		[parseTree arguments: ((parseTree arguments asOrderedCollection)  
									removeAt: removeIndex; yourself) asArray.
		parseTree selectorParts: ((parseTree selectorParts asOrderedCollection) 
									removeAt: removeIndex; yourself) asArray].! !

!MoveMethodRefactoring methodsFor: 'transforming' stamp: ''!
replaceVariableReferences
	| replacer |
	replacer := ParseTreeRewriter new.
	replacer replace: variable with: 'self'.
	replacer executeTree: parseTree.
	parseTree := replacer tree! !

!MoveMethodRefactoring methodsFor: 'transforming' stamp: ''!
abstractVariables
	self performComponentRefactoring: self abstractVariablesRefactoring.
	parseTree := self abstractVariablesRefactoring parseTree! !

!MoveMethodRefactoring methodsFor: 'transforming' stamp: ''!
abstractVariablesRefactoring
	^AbstractVariablesRefactoring 
		model: self model
		abstractVariablesIn: parseTree
		from: class
		toAll: moveToClasses
		ignoring: variable! !

!MoveMethodRefactoring methodsFor: 'transforming' stamp: ''!
compileDelagatorMethod
	| statementNode delegatorNode tree |
	delegatorNode := RBMessageNode 
				receiver: (RBVariableNode named: variable)
				selectorParts: parseTree selectorParts
				arguments: (parseTree argumentNames collect: 
							[:each | 
							RBVariableNode 
								named: (each = selfVariableName ifTrue: ['self'] ifFalse: [each])]).
	self hasOnlySelfReturns 
		ifFalse: [delegatorNode := RBReturnNode value: delegatorNode].
	statementNode := RBSequenceNode temporaries: #()
				statements: (Array with: delegatorNode).
	(tree := class parseTreeFor: selector) body: statementNode.
	class compileTree: tree! !

!MoveMethodRefactoring methodsFor: 'transforming' stamp: ''!
verifyTemporaryVariableDoesNotOverride
	(parseTree allDefinedVariables includes: selfVariableName) 
		ifTrue: [^false].
	moveToClasses 
		do: [:each | (each definesVariable: selfVariableName) ifTrue: [^false]].
	^true! !

MethodRefactoring subclass: #ExtractMethodToComponentRefactoring
	instanceVariableNames: 'selector extractionInterval extractedMethodSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!ExtractMethodToComponentRefactoring methodsFor: 'transforming' stamp: ''!
extractMethod
	| refactoring |
	refactoring := ExtractMethodRefactoring 
				model: self model
				extract: extractionInterval
				from: selector
				in: class.
	refactoring setOption: #methodName
		toUse: 
			[:ref :methodName | 
			extractedMethodSelector := ref 
						uniqueMethodNameFor: methodName arguments size.
			methodName
				selector: extractedMethodSelector;
				yourself].
	self performComponentRefactoring: refactoring! !

!ExtractMethodToComponentRefactoring class methodsFor: 'instance creation' stamp: ''!
extract: anInterval from: aSelector in: aClass 
	^self new
		extract: anInterval
		from: aSelector
		in: aClass! !

!ExtractMethodToComponentRefactoring methodsFor: 'initialize-release' stamp: ''!
extract: anInterval from: aSelector in: aClass 
	class := self classObjectFor: aClass.
	selector := aSelector.
	extractionInterval := anInterval! !

!ExtractMethodToComponentRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self
		extractMethod;
		moveMethod;
		inlineForwarder! !

!ExtractMethodToComponentRefactoring methodsFor: 'transforming' stamp: ''!
inlineForwarder
	| refactoring |
	refactoring := InlineAllSendersRefactoring 
				model: self model
				sendersOf: extractedMethodSelector
				in: class.
	refactoring setOption: #inlineExpression toUse: [:ref :string | true].
	self performComponentRefactoring: refactoring! !

!ExtractMethodToComponentRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' extract: '.
	extractionInterval storeOn: aStream.
	aStream
		nextPutAll: ' from: #';
		nextPutAll: selector;
		nextPutAll: ' in: '.
	class storeOn: aStream.
	aStream nextPut: $)! !

!ExtractMethodToComponentRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^RBCondition empty! !

!ExtractMethodToComponentRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk extract: anInterval from: aSelector in: aClass 
	^(self new)
		model: aRBSmalltalk;
		extract: anInterval
			from: aSelector
			in: aClass;
		yourself! !

!ExtractMethodToComponentRefactoring methodsFor: 'transforming' stamp: ''!
moveMethod
	| variable refactoring |
	variable := self selectVariableToMoveMethodTo: extractedMethodSelector
				class: class.
	variable isNil ifTrue: [self refactoringError: 'Did not extract method'].
	refactoring := MoveMethodRefactoring 
				model: self model
				selector: extractedMethodSelector
				class: class
				variable: variable.
	self performComponentRefactoring: refactoring! !

MethodRefactoring subclass: #PushUpMethodRefactoring
	instanceVariableNames: 'removeDuplicates selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!PushUpMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkInstVars
	selectors do: [:each | self checkInstVarsFor: each]! !

!PushUpMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkSuperMessages
	self checkSuperSendsFromPushedUpMethods.
	self checkSuperSendsFromSiblings! !

!PushUpMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkInstVarsFor: aSelector 
	class instanceVariableNames do: 
			[:each | 
			((class whichSelectorsReferToInstanceVariable: each) includes: aSelector) ifTrue: 
					[self
						refactoringError: ('<1p> refers to <2s> which is defined in <3p>' expandMacrosWith: aSelector
								with: each
								with: class)]]! !

!PushUpMethodRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(selectors inject: (RBCondition hasSuperclass: class)
		into: [:cond :each | cond & (RBCondition definesSelector: each in: class)]) 
			& (RBCondition withBlock: 
						[self checkInstVars.
						self checkClassVars.
						self checkSuperclass.
						self checkSuperMessages.
						true])! !

!PushUpMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
pushUp: selectorCollection from: aClass 
	^self new pushUp: selectorCollection from: aClass! !

!PushUpMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkClassVarsFor: aSelector 
	class nonMetaclass classVariableNames do: 
			[:each | 
			((class whichSelectorsReferToClassVariable: each) includes: aSelector) 
				ifTrue: 
					[self refactoringError: ('<1p> refers to <2s> which is defined in <3p>' 
								expandMacrosWith: aSelector
								with: each
								with: class)]]! !

!PushUpMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk pushUp: selectorCollection from: aClass 
	^(self new)
		model: aRBSmalltalk;
		pushUp: selectorCollection from: aClass;
		yourself! !

!PushUpMethodRefactoring methodsFor: 'transforming' stamp: ''!
removePushedUpMethods
	selectors do: [:each | class removeMethod: each]! !

!PushUpMethodRefactoring methodsFor: 'transforming' stamp: ''!
copyDownMethods
	selectors do: [:each | self copyDownMethod: each]! !

!PushUpMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkSuperSendsFromSiblings
	| siblings |
	siblings := class superclass subclasses reject: [:each | each = class].
	siblings do: [:aRBClass | self checkSiblingSuperSendsFrom: aRBClass]! !

!PushUpMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkClassVars
	selectors do: [:each | self checkClassVarsFor: each]! !

!PushUpMethodRefactoring methodsFor: 'private' stamp: ''!
copyDownMethod: aSelector 
	| oldProtocol oldSource superclassDefiner subclasses refactoring |
	superclassDefiner := class superclass whoDefinesMethod: aSelector.
	superclassDefiner isNil ifTrue: [^self].
	oldSource := superclassDefiner sourceCodeFor: aSelector.
	oldSource isNil 
		ifTrue: 
			[self 
				refactoringError: ('Source code for <1s> superclass method not available' 
						expandMacrosWith: aSelector)].
	oldProtocol := superclassDefiner protocolsFor: aSelector.
	subclasses := class superclass subclasses 
				reject: [:each | each directlyDefinesMethod: aSelector].
	subclasses isEmpty ifTrue: [^self].
	((superclassDefiner parseTreeFor: aSelector) superMessages 
		detect: [:each | superclassDefiner directlyDefinesMethod: each]
		ifNone: [nil]) notNil 
		ifTrue: 
			[self 
				refactoringError: ('Cannot push up <1s> since we must copy down the superclass method in <2p><n>to the other subclasses, and the superclass method sends a super message which is overriden.' 
						expandMacrosWith: aSelector
						with: superclassDefiner)].
	self 
		refactoringWarning: 'Do you want to copy down the superclass method to the classes that don''t define ' 
				, aSelector.
	refactoring := ExpandReferencedPoolsRefactoring 
				model: self model
				forMethod: (superclassDefiner parseTreeFor: aSelector)
				fromClass: superclassDefiner
				toClasses: subclasses.
	self performComponentRefactoring: refactoring.
	subclasses do: [:each | each compile: oldSource classified: oldProtocol]! !

!PushUpMethodRefactoring methodsFor: 'transforming' stamp: ''!
pushUpMethods
	selectors do: [:each | self pushUp: each]! !

!PushUpMethodRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self
		copyDownMethods;
		pushUpMethods;
		removePushedUpMethods;
		removeDuplicateMethods! !

!PushUpMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkBackReferencesTo: aSelector 
	| definingClass pushUpParseTree |
	definingClass := class superclass whoDefinesMethod: aSelector.
	definingClass isNil ifTrue: [^self].
	pushUpParseTree := class parseTreeFor: aSelector.
	class superclass allSubclasses do: 
			[:each | 
			each selectors do: 
					[:sel | 
					| parseTree |
					parseTree := each parseTreeFor: sel.
					(parseTree notNil and: 
							[(parseTree superMessages includes: aSelector) 
								and: [definingClass == (each whoDefinesMethod: aSelector)]]) 
						ifTrue: 
							[removeDuplicates := true.
							(aSelector == sel 
								and: [parseTree equalTo: pushUpParseTree exceptForVariables: #()]) 
									ifFalse: 
										[self 
											refactoringError: ('Cannot push up <1s> since it would override the method defined in <2p>' 
													expandMacrosWith: aSelector
													with: definingClass)]]]]! !

!PushUpMethodRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' pushUp: '.
	selectors asArray storeOn: aStream.
	aStream nextPutAll: ' from: '.
	class storeOn: aStream.
	aStream nextPut: $)! !

!PushUpMethodRefactoring methodsFor: 'transforming' stamp: ''!
pushUp: aSelector 
	| source refactoring |
	source := class sourceCodeFor: aSelector.
	source isNil 
		ifTrue: [self refactoringError: 'Source for method not available'].
	refactoring := ExpandReferencedPoolsRefactoring 
				model: self model
				forMethod: (class parseTreeFor: aSelector)
				fromClass: class
				toClasses: (Array with: class superclass).
	self performComponentRefactoring: refactoring.
	class superclass compile: source
		classified: (class protocolsFor: aSelector)! !

!PushUpMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkSiblingSuperSendsFrom: aRBClass 
	aRBClass selectors do: 
			[:each | 
			| tree |
			tree := aRBClass parseTreeFor: each.
			tree notNil 
				ifTrue: 
					[tree superMessages do: 
							[:aSelector | 
							(selectors includes: aSelector) 
								ifTrue: 
									[| definer |
									definer := aRBClass superclass whoDefinesMethod: aSelector.
									(definer notNil and: [class includesClass: definer]) 
										ifTrue: 
											[self 
												refactoringError: ('Cannot push up <1s> since <2p>>><3s> sends a super message to it.' 
														expandMacrosWith: aSelector
														with: aRBClass
														with: each)]]]]].
	aRBClass allSubclasses do: [:each | self checkSiblingSuperSendsFrom: each]! !

!PushUpMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkSuperSendsFromPushedUpMethods
	selectors do: 
			[:each | 
			| parseTree |
			parseTree := class parseTreeFor: each.
			(parseTree superMessages 
				detect: [:sup | class superclass directlyDefinesMethod: sup]
				ifNone: [nil]) notNil 
				ifTrue: 
					[self 
						refactoringError: ('Cannot push up <1s> since it sends a super message that is defined in the superclass.' 
								expandMacrosWith: each)]]! !

!PushUpMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkSuperclass
	| overrideSelectors |
	overrideSelectors := selectors 
				select: [:each | class superclass definesMethod: each].
	overrideSelectors := overrideSelectors reject: 
					[:each | 
					| myTree superTree |
					myTree := class parseTreeFor: each.
					superTree := class superclass parseTreeFor: each.
					superTree equalTo: myTree exceptForVariables: #()].
	overrideSelectors isEmpty ifTrue: [^self].
	class superclass isAbstract 
		ifFalse: 
			[self refactoringError: ('Non-abstract class <2p> already defines <1p>' 
						expandMacrosWith: overrideSelectors asArray first
						with: class superclass)].
	overrideSelectors do: [:each | self checkBackReferencesTo: each]! !

!PushUpMethodRefactoring methodsFor: 'transforming' stamp: ''!
removeDuplicateMethods
	selectors do: [:each | self removeDuplicatesOf: each]! !

!PushUpMethodRefactoring methodsFor: 'transforming' stamp: ''!
removeDuplicatesOf: aSelector 
	| tree |
	tree := class superclass parseTreeFor: aSelector.
	class superclass allSubclasses do: 
			[:each | 
			((each directlyDefinesMethod: aSelector) and: 
					[(tree equalTo: (each parseTreeFor: aSelector) exceptForVariables: #()) 
						and: [(each superclass whoDefinesMethod: aSelector) == class superclass]]) 
				ifTrue: 
					[removeDuplicates 
						ifFalse: 
							[removeDuplicates := true.
							self 
								refactoringWarning: 'Do you want to remove duplicate subclass methods?'].
					each removeMethod: aSelector]]! !

!PushUpMethodRefactoring methodsFor: 'initialize-release' stamp: ''!
pushUp: selectorCollection from: aClass 
	class := self classObjectFor: aClass.
	selectors := selectorCollection.
	removeDuplicates := false! !

MethodRefactoring subclass: #InlineMethodRefactoring
	instanceVariableNames: 'sourceInterval inlineParseTree sourceParseTree sourceSelector sourceMessage inlineClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
compileMethod
	class compileTree: sourceParseTree! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
rewriteInlinedTree
	sourceMessage parent isReturn 
		ifTrue: 
			[(sourceParseTree isLast: sourceMessage parent) 
				ifFalse: [self addSelfReturn]]
		ifFalse: 
			[self
				writeGuardClauses;
				normalizeIfTrues;
				normalizeReturns;
				addSelfReturn]! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
renameTemporary: oldName to: newName 
	| rewriter |
	rewriter := ParseTreeRewriter new.
	rewriter
		replace: oldName with: newName;
		replaceArgument: oldName with: newName.
	(rewriter executeTree: inlineParseTree) 
		ifTrue: [inlineParseTree := rewriter tree]! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
replaceArguments
	sourceMessage arguments reverse with: inlineParseTree arguments reverse
		do: 
			[:replacement :source | 
			(replacement isImmediate 
				or: [self shouldInlineExpression: replacement formattedCode]) 
					ifTrue: [self replaceArgument: source with: replacement]
					ifFalse: [self addTemporary: source assignedTo: replacement]]! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
inlineClass
	^inlineClass isNil 
		ifTrue: 
			[inlineClass := (sourceMessage receiver name = 'super' 
						ifTrue: [class superclass]
						ifFalse: [class]) whoDefinesMethod: self inlineSelector]
		ifFalse: [inlineClass]! !

!InlineMethodRefactoring methodsFor: 'initialize-release' stamp: ''!
inline: anInterval inMethod: aSelector forClass: aClass 
	sourceSelector := aSelector.
	class := self classObjectFor: aClass.
	sourceInterval := anInterval! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
addSelfReturn
	inlineParseTree addSelfReturn! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
normalizeIfTrues
	| rewriter |
	rewriter := ParseTreeRewriter new.
	rewriter
		replace: '| `@temps | ``@.s1. ``@boolean ifTrue: [| `@t1 | ``@.Stmts1. ^`@r1]. ``@.s2. ^``@r2'
			with: '| `@temps | ``@.s1. ``@boolean ifTrue: [| `@t1 | ``@.Stmts1. ^`@r1] ifFalse: [``@.s2. ^``@r2]';
		replace: '| `@temps | ``@.s1. ``@boolean ifFalse: [| `@t1 | ``@.Stmts1. ^`@r1]. ``@.s2. ^``@r2'
			with: '| `@temps | ``@.s1. ``@boolean ifTrue: [``@.s2. ^``@r2] ifFalse: [| `@t1 | ``@.Stmts1. ^`@r1]'.
	[rewriter executeTree: inlineParseTree] 
		whileTrue: [inlineParseTree := rewriter tree]! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
removeReturns
	| rewriter |
	rewriter := ParseTreeRewriter new.
	rewriter replace: '^``@object' with: '``@object'.
	(rewriter executeTree: inlineParseTree) 
		ifTrue: [inlineParseTree := rewriter tree]! !

!InlineMethodRefactoring methodsFor: 'testing' stamp: ''!
hasMultipleReturns
	"Do we have multiple returns? If the last statement isn't a return, then we have an implicit return of self."

	| searcher |
	searcher := ParseTreeSearcher new.
	searcher matches: '^``@object'
		do: 
			[:aNode :hasAReturn | 
			hasAReturn ifTrue: [^true].
			true].
	searcher executeTree: inlineParseTree
		initialAnswer: inlineParseTree lastIsReturn not.
	^false! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
removeEmptyIfTrues
	| rewriter |
	rewriter := ParseTreeRewriter new.
	rewriter
		replace: '``@boolean ifTrue: [] ifFalse: [| `@temps | ``@.Stmts]'
			with: '``@boolean ifFalse: [|`@temps | ``@.Stmts]';
		replace: '``@boolean ifFalse: [] ifTrue: [| `@temps | ``@.Stmts]'
			with: '``@boolean ifTrue: [|`@temps | ``@.Stmts]';
		replace: '``@boolean ifTrue: [| `@temps | ``@.Stmts] ifFalse: []'
			with: '``@boolean ifTrue: [|`@temps | ``@.Stmts]';
		replace: '``@boolean ifFalse: [| `@temps | ``@.Stmts] ifTrue: []'
			with: '``@boolean ifFalse: [|`@temps | ``@.Stmts]'.
	(rewriter executeTree: sourceParseTree) 
		ifTrue: [sourceParseTree := rewriter tree]! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
inlineSourceReplacing: aParseTree 
	| statements nodeUnderSequence |
	statements := inlineParseTree body statements.
	(statements size > 1 and: [aParseTree isEvaluatedFirst not]) 
		ifTrue: 
			[self 
				refactoringWarning: 'To inline this method, we need to move some of its statements before the original message send.<n>This could change the order of execution, which can change the behavior.<n>Do you want to proceed?' 
						expandMacros].
	nodeUnderSequence := aParseTree.
	[nodeUnderSequence parent isSequence] 
		whileFalse: [nodeUnderSequence := nodeUnderSequence parent].
	(nodeUnderSequence parent)
		addNodes: (statements copyFrom: 1 to: (statements size - 1 max: 0))
			before: nodeUnderSequence;
		addTemporariesNamed: inlineParseTree body temporaryNames.
	aParseTree parent replaceNode: aParseTree
		withNode: (statements isEmpty 
				ifTrue: [RBVariableNode named: 'self']
				ifFalse: [statements last])! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
removeImmediateBlocks
	| rewriter |
	rewriter := ParseTreeRewriter new.
	rewriter 
		replace: '[``.object] value'
		with: '``.object'
		when: [:aNode | aNode parent isCascade not].
	rewriter 
		replace: '| `@temps | ``@.Stmts1. [| `@bTemps | ``@.bStmts] value. ``@.Stmts2'
		with: '| `@temps `@bTemps | ``@.Stmts1. ``@.bStmts. ``@.Stmts2'.
	(rewriter executeTree: sourceParseTree) 
		ifTrue: [sourceParseTree := rewriter tree]! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self
		renameConflictingTemporaries;
		insertInlinedMethod;
		compileMethod! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
checkSuperMessages
	self inlineClass = class ifTrue: [^self].
	self inlineClass superclass isNil ifTrue: [^self].
	inlineParseTree superMessages do: 
			[:each | 
			(self inlineClass superclass whoDefinesMethod: each) 
				= (class superclass whoDefinesMethod: each) 
					ifFalse: 
						[self 
							refactoringError: ('Cannot inline method since it sends a super message <1s> that is overriden' 
									expandMacrosWith: each)]]! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
replaceArgument: sourceNode with: replacementNode 
	| rewriter |
	rewriter := ParseTreeRewriter new.
	rewriter replaceTree: sourceNode withTree: replacementNode.
	(rewriter executeTree: inlineParseTree body) 
		ifTrue: [inlineParseTree body: rewriter tree]! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
inlineSelector
	sourceMessage isNil ifTrue: [self findSelectedMessage].
	^sourceMessage selector! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
moveComments
	inlineParseTree nodesDo: 
			[:each | 
			each 
				comments: (each comments collect: 
							[:anInterval | 
							| start stop source |
							source := sourceParseTree source.
							start := source size + 1.
							source := source 
										, (inlineParseTree source copyFrom: anInterval first to: anInterval last).
							stop := source size.
							sourceParseTree source: source.
							start to: stop])]! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
insertInlinedMethod
	| node |
	node := sourceMessage.
	self moveComments.
	node parent isCascade 
		ifTrue: 
			[self rewriteCascadedMessage.
			node := node parent].
	node parent isReturn 
		ifTrue: [node := node parent]
		ifFalse: [self removeReturns].
	self replaceArguments.
	self inlineSourceReplacing: node.
	sourceParseTree removeDeadCode.
	self removeEmptyIfTrues.
	self removeImmediateBlocks! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
parseInlineMethod
	self inlineClass isNil 
		ifTrue: 
			[self 
				refactoringError: ('<1p> or its superclasses don''t contain method <2s>' 
						expandMacrosWith: class
						with: self inlineSelector)].
	inlineParseTree := self inlineClass parseTreeFor: self inlineSelector.
	inlineParseTree isNil 
		ifTrue: [self refactoringError: 'Could not parse sources'].
	inlineParseTree lastIsReturn ifFalse: [inlineParseTree addSelfReturn]! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
rewriteCascadedMessage
	| index messages |
	messages := sourceMessage parent messages.
	index := (1 to: messages size) 
				detect: [:i | sourceMessage == (messages at: i)]
				ifNone: [0].
	inlineParseTree body addNodesFirst: (messages copyFrom: 1 to: index - 1).
	self removeReturns.
	inlineParseTree body 
		addNodes: (messages copyFrom: index + 1 to: messages size).
	inlineParseTree addReturn! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
findSelectedMessage
	sourceParseTree := class parseTreeFor: sourceSelector.
	sourceParseTree isNil 
		ifTrue: [self refactoringError: 'Could not parse sources'].
	sourceMessage := sourceParseTree whichNodeIsContainedBy: sourceInterval.
	sourceMessage isNil 
		ifTrue: 
			[self 
				refactoringError: 'The selection doesn''t appear to be a message send'].
	sourceMessage isCascade 
		ifTrue: [sourceMessage := sourceMessage messages last].
	sourceMessage isMessage 
		ifFalse: 
			[self 
				refactoringError: 'The selection doesn''t appear to be a message send'].
	(sourceMessage receiver isVariable 
		and: [#('self' 'super') includes: sourceMessage receiver name]) 
			ifFalse: [self refactoringError: 'Cannot inline non-self messages']! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
addTemporary: sourceNode assignedTo: replacementNode 
	| newName |
	newName := self renameConflictingTemporary: sourceNode name.
	(inlineParseTree body)
		addTemporaryNamed: newName;
		addNodeFirst: (RBAssignmentNode variable: (RBVariableNode named: newName)
					value: replacementNode)! !

!InlineMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk inline: anInterval inMethod: aSelector forClass: aClass 
	^(self new)
		model: aRBSmalltalk;
		inline: anInterval
			inMethod: aSelector
			forClass: aClass;
		yourself! !

InlineMethodRefactoring subclass: #InlineMethodFromComponentRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!InlineMethodFromComponentRefactoring methodsFor: 'transforming' stamp: ''!
inlineClass
	| imps |
	inlineClass notNil ifTrue: [^inlineClass].
	imps := (self model allImplementorsOf: self inlineSelector) 
				asOrderedCollection.
	imps size = 1 ifTrue: [^inlineClass := imps first].
	imps isEmpty 
		ifTrue: 
			[self 
				refactoringError: 'Nobody defines a method named ' , self inlineSelector].
	inlineClass := self requestImplementorToInline: imps.
	inlineClass isNil 
		ifTrue: [self refactoringError: 'No implementor selected'].
	^inlineClass! !

!InlineMethodFromComponentRefactoring methodsFor: 'transforming' stamp: ''!
addArgumentToSelector: aSymbol 
	^aSymbol isInfix 
		ifTrue: [#value:value:]
		ifFalse: [(aSymbol , 'value:') asSymbol]! !

!InlineMethodFromComponentRefactoring methodsFor: 'transforming' stamp: ''!
abstractVariableReferences
	| refactoring |
	refactoring := AbstractVariablesRefactoring 
				model: self model
				abstractVariablesIn: inlineParseTree
				from: inlineClass
				toAll: (Array with: class).
	self performComponentRefactoring: refactoring.
	inlineParseTree := refactoring parseTree! !

!InlineMethodFromComponentRefactoring methodsFor: 'transforming' stamp: ''!
checkSuperMessages
	inlineParseTree superMessages isEmpty 
		ifFalse: 
			[self 
				refactoringError: 'Cannot inline method since it sends a super message']! !

!InlineMethodFromComponentRefactoring methodsFor: 'transforming' stamp: ''!
findSelectedMessage
	sourceParseTree := class parseTreeFor: sourceSelector.
	sourceParseTree isNil 
		ifTrue: [self refactoringError: 'Could not parse sources'].
	sourceMessage := sourceParseTree whichNodeIsContainedBy: sourceInterval.
	sourceMessage isNil 
		ifTrue: 
			[self 
				refactoringError: 'The selection doesn''t appear to be a message send'].
	sourceMessage isCascade 
		ifTrue: [sourceMessage := sourceMessage messages last].
	sourceMessage isMessage 
		ifFalse: 
			[self 
				refactoringError: 'The selection doesn''t appear to be a message send']! !

!InlineMethodFromComponentRefactoring methodsFor: 'testing' stamp: ''!
isOverridden
	^(self inlineClass allSubclasses 
		detect: [:each | each directlyDefinesMethod: self inlineSelector]
		ifNone: [nil]) notNil! !

!InlineMethodFromComponentRefactoring methodsFor: 'transforming' stamp: ''!
renameSelfReferences
	self addSelfReferenceToSourceMessage.
	self addSelfReferenceToInlineParseTree.! !

!InlineMethodFromComponentRefactoring methodsFor: 'transforming' stamp: ''!
addSelfReferenceToInlineParseTree
	| variableName rewriter newArguments |
	variableName := self newNameForSelf.
	rewriter := ParseTreeRewriter rename: 'self' to: variableName.
	(rewriter executeTree: inlineParseTree) 
		ifTrue: [inlineParseTree := rewriter tree].
	newArguments := inlineParseTree arguments asOrderedCollection.
	newArguments addFirst: (RBVariableNode named: variableName).
	inlineParseTree
		arguments: newArguments;
		selector: (self addArgumentToSelector: inlineParseTree selector).
	sourceMessage receiver replaceWith: (RBVariableNode named: variableName)! !

!InlineMethodFromComponentRefactoring methodsFor: 'transforming' stamp: ''!
addSelfReferenceToSourceMessage
	| newArguments |
	newArguments := sourceMessage arguments asOrderedCollection.
	newArguments addFirst: sourceMessage receiver copy.
	sourceMessage
		arguments: newArguments;
		selector: (self addArgumentToSelector: sourceMessage selector)! !

!InlineMethodFromComponentRefactoring methodsFor: 'transforming' stamp: ''!
safeVariableNameBasedOn: aString 
	"Creates an unused variable name containing aString"

	| baseString newString i allTempVars |
	allTempVars := inlineParseTree allTemporaryVariables.
	baseString := aString copy.
	baseString at: 1 put: baseString first asLowercase.
	newString := baseString.
	i := 0.
	
	[(allTempVars includes: newString) 
		or: [class definesInstanceVariable: newString]] 
			whileTrue: 
				[i := i + 1.
				newString := baseString , i printString].
	^newString! !

!InlineMethodFromComponentRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self abstractVariableReferences.
	self renameSelfReferences.
	super transform! !

!InlineMethodFromComponentRefactoring methodsFor: 'transforming' stamp: ''!
newNameForSelf
	| variableName index originalName nonMetaClass |
	nonMetaClass := inlineClass nonMetaclass.
	variableName := originalName := (nonMetaClass name first isVowel 
						ifTrue: ['an']
						ifFalse: ['a']) , nonMetaClass name.
	index := 1.
	
	[variableName := self safeVariableNameBasedOn: variableName.
	inlineParseTree allDefinedVariables includes: variableName] 
			whileTrue: 
				[variableName := originalName , index printString.
				index := index + 1].
	^variableName! !

!InlineMethodRefactoring methodsFor: 'testing' stamp: ''!
isOverridden
	^(class allSubclasses detect: [:each | each directlyDefinesMethod: self inlineSelector]
		ifNone: [nil]) notNil! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
writeGuardClauses
	| rewriter |
	rewriter := ParseTreeRewriter new.
	rewriter
		replaceMethod: '`@methodName: `@args | `@temps | `@.s1. `@boolean ifTrue: [| `@t1 | `@.Stmts1. ^`@r1]. `@.s2. ^`@r2'
			with: '`@methodName: `@args | `@temps | `@.s1. `@boolean ifTrue: [| `@t1 | `@.Stmts1. ^`@r1] ifFalse: [`@.s2. ^`@r2]';
		replaceMethod: '`@methodName: `@args | `@temps | `@.s1. `@boolean ifFalse: [| `@t1 | `@.Stmts1. ^`@r1]. `@.s2. ^`@r2'
			with: '`@methodName: `@args | `@temps | `@.s1. `@boolean ifTrue: [`@.s2. ^`@r2] ifFalse: [| `@t1 | `@.Stmts1. ^`@r1]';
		replaceMethod: '`@methodName: `@args | `@temps | `@.s1. `@boolean ifTrue: [| `@t1 | `@.Stmts1. ^`@r1]. `@.s2'
			with: '`@methodName: `@args | `@temps | `@.s1. `@boolean ifTrue: [| `@t1 | `@.Stmts1. ^`@r1] ifFalse: [`@.s2. ^self]';
		replaceMethod: '`@methodName: `@args | `@temps | `@.s1. `@boolean ifFalse: [| `@t1 | `@.Stmts1. ^`@r1]. `@.s2'
			with: '`@methodName: `@args | `@temps | `@.s1. `@boolean ifTrue: [`@.s2. ^self] ifFalse: [| `@t1 | `@.Stmts1. ^`@r1]'.
	[rewriter executeTree: inlineParseTree] 
		whileTrue: [inlineParseTree := rewriter tree]! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
normalizeReturns
	| rewriter |
	rewriter := ParseTreeRewriter new.
	rewriter
		replace: '^``@boolean ifTrue: [| `@t1 | `@.Stmts1. ^``@r1] ifFalse: [| `@t2 | `@.Stmts2. ^``@r2]'
			with: '^``@boolean ifTrue: [| `@t1 | `@.Stmts1. ``@r1] ifFalse: [| `@t2 | `@.Stmts2. ``@r2]';
		replace: '^``@boolean ifFalse: [| `@t1 | `@.Stmts1. ^``@r1] ifTrue: [| `@t2 | `@.Stmts2. ^``@r2]'
			with: '^``@boolean ifFalse: [| `@t1 | `@.Stmts1. ``@r1] ifTrue: [| `@t2 | `@.Stmts2. ``@r2]';
		replace: '^``@boolean ifTrue: [| `@t1 | `@.Stmts1. ``@r1] ifFalse: [| `@t2 | `@.Stmts2. ^``@r2]'
			with: '^``@boolean ifTrue: [| `@t1 | `@.Stmts1. ``@r1] ifFalse: [| `@t2 | `@.Stmts2. ``@r2]';
		replace: '^``@boolean ifFalse: [| `@t1 | `@.Stmts1. ``@r1] ifTrue: [| `@t2 | `@.Stmts2. ^``@r2]'
			with: '^``@boolean ifFalse: [| `@t1 | `@.Stmts1. ``@r1] ifTrue: [| `@t2 | `@.Stmts2. ``@r2]';
		replace: '^``@boolean ifTrue: [| `@t1 | `@.Stmts1. ^``@r1] ifFalse: [| `@t2 | `@.Stmts2. ``@r2]'
			with: '^``@boolean ifTrue: [| `@t1 | `@.Stmts1. ``@r1] ifFalse: [| `@t2 | `@.Stmts2. ``@r2]';
		replace: '^``@boolean ifFalse: [| `@t1 | `@.Stmts1. ^``@r1] ifTrue: [| `@t2 | `@.Stmts2. ``@r2]'
			with: '^``@boolean ifFalse: [| `@t1 | `@.Stmts1. ``@r1] ifTrue: [| `@t2 | `@.Stmts2. ``@r2]';
		replace: '``@boolean ifTrue: [| `@t1 | `@.Stmts1. ^``@r1] ifFalse: [| `@t2 | `@.Stmts2. ^``@r2]'
			with: '^``@boolean ifTrue: [| `@t1 | `@.Stmts1. ``@r1] ifFalse: [| `@t2 | `@.Stmts2. ``@r2]';
		replace: '``@boolean ifFalse: [| `@t1 | `@.Stmts1. ^``@r1] ifTrue: [| `@t2 | `@.Stmts2. ^``@r2]'
			with: '^``@boolean ifFalse: [| `@t1 | `@.Stmts1. ``@r1] ifTrue: [| `@t2 | `@.Stmts2. ``@r2]'.
	[rewriter executeTree: inlineParseTree] 
		whileTrue: [inlineParseTree := rewriter tree]! !

!InlineMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
inline: anInterval inMethod: aSelector forClass: aClass 
	^self new 
		inline: anInterval
		inMethod: aSelector
		forClass: aClass! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
renameConflictingTemporary: aName 
	| allNames newName index seqNode |
	allNames := (Set new)
				addAll: inlineParseTree allDefinedVariables;
				yourself.
	allNames remove: aName ifAbsent: [].
	seqNode := sourceMessage.
	[seqNode isSequence] whileFalse: [seqNode := seqNode parent].
	allNames addAll: seqNode allDefinedVariables.	"Add those variables defined in blocks. This might cause a few 
													variables to be renamed that don't need to be, but this should be safe."
	newName := aName.
	index := 0.
	
	[(sourceMessage whoDefines: newName) notNil or: 
			[(class hierarchyDefinesVariable: newName) or: [allNames includes: newName]]] 
			whileTrue: 
				[index := index + 1.
				newName := aName , index printString].
	newName = aName ifFalse: [self renameTemporary: aName to: newName].
	^newName! !

!InlineMethodRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition definesSelector: sourceSelector in: class) 
		& (RBCondition withBlock: 
					[self findSelectedMessage.
					self isOverridden 
						ifTrue: 
							[self 
								refactoringWarning: ('<1p>>><2s> is overriden. Do you want to inline it anyway?' 
										expandMacrosWith: self inlineClass
										with: self inlineSelector)].
					self parseInlineMethod.
					self isPrimitive 
						ifTrue: [self refactoringError: 'Cannot inline primitives'].
					self checkSuperMessages.
					self rewriteInlinedTree.
					(sourceMessage parent isReturn or: [self hasMultipleReturns not]) 
						ifFalse: 
							[self 
								refactoringError: 'Cannot inline method since it contains multiple returns that cannot be rewritten'].
					true])! !

!InlineMethodRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' inline: '.
	sourceInterval storeOn: aStream.
	aStream
		nextPutAll: ' inMethod: #';
		nextPutAll: sourceSelector;
		nextPutAll: ' forClass: '.
	class storeOn: aStream.
	aStream nextPut: $)! !

!InlineMethodRefactoring methodsFor: 'transforming' stamp: ''!
renameConflictingTemporaries
	inlineParseTree allDefinedVariables 
		do: [:each | self renameConflictingTemporary: each]! !

!InlineMethodRefactoring methodsFor: 'testing' stamp: ''!
isPrimitive
	^inlineParseTree isPrimitive! !

MethodRefactoring subclass: #MoveVariableDefinitionRefactoring
	instanceVariableNames: 'selector interval name parseTree blockNodes definingNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!MoveVariableDefinitionRefactoring methodsFor: 'initialize-release' stamp: ''!
class: aClass selector: aSelector interval: anInterval 
	interval := anInterval.
	class := self classObjectFor: aClass.
	selector := aSelector! !

!MoveVariableDefinitionRefactoring class methodsFor: 'instance creation' stamp: ''!
bindTight: anInterval in: aClass selector: aSelector 
	^self new
		class: aClass
		selector: aSelector
		interval: anInterval! !

!MoveVariableDefinitionRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk bindTight: anInterval in: aClass selector: aSelector 
	^(self new)
		model: aRBSmalltalk;
		class: aClass
			selector: aSelector
			interval: anInterval;
		yourself! !

!MoveVariableDefinitionRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition definesSelector: selector in: class) 
		& (RBCondition withBlock: 
					[| methodSource |
					interval first <= interval last 
						ifFalse: [self refactoringError: 'Invalid variable name'].
					methodSource := class sourceCodeFor: selector.
					methodSource size >= interval last 
						ifFalse: [self refactoringError: 'Invalid range for variable'].
					name := methodSource copyFrom: interval first to: interval last.
					(self checkInstanceVariableName: name in: class) 
						ifFalse: 
							[self 
								refactoringError: name , ' does not seem to be a valid variable name.'].
					parseTree := class parseTreeFor: selector.
					self checkParseTree.
					true])! !

!MoveVariableDefinitionRefactoring methodsFor: 'transforming' stamp: ''!
transform
	definingNode removeTemporaryNamed: name.
	blockNodes do: [:each | each body addTemporaryNamed: name].
	class compileTree: parseTree! !

!MoveVariableDefinitionRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' bindTight: '.
	interval storeOn: aStream.
	aStream nextPutAll: ' in: '.
	class storeOn: aStream.
	aStream
		nextPutAll: ' selector: #';
		nextPutAll: selector.
	aStream nextPut: $)! !

!MoveVariableDefinitionRefactoring methodsFor: 'transforming' stamp: ''!
checkNodes: sequenceNodes 
	(sequenceNodes 
		detect: [:each | RBReadBeforeWrittenTester isVariable: name readBeforeWrittenIn: each]
		ifNone: [nil]) notNil 
		ifTrue: [^false].
	sequenceNodes do: 
			[:each | 
			(self usesDirectly: each body) 
				ifTrue: [blockNodes add: each]
				ifFalse: 
					[(self checkNodes: (self subblocksIn: each body)) 
						ifFalse: [blockNodes add: each]]].
	^true! !

!MoveVariableDefinitionRefactoring methodsFor: 'transforming' stamp: ''!
subblocksIn: aParseTree 
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher matches: '[:`@blockTemps | | `@temps | `@.Statements]'
		do: 
			[:aNode :answer | 
			(aNode references: name)
				ifTrue: [answer add: aNode].
			answer].
	^searcher executeTree: aParseTree initialAnswer: OrderedCollection new! !

!MoveVariableDefinitionRefactoring methodsFor: 'transforming' stamp: ''!
usesDirectly: aParseTree 
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher
		matches: '[:`@args | | `@temps | `@.Statements]'
			do: [:aNode :answer | answer];
		matches: name do: [:aNode :answer | true].
	^searcher executeTree: aParseTree initialAnswer: false! !

!MoveVariableDefinitionRefactoring methodsFor: 'transforming' stamp: ''!
checkParseTree
	| node |
	blockNodes := OrderedCollection new.
	node := self whichVariableNode: parseTree
				inInterval: interval
				name: name.
	node isNil
		ifTrue: [self refactoringError: 'Unable to locate node in parse tree'].
	definingNode := node whoDefines: name.
	definingNode isNil
		ifTrue: [self refactoringError: 'Cannot locate variable definition'].
	definingNode isSequence
		ifFalse: [self refactoringError: 'Variable is an argument'].
	(self usesDirectly: definingNode)
		ifTrue: [self refactoringError: 'Variable already bound tightly as possible'].
	(self checkNodes: (self subblocksIn: definingNode))
		ifFalse: [self refactoringError: 'Variable is possibly read before written']! !

MethodRefactoring subclass: #RemoveMethodRefactoring
	instanceVariableNames: 'selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!RemoveMethodRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' removeMethods: '.
	selectors asArray storeOn: aStream.
	aStream nextPutAll: ' from: '.
	class storeOn: aStream.
	aStream nextPut: $)! !

!RemoveMethodRefactoring methodsFor: 'initialize-release' stamp: ''!
removeMethods: selectorCollection from: aClass 
	class := self classObjectFor: aClass.
	selectors := selectorCollection! !

!RemoveMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkSuperMethods
	| superMessages nonSupers |
	nonSupers := OrderedCollection new.
	superMessages := OrderedCollection new.
	(selectors reject: [:each | self justSendsSuper: each]) do: 
			[:each | 
			(self superclassEquivalentlyDefines: each) 
				ifTrue: 
					[(class parseTreeFor: each) superMessages isEmpty 
						ifFalse: [superMessages add: each]]
				ifFalse: [nonSupers add: each]].
	nonSupers isEmpty & superMessages isEmpty ifTrue: [^self].
	self checkReferencesToAnyOf: nonSupers.
	self checkReferencesToSuperSendsToAnyOf: superMessages! !

!RemoveMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkReferencesToSuperSendsToAnyOf: superMessages 
	[superMessages isEmpty] whileFalse: 
			[self 
				refactoringWarning: ('Although <1s> is equivalent to a superclass method,<n>it contains a super send so it might modify behavior.' 
						expandMacrosWith: superMessages first).
			superMessages remove: superMessages first]! !

!RemoveMethodRefactoring methodsFor: 'preconditions' stamp: ''!
superclassEquivalentlyDefines: aSelector 
	| superTree myTree |
	class superclass isNil ifTrue: [^false].
	superTree := class superclass parseTreeFor: aSelector.
	myTree := class parseTreeFor: aSelector.
	(superTree isNil or: [myTree isNil]) ifTrue: [^false].
	^superTree equalTo: myTree exceptForVariables: #()! !

!RemoveMethodRefactoring methodsFor: 'preconditions' stamp: ''!
justSendsSuper: aSelector 
	| matcher parseTree superclass |
	matcher := ParseTreeSearcher justSendsSuper.
	parseTree := class parseTreeFor: aSelector.
	(matcher executeTree: parseTree initialAnswer: false) ifFalse: [^false].
	parseTree lastIsReturn ifTrue: [^true].
	superclass := class superclass whichClassIncludesSelector: aSelector.
	superclass isNil ifTrue: [^true].	"Since there isn't a superclass that implements the message, we can 
								 delete it since it would be an error anyway."
	parseTree := superclass parseTreeFor: aSelector.
	matcher := ParseTreeSearcher new.
	matcher matches: '^``@object'
		do: 
			[:aNode :answer | 
			answer
				add: aNode value;
				yourself].
	matcher executeTree: parseTree initialAnswer: Set new.
	^(matcher answer 
		detect: [:each | (each isVariable and: [each name = 'self']) not]
		ifNone: [nil]) isNil! !

!RemoveMethodRefactoring methodsFor: 'preconditions' stamp: ''!
checkReferencesToAnyOf: aSelectorCollection 
	aSelectorCollection do: 
			[:each | 
			self model allReferencesTo: each
				do: 
					[:aRBMethod | 
					(aSelectorCollection includes: aRBMethod selector) 
						ifFalse: 
							[self 
								refactoringError: ('Possible call to <2s> in <1p><n>Browse references?' 
										expandMacrosWith: aRBMethod modelClass
										with: each)
								with: [self openBrowserOn: (BrowserEnvironment new referencesTo: each)]]]]! !

!RemoveMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk removeMethods: selectorCollection from: aClass 
	^(self new)
		model: aRBSmalltalk;
		removeMethods: selectorCollection from: aClass;
		yourself! !

!RemoveMethodRefactoring methodsFor: 'transforming' stamp: ''!
transform
	selectors do: [:each | class removeMethod: each]! !

!RemoveMethodRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(selectors inject: RBCondition empty
		into: [:cond :each | cond & (RBCondition definesSelector: each in: class)]) 
			& (RBCondition withBlock: 
						[self checkSuperMethods.
						true])! !

!RemoveMethodRefactoring class methodsFor: 'instance creation' stamp: ''!
removeMethods: selectorCollection from: aClass
	^self new removeMethods: selectorCollection from: aClass! !

MethodRefactoring subclass: #TemporaryToInstanceVariableRefactoring
	instanceVariableNames: 'selector temporaryVariableName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!TemporaryToInstanceVariableRefactoring methodsFor: 'transforming' stamp: ''!
transform
	| parseTree matcher protocols |
	parseTree := class parseTreeFor: selector.
	parseTree isNil ifTrue: [self refactoringError: 'Could not parse method'].
	protocols := class protocolsFor: selector.
	class removeMethod: selector.
	class addInstanceVariable: temporaryVariableName.
	(matcher := ParseTreeRewriter removeTemporaryNamed: temporaryVariableName) 
		executeTree: parseTree.
	class compileTree: matcher tree classified: protocols! !

!TemporaryToInstanceVariableRefactoring methodsFor: 'initialize-release' stamp: ''!
class: aClass selector: aSelector variable: aVariableName 
	class := self classObjectFor: aClass.
	selector := aSelector.
	temporaryVariableName := aVariableName! !

!TemporaryToInstanceVariableRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition definesSelector: selector in: class) 
		& (RBCondition hierarchyOf: class
				definesVariable: temporaryVariableName asString) not 
			& (RBCondition withBlock: 
						[self checkForValidTemporaryVariable.
						true])! !

!TemporaryToInstanceVariableRefactoring methodsFor: 'preconditions' stamp: ''!
checkForValidTemporaryVariable
	| parseTree |
	parseTree := class parseTreeFor: selector.
	(parseTree allTemporaryVariables includes: temporaryVariableName) 
		ifFalse: 
			[self refactoringError: temporaryVariableName 
						, ' isn''t a valid temporary variable name'].
	(parseTree allArgumentVariables includes: temporaryVariableName) 
		ifTrue: 
			[self refactoringError: temporaryVariableName , ' is a block parameter'].
	(RBReadBeforeWrittenTester isVariable: temporaryVariableName
		readBeforeWrittenIn: parseTree) 
			ifTrue: 
				[self 
					refactoringWarning: ('<1s> is read before it is written.<n>Proceed anyway?' 
							expandMacrosWith: temporaryVariableName)]! !

!TemporaryToInstanceVariableRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk class: aClass selector: aSelector variable: aVariableName 
	^(self new)
		model: aRBSmalltalk;
		class: aClass
			selector: aSelector
			variable: aVariableName;
		yourself! !

!TemporaryToInstanceVariableRefactoring class methodsFor: 'instance creation' stamp: ''!
class: aClass selector: aSelector variable: aVariableName 
	^self new 
		class: aClass
		selector: aSelector
		variable: aVariableName! !

!TemporaryToInstanceVariableRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' class: '.
	class storeOn: aStream.
	aStream
		nextPutAll: ' selector: #';
		nextPutAll: selector;
		nextPutAll: ' variable: ''';
		nextPutAll: temporaryVariableName;
		nextPut: $'.
	aStream nextPut: $)! !

!Refactoring methodsFor: 'private' stamp: ''!
classObjectFor: anObject 
	anObject isBehavior ifTrue: [^self model classFor: anObject].
	anObject isSymbol ifTrue: [^self model classNamed: anObject].
	^anObject! !

!Refactoring methodsFor: 'transforming' stamp: ''!
defaultEnvironment
	^BrowserEnvironment new! !

!Refactoring methodsFor: 'utilities' stamp: ''!
checkMethodName: aName in: aClass 
	^RBCondition checkMethodName: aName in: aClass! !

!Refactoring methodsFor: 'support' stamp: ''!
convertAllReferencesToClass: aRBClass using: searchReplacer 
	self model allReferencesToClass: aRBClass
		do: 
			[:method | 
			self 
				convertMethod: method selector
				for: method modelClass
				using: searchReplacer]! !

!Refactoring methodsFor: 'requests' stamp: 'rr 3/15/2004 11:48'!
selectVariableTypesFrom: initialTypeCollection selected: selectedTypeCollection 
	"Temporary workaround to get something usable here,
	which will avoid entering the emergency evaluator too..."
	
	"^(self options at: #variableTypes) 
		value: self
		value: initialTypeCollection
		value: selectedTypeCollection"
	| init classes |
	init := ''.
	initialTypeCollection do: [:each | init := init, each asString, Character space asString].
	classes := FillInTheBlank request: 'Here are the types found by the RefactoryTyper.
	Since you are smarter than it, you can edit the list to add or remove 
	relevant classes at your will' initialAnswer: init.
	^ (classes findTokens: Character space asString) collect: 
		[:each | self model classFor: (Smalltalk at: each withBlanksTrimmed asSymbol)].
	
! !

!Refactoring methodsFor: 'utilities' stamp: ''!
whichVariableNode: aParseTree inInterval: anInterval name: aName 
	| matcher block |
	matcher := ParseTreeSearcher new.
	block := 
			[:aNode :answer | 
			(aNode intersectsInterval: anInterval) ifTrue: [aNode] ifFalse: [answer]].
	matcher
		matches: aName do: block;
		matchesArgument: aName do: block.
	^matcher executeTree: aParseTree initialAnswer: nil! !

!Refactoring methodsFor: 'support' stamp: ''!
convertClasses: classSet select: aBlock using: searchReplacer 
	classSet do: 
			[:aClass | 
			(aBlock value: aClass) do: 
					[:selector | 
					self 
						convertMethod: selector
						for: aClass
						using: searchReplacer]]! !

!Refactoring methodsFor: 'transforming' stamp: ''!
transform
	self subclassResponsibility! !

!Refactoring methodsFor: 'utilities' stamp: ''!
poolVariableNamesFor: aClass 
	| pools |
	pools := Set new.
	aClass withAllSuperclasses do: 
			[:each | 
			each allPoolDictionaryNames do: 
					[:pool | 
					pools addAll: ((Smalltalk at: pool asSymbol) keys 
								collect: [:name | name asString])]].
	^pools! !

!Refactoring methodsFor: 'transforming' stamp: ''!
model
	^model isNil 
		ifTrue: 
			[model := (RBNamespace onEnvironment: self defaultEnvironment)
						name: self printString;
						yourself]
		ifFalse: [model]! !

Refactoring subclass: #SplitClassRefactoring
	instanceVariableNames: 'class instanceVariables newClassName referenceVariableName newClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!SplitClassRefactoring methodsFor: 'private-transforming' stamp: ''!
addClass
	self performComponentRefactoring: (AddClassRefactoring 
				model: self model
				addClass: newClassName
				superclass: Object
				subclasses: #()
				category: class category).
	newClass := self model classNamed: newClassName! !

!SplitClassRefactoring class methodsFor: 'instance creation' stamp: ''!
class: class instanceVariables: instVars newClassName: className referenceVariableName: newVariable 
	^(self new)
		class: class
			instanceVariables: instVars
			newClassName: className
			referenceVariableName: newVariable;
		yourself! !

!SplitClassRefactoring methodsFor: 'transforming' stamp: ''!
createNewClass
	self
		addClass;
		addInstanceVariables! !

!SplitClassRefactoring methodsFor: 'initialize-release' stamp: ''!
class: aClass instanceVariables: instVars newClassName: className referenceVariableName: newVariable 
	class := self model classFor: aClass.
	instanceVariables := instVars.
	newClassName := className.
	referenceVariableName := newVariable! !

!SplitClassRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk class: class instanceVariables: instVars newClassName: className referenceVariableName: newVariable 
	^(self new)
		model: aRBSmalltalk;
		class: class
			instanceVariables: instVars
			newClassName: className
			referenceVariableName: newVariable;
		yourself! !

!SplitClassRefactoring methodsFor: 'transforming' stamp: ''!
createReference
	self performComponentRefactoring: (AddInstanceVariableRefactoring 
				variable: referenceVariableName
				class: class)! !

!SplitClassRefactoring methodsFor: 'transforming' stamp: ''!
abstractVariableReferences
	instanceVariables do: [:each | self abstractReferenceTo: each]! !

!SplitClassRefactoring methodsFor: 'private-transforming' stamp: ''!
abstractReferenceTo: each 
	| setterMethod replacer accessorRef getterMethod |
	accessorRef := CreateAccessorsForVariableRefactoring 
				variable: each
				class: newClass
				classVariable: false.
	self performComponentRefactoring: accessorRef.
	getterMethod := accessorRef getterMethod.
	setterMethod := accessorRef setterMethod.
	replacer := ParseTreeRewriter 
				variable: each
				getter: getterMethod
				setter: setterMethod
				receiver: referenceVariableName.
	self 
		convertClasses: class withAllSubclasses
		select: [:aClass | aClass whichSelectorsReferToInstanceVariable: each]
		using: replacer.
	self performComponentRefactoring: (RemoveInstanceVariableRefactoring 
				remove: each
				from: class)! !

!SplitClassRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition isValidClassName: newClassName) 
		& (RBCondition isGlobal: newClassName in: self model) not 
			& (RBCondition isValidInstanceVariableName: referenceVariableName for: class) 
			& (RBCondition hierarchyOf: class definesVariable: referenceVariableName) 
					not 
			& (RBCondition isGlobal: referenceVariableName in: self model) not 
			& (RBCondition definesTemporaryVariable: referenceVariableName in: class) 
					not! !

!SplitClassRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self
		createNewClass;
		createReference;
		abstractVariableReferences! !

!SplitClassRefactoring methodsFor: 'private-transforming' stamp: ''!
addInstanceVariables
	instanceVariables do: 
			[:each | 
			self performComponentRefactoring: (AddInstanceVariableRefactoring 
						model: self model
						variable: each
						class: newClass)]! !

!SplitClassRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' class: '.
	class storeOn: aStream.
	aStream nextPutAll: ' instanceVariables: '.
	instanceVariables asArray storeOn: aStream.
	aStream
		nextPutAll: ' newClassName: #';
		nextPutAll: newClassName;
		nextPutAll: ' referenceVariableName: ''';
		nextPutAll: referenceVariableName;
		nextPutAll: ''')'! !

!Refactoring methodsFor: 'requests' stamp: ''!
shouldOverride: aSelector in: aClass 
	^(self options at: #alreadyDefined) 
		value: self
		value: aClass
		value: aSelector! !

!Refactoring class methodsFor: 'accessing signal' stamp: ''!
preconditionSignal
	^RefactoringError , RefactoringWarning! !

!Refactoring methodsFor: 'private' stamp: ''!
uniqueMethodNameFor: anInteger 
	| before after index name |
	before := 'a'.
	after := ''.
	anInteger timesRepeat: [after := after , 'z:'].
	index := 0.
	
	[name := before , index printString , after.
	(Symbol findInterned: name) notNil] 
			whileTrue: [index := index + 1].
	^name asSymbol! !

Refactoring subclass: #AbstractVariablesRefactoring
	instanceVariableNames: 'tree fromClass instVarReaders instVarWriters classVarReaders classVarWriters toClasses ignore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!AbstractVariablesRefactoring methodsFor: 'transforming' stamp: ''!
classVariableNames
	| nonMetaClass |
	nonMetaClass := fromClass nonMetaclass.
	^(nonMetaClass allClassVariableNames collect: [:each | each asString]) asSet! !

!AbstractVariablesRefactoring methodsFor: 'transforming' stamp: ''!
computeVariablesToAbstract
	| searcher |
	instVarReaders := Set new.
	instVarWriters := Set new.
	classVarReaders := Set new.
	classVarWriters := Set new.
	searcher := ParseTreeSearcher new.
	searcher
		matches: '`var := ``@anything'
			do: [:aNode :answer | self processAssignmentNode: aNode];
		matches: '`var' do: [:aNode :answer | self processReferenceNode: aNode].
	searcher executeTree: tree.
	self removeDefinedClassVariables! !

!AbstractVariablesRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk abstractVariablesIn: aBRProgramNode from: fromBehavior toAll: behaviorCollection 
	^self 
		model: aRBSmalltalk
		abstractVariablesIn: aBRProgramNode
		from: fromBehavior
		toAll: behaviorCollection
		ignoring: nil! !

!AbstractVariablesRefactoring methodsFor: 'transforming' stamp: ''!
abstractInstanceVariables
	| variables |
	instVarReaders isEmpty & instVarWriters isEmpty ifTrue: [^self].
	variables := Set new.
	variables
		addAll: instVarReaders;
		addAll: instVarWriters.
	variables do: [:each | self abstractInstanceVariable: each]! !

!AbstractVariablesRefactoring methodsFor: 'transforming' stamp: ''!
removeDefinedClassVariables
	| selectionBlock nonMetaClass |
	nonMetaClass := fromClass nonMetaclass.
	selectionBlock := 
			[:varName | 
			(toClasses detect: 
					[:each | 
					((each nonMetaclass) 
						includesClass: (nonMetaClass whoDefinesClassVariable: varName)) not]
				ifNone: [nil]) notNil].
	classVarReaders := classVarReaders select: selectionBlock.
	classVarWriters := classVarWriters select: selectionBlock! !

!AbstractVariablesRefactoring methodsFor: 'transforming' stamp: ''!
abstractClassVariables
	| variables |
	classVarReaders isEmpty & classVarWriters isEmpty ifTrue: [^self].
	variables := Set new.
	variables
		addAll: classVarReaders;
		addAll: classVarWriters.
	variables do: [:each | self abstractClassVariable: each]! !

!AbstractVariablesRefactoring methodsFor: 'testing' stamp: ''!
hasVariablesToAbstract
	^(instVarReaders isEmpty 
		& instVarWriters isEmpty 
		& classVarReaders isEmpty 
		& classVarWriters isEmpty) 
		not! !

!AbstractVariablesRefactoring methodsFor: 'accessing' stamp: ''!
parseTree
	^tree! !

!AbstractVariablesRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^RBCondition empty! !

!AbstractVariablesRefactoring methodsFor: 'initialize-release' stamp: ''!
abstractVariablesIn: aBRProgramNode from: fromBehavior toAll: behaviorCollection ignoring: aVariableName 
	| poolRefactoring |
	tree := aBRProgramNode.
	fromClass := self classObjectFor: fromBehavior.
	toClasses := behaviorCollection 
				collect: [:each | self classObjectFor: each].
	ignore := aVariableName.
	poolRefactoring := ExpandReferencedPoolsRefactoring 
				model: self model
				forMethod: tree
				fromClass: fromClass
				toClasses: toClasses.
	self performComponentRefactoring: poolRefactoring.
	self computeVariablesToAbstract! !

!AbstractVariablesRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk abstractVariablesIn: aBRProgramNode from: fromBehavior toAll: behaviorCollection ignoring: aVariableName 
	^(self new)
		model: aRBSmalltalk;
		abstractVariablesIn: aBRProgramNode
			from: fromBehavior
			toAll: behaviorCollection
			ignoring: aVariableName;
		yourself! !

!AbstractVariablesRefactoring methodsFor: 'transforming' stamp: ''!
instanceVariableNames
	^fromClass allInstanceVariableNames asSet! !

!AbstractVariablesRefactoring methodsFor: 'transforming' stamp: ''!
abstractInstanceVariable: aString 
	| refactoring rewriter |
	refactoring := CreateAccessorsForVariableRefactoring 
				model: self model
				variable: aString
				class: fromClass
				classVariable: false.
	self performComponentRefactoring: refactoring.
	rewriter := ParseTreeRewriter new.
	rewriter
		replace: aString , ' := ``@object'
			with: ('self <1s> ``@object' expandMacrosWith: refactoring setterMethod);
		replace: aString with: 'self ' , refactoring getterMethod.
	(rewriter executeTree: tree) ifTrue: [tree := rewriter tree]! !

!AbstractVariablesRefactoring methodsFor: 'transforming' stamp: ''!
processAssignmentNode: aNode 
	| varName |
	varName := aNode variable name.
	ignore = varName ifTrue: [^self].
	(aNode whoDefines: varName) notNil ifTrue: [^self].
	(self instanceVariableNames includes: varName) 
		ifTrue: [instVarWriters add: varName].
	(self classVariableNames includes: varName) 
		ifTrue: [classVarWriters add: varName]! !

!AbstractVariablesRefactoring methodsFor: 'transforming' stamp: ''!
processReferenceNode: aNode 
	| varName |
	varName := aNode name.
	ignore = varName ifTrue: [^self].
	(aNode whoDefines: varName) notNil ifTrue: [^self].
	(self instanceVariableNames includes: varName) 
		ifTrue: [instVarReaders add: varName].
	(self classVariableNames includes: varName) 
		ifTrue: [classVarReaders add: varName]! !

!AbstractVariablesRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self hasVariablesToAbstract 
		ifTrue: 
			[self 
				refactoringWarning: 'This method has direct variable references which<n>will need to be converted to getter/setters.' 
						expandMacros].
	self abstractInstanceVariables.
	self abstractClassVariables! !

!AbstractVariablesRefactoring methodsFor: 'transforming' stamp: ''!
abstractClassVariable: aString 
	| refactoring rewriter nonMetaClass |
	nonMetaClass := fromClass nonMetaclass.
	refactoring := CreateAccessorsForVariableRefactoring 
				model: self model
				variable: aString
				class: nonMetaClass
				classVariable: true.
	self performComponentRefactoring: refactoring.
	rewriter := ParseTreeRewriter new.
	fromClass isMeta 
		ifTrue: 
			[rewriter
				replace: aString , ' := ``@object'
					with: ('self <1s> ``@object' expandMacrosWith: refactoring setterMethod);
				replace: aString with: 'self ' , refactoring getterMethod]
		ifFalse: 
			[rewriter
				replace: aString , ' := ``@object'
					with: ('self class <1s> ``@object' 
							expandMacrosWith: refactoring setterMethod);
				replace: aString with: 'self class ' , refactoring getterMethod].
	(rewriter executeTree: tree) ifTrue: [tree := rewriter tree]! !

!Refactoring methodsFor: 'initialize-release' stamp: ''!
initialize! !

!Refactoring methodsFor: 'accessing' stamp: ''!
options
	^options isNil ifTrue: [self class refactoringOptions] ifFalse: [options]! !

!Refactoring methodsFor: 'private' stamp: ''!
primitiveExecute
	self checkPreconditions.
	self transform! !

!Refactoring methodsFor: 'requests' stamp: 'dvf 9/8/2001 19:32'!
requestMethodNameFor: aMethodName 
	^(self options at: #methodName) value: self value: aMethodName! !

!Refactoring methodsFor: 'accessing' stamp: ''!
changes
	^self model changes! !

!Refactoring methodsFor: 'support' stamp: ''!
convertMethod: selector for: aClass using: searchReplacer 
	"Convert the parse tree for selector using the searchReplacer. If a
	change is made then compile it into the changeBuilder."

	| parseTree |
	parseTree := aClass parseTreeFor: selector.
	parseTree isNil ifTrue: [^self].
	(searchReplacer executeTree: parseTree) 
		ifTrue: [aClass compileTree: searchReplacer tree]! !

!Refactoring methodsFor: 'requests' stamp: 'rr 3/26/2004 10:16'!
request: aString
	^FillInTheBlank request: aString! !

!Refactoring methodsFor: 'preconditions' stamp: ''!
checkPreconditions
	| conditions block |
	conditions := self preconditions.
	conditions check 
		ifFalse: 
			[block := conditions errorBlock.
			block notNil 
				ifTrue: [self refactoringError: conditions errorString with: block]
				ifFalse: [self refactoringError: conditions errorString]]! !

!Refactoring methodsFor: 'requests' stamp: ''!
shouldExtractAssignmentTo: aString 
	^(self options at: #extractAssignment) value: self value: aString! !

!Refactoring methodsFor: 'requests' stamp: ''!
shouldUseExistingMethod: aSelector 
	^(self options at: #useExistingMethod) value: self value: aSelector! !

!Refactoring methodsFor: 'support' stamp: ''!
checkClass: aRBClass selector: aSelector using: aMatcher 
	| parseTree |
	parseTree := aRBClass parseTreeFor: aSelector.
	parseTree notNil ifTrue: [aMatcher executeTree: parseTree].
	^aMatcher answer! !

!Refactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	self subclassResponsibility! !

!Refactoring methodsFor: 'requests' stamp: ''!
shouldInlineExpression: aString 
	^(self options at: #inlineExpression) value: self value: aString! !

!Refactoring methodsFor: 'transforming' stamp: ''!
performComponentRefactoring: aRefactoring 
	aRefactoring copyOptionsFrom: self options.
	aRefactoring primitiveExecute! !

!Refactoring methodsFor: 'accessing' stamp: ''!
setOption: aSymbol toUse: aBlock 
	| dict |
	dict := self options.
	dict == self class refactoringOptions ifTrue: [dict := dict copy].
	dict at: aSymbol put: aBlock.
	self options: dict! !

!Refactoring class methodsFor: '-- all --' stamp: 'dvf 9/8/2001 15:25'!
initializeRefactoringOptions
	"self initializeRefactoringOptions"

	RefactoringOptions := IdentityDictionary new.
	RefactoringOptions
		at: #implementorToInline
			put: 
				[:ref :imps | 
				ChooserMorph 
					choose: 'Which implementation should be inlined?'
					multipleSelect: false
					fromList: imps
					values: imps
					cancel: []];
		at: #methodName
			put: [:ref :methodName | MethodNameEditor modalEditorForMethodName: methodName];
		at: #selfArgumentName
			put: 
				[:ref | 
				ref 
					request: 'Enter name for argument to refer to "self" in extracted method'];
		at: #selectVariableToMoveTo
			put: 
				[:ref :class :selector | 
				| parseTree nameList ignoreList |
				parseTree := class parseTreeFor: selector.
				parseTree isNil 
					ifTrue: 
						[parseTree := RBMethodNode selector: #value
									body: (RBSequenceNode statements: #())].
				nameList := OrderedCollection new.
				nameList
					add: '---- Arguments ----';
					addAll: parseTree argumentNames asSortedCollection;
					add: '---- Instance Variables ----'.
				ignoreList := OrderedCollection with: 1 with: nameList size.
				nameList addAll: class allInstanceVariableNames asSortedCollection.
				nameList at: (PopUpMenu labelArray: nameList lines: #()) startUp];
		at: #variableTypes
			put: 
				[:ref :types :selected | 
				ChooserMorph 
					choose: 'Choose types'
					multipleSelect: true
					fromList: types
					values: types
					cancel: []
					initialSelections: selected];
		at: #extractAssignment
			put: 
				[:ref :varName | 
				ref 
					confirm: ('Do you want to extract the assignment of <1s><n>at the end of selection?' 
							expandMacrosWith: varName)];
		at: #inlineExpression
			put: 
				[:ref :string | 
				ref 
					confirm: ('Do you want to inline "<1s>"? If not, it will be assigned as a temporary.' 
							expandMacrosWith: string)];
		at: #alreadyDefined
			put: 
				[:ref :class :selector | 
				ref 
					confirm: ('<1s> is already defined in the <2p> hierarchy.<n>Extracting it to an existing selector may change behavior.<n>Do you wish to use <1s> anyway?' 
							expandMacrosWith: selector
							with: class)];
		at: #useExistingMethod
			put: 
				[:ref :selector | 
				ref confirm: 'Use existing method ' , selector 
							, ' instead of creating new method?'];
		at: #openBrowser put: [:ref :env | env openEditor]! !

!Refactoring methodsFor: 'requests' stamp: ''!
selectVariableToMoveMethodTo: aSelector class: aClass 
	^(self options at: #selectVariableToMoveTo) 
		value: self
		value: aClass
		value: aSelector! !

!Refactoring methodsFor: 'transforming' stamp: ''!
execute
	self primitiveExecute.
	RefactoringManager instance addRefactoring: self! !

!Refactoring methodsFor: 'utilities' stamp: ''!
safeMethodNameFor: aClass basedOn: aString 
	"Creates an unused method name containing aString"

	| baseString newString hasParam i |
	baseString := aString copy.
	baseString at: 1 put: baseString first asLowercase.
	newString := baseString.
	hasParam := newString last = $:.
	hasParam 
		ifTrue: [baseString := newString copyFrom: 1 to: newString size - 1].
	i := 0.
	[aClass hierarchyDefinesMethod: newString asSymbol] whileTrue: 
			[i := i + 1.
			newString := baseString , i printString 
						, (hasParam ifTrue: [':'] ifFalse: [''])].
	^newString asSymbol! !

!Refactoring methodsFor: 'accessing' stamp: ''!
options: aDictionary 
	options := aDictionary! !

!Refactoring methodsFor: 'initialize-release' stamp: ''!
model: aRBNamespace 
	model := aRBNamespace! !

!Refactoring methodsFor: 'private' stamp: ''!
onError: aBlock do: errorBlock 
	^aBlock on: self class preconditionSignal
		do: 
			[:ex | 
			errorBlock value.
			ex return: nil]! !

!Refactoring methodsFor: 'utilities' stamp: ''!
checkInstanceVariableName: aName in: aClass 
	^RBCondition checkInstanceVariableName: aName in: aClass! !

!Refactoring class methodsFor: 'accessing' stamp: ''!
refactoringOptions
	RefactoringOptions isNil ifTrue: [self initializeRefactoringOptions].
	^RefactoringOptions! !

!Refactoring class methodsFor: 'accessing' stamp: ''!
setDefaultOption: aSymbol to: aBlock 
	self refactoringOptions at: aSymbol put: aBlock! !

!Refactoring methodsFor: 'private' stamp: ''!
refactoringWarning: aString 
	RefactoringWarning raiseSignal: aString! !

!Refactoring methodsFor: 'testing' stamp: ''!
canReferenceVariable: aString in: aClass 
	(aClass definesVariable: aString) ifTrue: [^true].
	(self model includesGlobal: aString asSymbol) ifTrue: [^true].
	^(self poolVariableNamesFor: aClass) includes: aString! !

!Refactoring methodsFor: 'private' stamp: ''!
refactoringError: aString with: aBlock 
	RefactoringError raiseSignal: aString with: aBlock! !

Refactoring subclass: #RemoveClassRefactoring
	instanceVariableNames: 'classNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!RemoveClassRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk classNames: aClassNameCollection 
	^(self new)
		model: aRBSmalltalk;
		classNames: aClassNameCollection;
		yourself! !

!RemoveClassRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' classNames: '.
	classNames asArray storeOn: aStream.
	aStream nextPut: $)! !

!RemoveClassRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self
		reparentSubclasses;
		removeClasses! !

!RemoveClassRefactoring methodsFor: 'transforming' stamp: ''!
removeClasses
	classNames do: [:each | self model removeClassNamed: each]! !

!RemoveClassRefactoring class methodsFor: 'instance creation' stamp: ''!
classNames: aClassNameCollection 
	^self new classNames: aClassNameCollection! !

!RemoveClassRefactoring methodsFor: 'preconditions' stamp: ''!
hasReferencesTo: aSymbol 
	| literal |
	literal := Smalltalk associationAt: aSymbol.
	BrowserEnvironment new classesDo: 
			[:each | 
			(classNames 
				includes: (each isMeta ifTrue: [each soleInstance] ifFalse: [each]) name) 
					ifFalse: 
						[(each whichSelectorsReferTo: literal) isEmpty ifFalse: [^true].
						(each whichSelectorsReferTo: aSymbol) isEmpty ifFalse: [^true]]].
	^false! !

!RemoveClassRefactoring methodsFor: 'transforming' stamp: ''!
reparentSubclasses
	classNames do: 
			[:each | 
			| class |
			class := self model classNamed: each.
			self model reparentClasses: class subclasses copy to: class superclass]! !

!RemoveClassRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^classNames inject: RBCondition empty
		into: 
			[:sum :each | 
			| aClass |
			aClass := self model classNamed: each asSymbol.
			aClass isNil ifTrue: [self refactoringError: 'No such class'].
			sum 
				& (((RBCondition isMetaclass: aClass) 
						errorMacro: 'Cannot remove just the metaclass') not 
						& ((RBCondition withBlock: [(self hasReferencesTo: each asSymbol) not])
								errorMacro: each , ' is referenced.<n>Browse references?';
								errorBlock: 
										[self openBrowserOn: (BrowserEnvironment new 
													referencesTo: (Smalltalk associationAt: each ifAbsent: [each]))];
								yourself) 
							& ((RBCondition hasSubclasses: aClass) not 
									| ((RBCondition isEmptyClass: aClass) 
											& ((RBCondition withBlock: [aClass superclass notNil])
													errorMacro: 'Cannot remove top level class<n>when it has subclasses';
													yourself))))]! !

!RemoveClassRefactoring methodsFor: 'initialize-release' stamp: ''!
classNames: aClassNameCollection 
	classNames := aClassNameCollection! !

!Refactoring methodsFor: 'accessing' stamp: ''!
copyOptionsFrom: aDictionary 
	| dict |
	dict := self options.
	dict == self class refactoringOptions 
		ifTrue: [^self options: aDictionary copy].
	dict keysAndValuesDo: 
			[:key :value | 
			value == (self class refactoringOptions at: key) 
				ifTrue: [dict at: key put: (aDictionary at: key)]].
	self options: dict! !

!Refactoring methodsFor: 'private' stamp: ''!
refactoringError: aString 
	RefactoringError raiseSignal: aString! !

!Refactoring methodsFor: 'requests' stamp: ''!
requestImplementorToInline: implementorsCollection 
	^(self options at: #implementorToInline) value: self
		value: implementorsCollection! !

Refactoring subclass: #VariableRefactoring
	instanceVariableNames: 'class variableName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

VariableRefactoring subclass: #AbstractClassVariableRefactoring
	instanceVariableNames: 'accessorsRefactoring'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!AbstractClassVariableRefactoring methodsFor: 'transforming' stamp: ''!
abstractClassReferences
	| replacer |
	replacer := ParseTreeRewriter 
				variable: variableName
				getter: self accessorsRefactoring getterMethod
				setter: self accessorsRefactoring setterMethod.
	self 
		convertClasses: class metaclass withAllSubclasses
		select: 
			[:aClass | 
			(aClass whichSelectorsReferToClassVariable: variableName) reject: 
					[:each | 
					aClass == class metaclass and: 
							[each == self accessorsRefactoring getterMethod 
								or: [each == self accessorsRefactoring setterMethod]]]]
		using: replacer! !

!AbstractClassVariableRefactoring methodsFor: 'transforming' stamp: ''!
abstractInstanceReferences
	| replacer |
	replacer := ParseTreeRewriter 
				classVariable: variableName
				getter: self accessorsRefactoring getterMethod
				setter: self accessorsRefactoring setterMethod.
	self 
		convertClasses: class withAllSubclasses
		select: [:aClass | aClass whichSelectorsReferToClassVariable: variableName]
		using: replacer! !

!AbstractClassVariableRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self createAccessors.
	self abstractInstanceReferences.
	self abstractClassReferences! !

!AbstractClassVariableRefactoring methodsFor: 'private-accessing' stamp: ''!
accessorsRefactoring
	^accessorsRefactoring isNil 
		ifTrue: 
			[accessorsRefactoring := CreateAccessorsForVariableRefactoring 
						model: self model
						variable: variableName asString
						class: class
						classVariable: true]
		ifFalse: [accessorsRefactoring]! !

!AbstractClassVariableRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition isMetaclass: class) not 
		& (RBCondition directlyDefinesClassVariable: variableName asSymbol in: class) 
			& ((RBCondition withBlock: 
						[(#(#Object #Behavior #ClassDescription #Class) includes: class name) not]) 
					errorMacro: 'This refactoring does not work for Object, Behavior, ClassDescription, or Class')! !

!AbstractClassVariableRefactoring methodsFor: 'transforming' stamp: ''!
createAccessors
	self performComponentRefactoring: self accessorsRefactoring! !

VariableRefactoring subclass: #PullUpInstanceVariableRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!PullUpInstanceVariableRefactoring methodsFor: 'transforming' stamp: ''!
transform
	class allSubclasses do: 
			[:each | 
			(each directlyDefinesInstanceVariable: variableName) 
				ifTrue: [each removeInstanceVariable: variableName]].
	class addInstanceVariable: variableName! !

!PullUpInstanceVariableRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^RBCondition withBlock: 
			[(class hierarchyDefinesInstanceVariable: variableName) 
				ifFalse: [self refactoringError: 'No subclass defines ' , variableName].
			(class subclasses 
				detect: [:each | (each directlyDefinesInstanceVariable: variableName) not]
				ifNone: [nil]) notNil 
				ifTrue: 
					[self 
						refactoringWarning: 'Not all subclasses have an instance variable named ' 
								, variableName , '.'].
			true]! !

VariableRefactoring subclass: #AddInstanceVariableRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!AddInstanceVariableRefactoring methodsFor: 'transforming' stamp: ''!
transform
	class addInstanceVariable: variableName! !

!AddInstanceVariableRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition isValidInstanceVariableName: variableName for: class) 
		& (RBCondition hierarchyOf: class definesVariable: variableName) not 
			& (RBCondition isGlobal: variableName in: self model) not! !

VariableRefactoring subclass: #RenameInstanceVariableRefactoring
	instanceVariableNames: 'newName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!RenameInstanceVariableRefactoring methodsFor: 'transforming' stamp: ''!
transform
	class 
		renameInstanceVariable: variableName
		to: newName
		around: [self renameReferences]! !

!RenameInstanceVariableRefactoring methodsFor: 'initialize-release' stamp: ''!
rename: aVarName to: aName in: aClass
	self variable: aVarName class: aClass.
	newName := aName! !

!RenameInstanceVariableRefactoring class methodsFor: 'instance creation' stamp: ''!
rename: aVarName to: aName in: aClass
	^self new
		rename: aVarName
		to: aName
		in: aClass! !

!RenameInstanceVariableRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk rename: aVarName to: aName in: aClass 
	^(self new)
		model: aRBSmalltalk;
		rename: aVarName
			to: aName
			in: aClass;
		yourself! !

!RenameInstanceVariableRefactoring methodsFor: 'transforming' stamp: ''!
renameReferences
	| replacer |
	replacer := ParseTreeRewriter 
				rename: variableName
				to: newName
				handler: 
					[self 
						refactoringError: ('<1s> is already defined as a method or block temporary <n> variable in this class or one of its subclasses' 
								expandMacrosWith: newName)].
	self 
		convertClasses: class withAllSubclasses
		select: [:aClass | aClass whichSelectorsReferToInstanceVariable: variableName]
		using: replacer! !

!RenameInstanceVariableRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream
		nextPutAll: ' rename: ''';
		nextPutAll: variableName;
		nextPutAll: ''' to: ''';
		nextPutAll: newName;
		nextPutAll: ''' in: '.
	class storeOn: aStream.
	aStream nextPut: $)! !

!RenameInstanceVariableRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition isValidInstanceVariableName: newName for: class) 
		& (RBCondition definesInstanceVariable: variableName in: class) 
			& (RBCondition hierarchyOf: class definesVariable: newName) not 
			& (RBCondition isGlobal: newName in: self model) not! !

VariableRefactoring subclass: #PushDownInstanceVariableRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!PushDownInstanceVariableRefactoring methodsFor: 'transforming' stamp: ''!
transform
	class removeInstanceVariable: variableName.
	class subclasses do: 
			[:each | 
			(each withAllSubclasses detect: 
					[:aClass | 
					(aClass whichSelectorsReferToInstanceVariable: variableName) isEmpty not]
				ifNone: [nil]) notNil 
				ifTrue: [each addInstanceVariable: variableName]]! !

!PushDownInstanceVariableRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	| references |
	references := RBCondition referencesInstanceVariable: variableName
				in: class.
	class realClass isNil 
		ifTrue: 
			[references 
				errorMacro: ('<1s> is referenced.' expandMacrosWith: variableName)]
		ifFalse: 
			[references
				errorMacro: ('<1s> is referenced.<n>Browse references?' 
							expandMacrosWith: variableName);
				errorBlock: 
						[self openBrowserOn: (BrowserEnvironment new instVarRefsTo: variableName
									in: class realClass)]].
	^(RBCondition definesInstanceVariable: variableName in: class) 
		& references not! !

!VariableRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' variable: '.
	variableName storeOn: aStream.
	aStream nextPutAll: ' class: '.
	class storeOn: aStream.
	aStream nextPut: $)! !

VariableRefactoring subclass: #AddClassVariableRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!AddClassVariableRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition isMetaclass: class) not 
		& (RBCondition isValidClassVarName: variableName for: class) 
			& (RBCondition hierarchyOf: class definesVariable: variableName asString) 
					not 
			& (RBCondition isGlobal: variableName in: self model) not! !

!AddClassVariableRefactoring methodsFor: 'transforming' stamp: ''!
transform
	class addClassVariable: variableName! !

!VariableRefactoring class methodsFor: 'instance creation' stamp: ''!
variable: aVarName class: aClass
	^self new variable: aVarName class: aClass! !

VariableRefactoring subclass: #RenameClassVariableRefactoring
	instanceVariableNames: 'newName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!RenameClassVariableRefactoring methodsFor: 'initialize-release' stamp: ''!
rename: aVarName to: aName in: aClass
	self variable: aVarName class: aClass.
	newName := aName! !

!RenameClassVariableRefactoring methodsFor: 'transforming' stamp: ''!
renameReferences
	| replacer subclasses |
	replacer := ParseTreeRewriter 
				rename: variableName
				to: newName
				handler: 
					[self 
						refactoringError: ('<1s> is already defined as a method or block temporary <n> variable in this class or one of its subclasses' 
								expandMacrosWith: newName)].
	subclasses := class withAllSubclasses asSet.
	subclasses addAll: class metaclass withAllSubclasses.
	self 
		convertClasses: subclasses
		select: [:aClass | aClass whichSelectorsReferToClassVariable: variableName]
		using: replacer! !

!RenameClassVariableRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk rename: aVarName to: aName in: aClass 
	^(self new)
		model: aRBSmalltalk;
		rename: aVarName
			to: aName
			in: aClass;
		yourself! !

!RenameClassVariableRefactoring class methodsFor: 'instance creation' stamp: ''!
rename: aVarName to: aName in: aClass
	^self new
		rename: aVarName
		to: aName
		in: aClass! !

!RenameClassVariableRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition isMetaclass: class) not 
		& (RBCondition isValidClassVarName: newName asString for: class) 
			& (RBCondition definesClassVariable: variableName asString in: class) 
			& (RBCondition hierarchyOf: class definesVariable: newName asString) not 
			& (RBCondition isGlobal: newName asString in: self model) not! !

!RenameClassVariableRefactoring methodsFor: 'transforming' stamp: ''!
transform
	class 
		renameClassVariable: variableName
		to: newName
		around: [self renameReferences]! !

!RenameClassVariableRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream
		nextPutAll: ' rename: ''';
		nextPutAll: variableName;
		nextPutAll: ''' to: ''';
		nextPutAll: newName;
		nextPutAll: ''' in: '.
	class storeOn: aStream.
	aStream nextPut: $)! !

!VariableRefactoring methodsFor: 'initialize-release' stamp: ''!
variable: aVarName class: aClass 
	class := self classObjectFor: aClass.
	variableName := aVarName! !

!VariableRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk variable: aVarName class: aClass 
	^(self new)
		model: aRBSmalltalk;
		variable: aVarName class: aClass;
		yourself! !

VariableRefactoring subclass: #PullUpClassVariableRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!PullUpClassVariableRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition isMetaclass: class) not! !

!PullUpClassVariableRefactoring methodsFor: 'private-accessing' stamp: ''!
subclassDefiningVariable
	| subclasses |
	subclasses := class allSubclasses 
				select: [:each | each directlyDefinesClassVariable: variableName].
	subclasses isEmpty 
		ifTrue: 
			[self refactoringError: 'Could not find a class defining ' , variableName].
	subclasses size > 1 
		ifTrue: [self refactoringError: 'Multiple subclasses define ' , variableName].
	^subclasses asArray first! !

!PullUpClassVariableRefactoring methodsFor: 'transforming' stamp: ''!
transform
	| subclass |
	subclass := self subclassDefiningVariable.
	subclass removeClassVariable: variableName.
	class addClassVariable: variableName! !

VariableRefactoring subclass: #ProtectInstanceVariableRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!ProtectInstanceVariableRefactoring methodsFor: 'private-accessing' stamp: ''!
getterSetterMethods
	| matcher |
	matcher := ParseTreeSearcher new.
	matcher
		answer: Set new;
		matchesAnyMethodOf: (Array 
					with: '`method ^' , variableName
					with: ('`method: `arg <1s> := `arg' expandMacrosWith: variableName)
					with: ('`method: `arg ^<1s> := `arg' expandMacrosWith: variableName))
			do: 
				[:aNode :answer | 
				(class subclassRedefines: aNode selector) 
					ifFalse: [answer add: aNode selector].
				answer].
	(class whichSelectorsReferToInstanceVariable: variableName) do: 
			[:each | 
			self 
				checkClass: class
				selector: each
				using: matcher].
	^matcher answer! !

!ProtectInstanceVariableRefactoring methodsFor: 'transforming' stamp: ''!
inline: aSelector 
	self onError: 
			[self performComponentRefactoring: (InlineAllSendersRefactoring 
						model: self model
						sendersOf: aSelector
						in: class)]
		do: []! !

!ProtectInstanceVariableRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self setOption: #inlineExpression toUse: [:ref :string | true].
	self getterSetterMethods do: [:each | self inline: each]! !

!ProtectInstanceVariableRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^RBCondition definesInstanceVariable: variableName in: class! !

VariableRefactoring subclass: #RemoveInstanceVariableRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!RemoveInstanceVariableRefactoring methodsFor: 'transforming' stamp: ''!
transform
	class removeInstanceVariable: variableName! !

!RemoveInstanceVariableRefactoring class methodsFor: 'as yet unclassified' stamp: 'rr 3/11/2004 11:06'!
remove: variable from: class
	^ self variable: variable class:  class! !

!RemoveInstanceVariableRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	| references |
	references := RBCondition hierarchyOf: class
				referencesInstanceVariable: variableName.
	class realClass isNil 
		ifTrue: 
			[references 
				errorMacro: ('<1s> is referenced.' expandMacrosWith: variableName)]
		ifFalse: 
			[references
				errorMacro: ('<1s> is referenced.<n>Browse references?' 
							expandMacrosWith: variableName);
				errorBlock: 
						[self openBrowserOn: (BrowserEnvironment new instVarRefsTo: variableName
									in: class realClass)]].
	^(RBCondition definesInstanceVariable: variableName asString in: class) 
		& references not! !

VariableRefactoring subclass: #CreateAccessorsForVariableRefactoring
	instanceVariableNames: 'getterMethod setterMethod classVariable needsReturn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!CreateAccessorsForVariableRefactoring methodsFor: 'private-accessing' stamp: ''!
definingClass
	^classVariable ifTrue: [class metaclass] ifFalse: [class]! !

!CreateAccessorsForVariableRefactoring methodsFor: 'private-accessing' stamp: ''!
possibleGetterSelectors
	^self methodsReferencingVariable select: [:each | each numArgs == 0]! !

!CreateAccessorsForVariableRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk variable: aVarName class: aClass classVariable: aBoolean 
	^(self 
		model: aRBSmalltalk
		variable: aVarName
		class: aClass)
		classVariable: aBoolean;
		yourself! !

!CreateAccessorsForVariableRefactoring methodsFor: 'private-accessing' stamp: ''!
findSetterMethod
	| definingClass matcher |
	definingClass := self definingClass.
	matcher := self needsReturnForSetter 
				ifTrue: [ParseTreeSearcher returnSetterMethod: variableName]
				ifFalse: [ParseTreeSearcher setterMethod: variableName].
	^self possibleSetterSelectors detect: 
			[:each | 
			(self 
				checkClass: definingClass
				selector: each
				using: matcher) notNil 
				and: [(definingClass subclassRedefines: each) not]]
		ifNone: [nil]! !

!CreateAccessorsForVariableRefactoring methodsFor: 'private-accessing' stamp: ''!
getterMethod
	^getterMethod! !

!CreateAccessorsForVariableRefactoring class methodsFor: 'instance creation' stamp: ''!
variable: aVarName class: aClass classVariable: aBoolean 
	^(self variable: aVarName class: aClass)
		classVariable: aBoolean; yourself! !

!CreateAccessorsForVariableRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^classVariable 
		ifTrue: [RBCondition definesClassVariable: variableName asSymbol in: class]
		ifFalse: [RBCondition definesInstanceVariable: variableName in: class]! !

!CreateAccessorsForVariableRefactoring methodsFor: 'private-accessing' stamp: ''!
findGetterMethod
	| definingClass matcher |
	definingClass := self definingClass.
	matcher := ParseTreeSearcher getterMethod: variableName.
	^self possibleGetterSelectors detect: 
			[:each | 
			(self 
				checkClass: definingClass
				selector: each
				using: matcher) notNil 
				and: [(definingClass subclassRedefines: each) not]]
		ifNone: [nil]! !

!CreateAccessorsForVariableRefactoring methodsFor: 'transforming' stamp: ''!
createGetterAccessor
	getterMethod := self findGetterMethod.
	getterMethod isNil ifTrue: [getterMethod := self defineGetterMethod]! !

!CreateAccessorsForVariableRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' variable: '.
	variableName storeOn: aStream.
	aStream nextPutAll: ' class: '.
	class storeOn: aStream.
	aStream nextPutAll: ' classVariable: '.
	classVariable storeOn: aStream.
	aStream nextPut: $)! !

!CreateAccessorsForVariableRefactoring methodsFor: 'transforming' stamp: ''!
defineGetterMethod
	| selector definingClass |
	definingClass := self definingClass.
	selector := self safeMethodNameFor: definingClass
				basedOn: variableName asString.
	definingClass 
		compile: ('<1s><n><t>^<2s>' expandMacrosWith: selector with: variableName)
		classified: #(#accessing).
	^selector! !

!CreateAccessorsForVariableRefactoring methodsFor: 'private-accessing' stamp: ''!
methodsReferencingVariable
	^classVariable 
		ifTrue: [self definingClass whichSelectorsReferToClassVariable: variableName]
		ifFalse: 
			[self definingClass whichSelectorsReferToInstanceVariable: variableName]! !

!CreateAccessorsForVariableRefactoring methodsFor: 'initialize-release' stamp: ''!
classVariable: aBoolean 
	classVariable := aBoolean! !

!CreateAccessorsForVariableRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self
		createGetterAccessor;
		createSetterAccessor! !

!CreateAccessorsForVariableRefactoring methodsFor: 'transforming' stamp: ''!
createSetterAccessor
	setterMethod := self findSetterMethod.
	setterMethod isNil ifTrue: [setterMethod := self defineSetterMethod]! !

!CreateAccessorsForVariableRefactoring methodsFor: 'testing' stamp: ''!
needsReturnForSetter
	needsReturn isNil 
		ifTrue: 
			[needsReturn := self 
						usesAssignmentOf: variableName
						in: class
						classVariable: classVariable].
	^needsReturn! !

!CreateAccessorsForVariableRefactoring methodsFor: 'private-accessing' stamp: ''!
possibleSetterSelectors
	^self methodsReferencingVariable select: [:each | each numArgs == 1]! !

!CreateAccessorsForVariableRefactoring methodsFor: 'private-accessing' stamp: ''!
setterMethod
	^setterMethod! !

!CreateAccessorsForVariableRefactoring methodsFor: 'testing' stamp: ''!
usesAssignmentOf: aString in: aClass classVariable: isClassVar 
	| matcher definingClass |
	matcher := ParseTreeSearcher new.
	matcher
		answer: false;
		matches: aString , ' := ``@object'
			do: [:aNode :answer | answer or: [aNode isUsed]].
	definingClass := isClassVar ifTrue: [aClass nonMetaclass] ifFalse: [aClass].
	^(definingClass withAllSubclasses , (isClassVar 
				ifTrue: [definingClass metaclass withAllSubclasses]
				ifFalse: [#()]) 
		detect: 
			[:each | 
			((isClassVar 
				ifTrue: [each whichSelectorsReferToClassVariable: aString]
				ifFalse: [each whichSelectorsReferToInstanceVariable: aString]) detect: 
						[:sel | 
						self 
							checkClass: each
							selector: sel
							using: matcher]
					ifNone: [nil]) notNil]
		ifNone: [nil]) notNil! !

!CreateAccessorsForVariableRefactoring methodsFor: 'transforming' stamp: ''!
defineSetterMethod
	| selector definingClass string |
	definingClass := self definingClass.
	string := self needsReturnForSetter 
				ifTrue: ['<1s> anObject<n><t>^<2s> := anObject']
				ifFalse: ['<1s> anObject<n><t><2s> := anObject'].
	selector := self safeMethodNameFor: definingClass
				basedOn: variableName asString , ':'.
	definingClass 
		compile: (string expandMacrosWith: selector with: variableName)
		classified: #accessing.
	^selector! !

VariableRefactoring subclass: #RemoveClassVariableRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!RemoveClassVariableRefactoring methodsFor: 'transforming' stamp: ''!
transform
	class removeClassVariable: variableName! !

!RemoveClassVariableRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition isMetaclass: class) not 
		& (RBCondition definesClassVariable: variableName in: class) 
			& (RBCondition withBlock: 
						[| block |
						block := 
								[:each | 
								(each whichSelectorsReferToClassVariable: variableName) isEmpty 
									ifFalse: 
										[class realClass isNil 
											ifTrue: 
												[self 
													refactoringError: ('<1s> is referenced.' expandMacrosWith: variableName)]
											ifFalse: 
												[self refactoringError: ('<1s> is referenced.<n>Browse references?' 
															expandMacrosWith: variableName)
													with: 
														[self 
															openBrowserOn: (VariableEnvironment referencesToClassVariable: variableName
																	in: class realClass)]]]].
						class withAllSubclasses do: block.
						class metaclass withAllSubclasses do: block.
						true])! !

VariableRefactoring subclass: #PushDownClassVariableRefactoring
	instanceVariableNames: 'destinationClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!PushDownClassVariableRefactoring methodsFor: 'preconditions' stamp: 'rr 3/11/2004 22:03'!
findDestinationClass
	| classVarName classes classVar cond |
	classVarName := variableName asSymbol.
	classVar := class realClass classPool associationAt: classVarName.
	cond := [:eachClass | ((eachClass allCallsOn: classVar) 
							select: [:eachRef | eachRef actualClass = eachClass])  isEmpty].
	classes := class withAllSubclasses reject: [:each | (cond value: each realClass) 
												and: [cond value: each realClass class]].
	destinationClass := classes isEmpty ifTrue: [nil] ifFalse: [classes asOrderedCollection  first].
	classes do: 
			[:each | 
			(destinationClass includesClass: each) 
				ifTrue: [destinationClass := each]
				ifFalse: 
					[(each includesClass: destinationClass) 
						ifFalse: [self signalMultipleReferenceError]]].
	destinationClass = class ifTrue: [self signalStillReferencedError].
	^destinationClass! !

!PushDownClassVariableRefactoring methodsFor: 'preconditions' stamp: ''!
signalReferenceError: errorString 
	class realClass isNil 
		ifTrue: [self refactoringError: errorString]
		ifFalse: 
			[| classVarName error |
			error := '<1s><n>Browse references?' expandMacrosWith: errorString.
			classVarName := variableName asSymbol.
			self refactoringError: error
				with: 
					[self 
						openBrowserOn: (VariableEnvironment referencesToClassVariable: classVarName
								in: class realClass)]]! !

!PushDownClassVariableRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	"Preconditions are that only one subclass refers to the class variable."

	^(RBCondition definesClassVariable: variableName in: class) 
		& (RBCondition withBlock: 
					[self findDestinationClass.
					true])! !

!PushDownClassVariableRefactoring methodsFor: 'preconditions' stamp: ''!
signalMultipleReferenceError
	self signalReferenceError: ('Multiple subclasses reference <1s>' 
				expandMacrosWith: variableName)! !

!PushDownClassVariableRefactoring methodsFor: 'preconditions' stamp: ''!
signalStillReferencedError
	self signalReferenceError: ('<1p> has references to <2s>' 
				expandMacrosWith: class
				with: variableName)! !

!PushDownClassVariableRefactoring methodsFor: 'transforming' stamp: ''!
transform
	class removeClassVariable: variableName.
	destinationClass isNil ifTrue: [^self].
	destinationClass addClassVariable: variableName! !

VariableRefactoring subclass: #AbstractInstanceVariableRefactoring
	instanceVariableNames: 'accessorsRefactoring'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!AbstractInstanceVariableRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self createAccessors.
	self abstractReferences! !

!AbstractInstanceVariableRefactoring methodsFor: 'transforming' stamp: ''!
createAccessors
	self performComponentRefactoring: self accessorsRefactoring! !

!AbstractInstanceVariableRefactoring methodsFor: 'transforming' stamp: ''!
abstractReferences
	| replacer |
	replacer := ParseTreeRewriter 
				variable: variableName
				getter: self accessorsRefactoring getterMethod
				setter: self accessorsRefactoring setterMethod.
	self 
		convertClasses: class withAllSubclasses
		select: 
			[:aClass | 
			(aClass whichSelectorsReferToInstanceVariable: variableName) reject: 
					[:each | 
					aClass == class and: 
							[each == self accessorsRefactoring getterMethod 
								or: [each == self accessorsRefactoring setterMethod]]]]
		using: replacer! !

!AbstractInstanceVariableRefactoring methodsFor: 'private-accessing' stamp: ''!
accessorsRefactoring
	^accessorsRefactoring isNil 
		ifTrue: 
			[accessorsRefactoring := CreateAccessorsForVariableRefactoring 
						model: self model
						variable: variableName
						class: class
						classVariable: false]
		ifFalse: [accessorsRefactoring]! !

!AbstractInstanceVariableRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^RBCondition directlyDefinesInstanceVariable: variableName in: class! !

!Refactoring methodsFor: 'requests' stamp: ''!
requestSelfArgumentName
	^(self options at: #selfArgumentName) value: self! !

!Refactoring methodsFor: 'utilities' stamp: ''!
associationForClassVariable: aName in: aClass ifAbsent: aBlock 
	^aClass realClass classPool associationAt: aName asSymbol
		ifAbsent: [aClass realClass classPool associationAt: aName asString ifAbsent: aBlock]! !

!Refactoring methodsFor: 'requests' stamp: ''!
openBrowserOn: anEnvironment 
	^(self options at: #openBrowser) value: self value: anEnvironment! !

Refactoring subclass: #ClassRefactoring
	instanceVariableNames: 'className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

ClassRefactoring subclass: #RenameClassRefactoring
	instanceVariableNames: 'newName class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!RenameClassRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^(RBCondition withBlock: [class notNil and: [class isMeta not]]
		errorString: className , ' is not a valid class name') 
			& (RBCondition isValidClassName: newName) 
			& (RBCondition isGlobal: newName in: self model) not! !

!RenameClassRefactoring methodsFor: 'initialize-release' stamp: ''!
className: aName newName: aNewName 
	className := aName asSymbol.
	class := self model classNamed: className.
	newName := aNewName asSymbol! !

!RenameClassRefactoring class methodsFor: 'instance creation' stamp: ''!
rename: aClass to: aNewName
	^self new className: aClass name newName: aNewName! !

!RenameClassRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self model 
		renameClass: class
		to: newName
		around: [self renameReferences]! !

!RenameClassRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream nextPutAll: ' rename: '.
	class storeOn: aStream.
	aStream
		nextPutAll: ' to: #';
		nextPutAll: newName;
		nextPut: $)! !

!RenameClassRefactoring methodsFor: 'transforming' stamp: ''!
renameReferences
	| replacer |
	replacer := (ParseTreeRewriter replaceLiteral: className with: newName)
				replace: className with: newName;
				replaceArgument: newName
					withValueFrom: 
						[:aNode | 
						self 
							refactoringError: newName , ' already exists within the reference scope'];
				yourself.
	self model allReferencesToClass: class
		do: 
			[:method | 
			(method modelClass hierarchyDefinesVariable: newName) 
				ifTrue: 
					[self refactoringError: newName , ' is already defined in hierarchy of ' 
								, method modelClass printString].
			self 
				convertMethod: method selector
				for: method modelClass
				using: replacer]! !

!RenameClassRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk rename: aClass to: aNewName 
	^(self new)
		model: aRBSmalltalk;
		className: aClass name newName: aNewName;
		yourself! !

!ClassRefactoring class methodsFor: 'instance creation' stamp: ''!
className: aName
	^self new className: aName! !

ClassRefactoring subclass: #AddClassRefactoring
	instanceVariableNames: 'category superclass subclasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!AddClassRefactoring methodsFor: 'transforming' stamp: 'bh 4/10/2001 14:25'!
transform
	(self model)
		defineClass: ('<1p> subclass: #<2s> instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: <3p>' 
					expandMacrosWith: superclass
					with: className
					with: category asString);
		reparentClasses: subclasses to: (self model classNamed: className asSymbol)! !

!AddClassRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream
		nextPutAll: ' addClass: #';
		nextPutAll: className;
		nextPutAll: ' superclass: '.
	superclass storeOn: aStream.
	aStream nextPutAll: ' subclasses: '.
	subclasses asArray storeOn: aStream.
	aStream nextPutAll: ' category: '.
	category storeOn: aStream.
	aStream nextPut: $)! !

!AddClassRefactoring methodsFor: 'initialize-release' stamp: ''!
addClass: aName superclass: aClass subclasses: aCollection category: aSymbol 
	self className: aName.
	superclass := self classObjectFor: aClass.
	subclasses := aCollection collect: [:each | self classObjectFor: each].
	category := aSymbol! !

!AddClassRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk addClass: aName superclass: aClass subclasses: aCollection category: aSymbol 
	^(self new)
		model: aRBSmalltalk;
		addClass: aName
			superclass: aClass
			subclasses: aCollection
			category: aSymbol;
		yourself! !

!AddClassRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	| cond |
	cond := ((RBCondition isMetaclass: superclass) 
				errorMacro: 'Superclass must not be a metaclass') not.
	cond := subclasses inject: cond
				into: 
					[:sub :each | 
					sub 
						& ((RBCondition isMetaclass: each) 
								errorMacro: 'Subclass must <1?not :>be a metaclass') not 
							& (RBCondition isImmediateSubclass: each of: superclass)].
	^cond & (RBCondition isValidClassName: className) 
		& (RBCondition isGlobal: className in: self model) not 
			& (RBCondition isSymbol: category) 
			& ((RBCondition withBlock: [category isEmpty not]) 
					errorMacro: 'Invalid category name')! !

!AddClassRefactoring class methodsFor: 'instance creation' stamp: ''!
addClass: aName superclass: aClass subclasses: aCollection category: aSymbol
	^self new
		addClass: aName
		superclass: aClass
		subclasses: aCollection
		category: aSymbol! !

!ClassRefactoring methodsFor: 'initialize-release' stamp: ''!
className: aName
	className := aName! !

ClassRefactoring subclass: #ChildrenToSiblingsRefactoring
	instanceVariableNames: 'parent subclasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!ChildrenToSiblingsRefactoring methodsFor: 'transforming' stamp: ''!
pushUpMethods
	self pushUpMethodsFrom: parent.
	self pushUpMethodsFrom: parent metaclass! !

!ChildrenToSiblingsRefactoring methodsFor: 'private-methods' stamp: ''!
subclassResponsibilityFor: aSelector in: aClass 
	| methodNode position source |
	source := aClass sourceCodeFor: aSelector.
	methodNode := RBParser parseMethod: source onError: [:err :pos | ^nil].
	position := methodNode arguments isEmpty 
				ifTrue: [methodNode selectorParts last stop]
				ifFalse: [methodNode arguments last stop].
	^'<1s><n><t>self subclassResponsibility' 
		expandMacrosWith: (source copyFrom: 1 to: position)! !

!ChildrenToSiblingsRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self
		addSuperclass;
		pushUpVariables;
		pushUpMethods;
		changeIsKindOfReferences;
		reparentSubclasses! !

!ChildrenToSiblingsRefactoring methodsFor: 'private-variables' stamp: ''!
pullUpPoolVariables
	"Don't remove the pool variables from the subclass since they might be referenced there."

	| newSuperclass |
	newSuperclass := self abstractSuperclass.
	parent poolDictionaryNames 
		do: [:each | newSuperclass addPoolDictionary: each]! !

!ChildrenToSiblingsRefactoring methodsFor: 'private-accessing' stamp: ''!
abstractSuperclass
	^self model classNamed: className asSymbol! !

!ChildrenToSiblingsRefactoring methodsFor: 'initialize-release' stamp: ''!
name: aClassName class: aClass subclasses: subclassCollection 
	className := aClassName asSymbol.
	parent := self model classFor: aClass.
	subclasses := subclassCollection 
				collect: [:each | self model classFor: each]! !

!ChildrenToSiblingsRefactoring methodsFor: 'private-methods' stamp: ''!
computeSubclassSupersOf: aClass 
	| selectors |
	selectors := Set new.
	aClass subclasses do: 
			[:each | 
			each selectors 
				do: [:sel | selectors addAll: (each parseTreeFor: sel) superMessages]].
	^selectors! !

!ChildrenToSiblingsRefactoring methodsFor: 'private-methods' stamp: ''!
shouldPushUp: aSelector from: aClass 
	^((aClass isMeta 
		ifTrue: [subclasses collect: [:each | each metaclass]]
		ifFalse: [subclasses]) 
			detect: [:each | (each directlyDefinesMethod: aSelector) not]
			ifNone: [nil]) notNil! !

!ChildrenToSiblingsRefactoring methodsFor: 'private-methods' stamp: ''!
pushUpMethodsFrom: aClass 
	| selectorsToPushUp |
	selectorsToPushUp := self selectorsToPushUpFrom: aClass.
	aClass selectors do: 
			[:each | 
			(selectorsToPushUp includes: each) 
				ifTrue: [self pushUp: each in: aClass]
				ifFalse: [self createSubclassResponsibilityFor: each in: aClass]].
	selectorsToPushUp do: [:each | aClass removeMethod: each]! !

!ChildrenToSiblingsRefactoring methodsFor: 'transforming' stamp: ''!
pushUpVariables
	self pullUpInstanceVariables.
	self pullUpClassInstanceVariables.
	self pullUpClassVariables.
	self pullUpPoolVariables! !

!ChildrenToSiblingsRefactoring methodsFor: 'private-variables' stamp: ''!
pullUpInstanceVariables
	| newSuperclass |
	newSuperclass := self abstractSuperclass.
	parent instanceVariableNames do: 
			[:each | 
			self performComponentRefactoring: (PullUpInstanceVariableRefactoring 
						model: self model
						variable: each
						class: newSuperclass)]! !

!ChildrenToSiblingsRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk name: aClassName class: aClass subclasses: subclassCollection 
	^(self new)
		model: aRBSmalltalk;
		name: aClassName
			class: aClass
			subclasses: subclassCollection;
		yourself! !

!ChildrenToSiblingsRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^subclasses 
		inject: ((RBCondition isMetaclass: parent) 
				errorMacro: 'Superclass must not be a metaclass') not 
				& (RBCondition isValidClassName: className) 
					& (RBCondition isGlobal: className in: self model) not
		into: 
			[:sub :each | 
			sub 
				& ((RBCondition isMetaclass: each) 
						errorMacro: 'Subclass must <1?not :>be a metaclass') not 
					& (RBCondition isImmediateSubclass: each of: parent)]! !

!ChildrenToSiblingsRefactoring methodsFor: 'private-methods' stamp: ''!
pushUp: aSelector in: aClass 
	| source |
	source := aClass sourceCodeFor: aSelector.
	source isNil 
		ifFalse: 
			[aClass superclass compile: source
				classified: (aClass protocolsFor: aSelector)]! !

!ChildrenToSiblingsRefactoring class methodsFor: 'instance creation' stamp: ''!
name: aClassName class: aClass subclasses: subclassCollection 
	^(self new)
		name: aClassName
			class: aClass
			subclasses: subclassCollection;
		yourself! !

!ChildrenToSiblingsRefactoring methodsFor: 'transforming' stamp: ''!
changeIsKindOfReferences
	| replacer |
	replacer := ParseTreeRewriter new.
	replacer replace: '``@object isKindOf: ' , parent name
		with: '``@object isKindOf: ' , className.
	self convertAllReferencesToClass: parent using: replacer! !

!ChildrenToSiblingsRefactoring methodsFor: 'private-variables' stamp: ''!
pullUpClassVariables
	| newSuperclass |
	newSuperclass := self abstractSuperclass.
	parent classVariableNames do: 
			[:each | 
			self performComponentRefactoring: (PullUpClassVariableRefactoring 
						model: self model
						variable: each
						class: newSuperclass)]! !

!ChildrenToSiblingsRefactoring methodsFor: 'private-variables' stamp: ''!
pullUpClassInstanceVariables
	| newSuperclass |
	newSuperclass := self abstractSuperclass metaclass.
	parent metaclass instanceVariableNames do: 
			[:each | 
			self performComponentRefactoring: (PullUpInstanceVariableRefactoring 
						model: self model
						variable: each
						class: newSuperclass)]! !

!ChildrenToSiblingsRefactoring methodsFor: 'transforming' stamp: ''!
reparentSubclasses
	self model reparentClasses: subclasses to: self abstractSuperclass! !

!ChildrenToSiblingsRefactoring methodsFor: 'transforming' stamp: ''!
addSuperclass
	self performComponentRefactoring: (AddClassRefactoring 
				model: self model
				addClass: className
				superclass: parent superclass
				subclasses: (Array with: parent)
				category: parent category)! !

!ChildrenToSiblingsRefactoring methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	self class storeOn: aStream.
	aStream
		nextPutAll: ' name: #';
		nextPutAll: className;
		nextPutAll: ' class: '.
	parent storeOn: aStream.
	aStream nextPutAll: ' subclasses: '.
	subclasses asArray storeOn: aStream.
	aStream nextPut: $)! !

!ChildrenToSiblingsRefactoring methodsFor: 'private-methods' stamp: ''!
selectorsToPushUpFrom: aClass 
	| superSelectors |
	superSelectors := self computeSubclassSupersOf: aClass.
	^aClass selectors select: 
			[:each | 
			(superSelectors includes: each) or: [self shouldPushUp: each from: aClass]]! !

!ChildrenToSiblingsRefactoring methodsFor: 'private-methods' stamp: ''!
createSubclassResponsibilityFor: aSelector in: aClass 
	| source |
	(aClass superclass definesMethod: aSelector) ifTrue: [^self].
	source := self subclassResponsibilityFor: aSelector in: aClass.
	source isNil ifTrue: [^self].
	aClass superclass compile: source
		classified: (aClass protocolsFor: aSelector)! !

!ClassRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBSmalltalk className: aName 
	^(self new)
		model: aRBSmalltalk;
		className: aName;
		yourself! !

Refactoring subclass: #ExpandReferencedPoolsRefactoring
	instanceVariableNames: 'pools fromClass parseTree toClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!ExpandReferencedPoolsRefactoring methodsFor: 'testing' stamp: ''!
hasPoolsToMove
	^pools isEmpty not! !

!ExpandReferencedPoolsRefactoring methodsFor: 'transforming' stamp: ''!
computePoolsToMove
	| poolVariables searcher |
	poolVariables := self poolVariableNamesFor: fromClass.
	pools := Set new.
	searcher := ParseTreeSearcher new.
	searcher matches: '`var'
		do: 
			[:aNode :answer | 
			| varName pool |
			varName := aNode name.
			(aNode whoDefines: varName) isNil 
				ifTrue: 
					[(poolVariables includes: varName) 
						ifTrue: 
							[pool := self whichPoolDefines: varName.
							pool notNil ifTrue: [pools add: pool]]]].
	searcher executeTree: parseTree! !

!ExpandReferencedPoolsRefactoring methodsFor: 'transforming' stamp: ''!
transform
	self computePoolsToMove.
	self hasPoolsToMove 
		ifTrue: 
			[self 
				refactoringWarning: 'This method contains references to pools<n>which may need to be moved.' 
						expandMacros].
	self movePoolVariables! !

!ExpandReferencedPoolsRefactoring methodsFor: 'preconditions' stamp: ''!
preconditions
	^RBCondition empty! !

!ExpandReferencedPoolsRefactoring methodsFor: 'transforming' stamp: ''!
whichPoolDefines: varName 
	| currentClass |
	currentClass := fromClass.
	[currentClass isNil] whileFalse: 
			[currentClass allPoolDictionaryNames 
				do: [:each | ((self poolVariableNamesIn: each) includes: varName) ifTrue: [^each]].
			currentClass := currentClass superclass].
	^nil! !

!ExpandReferencedPoolsRefactoring methodsFor: 'transforming' stamp: ''!
movePool: aSymbol toClass: aClass 
	| nonMetaClass |
	nonMetaClass := aClass nonMetaclass.
	(nonMetaClass definesPoolDictionary: aSymbol) 
		ifFalse: [nonMetaClass addPoolDictionary: aSymbol]! !

!ExpandReferencedPoolsRefactoring methodsFor: 'transforming' stamp: ''!
movePoolVariables
	pools 
		do: [:poolDict | toClasses do: [:each | self movePool: poolDict toClass: each]]! !

!ExpandReferencedPoolsRefactoring class methodsFor: 'instance creation' stamp: ''!
forMethod: aParseTree fromClass: aClass toClasses: classCollection 
	^(self new)
		forMethod: aParseTree
			fromClass: aClass
			toClasses: classCollection;
		yourself! !

!ExpandReferencedPoolsRefactoring class methodsFor: 'instance creation' stamp: ''!
model: aRBNamespace forMethod: aParseTree fromClass: aClass toClasses: classCollection 
	^(self new)
		model: aRBNamespace;
		forMethod: aParseTree
			fromClass: aClass
			toClasses: classCollection;
		yourself! !

!ExpandReferencedPoolsRefactoring methodsFor: 'transforming' stamp: ''!
poolVariableNamesIn: poolName 
	^(Smalltalk at: poolName ifAbsent: [Dictionary new]) keys 
		collect: [:name | name asString]! !

!ExpandReferencedPoolsRefactoring methodsFor: 'initialize-release' stamp: ''!
forMethod: aParseTree fromClass: aClass toClasses: classCollection 
	fromClass := self model classFor: aClass.
	parseTree := aParseTree.
	toClasses := classCollection collect: [:each | self model classFor: each]! !

!Refactoring methodsFor: 'support' stamp: ''!
convertAllReferencesTo: aSymbol using: searchReplacer 
	self model allReferencesTo: aSymbol
		do: 
			[:method | 
			self 
				convertMethod: method selector
				for: method modelClass
				using: searchReplacer]! !

Object subclass: #RefactoryTestDataApp
	instanceVariableNames: 'temporaryVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Test data'!

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
inlineMethod
	| temp |
	temp := self
				foo;
				inlineMethod;
				bar.
	^temp! !

!RefactoryTestDataApp methodsFor: 'inline' stamp: ''!
called: anObject on1: aBlock 
	| each |
	each := anObject printString.
	Transcript
		show: each;
		cr.
	aBlock value: each! !

!RefactoryTestDataApp methodsFor: 'accessing' stamp: ''!
referencesConditionFor: aClass 
	| environment association |
	^(RBCondition withBlock: 
			[association := Smalltalk associationAt: aClass name
						ifAbsent: [self refactoringError: 'Could not find class'].
			environment := (self environment referencesTo: association) 
						| (self environment referencesTo: aClass name).
			environment isEmpty])
		errorMacro: aClass , ' is referenced.<n>Browse references?';
		errorBlock: [environment openEditor];
		yourself! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
usesAdd
	^(1 to: 10) asOrderedCollection addAll: (11 to: 20)! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
yourselfNotUsed
	self
		printString;
		printString;
		yourself! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
inlineFoo: aBlock 
	| bar baz asdf |
	bar := aBlock value: self.
	baz := bar + bar.
	asdf := baz + bar.
	^asdf! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
stringConcatenation
	| string |
	string := '' yourself.
	(1 to: 10) do: [:i | string := string , i printString].
	^string! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
consistencyCheck
	^(1 to: 10) at: 1! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
fullBlocks
	^[thisContext]! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
renameThisMethod: anArg
	^self! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
equalNotUsed
	| string |
	string = '' yourself.
	(1 to: 10) do: [:i | string := i printString].
	^string! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
toDoCollect
	| array |
	array := Array new: 10.
	1 to: 10 do: [:i | array at: i put: i * i].
	^array! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
returnsIfTrue
	^self isNil ifTrue: [4]! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
booleanPrecedence
	^true & 4 = 45! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
testMethod1
	^self testMethod1 
		, ([:each | each testMethod1] value: #(#(#testMethod1) 2 #testMethod1))! !

!RefactoryTestDataApp methodsFor: 'inline' stamp: ''!
caller1
	| anObject |
	anObject := 5.
	self called: anObject + 1
		on1: 
			[:each | 
			each printString.
			^anObject]! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
modifiesCollection
	| collection |
	collection := (1 to: 10) asOrderedCollection.
	collection do: [:each | each > 5 ifTrue: [collection remove: each]].
	^collection! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
symbolReference
	^#(#renameThisMethod: #(4 #renameThisMethod:))! !

!RefactoryTestDataApp methodsFor: 'inline' stamp: ''!
called: anObject on: aBlock 
	Transcript
		show: anObject printString;
		cr.
	aBlock value! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
isLiteral
	^false! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
whileTrue
	| i |
	i := 1.
	[i < self size] whileTrue: 
			[(self at: i) printString.
			i := i + 1]! !

!RefactoryTestDataApp methodsFor: 'inline' stamp: ''!
inlineTemporary
	| temp |
	self isNil ifTrue: [temp := 4].
	^temp! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
justSendsSuper
	super justSendsSuper! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
refersToClass
	^RefactoryTestDataApp! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
toDo
	1 to: self size do: [:i | (self at: i) printString]! !

!RefactoryTestDataApp methodsFor: 'inline' stamp: ''!
multipleCalls
	self caller2.
	self caller2! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
detectContains
	^(1 to: 10) do: [:each | each > 2 ifTrue: [^each]]! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
tempsReadBeforeWritten
	| temp |
	self isVariable ifTrue: [temp := 4].
	^temp! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
threeElementPoint
	^5 @ 5 + 6 @ 6! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
toDoWithIncrement
	| counter |
	counter := 0.
	1 to: 10
		by: 2
		do: [:i | counter := counter + 2].
	^counter! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
returnInEnsure
	[self error: 'asdf'] ensure: [^4]! !

!RefactoryTestDataApp methodsFor: 'inline' stamp: ''!
inlineLast
	5 = 3 ifTrue: [^self caller] ifFalse: [^self caller2]! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
missingYourself
	^(OrderedCollection new)
		add: 1;
		add: 2;
		removeFirst! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
moveDefinition
	| temp |
	^(self collect: 
			[:each | 
			temp := each printString.
			temp , temp]) 
		select: 
			[:each | 
			temp := each size.
			temp odd]! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
literalArrayCharacters
	^#($a $b $c) includes: $a! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
guardingClause
	self isSymbol 
		ifFalse: 
			[self printString.
			self isSymbol printString]! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
collectionProtocol
	| newCollection |
	newCollection := OrderedCollection new.
	(1 to: 10) asOrderedCollection do: 
			[:each | 
			| new |
			new := each * 2.
			newCollection add: new].
	^newCollection! !

!RefactoryTestDataApp methodsFor: 'inline' stamp: ''!
caller
	| anObject |
	anObject := 5.
	self 
		called: anObject + 1
		on: [^anObject]! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
sizeCheck
	self isEmpty
		ifFalse: [self do: 
					[:each | 
					Transcript
						show: each;
						cr]]! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
equalsTrue
	^true == self! !

!RefactoryTestDataApp methodsFor: 'inline' stamp: ''!
caller2
	^(1 to: 10) inject: 1 into: [:sum :each | sum * (self foo: each)]! !

!RefactoryTestDataApp methodsFor: 'inline' stamp: ''!
inlineMax
	| x y q |
	x := 5.
	y := 10.
	q := x + 1 max: y.
	^q! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
longMethods
	self printString.
	self printString.
	self isVariable ifTrue: [self printString].
	self isVariable ifTrue: [self printString].
	self isVariable ifTrue: [self printString].
	self isVariable ifTrue: [self printString]! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
callFoo
	^self testFoo: 5! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
contains
	^((1 to: 10) detect: [:each | each > 2] ifNone: [nil]) isNil! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
precedence
	^self isArray ifFalse: [self block + 5 * 34] ifTrue: [self printString = 10]! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
noMoveDefinition
	| temp |
	^(self collect: 
			[:each | 
			temp := each printString.
			temp , temp]) 
		select: [:each | temp := each size + temp]! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
atIfAbsent
	^Smalltalk at: #Test
		ifAbsent: 
			[| collection |
			collection := #().
			Smalltalk at: #Test put: collection]! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
sendsDifferentSuper
	super printString! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
release
	self printString! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
endTrueFalse
	self isVariable 
		ifTrue: 
			[self printString.
			self isVariable printString]
		ifFalse: 
			[self printString.
			^4]! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
fileBlocks
	| file |
	^
	[file := 'asdf' asFilename readStream.
	file contents] ensure: [file close]! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
returnsBooleanAndOther
	self isVariable ifTrue: [^false].
	self printString! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
inlineJunk
	| asdf |
	asdf := self inlineFoo: 
					[:each | 
					| temp |
					temp := each.
					temp , temp].
	^asdf foo: 
			[:bar | 
			| baz |
			baz := bar.
			baz * baz]! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
collectionMessagesToExternalObject
	self someObject collection remove: 10! !

!RefactoryTestDataApp methodsFor: 'inline' stamp: ''!
inlineComponent
	| a |
	a := 5.
	^a class
		superclass;
		hasImmediateInstances;
		yourself! !

!RefactoryTestDataApp methodsFor: 'inline' stamp: ''!
inlineFailed
	| x y q |
	x := 5.
	y := 10.
	q := x + 1 fooMax: y.
	^q! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
assignmentInIfTrue
	| variable |
	self isVariable 
		ifTrue: [variable := self]
		ifFalse: [variable := self printString].
	^variable! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
tempVarOverridesInstVar
	| temporaryVariable |
	temporaryVariable := 4.
	^temporaryVariable! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
selectorNotReferenced
	^self selectorNotReferenced + 4! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
assignmentInBlock
	[^self printString] ensure: [self close]! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
sendInlineParameterMethod
	^self inlineParameterMethod: #(#asdf)! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
callMethod
	^self renameThisMethod: 5! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
extraBlock
	^[:arg | arg + 43] value: 45! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
testFoo: anObject
	^self class + anObject! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
badMessage
	self become: String new! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
inlineParameterMethod: aSymbol
	^aSymbol isSymbol! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
asOrderedCollectionNotNeeded
	self foo addAll: (1 to: 10) asOrderedCollection! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
rename: this two: argumentMethod
	^self printString , this , argumentMethod! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
variableAssignedLiteral
	temporaryVariable := #()! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
exampleCall
	^self rename: 1 two: 2! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
minMax
	"Bug in 3<5 ifTrue: [3]  ifFalse: [5]"

^3<5 ifTrue: [3]  ifFalse: [5]
"	| var |
	var := 4.
	var < 5 ifTrue: [var := 5].
	^var"! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
ifTrueReturns
	self isSymbol ifFalse: [^true].
	^false! !

!RefactoryTestDataApp methodsFor: 'inline' stamp: ''!
foo: aValue
	^(1 to: 10) inject: aValue into: [:sum :each | sum + each]! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: ''!
collectSelectNotUsed
	(1 to: 10) select: [:each | each = 4]! !

!RefactoryTestDataApp methodsFor: 'test' stamp: ''!
testMethod
	^self class! !

!RefactoryTestDataApp methodsFor: 'lint' stamp: 'bh 4/2/2000 22:25'!
searchingLiteral
	^self printString = #a or: [#() = self printString | ( #() == self printString)]! !

Object subclass: #RBParser
	instanceVariableNames: 'scanner currentToken nextToken emptyStatements negatedNumbers errorBlock tags source'
	classVariableNames: 'ParserType BRAraryNode'
	poolDictionaries: ''
	category: 'Refactory-AST-RBParser'!

!RBParser methodsFor: 'private-parsing' stamp: 'ls 1/30/2000 18:13'!
parsePrimitiveObject
	currentToken isIdentifier ifTrue: [^self parsePrimitiveIdentifier].
	currentToken isLiteral ifTrue: [^self parsePrimitiveLiteral].
	currentToken isSpecial ifTrue: 
			[currentToken value == $[ ifTrue: [^self parseBlock].
			currentToken value == $( ifTrue: [^self parseParenthesizedExpression].
			currentToken value == ${ ifTrue: [^self parseArray]].
	currentToken isOptimized ifTrue: [^self parseOptimizedExpression].
	(negatedNumbers and: 
		[ currentToken isBinary and:
		[ currentToken value == #- ] ]) 
	ifTrue:
		[ ^self parseNegatedNumber ].
	currentToken isPatternBlock ifTrue:[^self parsePatternBlock].
	self parserError: 'Variable expected'! !

!RBParser class methodsFor: 'accessing' stamp: ''!
parseRewriteMethod: aString 
	^self parseRewriteMethod: aString onError: nil! !

!RBParser class methodsFor: 'accessing' stamp: 'bh 3/7/2000 01:35'!
parseMethodWithNoComments: aString 
	^ self parseMethodWithNoComments: aString onError: nil! !

!RBParser methodsFor: 'private' stamp: 'bh 4/29/2000 16:28'!
addCommentsTo: aNode 
	aNode comments: scanner getComments! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseParenthesizedExpression
	| leftParen node |
	leftParen := currentToken start.
	self step.
	node := self parseAssignment.
	^(currentToken isSpecial and: [currentToken value == $)])
		ifTrue: 
			[node addParenthesis: (leftParen to: currentToken start).
			self step.
			node]
		ifFalse: [self parserError: ''')'' expected']! !

!RBParser methodsFor: 'private-parsing' stamp: 'ls 1/24/2000 02:26'!
parseStatementList: tagBoolean into: sequenceNode 
	| statements return periods returnPosition node |
	return := false.
	statements := OrderedCollection new.
	periods := OrderedCollection new.
	self addCommentsTo: sequenceNode.
	tagBoolean ifTrue: [self parseResourceTag].
	
	["skip empty statements"
		emptyStatements ifTrue: 
			[[currentToken isSpecial and: [currentToken value == $.]] whileTrue: 
					[periods add: currentToken start.
					self step]].

		"check if we are finished yet"
	 	self atEnd 
			or: [currentToken isSpecial and: ['])}' includes: currentToken value]]] 
			whileFalse: 
				[return ifTrue: [self parserError: 'End of statement list encounted'].
				(currentToken isSpecial and: [currentToken value == $^]) 
					ifTrue: 
						[returnPosition := currentToken start.
						self step.
						node := RBReturnNode return: returnPosition value: self parseAssignment.
						self addCommentsTo: node.
						statements add: node.
						return := true]
					ifFalse: 
						[node := self parseAssignment.
						self addCommentsTo: node.
						statements add: node].
				(currentToken isSpecial and: [currentToken value == $.]) 
					ifTrue: 
						[periods add: currentToken start.
						self step]
					ifFalse: [return := true].
				].
	sequenceNode
		statements: statements;
		periods: periods.
	^sequenceNode! !

!RBParser methodsFor: 'accessing' stamp: ''!
initializeParserWith: aString type: aSymbol 
	source := aString.
	self scanner: (RBScanner 
				perform: aSymbol
				with: (ReadStream on: aString)
				with: self errorBlock)! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseArgs
	| args |
	args := OrderedCollection new.
	[currentToken isIdentifier]
		whileTrue: [args add: self parseVariableNode].
	^args! !

!RBParser methodsFor: 'accessing' stamp: ''!
parseMethod: aString 
	| node |
	node := self parseMethod.
	self atEnd ifFalse: [self parserError: 'Unknown input at end'].
	node source: aString.
	^node! !

!RBParser class methodsFor: 'accessing' stamp: 'dvf 11/8/2003 15:02'!
parseExpression: aString onError: aBlock 
	| node parser |
	parser := self new.
	parser errorBlock: aBlock.
	parser initializeParserWith: aString type: #on:errorBlock:.
	node := parser parseExpression.
	^(node statements size == 1 and: [node temporaries isEmpty])
		ifTrue: [node statements first]
		ifFalse: [node]! !

!RBParser class methodsFor: 'accessing' stamp: 'bh 3/7/2000 01:34'!
parseMethodWithNoComments: aString onError: aBlock 
	| parser |
	parser _ self new.
	parser errorBlock: aBlock.
	parser initializeParserWith: aString type: #on:errorBlock:.
	^ parser parseMethodWithNoComments: aString! !

!RBParser class methodsFor: 'parsing' stamp: ''!
parseMethodPattern: aString 
	| parser |
	parser := self new.
	parser errorBlock: [:error :position | ^nil].
	parser initializeParserWith: aString type: #on:errorBlock:.
	^parser parseMessagePattern selector! !

!RBParser class methodsFor: 'accessing' stamp: 'dvf 11/8/2003 04:44'!
parseMethod: aString onError: aBlock 
	| parser squeakString |
	squeakString := aString .
	parser := self new.
	parser errorBlock: aBlock.
	parser initializeParserWith: squeakString type: #on:errorBlock:.
	^parser parseMethod: squeakString! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseStatements: tagBoolean 
	| args leftBar rightBar |
	args := #().
	leftBar := rightBar := nil.
	currentToken isBinary 
		ifTrue: 
			[currentToken value == #| 
				ifTrue: 
					[leftBar := currentToken start.
					self step.
					args := self parseArgs.
					(currentToken isBinary and: [currentToken value = #|]) 
						ifFalse: [self parserError: '''|'' expected'].
					rightBar := currentToken start.
					self step]
				ifFalse: 
					[currentToken value == #'||' 
						ifTrue: 
							[rightBar := (leftBar := currentToken start) + 1.
							self step]]].
	^self parseStatementList: tagBoolean
		into: (RBSequenceNode 
				leftBar: leftBar
				temporaries: args
				rightBar: rightBar)! !

!RBParser class methodsFor: 'accessing' stamp: ''!
parseRewriteExpression: aString onError: aBlock 
	| node parser |
	parser := self new.
	parser errorBlock: aBlock.
	parser initializeParserWith: aString type: #rewriteOn:errorBlock:.
	node := parser parseExpression.
	^(node statements size == 1 and: [node temporaries isEmpty])
		ifTrue: [node statements first]
		ifFalse: [node]! !

!RBParser methodsFor: 'private' stamp: ''!
patchNegativeLiteral
	"Handle the special negative number case for binary message sends."

	(currentToken value isKindOf: Number) ifFalse: [^self].
	currentToken value <= 0 ifFalse: [^self].
	currentToken value = 0 
		ifTrue: 
			[(source notNil and: 
					[source isEmpty not 
						and: [(source at: (currentToken start min: source size)) == $-]]) 
				ifFalse: [^self]].
	nextToken := currentToken.
	currentToken := RBBinarySelectorToken value: #- start: nextToken start.
	nextToken value: nextToken value negated.
	nextToken start: nextToken start + 1! !

!RBParser class methodsFor: 'testing' stamp: 'ls 1/24/2000 02:19'!
isSqueak
	^ParserType == #Squeak! !

!RBParser methodsFor: 'private' stamp: 'ls 1/24/2000 02:19'!
patchLiteralMessage
	currentToken value == true 
		ifTrue: 
			[^currentToken := RBIdentifierToken value: 'true' start: currentToken start].
	currentToken value == false 
		ifTrue: 
			[^currentToken := RBIdentifierToken value: 'false' start: currentToken start].
	currentToken value == nil 
		ifTrue: 
			[^currentToken := RBIdentifierToken value: 'nil' start: currentToken start]! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseOptimizedExpression
	| position node |
	position := currentToken start.
	self step.
	node := RBOptimizedNode 
				left: position
				body: (self parseStatements: false)
				right: currentToken start.
	(currentToken isSpecial and: [currentToken value == $)]) 
		ifFalse: [self parserError: ''')'' expected'].
	self step.
	^node! !

!RBParser methodsFor: 'private-parsing' stamp: 'bh 3/7/2000 01:36'!
parseMethodWithNoComments
	| methodNode |
	methodNode _ self parseMessagePattern.
	self parseResourceTag.
	"self addCommentsTo: methodNode."
	methodNode body: (self parseStatements: true).
	methodNode tags: tags.
	^ methodNode! !

!RBParser methodsFor: 'accessing' stamp: 'bh 3/7/2000 01:40'!
parseMethodWithNoComments: aString 
	| node |
	node _ self parseMethodWithNoComments.
	self atEnd ifFalse: [self parserError: 'Unknown input at end'].
	node source: aString.
	^ node! !

!RBParser class methodsFor: 'testing' stamp: ''!
isVisualWorks
	^ParserType == #VisualWorks! !

!RBParser methodsFor: 'initialize-release' stamp: 'ls 1/30/2000 17:55'!
initializeForSqueak
	emptyStatements := true.
	negatedNumbers := true.
	scanner notNil ifTrue: [scanner initializeForSqueak]! !

!RBParser methodsFor: 'initialize-release' stamp: 'ls 1/30/2000 17:55'!
initializeForVisualWorks
	emptyStatements := false.
	negatedNumbers := false.
	scanner notNil ifTrue: [scanner initializeForVisualWorks]! !

!RBParser methodsFor: 'private' stamp: ''!
step
	nextToken notNil ifTrue: 
			[currentToken := nextToken.
			nextToken := nil.
			^currentToken].
	currentToken := scanner next! !

!RBParser class methodsFor: 'class initialization' stamp: 'ls 1/24/2000 02:19'!
initialize
	"Try to determine which image we're running in"

	ParserType _ #Squeak! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseKeywordMessage
	^self parseKeywordMessageWith: self parseBinaryMessage! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseUnaryMessage
	| node |
	node := self parsePrimitiveObject.
	
	[currentToken isLiteral ifTrue: [self patchLiteralMessage].
	currentToken isIdentifier] 
			whileTrue: [node := self parseUnaryMessageWith: node].
	^node! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseKeywordMessageWith: node 
	| args isKeyword keywords |
	args := OrderedCollection new: 3.
	keywords := OrderedCollection new: 3.
	isKeyword := false.
	[currentToken isKeyword] whileTrue: 
			[keywords add: currentToken.
			self step.
			args add: self parseBinaryMessage.
			isKeyword := true].
	^isKeyword 
		ifTrue: 
			[RBMessageNode 
				receiver: node
				selectorParts: keywords
				arguments: args]
		ifFalse: [node]! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseUnaryMessageWith: aNode 
	| selector |
	selector := currentToken.
	self step.
	^RBMessageNode 
		receiver: aNode
		selectorParts: (Array with: selector)
		arguments: #()! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseMessagePattern
	^currentToken isIdentifier
		ifTrue: [self parseUnaryPattern]
		ifFalse: 
			[currentToken isKeyword
				ifTrue: [self parseKeywordPattern]
				ifFalse: [self parseBinaryPattern]]! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parsePatternBlock
	| position node |
	position := currentToken start.
	self step.
	node := self parseBlockArgsInto: RBPatternBlockNode new.
	node left: position.
	node body: (self parseStatements: false).
	(currentToken isSpecial and: [currentToken value == $}]) 
		ifFalse: [self parserError: '''}'' expected'].
	node right: currentToken start.
	self step.
	^node! !

!RBParser methodsFor: 'accessing' stamp: ''!
parseExpression
	| node |
	node := self parseStatements: false.
	self atEnd ifFalse: [self parserError: 'Unknown input at end'].
	^node! !

!RBParser methodsFor: 'initialize-release' stamp: 'ls 1/30/2000 17:55'!
initializeForIBM
	emptyStatements := true.
	negatedNumbers := false.
	scanner notNil ifTrue: [scanner initializeForIBM]! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parsePrimitiveLiteral
	| token |
	token := currentToken.
	self step.
	^RBLiteralNode literalToken: token! !

!RBParser methodsFor: 'testing' stamp: ''!
atEnd
	^currentToken class == RBToken! !

!RBParser class methodsFor: 'testing' stamp: ''!
isIBM
	^ParserType == #IBM! !

!RBParser methodsFor: 'private-parsing' stamp: 'ls 1/30/2000 18:16'!
parseNegatedNumber
	| token |

	(self nextToken isLiteral not or: [ self nextToken realValue isNumber not ])
		ifTrue: [ self parserError: 'only numbers may be negated' ].

	"create a new token out of the $- and the number"
	token := RBLiteralToken value: (self nextToken realValue negated) start: currentToken start stop: nextToken stop.

	self step.
	self step.


	^RBLiteralNode literalToken: token! !

!RBParser methodsFor: 'error handling' stamp: ''!
parserError: aString 
	"Evaluate the block. If it returns raise an error"

	self errorBlock value: aString value: self errorPosition.
	self error: aString! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseBinaryMessage
	| node |
	node := self parseUnaryMessage.
	
	[currentToken isLiteral ifTrue: [self patchNegativeLiteral].
	currentToken isBinary] 
			whileTrue: [node := self parseBinaryMessageWith: node].
	^node! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseUnaryPattern
	| selector |
	selector := currentToken.
	self step.
	^RBMethodNode selectorParts: (Array with: selector) arguments: #()! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseBlockArgsInto: node 
	| verticalBar args colons |
	args := OrderedCollection new: 2.
	colons := OrderedCollection new: 2.
	verticalBar := false.
	[currentToken isSpecial and: [currentToken value == $:]] whileTrue: 
			[colons add: currentToken start.
			self step.	":"
			verticalBar := true.
			args add: self parseVariableNode].
	verticalBar 
		ifTrue: 
			[currentToken isBinary 
				ifTrue: 
					[node bar: currentToken start.
					currentToken value == #| 
						ifTrue: [self step]
						ifFalse: 
							[currentToken value == #'||' 
								ifTrue: 
									["Hack the current token to be the start 
									of temps bar"

									currentToken
										value: #|;
										start: currentToken start + 1]
								ifFalse: [self parserError: '''|'' expected']]]
				ifFalse: 
					[(currentToken isSpecial and: [currentToken value == $]]) 
						ifFalse: [self parserError: '''|'' expected']]].
	node
		arguments: args;
		colons: colons.
	^node! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseKeywordPattern
	| keywords args |
	keywords := OrderedCollection new: 2.
	args := OrderedCollection new: 2.
	[currentToken isKeyword] whileTrue: 
			[keywords add: currentToken.
			self step.
			args add: self parseVariableNode].
	^RBMethodNode selectorParts: keywords arguments: args! !

!RBParser class methodsFor: 'accessing' stamp: ''!
parseExpression: aString 
	^self parseExpression: aString onError: nil! !

!RBParser class methodsFor: 'accessing' stamp: ''!
parseRewriteExpression: aString 
	^self parseRewriteExpression: aString onError: nil! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseMethod
	| methodNode |
	methodNode := self parseMessagePattern.
	self parseResourceTag.
	self addCommentsTo: methodNode.
	methodNode body: (self parseStatements: true).
	methodNode tags: tags.
	^methodNode! !

!RBParser methodsFor: 'initialize-release' stamp: 'ls 1/24/2000 02:20'!
scanner: aScanner 
	scanner := aScanner.
	tags := nil.
	self class isIBM 
		ifTrue: [self initializeForIBM].
	self class isVisualWorks
		ifTrue: [self initializeForVisualWorks].
	self class isSqueak
		ifTrue: [ self initializeForSqueak].
	self step! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseCascadeMessage
	| node receiver messages semicolons |
	node := self parseKeywordMessage.
	(currentToken isSpecial 
		and: [currentToken value == $; and: [node isMessage]]) ifFalse: [^node].
	receiver := node receiver.
	messages := OrderedCollection new: 3.
	semicolons := OrderedCollection new: 3.
	messages add: node.
	[currentToken isSpecial and: [currentToken value == $;]] whileTrue: 
			[semicolons add: currentToken start.
			self step.
			messages add: (currentToken isIdentifier 
						ifTrue: [self parseUnaryMessageWith: receiver]
						ifFalse: 
							[currentToken isKeyword 
								ifTrue: [self parseKeywordMessageWith: receiver]
								ifFalse: 
									[| temp |
									currentToken isLiteral ifTrue: [self patchNegativeLiteral].
									currentToken isBinary ifFalse: [self parserError: 'Message expected'].
									temp := self parseBinaryMessageWith: receiver.
									temp == receiver ifTrue: [self parserError: 'Message expected'].
									temp]])].
	^RBCascadeNode messages: messages semicolons: semicolons! !

!RBParser methodsFor: 'private-parsing' stamp: 'ls 1/24/2000 00:11'!
parseArray
	"parse Squeak's {} construct"
	| leftBrace node rightBrace |
	leftBrace _ currentToken start.
	self step.

	node _ RBArrayNode new.
	self parseStatementList: false  into: node.

	(currentToken isSpecial and: [currentToken value == $}]) ifFalse: [
		self parserError: 'expected }' ].

	rightBrace _ currentToken start.
	self step.

	node leftBrace: leftBrace.
	node rightBrace: rightBrace.
	^node! !

!RBParser class methodsFor: 'accessing' stamp: ''!
parseRewriteMethod: aString onError: aBlock 
	| parser |
	parser := self new.
	parser errorBlock: aBlock.
	parser initializeParserWith: aString type: #rewriteOn:errorBlock:.
	^parser parseMethod: aString! !

!RBParser class methodsFor: 'accessing' stamp: ''!
parseMethod: aString 
	^self parseMethod: aString onError: nil! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseResourceTag
	| start |
	[currentToken isBinary and: [currentToken value == #<]] whileTrue: 
			[start := currentToken start.
			self step.
			[scanner atEnd or: [currentToken isBinary and: [currentToken value == #>]]] 
				whileFalse: [self step].
			(currentToken isBinary and: [currentToken value == #>]) 
				ifFalse: [self parserError: '''>'' expected'].
			tags isNil 
				ifTrue: [tags := OrderedCollection with: (start to: currentToken stop)]
				ifFalse: [tags add: (start to: currentToken stop)].
			self step]! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseBlock
	| position node |
	position := currentToken start.
	self step.
	node := self parseBlockArgsInto: RBBlockNode new.
	node left: position.
	node body: (self parseStatements: false).
	(currentToken isSpecial and: [currentToken value == $]]) 
		ifFalse: [self parserError: ''']'' expected'].
	node right: currentToken start.
	self step.
	^node! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseAssignment
	"Need one token lookahead to see if we have a ':='. This method could 
	make it possible to assign the literals true, false and nil."

	| node position |
	(currentToken isIdentifier and: [self nextToken isAssignment]) 
		ifFalse: [^self parseCascadeMessage].
	node := self parseVariableNode.
	position := currentToken start.
	self step.
	^RBAssignmentNode 
		variable: node
		value: self parseAssignment
		position: position! !

!RBParser methodsFor: 'error handling' stamp: ''!
errorBlock
	^errorBlock isNil
		ifTrue: [[:message :position | ]]
		ifFalse: [errorBlock]! !

!RBParser methodsFor: 'error handling' stamp: ''!
errorPosition
	^currentToken start! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseVariableNode
	currentToken isIdentifier 
		ifFalse: [self parserError: 'Variable name expected'].
	^self parsePrimitiveIdentifier! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parsePrimitiveIdentifier
	| token |
	token := currentToken.
	self step.
	^RBVariableNode identifierToken: token! !

!RBParser methodsFor: 'accessing' stamp: ''!
errorBlock: aBlock 
	errorBlock := aBlock.
	scanner notNil ifTrue: [scanner errorBlock: aBlock]! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseBinaryPattern
	| binaryToken |
	currentToken isBinary 
		ifFalse: [self parserError: 'Message pattern expected'].
	binaryToken := currentToken.
	self step.
	^RBMethodNode selectorParts: (Array with: binaryToken)
		arguments: (Array with: self parseVariableNode)! !

!RBParser methodsFor: 'private' stamp: ''!
nextToken
	^nextToken isNil
		ifTrue: [nextToken := scanner next]
		ifFalse: [nextToken]! !

!RBParser methodsFor: 'private-parsing' stamp: ''!
parseBinaryMessageWith: aNode 
	| binaryToken |
	binaryToken := currentToken.
	self step.
	^RBMessageNode 
		receiver: aNode
		selectorParts: (Array with: binaryToken)
		arguments: (Array with: self parseUnaryMessage)! !

Object subclass: #RBAbstractClass
	instanceVariableNames: 'name newMethods instanceVariableNames model superclass subclasses removedMethods realClass'
	classVariableNames: 'LookupSuperclass'
	poolDictionaries: ''
	category: 'Refactory-Model'!

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
subclasses
	^subclasses isNil 
		ifTrue: 
			[subclasses := self isDefined 
						ifTrue: 
							[(self realClass subclasses collect: [:each | model classFor: each]) 
								asOrderedCollection]
						ifFalse: [OrderedCollection new]]
		ifFalse: [subclasses]! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
directlyDefinesInstanceVariable: aString 
	^self instanceVariableNames includes: aString! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
compileTree: aBRMethodNode 
	^self compileTree: aBRMethodNode
		classified: (self protocolsFor: aBRMethodNode selector)! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
allPoolDictionaryNames
	^self subclassResponsibility! !

!RBAbstractClass methodsFor: 'private' stamp: ''!
privateInstanceVariableNames
	instanceVariableNames isNil 
		ifTrue: 
			[self isDefined 
				ifTrue: [self instanceVariableNames: self realClass instVarNames]
				ifFalse: [instanceVariableNames := OrderedCollection new]].
	^instanceVariableNames! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
superclass
	^superclass == LookupSuperclass 
		ifTrue: [model classFor: self realClass superclass]
		ifFalse: [superclass]! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
definesClassVariable: aSymbol 
	(self directlyDefinesClassVariable: aSymbol) ifTrue: [^true].
	^self superclass notNil 
		and: [self superclass definesClassVariable: aSymbol]! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
whichSelectorsReferToClass: aRBClass 
	| selectors |
	selectors := Set new.
	self newMethods do: 
			[:each | 
			(each refersToClassNamed: aRBClass name) 
				ifTrue: [selectors add: each selector]].
	(self isDefined and: [aRBClass isDefined]) 
		ifTrue: 
			[selectors addAll: (self existingMethodsThatReferTo: aRBClass classBinding).
			selectors addAll: (self existingMethodsThatReferTo: aRBClass name)].
	^selectors! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
whichSelectorsReferToClassVariable: aString 
	| selectors |
	selectors := Set new.
	self newMethods 
		do: [:each | (each refersToVariable: aString) ifTrue: [selectors add: each selector]].
	self isDefined 
		ifTrue: 
			[| binding |
			binding := self bindingFor: aString.
			binding isNil ifTrue: [^selectors].
			selectors addAll: ((self realClass whichSelectorsReferTo: binding) 
						reject: [:each | self hasRemoved: each])].
	^selectors! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
realClass: aClass 
	realClass := aClass.
	superclass isNil ifTrue: [superclass := LookupSuperclass]! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
soleInstance
	^self nonMetaclass! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
sourceCodeFor: aSelector 
	| class |
	class := self whoDefinesMethod: aSelector.
	class isNil ifTrue: [^nil].
	^(class methodFor: aSelector) source! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
hierarchyDefinesClassVariable: aString 
	(self definesClassVariable: aString) ifTrue: [^true].
	^(self allSubclasses 
		detect: [:each | each directlyDefinesClassVariable: aString]
		ifNone: [nil]) notNil! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
hierarchyDefinesVariable: aString 
	(self definesVariable: aString) ifTrue: [^true].
	^(self allSubclasses 
		detect: [:each | each directlyDefinesVariable: aString]
		ifNone: [nil]) notNil! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
selectors
	| selectors |
	selectors := Set new.
	selectors addAll: self newMethods keys.
	self isDefined 
		ifTrue: 
			[selectors addAll: self realClass selectors.
			removedMethods notNil 
				ifTrue: [removedMethods do: [:each | selectors remove: each ifAbsent: []]]].
	^selectors! !

!RBAbstractClass methodsFor: 'initialize-release' stamp: ''!
model: aRBSmalltalk
	model := aRBSmalltalk! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
model
	^model! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
compile: aString 
	^self compile: aString
		classified: (self protocolsFor: (RBParser parseMethodPattern: aString))! !

!RBAbstractClass methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPutAll: self name! !

!RBAbstractClass methodsFor: 'comparing' stamp: ''!
hash
	^self name hash bitXor: self class hash! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
parseTreeFor: aSelector 
	| class |
	class := self whoDefinesMethod: aSelector.
	class isNil ifTrue: [^nil].
	^(class methodFor: aSelector) parseTree! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
name: aSymbol 
	name := aSymbol! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
allSubclasses
	| allSubclasses index |
	index := 1.
	allSubclasses := self subclasses asOrderedCollection.
	[index <= allSubclasses size] whileTrue: 
			[allSubclasses addAll: (allSubclasses at: index) subclasses.
			index := index + 1].
	^allSubclasses! !

!RBAbstractClass methodsFor: 'private' stamp: ''!
addSubclass: aRBClass 
	self subclasses add: aRBClass! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
nonMetaclass
	^model classNamed: self name! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
addMethod: aRBMethod 
	self newMethods at: aRBMethod selector put: aRBMethod.
	removedMethods notNil 
		ifTrue: [removedMethods remove: aRBMethod selector ifAbsent: []]! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
definesPoolDictionary: aSymbol 
	(self directlyDefinesPoolDictionary: aSymbol) ifTrue: [^true].
	^self inheritsPoolDictionaries and: 
			[self superclass notNil 
				and: [self superclass definesPoolDictionary: aSymbol]]! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
directlyDefinesClassVariable: aString 
	self subclassResponsibility! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
includesClass: aRBClass 
	| currentClass |
	currentClass := self.
	[currentClass notNil and: [currentClass ~= aRBClass]] 
		whileTrue: [currentClass := currentClass superclass].
	^currentClass = aRBClass! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
withAllSubclasses
	^(self allSubclasses)
		add: self;
		yourself! !

!RBAbstractClass methodsFor: 'private' stamp: ''!
superclass: aRBClass 
	self superclass notNil ifTrue: [self superclass removeSubclass: self].
	superclass := aRBClass.
	superclass notNil ifTrue: [superclass addSubclass: self].! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
allSuperclasses
	| supers sprClass |
	supers := OrderedCollection new.
	sprClass := self superclass.
	[sprClass notNil] whileTrue: 
			[supers add: sprClass.
			sprClass := sprClass superclass].
	^supers! !

RBAbstractClass subclass: #RBClass
	instanceVariableNames: 'classVariableNames poolDictionaryNames category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Model'!

!RBClass methodsFor: 'variable accessing' stamp: ''!
renameClassVariable: oldName to: newName around: aBlock 
	self privateClassVariableNames 
		at: (self privateClassVariableNames indexOf: oldName asSymbol)
		put: newName asSymbol.
	model 
		renameClassVariable: oldName
		to: newName
		in: self
		around: aBlock! !

!RBClass methodsFor: 'private' stamp: ''!
privateClassVariableNames
	(self isDefined and: [classVariableNames isNil]) 
		ifTrue: [self classVariableNames: self realClass classVarNames].
	^classVariableNames! !

!RBClass class methodsFor: 'instance creation' stamp: ''!
named: aSymbol 
	^(self new)
		name: aSymbol;
		yourself! !

!RBClass methodsFor: 'testing' stamp: ''!
isMeta
	^false! !

!RBClass methodsFor: 'accessing' stamp: 'bh 11/8/2000 14:38'!
definitionString
	| definitionStream |
	definitionStream := WriteStream on: ''.
	definitionStream
		nextPutAll: self superclass printString;
		nextPutAll: ' subclass: #';
		nextPutAll: self name;
		nextPutAll: '
	instanceVariableNames: '''.
	self instanceVariableNames do: 
			[:each | 
			definitionStream
				nextPutAll: each;
				nextPut: $ ].
	definitionStream nextPutAll: '''
	classVariableNames: '''.
	self classVariableNames do: 
			[:each | 
			definitionStream
				nextPutAll: each;
				nextPut: $ ].
	definitionStream nextPutAll: '''
	poolDictionaries: '''.
	self poolDictionaryNames do: 
			[:each | 
			definitionStream
				nextPutAll: each;
				nextPut: $ ].
	definitionStream nextPutAll: '''
	category: #'''.
	definitionStream nextPutAll: self category asString.
	definitionStream nextPut: $'.
	^definitionStream contents! !

!RBClass methodsFor: 'accessing' stamp: ''!
category: aSymbol 
	category := aSymbol! !

!RBClass methodsFor: 'variable accessing' stamp: ''!
removePoolDictionary: aString 
	self privatePoolDictionaryNames remove: aString asSymbol! !

!RBClass methodsFor: 'accessing' stamp: ''!
allClassVariableNames
	| sprClass |
	sprClass := self superclass.
	^sprClass isNil 
		ifTrue: [self classVariableNames]
		ifFalse: [sprClass allClassVariableNames , self classVariableNames]! !

!RBClass methodsFor: 'variable accessing' stamp: ''!
removeClassVariable: aString 
	self privateClassVariableNames remove: aString asSymbol.
	model removeClassVariable: aString from: self! !

!RBClass methodsFor: 'accessing' stamp: ''!
classVariableNames
	^self privateClassVariableNames copy! !

!RBClass methodsFor: 'private' stamp: ''!
privatePoolDictionaryNames
	(self isDefined and: [poolDictionaryNames isNil]) 
		ifTrue: 
			[self poolDictionaryNames: (self realClass sharedPools 
						collect: [:each | Smalltalk keyAtValue: each])].
	^poolDictionaryNames! !

!RBClass methodsFor: 'testing' stamp: ''!
directlyDefinesClassVariable: aString 
	^self classVariableNames includes: aString asSymbol! !

!RBClass methodsFor: 'variable accessing' stamp: ''!
addPoolDictionary: aString 
	self privatePoolDictionaryNames add: aString asSymbol.
	model addPool: aString to: self! !

!RBClass methodsFor: 'variable accessing' stamp: ''!
addClassVariable: aString 
	self privateClassVariableNames add: aString asSymbol.
	model addClassVariable: aString to: self! !

!RBClass class methodsFor: 'instance creation' stamp: ''!
existingNamed: aSymbol 
	^(self named: aSymbol)
		realName: aSymbol;
		yourself! !

!RBClass methodsFor: 'accessing' stamp: ''!
sharedPools
	^self allPoolDictionaryNames 
		collect: [:each | Smalltalk at: each asSymbol ifAbsent: [Dictionary new]]! !

!RBClass methodsFor: 'testing' stamp: ''!
directlyDefinesPoolDictionary: aString 
	^self poolDictionaryNames includes: aString asSymbol! !

!RBClass methodsFor: 'accessing' stamp: ''!
allPoolDictionaryNames
	| sprClass |
	sprClass := self superclass.
	^sprClass isNil 
		ifTrue: [self poolDictionaryNames]
		ifFalse: [sprClass allPoolDictionaryNames , self poolDictionaryNames]! !

!RBClass methodsFor: 'accessing' stamp: ''!
classVariableNames: aCollectionOfStrings 
	classVariableNames := (aCollectionOfStrings 
				collect: [:each | each asSymbol]) asOrderedCollection! !

!RBClass methodsFor: 'accessing' stamp: ''!
poolDictionaryNames
	^self privatePoolDictionaryNames copy! !

!RBClass methodsFor: 'initialize-release' stamp: ''!
realName: aSymbol 
	self realClass: (Smalltalk at: aSymbol)! !

!RBClass methodsFor: 'accessing' stamp: 'bh 11/8/2000 15:22'!
category
	^category isNil 
		ifTrue: 
			[self isDefined
				ifTrue: [category _ self realClass category]
				ifFalse: [model environment whichCategoryIncludes: self name]]
		ifFalse: [category]
! !

!RBClass methodsFor: 'accessing' stamp: ''!
poolDictionaryNames: aCollectionOfStrings 
	poolDictionaryNames := (aCollectionOfStrings 
				collect: [:each | each asSymbol]) asOrderedCollection! !

!RBClass methodsFor: 'accessing' stamp: ''!
nonMetaclass
	^self! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
realClass
	^realClass! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
allClassVariableNames
	^self subclassResponsibility! !

!RBAbstractClass methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream nextPutAll: self name! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
isDefined
	^self realClass notNil! !

!RBAbstractClass methodsFor: 'variable accessing' stamp: ''!
renameInstanceVariable: oldName to: newName around: aBlock 
	self privateInstanceVariableNames 
		at: (self privateInstanceVariableNames indexOf: oldName asString)
		put: newName asString.
	model 
		renameInstanceVariable: oldName
		to: newName
		in: self
		around: aBlock! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
primaryInstance
	^self nonMetaclass! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
compile: aString classified: aSymbolCollection 
	| change method |
	change := model 
				compile: aString
				in: self
				classified: aSymbolCollection.
	method := RBMethod 
				for: self
				source: aString
				selector: change selector.
	self addMethod: method! !

!RBAbstractClass methodsFor: 'variable accessing' stamp: ''!
addInstanceVariable: aString 
	self privateInstanceVariableNames add: aString.
	model addInstanceVariable: aString to: self! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
allInstanceVariableNames
	| sprClass |
	sprClass := self superclass.
	^sprClass isNil 
		ifTrue: [self instanceVariableNames]
		ifFalse: [sprClass allInstanceVariableNames , self instanceVariableNames]! !

!RBAbstractClass methodsFor: 'accessing' stamp: 'dvf 9/17/2003 04:23'!
protocolsFor: aSelector 
	| change |
	change := self isMeta 
				ifTrue: [model changes changeForMetaclass: name selector: aSelector]
				ifFalse: [model changes changeForClass: name selector: aSelector].
	^change isNil 
		ifTrue: 
			[self isDefined 
				ifTrue: 
					[Array with: (BrowserEnvironment new whichProtocolIncludes: aSelector in: self realClass)]
				ifFalse: [#(#accessing)]]
		ifFalse: [change protocols]! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
hasRemoved: aSelector 
	^removedMethods notNil and: [removedMethods includes: aSelector]! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
metaclass
	^model metaclassNamed: self name! !

!RBAbstractClass methodsFor: 'method accessing' stamp: 'bh 4/8/2000 18:58'!
existingMethodsThatReferTo: aSymbol 
	| existingMethods |
	existingMethods := self realClass thoroughWhichSelectorsReferTo: aSymbol special:false byte:0.
	(newMethods isNil and: [removedMethods isNil]) ifTrue: [^existingMethods].
	^existingMethods 
		reject: [:each | (self hasRemoved: each) or: [self newMethods includesKey: each]]! !

!RBAbstractClass methodsFor: 'variable accessing' stamp: ''!
typeOfClassVariable: aSymbol 
	^model classNamed: #Object! !

!RBAbstractClass methodsFor: 'initialize-release' stamp: ''!
initialize
	name := #'Unknown Class'! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
methodFor: aSelector 
	^self newMethods at: aSelector
		ifAbsent: 
			[| compiledMethod class |
			(self hasRemoved: aSelector) ifTrue: [^nil].
			class := self realClass.
			class isNil ifTrue: [^nil].
			compiledMethod := class compiledMethodAt: aSelector ifAbsent: [nil].
			compiledMethod isNil 
				ifTrue: [nil]
				ifFalse: 
					[RBMethod 
						for: self
						fromMethod: compiledMethod
						andSelector: aSelector]]! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
instanceVariableNames
	^self privateInstanceVariableNames copy! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
name
	^name! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
removeSubclass: aRBClass 
	self subclasses remove: aRBClass ifAbsent: []! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
hierarchyDefinesMethod: aSelector 
	(self definesMethod: aSelector) ifTrue: [^true].
	^self subclassRedefines: aSelector! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
directlyDefinesMethod: aSelector 
	self isDefined 
		ifTrue: 
			[(self hasRemoved: aSelector) ifTrue: [^false].
			(self realClass includesSelector: aSelector) ifTrue: [^true]].
	^newMethods notNil and: [newMethods includesKey: aSelector]! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
definesInstanceVariable: aString 
	(self directlyDefinesInstanceVariable: aString) ifTrue: [^true].
	^self superclass notNil 
		and: [self superclass definesInstanceVariable: aString]! !

!RBAbstractClass methodsFor: 'variable accessing' stamp: ''!
whoDefinesInstanceVariable: aString 
	| sprClass |
	(self directlyDefinesInstanceVariable: aString) ifTrue: [^self].
	sprClass := self superclass.
	^sprClass isNil 
		ifTrue: [nil]
		ifFalse: [sprClass whoDefinesInstanceVariable: aString]! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
newMethods
	^newMethods isNil 
		ifTrue: [newMethods := IdentityDictionary new]
		ifFalse: [newMethods]! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
whichSelectorsReferToSymbol: aSymbol 
	| selectors |
	selectors := Set new.
	self newMethods 
		do: [:each | (each refersToSymbol: aSymbol) ifTrue: [selectors add: each selector]].
	self isDefined 
		ifTrue: [selectors addAll: (self existingMethodsThatReferTo: aSymbol)].
	^selectors! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
allSelectors
	| class selectors |
	class := self.
	selectors := Set new.
	[class notNil] whileTrue: 
			[selectors addAll: class selectors.
			class := class superclass].
	^selectors! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
removeMethod: aSelector 
	self newMethods removeKey: aSelector ifAbsent: [].
	model removeMethod: aSelector from: self.
	self removedMethods add: aSelector! !

!RBAbstractClass methodsFor: 'comparing' stamp: ''!
= aRBClass 
	^self class = aRBClass class 
		and: [self name = aRBClass name and: [self model = aRBClass model]]! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
removedMethods
	^removedMethods isNil 
		ifTrue: [removedMethods := Set new]
		ifFalse: [removedMethods]! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
bindingFor: aString 
	^self realClass classPool associationAt: aString asSymbol
		ifAbsent: [self realClass classPool associationAt: aString asString ifAbsent: [nil]]! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
classBinding
	^Smalltalk associationAt: self name! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
inheritsPoolDictionaries
	^false! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
isMeta
	self subclassResponsibility! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
subclassRedefines: aSelector 
	"Return true, if one of your subclasses redefines the method with name, aMethod"

	self allSubclasses 
		do: [:each | (each directlyDefinesMethod: aSelector) ifTrue: [^true]].
	^false! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
whoDefinesMethod: aSelector 
	| sprClass |
	(self directlyDefinesMethod: aSelector) ifTrue: [^self].
	sprClass := self superclass.
	^sprClass isNil 
		ifTrue: [nil]
		ifFalse: [sprClass whoDefinesMethod: aSelector]! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
isAbstract
	(self whichSelectorsReferToSymbol: #subclassResponsibility) isEmpty 
		ifFalse: [^true].
	model allReferencesToClass: self do: [:each | ^false].
	^true! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
instanceVariableNames: aCollectionOfStrings 
	instanceVariableNames := aCollectionOfStrings asOrderedCollection! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
directlyDefinesPoolDictionary: aString 
	self subclassResponsibility! !

!RBAbstractClass methodsFor: 'variable accessing' stamp: ''!
whoDefinesClassVariable: aString 
	| sprClass |
	(self directlyDefinesClassVariable: aString) ifTrue: [^self].
	sprClass := self superclass.
	^sprClass isNil 
		ifTrue: [nil]
		ifFalse: [sprClass whoDefinesClassVariable: aString]! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
compileTree: aBRMethodNode classified: aSymbolCollection 
	| method source |
	source := aBRMethodNode formattedCode.
	model 
		compile: source
		in: self
		classified: aSymbolCollection.
	method := RBMethod 
				for: self
				source: source
				selector: aBRMethodNode selector.
"	method parseTree: aBRMethodNode."
	self addMethod: method! !

RBAbstractClass subclass: #RBMetaclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Model'!

!RBMetaclass methodsFor: 'initialize-release' stamp: ''!
realName: aSymbol 
	self realClass: (Smalltalk at: aSymbol) class! !

!RBMetaclass methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	super storeOn: aStream.
	aStream nextPutAll: ' class'! !

!RBMetaclass methodsFor: 'accessing' stamp: ''!
metaclass
	^self! !

!RBMetaclass methodsFor: 'testing' stamp: ''!
directlyDefinesPoolDictionary: aString 
	^self nonMetaclass directlyDefinesPoolDictionary: aString! !

!RBMetaclass methodsFor: 'testing' stamp: ''!
isMeta
	^true! !

!RBMetaclass methodsFor: 'accessing' stamp: ''!
allClassVariableNames
	^self nonMetaclass allClassVariableNames! !

!RBMetaclass methodsFor: 'accessing' stamp: ''!
allPoolDictionaryNames
	^self nonMetaclass allPoolDictionaryNames! !

!RBMetaclass methodsFor: 'printing' stamp: ''!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' class'! !

!RBMetaclass class methodsFor: 'instance creation' stamp: ''!
named: aSymbol 
	^(self new)
		name: aSymbol;
		yourself! !

!RBMetaclass methodsFor: 'testing' stamp: ''!
directlyDefinesClassVariable: aString 
	^self nonMetaclass directlyDefinesClassVariable: aString! !

!RBMetaclass class methodsFor: 'instance creation' stamp: ''!
existingNamed: aSymbol 
	^(self named: aSymbol)
		realName: aSymbol;
		yourself! !

!RBAbstractClass methodsFor: 'variable accessing' stamp: ''!
removeInstanceVariable: aString 
	self privateInstanceVariableNames remove: aString.
	model removeInstanceVariable: aString from: self! !

!RBAbstractClass methodsFor: 'method accessing' stamp: ''!
whichSelectorsReferToInstanceVariable: aString 
	| selectors |
	selectors := Set new.
	self newMethods 
		do: [:each | (each refersToVariable: aString) ifTrue: [selectors add: each selector]].
	self isDefined 
		ifTrue: 
			[selectors addAll: ((self realClass whichSelectorsAccess: aString) 
						reject: [:each | self hasRemoved: each])].
	^selectors! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
directlyDefinesVariable: aVariableName 
	^(self directlyDefinesClassVariable: aVariableName) 
		or: [self directlyDefinesInstanceVariable: aVariableName]! !

!RBAbstractClass methodsFor: 'accessing' stamp: ''!
withAllSuperclasses
	^(self allSuperclasses)
		add: self;
		yourself! !

!RBAbstractClass class methodsFor: 'class initialization' stamp: ''!
initialize
	LookupSuperclass := Object new! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
definesMethod: aSelector 
	(self directlyDefinesMethod: aSelector) ifTrue: [^true].
	^self superclass notNil and: [self superclass definesMethod: aSelector]! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
hierarchyDefinesPoolDictionary: aString 
	(self definesPoolDictionary: aString) ifTrue: [^true].
	^(self allSubclasses 
		detect: [:each | each directlyDefinesPoolDictionary: aString]
		ifNone: [nil]) notNil! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
hierarchyDefinesInstanceVariable: aString 
	(self definesInstanceVariable: aString) ifTrue: [^true].
	^(self allSubclasses 
		detect: [:each | each directlyDefinesInstanceVariable: aString]
		ifNone: [nil]) notNil! !

!RBAbstractClass methodsFor: 'testing' stamp: ''!
definesVariable: aVariableName 
	^(self definesClassVariable: aVariableName) 
		or: [self definesInstanceVariable: aVariableName]! !

!Object methodsFor: '*Refactory-RBAddonsReasonable' stamp: ''!
needsWork! !

Object subclass: #RBProgramNode
	instanceVariableNames: 'parent comments'
	classVariableNames: 'FormatterClass'
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

!RBProgramNode methodsFor: 'accessing' stamp: ''!
comments: aCollection
	comments := aCollection! !

!RBProgramNode methodsFor: 'testing-matching' stamp: ''!
isPatternNode
	^false! !

!RBProgramNode methodsFor: 'meta variable-accessing' stamp: ''!
recurseIntoCharacter
	^$`! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
directlyUses: aNode
	^true! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
isLiteral
	^false! !

!RBProgramNode methodsFor: 'testing-matching' stamp: ''!
canMatchMethod: aCompiledMethod 
	self sentMessages do: 
			[:each | 
			((self class optimizedSelectors includes: each) 
				or: [aCompiledMethod refersToLiteral: each]) ifFalse: [^false]].
	^true! !

!RBProgramNode class methodsFor: 'accessing' stamp: ''!
formatterClass
	^FormatterClass isNil ifTrue: [RBFormatter] ifFalse: [FormatterClass]! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
containsReturn
	^(self children detect: [:each | each containsReturn] ifNone: [nil]) 
		notNil! !

!RBProgramNode methodsFor: '*refactory' stamp: ''!
superMessages
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher matches: 'super `@msg: ``@args'
		do: 
			[:aNode :answer | 
			answer
				add: aNode selector;
				yourself].
	^searcher executeTree: self initialAnswer: Set new! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
parent
	^parent! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
isUsed
	"Answer true if this node could be used as part of another expression. For example, you could use the 
	result of this node as a receiver of a message, an argument, the right part of an assignment, or the 
	return value of a block. This differs from isDirectlyUsed in that it is conservative since it also includes 
	return values of blocks."

	^parent isNil
		ifTrue: [false]
		ifFalse: [parent uses: self]! !

!RBProgramNode methodsFor: 'querying' stamp: ''!
bestNodeFor: anInterval 
	| selectedChildren |
	(self intersectsInterval: anInterval) ifFalse: [^nil].
	(self containedBy: anInterval) ifTrue: [^self].
	selectedChildren := self children 
				select: [:each | each intersectsInterval: anInterval].
	^selectedChildren size == 1 
		ifTrue: [selectedChildren first bestNodeFor: anInterval]
		ifFalse: [self]! !

!RBProgramNode methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream nextPutAll: self class name;
		nextPut: $(;
		nextPutAll: self formattedCode;
		nextPut: $)! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
parent: anObject
	parent := anObject! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
lastIsReturn
	^self isReturn! !

!RBProgramNode class methodsFor: 'accessing' stamp: ''!
optimizedSelectors
	^#(#== #ifTrue: #ifTrue:ifFalse: #ifFalse: #ifFalse:ifTrue: #whileTrue: #whileTrue #whileFalse: #whileFalse #to:do: #yourself #and: #or:)! !

RBProgramNode subclass: #RBArrayNode
	instanceVariableNames: 'leftBrace rightBrace statements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

!RBArrayNode methodsFor: 'accessing' stamp: 'ls 1/24/2000 00:32'!
statements
	^statements! !

!RBArrayNode methodsFor: 'accessing' stamp: 'ls 1/24/2000 00:02'!
leftBrace: leftBrace0
	leftBrace _ leftBrace0.! !

!RBArrayNode methodsFor: 'comparing' stamp: 'bh 4/3/2000 12:46'!
= anObject 
	self == anObject ifTrue: [^true].
	self class = anObject class ifFalse: [^false].
	^statements = anObject statements.! !

!RBArrayNode methodsFor: 'testing' stamp: 'ls 1/24/2000 00:28'!
lastIsReturn
	statements isEmpty ifTrue:[ ^false ].
	^statements last lastIsReturn! !

!RBArrayNode methodsFor: 'initialization' stamp: 'ls 1/23/2000 23:57'!
leftBrace: leftBrace0  rightBrace: rightBrace0  statements: statements0
	leftBrace _ leftBrace0.
	rightBrace _ rightBrace0.
	statements _ statements0.! !

!RBArrayNode methodsFor: 'accessing' stamp: 'ls 1/24/2000 00:00'!
children
	^statements! !

!RBArrayNode methodsFor: 'accessing' stamp: 'ls 1/23/2000 23:58'!
start
	^leftBrace! !

!RBArrayNode class methodsFor: 'instance creation' stamp: 'ls 1/23/2000 23:56'!
leftBrace: leftBrace  rightBrace: rightBrace  statements: statements
	^self new leftBrace: leftBrace  rightBrace: rightBrace  statements: statements! !

!RBArrayNode methodsFor: 'accessing' stamp: 'ls 1/24/2000 00:02'!
rightBrace: rightBrace0
	rightBrace _ rightBrace0.! !

!RBArrayNode methodsFor: 'accessing' stamp: 'dvf 11/12/2002 00:47'!
statements: statements0 
	statements ifNotNil: [self error: 'double initialization'].
	statements _ statements0.
	statements do: [:statement | statement parent: self]! !

!RBArrayNode methodsFor: 'comparing' stamp: 'bh 4/3/2000 12:46'!
hash

	^statements hash.! !

!RBArrayNode methodsFor: 'accessing' stamp: 'ls 1/23/2000 23:58'!
stop
	^rightBrace! !

!RBArrayNode methodsFor: 'accessing' stamp: 'ls 1/24/2000 00:02'!
periods: periods
	"ignored"! !

!RBArrayNode methodsFor: 'visitor' stamp: 'ls 2/29/2004 13:01'!
acceptVisitor: aProgramNodeVisitor
	^aProgramNodeVisitor acceptArrayNode: self! !

!RBArrayNode methodsFor: 'copying' stamp: 'ls 1/24/2000 00:25'!
postCopy
	statements _ statements collect: [ :statement | statement copy ]! !

!RBArrayNode methodsFor: 'replacing' stamp: 'ls 1/24/2000 00:27'!
replaceNode: oldNode  withNode: newNode
	statements _ statements collect: [ :statement |
		statement == oldNode 
			ifTrue: [ newNode ]
			ifFalse: [ statement ] ]! !

!RBProgramNode methodsFor: 'querying' stamp: ''!
whoDefines: aName 
	^(self defines: aName)
		ifTrue: [self]
		ifFalse: [parent notNil
				ifTrue: [parent whoDefines: aName]
				ifFalse: [nil]]! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
containedBy: anInterval 
	^anInterval first <= self start and: [anInterval last >= self stop]! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
isImmediate
	^false! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
allDefinedVariables
	| children |
	children := self children.
	children isEmpty ifTrue: [^#()].
	^children inject: OrderedCollection new
		into: 
			[:vars :each | 
			vars addAll: each allDefinedVariables;
				yourself]! !

!RBProgramNode methodsFor: 'copying' stamp: ''!
postCopy! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
sourceInterval
	^self start to: self stop! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
blockVariables
	^parent isNil
		ifTrue: [#()]
		ifFalse: [parent blockVariables]! !

!RBProgramNode methodsFor: 'matching' stamp: ''!
matchList: matchNodes against: programNodes inContext: aDictionary 
	^self
		matchList: matchNodes
		index: 1
		against: programNodes
		index: 1
		inContext: aDictionary! !

!RBProgramNode methodsFor: 'enumeration' stamp: ''!
collect: aBlock 
	"Hacked to fit collection protocols"

	^aBlock value: self! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
sentMessages
	| messages |
	messages := Set new.
	self children do: [:each | messages addAll: each sentMessages].
	^messages! !

!RBProgramNode methodsFor: 'replacing' stamp: ''!
removeDeadCode
	self children do: [:each | each removeDeadCode]! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
evaluatedFirst: aNode 
	self children do: 
			[:each | 
			each == aNode ifTrue: [^true].
			each isImmediate ifFalse: [^false]].
	^false! !

RBProgramNode subclass: #RBValueNode
	instanceVariableNames: 'parentheses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

RBValueNode subclass: #RBMessageNode
	instanceVariableNames: 'receiver selector selectorParts arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

!RBMessageNode methodsFor: 'accessing' stamp: ''!
sentMessages
	^(super sentMessages)
		add: self selector;
		yourself! !

!RBMessageNode methodsFor: 'replacing' stamp: ''!
replaceNode: aNode withNode: anotherNode 
	"If we're inside a cascade node and are changing the receiver, change all the receivers"

	receiver == aNode 
		ifTrue: 
			[self receiver: anotherNode.
			(parent notNil and: [parent isCascade]) 
				ifTrue: [parent messages do: [:each | each receiver: anotherNode]]].
	self arguments: (arguments 
				collect: [:each | each == aNode ifTrue: [anotherNode] ifFalse: [each]])! !

!RBMessageNode methodsFor: 'accessing' stamp: ''!
receiver
	^receiver! !

!RBMessageNode methodsFor: 'accessing' stamp: ''!
selector: aSelector 
	| keywords numArgs |
	keywords := aSelector keywords.
	numArgs := aSelector numArgs.
	numArgs == arguments size 
		ifFalse: 
			[self 
				error: 'Attempting to assign selector with wrong number of arguments.'].
	selectorParts := numArgs == 0 
				ifTrue: [Array with: (RBIdentifierToken value: keywords first start: nil)]
				ifFalse: 
					[keywords first last == $: 
						ifTrue: [keywords collect: [:each | RBKeywordToken value: each start: nil]]
						ifFalse: [Array with: (RBBinarySelectorToken value: aSelector start: nil)]].
	selector := aSelector! !

!RBMessageNode class methodsFor: 'instance creation' stamp: ''!
receiver: aValueNode selector: aSymbol arguments: valueNodes 
	^(self new)
		receiver: aValueNode;
		arguments: valueNodes;
		selector: aSymbol;
		yourself! !

!RBMessageNode methodsFor: 'testing' stamp: ''!
lastIsReturn
	^(#(#ifTrue:ifFalse: #ifFalse:ifTrue:) includes: self selector) and: 
			[arguments first isBlock and: 
					[arguments first body lastIsReturn
						and: [arguments last isBlock and: [arguments last body lastIsReturn]]]]! !

!RBMessageNode methodsFor: 'testing' stamp: ''!
isBinary
	^(self isUnary or: [self isKeyword]) not! !

!RBMessageNode methodsFor: 'accessing' stamp: ''!
receiver: aValueNode 
	receiver := aValueNode.
	receiver parent: self! !

!RBMessageNode methodsFor: 'private' stamp: ''!
selectorParts
	^selectorParts! !

!RBMessageNode methodsFor: 'querying' stamp: ''!
bestNodeFor: anInterval 
	(self intersectsInterval: anInterval) ifFalse: [^nil].
	(self containedBy: anInterval) ifTrue: [^self].
	selectorParts do: 
			[:each | 
			((anInterval first between: each start and: each stop) 
				or: [each start between: anInterval first and: anInterval last]) 
					ifTrue: [^self]].
	self children do: 
			[:each | 
			| node |
			node := each bestNodeFor: anInterval.
			node notNil ifTrue: [^node]]! !

!RBMessageNode methodsFor: 'accessing' stamp: ''!
selector
	^selector isNil
		ifTrue: [selector := self buildSelector]
		ifFalse: [selector]! !

!RBMessageNode methodsFor: 'matching' stamp: ''!
copyInContext: aDictionary 
	^(self class new) receiver: (receiver copyInContext: aDictionary);
		selectorParts: (selectorParts collect: [:each | each removePositions]);
		arguments: (arguments collect: [:each | each copyInContext: aDictionary]);
		yourself! !

!RBMessageNode methodsFor: 'accessing' stamp: ''!
children
	^(OrderedCollection with: self receiver) addAll: self arguments;
		yourself! !

!RBMessageNode class methodsFor: 'instance creation' stamp: ''!
receiver: aValueNode selector: aSymbol 
	^self 
		receiver: aValueNode
		selector: aSymbol
		arguments: #()! !

!RBMessageNode methodsFor: 'private' stamp: ''!
selectorParts: tokenCollection 
	selectorParts := tokenCollection! !

!RBMessageNode methodsFor: 'testing' stamp: ''!
isKeyword
	^selectorParts first value last == $:! !

!RBMessageNode methodsFor: 'comparing' stamp: ''!
equalTo: anObject withMapping: aDictionary 
	self class = anObject class ifFalse: [^false].
	((self receiver equalTo: anObject receiver withMapping: aDictionary)
		and: [self selector = anObject selector]) ifFalse: [^false].
	1 to: self arguments size
		do: 
			[:i | 
			((self arguments at: i) equalTo: (anObject arguments at: i)
				withMapping: aDictionary) ifFalse: [^false]].
	^true! !

!RBMessageNode methodsFor: 'testing' stamp: ''!
isMessage
	^true! !

!RBMessageNode methodsFor: 'copying' stamp: ''!
postCopy
	super postCopy.
	receiver := receiver copy.
	arguments := arguments collect: [:each | each copy]! !

!RBMessageNode class methodsFor: 'instance creation' stamp: ''!
receiver: aValueNode selectorParts: keywordTokens arguments: valueNodes 
	^((keywordTokens detect: [:each | each isPatternVariable] ifNone: [nil]) 
		notNil ifTrue: [RBPatternMessageNode] ifFalse: [RBMessageNode]) 
		new 
			receiver: aValueNode
			selectorParts: keywordTokens
			arguments: valueNodes! !

!RBMessageNode methodsFor: 'testing' stamp: ''!
isUnary
	^arguments isEmpty! !

!RBMessageNode methodsFor: 'accessing' stamp: ''!
precedence
	^self isUnary ifTrue: [1] ifFalse: [self isKeyword ifTrue: [3] ifFalse: [2]]! !

!RBMessageNode methodsFor: 'matching' stamp: ''!
match: aNode inContext: aDictionary 
	aNode class == self class ifFalse: [^false].
	self selector == aNode selector ifFalse: [^false].
	(receiver match: aNode receiver inContext: aDictionary) ifFalse: [^false].
	1 to: arguments size
		do: 
			[:i | 
			((arguments at: i) match: (aNode arguments at: i) inContext: aDictionary)
				ifFalse: [^false]].
	^true! !

!RBMessageNode methodsFor: 'accessing' stamp: ''!
stopWithoutParentheses
	^arguments isEmpty 
		ifTrue: [selectorParts first stop]
		ifFalse: [arguments last stop]! !

!RBMessageNode methodsFor: 'testing' stamp: ''!
isFirstCascaded
	^self isCascaded and: [parent messages first == self]! !

!RBMessageNode methodsFor: 'comparing' stamp: ''!
hash
	^(self receiver hash bitXor: self selector hash)
		bitXor: (self arguments isEmpty ifTrue: [0] ifFalse: [self arguments first hash])! !

!RBMessageNode methodsFor: 'accessing' stamp: ''!
arguments: argCollection 
	arguments := argCollection.
	arguments do: [:each | each parent: self]! !

!RBMessageNode methodsFor: 'comparing' stamp: ''!
= anObject 
	self == anObject ifTrue: [^true].
	self class = anObject class ifFalse: [^false].
	(self receiver = anObject receiver 
		and: [self selector = anObject selector]) ifFalse: [^false].
	1 to: self arguments size
		do: [:i | (self arguments at: i) = (anObject arguments at: i) ifFalse: [^false]].
	^true! !

!RBMessageNode methodsFor: 'accessing' stamp: ''!
startWithoutParentheses
	^receiver start! !

!RBMessageNode methodsFor: 'visitor' stamp: ''!
acceptVisitor: aProgramNodeVisitor 
	^aProgramNodeVisitor acceptMessageNode: self! !

!RBMessageNode methodsFor: 'initialize-release' stamp: ''!
receiver: aValueNode selectorParts: keywordTokens arguments: valueNodes 
	self receiver: aValueNode.
	selectorParts := keywordTokens.
	self arguments: valueNodes! !

RBMessageNode subclass: #RBPatternMessageNode
	instanceVariableNames: 'isList isCascadeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

!RBPatternMessageNode methodsFor: 'matching' stamp: ''!
copyInContext: aDictionary 
	| selectors |
	self isList ifTrue: [^aDictionary at: self].
	selectors := self isSelectorList 
				ifTrue: [(aDictionary at: selectorParts first value) keywords]
				ifFalse: [selectorParts collect: [:each | aDictionary at: each value]].
	^(RBMessageNode new)
		receiver: (receiver copyInContext: aDictionary);
		selectorParts: (selectors collect: 
						[:each | 
						(each last == $: ifTrue: [RBKeywordToken] ifFalse: [RBIdentifierToken]) 
							value: each
							start: nil]);
		arguments: (self copyList: arguments inContext: aDictionary);
		yourself! !

!RBPatternMessageNode methodsFor: 'testing-matching' stamp: ''!
isList
	^isCascadeList and: [parent notNil and: [parent isCascade]]! !

!RBPatternMessageNode methodsFor: 'testing-matching' stamp: ''!
isSelectorList
	^isList! !

!RBPatternMessageNode methodsFor: 'initialize-release' stamp: ''!
receiver: aValueNode selectorParts: keywordTokens arguments: valueNodes 
	| message |
	super 
		receiver: aValueNode
		selectorParts: keywordTokens
		arguments: valueNodes.
	isCascadeList := isList := false.
	message := keywordTokens first value.
	2 to: message size
		do: 
			[:i | 
			| character |
			character := message at: i.
			character == self listCharacter 
				ifTrue: [isList := true]
				ifFalse: 
					[character == self cascadeListCharacter 
						ifTrue: [isCascadeList := true]
						ifFalse: [^self]]]! !

!RBPatternMessageNode methodsFor: 'matching' stamp: ''!
match: aNode inContext: aDictionary 
	aNode class == self matchingClass ifFalse: [^false].
	(receiver match: aNode receiver inContext: aDictionary) ifFalse: [^false].
	self isSelectorList ifTrue: 
			[^(aDictionary at: selectorParts first value ifAbsentPut: [aNode selector])
				== aNode selector and: 
						[(aDictionary at: arguments first ifAbsentPut: [aNode arguments])
							= aNode arguments]].
	^self matchArgumentsAgainst: aNode inContext: aDictionary! !

!RBPatternMessageNode methodsFor: 'matching' stamp: ''!
matchSelectorAgainst: aNode inContext: aDictionary 
	| keyword |
	1 to: selectorParts size
		do: 
			[:i | 
			keyword := selectorParts at: i.
			(aDictionary at: keyword value
				ifAbsentPut: 
					[keyword isPatternVariable 
						ifTrue: [(aNode selectorParts at: i) value]
						ifFalse: [keyword value]]) 
					= (aNode selectorParts at: i) value ifFalse: [^false]].
	^true! !

!RBPatternMessageNode methodsFor: 'private' stamp: ''!
matchingClass
	^RBMessageNode! !

!RBPatternMessageNode methodsFor: 'accessing' stamp: ''!
sentMessages
	^(super sentMessages)
		remove: self selector ifAbsent: [];
		yourself! !

!RBPatternMessageNode methodsFor: 'testing-matching' stamp: ''!
isPatternNode
	^true! !

!RBPatternMessageNode methodsFor: 'matching' stamp: ''!
matchArgumentsAgainst: aNode inContext: aDictionary 
	self arguments size == aNode arguments size ifFalse: [^false].
	(self matchSelectorAgainst: aNode inContext: aDictionary) 
		ifFalse: [^false].
	1 to: arguments size
		do: 
			[:i | 
			((arguments at: i) match: (aNode arguments at: i) inContext: aDictionary) 
				ifFalse: [^false]].
	^true! !

!RBMessageNode methodsFor: 'testing' stamp: ''!
isCascaded
	^parent notNil and: [parent isCascade]! !

!RBMessageNode methodsFor: 'private' stamp: ''!
buildSelector
	| selectorStream |
	selectorStream := WriteStream on: (String new: 50).
	selectorParts do: [:each | selectorStream nextPutAll: each value].
	^selectorStream contents asSymbol! !

!RBMessageNode methodsFor: 'accessing' stamp: ''!
arguments
	^arguments isNil
		ifTrue: [#()]
		ifFalse: [arguments]! !

RBValueNode subclass: #RBVariableNode
	instanceVariableNames: 'token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

!RBVariableNode methodsFor: 'comparing' stamp: ''!
= anObject 
	self == anObject ifTrue: [^true].
	self class = anObject class ifFalse: [^false].
	^self name = anObject name! !

!RBVariableNode methodsFor: 'testing' stamp: ''!
references: aVariableName 
	^self name = aVariableName! !

!RBVariableNode methodsFor: 'matching' stamp: ''!
copyInContext: aDictionary 
	^self class identifierToken: token removePositions! !

!RBVariableNode methodsFor: 'testing' stamp: ''!
isImmediate
	^true! !

!RBVariableNode methodsFor: 'comparing' stamp: ''!
equalTo: anObject withMapping: aDictionary 
	self class = anObject class ifFalse: [^false].
	^(aDictionary at: self name ifAbsentPut: [anObject name]) = anObject name! !

!RBVariableNode methodsFor: 'comparing' stamp: ''!
hash
	^self name hash! !

!RBVariableNode methodsFor: 'accessing' stamp: ''!
name
	^token value! !

!RBVariableNode methodsFor: 'accessing' stamp: ''!
precedence
	^0! !

!RBVariableNode methodsFor: 'accessing' stamp: ''!
startWithoutParentheses
	^token start! !

!RBVariableNode methodsFor: 'visitor' stamp: ''!
acceptVisitor: aProgramNodeVisitor 
	^aProgramNodeVisitor acceptVariableNode: self! !

!RBVariableNode methodsFor: 'accessing' stamp: ''!
stopWithoutParentheses
	^token stop! !

!RBVariableNode class methodsFor: 'instance creation' stamp: ''!
identifierToken: anIdentifierToken 
	^(anIdentifierToken isPatternVariable 
		ifTrue: [RBPatternVariableNode]
		ifFalse: [RBVariableNode]) new 
		identifierToken: anIdentifierToken! !

!RBVariableNode methodsFor: 'initialize-release' stamp: ''!
identifierToken: anIdentifierToken 
	token := anIdentifierToken! !

!RBVariableNode class methodsFor: 'instance creation' stamp: ''!
named: aString 
	^self identifierToken: (RBIdentifierToken value: aString start: 0)! !

!RBVariableNode methodsFor: 'testing' stamp: ''!
isVariable
	^true! !

RBVariableNode subclass: #RBPatternVariableNode
	instanceVariableNames: 'recurseInto isList isLiteral isStatement isAnything'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

!RBPatternVariableNode methodsFor: 'testing-matching' stamp: ''!
recurseInto
	^recurseInto! !

!RBPatternVariableNode methodsFor: 'testing-matching' stamp: ''!
isList
	^isList! !

!RBPatternVariableNode methodsFor: 'matching' stamp: ''!
matchStatement: aNode inContext: aDictionary 
	(aNode parent notNil and: [aNode parent isSequence]) ifFalse: [^false].
	^(aDictionary at: self ifAbsentPut: [aNode]) = aNode! !

!RBPatternVariableNode methodsFor: 'matching' stamp: ''!
matchLiteral: aNode inContext: aDictionary 
	^aNode class == RBLiteralNode 
		and: [(aDictionary at: self ifAbsentPut: [aNode]) = aNode]! !

!RBPatternVariableNode methodsFor: 'testing-matching' stamp: ''!
isAnything
	^isAnything! !

!RBPatternVariableNode methodsFor: 'accessing' stamp: ''!
parent: aBRProgramNode 
	"Fix the case where '``@node' should match a single node, not a sequence node."

	super parent: aBRProgramNode.
	parent isSequence 
		ifTrue: 
			[(self isStatement or: [parent temporaries includes: self]) 
				ifFalse: [isList := false]]! !

!RBPatternVariableNode methodsFor: 'testing-matching' stamp: ''!
isLiteral
	^isLiteral! !

!RBPatternVariableNode methodsFor: 'initialize-release' stamp: ''!
identifierToken: anIdentifierToken 
	super identifierToken: anIdentifierToken.
	self initializePatternVariables! !

!RBPatternVariableNode methodsFor: 'initialize-release' stamp: ''!
initializePatternVariables
	| name |
	name := self name.
	isAnything := isList := isLiteral := isStatement := recurseInto := false.
	2 to: name size
		do: 
			[:i | 
			| character |
			character := name at: i.
			character == self listCharacter 
				ifTrue: [isAnything := isList := true]
				ifFalse: 
					[character == self literalCharacter 
						ifTrue: [isLiteral := true]
						ifFalse: 
							[character == self statementCharacter 
								ifTrue: [isStatement := true]
								ifFalse: 
									[character == self recurseIntoCharacter 
										ifTrue: [recurseInto := true]
										ifFalse: [^self]]]]]! !

!RBPatternVariableNode methodsFor: 'matching' stamp: ''!
match: aNode inContext: aDictionary 
	self isAnything ifTrue: [^(aDictionary at: self ifAbsentPut: [aNode]) = aNode].
	self isLiteral ifTrue: [^self matchLiteral: aNode inContext: aDictionary].
	self isStatement
		ifTrue: [^self matchStatement: aNode inContext: aDictionary].
	aNode class == self matchingClass ifFalse: [^false].
	^(aDictionary at: self ifAbsentPut: [aNode]) = aNode! !

!RBPatternVariableNode methodsFor: 'private' stamp: ''!
matchingClass
	^RBVariableNode! !

!RBPatternVariableNode methodsFor: 'testing-matching' stamp: ''!
isPatternNode
	^true! !

!RBPatternVariableNode methodsFor: 'matching' stamp: ''!
copyInContext: aDictionary 
	^aDictionary at: self! !

!RBPatternVariableNode methodsFor: 'testing-matching' stamp: ''!
isStatement
	^isStatement! !

!RBValueNode methodsFor: 'accessing' stamp: ''!
stopWithoutParentheses
	^self subclassResponsibility! !

RBValueNode subclass: #RBCascadeNode
	instanceVariableNames: 'messages semicolons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

!RBCascadeNode methodsFor: 'testing' stamp: ''!
isCascade
	^true! !

!RBCascadeNode methodsFor: 'initialize-release' stamp: ''!
messages: messageNodes semicolons: integerCollection 
	self messages: messageNodes.
	semicolons := integerCollection! !

!RBCascadeNode methodsFor: 'replacing' stamp: ''!
replaceNode: aNode withNode: anotherNode 
	self messages: (messages 
				collect: [:each | each == aNode ifTrue: [anotherNode] ifFalse: [each]])! !

!RBCascadeNode methodsFor: 'querying' stamp: ''!
bestNodeFor: anInterval 
	| selectedChildren |
	(self intersectsInterval: anInterval) ifFalse: [^nil].
	(self containedBy: anInterval) ifTrue: [^self].
	messages 
		reverseDo: [:each | (each containedBy: anInterval) ifTrue: [^each]].
	selectedChildren := (messages 
				collect: [:each | each bestNodeFor: anInterval]) 
					reject: [:each | each isNil].
	^selectedChildren detect: [:each | true] ifNone: [nil]! !

!RBCascadeNode methodsFor: 'accessing' stamp: ''!
messages
	^messages! !

!RBCascadeNode methodsFor: 'comparing' stamp: 'bh 4/10/2001 15:59'!
hash
	^self messages asArray hash! !

!RBCascadeNode methodsFor: 'accessing' stamp: ''!
messages: messageNodeCollection 
	messages := messageNodeCollection.
	messages do: [:each | each parent: self]! !

!RBCascadeNode methodsFor: 'accessing' stamp: ''!
children
	^self messages! !

!RBCascadeNode class methodsFor: 'instance creation' stamp: ''!
messages: messageNodes semicolons: integerCollection 
	^self new messages: messageNodes semicolons: integerCollection! !

!RBCascadeNode methodsFor: 'accessing' stamp: ''!
precedence
	^4! !

!RBCascadeNode methodsFor: 'querying' stamp: ''!
whichNodeIsContainedBy: anInterval 
	| selectedChildren |
	(self intersectsInterval: anInterval) ifFalse: [^nil].
	(self containedBy: anInterval) ifTrue: [^self].
	messages 
		reverseDo: [:each | (each containedBy: anInterval) ifTrue: [^each]].
	selectedChildren := (messages 
				collect: [:each | each whichNodeIsContainedBy: anInterval]) 
					reject: [:each | each isNil].
	^selectedChildren detect: [:each | true] ifNone: [nil]! !

!RBCascadeNode methodsFor: 'testing' stamp: ''!
directlyUses: aNode 
	^messages last = aNode and: [self isDirectlyUsed]! !

!RBCascadeNode methodsFor: 'testing' stamp: ''!
uses: aNode 
	^messages last = aNode and: [self isUsed]! !

!RBCascadeNode methodsFor: 'visitor' stamp: ''!
acceptVisitor: aProgramNodeVisitor 
	^aProgramNodeVisitor acceptCascadeNode: self! !

!RBCascadeNode methodsFor: 'copying' stamp: ''!
postCopy
	super postCopy.
	messages := messages collect: [:each | each copy]! !

!RBCascadeNode methodsFor: 'matching' stamp: ''!
match: aNode inContext: aDictionary 
	aNode class == self class ifFalse: [^false].
	^self matchList: messages
		against: aNode messages
		inContext: aDictionary! !

!RBCascadeNode methodsFor: 'comparing' stamp: ''!
= anObject 
	self == anObject ifTrue: [^true].
	self class = anObject class ifFalse: [^false].
	self messages size = anObject messages size ifFalse: [^false].
	1 to: self messages size
		do: [:i | (self messages at: i) = (anObject messages at: i) ifFalse: [^false]].
	^true! !

!RBCascadeNode class methodsFor: 'instance creation' stamp: ''!
messages: messageNodes 
	^self new messages: messageNodes! !

!RBCascadeNode methodsFor: 'accessing' stamp: ''!
startWithoutParentheses
	^messages first start! !

!RBCascadeNode methodsFor: 'comparing' stamp: ''!
equalTo: anObject withMapping: aDictionary 
	self class = anObject class ifFalse: [^false].
	self messages size == anObject messages size ifFalse: [^false].
	1 to: self messages size
		do: 
			[:i | 
			((self messages at: i) equalTo: (anObject messages at: i)
				withMapping: aDictionary) ifFalse: [^false]].
	^true! !

!RBCascadeNode methodsFor: 'matching' stamp: ''!
copyInContext: aDictionary 
	^(self class new) messages: (self copyList: messages inContext: aDictionary);
		yourself! !

!RBCascadeNode methodsFor: 'accessing' stamp: ''!
stopWithoutParentheses
	^messages last stop! !

RBValueNode subclass: #RBLiteralNode
	instanceVariableNames: 'token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

!RBLiteralNode class methodsFor: 'instance creation' stamp: ''!
value: aValue 
	^self literalToken: (RBLiteralToken value: aValue)! !

!RBLiteralNode methodsFor: 'accessing' stamp: ''!
startWithoutParentheses
	^token start! !

!RBLiteralNode methodsFor: 'initialize-release' stamp: ''!
literalToken: aLiteralToken 
	token := aLiteralToken! !

!RBLiteralNode methodsFor: 'testing' stamp: ''!
isImmediate
	^true! !

!RBLiteralNode methodsFor: 'accessing' stamp: ''!
token
	^token! !

!RBLiteralNode methodsFor: 'accessing' stamp: ''!
precedence
	^0! !

!RBLiteralNode methodsFor: 'matching' stamp: ''!
copyInContext: aDictionary
	^self class literalToken: token removePositions! !

!RBLiteralNode methodsFor: 'comparing' stamp: ''!
hash
	^self value hash! !

!RBLiteralNode methodsFor: 'accessing' stamp: ''!
value
	^token realValue! !

!RBLiteralNode class methodsFor: 'instance creation' stamp: ''!
literalToken: aLiteralToken 
	^self new literalToken: aLiteralToken! !

!RBLiteralNode methodsFor: 'accessing' stamp: ''!
stopWithoutParentheses
	^token stop! !

!RBLiteralNode methodsFor: 'visitor' stamp: ''!
acceptVisitor: aProgramNodeVisitor 
	^aProgramNodeVisitor acceptLiteralNode: self! !

!RBLiteralNode methodsFor: 'testing' stamp: ''!
isLiteral
	^true! !

!RBLiteralNode methodsFor: 'comparing' stamp: ''!
= anObject 
	self == anObject ifTrue: [^true].
	self class == anObject class ifFalse: [^false].
	self value class == anObject value class ifFalse: [^false].
	^self value = anObject value! !

RBValueNode subclass: #RBOptimizedNode
	instanceVariableNames: 'left right body'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

!RBOptimizedNode methodsFor: 'matching' stamp: ''!
copyInContext: aDictionary 
	^self class body: (body copyInContext: aDictionary)! !

!RBOptimizedNode methodsFor: 'matching' stamp: ''!
match: aNode inContext: aDictionary 
	aNode class == self class ifFalse: [^false].
	^body match: aNode body inContext: aDictionary! !

!RBOptimizedNode methodsFor: 'accessing' stamp: ''!
body: stmtsNode 
	body := stmtsNode.
	body parent: self! !

!RBOptimizedNode methodsFor: 'comparing' stamp: ''!
= anObject 
	self == anObject ifTrue: [^true].
	self class = anObject class ifFalse: [^false].
	^self body = anObject body! !

!RBOptimizedNode methodsFor: 'comparing' stamp: ''!
equalTo: anObject withMapping: aDictionary 
	self class = anObject class ifFalse: [^false].
	^self body equalTo: anObject body withMapping: aDictionary! !

!RBOptimizedNode methodsFor: 'accessing' stamp: ''!
children
	^Array with: body! !

!RBOptimizedNode methodsFor: 'testing' stamp: ''!
isImmediate
	^true! !

!RBOptimizedNode methodsFor: 'accessing' stamp: ''!
stopWithoutParentheses
	^right! !

!RBOptimizedNode methodsFor: 'visitor' stamp: ''!
acceptVisitor: aProgramNodeVisitor 
	^aProgramNodeVisitor acceptOptimizedNode: self! !

!RBOptimizedNode methodsFor: 'comparing' stamp: ''!
hash
	^self body hash! !

!RBOptimizedNode methodsFor: 'initialize-release' stamp: ''!
left: leftInteger body: aSequenceNode right: rightInteger 
	left := leftInteger.
	self body: aSequenceNode.
	right := rightInteger! !

!RBOptimizedNode methodsFor: 'accessing' stamp: ''!
precedence
	^0! !

!RBOptimizedNode class methodsFor: 'instance creation' stamp: ''!
body: aSequenceNode 
	^self new body: aSequenceNode! !

!RBOptimizedNode class methodsFor: 'instance creation' stamp: ''!
left: leftInteger body: aSequenceNode right: rightInteger 
	^self new
		left: leftInteger
		body: aSequenceNode
		right: rightInteger! !

!RBOptimizedNode methodsFor: 'accessing' stamp: ''!
body
	^body! !

!RBOptimizedNode methodsFor: 'replacing' stamp: ''!
replaceNode: aNode withNode: anotherNode 
	body == aNode ifTrue: [self body: anotherNode]! !

!RBOptimizedNode methodsFor: 'accessing' stamp: ''!
startWithoutParentheses
	^left! !

!RBValueNode methodsFor: 'testing' stamp: ''!
hasParentheses
	^self parentheses isEmpty not! !

!RBValueNode methodsFor: 'accessing' stamp: ''!
start
	^parentheses isNil 
		ifTrue: [self startWithoutParentheses]
		ifFalse: [parentheses last first]! !

RBValueNode subclass: #RBAssignmentNode
	instanceVariableNames: 'variable assignment value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

!RBAssignmentNode methodsFor: 'comparing' stamp: ''!
equalTo: anObject withMapping: aDictionary 
	self class = anObject class ifFalse: [^false].
	^(self variable equalTo: anObject variable withMapping: aDictionary)
		and: [self value equalTo: anObject value withMapping: aDictionary]! !

!RBAssignmentNode methodsFor: 'accessing' stamp: ''!
value
	^value! !

!RBAssignmentNode methodsFor: 'accessing' stamp: ''!
stopWithoutParentheses
	^value stop! !

!RBAssignmentNode methodsFor: 'testing' stamp: ''!
directlyUses: aNode 
	^aNode = value ifTrue: [true] ifFalse: [self isDirectlyUsed]! !

!RBAssignmentNode methodsFor: 'accessing' stamp: ''!
variable
	^variable! !

!RBAssignmentNode class methodsFor: 'instance creation' stamp: ''!
variable: aVariableNode value: aValueNode position: anInteger 
	^self new
		variable: aVariableNode
		value: aValueNode
		position: anInteger! !

!RBAssignmentNode methodsFor: 'accessing' stamp: ''!
children
	^Array with: value with: variable! !

!RBAssignmentNode methodsFor: 'matching' stamp: ''!
copyInContext: aDictionary 
	^(self class new) variable: (variable copyInContext: aDictionary);
		value: (value copyInContext: aDictionary);
		yourself! !

!RBAssignmentNode methodsFor: 'testing' stamp: ''!
uses: aNode 
	^aNode = value ifTrue: [true] ifFalse: [self isUsed]! !

!RBAssignmentNode methodsFor: 'comparing' stamp: ''!
hash
	^self variable hash bitXor: self value hash! !

!RBAssignmentNode methodsFor: 'accessing' stamp: ''!
value: aValueNode 
	value := aValueNode.
	value parent: self! !

!RBAssignmentNode methodsFor: 'testing' stamp: ''!
isAssignment
	^true! !

!RBAssignmentNode methodsFor: 'accessing' stamp: ''!
startWithoutParentheses
	^variable start! !

!RBAssignmentNode methodsFor: 'accessing' stamp: ''!
precedence
	^5! !

!RBAssignmentNode methodsFor: 'querying' stamp: ''!
bestNodeFor: anInterval 
	(self intersectsInterval: anInterval) ifFalse: [^nil].
	(self containedBy: anInterval) ifTrue: [^self].
	assignment isNil ifTrue: [^super bestNodeFor: anInterval].
	((anInterval first between: assignment and: assignment + 1) 
		or: [assignment between: anInterval first and: anInterval last]) 
			ifTrue: [^self].
	self children do: 
			[:each | 
			| node |
			node := each bestNodeFor: anInterval.
			node notNil ifTrue: [^node]]! !

!RBAssignmentNode methodsFor: 'copying' stamp: ''!
postCopy
	super postCopy.
	variable := variable postCopy.
	value := value postCopy! !

!RBAssignmentNode methodsFor: 'replacing' stamp: ''!
replaceNode: aNode withNode: anotherNode 
	value == aNode ifTrue: [self value: anotherNode].
	variable == aNode ifTrue: [self variable: anotherNode]! !

!RBAssignmentNode methodsFor: 'comparing' stamp: ''!
= anObject 
	self == anObject ifTrue: [^true].
	self class = anObject class ifFalse: [^false].
	^self variable = anObject variable and: [self value = anObject value]! !

!RBAssignmentNode methodsFor: 'matching' stamp: ''!
match: aNode inContext: aDictionary 
	aNode class == self class ifFalse: [^false].
	^(variable match: aNode variable inContext: aDictionary)
		and: [value match: aNode value inContext: aDictionary]! !

!RBAssignmentNode methodsFor: 'accessing' stamp: ''!
variable: varNode 
	variable := varNode.
	variable parent: self! !

!RBAssignmentNode methodsFor: 'testing' stamp: ''!
assigns: aVariableName 
	^variable name = aVariableName or: [value assigns: aVariableName]! !

!RBAssignmentNode class methodsFor: 'instance creation' stamp: ''!
variable: aVariableNode value: aValueNode 
	^self 
		variable: aVariableNode
		value: aValueNode
		position: nil! !

!RBAssignmentNode methodsFor: 'visitor' stamp: ''!
acceptVisitor: aProgramNodeVisitor 
	^aProgramNodeVisitor acceptAssignmentNode: self! !

!RBAssignmentNode methodsFor: 'initialize-release' stamp: ''!
variable: aVariableNode value: aValueNode position: anInteger 
	self variable: aVariableNode.
	self value: aValueNode.
	assignment := anInteger! !

!RBValueNode methodsFor: 'accessing' stamp: ''!
parentheses
	^parentheses isNil
		ifTrue: [#()]
		ifFalse: [parentheses]! !

!RBValueNode methodsFor: 'testing' stamp: ''!
containedBy: anInterval 
	^anInterval first <= self startWithoutParentheses 
		and: [anInterval last >= self stopWithoutParentheses]! !

!RBValueNode methodsFor: 'accessing' stamp: ''!
startWithoutParentheses
	^self subclassResponsibility! !

RBValueNode subclass: #RBBlockNode
	instanceVariableNames: 'left right colons body arguments bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

!RBBlockNode methodsFor: 'testing' stamp: ''!
isBlock
	^true! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
body: stmtsNode 
	body := stmtsNode.
	body parent: self! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
left
	^left! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
right
	^right! !

RBBlockNode subclass: #RBPatternBlockNode
	instanceVariableNames: 'valueBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-ParseTree Matching'!

!RBPatternBlockNode methodsFor: 'accessing' stamp: ''!
sentMessages
	^OrderedCollection new! !

!RBPatternBlockNode methodsFor: 'matching' stamp: ''!
createMatchingBlock
	self arguments size > 2 
		ifTrue: 
			[self 
				error: 'Search blocks can only contain arguments for the node and matching dictionary'].
	self arguments size == 0 
		ifTrue: [self error: 'Search blocks must contain one argument for the node'].
	self arguments size = 1 
		ifTrue: [self addArgumentWithNameBasedOn: 'aDictionary'].
	^self createBlock! !

!RBPatternBlockNode methodsFor: 'matching' stamp: ''!
matchingBlock
	^valueBlock isNil 
		ifTrue: [valueBlock := self createMatchingBlock]
		ifFalse: [valueBlock]! !

!RBPatternBlockNode methodsFor: 'matching' stamp: ''!
createBlock
	| source |
	source := self formattedCode.
	^Compiler evaluate: source! !

!RBPatternBlockNode methodsFor: 'matching' stamp: ''!
copyInContext: aDictionary 
	^self replacingBlock value: aDictionary! !

!RBPatternBlockNode methodsFor: 'matching' stamp: ''!
replacingBlock
	^valueBlock isNil 
		ifTrue: [valueBlock := self createReplacingBlock]
		ifFalse: [valueBlock]! !

!RBPatternBlockNode methodsFor: 'matching' stamp: ''!
createReplacingBlock
	self arguments size > 1 
		ifTrue: 
			[self 
				error: 'Replace blocks can only contain an argument for the matching dictionary'].
	self arguments size = 0 
		ifTrue: [self addArgumentWithNameBasedOn: 'aDictionary'].
	^self createBlock! !

!RBPatternBlockNode methodsFor: 'matching' stamp: ''!
addArgumentWithNameBasedOn: aString 
	| name index vars |
	name := aString.
	vars := self allDefinedVariables.
	index := 0.
	[vars includes: name] whileTrue: 
			[index := index + 1.
			name := name , index printString].
	arguments := arguments copyWith: (RBVariableNode named: name)! !

!RBPatternBlockNode methodsFor: 'matching' stamp: ''!
match: aNode inContext: aDictionary 
	^self matchingBlock value: aNode value: aDictionary! !

!RBBlockNode methodsFor: 'comparing' stamp: ''!
hash
	^self arguments hash bitXor: self body hash! !

!RBBlockNode methodsFor: 'testing' stamp: ''!
isImmediate
	^true! !

!RBBlockNode methodsFor: 'replacing' stamp: ''!
replaceNode: aNode withNode: anotherNode 
	body == aNode ifTrue: [self body: anotherNode].
	self arguments: (arguments 
				collect: [:each | each == aNode ifTrue: [anotherNode] ifFalse: [each]])! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
allDefinedVariables
	^(self argumentNames asOrderedCollection) addAll: super allDefinedVariables;
		yourself! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
argumentNames
	^self arguments collect: [:each | each name]! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
right: anObject
	right := anObject! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
blockVariables
	| vars |
	vars := super blockVariables asOrderedCollection.
	vars addAll: self argumentNames.
	^vars! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
startWithoutParentheses
	^left! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
arguments: argCollection 
	arguments := argCollection.
	arguments do: [:each | each parent: self]! !

!RBBlockNode methodsFor: 'comparing' stamp: ''!
equalTo: anObject withMapping: aDictionary 
	self class = anObject class ifFalse: [^false].
	self arguments size = anObject arguments size ifFalse: [^false].
	1 to: self arguments size
		do: 
			[:i | 
			((self arguments at: i) equalTo: (anObject arguments at: i)
				withMapping: aDictionary) ifFalse: [^false]].
	(self body equalTo: anObject body withMapping: aDictionary)
		ifFalse: [^false].
	self arguments do: [:each | aDictionary removeKey: each name].
	^true! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
arguments
	^arguments! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
bar: anObject
	bar := anObject! !

!RBBlockNode methodsFor: 'matching' stamp: ''!
match: aNode inContext: aDictionary 
	aNode class == self class ifFalse: [^false].
	^(self matchList: arguments
		against: aNode arguments
		inContext: aDictionary)
			and: [body match: aNode body inContext: aDictionary]! !

!RBBlockNode methodsFor: 'testing' stamp: ''!
references: aVariableName 
	^body references: aVariableName! !

!RBBlockNode methodsFor: 'comparing' stamp: ''!
= anObject 
	self == anObject ifTrue: [^true].
	self class = anObject class ifFalse: [^false].
	self body = anObject body ifFalse: [^false].
	self arguments size = anObject arguments size ifFalse: [^false].
	1 to: self arguments size
		do: [:i | (self arguments at: i) = (anObject arguments at: i) ifFalse: [^false]].
	^true! !

!RBBlockNode methodsFor: 'matching' stamp: ''!
copyInContext: aDictionary 
	^(self class new)
		arguments: (self copyList: arguments inContext: aDictionary);
		body: (body copyInContext: aDictionary);
		yourself! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
body
	^body! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
left: anObject
	left := anObject! !

!RBBlockNode methodsFor: 'testing' stamp: ''!
defines: aName 
	^(arguments detect: [:each | each name = aName] ifNone: [nil]) notNil! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
stopWithoutParentheses
	^right! !

!RBBlockNode methodsFor: 'testing' stamp: ''!
directlyUses: aNode 
	^false! !

!RBBlockNode methodsFor: 'testing' stamp: ''!
isLast: aNode 
	^body isLast: aNode! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
colons: anObject
	colons := anObject! !

!RBBlockNode methodsFor: 'testing' stamp: ''!
uses: aNode 
	aNode = body ifFalse: [^false].
	^parent isMessage
		ifTrue: [(#(#ifTrue:ifFalse: #ifTrue: #ifFalse: #ifFalse:ifTrue:) includes: parent selector) not or: [parent isUsed]]
		ifFalse: [self isUsed]! !

!RBBlockNode class methodsFor: 'instance creation' stamp: ''!
body: sequenceNode 
	^self arguments: #() body: sequenceNode! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
allArgumentVariables
	^(self argumentNames asOrderedCollection)
		addAll: super allArgumentVariables;
		yourself! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
bar
	^bar! !

!RBBlockNode methodsFor: 'copying' stamp: ''!
postCopy
	super postCopy.
	arguments := arguments collect: [:each | each copy].
	body := body copy! !

!RBBlockNode class methodsFor: 'instance creation' stamp: ''!
arguments: argNodes body: sequenceNode 
	^(self new)
		arguments: argNodes;
		body: sequenceNode;
		yourself! !

!RBBlockNode methodsFor: 'visitor' stamp: ''!
acceptVisitor: aProgramNodeVisitor 
	^aProgramNodeVisitor acceptBlockNode: self! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
precedence
	^0! !

!RBBlockNode methodsFor: 'accessing' stamp: ''!
children
	^self arguments copyWith: self body! !

!RBValueNode methodsFor: 'accessing' stamp: ''!
stop
	^parentheses isNil
		ifTrue: [self stopWithoutParentheses]
		ifFalse: [parentheses last last]! !

!RBValueNode methodsFor: 'testing' stamp: ''!
isValue
	^true! !

!RBValueNode methodsFor: 'accessing' stamp: ''!
addParenthesis: anInterval 
	parentheses isNil ifTrue: [parentheses := OrderedCollection new: 1].
	parentheses add: anInterval! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
isEvaluatedFirst
	"Return true if we are the first thing evaluated in this statement."

	^parent isNil or: [parent isSequence or: [parent evaluatedFirst: self]]! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
intersectsInterval: anInterval 
	^(anInterval first between: self start and: self stop) 
		or: [self start between: anInterval first and: anInterval last]! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
start
	self subclassResponsibility! !

!RBProgramNode methodsFor: 'replacing' stamp: ''!
replaceWith: aNode 
	parent isNil ifTrue: [self error: 'This node doesn''t have a parent'].
	parent replaceNode: self withNode: aNode! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
stop
	self subclassResponsibility! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
uses: aNode
	^true! !

!RBProgramNode methodsFor: 'matching' stamp: ''!
copyList: matchNodes inContext: aDictionary 
	| newNodes |
	newNodes := OrderedCollection new.
	matchNodes do: 
			[:each | 
			| object |
			object := each copyInContext: aDictionary.
			newNodes addAll: object].
	^newNodes! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
assigns: aVariableName 
	^(self children detect: [:each | each assigns: aVariableName] ifNone: [nil]) 
		notNil! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
isCascade
	^false! !

!RBProgramNode methodsFor: 'matching' stamp: ''!
copyInContext: aDictionary
	^self copy! !

!RBProgramNode methodsFor: 'enumeration' stamp: ''!
do: aBlock 
	"Hacked to fit collection protocols"

	aBlock value: self! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
precedence
	^6! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
asReturn
	"Change the current node to a return node."

	parent isNil ifTrue: [self error: 'Cannot change to a return without a parent node.'].
	parent isSequence ifFalse: [self error: 'Parent node must be a sequence node.'].
	(parent isLast: self)
		ifFalse: [self error: 'Return node must be last.'].
	^parent addReturn! !

!RBProgramNode methodsFor: 'iterating' stamp: 'bh 3/13/2000 01:48'!
allChildren

	^self children inject:(OrderedCollection new addAll:self children; yourself) into:[:answer :child| answer addAll:child allChildren; yourself].! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
isMessage
	^false! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
defines: aName
	^false! !

!RBProgramNode methodsFor: 'meta variable-accessing' stamp: ''!
literalCharacter
	^$#! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
formattedCode
	^self formatterClass new format: self! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
isAssignment
	^false! !

!RBProgramNode methodsFor: 'replacing' stamp: ''!
replaceNode: aNode withNode: anotherNode 
	self error: 'I don''t store other nodes'! !

!RBProgramNode methodsFor: 'testing-matching' stamp: ''!
isList
	^false! !

!RBProgramNode methodsFor: 'comparing' stamp: ''!
equalTo: aNode withMapping: aDictionary 
	^self = aNode! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
isBlock
	^false! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
allArgumentVariables
	| children |
	children := self children.
	children isEmpty ifTrue: [^#()].
	^children inject: OrderedCollection new
		into: 
			[:vars :each | 
			vars
				addAll: each allArgumentVariables;
				yourself]! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
isReturn
	^false! !

RBProgramNode subclass: #RBReturnNode
	instanceVariableNames: 'return value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

!RBReturnNode methodsFor: 'matching' stamp: ''!
match: aNode inContext: aDictionary 
	aNode class == self class ifFalse: [^false].
	^value match: aNode value inContext: aDictionary! !

!RBReturnNode methodsFor: 'copying' stamp: ''!
postCopy
	super postCopy.
	value := value copy! !

!RBReturnNode methodsFor: 'replacing' stamp: ''!
replaceNode: aNode withNode: anotherNode 
	value == aNode ifTrue: [self value: anotherNode]! !

!RBReturnNode methodsFor: 'accessing' stamp: ''!
value: valueNode 
	value := valueNode.
	value parent: self! !

!RBReturnNode methodsFor: 'accessing' stamp: ''!
start
	^return! !

!RBReturnNode methodsFor: 'matching' stamp: ''!
copyInContext: aDictionary 
	^(self class new) value: (value copyInContext: aDictionary); yourself! !

!RBReturnNode methodsFor: 'visitor' stamp: ''!
acceptVisitor: aProgramNodeVisitor 
	^aProgramNodeVisitor acceptReturnNode: self! !

!RBReturnNode methodsFor: 'comparing' stamp: ''!
hash
	^self value hash! !

!RBReturnNode methodsFor: 'accessing' stamp: ''!
children
	^Array with: value! !

!RBReturnNode methodsFor: 'accessing' stamp: ''!
value
	^value! !

!RBReturnNode class methodsFor: 'instance creation' stamp: ''!
return: returnInteger value: aValueNode 
	^self new return: returnInteger value: aValueNode! !

!RBReturnNode methodsFor: 'comparing' stamp: ''!
= anObject 
	self == anObject ifTrue: [^true].
	self class = anObject class ifFalse: [^false].
	^self value = anObject value! !

!RBReturnNode methodsFor: 'testing' stamp: ''!
isReturn
	^true! !

!RBReturnNode class methodsFor: 'instance creation' stamp: ''!
value: aNode
	^self return: nil value: aNode! !

!RBReturnNode methodsFor: 'accessing' stamp: ''!
stop
	^value stop! !

!RBReturnNode methodsFor: 'testing' stamp: ''!
containsReturn
	^true! !

!RBReturnNode methodsFor: 'initialize-release' stamp: ''!
return: returnInteger value: aValueNode 
	return := returnInteger.
	self value: aValueNode! !

!RBReturnNode methodsFor: 'comparing' stamp: ''!
equalTo: anObject withMapping: aDictionary 
	self class = anObject class ifFalse: [^false].
	^self value equalTo: anObject value withMapping: aDictionary! !

!RBProgramNode methodsFor: 'meta variable-accessing' stamp: ''!
cascadeListCharacter
	^$;! !

!RBProgramNode methodsFor: 'copying' stamp: ''!
copyCommentsFrom: aNode 
	"Add all comments from aNode to us. If we already have the comment, then don't add it."

	| newComments |
	newComments := OrderedCollection new.
	aNode nodesDo: [:each | newComments addAll: each comments].
	self nodesDo: 
			[:each | 
			each comments do: [:comment | newComments remove: comment ifAbsent: []]].
	newComments isEmpty ifTrue: [^self].
	newComments := newComments asSortedCollection: [:a :b | a first < b first].
	self comments: newComments! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
temporaryVariables
	^parent isNil
		ifTrue: [#()]
		ifFalse: [parent temporaryVariables]! !

!RBProgramNode methodsFor: 'copying' stamp: ''!
copy
	"This is redefined for IBM Smalltalk which doesn't have postCopy."

	^self shallowCopy postCopy! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
isSequence
	^false! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
isDirectlyUsed
	"This node is directly used as an argument, receiver, or part of an assignment."

	^parent isNil
		ifTrue: [false]
		ifFalse: [parent directlyUses: self]! !

!RBProgramNode methodsFor: 'comparing' stamp: ''!
equalTo: aNode exceptForVariables: variableNameCollection 
	| dictionary |
	dictionary := Dictionary new.
	(self equalTo: aNode withMapping: dictionary) ifFalse: [^false].
	dictionary keysAndValuesDo: 
			[:key :value | 
			(key = value or: [variableNameCollection includes: key]) ifFalse: [^false]].
	^true! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
children
	^#()! !

!RBProgramNode methodsFor: 'matching' stamp: ''!
match: aNode inContext: aDictionary 
	^self = aNode! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
comments
	^comments isNil
		ifTrue: [#()]
		ifFalse: [comments]! !

!RBProgramNode methodsFor: 'meta variable-accessing' stamp: ''!
listCharacter
	^$@! !

!RBProgramNode methodsFor: '*refactory' stamp: ''!
selfMessages
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher matches: 'self `@msg: ``@args'
		do: 
			[:aNode :answer | 
			answer
				add: aNode selector;
				yourself].
	^searcher executeTree: self initialAnswer: Set new! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
isLast: aNode 
	| children |
	children := self children.
	^children isEmpty not and: [children last == aNode]! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
isVariable
	^false! !

!RBProgramNode methodsFor: 'meta variable-accessing' stamp: ''!
statementCharacter
	^$.! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
formatterClass
	^self class formatterClass! !

!RBProgramNode methodsFor: 'querying' stamp: ''!
whichNodeIsContainedBy: anInterval 
	| selectedChildren |
	(self intersectsInterval: anInterval) ifFalse: [^nil].
	(self containedBy: anInterval) ifTrue: [^self].
	selectedChildren := self children 
				select: [:each | each intersectsInterval: anInterval].
	^selectedChildren size == 1 
		ifTrue: [selectedChildren first whichNodeIsContainedBy: anInterval]
		ifFalse: [nil]! !

!RBProgramNode methodsFor: 'matching' stamp: ''!
matchList: matchNodes index: matchIndex against: programNodes index: programIndex inContext: aDictionary 
	| node currentIndex currentDictionary nodes |
	matchNodes size < matchIndex ifTrue: [^programNodes size < programIndex].
	node := matchNodes at: matchIndex.
	node isList 
		ifTrue: 
			[currentIndex := programIndex - 1.
			
			[currentDictionary := aDictionary copy.
			programNodes size < currentIndex or: 
					[nodes := programNodes copyFrom: programIndex to: currentIndex.
					(currentDictionary at: node ifAbsentPut: [nodes]) = nodes and: 
							[(self 
								matchList: matchNodes
								index: matchIndex + 1
								against: programNodes
								index: currentIndex + 1
								inContext: currentDictionary) 
									ifTrue: 
										[currentDictionary keysAndValuesDo: [:key :value | aDictionary at: key put: value].
										^true].
							false]]] 
					whileFalse: [currentIndex := currentIndex + 1].
			^false].
	programNodes size < programIndex ifTrue: [^false].
	(node match: (programNodes at: programIndex) inContext: aDictionary) 
		ifFalse: [^false].
	^self 
		matchList: matchNodes
		index: matchIndex + 1
		against: programNodes
		index: programIndex + 1
		inContext: aDictionary! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
source
	^parent notNil ifTrue: [parent source] ifFalse: [nil]! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
isValue
	^false! !

!RBProgramNode methodsFor: 'querying' stamp: ''!
statementNode
	"Return your topmost node that is contained by a sequence node."

	(parent isNil or: [parent isSequence]) ifTrue: [^self].
	^parent statementNode! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
isMethod
	^false! !

!RBProgramNode methodsFor: 'testing' stamp: ''!
references: aVariableName 
	^(self children detect: [:each | each references: aVariableName]
		ifNone: [nil]) notNil! !

RBProgramNode subclass: #RBSequenceNode
	instanceVariableNames: 'leftBar rightBar statements periods temporaries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

!RBSequenceNode methodsFor: 'querying' stamp: ''!
whichNodeIsContainedBy: anInterval 
	| node |
	node := super whichNodeIsContainedBy: anInterval.
	node == self 
		ifTrue: 
			[(temporaries isEmpty and: [statements size == 1]) 
				ifTrue: [^statements first]].
	^node! !

!RBSequenceNode methodsFor: 'matching' stamp: ''!
match: aNode inContext: aDictionary 
	self class == aNode class ifFalse: [^false].
	^(self matchList: temporaries
		against: aNode temporaries
		inContext: aDictionary) and: 
				[self matchList: statements
					against: aNode statements
					inContext: aDictionary]! !

!RBSequenceNode methodsFor: 'replacing' stamp: ''!
replaceNode: aNode withNodes: aCollection 
	| index newStatements |
	index := self indexOfNode: aNode.
	newStatements := OrderedCollection new: statements size + aCollection size.
	1 to: index - 1 do: [:i | newStatements add: (statements at: i)].
	newStatements addAll: aCollection.
	index + 1 to: statements size
		do: [:i | newStatements add: (statements at: i)].
	aCollection do: [:each | each parent: self].
	statements := newStatements! !

!RBSequenceNode methodsFor: 'comparing' stamp: ''!
= anObject 
	"Can't send = to the temporaries and statements collection since they might change from arrays to OCs"

	self == anObject ifTrue: [^true].
	self class = anObject class ifFalse: [^false].
	self temporaries size = anObject temporaries size ifFalse: [^false].
	1 to: self temporaries size
		do: 
			[:i | 
			(self temporaries at: i) = (anObject temporaries at: i) ifFalse: [^false]].
	self statements size = anObject statements size ifFalse: [^false].
	1 to: self statements size
		do: [:i | (self statements at: i) = (anObject statements at: i) ifFalse: [^false]].
	^true! !

!RBSequenceNode class methodsFor: 'instance creation' stamp: ''!
leftBar: leftInteger temporaries: variableNodes rightBar: rightInteger 
	^self new
		leftBar: leftInteger
		temporaries: variableNodes
		rightBar: rightInteger! !

!RBSequenceNode methodsFor: 'adding nodes' stamp: ''!
addTemporariesNamed: aCollection 
	aCollection do: [:each | self addTemporaryNamed: each]! !

!RBSequenceNode methodsFor: 'adding nodes' stamp: ''!
addNode: aNode before: anotherNode 
	| index |
	index := self indexOfNode: anotherNode.
	index = 0 ifTrue: [^self addNode: aNode].
	statements := (statements asOrderedCollection)
				add: aNode beforeIndex: index;
				yourself.
	aNode parent: self! !

!RBSequenceNode methodsFor: 'accessing' stamp: ''!
start
	^leftBar isNil 
		ifTrue: [statements isEmpty ifTrue: [1] ifFalse: [statements first start]]
		ifFalse: [leftBar]! !

!RBSequenceNode methodsFor: 'testing' stamp: ''!
isLast: aNode 
	| last |
	statements isEmpty ifTrue: [^false].
	last := statements last.
	^last == aNode or: [last isMessage and: [(#(#ifTrue:ifFalse: #ifFalse:ifTrue:) includes: last selector)
				and: [last arguments inject: false into: [:bool :each | bool or: [each isLast: aNode]]]]]! !

!RBSequenceNode methodsFor: 'matching' stamp: ''!
copyInContext: aDictionary 
	^(self class new)
		temporaries: (self copyList: temporaries inContext: aDictionary);
		statements: (self copyList: statements inContext: aDictionary);
		yourself! !

!RBSequenceNode methodsFor: 'replacing' stamp: ''!
removeDeadCode
	(self isUsed ifTrue: [statements size - 1] ifFalse: [statements size]) 
		to: 1
		by: -1
		do: [:i | (statements at: i) isImmediate ifTrue: [statements removeAtIndex: i]].
	super removeDeadCode! !

!RBSequenceNode methodsFor: 'accessing' stamp: ''!
removeTemporaryNamed: aName 
	temporaries := temporaries reject: [:each | each name = aName]! !

!RBSequenceNode methodsFor: 'accessing' stamp: ''!
children
	^(OrderedCollection new) addAll: self temporaries;
		addAll: self statements;
		yourself! !

!RBSequenceNode methodsFor: 'testing' stamp: ''!
references: aVariableName 
	^(statements detect: [:each | each references: aVariableName] ifNone: [nil]) 
		notNil! !

!RBSequenceNode methodsFor: 'replacing' stamp: ''!
replaceNode: aNode withNode: anotherNode 
	self statements: (statements 
				collect: [:each | each == aNode ifTrue: [anotherNode] ifFalse: [each]]).
	self temporaries: (temporaries 
				collect: [:each | each == aNode ifTrue: [anotherNode] ifFalse: [each]])! !

!RBSequenceNode methodsFor: 'testing' stamp: ''!
lastIsReturn
	^statements isEmpty not and: [statements last lastIsReturn]! !

!RBSequenceNode methodsFor: 'adding nodes' stamp: ''!
addNode: aNode 
	aNode parent: self.
	(statements isEmpty not and: [statements last isReturn])
		ifTrue: [self error: 'Cannot add statement after return node'].
	statements := statements asOrderedCollection add: aNode; yourself! !

!RBSequenceNode methodsFor: 'adding nodes' stamp: ''!
addSelfReturn
	| node |
	self lastIsReturn ifTrue: [^self].
	node := RBReturnNode value: (RBVariableNode named: 'self').
	self addNode: node! !

!RBSequenceNode methodsFor: 'adding nodes' stamp: ''!
addNodes: aCollection before: anotherNode 
	aCollection do: [:each | self addNode: each before: anotherNode]! !

!RBSequenceNode methodsFor: 'accessing' stamp: ''!
temporaryVariables
	^(super temporaryVariables asOrderedCollection) addAll: self temporaryNames;
		yourself! !

!RBSequenceNode methodsFor: 'initialize-release' stamp: ''!
leftBar: leftInteger temporaries: variableNodes rightBar: rightInteger 
	leftBar := leftInteger.
	self temporaries: variableNodes.
	rightBar := rightInteger! !

!RBSequenceNode methodsFor: 'testing' stamp: ''!
defines: aName 
	^(temporaries detect: [:each | each name = aName] ifNone: [nil]) notNil! !

!RBSequenceNode methodsFor: 'accessing' stamp: ''!
allTemporaryVariables
	^(self temporaryNames asOrderedCollection)
		addAll: super allTemporaryVariables;
		yourself! !

!RBSequenceNode methodsFor: 'accessing' stamp: ''!
periods: anObject
	periods := anObject! !

!RBSequenceNode methodsFor: 'adding nodes' stamp: ''!
addTemporaryNamed: aString 
	| variableNode |
	variableNode := RBVariableNode named: aString.
	variableNode parent: self.
	temporaries := temporaries copyWith: variableNode! !

!RBSequenceNode methodsFor: 'private' stamp: ''!
indexOfNode: aNode 
	"Try to find the node by first looking for ==, and then for ="

	^(1 to: statements size) detect: [:each | (statements at: each) == aNode]
		ifNone: [statements indexOf: aNode]! !

!RBSequenceNode methodsFor: 'accessing' stamp: ''!
statements: stmtCollection 
	statements := stmtCollection.
	statements do: [:each | each parent: self]! !

!RBSequenceNode methodsFor: 'comparing' stamp: ''!
hash
	^self temporaries hash bitXor: (self statements isEmpty
			ifTrue: [0]
			ifFalse: [self statements first hash])! !

!RBSequenceNode methodsFor: 'accessing' stamp: ''!
stop
	^(periods isEmpty
		ifTrue: [0]
		ifFalse: [periods last])
		max: (statements isEmpty
				ifTrue: [0]
				ifFalse: [statements last stop])! !

!RBSequenceNode methodsFor: 'visitor' stamp: ''!
acceptVisitor: aProgramNodeVisitor 
	^aProgramNodeVisitor acceptSequenceNode: self! !

!RBSequenceNode methodsFor: 'accessing' stamp: ''!
addReturn
	| node |
	statements isEmpty ifTrue: [^nil].
	statements last isReturn ifTrue: [^statements last].
	node := RBReturnNode value: statements last.
	statements at: statements size put: node.
	node parent: self.
	^node! !

!RBSequenceNode methodsFor: 'testing' stamp: ''!
uses: aNode 
	statements isEmpty ifTrue: [^false].
	aNode == statements last ifFalse: [^false].
	^self isUsed! !

!RBSequenceNode methodsFor: 'adding nodes' stamp: ''!
addNodesFirst: aCollection 
	aCollection do: [:each | each parent: self].
	statements := (statements asOrderedCollection)
				addAllFirst: aCollection;
				yourself! !

!RBSequenceNode methodsFor: 'accessing' stamp: ''!
temporaryNames
	^temporaries collect: [:each | each name]! !

!RBSequenceNode methodsFor: 'replacing' stamp: ''!
removeNode: aNode
	self replaceNode: aNode withNodes: #()! !

!RBSequenceNode methodsFor: 'accessing' stamp: ''!
temporaries
	^temporaries! !

!RBSequenceNode methodsFor: 'testing' stamp: ''!
isSequence
	^true! !

!RBSequenceNode methodsFor: 'querying' stamp: ''!
bestNodeFor: anInterval 
	| node |
	node := super bestNodeFor: anInterval.
	node == self 
		ifTrue: 
			[(temporaries isEmpty and: [statements size == 1]) 
				ifTrue: [^statements first]].
	^node! !

!RBSequenceNode methodsFor: 'copying' stamp: ''!
postCopy
	super postCopy.
	temporaries := temporaries collect: [:each | each copy].
	statements := statements collect: [:each | each copy]! !

!RBSequenceNode class methodsFor: 'instance creation' stamp: ''!
temporaries: variableNodes statements: statementNodes 
	^(self new)
		temporaries: variableNodes;
		statements: statementNodes;
		yourself! !

!RBSequenceNode class methodsFor: 'instance creation' stamp: ''!
statements: statementNodes 
	^self temporaries: #() statements: statementNodes! !

!RBSequenceNode methodsFor: 'accessing' stamp: ''!
temporaries: tempCollection 
	temporaries := tempCollection.
	temporaries do: [:each | each parent: self]! !

!RBSequenceNode methodsFor: 'testing' stamp: ''!
directlyUses: aNode 
	^false! !

!RBSequenceNode methodsFor: 'adding nodes' stamp: ''!
addNodeFirst: aNode 
	aNode parent: self.
	statements := (statements asOrderedCollection)
				addFirst: aNode;
				yourself! !

!RBSequenceNode methodsFor: 'comparing' stamp: ''!
equalTo: anObject withMapping: aDictionary 
	self class = anObject class ifFalse: [^false].
	self statements size == anObject statements size ifFalse: [^false].
	1 to: self statements size
		do: 
			[:i | 
			((self statements at: i) equalTo: (anObject statements at: i)
				withMapping: aDictionary) ifFalse: [^false]].
	aDictionary values asSet size = aDictionary size ifFalse: [^false].	"Not a one-to-one mapping"
	self temporaries
		do: [:each | aDictionary removeKey: each name ifAbsent: []].
	^true! !

!RBSequenceNode methodsFor: 'accessing' stamp: ''!
statements
	^statements! !

!RBSequenceNode methodsFor: 'adding nodes' stamp: ''!
addNodes: aCollection 
	aCollection do: [:each | each parent: self].
	(statements isEmpty not and: [statements last isReturn]) 
		ifTrue: [self error: 'Cannot add statement after return node'].
	statements := (statements asOrderedCollection)
				addAll: aCollection;
				yourself! !

!RBSequenceNode methodsFor: 'accessing' stamp: ''!
allDefinedVariables
	^(self temporaryNames asOrderedCollection) addAll: super allDefinedVariables;
		yourself! !

!RBProgramNode methodsFor: 'visitor' stamp: 'rr 4/10/2004 16:54'!
acceptVisitor: aProgramNodeVisitor 
	"self subclassResponsibility"! !

!RBProgramNode methodsFor: 'testing-matching' stamp: ''!
recurseInto
	^false! !

RBProgramNode subclass: #RBMethodNode
	instanceVariableNames: 'selector selectorParts body source arguments tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

!RBMethodNode methodsFor: 'accessing' stamp: ''!
children
	^self arguments copyWith: self body! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
body: stmtsNode 
	body := stmtsNode.
	body parent: self! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
allArgumentVariables
	^(self argumentNames asOrderedCollection)
		addAll: super allArgumentVariables;
		yourself! !

!RBMethodNode methodsFor: 'testing' stamp: ''!
uses: aNode 
	^body == aNode and: [aNode lastIsReturn]! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
tags: aCollectionOfIntervals 
	tags := aCollectionOfIntervals! !

!RBMethodNode methodsFor: 'testing' stamp: ''!
isLast: aNode 
	^body isLast: aNode! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
addNode: aNode 
	^body addNode: aNode! !

!RBMethodNode class methodsFor: 'instance creation' stamp: ''!
selectorParts: tokenCollection arguments: variableNodes 
	^((tokenCollection detect: [:each | each isPatternVariable] ifNone: [nil]) 
		notNil ifTrue: [RBPatternMethodNode] ifFalse: [RBMethodNode]) 
		new selectorParts: tokenCollection arguments: variableNodes! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
selector: aSelector 
	| keywords numArgs |
	keywords := aSelector keywords.
	numArgs := aSelector numArgs.
	numArgs == arguments size 
		ifFalse: 
			[self 
				error: 'Attempting to assign selector with wrong number of arguments.'].
	selectorParts := numArgs == 0 
				ifTrue: [Array with: (RBIdentifierToken value: keywords first start: nil)]
				ifFalse: 
					[keywords first last == $: 
						ifTrue: [keywords collect: [:each | RBKeywordToken value: each start: nil]]
						ifFalse: [Array with: (RBBinarySelectorToken value: aSelector start: nil)]].
	selector := aSelector! !

!RBMethodNode methodsFor: 'visitor' stamp: ''!
acceptVisitor: aProgramNodeVisitor 
	^aProgramNodeVisitor acceptMethodNode: self! !

!RBMethodNode methodsFor: 'testing' stamp: ''!
isPrimitive
	^tags notNil and: 
			[tags isEmpty not and: 
					[(self primitiveSources detect: [:each | '*primitive*' match: each]
						ifNone: [nil]) notNil]]! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
stop
	^source size! !

!RBMethodNode methodsFor: 'testing' stamp: ''!
isMethod
	^true! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
selector
	^selector isNil
		ifTrue: [selector := self buildSelector]
		ifFalse: [selector]! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
tags
	^tags isNil ifTrue: [#()] ifFalse: [tags]! !

!RBMethodNode methodsFor: 'printing' stamp: ''!
printOn: aStream
	aStream nextPutAll: self formattedCode! !

!RBMethodNode methodsFor: 'testing' stamp: ''!
lastIsReturn
	^body lastIsReturn! !

!RBMethodNode class methodsFor: 'instance creation' stamp: ''!
selector: aSymbol arguments: variableNodes body: aSequenceNode 
	^(self new)
		arguments: variableNodes;
		selector: aSymbol;
		body: aSequenceNode;
		yourself! !

!RBMethodNode class methodsFor: 'instance creation' stamp: ''!
selector: aSymbol body: aSequenceNode 
	^self 
		selector: aSymbol
		arguments: #()
		body: aSequenceNode! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
start
	^1! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
body
	^body! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
source
	^source! !

!RBMethodNode methodsFor: 'matching' stamp: ''!
match: aNode inContext: aDictionary 
	self class == aNode class ifFalse: [^false].
	aDictionary at: '-source-' put: aNode source.
	self selector == aNode selector ifFalse: [^false].
	^(self matchList: arguments
		against: aNode arguments
		inContext: aDictionary)
			and: [body match: aNode body inContext: aDictionary]! !

!RBMethodNode methodsFor: 'private' stamp: ''!
selectorParts: tokenCollection 
	selectorParts := tokenCollection! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
primitiveSources
	^self tags 
		collect: [:each | self source copyFrom: each first to: each last]! !

!RBMethodNode methodsFor: 'comparing' stamp: ''!
hash
	^(self selector hash bitXor: self body hash)
		bitXor: self arguments hash! !

!RBMethodNode methodsFor: 'comparing' stamp: ''!
= anObject 
	self == anObject ifTrue: [^true].
	self class = anObject class ifFalse: [^false].
	(self selector = anObject selector and: [self body = anObject body]) 
		ifFalse: [^false].
	1 to: self arguments size
		do: [:i | (self arguments at: i) = (anObject arguments at: i) ifFalse: [^false]].
	^true! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
source: anObject
	source := anObject! !

!RBMethodNode methodsFor: 'private' stamp: ''!
selectorParts
	^selectorParts! !

!RBMethodNode methodsFor: 'replacing' stamp: ''!
replaceNode: aNode withNode: anotherNode 
	aNode == body ifTrue: [self body: anotherNode].
	self arguments: (arguments 
				collect: [:each | each == aNode ifTrue: [anotherNode] ifFalse: [each]])! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
addSelfReturn
	^body addSelfReturn! !

!RBMethodNode methodsFor: 'testing' stamp: ''!
references: aVariableName 
	^body references: aVariableName! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
arguments: variableNodes 
	arguments := variableNodes.
	arguments do: [:each | each parent: self]! !

!RBMethodNode methodsFor: 'comparing' stamp: ''!
equalTo: anObject withMapping: aDictionary 
	self class = anObject class ifFalse: [^false].
	(self selector = anObject selector 
		and: [self body equalTo: anObject body withMapping: aDictionary]) 
			ifFalse: [^false].
	1 to: self arguments size
		do: 
			[:i | 
			((self arguments at: i) equalTo: (anObject arguments at: i)
				withMapping: aDictionary) ifFalse: [^false].
			aDictionary removeKey: (self arguments at: i) name].
	^self primitiveSources = anObject primitiveSources! !

RBMethodNode subclass: #RBPatternMethodNode
	instanceVariableNames: 'isList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Nodes'!

!RBPatternMethodNode methodsFor: 'matching' stamp: ''!
matchArgumentsAgainst: aNode inContext: aDictionary 
	self arguments size == aNode arguments size ifFalse: [^false].
	(self matchSelectorAgainst: aNode inContext: aDictionary) 
		ifFalse: [^false].
	1 to: arguments size
		do: 
			[:i | 
			((arguments at: i) match: (aNode arguments at: i) inContext: aDictionary) 
				ifFalse: [^false]].
	^true! !

!RBPatternMethodNode methodsFor: 'matching' stamp: ''!
match: aNode inContext: aDictionary 
	aNode class == self matchingClass ifFalse: [^false].
	aDictionary at: '-source-' put: aNode source.
	self isSelectorList ifTrue: 
			[^(aDictionary at: selectorParts first value ifAbsentPut: [aNode selector])
				= aNode selector and: 
						[(aDictionary at: arguments first ifAbsentPut: [aNode arguments])
							= aNode arguments and: [body match: aNode body inContext: aDictionary]]].
	^(self matchArgumentsAgainst: aNode inContext: aDictionary)
		and: [body match: aNode body inContext: aDictionary]! !

!RBPatternMethodNode methodsFor: 'testing' stamp: ''!
isSelectorList
	^isList! !

!RBPatternMethodNode methodsFor: 'matching' stamp: ''!
copyInContext: aDictionary 
	| selectors |
	selectors := self isSelectorList 
				ifTrue: [(aDictionary at: selectorParts first value) keywords]
				ifFalse: [selectorParts collect: [:each | aDictionary at: each value]].
	^(RBMethodNode new)
		selectorParts: (selectors collect: 
						[:each | 
						(each last == $: ifTrue: [RBKeywordToken] ifFalse: [RBIdentifierToken]) 
							value: each
							start: nil]);
		arguments: (self copyList: arguments inContext: aDictionary);
		body: (body copyInContext: aDictionary);
		source: (aDictionary at: '-source-');
		yourself! !

!RBPatternMethodNode methodsFor: 'testing-matching' stamp: ''!
isPatternNode
	^true! !

!RBPatternMethodNode methodsFor: 'matching' stamp: ''!
matchSelectorAgainst: aNode inContext: aDictionary 
	| keyword |
	1 to: selectorParts size
		do: 
			[:i | 
			keyword := selectorParts at: i.
			(aDictionary at: keyword value
				ifAbsentPut: 
					[keyword isPatternVariable 
						ifTrue: [(aNode selectorParts at: i) value]
						ifFalse: [keyword value]]) 
					= (aNode selectorParts at: i) value ifFalse: [^false]].
	^true! !

!RBPatternMethodNode methodsFor: 'private' stamp: ''!
matchingClass
	^RBMethodNode! !

!RBPatternMethodNode methodsFor: 'initialize-release' stamp: ''!
selectorParts: tokenCollection arguments: variableNodes 
	super selectorParts: tokenCollection arguments: variableNodes.
	isList := (tokenCollection first value at: 2) == self listCharacter! !

!RBMethodNode methodsFor: 'matching' stamp: ''!
copyInContext: aDictionary 
	^(self class new)
		selectorParts: (selectorParts collect: [:each | each removePositions]);
		arguments: (arguments collect: [:each | each copyInContext: aDictionary]);
		body: (body copyInContext: aDictionary);
		source: (aDictionary at: '-source-');
		yourself! !

!RBMethodNode methodsFor: 'initialize-release' stamp: ''!
selectorParts: tokenCollection arguments: variableNodes 
	selectorParts := tokenCollection.
	self arguments: variableNodes! !

!RBMethodNode methodsFor: 'private' stamp: ''!
buildSelector
	| selectorStream |
	selectorStream := WriteStream on: (String new: 50).
	selectorParts do: [:each | selectorStream nextPutAll: each value].
	^selectorStream contents asSymbol! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
allDefinedVariables
	^(self argumentNames asOrderedCollection) addAll: super allDefinedVariables;
		yourself! !

!RBMethodNode methodsFor: 'copying' stamp: ''!
postCopy
	super postCopy.
	body := body copy.
	arguments := arguments collect: [:each | each copy]! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
addReturn
	body addReturn! !

!RBMethodNode methodsFor: 'testing' stamp: ''!
defines: aName 
	^(arguments detect: [:each | each name = aName] ifNone: [nil]) notNil! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
arguments
	^arguments! !

!RBMethodNode methodsFor: 'accessing' stamp: ''!
argumentNames
	^self arguments collect: [:each | each name]! !

!RBProgramNode methodsFor: 'accessing' stamp: ''!
allTemporaryVariables
	| children |
	children := self children.
	children isEmpty ifTrue: [^#()].
	^children inject: OrderedCollection new
		into: 
			[:vars :each | 
			vars
				addAll: each allTemporaryVariables;
				yourself]! !

!RBProgramNode class methodsFor: 'accessing' stamp: ''!
formatterClass: aClass 
	FormatterClass := aClass! !

!RBProgramNode methodsFor: 'enumeration' stamp: ''!
size
	"Hacked to fit collection protocols"

	^1! !

!RBProgramNode methodsFor: 'iterating' stamp: ''!
nodesDo: aBlock 
	aBlock value: self.
	self children do: [:each | each nodesDo: aBlock]! !

Object subclass: #FinderTool
	instanceVariableNames: 'searchString conditionString searchEnvironment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-UserInterface'!

!FinderTool commentStamp: 'nk 9/17/2003 14:32' prior: 0!
This tool searches for code matching the pattern in the first pane.

The pattern (top) pane

To match unknown code, use "Jokers" (explained below) that start with a ` , like the `@Expression in the example.

That Joker will match any expression: 3 halt and (3 + 4) halt both match.

The condition (second) pane

Beyond the pattern match in the top pane, the expression found is also checked against a test condition in the second pane. Within that condition, aNode is set to each node that matches the pattern. If that pane is empty, the default pattern is true which is equivalent to this test block:

[:aNode | true]

Edit the second pane to make the test block more selective.
See below for a quick reference to the node accessors and some tests.
Browse RBProgramNode and subclasses to see what other tests they support.

Joker reference

All of the wild-card patterns used in the FinderTool start with a ` character.
The following characters may be:

#	(literal)

Matches only literal objects.

	`#literal				matches any literal (#(), #foo, 1, etc.)

@		(list)

When applied to a variable node, this will match a literal, variable, or a sequence of messages sent to a literal or variable.

When applied to a keyword in a message, it will match a list of keyword messages (i.e., any message send).

When applied with a statement character, it will match a list of statements.

	| `@Temps |				matches list of temps
	`@.Statements			matches list of statements
	`@object					matches any message node, literal node or block node
	foo `@message: `@args	matches any message sent to foo

.	(statement)

Matches a statement in a sequence node.

	`.Statement				matches a single statement
	`@.Statements			matches list of statements

`		(recurse into)

Whenever a match is found, look inside this matched node for more matches.

	``@object foo				matches foo sent to any object, plus for each match found look for more matches in the ``@object part

For more information on Joker, aka meta-variables, see this page on the rewrite rule editor, with whom this tool shares much logic. http://st-www.cs.uiuc.edu/users/brant/Refactory/Rewrite.html

Test condition quick reference
Browse RBProgramNode and subclasses to see what other tests the nodes support.

accessors:
allArgumentVariables allDefinedVariables allTemporaryVariables asReturn blockVariables children comments comments: formattedCode formatterClass parent parent: precedence sentMessages source sourceInterval start stop temporaryVariables

tests:
isList isPatternNode assigns: containedBy: containsReturn defines: directlyUses: evaluatedFirst: intersectsInterval: isAssignment isBlock isCascade isDirectlyUsed isEvaluatedFirst isImmediate isLast: isLiteral isMessage isMethod isReturn isSequence isUsed isValue isVariable lastIsReturn references: uses:!

!FinderTool methodsFor: 'actions' stamp: 'dvf 9/27/2001 18:54'!
searchFor: pattern when: conditionalBlock 
	| newEnv |
	newEnv := SelectorEnvironment onEnvironment: BrowserEnvironment new.
	searchEnvironment classesAndSelectorsDo: 
			[:currentClass :currentSelector | 

			| methodTree |
			methodTree := currentClass parseTreeFor: currentSelector.
			methodTree ifNotNil: [
			(ParseTreeRewriter new 
				replace: pattern
				withValueFrom: 
					[:tree | 
					newEnv addClass: currentClass selector: currentSelector.
					tree]
				when: conditionalBlock) executeTree: methodTree]].
	^newEnv! !

!FinderTool methodsFor: 'as yet unclassified' stamp: 'nk 8/13/2003 16:22'!
searchString: aString
	searchString _ aString.
	self changed: #searchString.
	^true! !

!FinderTool methodsFor: 'accessing' stamp: 'dvf 9/22/2001 15:42'!
conditionString
	^conditionString! !

!FinderTool class methodsFor: 'as yet unclassified' stamp: 'dvf 9/29/2001 00:03'!
onClassCategory: aClassCategory

	^self new searchEnvironment: (BrowserEnvironment new forCategories: {aClassCategory}).! !

!FinderTool class methodsFor: 'as yet unclassified' stamp: 'dvf 8/27/2003 15:14'!
unload
	TheWorldMenu unregisterOpenCommandWithReceiver: self! !

!FinderTool class methodsFor: 'as yet unclassified' stamp: 'nk 9/17/2003 14:27'!
onPackageWithClassCategory: aClassCategory

	| pkg |
	pkg _ PackageInfo allPackages detect: [ :p | p includesSystemCategory: aClassCategory ]
		ifNone: [ self inform: 'no package for this category'. ^nil ].
	^self new searchEnvironment: (BrowserEnvironment new forPackage: pkg)! !

!FinderTool methodsFor: 'actions' stamp: 'nk 9/17/2003 14:29'!
openAsMorph
	"self new openAsMorph"
	| window searchStringPane conditionsPane |
	window := (SystemWindow labelled: 'Code finder') model: self.

	searchStringPane _ PluggableTextMorph 
				on: self
				text: #searchString
				accept: #searchString:
				readSelection: nil
				menu: nil.

	window addMorph: searchStringPane frame: (0 @ 0 corner: 1.0 @ 0.2).

	conditionsPane _ PluggableTextMorph 
				on: self
				text: #conditionString
				accept: #conditionString:
				readSelection: nil
				menu: nil.

	window addMorph: conditionsPane frame: (0 @ 0.2 corner: 1.0 @ 0.4).

	window addMorph: (PluggableTextMorph 
				on: self class
				text: #comment
				accept: nil
				readSelection: nil
				menu: nil)
 		frame: (0 @ 0.4 corner: 1 @ 0.9).
	window addMorph: ((PluggableButtonMorph on: self
		getState: nil
		action: #search)
		label: 'Search';
		onColor: Color white offColor: Color lightGray)
 		frame: (0 @ 0.9 corner: 1 @ 1).
	window
		center: Display center;
		extent: 100 @ 100.
	window openInWorld.
	^window! !

!FinderTool methodsFor: 'accessing' stamp: 'dvf 9/27/2001 18:40'!
searchEnvironment: anObject
	searchEnvironment := anObject! !

!FinderTool class methodsFor: 'as yet unclassified' stamp: 'dvf 9/28/2001 23:31'!
onClass: aClass

	^self new searchEnvironment: (BrowserEnvironment new forClasses: {aClass}).! !

!FinderTool methodsFor: 'testing' stamp: 'dvf 9/28/2001 23:34'!
searchEnabled
	^(RBParser parseRewriteExpression: searchString) notNil! !

!FinderTool class methodsFor: 'as yet unclassified' stamp: 'dvf 8/27/2003 14:50'!
open
	self new openAsMorph! !

!FinderTool class methodsFor: 'as yet unclassified' stamp: 'dvf 8/27/2003 14:50'!
initialize
	TheWorldMenu registerOpenCommand: {'Code finder'. {self. #open}}! !

!FinderTool methodsFor: 'initialization' stamp: 'dvf 9/29/2001 00:03'!
initialize
	searchString _ '`@Expression halt'.
	conditionString _ 'aNode isImmediate not'.
	searchEnvironment _ BrowserEnvironment new.! !

!FinderTool methodsFor: 'accessing' stamp: 'nk 8/13/2003 16:37'!
conditionString: anObject
	conditionString := anObject.
	self changed: #conditionString.
	^true! !

!FinderTool methodsFor: 'accessing' stamp: 'nk 8/13/2003 16:39'!
createConditionBlock
	^self conditionString isEmpty 
		ifFalse: [Compiler evaluate: '[ :aNode | ' , conditionString , ' ]' for: self logged: false ]
		ifTrue: [[:aNode | true]]! !

!FinderTool methodsFor: 'accessing' stamp: 'dvf 9/27/2001 18:40'!
searchEnvironment
	^searchEnvironment! !

!FinderTool class methodsFor: 'as yet unclassified' stamp: 'nk 9/17/2003 12:58'!
jokerHelp
	((StringHolder new ) contents: self comment) openLabel: 'Jokers'! !

!FinderTool methodsFor: 'actions' stamp: 'nk 9/17/2003 14:30'!
search
	self dependents 
		do: [:dep | (dep respondsTo: #accept) ifTrue: [dep hasUnacceptedEdits ifTrue: [ dep accept]]].
	([ self searchEnabled ] on: Error do: [ :ex | ex return: false ])
		ifFalse: [ ^self inform: 'bad search string' ].
	Cursor wait showWhile: 
			[(self searchFor: searchString asString
				when: (self createConditionBlock ifNil: [^self flash])) openEditor]! !

!FinderTool methodsFor: 'as yet unclassified' stamp: 'dvf 9/22/2001 15:42'!
searchString
	^searchString! !

Object subclass: #RefactoringManager
	instanceVariableNames: 'refactorings'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!RefactoringManager methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream nextPutAll: '#		Refactoring';
		cr;
		nextPutAll: '---		-----------------------------------------------';
		cr.
	refactorings asSet asSortedCollection do: 
			[:name | 
			aStream nextPutAll: (refactorings occurrencesOf: name) printString;
				nextPutAll: '		';
				nextPutAll: name;
				cr]! !

!RefactoringManager class methodsFor: 'instance creation' stamp: ''!
new
	^self shouldNotImplement! !

!RefactoringManager class methodsFor: 'public access' stamp: ''!
nuke
	Instance notNil ifTrue: [Instance release].
	Instance := nil! !

!RefactoringManager methodsFor: 'public access' stamp: ''!
addRefactoring: aRefactoring 
	RefactoryChangeManager instance performChange: aRefactoring changes.
	refactorings add: aRefactoring class name! !

!RefactoringManager methodsFor: 'initialize-release' stamp: ''!
initialize
	refactorings := Bag new! !

!RefactoringManager class methodsFor: 'parcel load/unload/save' stamp: ''!
preUnloadActionFor: aParcel
	^RefactoringManager nuke! !

!RefactoringManager class methodsFor: 'instance creation' stamp: ''!
instance
	Instance isNil
		ifTrue:
			[Instance := self basicNew.
			Instance initialize].
	^Instance! !

Object subclass: #LintRule
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Lint'!

!LintRule methodsFor: 'printing' stamp: ''!
displayName
	| nameStream |
	nameStream := WriteStream on: (String new: 64).
	nameStream nextPutAll: self name;
		nextPutAll: ' ['.
	self problemCount printOn: nameStream.
	nameStream nextPut: $].
	^nameStream contents! !

!LintRule methodsFor: 'accessing' stamp: ''!
checkMethod: aSmalllintContext! !

!LintRule methodsFor: 'accessing' stamp: ''!
problemCount
	^self subclassResponsibility! !

!LintRule methodsFor: 'accessing' stamp: ''!
checkClass: aSmalllintContext! !

LintRule subclass: #BasicLintRule
	instanceVariableNames: 'result openSymbol'
	classVariableNames: 'FilterDictionary'
	poolDictionaries: ''
	category: 'Refactory-Lint'!

!BasicLintRule methodsFor: 'private' stamp: 'bh 5/9/2000 00:16'!
openWithoutFilters
	^self result openEditor! !

!BasicLintRule methodsFor: 'initialize-release' stamp: ''!
openUsing: aSymbol 
	openSymbol := aSymbol! !

!BasicLintRule methodsFor: 'initialize-release' stamp: ''!
result: aResult 
	result := aResult copyEmpty! !

!BasicLintRule methodsFor: 'accessing' stamp: ''!
problemCount
	^self result problemCount! !

!BasicLintRule methodsFor: 'initialize-release' stamp: ''!
resetResult
	result := result copyEmpty.
	result label: name! !

!BasicLintRule methodsFor: 'initialize-release' stamp: ''!
resultClass: aClass 
	result := aClass new! !

!BasicLintRule methodsFor: 'private' stamp: 'bh 5/9/2000 00:16'!
viewResults
	^self perform: openSymbol! !

BasicLintRule subclass: #ParseTreeLintRule
	instanceVariableNames: 'matcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Lint'!

!ParseTreeLintRule methodsFor: 'initialize-release' stamp: ''!
matcher: aParseTreeMatcher
	matcher := aParseTreeMatcher! !

!ParseTreeLintRule class methodsFor: 'private' stamp: ''!
isSearchingLiteralExpression: aSearchingNode for: anObjectNode 
	| argument arguments |
	aSearchingNode isMessage ifFalse: [^false].
	arguments := aSearchingNode arguments.
	arguments size = 1 ifFalse: [^false].
	argument := arguments first.
	(#(#= #==) includes: aSearchingNode selector) 
		ifTrue: 
			[^(aSearchingNode receiver = anObjectNode 
				and: [aSearchingNode arguments first isLiteral]) or: 
						[aSearchingNode arguments first = anObjectNode 
							and: [aSearchingNode receiver isLiteral]]].
	aSearchingNode selector = #| 
		ifTrue: 
			[^(self isSearchingLiteralExpression: aSearchingNode receiver
				for: anObjectNode) 
					and: [self isSearchingLiteralExpression: argument for: anObjectNode]].
	aSearchingNode selector = #or: ifFalse: [^false].
	argument isBlock ifFalse: [^false].
	argument body statements size = 1 ifFalse: [^false].
	^(self isSearchingLiteralExpression: aSearchingNode receiver
		for: anObjectNode) and: 
				[self isSearchingLiteralExpression: argument body statements first
					for: anObjectNode]! !

!ParseTreeLintRule class methodsFor: 'unnecessary code' stamp: ''!
unnecessaryAssignment
	^self 
		createParseTreeRule: #('^`{:aNode | aNode isAssignment and: [(aNode whoDefines: aNode variable name) notNil]}')
		name: 'Unnecessary assignment to a temporary variable'! !

!ParseTreeLintRule class methodsFor: 'possible bugs' stamp: ''!
usesAdd
	^self 
		createParseTreeRule: #('`{:node | node isMessage and: [(node selector == #add: or: [node selector == #addAll:]) and: [node isDirectlyUsed]]}')
		name: 'Uses the result of an add: message'! !

!ParseTreeLintRule class methodsFor: 'miscellaneous' stamp: ''!
unoptimizedAndOr
	^self 
		createParseTreeRule: #('(`@a and: `@b) and: `@c' '(`@a or: `@b) or: `@c')
		name: 'Uses "(a and: [b]) and: [c]" instead of "a and: [b and: [c]]"'! !

!ParseTreeLintRule class methodsFor: 'private' stamp: ''!
isArrayOfCharacters: anArray 
	anArray isEmpty ifTrue: [^false].
	1 to: anArray size
		do: [:each | (anArray at: each) class == Character ifFalse: [^false]].
	^true! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
toDoWithIncrement
	^self 
		createParseTreeRule: #(
				'`@i to: `@j do: [:`e | | `@temps | `@.Stmts. `x := `x + 1. `@.Stmts2]' 
				'`@i to: `@j by: `@k do: [:`e | | `@temps | `@.Stmts. `x := `x + `@k. `@.Stmts2]')
		name: 'to:do: loop also increments a counter'! !

!ParseTreeLintRule class methodsFor: 'instance creation' stamp: ''!
createParseTreeRule: codeStrings method: aBoolean name: aName 
	^(self new)
		name: aName;
		matcher: (self createMatcherFor: codeStrings method: aBoolean);
		yourself! !

!ParseTreeLintRule class methodsFor: 'miscellaneous' stamp: ''!
assignmentInBlock
	^self createParseTreeRule: #(
			'`@cursor showWhile: [| `@temps | `@.Statements1. `var := `@object]' 
			'`@cursor showWhile: [| `@temps | `@.Statements1. ^`@object]' 
			'[| `@temps | `@.Statements. `var := `@object] valueNowOrOnUnwindDo: `@block' 
			'[| `@temps | `@.Statements. ^`@object] valueNowOrOnUnwindDo: `@block' 
			'[| `@temps | `@.Statements. `var := `@object] valueOnUnwindDo: `@block' 
			'[| `@temps | `@.Statements. ^`@object] valueOnUnwindDo: `@block' 
			'[| `@temps | `@.Statements. `var := `@object] ensure: `@block' 
			'[| `@temps | `@.Statements. ^`@object] ensure: `@block' 
			'[| `@temps | `@.Statements. `var := `@object] ifCurtailed: `@block' 
			'[| `@temps | `@.Statements. ^`@object] ifCurtailed: `@block' ) 
		name: 'Unnecessary assignment or return in block'! !

!ParseTreeLintRule class methodsFor: 'miscellaneous' stamp: ''!
unoptimizedToDo
	^self createParseTreeRule: #('(`@a to: `@b) do: `@c')
		name: 'Uses (to:)do: instead of to:do:'! !

!ParseTreeLintRule class methodsFor: 'possible bugs' stamp: ''!
returnsIfTrue
	^self createParseTreeRule: 
				#('^`@condition ifTrue: [| `@temps | `@.statements]' 
				'^`@condition ifFalse: [| `@temps | `@.statements]') 
		name: 'Returns value of ifTrue:/ifFalse: without ifFalse:/ifTrue: block'! !

!ParseTreeLintRule class methodsFor: 'private' stamp: ''!
isSearchingLiteralExpression: aMessageNode 
	| equalNode expressionNode |
	equalNode := aMessageNode selector = #| 
				ifTrue: [aMessageNode arguments first]
				ifFalse: [aMessageNode receiver].
	expressionNode := equalNode receiver isLiteral 
				ifTrue: [equalNode arguments first]
				ifFalse: [equalNode receiver].
	^self isSearchingLiteralExpression: aMessageNode for: expressionNode! !

!ParseTreeLintRule methodsFor: 'private' stamp: ''!
defaultResultClass
	^ParseTreeEnvironment! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
collectionProtocol
	^self createParseTreeRule: 
			#('`@collection do: [:`each | | `@temps | `@.Statements1. `@object add: `@arg. `@.Statements2]' 
			'`@collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifTrue: [| `@blockTemps | 
							`@.BlockStatements1. 
							`@object add: `each. 
							`@.BlockStatements2]. 
					`@.Statements2]' 
			'`@collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifFalse: [| `@blockTemps | 
							`@.BlockStatements1. 
							`@object add: `each. 
							`@.BlockStatements2]. 
					`@.Statements2]') 
		name: 'Uses do: instead of collect: or select:''s'! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
detectContains
	^self createParseTreeRule: 
			#('`@collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifFalse: [| `@BlockTemps | `@.BlockStatements1. ^`each]. 
					`@.Statements2]' 
			'`@collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifTrue: [| `@BlockTemps | `@.BlockStatements1.  ^`each]. 
					`@.Statements2]' 
			'`@collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifFalse: [| `@BlockTemps | `@.BlockStatements1. ^true]. 
					`@.Statements2]' 
			'`@Collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifTrue: [| `@BlockTemps | `@.BlockStatements1.  ^true]. 
					`@.Statements2]' 
			'`@collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifFalse: [| `@BlockTemps | `@.BlockStatements1. ^false]. 
					`@.Statements2]' 
			'`@collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifTrue: [| `@BlockTemps | `@.BlockStatements1.  ^false]. 
					`@.Statements2]') 
		name: 'Uses do: instead of contains: or detect:''s'! !

!ParseTreeLintRule class methodsFor: 'miscellaneous' stamp: ''!
yourselfNotUsed
	^self createParseTreeRule: #('`{:node | node parent isUsed not} yourself')
		name: 'Doesn''t use the result of a yourself message'! !

!ParseTreeLintRule class methodsFor: 'possible bugs' stamp: 'bh 4/2/2000 22:17'!
missingYourself
	^self 
		createParseTreeRule: #('`{:node | node isMessage and: [node parent isCascade and: [node isDirectlyUsed and: [node selector ~~ #yourself]]]}')
		name: 'Possible missing "; yourself"'! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
searchingLiteral
	| detector matcher |
	detector := self new.
	detector name: 'Uses or''s instead of a searching literal'.
	matcher := ParseTreeSearcher new.
	matcher 
		matchesAnyOf: #('``@object = `#literal or: [``@expression]' 
						'``@object == `#literal or: [``@expression]' 
						'`#literal = ``@object or: [``@expression]' 
						'`#literal == ``@object or: [``@expression]' 
						'``@expression | (``@object = `#literal)' 
						'``@expression | (``@object == `#literal)' 
						'``@expression | (`#literal = ``@object)' 
						'``@expression | (`#literal == ``@object)')
		do: 
			[:aNode :answer | 
			answer isNil 
				ifTrue: 
					[(self isSearchingLiteralExpression: aNode) ifTrue: [aNode] ifFalse: [nil]]
				ifFalse: [answer]].
	detector matcher: matcher.
	^detector! !

!ParseTreeLintRule class methodsFor: 'instance creation' stamp: ''!
createParseTreeRule: codeStrings name: aName 
	^self 
		createParseTreeRule: codeStrings
		method: false
		name: aName! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
contains
	^self createParseTreeRule: 
			#('(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) isNil' 
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) notNil' 
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) = nil' 
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) == nil' 
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) ~= nil' 
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) ~~ nil' 
			'`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [| `@temps1 | `@.Statements2. ^`@anything]') 
		name: 'Uses detect:ifNone: instead of contains:'! !

!ParseTreeLintRule class methodsFor: 'miscellaneous' stamp: ''!
asOrderedCollectionNotNeeded
	^self 
		createParseTreeRule: #('`@node addAll: `{:node | node isMessage and: [#(asOrderedCollection asArray) includes: node selector]}')
		name: '#asOrderedCollection/#asArray not needed'! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
guardingClause
	| detector matcher |
	detector := self new.
	detector name: 'Guarding clauses'.
	matcher := ParseTreeSearcher new.
	matcher 
		matchesAnyMethodOf: 	
			#('`@MethodName: `@args 
					| `@temps | 
					`@.Statements. 
					`@condition ifTrue: [| `@BlockTemps | `.Statement1. `.Statement2. `@.BStatements]' 
			'`@MethodName: `@args 
					| `@temps | 
					`@.Statements. 
					`@condition ifFalse: [| `@BlockTemps | `.Statement1. `.Statement2. `@.BStatements]')
		do: 
			[:aNode :answer | 
			answer isNil 
				ifTrue: 
					[aNode body statements last]
				ifFalse: [answer]].
	detector matcher: matcher.
	^detector! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
collectSelectNotUsed
	^self 
		createParseTreeRule: #('`{:node | node isMessage and: [(#(#select: #collect: #reject:) includes: node selector) and: [node isUsed not]]}')
		name: 'Doesn''t use the result of a collect:/select:'! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
collectionMessagesToExternalObject
	| detector matcher |
	detector := self new.
	detector name: 'Sends add:/remove: to external collection'.
	matcher := ParseTreeSearcher new.
	matcher 
		matchesAnyOf: (#(#add: #remove: #addAll: #removeAll:) collect: 
					[:each | 
					('(`@Object `@message: `@args) <1s> `@Arg' expandMacrosWith: each) 
						asString])
		do: 
			[:aNode :answer | 
			answer isNil 
				ifTrue: 
					[((aNode receiver selector copyFrom: 1
						to: (aNode receiver selector size min: 2)) ~= 'as' 
						and: 
							[| receiver |
							receiver := aNode receiver receiver.
							receiver isVariable not or: 
									[((#('self' 'super') includes: receiver name) 
										or: [Smalltalk includesKey: receiver name asSymbol]) not]]) 
							ifTrue: [aNode]
							ifFalse: [nil]]
				ifFalse: [answer]].
	detector matcher: matcher.
	^detector! !

!ParseTreeLintRule class methodsFor: 'possible bugs' stamp: ''!
modifiesCollection
	| detector matcher |
	detector := self new.
	detector name: 'Modifies collection while iterating over it'.
	matcher := (ParseTreeSearcher new)
				matchesAnyOf: 
						#('`@object do: [:`each | | `@temps | ``@.Statements]' 
						'`@object collect: [:`each | | `@temps | ``@.Statements]' 
						'`@object select: [:`each | | `@temps | ``@.Statements]' 
						'`@object reject: [:`each | | `@temps | ``@.Statements]' 
						'`@object inject: `@value into: [:`sum :`each | | `@temps | ``@.Statements]')
					do: 
						[:aNode :answer | 
						answer isNil 
							ifTrue: 
								[(self modifiesTree: aNode receiver in: aNode arguments last) 
									ifTrue: [aNode]
									ifFalse: [nil]]
							ifFalse: [answer]];
				yourself.
	detector matcher: matcher.
	^detector! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
sizeCheck
	^self createParseTreeRule: (#(#do: #collect: #reject: #select:) collect: 
					[:each | 
					'`@object size > 0 ifTrue: [`@object ' , each
						, ' [:`each | | `@temps | `@.Statements1]. `@.Statements2]'])
				, (#(#do: #collect: #reject: #select:) collect: 
							[:each | 
							'`@object isEmpty ifFalse: [`@object ' , each
								, ' [:`each | | `@temps | `@.Statements1]. `@.Statements2]'])
		name: 'Unnecessary size check'! !

!ParseTreeLintRule methodsFor: 'accessing' stamp: ''!
checkMethod: aSmalllintContext 
	(matcher canMatchMethod: aSmalllintContext compiledMethod) 
		ifFalse: [^self].
	(matcher executeTree: aSmalllintContext parseTree initialAnswer: nil) 
		notNil 
			ifTrue: 
				[result addClass: aSmalllintContext selectedClass
					selector: aSmalllintContext selector]! !

!ParseTreeLintRule class methodsFor: 'private' stamp: ''!
modifiesTree: aCollectionTree in: aParseTree 
	| notifier args |
	notifier := ParseTreeSearcher new.
	args := Array with: (RBVariableNode named: '`@object').
	notifier 
		matchesAnyTreeOf: (#(#add: #addAll: #remove: #removeAll:) collect: 
					[:each | 
					RBMessageNode 
						receiver: aCollectionTree
						selector: each
						arguments: args])
		do: [:aNode :answer | true].
	^notifier executeTree: aParseTree initialAnswer: false! !

!ParseTreeLintRule class methodsFor: 'miscellaneous' stamp: ''!
ifTrueBlocks
	^self 
		createParseTreeRule: #(
				'`@condition ifTrue: `{:node | node isBlock not} ifFalse: `@block' 
				'`@condition ifTrue: `@block ifFalse: `{:node | node isBlock not}' 
				'`@condition ifFalse: `{:node | node isBlock not} ifTrue: `@block' 
				'`@condition ifFalse: `@block ifTrue: `{:node | node isBlock not}' 
				'`@condition ifTrue: `{:node | node isBlock not}' 
				'`@condition ifFalse: `{:node | node isBlock not}')
		name: 'Non-blocks in ifTrue:/ifFalse: messages'! !

!ParseTreeLintRule class methodsFor: 'possible bugs' stamp: ''!
returnInEnsure
	| detector matcher returnMatcher |
	detector := self new.
	detector name: 'Contains a return in an ensure: block'.
	returnMatcher := ParseTreeSearcher new.
	returnMatcher matches: '^`@object' do: [:aNode :answer | true].
	matcher := ParseTreeSearcher new.
	matcher 
		matchesAnyOf: #('``@rcv ensure: [| `@temps | ``@.Stmts]' 
						'``@rcv valueNowOrOnUnwindDo: [| `@temps | ``@.Stmts]' 
						'``@rcv ifCurtailed: [| `@temps | ``@.Stmts]' 
						'``@rcv valueOnUnwindDo: [| `@temps | ``@.Stmts]')
		do: 
			[:aNode :answer | 
			answer isNil 
				ifTrue: 
					[(returnMatcher executeTree: aNode arguments first initialAnswer: false) 
						ifTrue: [aNode]
						ifFalse: [nil]]
				ifFalse: [answer]].
	detector matcher: matcher.
	^detector! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
toDoCollect
	^self 
		createParseTreeRule: #(
			'| `@temps1 |
			`@.Stmts1.
			`collection := Array new: `@size.
			`@.Stmts2.
			1 to: `@size do: 
					[:`i | 
					| `@Btemps2 | 
					`@.BStmts1. 
					`collection at: `i put: `@obj.
					`@.BStmt2].
			`@.Stmts3'
					"-------------"
			 '| `@temps1 |
			`@.Stmts1.
			`collection := Array new: `@size.
			`@.Stmts2.
			1 to: `collection size do: 
					[:`i | 
					| `@Btemps2 | 
					`@.BStmts1. 
					`collection at: `i put: `@obj.
					`@.BStmt2].
			`@.Stmts3')
		name: 'to:do: doesn''t use collect:'! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
assignmentInIfTrue
	^self createParseTreeRule: 
			#('`@boolean 
					ifTrue: [| `@temps1 | `@.Statements1. `var := `@object1] 
					ifFalse: [| `@temps2 | `@.Statements2. `var := `@object2]' 
			'`@boolean 
					ifFalse: [| `@temps1 | `@.Statements1. `var := `@object1] 
					ifTrue: [| `@temps2 | `@.Statements2. `var := `@object2]') 
		name: 'Assignment to same variable and end of ifTrue:ifFalse: blocks'! !

!ParseTreeLintRule class methodsFor: 'possible bugs' stamp: ''!
equalNotUsed
	^self 
		createParseTreeRule: #('`{:node | node isMessage and: [node isUsed not and: [#(#= #== #~= #~~ #< #> #<= #>=) includes: node selector]]}')
		name: 'Doesn''t use the result of a =, ~=, etc.'! !

!ParseTreeLintRule class methodsFor: 'bugs' stamp: ''!
booleanPrecedence
	^self createParseTreeRule: 
			#('`@object1 | `@object2 = `@object3'
			'`@object1 | `@object2 == `@object3'
			'`@object1 & `@object2 = `@object3'
			'`@object1 & `@object2 == `@object3'
			'`@object1 | `@object2 ~= `@object3'
			'`@object1 | `@object2 ~~ `@object3'
			'`@object1 & `@object2 ~= `@object3'
			'`@object1 & `@object2 ~~ `@object3')
		name: 'Uses A | B = C instead of A | (B = C)'! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
minMax
	| detector matcher |
	detector := self new.
	detector name: 'Uses ifTrue:/ifFalse: instead of min: or max:'.
	matcher := ParseTreeSearcher new.
	matcher 
		matchesAnyOf: #('(`x `message: `@y) `ifTrue: [`x := `@y]' '(`@x `message: `@y) `ifTrue: [`@x] `ifFalse: [`@y]' '(`@x `message: `@y) `ifTrue: [`v := `@x] `ifFalse: [`v := `@y]')
		do: 
			[:aNode :answer | 
			answer isNil 
				ifTrue: 
					[((#(#ifTrue: #ifFalse: #ifTrue:ifFalse: #ifFalse:ifTrue:) 
						includes: aNode selector) 
							and: [#(#< #<= #> #>=) includes: aNode receiver selector]) 
							ifTrue: [aNode]
							ifFalse: [nil]]
				ifFalse: [answer]].
	detector matcher: matcher.
	^detector! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
literalArrayCharacters
	| detector matcher |
	detector := self new.
	detector name: 'Literal array contains only characters'.
	matcher := ParseTreeSearcher new.
	matcher matches: '`#literal'
		do: 
			[:aNode :answer | 
			answer isNil 
				ifTrue: 
					[(aNode value class == Array and: [self isArrayOfCharacters: aNode value]) 
						ifTrue: [aNode]
						ifFalse: [nil]]
				ifFalse: [answer]].
	detector matcher: matcher.
	^detector! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
atIfAbsent
	^self createParseTreeRule: 
				#('`@object 
						at: `@atArg 
						ifAbsent: [| `@temps | `@.Statements. `@object at: `@atArg put: `@putArg]' 
				'`@object 
						at: `@atArg 
						ifAbsent: [| `@temps | 
								`@.Statements. 
								`@object at: `@atArg put: `@putArg. 
								`@.xStatements1. 
								`@putArg]') 
		name: 'Uses at:ifAbsent: instead of at:ifAbsentPut:'! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
consistencyCheck
	^self createParseTreeRule: 
				#('`@object size == 0' 
				'`@object size = 0' 
				'`@object size > 0' 
				'`@object size >= 1' 
				'`@object == nil' 
				'`@object = nil'
				'`@collection at: 1'
				'`@collection at: `@collection size') 
		name: 'Uses "size = 0", "= nil",  or "at: 1" instead of "isEmpty",  "isNil", or "first"'! !

!ParseTreeLintRule class methodsFor: 'unnecessary code' stamp: ''!
endTrueFalse
	| detector matcher |
	detector := self new.
	detector 
		name: 'Check for same statements at end of ifTrue:ifFalse: blocks'.
	matcher := (ParseTreeSearcher new)
				matchesAnyOf: 	
					#('`@object 
								ifTrue: [| `@temps1 | `@.Statements1. `.Statement] 
								ifFalse: [| `@temps2 | `@.Statements2. `.Statement]' 
						'`@object 
								ifTrue: [| `@temps1 | `.Statement. `@.Statements1] 
								ifFalse: [| `@temps2 | `.Statement. `@.Statements2]' 
						'`@object 
								ifFalse: [| `@temps1 | `@.Statements1. `.Statement] 
								ifTrue: [| `@temps2 | `@.Statements2. `.Statement]' 
						'`@object 
								ifFalse: [| `@temps1 | `.Statement. `@.Statements1] 
								ifTrue: [| `@temps2 | `.Statement. `@.Statement2]') 
					do: 
						[:aNode :answer | 
						answer isNil 
							ifTrue: 
								[| node |
								node := aNode arguments first body statements last.
								(node isVariable and: [node = aNode arguments last body statements last]) 
									ifTrue: [nil]
									ifFalse: [aNode]]
							ifFalse: [answer]];
				yourself.
	detector matcher: matcher.
	^detector! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
whileTrue
	^self createParseTreeRule: 
			#('| `@temps | 
				`@.Statements1. 
				[`index <= `@stop] 
					whileTrue: 
						[| `@blockTemps | 
						`@.BlockStmts1. 
						`index := `index + 1].
				`@.Statements2' 
			'| `@temps | 
				`@.Statements1. 
				[`index < `@stop] 
					whileTrue: 
						[| `@blockTemps | 
						`@.BlockStmts1. 
						`index := `index + 1].
				`@.Statements2'
			'| `@temps | 
				`@.Statements1. 
				[`index >= `@stop] 
					whileTrue: 
						[| `@blockTemps | 
						`@.BlockStmts1. 
						`index := `index - 1].
				`@.Statements2' 
			'| `@temps | 
				`@.Statements1. 
				[`index > `@stop] 
					whileTrue: 
						[| `@blockTemps | 
						`@.BlockStmts1. 
						`index := `index - 1].
				`@.Statements2') 
		name: 'Uses whileTrue: instead of to:do:'! !

!ParseTreeLintRule class methodsFor: 'possible bugs' stamp: ''!
threeElementPoint
	| detector matcher |
	detector := self new.
	detector name: 'Possible three element point (e.g., x @ y + q @ r)'.
	matcher := (ParseTreeSearcher new)
				matches: '``@x @ ``@y'
					do: 
						[:aNode :answer | 
						answer isNil 
							ifTrue: 
								[| current |
								current := aNode parent.
								
								[current isNil or: 
										[current isMessage 
											and: [current selector == #@ or: [current selector isInfix not]]]] 
										whileFalse: [current := current parent].
								(current isNil or: [current isMessage and: [current selector isInfix not]]) 
									ifTrue: [nil]
									ifFalse: [aNode]]
							ifFalse: [answer]];
				yourself.
	detector matcher: matcher.
	^detector! !

!ParseTreeLintRule class methodsFor: 'possible bugs' stamp: ''!
fileBlocks
	^self createParseTreeRule: 
				#('[| `@temps | 
					`var := `@object.  
					`@.statements] 
							valueNowOrOnUnwindDo: 
								[`var `@messages: `@args]' 
				'[| `@temps | 
					`var := `@object.  
					`@.statements] 
							valueOnUnwindDo: 
								[`var `@messages: `@args]'
				'[| `@temps | 
					`var := `@object.  
					`@.statements] 
							ensure: 
								[`var `@messages: `@args]' 
				'[| `@temps | 
					`var := `@object.  
					`@.statements] 
							ifCurtailed: 
								[`var `@messages: `@args]') 
		name: 'Assignment inside unwind blocks should be outside.'! !

!ParseTreeLintRule class methodsFor: 'miscellaneous' stamp: ''!
stringConcatenation
	| detector matcher concatenationMatcher |
	detector := self new.
	detector name: 'String concatenation instead of streams'.
	matcher := ParseTreeSearcher new.
	concatenationMatcher := ParseTreeSearcher new.
	concatenationMatcher matches: '`@receiver , `@argument'
		do: [:aNode :answer | true].
	matcher 
		matchesAnyOf: 
			#('``@collection do: [:`each | | `@temps | ``@.Statements]' 
			'``@collection do: [:`each | | `@temps | ``@.Statements] separatedBy: [| `@temps1 | ``@.Statements1]' 
			'``@number to: ``@endNumber do: [:`i | | `@temps | ``@.Statements]' 
			'``@collection detect: [:`each | | `@temps | ``@.Statements]' 
			'``@collection detect: [:`each | | `@temps | ``@.Statements] ifNone: [| `@temps1 | ``@.Statements1]' 
			'``@collection select: [:`each | | `@temps | ``@.Statements]' 
			'``@collection inject: ``@value into: [:`each | | `@temps | ``@.Statements]')
		do: 
			[:aNode :answer | 
			answer isNil 
				ifTrue: 
					[(aNode arguments detect: 
							[:each | 
							each isBlock 
								and: [concatenationMatcher executeTree: each initialAnswer: false]]
						ifNone: [nil]) notNil 
						ifTrue: [aNode]
						ifFalse: [nil]]
				ifFalse: [answer]].
	detector matcher: matcher.
	^detector! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: ''!
toDo
	| detector matcher |
	detector := self new.
	detector name: 'Uses to:do: instead of do:, with:do: or timesRepeat:'.
	matcher := ParseTreeSearcher new.
	matcher 
		matches: '1 to: ``@object size do: [:`each | | `@temps | `@.Statements]'
		do: 
			[:aNode :answer | 
			answer isNil 
				ifTrue: 
					[| varName variableMatcher |
					varName := aNode arguments last arguments first.	"`each"
					variableMatcher := ParseTreeSearcher new.
					variableMatcher matchesTree: varName
						do: [:node :ans | ans and: [node parent isMessage and: [node parent selector == #at:]]].
					(variableMatcher executeTree: aNode arguments last body initialAnswer: true) 
						ifTrue: [aNode]
						ifFalse: [nil]]
				ifFalse: [answer]].
	detector matcher: matcher.
	^detector! !

!ParseTreeLintRule class methodsFor: 'unnecessary code' stamp: ''!
equalsTrue
	| detector matcher |
	detector := self new.
	detector name: 'Unnecessary "= true"'.
	matcher := (ParseTreeSearcher new)
				matchesAnyOf: #('true' 'false')
					do: 
						[:aNode :answer | 
						answer isNil 
							ifTrue: 
								[(aNode parent isMessage 
									and: [#(#= #== #~= #~~) includes: aNode parent selector]) 
										ifTrue: [aNode]
										ifFalse: [nil]]
							ifFalse: [answer]];
				yourself.
	detector matcher: matcher.
	^detector! !

!ParseTreeLintRule class methodsFor: 'miscellaneous' stamp: ''!
precedence
	^self 
		createParseTreeRule: #('`{:node | node isMessage and: [node hasParentheses not and: [#(#+ #-) includes: node selector]]} * `@C')
		name: 'Inspect instances of "A + B * C" might be "A + (B * C)"'! !

!ParseTreeLintRule class methodsFor: 'private' stamp: ''!
createMatcherFor: codeStrings method: aBoolean 
	| matcher |
	matcher := ParseTreeSearcher new.
	aBoolean 
		ifTrue: [matcher matchesAnyMethodOf: codeStrings do: [:aNode :answer | aNode]]
		ifFalse: [matcher matchesAnyOf: codeStrings do: [:aNode :answer | aNode]].
	^matcher! !

!ParseTreeLintRule class methodsFor: 'intention revealing' stamp: 'bh 4/2/2000 22:14'!
ifTrueReturns
	| detector matcher |
	detector := self new.
	detector name: 'ifTrue:/ifFalse: returns instead of and:/or:''s'.
	matcher := ParseTreeSearcher new.
	matcher 
		matchesAnyOf: 
			#('| `@temps | ``@.Statements. ``@object ifTrue: [^``@value1]. ^``@value2' 
			'| `@temps | ``@.Statements. ``@object ifFalse: [^``@value1]. ^``@value2')
		do: 
			[:aNode :answer | 
			answer isNil 
				ifTrue: 
					[| node |
					node := (aNode statements at: aNode statements size - 1) arguments first 
								body statements 
								last value.	"``@value1"
					((node isLiteral and: [{true. false} includes: node value]) or: 
							[node := aNode statements last value.
							node isLiteral and: [{true. false} includes: node value]]) 
						ifTrue: [aNode]
						ifFalse: [nil]]
				ifFalse: [answer]].
	detector matcher: matcher.
	^detector! !

!ParseTreeLintRule methodsFor: 'initialize-release' stamp: ''!
resetResult
	result := ParseTreeEnvironment new.
	result
		label: self name;
		matcher: matcher! !

!ParseTreeLintRule class methodsFor: 'unnecessary code' stamp: ''!
extraBlock
	^self 
		createParseTreeRule: #('`{:node | node isMessage and: [node receiver isBlock and: [node parent isCascade not and: [#(#value #value: #value:value: #value:value:value: #valueWithArguments) includes: node selector]]]}')
		name: 'Block immediately evaluated'! !

!BasicLintRule class methodsFor: 'storing' stamp: ''!
storeFiltersOn: aStream 
	aStream
		nextPut: $(;
		nextPutAll: self name;
		nextPutAll: ' filterDictionary: (Dictionary new'.
	self filterDictionary keysAndValuesDo: 
			[:key :value | 
			aStream nextPutAll: ' at: '.
			key storeOn: aStream.
			aStream nextPutAll: ' put: '.
			value storeOn: aStream.
			aStream
				nextPutAll: ';';
				cr].
	aStream
		tab;
		nextPutAll: 'yourself))'! !

!BasicLintRule methodsFor: 'accessing' stamp: ''!
result
	^(self class filterDictionary includesKey: self name) 
		ifTrue: [self filteredResult]
		ifFalse: [result]! !

!BasicLintRule class methodsFor: 'accessing' stamp: ''!
filterFor: aName 
	^self filterDictionary at: aName ifAbsentPut: [SelectorEnvironment new]! !

!BasicLintRule methodsFor: 'testing' stamp: ''!
isEmpty
	^self result isEmpty! !

!BasicLintRule class methodsFor: 'accessing' stamp: ''!
protocols
	^#('bugs' 'possible bugs' 'unnecessary code' 'intention revealing' 'miscellaneous')! !

!BasicLintRule class methodsFor: 'accessing' stamp: ''!
addFilter: anEnvironment for: aString 
	self filterDictionary at: aString put: anEnvironment copy! !

BasicLintRule subclass: #BlockLintRule
	instanceVariableNames: 'classBlock methodBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Lint'!

!BlockLintRule class methodsFor: 'bugs' stamp: ''!
sentNotImplemented
	| detector |
	detector := self new.
	detector name: 'Messages sent but not implemented'.
	detector methodBlock: 
			[:context :result | 
			| message |
			message := context messages detect: [:each | (context implements: each) not]
						ifNone: [nil].
			message isNil ifTrue: 
					[message := context superMessages detect: 
									[:each | 
									context selectedClass superclass isNil
										or: [(context selectedClass superclass canUnderstand: each) not]]
								ifNone: [nil].
					message isNil ifTrue: 
							[message := context selfMessages
										detect: [:each | (context selectedClass canUnderstand: each) not]
										ifNone: [nil]]].
			message notNil ifTrue: 
					[result addSearchString: message.
					result addClass: context selectedClass selector: context selector]].
	^detector! !

!BlockLintRule class methodsFor: 'bugs' stamp: ''!
undeclaredReference
	| detector |
	detector := self new.
	detector name: 'References an undeclared variable'.
	detector methodBlock: 
			[:context :result | 
			| undeclared |
			undeclared := Undeclared associations detect: 
							[:each | 
							(context uses: each)
								and: [context compiledMethod refersToLiteral: each]]
						ifNone: [nil].
			undeclared notNil ifTrue: 
					[result addSearchString: undeclared key.
					result addClass: context selectedClass selector: context selector]].
	^detector! !

!BlockLintRule class methodsFor: 'possible bugs' stamp: ''!
classInstVarNotInitialized
	| detector |
	detector := self new.
	detector name: 'Has class instance variables but no initialize method'.
	detector resultClass: ClassEnvironment.
	detector classBlock: 
		[:context :result | 
		| definesVar class |
		context selectedClass isMeta
			ifTrue: 
				[class := context selectedClass.
				definesVar := false.
				[definesVar or: [class isNil or: [class isMeta not]]]
					whileFalse: 
						[definesVar := class instVarNames isEmpty not.
						class := class superclass].
				(definesVar and: [(context selectedClass includesSelector: #initialize) not])
					ifTrue: [result addClass: context selectedClass]]].
	^detector! !

!BlockLintRule class methodsFor: 'unnecessary code' stamp: ''!
classNotReferenced
	| detector |
	detector := self new.
	detector name: 'Class not referenced'.
	detector resultClass: ClassEnvironment.
	detector classBlock: 
			[:context :result | 
			(context selectedClass isMeta
				or: [context selectedClass subclasses isEmpty not])
					ifFalse: 
						[| assoc |
						assoc := Smalltalk associationAt: context selectedClass name.
						((context uses: assoc) or: [context uses: context selectedClass name])
							ifFalse: 
								[result addClass: context selectedClass;
									addClass: context selectedClass class]]].
	^detector! !

!BlockLintRule class methodsFor: 'unnecessary code' stamp: ''!
unreferencedVariables
	| detector |
	detector := self new.
	detector
		name: 'Variables not referenced';
		resultClass: VariableEnvironment;
		openUsing: #openWithoutFilters.
	detector classBlock: 
			[:context :result | 
			| allSubclasses |
			allSubclasses := context selectedClass withAllSubclasses.
			context selectedClass instVarNames do: 
					[:each | 
					allSubclasses 
						detect: [:class | (class whichSelectorsAccess: each) isEmpty not]
						ifNone: [result addClass: context selectedClass instanceVariable: each]].
			context selectedClass isMeta 
				ifFalse: 
					[context selectedClass classPool associationsDo: 
							[:each | 
							(context uses: each) 
								ifFalse: [result addClass: context selectedClass classVariable: each key]]]].
	^detector! !

!BlockLintRule class methodsFor: 'bugs' stamp: ''!
overridesSpecialMessage
	| detector |
	detector := self new.
	detector name: 'Overrides a "special" message'.
	detector resultClass: ClassEnvironment.
	detector classBlock: 
			[:context :result | 
			((context selectedClass isMeta
				ifTrue: [self metaclassShouldNotOverride]
				ifFalse: [self classShouldNotOverride]) detect: 
						[:each | 
						context selectedClass superclass notNil and: 
								[(context selectedClass superclass canUnderstand: each)
									and: [context selectedClass includesSelector: each]]]
					ifNone: [nil]) notNil ifTrue: [result addClass: context selectedClass]].
	^detector! !

!BlockLintRule class methodsFor: 'possible bugs' stamp: 'bh 3/16/2000 12:07'!
tempsReadBeforeWritten
	| detector |
	detector := self new.
	detector name: 'Temporaries read before written'.
	detector methodBlock: 
			[:context :result | 
			(RBReadBeforeWrittenTester variablesReadBeforeWrittenIn: context parseTree) 
				do: 
					[:each | 
					result addClass: context selectedClass selector: context selector.
					result addSearchString: each]].
	^detector! !

!BlockLintRule methodsFor: 'accessing' stamp: ''!
checkMethod: aSmalllintContext 
	^methodBlock value: aSmalllintContext value: result! !

!BlockLintRule class methodsFor: 'miscellaneous' stamp: 'bh 4/29/2000 23:31'!
utilityMethods
	| detector |
	detector := self new.
	detector name: 'Utility methods'.
	self needsWork.
"	detector methodBlock: 
			[:context :result | 
			(context selectedClass isMeta | (context selector numArgs == 0) or: 
					[(context protocols detect: 
							[:each | 
							(self utilityProtocols detect: [:protocol | protocol match: each]
								ifNone: [nil]) notNil]
						ifNone: [nil]) notNil]) 
				ifFalse: 
					[(self subclassOf: context selectedClass overrides: context selector) 
						ifFalse: 
							[(context superMessages isEmpty and: [context selfMessages isEmpty]) 
								ifTrue: 
									[(context selectedClass allInstVarNames 
										, context selectedClass allClassVarNames asArray , #('self') 
										detect: [:each | context parseTree references: each]
										ifNone: [nil]) isNil 
										ifTrue: [result addClass: context selectedClass selector: context selector]]]]]."
	^detector! !

!BlockLintRule class methodsFor: 'miscellaneous' stamp: 'bh 3/16/2000 12:06'!
longMethods
	| detector matcher |
	detector := self new.
	detector name: 'Long methods'.
	matcher := ParseTreeSearcher new.
	matcher matches: '`.Stmt'
		do: 
			[:aNode :answer | 
			(aNode children inject: answer
				into: [:sum :each | matcher executeTree: each initialAnswer: sum]) + 1].
	detector methodBlock: 
			[:context :result | 
			(matcher executeTree: context parseTree initialAnswer: 0) 
				>= self longMethodSize 
					ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BlockLintRule class methodsFor: 'miscellaneous' stamp: ''!
badMessage
	| detector badMessages |
	detector := self new.
	detector name: 'Sends "questionable" message'.
	badMessages := self badSelectors.
	detector classBlock: 
			[:context :result | 
			| selectors |
			selectors := badMessages inject: Set new
						into: 
							[:set :each | 
							set addAll: (context selectedClass whichSelectorsReferTo: each);
								yourself].
			selectors do: [:each | result addClass: context selectedClass selector: each].
			selectors isEmpty ifFalse: [result searchStrings: badMessages]].
	^detector! !

!BlockLintRule class methodsFor: 'intention revealing' stamp: ''!
missingSubclassResponsibility
	| detector |
	detector := self new.
	detector
		name: 'Method defined in all subclasses, but not in superclass';
		resultClass: MultiEnvironment;
		openUsing: #openWithoutFilters.
	detector classBlock: 
			[:context :result | 
			| subs |
			subs := context selectedClass subclasses.
			subs size > 1 & context selectedClass isMeta not 
				ifTrue: 
					[| sels |
					sels := Bag new.
					subs do: [:each | sels addAll: each selectors].
					sels asSet do: 
							[:each | 
							((sels occurrencesOf: each) == subs size 
								and: [(context selectedClass canUnderstand: each) not]) 
									ifTrue: 
										[| envName |
										envName := context selectedClass name , '>>' , each.
										subs do: 
												[:subClass | 
												result 
													addClass: subClass
													selector: each
													into: envName]]]]].
	^detector! !

!BlockLintRule class methodsFor: 'miscellaneous' stamp: ''!
fullBlocks
	| detector |
	detector := self new.
	detector name: 'Method with full blocks'.
	detector methodBlock: 
			[:context :result | 
			context compiledMethod withAllBlockMethodsDo: 
					[:method | 
					method needsHybridFrame
						ifTrue: [result addClass: context selectedClass selector: context selector]]].
	^detector! !

!BlockLintRule class methodsFor: 'miscellaneous' stamp: ''!
classNameInSelector
	| detector |
	detector := self new.
	detector name: 'Redundant class name in selector'.
	detector methodBlock: 
			[:context :result | 
			(context selectedClass isMeta and: 
					[(context selector
						indexOfSubCollection: context selectedClass soleInstance name
						startingAt: 1) > 0])
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BlockLintRule class methodsFor: 'private' stamp: ''!
doesLiteralArrayContainComma: aLiteral 
	aLiteral class == Array ifFalse: [^false].
	(aLiteral includes: #,) ifTrue: [^true].
	^aLiteral inject: false
		into: [:sum :each | sum or: [self doesLiteralArrayContainComma: each]]! !

!BlockLintRule class methodsFor: 'possible bugs' stamp: ''!
literalArrayContainsComma
	| detector |
	detector := self new.
	detector name: 'Literal array contains a #,'.
	detector methodBlock: 
			[:context :result | 
			(context compiledMethod allLiterals inject: false
				into: [:sum :each | sum or: [self doesLiteralArrayContainComma: each]]) 
					ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BlockLintRule class methodsFor: 'possible bugs' stamp: ''!
abstractClass
	| detector subclassResponsibilitySymbol |
	detector := self new.
	detector name: 'References an abstract class'.
	detector resultClass: ClassEnvironment.
	subclassResponsibilitySymbol := 'subclassResponsibility' asSymbol.
	detector classBlock: 
			[:context :result | 
			(context selectedClass whichSelectorsReferTo: subclassResponsibilitySymbol)
				isEmpty ifFalse: 
						[(context
							uses: (Smalltalk associationAt: context selectedClass name ifAbsent: [nil]))
								ifTrue: [result addClass: context selectedClass]]].
	^detector! !

!BlockLintRule class methodsFor: 'unnecessary code' stamp: ''!
implementedNotSent
	| detector |
	detector := self new.
	detector name: 'Methods implemented but not sent'.
	detector methodBlock: 
			[:context :result | 
			(context uses: context selector)
				ifFalse: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BlockLintRule class methodsFor: 'miscellaneous' stamp: ''!
refersToClass
	| detector |
	detector := self new.
	detector name: 'Refers to class name instead of "self class"'.
	detector classBlock: 
			[:context :result | 
			| sels className |
			className := (context selectedClass isMeta
						ifTrue: [context selectedClass soleInstance]
						ifFalse: [context selectedClass]) name.
			sels := context selectedClass
						whichSelectorsReferTo: (Smalltalk associationAt: className).
			sels do: [:each | result addClass: context selectedClass selector: each].
			sels isEmpty ifFalse: [result addSearchString: className]].
	^detector! !

!BlockLintRule class methodsFor: 'possible bugs' stamp: ''!
superSends
	| detector |
	detector := self new.
	detector name: 'Missing super sends'.
	detector methodBlock: 
			[:context :result | 
			(context selectedClass isMeta not
				and: [self superMessages includes: context selector]) ifTrue: 
						[(context selectedClass superclass notNil
							and: [context selectedClass superclass canUnderstand: context selector])
								ifTrue: 
									[(context superMessages includes: context selector)
										ifFalse: [result addClass: context selectedClass selector: context selector]]]].
	^detector! !

!BlockLintRule class methodsFor: 'private' stamp: ''!
metaclassShouldNotOverride
	^#(#name #comment)! !

!BlockLintRule class methodsFor: 'unnecessary code' stamp: ''!
justSendsSuper
	| detector matcher |
	detector := self new.
	detector name: 'Method just sends super message'.
	matcher := ParseTreeSearcher justSendsSuper.
	detector methodBlock: 
			[:context :result | 
			(context parseTree isPrimitive not 
				and: [matcher executeMethod: context parseTree initialAnswer: false]) 
					ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BlockLintRule class methodsFor: 'miscellaneous' stamp: ''!
variableAssignedLiteral
	| detector |
	detector := self new.
	detector
		name: 'Variable is only assigned a single literal value';
		resultClass: VariableEnvironment;
		openUsing: #openWithoutFilters.
	detector classBlock: 
			[:context :result | 
			| allSubclasses |
			allSubclasses := context selectedClass withAllSubclasses.
			context selectedClass instVarNames do: 
					[:each | 
					| defClass selector |
					(allSubclasses inject: 0
						into: 
							[:sum :class | 
							| sels |
							sels := class whichSelectorsAssign: each.
							sels size == 1 
								ifTrue: 
									[selector := sels asArray first.
									defClass := class].
							sum + sels size]) 
							== 1 
							ifTrue: 
								[| tree searcher |
								searcher := ParseTreeSearcher new.
								searcher matches: each , ' := ``@object'
									do: [:aNode :answer | answer isNil and: [aNode value isLiteral]].
								tree := defClass parseTreeFor: selector.
								tree notNil 
									ifTrue: 
										[(searcher executeTree: tree initialAnswer: nil) == true 
											ifTrue: [result addClass: context selectedClass instanceVariable: each]]]]].
	^detector! !

!BlockLintRule class methodsFor: 'private' stamp: ''!
badSelectors
	^#(#become: #isKindOf: #changeClassToThatOf: #respondsTo: #isMemberOf: #performMethod: #performMethod:arguments: #performMethod:with: #performMethod:with:with: #performMethod:with:with:with: #allOwners #allOwnersWeakly: #firstOwner #instVarAt: #instVarAt:put: #nextInstance #nextObject #ownerAfter: #primBecome:  #halt)! !

!BlockLintRule class methodsFor: 'unnecessary code' stamp: ''!
equivalentSuperclassMethods
	| detector |
	detector := self new.
	detector name: 'Methods equivalently defined in superclass'.
	detector methodBlock: 
			[:context :result | 
			context selectedClass superclass notNil ifTrue: 
					[(context selectedClass superclass canUnderstand: context selector)
						ifTrue: 
							[(((context selectedClass superclass
								whichClassIncludesSelector: context selector)
									compiledMethodAt: context selector)
									equivalentTo: context compiledMethod)
									ifTrue: [result addClass: context selectedClass selector: context selector]]]].
	^detector! !

!BlockLintRule class methodsFor: 'possible bugs' stamp: ''!
addRemoveDependents
	| detector |
	detector := self new.
	detector resultClass: ClassEnvironment.
	detector name: 'Number of addDependent: messages > removeDependent:'.
	detector classBlock: 
			[:context :result | 
			| count |
			count := 0.
			((Set
				withAll: (context selectedClass whichSelectorsReferTo: #addDependent:))
					addAll: (context selectedClass whichSelectorsReferTo: #removeDependent:);
				yourself) do: 
					[:sel | 
					(context selectedClass compiledMethodAt: sel) messagesDo: 
							[:each | 
							each == #addDependent: ifTrue: [count := count + 1].
							each == #removeDependent: ifTrue: [count := count - 1]]].
			count > 0 ifTrue: [result addClass: context selectedClass]].
	^detector! !

!BlockLintRule class methodsFor: 'private' stamp: ''!
utilityProtocols
	"If a method is defined in one of these protocols, then don't check if its a utility method."

	^#('*utilit*')! !

!BlockLintRule class methodsFor: 'private' stamp: ''!
superMessages
	^#(#release #postCopy #postBuildWith: #preBuildWith: #postOpenWith: #noticeOfWindowClose: #initialize)! !

!BlockLintRule class methodsFor: 'bugs' stamp: ''!
usesTrue
	| detector trueBinding falseBinding |
	detector := self new.
	trueBinding := Smalltalk associationAt: #True.
	falseBinding := Smalltalk associationAt: #False.
	detector name: 'Uses True/False instead of true/false'.
	detector methodBlock: 
			[:context :result | 
			| method |
			method := context compiledMethod.
			((method refersToLiteral: trueBinding)
				or: [method refersToLiteral: falseBinding]) ifTrue: 
						[result addClass: context selectedClass selector: context selector.
						result searchStrings: #('True' 'False')]].
	^detector! !

!BlockLintRule class methodsFor: 'private' stamp: ''!
classShouldNotOverride
	^#(#== #class)! !

!BlockLintRule methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	classBlock := [:context :aResult | ].
	methodBlock := [:context :aResult | ]! !

!BlockLintRule class methodsFor: 'possible bugs' stamp: ''!
collectionCopyEmpty
	| detector |
	detector := self new.
	detector
		name: 'Subclass of collection that has instance variable but doesn''t define copyEmpty'.
	detector resultClass: ClassEnvironment.
	detector classBlock: 
			[:context :result | 
			(context selectedClass isVariable 
					and: [(context selectedClass includesSelector: #copyEmpty:) not 
						and: [context selectedClass instVarNames isEmpty not
							and: [context selectedClass inheritsFrom: Collection]]])
				ifTrue: [result addClass: context selectedClass]].
	^detector! !

!BlockLintRule class methodsFor: 'private' stamp: ''!
longMethodSize
	^10! !

!BlockLintRule class methodsFor: 'unnecessary code' stamp: ''!
onlyReadOrWritten
	| detector |
	detector := self new.
	detector
		name: 'Instance variables not read AND written';
		resultClass: VariableEnvironment;
		openUsing: #openWithoutFilters.
	detector classBlock: 
			[:context :result | 
			| allSubclasses |
			allSubclasses := context selectedClass withAllSubclasses.
			context selectedClass instVarNames do: 
					[:each | 
					| isRead isWritten |
					isRead := false.
					isWritten := false.
					allSubclasses detect: 
							[:class | 
							isRead ifFalse: [isRead := (class whichSelectorsRead: each) isEmpty not].
							isWritten 
								ifFalse: [isWritten := (class whichSelectorsAssign: each) isEmpty not].
							isRead & isWritten]
						ifNone: [result addClass: context selectedClass instanceVariable: each]]].
	^detector! !

!BlockLintRule methodsFor: 'accessing' stamp: ''!
checkClass: aSmalllintContext 
	^classBlock value: aSmalllintContext value: result! !

!BlockLintRule methodsFor: 'initialize-release' stamp: ''!
classBlock: aBlock
	classBlock := aBlock! !

!BlockLintRule class methodsFor: 'bugs' stamp: 'bh 5/1/2000 16:56'!
variableNotDefined
	| detector |
	detector _ self new.
	detector name: 'Variable used, but not defined anywhere'.
self needsWork.
"	detector methodBlock: [:context :result | context compiledMethod withAllBlockMethodsDo: [:each | each
				literalsDo: [:lit | lit isVariableBinding
						ifTrue: [((Smalltalk associationAt: lit key ifAbsent: [])
								== lit or: [(Undeclared associationAt: lit key ifAbsent: [])
									== lit])
								ifFalse: [(context selectedClass fullBindingFor: lit key)
										== lit
										ifFalse: 
											[result addClass: context selectedClass selector: context selector.
											result addSearchString: lit key]]]]]]."
	^ detector
	! !

!BlockLintRule class methodsFor: 'bugs' stamp: ''!
subclassResponsibilityNotDefined
	| detector subclassResponsibilitySymbol |
	detector := self new.
	detector name: 'Subclass responsibility not defined'.
	subclassResponsibilitySymbol := 'subclassResponsibility' asSymbol.
	detector classBlock: 
			[:context :result | 
			(context selectedClass whichSelectorsReferTo: subclassResponsibilitySymbol)
				do: 
					[:each | 
					(context selectedClass withAllSubclasses detect: 
							[:class | 
							class subclasses isEmpty
								and: [(class whichClassIncludesSelector: each) == context selectedClass]]
						ifNone: [nil]) notNil
						ifTrue: [result addClass: context selectedClass selector: each]]].
	^detector! !

!BlockLintRule class methodsFor: 'miscellaneous' stamp: ''!
instVarInSubclasses
	| detector |
	detector := self new.
	detector
		name: 'Instance variables defined in all subclasses';
		resultClass: VariableEnvironment;
		openUsing: #openWithoutFilters.
	detector classBlock: 
			[:context :result | 
			| subs |
			subs := context selectedClass subclasses.
			subs size > 1 
				ifTrue: 
					[| sels |
					sels := Bag new.
					subs do: [:each | sels addAll: each instVarNames].
					sels asSet do: 
							[:val | 
							| count |
							count := sels occurrencesOf: val.
							count == subs size 
								ifTrue: [result addClass: context selectedClass instanceVariable: val]]]].
	^detector! !

!BlockLintRule methodsFor: 'initialize-release' stamp: ''!
methodBlock: aBlock
	methodBlock := aBlock! !

!BlockLintRule class methodsFor: 'possible bugs' stamp: ''!
sendsDifferentSuper
	| detector |
	detector := self new.
	detector name: 'Sends different super message'.
	detector methodBlock: 
			[:context :result | 
			| message |
			(message := context superMessages detect: [:each | each ~= context selector]
						ifNone: [nil]) notNil ifTrue: 
					[result addSearchString: message.
					result addClass: context selectedClass selector: context selector]].
	^detector! !

!BlockLintRule class methodsFor: 'possible bugs' stamp: 'bh 4/2/2000 22:09'!
returnsBooleanAndOther
	| detector matcher |
	detector := self new.
	detector name: 'Returns a boolean and non boolean'.
	matcher := ParseTreeSearcher new.
	matcher matches: '^``@xObject'
		do: 
			[:aNode :answer | 
			answer
				add: aNode value;
				yourself].
	detector methodBlock: 
			[:context :result | 
			| hasBool hasSelf |
			hasBool := false.
			hasSelf := context parseTree lastIsReturn not.
			(matcher executeTree: context parseTree initialAnswer: Set new) do: 
					[:each | 
					hasBool := hasBool or: 
									[(each isLiteral and: [{true. false} includes: each value]) 
										or: [each isMessage and: [#(#and: #or:) includes: each selector]]].
					hasSelf := hasSelf or: 
									[(each isVariable and: [each name = 'self']) 
										or: [each isLiteral and: [({true. false} includes: each value) not]]]].
			hasSelf & hasBool 
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BlockLintRule class methodsFor: 'possible bugs' stamp: ''!
definesEqualNotHash
	| detector |
	detector := self new.
	detector name: 'Defines = but not hash'.
	detector resultClass: ClassEnvironment.
	detector classBlock: 
			[:context :result | 
			((context selectedClass includesSelector: #=)
				and: [(context selectedClass includesSelector: #hash) not])
				ifTrue: [result addClass: context selectedClass]].
	^detector! !

!BlockLintRule class methodsFor: 'private' stamp: ''!
subclassOf: aClass overrides: aSelector 
	^(aClass subclasses detect: 
			[:each | 
			(each includesSelector: aSelector)
				or: [self subclassOf: each overrides: aSelector]]
		ifNone: [nil]) notNil! !

!BlockLintRule class methodsFor: 'possible bugs' stamp: ''!
tempVarOverridesInstVar
	| detector matcher vars varName |
	detector := self new.
	detector name: 'Instance variable overridden by temporary variable'.
	matcher := (ParseTreeSearcher new)
				matchesArgument: '`xxxvar'
					do: 
						[:aNode :answer | 
						answer or: 
								[varName := aNode name.
								vars includes: varName]];
				yourself.
	detector methodBlock: 
			[:context :result | 
			vars := context instVarNames.
			(matcher executeTree: context parseTree initialAnswer: false) 
				ifTrue: 
					[result addClass: context selectedClass selector: context selector.
					result addSearchString: varName]].
	^detector! !

!BlockLintRule class methodsFor: 'unnecessary code' stamp: ''!
variableReferencedOnce
	| detector |
	detector := self new.
	detector 
		name: 'Variable referenced in only one method and always assigned first'.
	detector classBlock: 
			[:context :result | 
			| allSubclasses |
			allSubclasses := context selectedClass withAllSubclasses.
			context selectedClass instVarNames do: 
					[:each | 
					| defClass selector |
					(allSubclasses inject: 0
						into: 
							[:sum :class | 
							| sels |
							sels := class whichSelectorsAccess: each.
							sels size == 1 
								ifTrue: 
									[selector := sels asArray first.
									defClass := class].
							sum + sels size]) 
							== 1 
							ifTrue: 
								[| tree |
								tree := defClass parseTreeFor: selector.
								tree notNil 
									ifTrue: 
										[(RBReadBeforeWrittenTester isVariable: each writtenBeforeReadIn: tree) 
											ifTrue: 
												[result addClass: defClass selector: selector.
												result addSearchString: each]]]]].
	^detector! !

!BasicLintRule methodsFor: 'private' stamp: 'dvf 9/8/2001 20:00'!
openWithFilters
	| browser navigator menuItem filter |
	self needsWork.
	browser := self filteredResult openEditor.
	navigator := browser navigator.
	filter := navigator environment andedEnvironment environment.
	(filter isClassEnvironment or: [filter isSelector]) 
		ifTrue: 
			[menuItem := MenuItem labeled: 'add filter for class'.
			menuItem value: 
					[(BasicLintRule filterFor: self name) addClass: navigator selectedClass.
					filter addClass: navigator selectedClass.
					navigator updateCategoryList].
			navigator classMenu value addItemGroup: (Array with: menuItem).
			navigator updateClassMenu].
	filter isSelector 
		ifTrue: 
			[menuItem := MenuItem labeled: 'add filter for selector'.
			menuItem value: 
					[(BasicLintRule filterFor: self name) addClass: navigator selectedClass
						selector: navigator selector.
					filter addClass: navigator selectedClass selector: navigator selector.
					navigator updateCategoryList].
			navigator selectorMenu value addItemGroup: (Array with: menuItem).
			navigator updateSelectorMenu].
	^browser! !

!BasicLintRule class methodsFor: 'accessing' stamp: ''!
filterDictionary
	^FilterDictionary isNil 
		ifTrue: [FilterDictionary := Dictionary new]
		ifFalse: [FilterDictionary]! !

!BasicLintRule methodsFor: 'accessing' stamp: ''!
filteredResult
	^(result 
		& (self class filterDictionary at: self name ifAbsent: [result copyEmpty]) 
				copy not)
		label: result label;
		yourself! !

!BasicLintRule methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	openSymbol := #openWithFilters.
	self resultClass: self defaultResultClass! !

!BasicLintRule class methodsFor: 'accessing' stamp: ''!
filterDictionary: aDictionary 
	FilterDictionary := aDictionary! !

!BasicLintRule methodsFor: 'private' stamp: ''!
defaultResultClass
	^SelectorEnvironment! !

!LintRule methodsFor: 'testing' stamp: ''!
isEmpty
	self subclassResponsibility! !

!LintRule methodsFor: 'testing' stamp: ''!
isComposite
	^false! !

!LintRule methodsFor: 'private' stamp: 'bh 5/9/2000 00:17'!
viewResults
	self subclassResponsibility! !

!LintRule methodsFor: 'printing' stamp: ''!
printOn: aStream 
	name isNil
		ifTrue: [super printOn: aStream]
		ifFalse: [aStream nextPutAll: name]! !

!LintRule methodsFor: 'accessing' stamp: ''!
name: aString 
	name := aString! !

!LintRule methodsFor: 'initialize-release' stamp: ''!
initialize! !

LintRule subclass: #CompositeLintRule
	instanceVariableNames: 'rules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Lint'!

!CompositeLintRule methodsFor: 'accessing' stamp: ''!
problemCount
	^rules inject: 0 into: [:count :each | count + each problemCount]! !

!CompositeLintRule methodsFor: 'private' stamp: 'bh 5/9/2000 00:17'!
viewResults
	rules do: [:each | each viewResults]! !

!CompositeLintRule class methodsFor: 'instance creation' stamp: ''!
ruleFor: aClass protocol: aProtocol 
	| allRules |
	allRules := aClass withAllSubclasses inject: OrderedCollection new
				into: 
					[:sum :each | 
					sum
						addAll: ((BrowserEnvironment new selectorsFor: aProtocol asSymbol
									in: each class) collect: [:selector | each perform: selector]);
						yourself].
	^self rules: (allRules asSortedCollection: [:a :b | a name < b name])
		name: ((aProtocol asString copy)
				at: 1 put: aProtocol first asUppercase;
				yourself)! !

!CompositeLintRule methodsFor: 'accessing' stamp: ''!
checkClass: aSmalllintContext 
	rules do: 
			[:each | 
			each checkClass: aSmalllintContext.
			Processor yield]! !

!CompositeLintRule methodsFor: 'testing' stamp: ''!
isEmpty
	^(rules detect: [:each | each isEmpty not] ifNone: [nil]) isNil! !

!CompositeLintRule methodsFor: 'accessing' stamp: ''!
failedRules
	^rules inject: OrderedCollection new into: [:oc :each | oc addAll: each failedRules; yourself]! !

!CompositeLintRule methodsFor: 'testing' stamp: ''!
isComposite
	^true! !

!CompositeLintRule class methodsFor: 'instance creation' stamp: ''!
rules: aCollection 
	^self new rules: aCollection! !

!CompositeLintRule class methodsFor: 'instance creation' stamp: ''!
allRules
	^self ruleFor: self protocol: 'all checks'! !

!CompositeLintRule class methodsFor: 'all checks' stamp: ''!
transformations
	^self ruleFor: TransformationRule protocol: 'transformations'! !

!CompositeLintRule methodsFor: 'initialize-release' stamp: ''!
resetResult
	rules do: [:each | each resetResult]! !

!CompositeLintRule methodsFor: 'testing' stamp: ''!
hasConflicts
	^(rules detect: [:each | each hasConflicts] ifNone: [nil]) notNil! !

!CompositeLintRule methodsFor: 'accessing' stamp: ''!
rules
	^rules! !

!CompositeLintRule class methodsFor: 'instance creation' stamp: ''!
rules: aCollection name: aString 
	^(self new) rules: aCollection;
		name: aString;
		yourself! !

!CompositeLintRule class methodsFor: 'all checks' stamp: ''!
lintChecks
	^self rules: (BasicLintRule protocols
				collect: [:each | self ruleFor: BasicLintRule protocol: each])
		name: 'Lint checks'! !

!CompositeLintRule methodsFor: 'initialize-release' stamp: ''!
rules: aCollection
	rules := aCollection! !

!CompositeLintRule methodsFor: 'accessing' stamp: ''!
checkMethod: aSmalllintContext 
	rules do: 
			[:each | 
			each checkMethod: aSmalllintContext.
			Processor yield]! !

!LintRule methodsFor: 'initialize-release' stamp: ''!
resetResult! !

!LintRule methodsFor: 'accessing' stamp: 'bh 5/9/2000 00:17'!
openEditor
	| rules |
	rules := self failedRules.
	rules isEmpty ifTrue: [^self].
	rules size == 1 ifTrue: [^rules first viewResults].
	SmalllintResultEditor openOn: self label: name! !

!LintRule methodsFor: 'testing' stamp: ''!
hasConflicts
	^false! !

!LintRule methodsFor: 'accessing' stamp: 'nk 11/12/2002 13:11'!
runOnEnvironment: anEnvironment 
	^SmalllintChecker runRule: self onEnvironment: anEnvironment! !

!LintRule methodsFor: 'private' stamp: ''!
failedRules
	^self isEmpty
		ifTrue: [#()]
		ifFalse: [Array with: self]! !

!LintRule methodsFor: 'accessing' stamp: 'nk 11/12/2002 13:11'!
run
	^SmalllintChecker runRule: self! !

LintRule subclass: #TransformationRule
	instanceVariableNames: 'rewriteRule builder class'
	classVariableNames: 'RecursiveSelfRule'
	poolDictionaries: ''
	category: 'Refactory-Lint'!

!TransformationRule class methodsFor: 'transformations' stamp: ''!
atIfAbsent
	^self rewrite: #(
			#('``@dictionary at: ``@key 
					ifAbsent: [| `@temps | 
							``@.Statements1.
							``@dictionary at: ``@key put: ``@object.
							``@.Statements2.
							``@object]'
			"->"
			'``@dictionary at: ``@key
					ifAbsentPut: [| `@temps |
							``@.Statements1.
							``@.Statements2.
							``@object]')
			#('``@dictionary at: ``@key
					ifAbsent: [| `@temps |
							``@.Statements.
							``@dictionary at: ``@key put: ``@object]'
			"->"
			'``@dictionary at: ``@key
					ifAbsentPut: [| `@temps |
							``@.Statements.
							``@object]'))
		methods: false
		name: 'at:ifAbsent: -> at:ifAbsentPut:'! !

!TransformationRule methodsFor: 'testing' stamp: ''!
isEmpty
	^builder changes isEmpty! !

!TransformationRule class methodsFor: 'instance creation' stamp: ''!
rewrite: stringArrays methods: aBoolean name: aName 
	| rewriteRule |
	rewriteRule := ParseTreeRewriter new.
	stringArrays do: 
			[:each | 
			aBoolean 
				ifTrue: [rewriteRule replaceMethod: each first with: each last]
				ifFalse: [rewriteRule replace: each first with: each last]].
	^(self new)
		name: aName;
		rewriteUsing: rewriteRule;
		yourself! !

!TransformationRule class methodsFor: 'transformations' stamp: ''!
superSends
	^(self new)
		name: 'Rewrite super messages to self messages when both refer to same method';
		superSends;
		yourself! !

!TransformationRule class methodsFor: 'transformations' stamp: ''!
unwindBlocks
	^self
		rewrite: #(
			#('[| `@temps | ``@.Statements. `var := ``@object] valueNowOrOnUnwindDo: ``@block'
				"->"	'`var := [| `@temps | ``@.Statements. ``@object] valueNowOrOnUnwindDo: ``@block') 
			#('[| `@temps | ``@.Statements. ^``@object] valueNowOrOnUnwindDo: ``@block'
				"->"	'^[| `@temps | ``@.Statements. ``@object] valueNowOrOnUnwindDo: ``@block') 
			#('[| `@temps | ``@.Statements. `var := ``@object] valueOnUnwindDo: ``@block'
				"->"	'`var := [| `@temps | ``@.Statements. ``@object] valueOnUnwindDo: ``@block') 
			#('[| `@temps | ``@.Statements. ^``@object] valueOnUnwindDo: ``@block'
				"->"	'^[| `@temps | ``@.Statements. ``@object] valueOnUnwindDo: ``@block'))
		methods: false
		name: 'Move assignment out of valueNowOrUnwindDo: blocks'! !

!TransformationRule class methodsFor: 'transformations' stamp: ''!
notElimination
	^self
		rewrite: #(
			#('``@object not not'	"->"	'``@object') 
			#('``@object not ifTrue: ``@block' 	"->"	'``@object ifFalse: ``@block') 
			#('``@object not ifFalse: ``@block'	"->"	'``@object ifTrue: ``@block') 
			#('``@collection select: [:`each | | `@temps | ``@.Statements. ``@object not]'
				"->"	'``@collection reject: [:`each | | `@temps | ``@.Statements. ``@object]')
			#('``@collection reject: [:`each | | `@temps | ``@.Statements. ``@object not]'
				"->"	'``@collection select: [:`each | | `@temps | ``@.Statements. ``@object]')
			#('[| `@temps | ``@.Statements. ``@object not] whileTrue: ``@block'
				"->"	'[| `@temps | ``@.Statements. ``@object] whileFalse: ``@block')
			#('[| `@temps | ``@.Statements. ``@object not] whileFalse: ``@block'
				"->"	'[| `@temps | ``@.Statements. ``@object] whileTrue: ``@block')
			#('[| `@temps | ``@.Statements. ``@object not] whileTrue'
				"->"	'[| `@temps | ``@.Statements. ``@object] whileFalse')
			#('[| `@temps | ``@.Statements. ``@object not] whileFalse'
				"->"	'[| `@temps | ``@.Statements. ``@object] whileTrue')
			#('(``@a <= ``@b) not' "->" '``@a > ``@b')
			#('(``@a < ``@b) not' "->" '``@a >= ``@b')
			#('(``@a = ``@b) not' "->" '``@a ~= ``@b')
			#('(``@a == ``@b) not' "->" '``@a ~~ ``@b')
			#('(``@a ~= ``@b) not' "->" '``@a = ``@b')
			#('(``@a ~~ ``@b) not' "->" '``@a == ``@b')
			#('(``@a >= ``@b) not' "->" '``@a < ``@b')
			#('(``@a > ``@b) not' "->" '``@a <= ``@b'))			
		methods: false
		name: 'Eliminate unnecessary not''s'! !

!TransformationRule methodsFor: 'private' stamp: ''!
viewResults
	"I reset the result so that we don't fill up memory with methods to compile in the builder."

	builder inspect.
	self resetResult! !

!TransformationRule methodsFor: 'accessing' stamp: ''!
resetResult
	builder := CompositeRefactoryChange named: 'Some transformations'! !

!TransformationRule methodsFor: 'accessing' stamp: ''!
checkMethod: aSmalllintContext 
	(rewriteRule canMatchMethod: aSmalllintContext compiledMethod) 
		ifFalse: [^self].
	class := aSmalllintContext selectedClass.
	(rewriteRule executeTree: aSmalllintContext parseTree) 
		ifTrue: 
			[(self class recursiveSelfRule executeTree: rewriteRule tree
				initialAnswer: false) 
					ifFalse: 
						[builder 
							compile: rewriteRule tree printString
							in: class
							classified: aSmalllintContext protocol]]! !

!TransformationRule class methodsFor: 'accessing' stamp: ''!
initializeRecursiveSelfRule
	RecursiveSelfRule := ParseTreeSearcher new.
	RecursiveSelfRule 
		matchesAnyMethodOf: 
			#('`@methodName: `@args | `@temps | self `@methodName: `@args1' 
			'`@methodName: `@args | `@temps | ^self `@methodName: `@args1')
		do: [:aNode :answer | true].
	^RecursiveSelfRule! !

!TransformationRule class methodsFor: 'accessing' stamp: ''!
recursiveSelfRule
	^RecursiveSelfRule isNil 
		ifTrue: [self initializeRecursiveSelfRule]
		ifFalse: [RecursiveSelfRule]! !

!TransformationRule class methodsFor: 'transformations' stamp: ''!
betweenAnd
	^self rewrite: #(
			#('``@a >= ``@b and: [``@a <= ``@c]' "->" '``@a between: ``@b and: ``@c')
			#('``@a >= ``@b & (``@a <= ``@c)' "->" '``@a between: ``@b and: ``@c')
			#('``@b <= ``@a and: [``@a <= ``@c]' "->" '``@a between: ``@b and: ``@c')
			#('``@b <= ``@a & (``@a <= ``@c)' "->" '``@a between: ``@b and: ``@c')
			#('``@a <= ``@c and: [``@a >= ``@b]' "->" '``@a between: ``@b and: ``@c')
			#('``@a <= ``@c & (``@a >= ``@b)' "->" '``@a between: ``@b and: ``@c')
			#('``@c >= ``@a and: [``@a >= ``@b]' "->" '``@a between: ``@b and: ``@c')
			#('``@c >= ``@a & (``@a >= ``@b)' "->" '``@a between: ``@b and: ``@c')
			#('``@a >= ``@b and: [``@c >= ``@a]' "->" '``@a between: ``@b and: ``@c')
			#('``@a >= ``@b & (``@c >= ``@a)' "->" '``@a between: ``@b and: ``@c')
			#('``@b <= ``@a and: [``@c >= ``@a]' "->" '``@a between: ``@b and: ``@c')
			#('``@b <= ``@a & (``@c >= ``@a)' "->" '``@a between: ``@b and: ``@c')
			#('``@a <= ``@c and: [``@b <= ``@a]' "->" '``@a between: ``@b and: ``@c')
			#('``@a <= ``@c & (``@b <= ``@a)' "->" '``@a between: ``@b and: ``@c')
			#('``@c >= ``@a and: [``@b <= ``@a]' "->" '``@a between: ``@b and: ``@c')
			#('``@c >= ``@a & (``@b <= ``@a)' "->" '``@a between: ``@b and: ``@c'))
		methods: false
		name: '"a >= b and: [a <= c]" -> "a between: b and: c"'! !

!TransformationRule class methodsFor: 'transformations' stamp: ''!
equalNil
	^self
		rewrite: #(
			#('``@object = nil'	"->"	'``@object isNil') 
			#('``@object == nil'	"->"	'``@object isNil') 
			#('``@object ~= nil'	"->"	'``@object notNil') 
			#('``@object ~~ nil'	"->"	'``@object notNil'))
		methods: false
		name: '= nil -> isNil AND ~= nil -> notNil'! !

!TransformationRule class methodsFor: 'transformations' stamp: ''!
minMax
	^self rewrite: #(
			#('``@a < ``@b ifTrue: [``@a] ifFalse: [``@b]'	"->"	'``@a min: ``@b')
			#('``@a <= ``@b ifTrue: [``@a] ifFalse: [``@b]'	"->"	'``@a min: ``@b')
			#('``@a > ``@b ifTrue: [``@a] ifFalse: [``@b]'	"->"	'``@a max: ``@b')
			#('``@a >= ``@b ifTrue: [``@a] ifFalse: [``@b]'	"->"	'``@a max: ``@b')
			#('``@a < ``@b ifTrue: [``@b] ifFalse: [``@a]'	"->"	'``@a max: ``@b')
			#('``@a <= ``@b ifTrue: [``@b] ifFalse: [``@a]'	"->"	'``@a max: ``@b')
			#('``@a > ``@b ifTrue: [``@b] ifFalse: [``@a]'	"->"	'``@a min: ``@b')
			#('``@a >= ``@b ifTrue: [``@b] ifFalse: [``@a]'	"->"	'``@a min: ``@b')
			#('`a < ``@b ifTrue: [`a := ``@b]'				"->"	'`a := `a max: ``@b')
			#('`a <= ``@b ifTrue: [`a := ``@b]'				"->"	'`a := `a max: ``@b')
			#('`a < ``@b ifFalse: [`a := ``@b]'				"->"	'`a := `a min: ``@b')
			#('`a <= ``@b ifFalse: [`a := ``@b]'			"->"	'`a := `a min: ``@b')
			#('`a > ``@b ifTrue: [`a := ``@b]'				"->"	'`a := `a min: ``@b')
			#('`a >= ``@b ifTrue: [`a := ``@b]'				"->"	'`a := `a min: ``@b')
			#('`a > ``@b ifFalse: [`a := ``@b]'				"->"	'`a := `a max: ``@b')
			#('`a >= ``@b ifFalse: [`a := ``@b]'			"->"	'`a := `a max: ``@b')
			#('``@b < `a ifTrue: [`a := ``@b]'				"->"	'`a := `a min: ``@b')
			#('``@b <= `a ifTrue: [`a := ``@b]'				"->"	'`a := `a min: ``@b')
			#('``@b < `a ifFalse: [`a := ``@b]'				"->"	'`a := `a max: ``@b')
			#('``@b <= `a ifFalse: [`a := ``@b]'			"->"	'`a := `a max: ``@b')
			#('``@b > `a ifTrue: [`a := ``@b]'				"->"	'`a := `a max: ``@b')
			#('``@b >= `a ifTrue: [`a := ``@b]'				"->"	'`a := `a max: ``@b')
			#('``@b > `a ifFalse: [`a := ``@b]'				"->"	'`a := `a min: ``@b')
			#('``@b >= `a ifFalse: [`a := ``@b]'			"->"	'`a := `a min: ``@b'))
		methods: false
		name: 'Rewrite ifTrue:ifFalse: using min:/max:'! !

!TransformationRule methodsFor: 'testing' stamp: ''!
hasConflicts
	^true! !

!TransformationRule class methodsFor: 'transformations' stamp: ''!
detectIfNone
	^self rewrite: #(
			#('(``@collection detect: [:`each | | `@temps | ``@.Statements] ifNone: [nil]) isNil'
				"->"	'(``@collection contains: [:`each | | `@temps | ``@.Statements]) not')
			#('(``@collection detect: [:`each | | `@temps | ``@.Statements] ifNone: [nil]) = nil'
				"->"	'(``@collection contains: [:`each | | `@temps | ``@.Statements]) not')
			#('(``@collection detect: [:`each | | `@temps | ``@.Statements] ifNone: [nil]) == nil'
				"->"	'(``@collection contains: [:`each | | `@temps | ``@.Statements]) not')
			#('(``@collection detect: [:`each | | `@temps | ``@.Statements] ifNone: [nil]) notNil'
				"->"	'``@collection contains: [:`each | | `@temps | ``@.Statements]')
			#('(``@collection detect: [:`each | | `@temps | ``@.Statements] ifNone: [nil]) ~= nil'
				"->"	'``@collection contains: [:`each | | `@temps | ``@.Statements]')
			#('(``@collection detect: [:`each | | `@temps | ``@.Statements] ifNone: [nil]) ~~ nil'
				"->"	'``@collection contains: [:`each | | `@temps | ``@.Statements]'))
		methods: false
		name: 'detect:ifNone: -> contains:'! !

!TransformationRule class methodsFor: 'transformations' stamp: ''!
assignmentInIfTrue
	^self rewrite: #(
			#('``@Boolean ifTrue: [`variable := ``@true] ifFalse: [`variable := ``@false]'
			"->"
			'`variable := ``@Boolean ifTrue: [``@true] ifFalse: [``@false]')
			#('``@Boolean ifFalse: [`variable := ``@true] ifTrue: [`variable := ``@false]'
			"->"
			'`variable := ``@Boolean ifFalse: [``@true] ifTrue: [``@false]'))
		methods: false
		name: 'Move variable assignment outside of single statement ifTrue:ifFalse: blocks'! !

!TransformationRule class methodsFor: 'transformations' stamp: ''!
guardClause
	^self
		rewrite: #(
			#('`@methodName: `@args 
					| `@temps | 
					`@.Statements. 
					`@condition ifTrue: [| `@trueTemps | `.Statement1. `.Statement2. `@.Statements1]'
			"->"
			'`@methodName: `@args
					| `@temps `@trueTemps |
					`@.Statements.
					`@condition ifFalse: [^self].
					`.Statement1.
					`.Statement2.
					`@.Statements1') 
			#('`@methodName: `@args 
					| `@temps | 
					`@.Statements. 
					`@condition ifFalse: [| `@falseTemps | `.Statement1. `.Statement2. `@.Statements1]'
			"->"
			'`@methodName: `@args
					| `@temps `@falseTemps |
					`@.Statements.
					`@condition ifTrue: [^self].
					`.Statement1.
					`.Statement2.
					`@.Statements1'))
		methods: true
		name: 'Eliminate guarding clauses'! !

!TransformationRule methodsFor: 'rules' stamp: ''!
superSends
	| rule |
	rule := ParseTreeRewriter new.
	rule 
		replace: 'super `@message: ``@args'
		with: 'self `@message: ``@args'
		when: 
			[:aNode | 
			(class withAllSubclasses 
				detect: [:each | each includesSelector: aNode selector]
				ifNone: [nil]) isNil].
	self rewriteUsing: rule! !

!TransformationRule methodsFor: 'accessing' stamp: ''!
problemCount
	^builder problemCount! !

!TransformationRule class methodsFor: 'transformations' stamp: ''!
showWhileBlocks
	^self
		rewrite: #(
			#('``@cursor showWhile: [| `@temps | ``@.Statements. `var := ``@object]'
				"->"	'`var := ``@cursor showWhile: [| `@temps | ``@.Statements. ``@object]') 
			#('``@cursor showWhile: [| `@temps | ``@.Statements. ^``@object]'
				"->"	'^``@cursor showWhile: [| `@temps | ``@.Statements. ``@object]'))
		methods: false
		name: 'Move assignment out of showWhile: blocks'! !

!TransformationRule class methodsFor: 'transformations' stamp: ''!
cascadedNextPutAlls
	^self
		rewrite: #(
			#('``@rcvr nextPutAll: ``@object1 , ``@object2'
					"->"
				'``@rcvr nextPutAll: ``@object1; nextPutAll: ``@object2')
			#('``@rcvr show: ``@object1 , ``@object2'
					"->"
				'``@rcvr show: ``@object1; show: ``@object2'))
		methods: false
		name: 'Use cascaded nextPutAll:''s instead of #, in #nextPutAll:'! !

!TransformationRule methodsFor: 'initialize-release' stamp: ''!
rewriteUsing: searchReplacer 
	rewriteRule := searchReplacer.
	self resetResult! !

!LintRule methodsFor: 'accessing' stamp: ''!
name
	^name! !

Object subclass: #RBToken
	instanceVariableNames: 'sourcePointer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Tokens'!

!RBToken methodsFor: 'accessing' stamp: ''!
start
	^sourcePointer! !

!RBToken methodsFor: 'testing' stamp: ''!
isPatternVariable
	^false! !

!RBToken methodsFor: 'accessing' stamp: ''!
stop
	^self start + self length - 1! !

!RBToken methodsFor: 'testing' stamp: ''!
isBinary
	^false! !

!RBToken methodsFor: 'accessing' stamp: ''!
length
	^self subclassResponsibility! !

RBToken subclass: #RBOptimizedToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Tokens'!

!RBOptimizedToken methodsFor: 'testing' stamp: 'ls 1/11/2000 07:00'!
isOptimized
	^true! !

!RBOptimizedToken methodsFor: 'private' stamp: ''!
length
	^3! !

!RBToken methodsFor: 'testing' stamp: ''!
isSpecial
	^false! !

!RBToken methodsFor: 'accessing' stamp: ''!
removePositions
	sourcePointer := nil! !

!RBToken methodsFor: 'testing' stamp: ''!
isLiteral
	^false! !

!RBToken methodsFor: 'testing' stamp: ''!
isAssignment
	^false! !

RBToken subclass: #RBAssignmentToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Tokens'!

!RBAssignmentToken methodsFor: 'testing' stamp: ''!
isAssignment
	^true! !

RBAssignmentToken subclass: #RBShortAssignmentToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Tokens'!

!RBShortAssignmentToken methodsFor: 'private' stamp: 'ls 1/11/2000 07:00'!
length
	^1! !

!RBAssignmentToken methodsFor: 'private' stamp: 'ls 1/11/2000 07:00'!
length
	^2! !

!RBToken methodsFor: 'testing' stamp: ''!
isOptimized
	^false! !

RBToken subclass: #RBValueToken
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Tokens'!

RBValueToken subclass: #RBLiteralToken
	instanceVariableNames: 'stopPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Tokens'!

!RBLiteralToken methodsFor: 'accessing' stamp: ''!
realValue
	^value class == Array
		ifTrue: [value collect: [:each | each realValue]]
		ifFalse: [value]! !

!RBLiteralToken class methodsFor: 'instance creation' stamp: ''!
value: aString start: anInteger stop: stopInteger 
	^self new
		value: aString
		start: anInteger
		stop: stopInteger! !

!RBLiteralToken methodsFor: 'private' stamp: ''!
length
	^stopPosition - self start + 1! !

!RBLiteralToken methodsFor: 'initialize-release' stamp: ''!
value: aString start: anInteger stop: stopInteger 
	value := aString.
	sourcePointer := anInteger.
	stopPosition := stopInteger! !

!RBLiteralToken methodsFor: 'testing' stamp: ''!
isLiteral
	^true! !

!RBLiteralToken class methodsFor: 'instance creation' stamp: ''!
value: anObject 
	| literal |
	literal := anObject class == Array 
				ifTrue: [anObject collect: [:each | self value: each]]
				ifFalse: [anObject].
	^self 
		value: literal
		start: nil
		stop: nil! !

!RBLiteralToken methodsFor: 'accessing' stamp: ''!
stop: anObject 
	stopPosition := anObject! !

RBValueToken subclass: #RBKeywordToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Tokens'!

!RBKeywordToken methodsFor: 'testing' stamp: ''!
isKeyword
	^true! !

!RBKeywordToken methodsFor: 'testing' stamp: 'md 8/26/2004 18:37'!
isPatternVariable
		^value first == $`.
		"value first == RBScanner patternVariableCharacter"! !

!RBValueToken methodsFor: 'private' stamp: ''!
length
	^value size! !

!RBValueToken methodsFor: 'accessing' stamp: ''!
value: anObject
	value := anObject! !

!RBValueToken class methodsFor: 'instance creation' stamp: ''!
value: aString start: anInteger 
	^self new value: aString start: anInteger! !

!RBValueToken methodsFor: 'printing' stamp: ''!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	value printOn: aStream.
	aStream nextPutAll: ')'! !

!RBValueToken methodsFor: 'initialize-release' stamp: ''!
value: aString start: anInteger 
	value := aString.
	sourcePointer := anInteger! !

!RBValueToken methodsFor: 'accessing' stamp: ''!
value
	^value! !

RBValueToken subclass: #RBBinarySelectorToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Tokens'!

!RBBinarySelectorToken methodsFor: 'testing' stamp: ''!
isBinary
	^true! !

RBValueToken subclass: #RBIdentifierToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Tokens'!

!RBIdentifierToken methodsFor: 'testing' stamp: ''!
isIdentifier
	^true! !

!RBIdentifierToken methodsFor: 'testing' stamp: 'md 8/26/2004 18:36'!
isPatternVariable
	^value first == $`.
		"value first == RBScanner patternVariableCharacter"! !

RBValueToken subclass: #RBPatternBlockToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Tokens'!

!RBPatternBlockToken methodsFor: 'testing' stamp: ''!
isPatternBlock
	^true! !

RBValueToken subclass: #RBSpecialCharacterToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Tokens'!

!RBSpecialCharacterToken methodsFor: 'private' stamp: ''!
length
	^1! !

!RBSpecialCharacterToken methodsFor: 'testing' stamp: ''!
isSpecial
	^true! !

!RBToken methodsFor: 'testing' stamp: ''!
isPatternBlock
	^false! !

!RBToken methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPut: $ ;
		nextPutAll: self class name! !

!RBToken class methodsFor: 'instance creation' stamp: 'ls 1/11/2000 07:00'!
start: anInterval 
	^self new start: anInterval! !

!RBToken methodsFor: 'testing' stamp: ''!
isIdentifier
	^false! !

!RBToken methodsFor: 'initialize-release' stamp: ''!
start: anInteger 
	sourcePointer := anInteger! !

!RBToken methodsFor: 'testing' stamp: ''!
isKeyword
	^false! !

Object subclass: #BrowserEnvironment
	instanceVariableNames: 'label searchStrings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Environments'!

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
selectMethods: aBlock 
	| env |
	env := SelectorEnvironment onEnvironment: self.
	self classesAndSelectorsDo: 
			[:each :sel | 
			(aBlock value: (each compiledMethodAt: sel)) 
				ifTrue: [env addClass: each selector: sel]].
	^env! !

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
not
	self isSystem ifTrue: [^SelectorEnvironment new].
	^NotEnvironment onEnvironment: self! !

!BrowserEnvironment methodsFor: 'accessing-classes' stamp: 'dvf 10/9/2001 16:14'!
associationAt: aKey
	| association class |
	association := Smalltalk associationAt: aKey ifAbsent: [^nil].
	class := association value isBehavior
				ifTrue: [association value]
				ifFalse: [association value class].
	^((self includesClass: class) or: [self includesClass: class class])
		ifTrue: [association]
		ifFalse: [nil]! !

!BrowserEnvironment methodsFor: 'copying' stamp: ''!
copyEmpty
	^self class new! !

!BrowserEnvironment methodsFor: 'testing' stamp: ''!
includesSelector: aSelector in: aClass
	^true! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
classNamesFor: aCategoryName
	^(Smalltalk organization listAtCategoryNamed: aCategoryName)
		select:
			[:each |
			| class |
			class := Smalltalk at: each ifAbsent: [nil].
			class notNil and: [(self includesClass: class)
					or: [self includesClass: class class]]]! !

!BrowserEnvironment methodsFor: 'accessing' stamp: 'rr 4/19/2004 16:06'!
asSelectorEnvironment
	"default implementation ?"
	^ self subclassResponsibility! !

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
instVarReadersTo: instVarName in: aClass 
	^VariableEnvironment 
		on: self
		readersOfInstanceVariable: instVarName
		in: aClass! !

!BrowserEnvironment methodsFor: 'testing' stamp: ''!
isClassEnvironment
	^false! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
searchStrings: aCollection 
	searchStrings := aCollection! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
selectorsForClass: aClass 
	| selectors |
	selectors := Set new: 50.
	self selectorsForClass: aClass do: [:each | selectors add: each].
	^selectors! !

!BrowserEnvironment methodsFor: 'accessing' stamp: 'bh 5/8/2000 21:03'!
selectionParseTreeIntervalFor: aString 
	| parseTree answerBlock |
	parseTree := RBParser parseMethod: aString onError: [:str :pos | ^nil].
	answerBlock := [:aNode :answer | ^aNode sourceInterval].
	self searchStrings do: 
			[:each | 
			| matcher tree |
			matcher := ParseTreeSearcher new.
			each isSymbol 
				ifTrue: 
					[matcher matchesTree: (RBLiteralNode value: each) do: answerBlock.
					tree := ParseTreeSearcher buildSelectorTree: each.
					tree notNil ifTrue: [matcher matchesTree: tree do: answerBlock]]
				ifFalse: 
					[tree := RBVariableNode named: each.
					matcher
						matchesTree: tree do: answerBlock;
						matchesArgumentTree: tree do: answerBlock].
			matcher executeTree: parseTree].
	^nil! !

!BrowserEnvironment methodsFor: 'accessing-classes' stamp: ''!
at: aKey ifAbsent: aBlock
	| assoc |
	assoc := self associationAt: aKey.
	^assoc isNil
		ifTrue: [aBlock value]
		ifFalse: [assoc value]! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
categories
	^Smalltalk organization categories select: [:each | self includesCategory: each]! !

!BrowserEnvironment methodsFor: 'testing' stamp: ''!
isEmpty
	^false! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
selectorsForClass: aClass do: aBlock 
	aClass selectorsAndMethodsDo: 
			[:each :meth | 
			(self includesSelector: each in: aClass) ifTrue: [aBlock value: each]]! !

!BrowserEnvironment methodsFor: 'environments' stamp: 'dvf 9/21/2003 19:13'!
forPackage: aPackageInfo
	| retval |
	retval _ SelectorEnvironment new.
	aPackageInfo coreMethods do: [ :mr | retval addClass: mr actualClass selector: mr methodSymbol].
	aPackageInfo extensionMethods do: [ :mr | retval addClass: mr actualClass selector: mr methodSymbol].
	^retval! !

!BrowserEnvironment methodsFor: 'accessing-classes' stamp: ''!
classes
	| classes |
	classes := Set new.
	self classesDo: [:each | classes add: each].
	^classes! !

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
implementorsMatching: aString 
	^SelectorEnvironment implementorsMatching: aString in: self! !

!BrowserEnvironment methodsFor: 'accessing-classes' stamp: ''!
at: aKey
	^self at: aKey ifAbsent: [Smalltalk keyNotFoundError: aKey]! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
addSearchString: aString 
	searchStrings isNil ifTrue: 
			[searchStrings := SortedCollection sortBlock: 
							[:a :b | 
							(a indexOf: $: ifAbsent: [a size]) > (b indexOf: $: ifAbsent: [b size])]].
	searchStrings add: aString! !

!BrowserEnvironment methodsFor: 'printing' stamp: ''!
printOn: aStream
	aStream nextPutAll: self label! !

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
forClass: aClass selectors: selectorCollection 
	^(SelectorEnvironment 
		onMethods: selectorCollection
		forClass: aClass
		in: self)
		label: aClass name , '>>' 
					, (selectorCollection detect: [:each | true] ifNone: ['']);
		yourself! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
numberSelectors
	| total |
	total := 0.
	self 
		allClassesDo: [:each | self selectorsForClass: each do: [:sel | total := total + 1]].
	^total! !

!BrowserEnvironment methodsFor: 'testing' stamp: ''!
isSystem
	^true! !

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
implementorsOf: aSelector 
	^SelectorEnvironment implementorsOf: aSelector in: self! !

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
referencesTo: aLiteral in: aClass 
	| classes |
	classes := aClass withAllSuperclasses asSet.
	classes
		addAll: aClass allSubclasses;
		addAll: aClass class withAllSuperclasses;
		addAll: aClass class allSubclasses.
	^(self forClasses: classes) referencesTo: aLiteral! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
protocolsFor: aClass
	^aClass organization categories select: [:each | self includesProtocol: each in: aClass]! !

!BrowserEnvironment methodsFor: 'private' stamp: ''!
label
	^label isNil
		ifTrue: [self defaultLabel]
		ifFalse: [label]! !

!BrowserEnvironment methodsFor: 'accessing-classes' stamp: ''!
keys
	| keys |
	keys := Set new.
	Smalltalk keysAndValuesDo: 
			[:key :value | 
			| class |
			value isBehavior 
				ifTrue: [(self includesClass: value) ifTrue: [keys add: key]].
			class := value class.
			(self includesClass: class) ifTrue: [keys add: key]].
	^keys! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
numberClasses
	^self classNames size! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
whichCategoryIncludes: aClassName
	^Smalltalk organization categoryOfElement: aClassName! !

BrowserEnvironment subclass: #BrowserEnvironmentWrapper
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Environments'!

!BrowserEnvironmentWrapper class methodsFor: 'instance creation' stamp: ''!
onEnvironment: anEnvironment 
	^(self basicNew)
		initialize;
		onEnvironment: anEnvironment;
		yourself! !

BrowserEnvironmentWrapper subclass: #ClassEnvironment
	instanceVariableNames: 'classes metaClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Environments'!

!ClassEnvironment methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	classes := Set new.
	metaClasses := Set new! !

!ClassEnvironment methodsFor: 'printing' stamp: 'bh 6/10/2000 17:39'!
metaClassSelectorDictionary

	^metaClasses inject:Dictionary new into:
		[:answer :class |
		answer at:class put:(Smalltalk at:class) class selectors;
			yourself].	! !

!ClassEnvironment methodsFor: 'testing' stamp: ''!
includesClass: aClass 
	^(aClass isMeta
		ifTrue: [metaClasses includes: aClass soleInstance name]
		ifFalse: [classes includes: aClass name])
			and: [super includesClass: aClass]! !

!ClassEnvironment methodsFor: 'printing' stamp: ''!
storeOn: aStream
	aStream nextPut: $(.
	super storeOn: aStream.
	aStream nextPutAll: ' classes: (('.
	classes asArray storeOn: aStream.
	aStream nextPutAll: ' inject: OrderedCollection new into: [:sum :each | 
				| class |
				class := Smalltalk at: each ifAbsent: [nil].
				class notNil ifTrue: [sum add: class].
				sum]) , ('.
	metaClasses asArray storeOn: aStream.
	aStream nextPutAll: ' inject: OrderedCollection new into: [:sum :each | 
				| class |
				class := Smalltalk at: each ifAbsent: [nil].
				class notNil ifTrue: [sum add: class class].
				sum])))'! !

!ClassEnvironment methodsFor: 'copying' stamp: ''!
postCopy
	classes := classes copy.
	metaClasses := metaClasses copy.
	^super postCopy! !

!ClassEnvironment methodsFor: 'accessing-classes' stamp: ''!
classNames
	^(Set withAll: classes) addAll: metaClasses;
		yourself! !

!ClassEnvironment methodsFor: 'testing' stamp: ''!
isClassEnvironment
	^true! !

!ClassEnvironment methodsFor: 'private' stamp: ''!
defaultLabel
	| stream |
	stream := String new writeStream.
	classes do: 
			[:each | 
			stream nextPutAll: each;
				nextPut: $ ].
	^stream contents! !

!ClassEnvironment methodsFor: 'printing' stamp: 'bh 6/10/2000 17:39'!
classSelectorDictionary

	^classes inject:Dictionary new into:
		[:answer :class |
		answer at:class put:(Smalltalk at:class) selectors;
			yourself].	! !

!ClassEnvironment methodsFor: 'testing' stamp: ''!
isEmpty
	^classes isEmpty and: [metaClasses isEmpty]! !

!ClassEnvironment methodsFor: 'printing' stamp: 'bh 4/29/2000 17:53'!
logOrInspect

	Transcript cr; cr; show:self name.
	(classes asArray, metaClasses asArray) asSet do: 
		[:class | 
		Transcript cr; show: '     ',class asString].
! !

!ClassEnvironment methodsFor: 'accessing' stamp: 'bh 6/10/2000 17:05'!
asSelectorEnvironment

	^SelectorEnvironment new
		searchStrings:#();
		label:self label;
		onEnvironment: self environment;
		classSelectors: self classSelectorDictionary metaClassSelectors: self metaClassSelectorDictionary;
		yourself.! !

!ClassEnvironment class methodsFor: 'instance creation' stamp: ''!
onEnvironment: anEnvironment classes: aCollection
	^(self onEnvironment: anEnvironment)
		classes: aCollection; yourself! !

!ClassEnvironment methodsFor: 'accessing' stamp: ''!
problemCount
	^self numberClasses! !

!ClassEnvironment methodsFor: 'initialize-release' stamp: ''!
classes: aCollection 
	aCollection do: [:each | self addClass: each]! !

!ClassEnvironment methodsFor: 'adding' stamp: ''!
addClass: aClass 
	aClass isMeta
		ifTrue: [metaClasses add: aClass soleInstance name]
		ifFalse: [classes add: aClass name]! !

!ClassEnvironment methodsFor: 'accessing-classes' stamp: ''!
classesDo: aBlock 
	classes
		do: 
			[:each | 
			| class |
			class := Smalltalk at: each ifAbsent: [nil].
			(class notNil and: [environment includesClass: class])
				ifTrue: [aBlock value: class]].
	metaClasses
		do: 
			[:each | 
			| class |
			class := Smalltalk at: each ifAbsent: [nil].
			(class notNil and: [environment includesClass: class class])
				ifTrue: [aBlock value: class class]]! !

!ClassEnvironment methodsFor: 'removing' stamp: ''!
removeClass: aClass 
	aClass isMeta
		ifTrue: [metaClasses remove: aClass soleInstance name ifAbsent: []]
		ifFalse: [classes remove: aClass name ifAbsent: []]! !

!ClassEnvironment methodsFor: '*Refactory-SqueakRB-UserInterface' stamp: 'dvf 10/3/2001 01:32'!
openEditor

	^(ClassEnvironmentBrowser openOnEnvironment: self) openInWorld.! !

!ClassEnvironment methodsFor: 'testing' stamp: ''!
includesCategory: aCategory
	^(super includesCategory: aCategory)
		and: [(environment classNamesFor: aCategory)
				inject: false into: [:bool :each | bool
					or:
						[| class |
						class := Smalltalk at: each ifAbsent: [nil].
						class notNil and: [(self includesClass: class)
								or: [self includesClass: class class]]]]]! !

!BrowserEnvironmentWrapper methodsFor: 'initialize-release' stamp: ''!
onEnvironment: anEnvironment
	environment := anEnvironment! !

!BrowserEnvironmentWrapper methodsFor: 'accessing' stamp: 'bh 5/8/2000 21:03'!
selectionIntervalFor: aString 
	| interval |
	interval := super selectionIntervalFor: aString.
	^interval notNil 
		ifTrue: [interval]
		ifFalse: [environment selectionIntervalFor: aString]! !

!BrowserEnvironmentWrapper methodsFor: 'testing' stamp: ''!
isEmpty
	self classesDo: [:each | ^false].
	^true! !

BrowserEnvironmentWrapper subclass: #SelectorEnvironment
	instanceVariableNames: 'classSelectors metaClassSelectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Environments'!

!SelectorEnvironment methodsFor: 'initialize-release' stamp: ''!
classes: classArray metaClasses: metaArray 
	"Used to recreate an environment from its storeString"

	classSelectors := Dictionary new.
	metaClassSelectors := Dictionary new.
	classArray 
		do: [:each | classSelectors at: each first put: each last asSet].
	metaArray 
		do: [:each | metaClassSelectors at: each first put: each last asSet]! !

!SelectorEnvironment methodsFor: 'accessing-classes' stamp: ''!
classesDo: aBlock 
	classSelectors keysDo: 
			[:each | 
			| class |
			class := Smalltalk at: each ifAbsent: [nil].
			class notNil 
				ifTrue: [(self includesClass: class) ifTrue: [aBlock value: class]]].
	metaClassSelectors keysDo: 
			[:each | 
			| class |
			class := Smalltalk at: each ifAbsent: [nil].
			class notNil 
				ifTrue: 
					[(self includesClass: class class) ifTrue: [aBlock value: class class]]]! !

!SelectorEnvironment methodsFor: 'accessing-classes' stamp: ''!
classNames
	| names |
	names := Set new: classSelectors size + metaClassSelectors size.
	names
		addAll: classSelectors keys;
		addAll: metaClassSelectors keys.
	^names asOrderedCollection! !

!SelectorEnvironment methodsFor: 'adding' stamp: 'bh 4/29/2000 18:09'!
logOrInspect

	Transcript cr; cr; show:self name.
	searchStrings ifNotNil:
		[Transcript cr;show:'     ( '.
		searchStrings do:[:string| Transcript show:string asString,' '].
		Transcript show:')'.].
	self logOrInspectDictionary:classSelectors.
	self logOrInspectDictionary:metaClassSelectors.! !

!SelectorEnvironment methodsFor: 'private' stamp: ''!
defaultLabel
	^'some methods'! !

!SelectorEnvironment methodsFor: 'removing' stamp: ''!
removeClass: aClass selector: aSelector 
	(aClass isMeta 
		ifTrue: [metaClassSelectors at: aClass soleInstance name ifAbsent: [^self]]
		ifFalse: [classSelectors at: aClass name ifAbsent: [^self]]) 
			remove: aSelector
			ifAbsent: []! !

!SelectorEnvironment methodsFor: 'testing' stamp: ''!
includesCategory: aCategory 
	^(super includesCategory: aCategory) and: 
			[(self classNamesFor: aCategory) contains: 
					[:className | 
					(classSelectors includesKey: className) 
						or: [metaClassSelectors includesKey: className]]]! !

!SelectorEnvironment methodsFor: 'testing' stamp: ''!
includesProtocol: aProtocol in: aClass 
	^(super includesProtocol: aProtocol in: aClass)
		and: [(environment selectorsFor: aProtocol in: aClass)
				contains: [:aSelector | self privateIncludesSelector: aSelector inClass: aClass]]! !

!SelectorEnvironment methodsFor: 'initialize-release' stamp: ''!
on: aDict 
	aDict keysAndValuesDo: 
			[:class :selectors | 
			class isMeta 
				ifTrue: [metaClassSelectors at: class soleInstance name put: selectors]
				ifFalse: [classSelectors at: class name put: selectors]]! !

!SelectorEnvironment methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	| classBlock |
	aStream
		nextPutAll: '((';
		nextPutAll: self class name;
		nextPutAll: ' onEnvironment: '.
	environment storeOn: aStream.
	aStream
		nextPut: $);
		nextPutAll: ' classes: #('.
	classBlock := 
			[:key :value | 
			aStream
				nextPutAll: '#(';
				nextPutAll: key;
				nextPutAll: ' #('.
			value do: 
					[:each | 
					aStream
						nextPutAll: each;
						nextPut: $ ].
			aStream
				nextPutAll: '))';
				cr].
	classSelectors keysAndValuesDo: classBlock.
	aStream nextPutAll: ') metaClasses: #('.
	metaClassSelectors keysAndValuesDo: classBlock.
	aStream nextPutAll: '))'! !

!SelectorEnvironment class methodsFor: 'instance creation' stamp: ''!
onMethods: selectorCollection forClass: aClass in: anEnvironment 
	| env |
	env := self onEnvironment: anEnvironment.
	selectorCollection do: [:each | env addClass: aClass selector: each].
	^env! !

!SelectorEnvironment class methodsFor: 'instance creation' stamp: ''!
implementorsOf: aSelector in: anEnvironment 
	| classDict metaDict selectors |
	classDict := IdentityDictionary new.
	metaDict := IdentityDictionary new.
	selectors := Array with: aSelector.
	anEnvironment classesDo: 
			[:class | 
			((class includesSelector: aSelector) 
				and: [anEnvironment includesSelector: aSelector in: class]) 
					ifTrue: 
						[class isMeta 
							ifTrue: [metaDict at: class soleInstance name put: selectors]
							ifFalse: [classDict at: class name put: selectors]]].
	^(self onEnvironment: anEnvironment)
		classSelectors: classDict metaClassSelectors: metaDict;
		label: 'Implementors of ' , aSelector;
		yourself! !

!SelectorEnvironment methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	classSelectors := IdentityDictionary new.
	metaClassSelectors := IdentityDictionary new! !

!SelectorEnvironment methodsFor: 'initialize-release' stamp: ''!
classSelectors: classSelectorDictionary metaClassSelectors: metaClassSelectorDictionary 
	classSelectors := classSelectorDictionary.
	metaClassSelectors := metaClassSelectorDictionary! !

!SelectorEnvironment methodsFor: 'testing' stamp: ''!
includesClass: aClass 
	^(self privateSelectorsForClass: aClass) isEmpty not 
		and: [super includesClass: aClass]! !

!SelectorEnvironment class methodsFor: 'instance creation' stamp: ''!
referencesTo: aLiteral in: anEnvironment 
	| classDict literalPrintString |
	literalPrintString := aLiteral isVariableBinding
				ifTrue: [aLiteral key asString]
				ifFalse: 
					[aLiteral isString ifTrue: [aLiteral] ifFalse: [aLiteral printString]].
	classDict := Dictionary new.
	anEnvironment classesDo: 
			[:class | 
			| selectors |
			selectors := (class whichSelectorsReferTo: aLiteral)
						select: [:aSelector | anEnvironment includesSelector: aSelector in: class].
			selectors isEmpty ifFalse: [classDict at: class put: selectors]].
	^(self onEnvironment: anEnvironment) on: classDict;
		label: 'References to: ' , literalPrintString;
		searchStrings: (Array with: literalPrintString);
		yourself! !

!SelectorEnvironment methodsFor: 'private' stamp: ''!
privateIncludesSelector: aSelector inClass: aClass 
	^(self privateSelectorsForClass: aClass) includes: aSelector! !

!SelectorEnvironment methodsFor: 'removing' stamp: ''!
removeClass: aClass 
	aClass isMeta 
		ifTrue: [metaClassSelectors removeKey: aClass soleInstance name ifAbsent: []]
		ifFalse: [classSelectors removeKey: aClass name ifAbsent: []]! !

!SelectorEnvironment methodsFor: 'accessing' stamp: ''!
numberSelectors
	"This doesn't compute the correct result when a method that is included in our method list is not in the
	environment we are wrapping. It is implemented this way for efficiency."

	^(classSelectors inject: 0 into: [:sum :each | sum + each size]) 
		+ (metaClassSelectors inject: 0 into: [:sum :each | sum + each size])! !

SelectorEnvironment subclass: #ParseTreeEnvironment
	instanceVariableNames: 'matcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Lint'!

!ParseTreeEnvironment methodsFor: 'initialize-release' stamp: ''!
matcher: aParseTreeSearcher
	matcher := aParseTreeSearcher! !

!ParseTreeEnvironment methodsFor: 'accessing' stamp: 'bh 5/9/2000 00:19'!
selectionIntervalFor: aString 
	| parseTree node |
	matcher isNil ifTrue: [^super selectionIntervalFor: aString].
	parseTree := RBParser parseMethod: aString
				onError: [:error :position | ^super selectionIntervalFor: aString].
	node := matcher executeTree: parseTree initialAnswer: nil.
	^node isNil 
		ifTrue: [super selectionIntervalFor: aString]
		ifFalse: [node sourceInterval]! !

!SelectorEnvironment methodsFor: 'private' stamp: ''!
privateSelectorsForClass: aClass 
	^aClass isMeta 
		ifTrue: [metaClassSelectors at: aClass soleInstance name ifAbsent: [#()]]
		ifFalse: [classSelectors at: aClass name ifAbsent: [#()]]! !

!SelectorEnvironment class methodsFor: 'instance creation' stamp: ''!
implementorsMatching: aString in: anEnvironment 
	| classDict metaDict |
	classDict := IdentityDictionary new.
	metaDict := IdentityDictionary new.
	anEnvironment classesDo: 
			[:class | 
			| selectors |
			selectors := Set new.
			anEnvironment selectorsForClass: class
				do: [:each | (aString match: each) ifTrue: [selectors add: each]].
			selectors isEmpty 
				ifFalse: 
					[class isMeta 
						ifTrue: [metaDict at: class soleInstance name put: selectors]
						ifFalse: [classDict at: class name put: selectors]]].
	^(self onEnvironment: anEnvironment)
		classSelectors: classDict metaClassSelectors: metaDict;
		label: 'Implementors of ' , aString;
		yourself! !

!SelectorEnvironment methodsFor: 'testing' stamp: ''!
includesSelector: aSelector in: aClass 
	^(environment includesSelector: aSelector in: aClass)
		and: [self privateIncludesSelector: aSelector inClass: aClass]! !

!SelectorEnvironment methodsFor: 'adding' stamp: ''!
addClass: aClass 
	aClass isMeta 
		ifTrue: 
			[metaClassSelectors at: aClass soleInstance name put: aClass selectors]
		ifFalse: [classSelectors at: aClass name put: aClass selectors]! !

!SelectorEnvironment methodsFor: 'adding' stamp: 'bh 4/29/2000 18:09'!
logOrInspectDictionary:aDictionary

	aDictionary keysAndValuesDo: 
		[:class :selectors | 
		selectors do: 
			[:sel |
			Transcript cr; show: '     ',class name asString , '>>' , sel asString]].! !

!SelectorEnvironment methodsFor: 'adding' stamp: ''!
addClass: aClass selector: aSymbol 
	(aClass isMeta 
		ifTrue: 
			[metaClassSelectors at: aClass soleInstance name ifAbsentPut: [Set new]]
		ifFalse: [classSelectors at: aClass name ifAbsentPut: [Set new]]) add: aSymbol! !

!SelectorEnvironment methodsFor: 'testing' stamp: ''!
isSelector
	^true! !

!SelectorEnvironment methodsFor: 'copying' stamp: ''!
postCopy
	| newDict |
	newDict := classSelectors copy.
	newDict keysAndValuesDo: [:key :value | newDict at: key put: value copy].
	classSelectors := newDict.
	newDict := metaClassSelectors copy.
	newDict keysAndValuesDo: [:key :value | newDict at: key put: value copy].
	metaClassSelectors := newDict.
	^super postCopy! !

!SelectorEnvironment methodsFor: 'accessing' stamp: 'rr 4/19/2004 16:06'!
asSelectorEnvironment
	^ self! !

!SelectorEnvironment methodsFor: 'testing' stamp: ''!
isEmpty
	^classSelectors isEmpty and: [metaClassSelectors isEmpty]! !

!SelectorEnvironment class methodsFor: 'instance creation' stamp: ''!
matches: aString in: anEnvironment 
	| newEnvironment |
	newEnvironment := (self onEnvironment: anEnvironment)
				label: 'Matching: ' , aString;
				searchStrings: (Array with: aString);
				yourself.
	anEnvironment classesAndSelectorsDo: 
			[:each :sel | 
			| method |
			method := each compiledMethodAt: sel.
			method allLiterals do: 
					[:lit | 
					lit isString 
						ifTrue: 
							[(aString match: lit) ifTrue: [newEnvironment addClass: each selector: sel]]]].
	^newEnvironment! !

!SelectorEnvironment methodsFor: '*Refactory-SqueakRB-UserInterface' stamp: 'dvf 10/3/2001 01:32'!
openEditor

	^(SelectorEnvironmentBrowser openOnEnvironment: self) openInWorld.! !

!SelectorEnvironment methodsFor: 'accessing' stamp: ''!
selectorsForClass: aClass do: aBlock 
	^(self privateSelectorsForClass: aClass) 
		do: [:each | (aClass includesSelector: each) ifTrue: [aBlock value: each]]! !

!BrowserEnvironmentWrapper methodsFor: 'testing' stamp: ''!
includesCategory: aCategory
	^environment includesCategory: aCategory! !

!BrowserEnvironmentWrapper class methodsFor: 'instance creation' stamp: ''!
new
	^self onEnvironment: BrowserEnvironment new! !

BrowserEnvironmentWrapper subclass: #CategoryEnvironment
	instanceVariableNames: 'categories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Environments'!

!CategoryEnvironment methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	categories := Set new! !

!CategoryEnvironment methodsFor: 'copying' stamp: ''!
postCopy
	categories := categories copy.
	^super postCopy! !

!CategoryEnvironment methodsFor: 'initialize-release' stamp: ''!
categories: aCollection
	categories := aCollection! !

!CategoryEnvironment methodsFor: 'testing' stamp: ''!
isEmpty
	^categories isEmpty! !

!CategoryEnvironment methodsFor: 'accessing' stamp: ''!
numberSelectors
	| total |
	total := 0.
	self 
		classesDo: [:each | self selectorsForClass: each do: [:sel | total := total + 1]].
	^total! !

!CategoryEnvironment methodsFor: 'testing' stamp: ''!
includesClass: aClass 
	^(super includesClass: aClass) and: 
			[| nonMetaClass |
			nonMetaClass := aClass isMeta 
						ifTrue: [aClass soleInstance]
						ifFalse: [aClass].
			categories 
				includes: (environment whichCategoryIncludes: nonMetaClass name)]! !

!CategoryEnvironment methodsFor: 'private' stamp: ''!
defaultLabel
	| stream |
	stream := String new writeStream.
	categories do: [:each | stream nextPutAll: each; nextPut: $ ].
	^stream contents! !

!CategoryEnvironment methodsFor: 'accessing-classes' stamp: ''!
classNames
	^self categories inject: OrderedCollection new into: [:col :each | col addAll: (self classNamesFor: each); yourself]! !

!CategoryEnvironment methodsFor: 'printing' stamp: ''!
storeOn: aStream
	aStream nextPut: $(.
	super storeOn: aStream.
	aStream nextPutAll: ' categories: '.
	categories asArray storeOn: aStream.
	aStream nextPut: $)! !

!CategoryEnvironment methodsFor: 'accessing' stamp: ''!
categories
	^categories select: [:each | self includesCategory: each]! !

!CategoryEnvironment methodsFor: 'testing' stamp: ''!
includesCategory: aCategory
	^(categories includes: aCategory)
		and: [super includesCategory: aCategory]! !

!CategoryEnvironment class methodsFor: 'instance creation' stamp: ''!
onEnvironment: anEnvironment categories: aCollection
	^(self onEnvironment: anEnvironment)
		categories: aCollection; yourself! !

BrowserEnvironmentWrapper subclass: #AndEnvironment
	instanceVariableNames: 'andedEnvironment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Environments'!

!AndEnvironment methodsFor: 'accessing' stamp: 'bh 5/8/2000 21:01'!
selectionIntervalFor: aString 
	| interval |
	interval := super selectionIntervalFor: aString.
	interval notNil ifTrue: [^interval].
	^andedEnvironment selectionIntervalFor: aString
! !

!AndEnvironment methodsFor: 'testing' stamp: ''!
includesClass: aClass 
	| doesntHaveSelectors |
	(environment includesClass: aClass) ifFalse: [^false].
	(andedEnvironment includesClass: aClass) ifFalse: [^false].
	doesntHaveSelectors := true.
	environment selectorsForClass: aClass
		do: 
			[:each | 
			doesntHaveSelectors := false.
			(andedEnvironment includesSelector: each in: aClass) ifTrue: [^true]].
	^doesntHaveSelectors! !

!AndEnvironment methodsFor: 'accessing' stamp: ''!
selectorsForClass: aClass do: aBlock 
	environment selectorsForClass: aClass
		do: 
			[:each | 
			(andedEnvironment includesSelector: each in: aClass) 
				ifTrue: [aBlock value: each]]! !

!AndEnvironment methodsFor: 'testing' stamp: ''!
includesCategory: aCategory 
	^(self classNamesFor: aCategory) isEmpty not! !

!AndEnvironment methodsFor: 'testing' stamp: ''!
includesSelector: aSelector in: aClass 
	^(environment includesSelector: aSelector in: aClass) 
		and: [andedEnvironment includesSelector: aSelector in: aClass]! !

!AndEnvironment methodsFor: 'private' stamp: ''!
andedEnvironment
	^andedEnvironment! !

!AndEnvironment methodsFor: 'accessing' stamp: ''!
classesDo: aBlock 
	environment 
		classesDo: [:each | (self includesClass: each) ifTrue: [aBlock value: each]]! !

!AndEnvironment methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	environment storeOn: aStream.
	aStream nextPutAll: ' & '.
	andedEnvironment storeOn: aStream.
	aStream nextPut: $)! !

!AndEnvironment methodsFor: 'accessing' stamp: ''!
problemCount
	^environment isClassEnvironment 
		ifTrue: [self numberClasses]
		ifFalse: [super problemCount]! !

!AndEnvironment methodsFor: 'initialize-release' stamp: ''!
andedEnvironment: aBrowserEnvironment 
	andedEnvironment := aBrowserEnvironment! !

!AndEnvironment methodsFor: 'accessing' stamp: ''!
numberSelectors
	| total |
	total := 0.
	environment classesAndSelectorsDo: 
			[:each :sel | 
			(andedEnvironment includesSelector: sel in: each) 
				ifTrue: [total := total + 1]].
	^total! !

!AndEnvironment methodsFor: 'testing' stamp: ''!
includesProtocol: aProtocol in: aClass 
	^(self selectorsFor: aProtocol in: aClass) isEmpty not! !

!AndEnvironment class methodsFor: 'instance creation' stamp: ''!
onEnvironment: anEnvironment and: anotherEnvironment 
	^(self onEnvironment: anEnvironment)
		andedEnvironment: anotherEnvironment;
		yourself! !

!BrowserEnvironmentWrapper methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream
		nextPutAll: '(';
		nextPutAll: self class name;
		nextPutAll: ' onEnvironment: '.
	environment storeOn: aStream.
	aStream nextPut: $)! !

!BrowserEnvironmentWrapper methodsFor: 'testing' stamp: ''!
includesClass: aClass
	^environment includesClass: aClass! !

!BrowserEnvironmentWrapper methodsFor: 'testing' stamp: ''!
includesProtocol: aProtocol in: aClass
	^(self includesClass: aClass)
		and: [environment includesProtocol: aProtocol in: aClass]! !

!BrowserEnvironmentWrapper methodsFor: 'private' stamp: ''!
environment
	^environment! !

BrowserEnvironmentWrapper subclass: #MultiEnvironment
	instanceVariableNames: 'environmentDictionaries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Environments'!

!MultiEnvironment methodsFor: 'accessing' stamp: ''!
problemCount
	^environmentDictionaries size! !

!MultiEnvironment methodsFor: 'adding' stamp: ''!
addClass: aClass selector: aSymbol into: aValue 
	(environmentDictionaries at: aValue ifAbsentPut: [SelectorEnvironment new]) 
		addClass: aClass
		selector: aSymbol! !

!MultiEnvironment methodsFor: 'removing' stamp: ''!
removeClass: aClass into: aValue 
	(environmentDictionaries at: aValue ifAbsent: [SelectorEnvironment new]) 
		removeClass: aClass! !

!MultiEnvironment methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	environmentDictionaries := Dictionary new.
	environment := SelectorEnvironment new! !

!MultiEnvironment methodsFor: 'testing' stamp: ''!
isEmpty
	^environmentDictionaries isEmpty! !

!MultiEnvironment methodsFor: 'accessing' stamp: 'rr 4/19/2004 16:04'!
asSelectorEnvironment
	| s |
	s := SelectorEnvironment new.
	s label: self label.
	environmentDictionaries do: [:each | | env |
			env := each asSelectorEnvironment. 
			env classesDo: [:cls | env selectorsForClass: cls do:  [:sel | s addClass: cls selector: sel]]].
	^ s
	  ! !

!MultiEnvironment methodsFor: 'removing' stamp: ''!
removeClass: aClass selector: aSelector into: aValue 
	(environmentDictionaries at: aValue ifAbsentPut: [SelectorEnvironment new]) 
		removeClass: aClass
		selector: aSelector! !

!MultiEnvironment methodsFor: 'accessing' stamp: ''!
environments
	^environmentDictionaries keys! !

!MultiEnvironment methodsFor: 'accessing' stamp: ''!
selectEnvironment: aValue 
	environment := environmentDictionaries at: aValue
				ifAbsent: [SelectorEnvironment new]! !

!MultiEnvironment methodsFor: 'adding' stamp: ''!
addClass: aClass into: aValue 
	(environmentDictionaries at: aValue ifAbsentPut: [SelectorEnvironment new]) 
		addClass: aClass! !

BrowserEnvironmentWrapper subclass: #ProtocolEnvironment
	instanceVariableNames: 'class protocols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Environments'!

!ProtocolEnvironment methodsFor: 'testing' stamp: ''!
includesClass: aClass
	^aClass == class and: [super includesClass: aClass]! !

!ProtocolEnvironment methodsFor: 'private' stamp: ''!
defaultLabel
	| stream |
	stream := String new writeStream.
	stream nextPutAll: class name;
		nextPut: $>.
	protocols do: 
			[:each | 
			stream nextPutAll: each;
				nextPut: $ ].
	^stream contents! !

!ProtocolEnvironment methodsFor: 'initialize-release' stamp: ''!
class: aClass protocols: aCollection
	class := aClass.
	protocols := aCollection! !

!ProtocolEnvironment methodsFor: 'copying' stamp: ''!
postCopy
	protocols := protocols copy.
	^super postCopy! !

!ProtocolEnvironment methodsFor: 'testing' stamp: ''!
includesSelector: aSelector in: aClass 
	^(super includesSelector: aSelector in: aClass) and: 
			[protocols 
				includes: (environment whichProtocolIncludes: aSelector in: aClass)]! !

!ProtocolEnvironment methodsFor: 'testing' stamp: ''!
includesProtocol: aProtocol in: aClass
	^aClass == class and: [(super includesProtocol: aProtocol in: aClass)
			and: [protocols includes: aProtocol]]! !

!ProtocolEnvironment methodsFor: 'testing' stamp: ''!
isEmpty
	^protocols isEmpty! !

!ProtocolEnvironment methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream nextPut: $(.
	super storeOn: aStream.
	aStream
		nextPutAll: ' class: ';
		nextPutAll: class name;
		nextPutAll: ' protocols: '.
	protocols asArray storeOn: aStream.
	aStream nextPut: $)! !

!ProtocolEnvironment class methodsFor: 'instance creation' stamp: ''!
onEnvironment: anEnvironment class: aClass protocols: aCollection
	^(self onEnvironment: anEnvironment)
		class: aClass protocols: aCollection; yourself! !

!ProtocolEnvironment methodsFor: 'testing' stamp: ''!
includesCategory: aCategory
	^(super includesCategory: aCategory)
		and: [(environment classNamesFor: aCategory)
				inject: false into: [:bool :each | bool
					or:
						[| aClass |
						aClass := Smalltalk at: each ifAbsent: [nil].
						aClass == class or: [aClass class == class]]]]! !

!BrowserEnvironmentWrapper methodsFor: 'testing' stamp: ''!
includesSelector: aSelector in: aClass
	^(self includesClass: aClass)
		and: [environment includesSelector: aSelector in: aClass]! !

BrowserEnvironmentWrapper subclass: #NotEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Environments'!

!NotEnvironment methodsFor: 'testing' stamp: ''!
includesCategory: aCategory 
	^(self classNamesFor: aCategory) isEmpty not! !

!NotEnvironment methodsFor: 'testing' stamp: ''!
includesClass: aClass 
	(environment includesClass: aClass) ifFalse: [^true].
	aClass selectorsAndMethodsDo: 
			[:each :meth | 
			(environment includesSelector: each in: aClass) ifFalse: [^true]].
	^false! !

!NotEnvironment methodsFor: 'testing' stamp: ''!
includesSelector: aSelector in: aClass
	^(environment includesSelector: aSelector in: aClass) not! !

!NotEnvironment methodsFor: 'environments' stamp: ''!
not
	^environment! !

!NotEnvironment methodsFor: 'printing' stamp: ''!
storeOn: aStream
	environment storeOn: aStream.
	aStream nextPutAll: ' not'! !

!NotEnvironment methodsFor: 'testing' stamp: ''!
includesProtocol: aProtocol in: aClass 
	^(self selectorsFor: aProtocol in: aClass) isEmpty not! !

!BrowserEnvironmentWrapper methodsFor: 'testing' stamp: ''!
isSystem
	^false! !

BrowserEnvironmentWrapper subclass: #VariableEnvironment
	instanceVariableNames: 'instanceVariables instanceVariableReaders instanceVariableWriters classVariables selectorCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Environments'!

!VariableEnvironment class methodsFor: 'instance creation' stamp: ''!
writersOfInstanceVariable: aString in: aClass 
	^self 
		on: BrowserEnvironment new
		writersOfInstanceVariable: aString
		in: aClass! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
instanceVariableWriters: anObject
	instanceVariableWriters := anObject! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
instanceVariableWriters
	^instanceVariableWriters! !

!VariableEnvironment class methodsFor: 'instance creation' stamp: ''!
readersOfInstanceVariable: aString in: aClass 
	^self 
		on: BrowserEnvironment new
		readersOfInstanceVariable: aString
		in: aClass! !

!VariableEnvironment methodsFor: 'accessing' stamp: ''!
removeClass: aClass instanceVariableWriter: aString 
	| vars |
	vars := instanceVariableWriters at: aClass name ifAbsent: [Set new].
	vars remove: aString ifAbsent: [].
	vars isEmpty 
		ifTrue: [instanceVariableWriters removeKey: aClass name ifAbsent: []].
	self flushCachesFor: aClass! !

!VariableEnvironment methodsFor: 'accessing' stamp: ''!
addClass: aClass instanceVariable: aString 
	(instanceVariables at: aClass name ifAbsentPut: [Set new]) add: aString.
	self flushCachesFor: aClass.
	self addSearchString: aString! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
instanceVariables
	^instanceVariables! !

!VariableEnvironment methodsFor: 'accessing' stamp: ''!
removeClass: aClass instanceVariable: aString 
	| vars |
	vars := instanceVariables at: aClass name ifAbsent: [Set new].
	vars remove: aString ifAbsent: [].
	vars isEmpty 
		ifTrue: [instanceVariables removeKey: aClass name ifAbsent: []].
	self flushCachesFor: aClass! !

!VariableEnvironment class methodsFor: 'instance creation' stamp: ''!
referencesToInstanceVariable: aString in: aClass 
	^self 
		on: BrowserEnvironment new
		referencesToInstanceVariable: aString
		in: aClass! !

!VariableEnvironment methodsFor: 'testing' stamp: ''!
isEmpty
	self accessorMethods 
		do: [:each | (self perform: each) isEmpty ifFalse: [^false]].
	^true! !

!VariableEnvironment methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream
		nextPut: $(;
		nextPutAll: self class name;
		nextPutAll: ' new '.
	#(#instanceVariables #instanceVariableReaders #instanceVariableWriters #classVariables) 
		do: 
			[:each | 
			aStream
				nextPutAll: each;
				nextPutAll: ': '.
			(self perform: each) storeOn: aStream.
			aStream nextPutAll: '; '].
	aStream nextPutAll: ' yourself)'! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
selectorCache
	^selectorCache isNil 
		ifTrue: [selectorCache := Dictionary new]
		ifFalse: [selectorCache]! !

!VariableEnvironment methodsFor: 'accessing' stamp: ''!
classNamesWithVariables
	| classNames |
	classNames := Set new.
	classNames
		addAll: instanceVariables keys;
		addAll: instanceVariableReaders keys;
		addAll: instanceVariableWriters keys;
		addAll: classVariables keys.
	^classNames! !

!VariableEnvironment methodsFor: 'testing' stamp: ''!
includesProtocol: aProtocol in: aClass 
	^(self selectorsFor: aProtocol in: aClass) isEmpty not! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
accessorMethods
	^#(#instanceVariables #instanceVariableReaders #instanceVariableWriters #classVariables)! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
classVariableSelectorsFor: aClass 
	| selectors classVars nonMetaClass |
	nonMetaClass := aClass isMeta 
				ifTrue: [aClass soleInstance]
				ifFalse: [aClass].
	selectors := Set new.
	classVars := Set new.
	classVariables keysDo: 
			[:each | 
			| cls |
			cls := self classForName: each.
			(cls notNil and: [nonMetaClass includesBehavior: cls]) 
				ifTrue: [classVars addAll: (classVariables at: each)]].
	classVars do: 
			[:each | 
			| binding |
			binding := aClass bindingFor: each.
			binding notNil 
				ifTrue: [selectors addAll: (aClass whichSelectorsReferTo: binding)]].
	^selectors! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
allClassesDo: aBlock 
	| classes instVarBlock |
	classes := Set new.
	instVarBlock := 
			[:each | 
			| class |
			class := self classForName: each.
			classes addAll: class withAllSubclasses].
	instanceVariables keysDo: instVarBlock.
	instanceVariableReaders keysDo: instVarBlock.
	instanceVariableWriters keysDo: instVarBlock.
	classVariables keysDo: 
			[:each | 
			| class |
			class := self classForName: each.
			class notNil 
				ifTrue: 
					[classes
						addAll: class withAllSubclasses;
						addAll: class class withAllSubclasses]].
	classes do: aBlock! !

!VariableEnvironment methodsFor: 'printing' stamp: 'bh 4/29/2000 18:10'!
logOrInspect

	Transcript cr; cr; show:self name.
	instanceVariables keysAndValuesDo: 
		[:class :variables | 
		variables do: 
			[:variable |
			Transcript cr; show: '     ',class name asString , '->' , variable asString]].
	classVariables keysAndValuesDo: 
		[:class :variables | 
		variables do: 
			[:variable |
			Transcript cr; show: '     ',class name asString , ' (cvar) ' , variable asString]].
! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
instanceVariableSelectorsFor: aClass 
	| selectors |
	selectors := Set new.
	#(#instanceVariables #instanceVariableReaders #instanceVariableWriters) 
		with: #(#whichSelectorsAccess: #whichSelectorsRead: #whichSelectorsAssign:)
		do: 
			[:var :sel | 
			| instVars |
			instVars := Set new.
			(self perform: var) keysDo: 
					[:each | 
					| cls |
					cls := self classForName: each.
					(cls notNil and: [aClass includesBehavior: cls]) 
						ifTrue: [instVars addAll: ((self perform: var) at: each)]].
			instVars do: [:each | selectors addAll: (aClass perform: sel with: each)]].
	^selectors! !

!VariableEnvironment methodsFor: 'testing' stamp: ''!
includesCategory: aCategory 
	^(self classNamesFor: aCategory) isEmpty not! !

!VariableEnvironment methodsFor: 'accessing' stamp: ''!
classVariablesFor: aClass 
	^classVariables at: aClass name ifAbsent: [#()]! !

!VariableEnvironment methodsFor: 'copying' stamp: ''!
postCopy
	super postCopy.
	instanceVariables := self copyDictionary: instanceVariables.
	instanceVariableReaders := self copyDictionary: instanceVariableReaders.
	instanceVariableWriters := self copyDictionary: instanceVariableWriters.
	classVariables := self copyDictionary: classVariables.
	selectorCache := nil! !

!VariableEnvironment methodsFor: 'testing' stamp: ''!
includesClass: aClass 
	(super includesClass: aClass) ifFalse: [^false].
	(instanceVariables includesKey: aClass) ifTrue: [^true].
	(classVariables includesKey: aClass) ifTrue: [^true].
	^((self selectorCacheFor: aClass) 
		detect: [:each | self includesSelector: each in: aClass]
		ifNone: [nil]) notNil! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
flushCachesFor: aClass 
	| nonMetaClass |
	selectorCache isNil ifTrue: [^self].
	nonMetaClass := aClass isMeta 
				ifTrue: [aClass soleInstance]
				ifFalse: [aClass].
	nonMetaClass withAllSubclasses do: 
			[:each | 
			selectorCache
				removeKey: each ifAbsent: [];
				removeKey: each class ifAbsent: []]! !

!VariableEnvironment class methodsFor: 'instance creation' stamp: ''!
on: anEnvironment writersOfInstanceVariable: aString in: aClass 
	^(self onEnvironment: anEnvironment)
		label: 'Writers of ''' , aString , ''' in ' , aClass name;
		addClass: aClass instanceVariableWriter: aString;
		yourself! !

!VariableEnvironment methodsFor: 'accessing' stamp: ''!
instanceVariablesFor: aClass 
	| vars name |
	vars := Set new.
	name := aClass name.
	vars
		addAll: (instanceVariables at: name ifAbsent: [#()]);
		addAll: (instanceVariableReaders at: name ifAbsent: [#()]);
		addAll: (instanceVariableWriters at: name ifAbsent: [#()]).
	^vars! !

!VariableEnvironment methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	instanceVariables := Dictionary new.
	classVariables := Dictionary new.
	instanceVariableReaders := Dictionary new.
	instanceVariableWriters := Dictionary new! !

!VariableEnvironment methodsFor: 'accessing' stamp: ''!
addClass: aClass instanceVariableReader: aString 
	(instanceVariableReaders at: aClass name ifAbsentPut: [Set new]) 
		add: aString.
	self flushCachesFor: aClass.
	self addSearchString: aString! !

!VariableEnvironment methodsFor: 'accessing' stamp: ''!
environmentForClassVariable: aSymbol in: aClass 
	| selectorEnvironment assoc block |
	selectorEnvironment := SelectorEnvironment onEnvironment: self.
	selectorEnvironment addSearchString: aSymbol.
	((classVariables at: aClass name ifAbsent: [#()]) includes: aSymbol) 
		ifFalse: [^selectorEnvironment].
	assoc := aClass bindingFor: aSymbol.
	block := 
			[:each | 
			(each whichSelectorsReferTo: assoc) 
				do: [:sel | selectorEnvironment addClass: each selector: sel]].
	aClass withAllSubclasses do: 
			[:each | 
			block
				value: each;
				value: each class].
	^selectorEnvironment! !

!VariableEnvironment methodsFor: 'accessing' stamp: ''!
addClass: aClass instanceVariableWriter: aString 
	(instanceVariableWriters at: aClass name ifAbsentPut: [Set new]) 
		add: aString.
	self flushCachesFor: aClass.
	self addSearchString: aString! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
computeSelectorCacheFor: aClass 
	^(self instanceVariableSelectorsFor: aClass)
		addAll: (self classVariableSelectorsFor: aClass);
		yourself! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
selectorCacheFor: aClass 
	^self selectorCache at: aClass
		ifAbsentPut: [self computeSelectorCacheFor: aClass]! !

!VariableEnvironment methodsFor: 'accessing' stamp: ''!
problemCount
	^self numberVariables! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
classVariables
	^classVariables! !

!VariableEnvironment methodsFor: 'testing' stamp: ''!
includesSelector: aSymbol in: aClass 
	^(environment includesSelector: aSymbol in: aClass) 
		and: [(self selectorCacheFor: aClass) includes: aSymbol]! !

!VariableEnvironment methodsFor: 'accessing' stamp: ''!
addClass: aClass classVariable: aSymbol 
	(classVariables at: aClass name ifAbsentPut: [Set new]) add: aSymbol.
	self flushCachesFor: aClass.
	self addSearchString: aSymbol! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
instanceVariableReaders
	^instanceVariableReaders! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
instanceVariables: anObject
	instanceVariables := anObject! !

!VariableEnvironment methodsFor: 'accessing' stamp: ''!
removeClass: aClass instanceVariableReader: aString 
	| vars |
	vars := instanceVariableReaders at: aClass name ifAbsent: [Set new].
	vars remove: aString ifAbsent: [].
	vars isEmpty 
		ifTrue: [instanceVariableReaders removeKey: aClass name ifAbsent: []].
	self flushCachesFor: aClass! !

!VariableEnvironment class methodsFor: 'instance creation' stamp: ''!
on: anEnvironment referencesToClassVariable: aSymbol in: aClass 
	^(self onEnvironment: anEnvironment)
		label: 'References to ''' , aSymbol , ''' in ' , aClass name;
		addClass: aClass classVariable: aSymbol;
		yourself! !

!VariableEnvironment methodsFor: 'accessing' stamp: ''!
environmentForInstanceVariable: aString in: aClass 
	| selectorEnvironment isReader isWriter |
	selectorEnvironment := SelectorEnvironment onEnvironment: self.
	selectorEnvironment addSearchString: aString.
	isReader := isWriter := false.
	((instanceVariables at: aClass name ifAbsent: [#()]) includes: aString) 
		ifTrue: 
			[isReader := true.
			isWriter := true].
	((instanceVariableWriters at: aClass name ifAbsent: [#()]) 
		includes: aString) ifTrue: [isWriter := true].
	((instanceVariableReaders at: aClass name ifAbsent: [#()]) 
		includes: aString) ifTrue: [isReader := true].
	aClass withAllSubclasses do: 
			[:each | 
			isWriter 
				ifTrue: 
					[(each whichSelectorsAssign: aString) 
						do: [:sel | selectorEnvironment addClass: each selector: sel]].
			isReader 
				ifTrue: 
					[(each whichSelectorsRead: aString) 
						do: [:sel | selectorEnvironment addClass: each selector: sel]]].
	^selectorEnvironment! !

!VariableEnvironment class methodsFor: 'instance creation' stamp: ''!
on: anEnvironment readersOfInstanceVariable: aString in: aClass 
	^(self onEnvironment: anEnvironment)
		label: 'Readers of ''' , aString , ''' in ' , aClass name;
		addClass: aClass instanceVariableReader: aString;
		yourself! !

!VariableEnvironment methodsFor: '*Refactory-SqueakRB-UserInterface' stamp: 'dvf 10/3/2001 01:32'!
openEditor

	^(VariableEnvironmentBrowser openOnEnvironment: self) openInWorld.! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
classForName: aString 
	| name isMeta class |
	isMeta := aString includes: $ .
	name := (isMeta 
				ifTrue: [aString copyFrom: 1 to: (aString size - 6 max: 1)]
				ifFalse: [aString]) asSymbol.
	class := Smalltalk at: name ifAbsent: [nil].
	^class notNil & isMeta ifTrue: [class class] ifFalse: [class]! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
classVariables: anObject
	classVariables := anObject! !

!VariableEnvironment class methodsFor: 'instance creation' stamp: ''!
referencesToClassVariable: aSymbol in: aClass 
	^self 
		on: BrowserEnvironment new
		referencesToClassVariable: aSymbol
		in: aClass! !

!VariableEnvironment class methodsFor: 'instance creation' stamp: ''!
on: anEnvironment referencesToInstanceVariable: aString in: aClass 
	^(self onEnvironment: anEnvironment)
		label: 'References to ''' , aString , ''' in ' , aClass name;
		addClass: aClass instanceVariable: aString;
		yourself! !

!VariableEnvironment methodsFor: 'accessing' stamp: ''!
removeClass: aClass classVariable: aSymbol 
	| vars |
	vars := classVariables at: aClass name ifAbsent: [Set new].
	vars remove: aSymbol ifAbsent: [].
	vars isEmpty ifTrue: [classVariables removeKey: aClass name ifAbsent: []].
	self flushCachesFor: aClass! !

!VariableEnvironment methodsFor: 'accessing' stamp: ''!
numberVariables
	^self accessorMethods inject: 0
		into: [:sum :each | sum + ((self perform: each) inject: 0 into: [:s :e | s + e size])]! !

!VariableEnvironment methodsFor: 'private' stamp: ''!
instanceVariableReaders: anObject
	instanceVariableReaders := anObject! !

!VariableEnvironment methodsFor: 'copying' stamp: ''!
copyDictionary: aDictionary 
	| copy |
	copy := Dictionary new: aDictionary size.
	aDictionary keysAndValuesDo: [:key :value | copy at: key put: value].
	^copy! !

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
forClasses: classCollection 
	| classes |
	classes := OrderedCollection new: classCollection size * 2.
	classCollection do: 
			[:each | 
			classes add: each;
				add: each class].
	^ClassEnvironment onEnvironment: self classes: classes! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
whichProtocolIncludes: aSelector in: aClass
	^aClass organization categoryOfElement: aSelector! !

!BrowserEnvironment methodsFor: 'testing' stamp: ''!
includesCategory: aCategory
	^true! !

!BrowserEnvironment methodsFor: 'testing' stamp: ''!
isSelector
	^false! !

!BrowserEnvironment methodsFor: 'testing' stamp: ''!
definesClass: aClass
	^true! !

!BrowserEnvironment methodsFor: '*Refactory-SqueakRB-UserInterface' stamp: 'rr 4/19/2004 16:07'!
openEditor
	"rr 4/7/2004 17:56 : original version could not work, as 
	RefactoringBrowser is unable to understand this message.
	So I chose one of the two implementors. It seems this has
	never been called."
	^self asSelectorEnvironment openInWorld! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
classVariablesFor: aClass 
	^aClass classVarNames! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
searchStrings
	^searchStrings isNil
		ifTrue: [#()]
		ifFalse: [searchStrings]! !

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
instVarRefsTo: instVarName in: aClass 
	^VariableEnvironment 
		on: self
		referencesToInstanceVariable: instVarName
		in: aClass! !

!BrowserEnvironment methodsFor: 'accessing-classes' stamp: ''!
classesDo: aBlock 
	self 
		allClassesDo: [:each | (self includesClass: each) ifTrue: [aBlock value: each]]! !

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
| anEnvironment 
	"If we or anEnvironment includes everything, then return it instead of creating 
	an or that will include everything."

	self isSystem ifTrue: [^self].
	anEnvironment isSystem ifTrue: [^anEnvironment].
	^(self not & anEnvironment not) not! !

!BrowserEnvironment methodsFor: 'private' stamp: ''!
defaultLabel
	^'Smalltalk'! !

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
& anEnvironment 
	"If we or anEnvironment includes everything, then just include the other environment (optimization)"

	self isSystem ifTrue: [^anEnvironment].
	anEnvironment isSystem ifTrue: [^self].
	^AndEnvironment onEnvironment: self and: anEnvironment! !

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
matches: aString 
	^SelectorEnvironment matches: aString in: self! !

!BrowserEnvironment methodsFor: 'initialize-release' stamp: ''!
label: aString
	label := aString! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
selectorsFor: aProtocol in: aClass
	^(aClass organization listAtCategoryNamed: aProtocol)
		select: [:each | self includesSelector: each in: aClass]! !

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
referencesTo: aLiteral 
	^SelectorEnvironment referencesTo: aLiteral in: self! !

!BrowserEnvironment methodsFor: 'copying' stamp: 'bh 3/16/2000 23:24'!
copy
	^self shallowCopy postCopy! !

!BrowserEnvironment methodsFor: 'accessing-classes' stamp: ''!
classNames
	| names |
	names := Set new.
	self classesDo: 
			[:each | 
			names add: (each isMeta ifTrue: [each soleInstance] ifFalse: [each]) name].
	^names! !

!BrowserEnvironment methodsFor: 'initialize-release' stamp: ''!
initialize! !

!BrowserEnvironment methodsFor: 'testing' stamp: ''!
includesProtocol: aProtocol in: aClass
	^true! !

!BrowserEnvironment methodsFor: 'printing' stamp: ''!
storeOn: aStream 
	aStream
		nextPutAll: self class name;
		nextPutAll: ' new'! !

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
instVarWritersTo: instVarName in: aClass 
	^VariableEnvironment 
		on: self
		writersOfInstanceVariable: instVarName
		in: aClass! !

!BrowserEnvironment methodsFor: 'accessing' stamp: 'bh 5/8/2000 21:02'!
selectionIntervalFor: aString 
	| interval |
	self searchStrings isEmpty ifTrue: [^nil].
	interval := self selectionParseTreeIntervalFor: aString.
	interval notNil ifTrue: [^interval].
	self searchStrings do: 
			[:each | 
			| search index |
			search := each isSymbol ifTrue: [each keywords first] ifFalse: [each].
			index := aString indexOfSubCollection: search startingAt: 1.
			index > 0 ifTrue: [^index to: index + search size - 1]].
	^nil! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
problemCount
	^self numberSelectors! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
classesAndSelectorsDo: aBlock 
	self classesDo: 
			[:class | 
			self selectorsForClass: class do: [:sel | aBlock value: class value: sel]]! !

!BrowserEnvironment methodsFor: 'copying' stamp: 'dvf 9/12/2003 13:21'!
postCopy
	^self! !

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
forCategories: categoryList 
	^CategoryEnvironment onEnvironment: self categories: categoryList! !

!BrowserEnvironment methodsFor: 'testing' stamp: ''!
includesClass: aClass
	^true! !

!BrowserEnvironment methodsFor: 'environments' stamp: ''!
forClass: aClass protocols: protocolCollection 
	^ProtocolEnvironment onEnvironment: self
		class: aClass
		protocols: protocolCollection! !

!BrowserEnvironment methodsFor: 'accessing' stamp: ''!
instanceVariablesFor: aClass 
	^aClass instVarNames! !

!BrowserEnvironment methodsFor: 'private' stamp: 'nk 8/8/2003 09:07'!
allClassesDo: aBlock 
	self systemNavigation allBehaviorsDo: aBlock! !

Object subclass: #RBNamespace
	instanceVariableNames: 'changes environment newClasses removedClasses changedClasses rootClasses implementorsCache sendersCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Model'!

!RBNamespace methodsFor: 'changes' stamp: ''!
removeClass: aRBClass 
	self removeClassNamed: aRBClass name! !

!RBNamespace methodsFor: 'private-changes' stamp: ''!
replaceClassNameIn: definitionString to: aSymbol 
	| parseTree |
	parseTree := RBParser parseExpression: definitionString.
	parseTree receiver: (RBVariableNode named: aSymbol).
	^parseTree formattedCode! !

!RBNamespace methodsFor: 'private-changes' stamp: ''!
removeClassVariable: aString from: aRBClass 
	^changes removeClassVariable: aString from: aRBClass! !

!RBNamespace methodsFor: 'accessing' stamp: 'bh 4/3/2000 15:47'!
rootClasses
	rootClasses isNil 
		ifTrue: 
			[rootClasses := OrderedCollection new.
			Class rootsOfTheWorld do: 
					[:each | 
					| class |
					class := self classFor: each.
					(class notNil "and: [class superclass isNil] <- it's protoObject, not nil.") 
						ifTrue: [rootClasses add: class]]].
	^rootClasses! !

!RBNamespace methodsFor: 'private-changes' stamp: ''!
changeClass: aRBClass 
	changedClasses at: aRBClass name
		put: (Array with: aRBClass nonMetaclass with: aRBClass metaclass).
	self flushCaches! !

!RBNamespace methodsFor: 'private-changes' stamp: ''!
addClassVariable: aString to: aRBClass 
	^changes addClassVariable: aString to: aRBClass! !

!RBNamespace methodsFor: 'changes' stamp: ''!
reparentClasses: aRBClassCollection to: newClass 
	aRBClassCollection do: 
			[:aClass | 
			self defineClass: (self replaceClassNameIn: aClass definitionString
						to: newClass name)]! !

!RBNamespace methodsFor: 'changes' stamp: ''!
renameClass: aRBClass to: aSymbol around: aBlock 
	| change value dict |
	change := RenameClassChange rename: aRBClass name to: aSymbol.
	self performChange: change around: aBlock.
	self flushCaches.
	dict := (newClasses includesKey: aSymbol) 
				ifTrue: [newClasses]
				ifFalse: [changedClasses].
	removedClasses
		add: aRBClass name;
		add: aRBClass name , ' class'.
	value := dict at: aRBClass name.
	dict removeKey: aRBClass name.
	dict at: aSymbol put: value.
	value first name: aSymbol.
	value last name: aSymbol.
	value first subclasses do: [:each | each superclass: value first].
	value last subclasses do: [:each | each superclass: value last].
	^change! !

!RBNamespace methodsFor: 'accessing-classes' stamp: ''!
classFor: aBehavior 
	| nonMetaclass |
	aBehavior isNil ifTrue: [^nil].
	nonMetaclass := aBehavior isMeta 
				ifTrue: [aBehavior soleInstance]
				ifFalse: [aBehavior].
	^aBehavior isMeta 
		ifTrue: [self metaclassNamed: nonMetaclass name]
		ifFalse: [self classNamed: nonMetaclass name]! !

!RBNamespace methodsFor: 'accessing-classes' stamp: ''!
metaclassNamed: aSymbol 
	| class |
	aSymbol isNil ifTrue: [^nil].
	(self hasRemoved: aSymbol) ifTrue: [^nil].
	(newClasses includesKey: aSymbol) ifTrue: [^(newClasses at: aSymbol) last].
	(changedClasses includesKey: aSymbol) 
		ifTrue: [^(changedClasses at: aSymbol) last].
	(class := environment at: aSymbol ifAbsent: [nil]) isBehavior 
		ifTrue: [^(self createNewClassFor: class) last].
	^nil! !

!RBNamespace methodsFor: 'accessing' stamp: ''!
name
	^changes name! !

!RBNamespace methodsFor: 'private-changes' stamp: ''!
compile: aString in: aRBClass classified: aSymbol 
	| change |
	change := changes 
				compile: aString
				in: aRBClass
				classified: aSymbol.
	self flushCaches.
	^change! !

!RBNamespace methodsFor: 'private-changes' stamp: ''!
removeMethod: aSelector from: aRBClass 
	self flushCaches.
	^changes removeMethod: aSelector from: aRBClass! !

!RBNamespace methodsFor: 'accessing' stamp: ''!
name: aString
	^changes name: aString! !

!RBNamespace methodsFor: 'accessing' stamp: ''!
allReferencesToClass: aRBClass do: aBlock 
	self allClassesDo: 
			[:each | 
			(each whichSelectorsReferToClass: aRBClass) 
				do: [:sel | aBlock value: (each methodFor: sel)]]! !

!RBNamespace methodsFor: 'accessing-classes' stamp: ''!
createNewClassFor: aBehavior 
	| nonMeta meta className |
	className := (aBehavior isMeta 
				ifTrue: [aBehavior soleInstance]
				ifFalse: [aBehavior]) name.
	nonMeta := (RBClass existingNamed: className)
				model: self;
				yourself.
	meta := (RBMetaclass existingNamed: className)
				model: self;
				yourself.
	^changedClasses at: className put: (Array with: nonMeta with: meta)! !

!RBNamespace methodsFor: 'accessing' stamp: ''!
allImplementorsOf: aSelector 
	^implementorsCache at: aSelector
		ifAbsentPut: [self privateImplementorsOf: aSelector]! !

!RBNamespace methodsFor: 'accessing-classes' stamp: ''!
whichCategoryIncludes: aSymbol
	^self environment whichCategoryIncludes: aSymbol! !

!RBNamespace methodsFor: 'testing' stamp: ''!
includesGlobal: aSymbol 
	(self hasRemoved: aSymbol) ifTrue: [^false].
	(self includesClassNamed: aSymbol) ifTrue: [^true].
	environment at: aSymbol ifAbsent: [^false].
	^true! !

!RBNamespace methodsFor: 'changes' stamp: ''!
removeClassNamed: aSymbol 
	(self classNamed: aSymbol) subclasses 
		do: [:each | self removeClassNamed: each name].
	removedClasses
		add: aSymbol;
		add: aSymbol , ' class'.
	newClasses removeKey: aSymbol ifAbsent: [].
	changedClasses removeKey: aSymbol ifAbsent: [].
	self flushCaches.
	^changes removeClassNamed: aSymbol! !

!RBNamespace methodsFor: 'private' stamp: ''!
privateImplementorsOf: aSelector 
	| classes |
	classes := Set new.
	self allClassesDo: 
			[:each | 
			(each directlyDefinesMethod: aSelector) ifTrue: [classes add: each]].
	^classes! !

!RBNamespace methodsFor: 'changes' stamp: ''!
defineClass: aString 
	| change newClass newClassName |
	change := changes defineClass: aString.
	newClassName := change changeClassName.
	newClass := self classNamed: newClassName.
	newClass isNil 
		ifTrue: 
			[| newMetaclass |
			removedClasses
				remove: newClassName ifAbsent: [];
				remove: newClassName , ' class' ifAbsent: [].
			newClass := RBClass named: newClassName.
			newMetaclass := RBMetaclass named: newClassName.
			newClass model: self.
			newMetaclass model: self.
			newClasses at: newClassName put: (Array with: newClass with: newMetaclass)].
	newClass superclass: (self classNamed: change superclassName).
	newClass superclass isNil 
		ifTrue: 
			[self rootClasses add: newClass.
			newClass metaclass superclass: (self classFor: Object class superclass)]
		ifFalse: [newClass metaclass superclass: newClass superclass metaclass].
	newClass instanceVariableNames: change instanceVariableNames.
	newClass classVariableNames: change classVariableNames.
	newClass poolDictionaryNames: change poolDictionaryNames.
	newClass category: change category.
	^change! !

!RBNamespace class methodsFor: 'instance creation' stamp: ''!
onEnvironment: aBrowserEnvironment 
	^(self new)
		environment: aBrowserEnvironment;
		yourself! !

!RBNamespace methodsFor: 'private' stamp: ''!
hasCreatedClassFor: aBehavior 
	| className |
	className := self classNameFor: aBehavior.
	^(newClasses includesKey: className) 
		or: [changedClasses includesKey: className]! !

!RBNamespace methodsFor: 'testing' stamp: ''!
hasRemoved: aSymbol 
	^removedClasses includes: aSymbol! !

!RBNamespace methodsFor: 'testing' stamp: ''!
includesClassNamed: aSymbol 
	^(self classNamed: aSymbol) notNil! !

!RBNamespace methodsFor: 'accessing' stamp: ''!
allClassesDo: aBlock 
	| seen evalBlock |
	seen := Set new.
	evalBlock := 
			[:each | 
			seen add: each first name.
			aBlock
				value: each first;
				value: each last].
	newClasses do: evalBlock.
	changedClasses do: evalBlock.
	environment classesDo: 
			[:each | 
			each isMeta 
				ifFalse: 
					[((seen includes: each name) or: [self hasRemoved: (self classNameFor: each)]) 
						ifFalse: 
							[| class |
							class := self classFor: each.
							aBlock
								value: class;
								value: class metaclass]]]! !

!RBNamespace methodsFor: 'private-changes' stamp: ''!
addPool: aString to: aRBClass 
	^changes addPool: aString to: aRBClass! !

!RBNamespace methodsFor: 'private-changes' stamp: ''!
flushCaches
	implementorsCache := IdentityDictionary new.
	sendersCache := IdentityDictionary new! !

!RBNamespace methodsFor: 'accessing' stamp: ''!
changes
	^changes! !

!RBNamespace methodsFor: 'private-changes' stamp: ''!
performChange: aCompositeRefactoryChange around: aBlock 
	| oldChanges |
	changes addChange: aCompositeRefactoryChange.
	oldChanges := changes.
	changes := aCompositeRefactoryChange.
	aBlock ensure: [changes := oldChanges].
	^aCompositeRefactoryChange! !

!RBNamespace methodsFor: 'private' stamp: ''!
classNameFor: aBehavior 
	^(aBehavior isMeta ifTrue: [aBehavior soleInstance] ifFalse: [aBehavior]) 
		name! !

!RBNamespace methodsFor: 'accessing-classes' stamp: ''!
classNamed: aSymbol 
	| class index classes |
	aSymbol isNil ifTrue: [^nil].
	(self hasRemoved: aSymbol) ifTrue: [^nil].
	(newClasses includesKey: aSymbol) 
		ifTrue: [^(newClasses at: aSymbol) first].
	(changedClasses includesKey: aSymbol) 
		ifTrue: [^(changedClasses at: aSymbol) first].
	(class := environment at: aSymbol ifAbsent: [nil]) isBehavior 
		ifTrue: 
			[classes := self createNewClassFor: class.
			^class isMeta ifTrue: [classes last] ifFalse: [classes first]].
	index := aSymbol 
				indexOfSubCollection: ' class'
				startingAt: 1
				ifAbsent: [^nil].
	class := self classNamed: (aSymbol copyFrom: 1 to: index - 1) asSymbol.
	^class isNil ifTrue: [nil] ifFalse: [class metaclass]! !

!RBNamespace methodsFor: 'private-changes' stamp: ''!
addInstanceVariable: aString to: aRBClass 
	^changes addInstanceVariable: aString to: aRBClass! !

!RBNamespace methodsFor: 'initialize-release' stamp: ''!
initialize
	changes := CompositeRefactoryChange new.
	environment := BrowserEnvironment new.
	newClasses := IdentityDictionary new.
	changedClasses := IdentityDictionary new.
	removedClasses := Set new.
	implementorsCache := IdentityDictionary new.
	sendersCache := IdentityDictionary new! !

!RBNamespace methodsFor: 'private-changes' stamp: ''!
renameInstanceVariable: oldName to: newName in: aRBClass around: aBlock 
	^self performChange: (RenameInstanceVariableChange 
				rename: oldName
				to: newName
				in: aRBClass)
		around: aBlock! !

!RBNamespace methodsFor: 'private-changes' stamp: ''!
renameClassVariable: oldName to: newName in: aRBClass around: aBlock 
	^self performChange: (RenameClassVariableChange 
				rename: oldName
				to: newName
				in: aRBClass)
		around: aBlock! !

!RBNamespace methodsFor: 'accessing' stamp: ''!
environment: aBrowserEnvironment 
	environment := aBrowserEnvironment! !

!RBNamespace methodsFor: 'private-changes' stamp: ''!
addChangeToClass: aRBClass 
	^changedClasses at: aRBClass name
		put: (Array with: aRBClass nonMetaclass with: aRBClass metaclass)! !

!RBNamespace methodsFor: 'accessing' stamp: ''!
environment
	^environment! !

!RBNamespace methodsFor: 'accessing' stamp: ''!
allReferencesTo: aSymbol do: aBlock 
	(sendersCache at: aSymbol
		ifAbsentPut: 
			[| refs |
			refs := OrderedCollection new.
			self allClassesDo: 
					[:each | 
					(each whichSelectorsReferToSymbol: aSymbol) 
						do: [:sel | refs add: (each methodFor: sel)]].
			refs]) 
			do: aBlock! !

!RBNamespace methodsFor: 'private-changes' stamp: ''!
removeInstanceVariable: aString from: aRBClass 
	^changes removeInstanceVariable: aString from: aRBClass! !

Object subclass: #RefactoryChange
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!RefactoryChange methodsFor: 'accessing' stamp: ''!
renameChangesForClass: aClassName to: newClassName 
	"We're in the middle of performing a rename operation. If we stored 
	the class name, we need to change the class name to the new 
	name to perform the compiles."

	self subclassResponsibility! !

!RefactoryChange methodsFor: 'copying' stamp: 'bh 3/16/2000 23:27'!
copy
	^(super copy)
		postCopy;
		yourself! !

!RefactoryChange methodsFor: 'initialize-release' stamp: ''!
initialize! !

RefactoryChange subclass: #RefactoryClassChange
	instanceVariableNames: 'className isMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!RefactoryClassChange methodsFor: 'accessing' stamp: ''!
changeClass
	| class |
	class := Smalltalk at: self changeClassName ifAbsent: [^nil].
	^isMeta ifTrue: [class class] ifFalse: [class]! !

!RefactoryClassChange methodsFor: 'accessing' stamp: ''!
methodSourceFor: aSymbol 
	(self changeClass includesSelector: aSymbol) ifFalse: [^nil].
	^self changeClass sourceCodeAt: aSymbol! !

!RefactoryClassChange methodsFor: 'comparing' stamp: ''!
= aRefactoryClassChange 
	self class = aRefactoryClassChange class ifFalse: [^false].
	^className = aRefactoryClassChange changeClassName 
		and: [isMeta = aRefactoryClassChange isMeta]! !

!RefactoryClassChange methodsFor: 'accessing' stamp: ''!
changeClassName: aSymbol 
	className := aSymbol.
	isMeta isNil ifTrue: [isMeta := false]! !

!RefactoryClassChange methodsFor: 'private' stamp: ''!
executeNotifying: aBlock 
	| undo |
	undo := self asUndoOperation.
	undo name: self name.
	self primitiveExecute.
	aBlock value.
	^undo! !

RefactoryClassChange subclass: #RefactoryVariableChange
	instanceVariableNames: 'variable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!RefactoryVariableChange methodsFor: 'comparing' stamp: ''!
hash
	^self class hash bitXor: variable hash! !

RefactoryVariableChange subclass: #AddClassVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!AddClassVariableChange methodsFor: 'private' stamp: ''!
changeSymbol
	^#addClassVarName:! !

!AddClassVariableChange methodsFor: 'printing' stamp: ''!
changeString
	^'Add class variable named, <1s>, from <2s>' 
		expandMacrosWith: variable
		with: self displayClassName! !

!AddClassVariableChange methodsFor: 'converting' stamp: ''!
asUndoOperation
	^RemoveClassVariableChange remove: variable from: self changeClass! !

!AddClassVariableChange methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPutAll: self displayClassName;
		nextPutAll: ' addClassVarNamed: ';
		nextPutAll: variable;
		nextPut: $!!! !

!AddClassVariableChange methodsFor: 'private' stamp: ''!
variable
	^variable asSymbol! !

RefactoryVariableChange subclass: #AddPoolVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!AddPoolVariableChange methodsFor: 'private' stamp: ''!
changeSymbol
	^#addSharedPool:! !

!AddPoolVariableChange methodsFor: 'printing' stamp: ''!
changeString
	^'Add pool variable named, <1s>, from <2s>' 
		expandMacrosWith: self variable
		with: self displayClassName! !

!AddPoolVariableChange methodsFor: 'private' stamp: ''!
changesFileTemplate
	^'<1p> <2s> <3s>'! !

!AddPoolVariableChange methodsFor: 'converting' stamp: ''!
asUndoOperation
	^RemovePoolVariableChange remove: variable from: self changeClass! !

!AddPoolVariableChange methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPutAll: self displayClassName;
		nextPutAll: ' addSharedPool: ';
		nextPutAll: self variable;
		nextPut: $!!! !

!AddPoolVariableChange methodsFor: 'private' stamp: ''!
variable
	^variable isString 
		ifTrue: [variable]
		ifFalse: 
			[Smalltalk keyAtValue: variable ifAbsent: [self error: 'Cannot find value']]! !

!AddPoolVariableChange methodsFor: 'private' stamp: ''!
changeObject
	| dictionary |
	dictionary := variable isString 
				ifTrue: [Smalltalk at: variable asSymbol]
				ifFalse: [variable].
	^dictionary! !

!RefactoryVariableChange class methodsFor: 'instance creation' stamp: ''!
add: aVariable to: aBehavior 
	"This should only be called on the Add*Change subclasses, 
	but is here so we don't need to copy it to all subclasses"

	^self new class: aBehavior variable: aVariable! !

RefactoryVariableChange subclass: #RemoveClassVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!RemoveClassVariableChange methodsFor: 'converting' stamp: ''!
asUndoOperation
	^AddClassVariableChange add: variable to: self changeClass! !

!RemoveClassVariableChange methodsFor: 'private' stamp: 'dvf 8/31/2001 01:17'!
primitiveExecute
	[super primitiveExecute] on: Notification do: [:ex | ex proceed] ! !

!RemoveClassVariableChange methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPutAll: self displayClassName;
		nextPutAll: ' removeClassVarNamed: ';
		nextPutAll: variable;
		nextPut: $!!! !

!RemoveClassVariableChange methodsFor: 'printing' stamp: ''!
changeString
	^'Remove class variable named, <1s>, from <2s>' 
		expandMacrosWith: variable
		with: self displayClassName! !

!RemoveClassVariableChange methodsFor: 'private' stamp: ''!
variable
	^variable asSymbol! !

!RemoveClassVariableChange methodsFor: 'private' stamp: ''!
changeSymbol
	^#removeClassVarName:! !

!RefactoryVariableChange class methodsFor: 'instance creation' stamp: ''!
remove: aVariable from: aBehavior 
	"This should only be called on the Remove*Change subclasses, 
	but is here so we don't need to copy it to all subclasses"

	^self new class: aBehavior variable: aVariable! !

!RefactoryVariableChange methodsFor: 'private' stamp: ''!
variable
	^variable! !

RefactoryVariableChange subclass: #RemovePoolVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!RemovePoolVariableChange methodsFor: 'private' stamp: ''!
changeSymbol
	^#removeSharedPool:! !

!RemovePoolVariableChange methodsFor: 'private' stamp: ''!
changesFileTemplate
	^'<1p> <2s> <3s>'! !

!RemovePoolVariableChange methodsFor: 'converting' stamp: ''!
asUndoOperation
	^AddPoolVariableChange add: variable to: self changeClass! !

!RemovePoolVariableChange methodsFor: 'private' stamp: ''!
variable
	^variable isString 
		ifTrue: [variable]
		ifFalse: 
			[Smalltalk keyAtValue: variable ifAbsent: [self error: 'Cannot find value']]! !

!RemovePoolVariableChange methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPutAll: self displayClassName;
		nextPutAll: ' removeSharedPool: ';
		nextPutAll: self variable;
		nextPut: $!!! !

!RemovePoolVariableChange methodsFor: 'printing' stamp: ''!
changeString
	^'Remove pool variable named, <1s>, from <2s>' 
		expandMacrosWith: self variable
		with: self displayClassName! !

!RemovePoolVariableChange methodsFor: 'private' stamp: ''!
changeObject
	| dictionary |
	dictionary := variable isString 
				ifTrue: [Smalltalk at: variable asSymbol]
				ifFalse: [variable].
	^dictionary! !

!RefactoryVariableChange methodsFor: 'private' stamp: ''!
changesFileTemplate
	^'<1p> <2s> <3p>'! !

!RefactoryVariableChange methodsFor: 'private' stamp: 'bh 4/29/2000 18:16'!
primitiveExecute
	| changeSymbol |
	changeSymbol _ self changeSymbol.
	self changeClass perform: changeSymbol with: self changeObject.
	self needsWork. "the following is to handle a VW bug.  Is it also a problem for Squeak?"
	"ChangeSet current changeClass: self changeClass.
	SourceFileManager default logChange: (self changesFileTemplate
			expandMacrosWith: self changeClass
			with: changeSymbol
			with: self variable)"! !

RefactoryVariableChange subclass: #AddInstanceVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!AddInstanceVariableChange methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPutAll: self displayClassName;
		nextPutAll: ' addInstVarNamed: ';
		nextPutAll: variable;
		nextPut: $!!! !

!AddInstanceVariableChange methodsFor: 'printing' stamp: ''!
changeString
	^'Add instance variable named, <1s>, from <2s>' 
		expandMacrosWith: variable
		with: self displayClassName! !

!AddInstanceVariableChange methodsFor: 'converting' stamp: ''!
asUndoOperation
	^RemoveInstanceVariableChange remove: variable from: self changeClass! !

!AddInstanceVariableChange methodsFor: 'private' stamp: ''!
changeSymbol
	^#addInstVarName:! !

RefactoryVariableChange subclass: #RemoveInstanceVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!RemoveInstanceVariableChange methodsFor: 'converting' stamp: ''!
asUndoOperation
	^AddInstanceVariableChange add: variable to: self changeClass! !

!RemoveInstanceVariableChange methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPutAll: self displayClassName;
		nextPutAll: ' removeInstVarNamed: ';
		nextPutAll: variable;
		nextPut: $!!! !

!RemoveInstanceVariableChange methodsFor: 'private' stamp: ''!
changeSymbol
	^#removeInstVarName:! !

!RemoveInstanceVariableChange methodsFor: 'printing' stamp: ''!
changeString
	^'Remove instance variable named, <1s>, from <2s>' 
		expandMacrosWith: variable
		with: self displayClassName! !

!RefactoryVariableChange methodsFor: 'comparing' stamp: ''!
= aRefactoryVariableChange 
	^super = aRefactoryVariableChange 
		and: [variable = aRefactoryVariableChange variable]! !

!RefactoryVariableChange methodsFor: 'private' stamp: ''!
changeSymbol
	self subclassResponsibility! !

!RefactoryVariableChange methodsFor: 'private' stamp: ''!
changeObject
	^self variable! !

!RefactoryVariableChange methodsFor: 'initialize-release' stamp: ''!
class: aBehavior variable: aString 
	self changeClass: aBehavior.
	variable := aString! !

!RefactoryClassChange methodsFor: 'printing' stamp: ''!
printOn: aStream
	aStream nextPutAll: self displayString! !

RefactoryClassChange subclass: #AddMethodChange
	instanceVariableNames: 'source selector protocols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!AddMethodChange methodsFor: 'comparing' stamp: ''!
hash
	^self parseTree hash! !

!AddMethodChange methodsFor: 'accessing' stamp: ''!
protocol
	^self protocols first! !

!AddMethodChange methodsFor: 'initialize-release' stamp: ''!
protocols: aCollection 
	protocols := aCollection isString 
				ifTrue: [Array with: aCollection]
				ifFalse: [aCollection].
	protocols isNil ifTrue: [protocols := #(#accessing)]! !

!AddMethodChange methodsFor: 'printing' stamp: ''!
changeString
	^self displayClassName , '>>' , self selector! !

!AddMethodChange methodsFor: 'initialize-release' stamp: ''!
class: aClass source: aString 
	self changeClass: aClass.
	source := aString.
	self protocols: (BrowserEnvironment new whichProtocolIncludes: self selector in: aClass)! !

!AddMethodChange methodsFor: 'accessing' stamp: ''!
protocols
	^protocols! !

!AddMethodChange methodsFor: 'accessing' stamp: ''!
selector
	selector isNil 
		ifTrue: 
			[selector := RBParser parseMethodPattern: source.
			selector isNil ifTrue: [selector := #unknown]].
	^selector! !

AddMethodChange subclass: #InteractiveAddMethodChange
	instanceVariableNames: 'controller definedSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!InteractiveAddMethodChange class methodsFor: 'instance creation' stamp: ''!
compile: aString in: aClass for: aController 
	^(self compile: aString in: aClass)
		controller: aController;
		yourself! !

!InteractiveAddMethodChange class methodsFor: 'instance creation' stamp: ''!
compile: aString in: aBehavior classified: aProtocol for: aController 
	^(self 
		compile: aString
		in: aBehavior
		classified: aProtocol)
		controller: aController;
		yourself! !

!InteractiveAddMethodChange methodsFor: 'private' stamp: ''!
controller
	^controller! !

!InteractiveAddMethodChange methodsFor: 'private' stamp: ''!
controller: aController 
	controller := aController! !

!InteractiveAddMethodChange methodsFor: 'accessing' stamp: ''!
definedSelector
	^definedSelector! !

!InteractiveAddMethodChange methodsFor: 'private' stamp: ''!
primitiveExecute
	^definedSelector := super primitiveExecute! !

!AddMethodChange methodsFor: 'private' stamp: ''!
controller
	^nil! !

!AddMethodChange methodsFor: 'converting' stamp: ''!
asUndoOperation
	^(self changeClass includesSelector: self selector) 
		ifTrue: 
			[| oldProtocol |
			oldProtocol := BrowserEnvironment new whichProtocolIncludes: self selector
						in: self changeClass.
			oldProtocol isNil ifTrue: [oldProtocol := #accessing].
			AddMethodChange 
				compile: (self methodSourceFor: self selector)
				in: self changeClass
				classified: oldProtocol]
		ifFalse: [RemoveMethodChange remove: selector from: self changeClass]! !

!AddMethodChange methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPut: $!!;
		nextPutAll: self displayClassName;
		nextPutAll: ' methodsFor: ''';
		nextPutAll: self protocol;
		nextPutAll: '''!!!!';
		cr;
		cr;
		nextPutAll: source;
		nextPutAll: '!! !!'! !

!AddMethodChange class methodsFor: 'instance creation' stamp: ''!
compile: aString in: aBehavior classified: aProtocol 
	^self new 
		class: aBehavior
		protocol: aProtocol
		source: aString! !

!AddMethodChange methodsFor: 'initialize-release' stamp: ''!
class: aClass protocol: aProtocol source: aString 
	self changeClass: aClass.
	self protocols: aProtocol.
	source := aString! !

!AddMethodChange methodsFor: 'private' stamp: ''!
parseTree
	^RBParser parseMethod: source onError: [:str :pos | ^nil]! !

!AddMethodChange class methodsFor: 'instance creation' stamp: ''!
compile: aString in: aClass 
	^self new class: aClass source: aString! !

!AddMethodChange methodsFor: 'comparing' stamp: ''!
= anAddMethodChange 
	super = anAddMethodChange ifFalse: [^false].
	^self parseTree = anAddMethodChange parseTree! !

!AddMethodChange methodsFor: 'accessing' stamp: ''!
changeForClass: aSymbol selector: aSelector 
	^(isMeta not and: [self selector = aSelector and: [className = aSymbol]])
		ifTrue: [self]
		ifFalse: [nil]! !

!AddMethodChange methodsFor: 'private' stamp: ''!
primitiveExecute
	^self changeClass 
		compile: source
		classified: self protocol
		notifying: self controller! !

!AddMethodChange methodsFor: 'accessing' stamp: ''!
changeForMetaclass: aSymbol selector: aSelector 
	^(isMeta and: [self selector = aSelector and: [className = aSymbol]])
		ifTrue: [self]
		ifFalse: [nil]! !

RefactoryClassChange subclass: #AddClassChange
	instanceVariableNames: 'definition superclassName instanceVariableNames classVariableNames poolDictionaryNames category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!AddClassChange methodsFor: 'private' stamp: ''!
namesIn: aString 
	| names stream nameStream |
	names := OrderedCollection new.
	stream := ReadStream on: aString.
	
	[stream skipSeparators.
	stream atEnd] whileFalse: 
				[nameStream := WriteStream on: (String new: 10).
				[stream atEnd or: [stream peek isSeparator]] 
					whileFalse: [nameStream nextPut: stream next].
				names add: nameStream contents].
	^names! !

!AddClassChange methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	isMeta := false! !

!AddClassChange methodsFor: 'printing' stamp: ''!
changeString
	^'Define ' , self displayClassName! !

!AddClassChange methodsFor: 'comparing' stamp: ''!
= anAddClassChange 
	self class = anAddClassChange class ifFalse: [^false].
	^definition = anAddClassChange definition! !

!AddClassChange methodsFor: 'private' stamp: ''!
definition
	^definition! !

!AddClassChange methodsFor: 'testing' stamp: ''!
isValidSubclassCreationMessage: aMessageNode 
	(aMessageNode receiver isVariable or: [aMessageNode receiver isLiteral]) 
		ifFalse: [^false].
	(self isValidMessageName: aMessageNode) ifFalse: [^false].
	^(aMessageNode arguments detect: [:each | each isLiteral not] ifNone: [nil]) 
		isNil! !

!AddClassChange methodsFor: 'private' stamp: ''!
controller
	^nil! !

!AddClassChange methodsFor: 'initialize-release' stamp: ''!
definition: aString 
	definition := aString! !

!AddClassChange methodsFor: 'accessing' stamp: ''!
poolDictionaryNames
	poolDictionaryNames isNil ifTrue: [self fillOutDefinition].
	^poolDictionaryNames! !

!AddClassChange methodsFor: 'accessing' stamp: ''!
instanceVariableNames
	instanceVariableNames isNil ifTrue: [self fillOutDefinition].
	^instanceVariableNames! !

!AddClassChange methodsFor: 'private' stamp: ''!
definingSuperclass
	^self class! !

!AddClassChange methodsFor: 'accessing' stamp: ''!
changeClassName
	className isNil ifTrue: [self fillOutDefinition].
	^className! !

!AddClassChange methodsFor: 'testing' stamp: 'bh 11/8/2000 12:29'!
isValidMessageName: aMessageNode 
	^#("#subclass:instanceVariableNames:classVariableNames:poolDictionaries:" #subclass:instanceVariableNames:classVariableNames:poolDictionaries:category: "#variableByteSubclass:classVariableNames:poolDictionaries:" #variableByteSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category: "#variableSubclass:instanceVariableNames:classVariableNames:poolDictionaries:" #variableSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:) 
		includes: aMessageNode selector! !

!AddClassChange methodsFor: 'comparing' stamp: ''!
hash
	^definition hash! !

!AddClassChange methodsFor: 'accessing' stamp: ''!
superclassName
	className isNil ifTrue: [self fillOutDefinition].
	^superclassName! !

!AddClassChange methodsFor: 'private' stamp: ''!
parseDefinitionError
	className := #'Unknown Class'.
	instanceVariableNames := #().
	classVariableNames := #().
	poolDictionaryNames := #()! !

!AddClassChange methodsFor: 'accessing' stamp: ''!
classVariableNames
	classVariableNames isNil ifTrue: [self fillOutDefinition].
	^classVariableNames! !

!AddClassChange methodsFor: 'private' stamp: ''!
fillOutDefinition
	| parseTree |
	parseTree := RBParser parseExpression: definition
				onError: [:str :pos | ^self parseDefinitionError].
	parseTree isMessage ifFalse: [^self parseDefinitionError].
	(self isValidSubclassCreationMessage: parseTree) 
		ifFalse: [^self parseDefinitionError].
	superclassName := parseTree receiver isVariable 
				ifTrue: [parseTree receiver name asSymbol]
				ifFalse: [parseTree receiver value].
	className := parseTree arguments first value.
	instanceVariableNames := self namesIn: (parseTree arguments at: 2) value.
	classVariableNames := self namesIn: (parseTree arguments at: 3) value.
	poolDictionaryNames := self namesIn: (parseTree arguments at: 4) value.
	category := parseTree arguments size < 5 
				ifTrue: [#Unknown]
				ifFalse: [(parseTree arguments at: 5) value asSymbol]! !

!AddClassChange methodsFor: 'accessing' stamp: ''!
category
	category isNil ifTrue: [self fillOutDefinition].
	^category! !

!AddClassChange class methodsFor: 'instance creation' stamp: 'bh 11/8/2000 13:51'!
definition: aString 

	^self new definition: aString! !

AddClassChange subclass: #InteractiveAddClassChange
	instanceVariableNames: 'controller definedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!InteractiveAddClassChange methodsFor: 'accessing' stamp: ''!
definedClass
	^definedClass! !

!InteractiveAddClassChange class methodsFor: 'instance creation' stamp: ''!
definition: aString for: aController 
	^(self definition: aString)
		controller: aController;
		yourself! !

!InteractiveAddClassChange methodsFor: 'private' stamp: ''!
primitiveExecute
	definedClass := super primitiveExecute! !

!InteractiveAddClassChange methodsFor: 'private' stamp: ''!
controller: aController 
	controller := aController! !

!InteractiveAddClassChange methodsFor: 'private' stamp: ''!
controller
	^controller! !

!AddClassChange methodsFor: 'converting' stamp: ''!
asUndoOperation
	| class |
	class := Smalltalk at: self changeClassName ifAbsent: [nil].
	^class isBehavior 
		ifTrue: [AddClassChange definition: class definition]
		ifFalse: [RemoveClassChange removeClassName: self changeClassName]! !

!AddClassChange methodsFor: 'private' stamp: ''!
primitiveExecute
	^self definingSuperclass subclassDefinerClass 
		evaluate: definition
		notifying: self controller
		logged: true! !

!AddClassChange methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPutAll: definition;
		nextPut: $!!! !

!RefactoryClassChange methodsFor: 'comparing' stamp: ''!
hash
	^self changeClassName hash! !

RefactoryClassChange subclass: #RemoveMethodChange
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!RemoveMethodChange class methodsFor: 'instance creation' stamp: ''!
remove: aSymbol from: aClass 
	^(self new)
		changeClass: aClass;
		selector: aSymbol;
		yourself! !

!RemoveMethodChange methodsFor: 'comparing' stamp: ''!
hash
	^selector hash! !

!RemoveMethodChange methodsFor: 'comparing' stamp: ''!
= aRemoveMethodChange 
	super = aRemoveMethodChange ifFalse: [^false].
	^selector = aRemoveMethodChange selector! !

!RemoveMethodChange methodsFor: 'converting' stamp: ''!
asUndoOperation
	^AddMethodChange compile: (self methodSourceFor: selector)
		in: self changeClass! !

!RemoveMethodChange methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPutAll: self displayClassName;
		nextPutAll: ' removeSelector: ';
		nextPutAll: selector;
		nextPut: $!!! !

!RemoveMethodChange methodsFor: 'private' stamp: ''!
primitiveExecute
	^self changeClass removeSelector: selector! !

!RemoveMethodChange methodsFor: 'printing' stamp: ''!
changeString
	^'Remove method, #<1s>, from: <2s>' expandMacrosWith: selector
		with: self displayClassName! !

!RemoveMethodChange methodsFor: 'private' stamp: ''!
selector
	^selector! !

!RemoveMethodChange methodsFor: 'initialize-release' stamp: ''!
selector: aSymbol 
	selector := aSymbol! !

!RefactoryClassChange methodsFor: 'accessing' stamp: ''!
renameChangesForClass: aClassName to: newClassName 
	self changeClassName == aClassName 
		ifTrue: 
			[^(self copy)
				changeClassName: newClassName;
				yourself].
	^self! !

!RefactoryClassChange methodsFor: 'printing' stamp: ''!
changeString
	^self displayClassName! !

!RefactoryClassChange methodsFor: 'accessing' stamp: ''!
changeClassName
	^className! !

!RefactoryClassChange methodsFor: 'printing' stamp: ''!
displayClassName
	^isMeta 
		ifTrue: [self changeClassName , ' class']
		ifFalse: [self changeClassName asString]! !

RefactoryClassChange subclass: #RemoveClassChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!RemoveClassChange class methodsFor: 'instance creation' stamp: ''!
removeClassName: aSymbol 
	^self new changeClassName: aSymbol! !

!RemoveClassChange methodsFor: 'converting' stamp: ''!
asUndoOperation
	| classChanges |
	classChanges := CompositeRefactoryChange new.
	self changeClass withAllSubclasses do: 
			[:each | 
			classChanges defineClass: each definition.
			each class instVarNames 
				do: [:varName | classChanges addInstanceVariable: varName to: each class].
			each selectors 
				do: [:selector | classChanges compile: (each sourceCodeAt: selector) in: each].
			each class selectors 
				do: [:selector | classChanges compile: (each class sourceCodeAt: selector) in: each class]].
	^classChanges! !

!RemoveClassChange methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPutAll: self displayClassName;
		nextPutAll: ' removeFromSystem';
		nextPut: $!!! !

!RemoveClassChange methodsFor: 'private' stamp: ''!
primitiveExecute
	self changeClass removeFromSystem! !

!RemoveClassChange class methodsFor: 'instance creation' stamp: ''!
remove: aClass 
	^self new changeClass: aClass! !

!RemoveClassChange methodsFor: 'printing' stamp: ''!
changeString
	^'Remove class ', self displayClassName! !

!RefactoryClassChange methodsFor: 'private' stamp: ''!
isMeta
	^isMeta! !

!RefactoryClassChange methodsFor: 'accessing' stamp: ''!
changeClass: aBehavior 
	isMeta := aBehavior isMeta.
	className := isMeta 
				ifTrue: [aBehavior soleInstance name]
				ifFalse: [aBehavior name]! !

!RefactoryClassChange methodsFor: 'converting' stamp: ''!
asUndoOperation
	^self subclassResponsibility! !

!RefactoryClassChange methodsFor: 'private' stamp: ''!
primitiveExecute
	^self subclassResponsibility! !

!RefactoryChange methodsFor: 'private' stamp: ''!
flattenedChanges
	| changes |
	changes := OrderedCollection new.
	self flattenOnto: changes.
	^changes! !

!RefactoryChange methodsFor: 'printing' stamp: ''!
displayString
	^name isNil ifTrue: [self changeString] ifFalse: [name]! !

!RefactoryChange methodsFor: 'accessing' stamp: ''!
changeForClass: aRBClass selector: aSelector 
	^nil! !

!RefactoryChange methodsFor: 'printing' stamp: ''!
changeString
	^self class name! !

!RefactoryChange methodsFor: 'accessing' stamp: ''!
changeForMetaclass: aSymbol selector: aSelector 
	^nil! !

!RefactoryChange methodsFor: 'accessing' stamp: ''!
changesSize
	^1! !

!RefactoryChange methodsFor: 'private' stamp: ''!
executeNotifying: aBlock 
	self subclassResponsibility! !

!RefactoryChange methodsFor: 'accessing' stamp: ''!
changes
	^Array with: self! !

!RefactoryChange methodsFor: 'user interface' stamp: 'bh 5/8/2000 21:13'!
inspect
	^((CompositeRefactoryChange new)
		changes: (Array with: self);
		yourself) inspect! !

!RefactoryChange methodsFor: 'accessing' stamp: ''!
name
	^name isNil ifTrue: [self changeString] ifFalse: [name]! !

RefactoryChange subclass: #CompositeRefactoryChange
	instanceVariableNames: 'changes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!CompositeRefactoryChange methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	changes := OrderedCollection new! !

!CompositeRefactoryChange methodsFor: 'refactory-changes' stamp: ''!
removeClass: aClass 
	^self addChange: (RemoveClassChange removeClassName: aClass name)! !

!CompositeRefactoryChange methodsFor: 'refactory-changes' stamp: ''!
removeClassNamed: aSymbol 
	self addChange: (RemoveClassChange removeClassName: aSymbol)! !

!CompositeRefactoryChange methodsFor: 'refactory-changes' stamp: ''!
compile: source in: class classified: aProtocol 
	^self addChange: (AddMethodChange 
				compile: source
				in: class
				classified: aProtocol)! !

!CompositeRefactoryChange methodsFor: 'refactory-changes' stamp: ''!
compile: source in: class 
	^self addChange: (AddMethodChange compile: source in: class)! !

!CompositeRefactoryChange methodsFor: 'accessing' stamp: ''!
changesSize
	^changes inject: 0 into: [:sum :each | sum + each changesSize]! !

!CompositeRefactoryChange methodsFor: 'printing' stamp: ''!
displayString
	^super displayString asText allBold! !

!CompositeRefactoryChange methodsFor: 'refactory-changes' stamp: ''!
addPool: aPoolVariable to: aClass 
	^self addChange: (AddPoolVariableChange add: aPoolVariable to: aClass)! !

!CompositeRefactoryChange methodsFor: 'private-inspector accessing' stamp: ''!
changes
	^changes! !

!CompositeRefactoryChange methodsFor: 'comparing' stamp: ''!
hash
	^changes size! !

!CompositeRefactoryChange methodsFor: 'refactory-changes' stamp: ''!
defineClass: aString 
	^self addChange: (AddClassChange definition: aString)! !

!CompositeRefactoryChange methodsFor: 'comparing' stamp: ''!
= aRefactoryBuilder 
	self class = aRefactoryBuilder class ifFalse: [^false].
	changes size = aRefactoryBuilder changes size ifFalse: [^false].
	changes with: aRefactoryBuilder changes
		do: [:each :change | each = change ifFalse: [^false]].
	^true! !

!CompositeRefactoryChange methodsFor: 'private-inspector accessing' stamp: ''!
changes: aCollection 
	changes := aCollection! !

!CompositeRefactoryChange methodsFor: 'accessing' stamp: ''!
addChange: aRefactoryChange 
	changes add: aRefactoryChange.
	^aRefactoryChange! !

!CompositeRefactoryChange methodsFor: 'refactory-changes' stamp: ''!
addClassVariable: variableName to: aClass 
	^self addChange: (AddClassVariableChange add: variableName to: aClass)! !

!CompositeRefactoryChange methodsFor: 'accessing' stamp: ''!
addChangeFirst: aRefactoryChange 
	changes addFirst: aRefactoryChange.
	^aRefactoryChange! !

!CompositeRefactoryChange methodsFor: 'refactory-changes' stamp: ''!
addInstanceVariable: variableName to: aClass 
	^self addChange: (AddInstanceVariableChange add: variableName to: aClass)! !

!CompositeRefactoryChange methodsFor: 'accessing' stamp: ''!
problemCount
	^self changesSize! !

!CompositeRefactoryChange methodsFor: 'private' stamp: ''!
executeNotifying: aBlock 
	| undos undo |
	undos := changes collect: [:each | each executeNotifying: aBlock].
	undo := self copy.
	undo changes: undos reverse.
	^undo! !

CompositeRefactoryChange subclass: #RenameClassChange
	instanceVariableNames: 'oldName newName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!RenameClassChange methodsFor: 'accessing' stamp: ''!
changeClass
	^Smalltalk at: oldName asSymbol ifAbsent: [Smalltalk at: newName asSymbol]! !

!RenameClassChange methodsFor: 'accessing' stamp: ''!
renameChangesForClass: aClassName to: newClassName 
	| change |
	change := super renameChangesForClass: aClassName to: newClassName.
	oldName asSymbol == aClassName 
		ifTrue: [change rename: newClassName to: newName].
	^change! !

!RenameClassChange methodsFor: 'private' stamp: ''!
newName
	^newName! !

!RenameClassChange methodsFor: 'comparing' stamp: ''!
= aRenameClassChange 
	super = aRenameClassChange ifFalse: [^false].
	^oldName = aRenameClassChange oldName 
		and: [newName = aRenameClassChange newName]! !

!RenameClassChange methodsFor: 'private' stamp: ''!
executeNotifying: aBlock 
	| undos |
	self changeClass rename: newName.
	undos := changes collect: 
					[:each | 
					(each renameChangesForClass: oldName asSymbol to: newName asSymbol) 
						executeNotifying: aBlock].
	^(self copy)
		changes: undos reverse;
		rename: newName to: oldName;
		yourself! !

!RenameClassChange methodsFor: 'initialize-release' stamp: ''!
rename: oldString to: newString 
	oldName := oldString.
	newName := newString! !

!RenameClassChange class methodsFor: 'instance creation' stamp: ''!
rename: oldString to: newString 
	^(self new)
		rename: oldString to: newString;
		yourself! !

!RenameClassChange methodsFor: 'private' stamp: ''!
oldName
	^oldName! !

!RenameClassChange methodsFor: 'private' stamp: ''!
flattenOnto: aCollection 
	aCollection 
		add: (self copy changes: (changes inject: OrderedCollection new
						into: 
							[:sum :each | 
							each flattenOnto: sum.
							sum]))! !

!CompositeRefactoryChange methodsFor: 'accessing' stamp: ''!
changeForMetaclass: aSymbol selector: aSelector 
	changes reverseDo: 
			[:each | 
			| change |
			change := each changeForMetaclass: aSymbol selector: aSelector.
			change notNil ifTrue: [^change]].
	^nil! !

!CompositeRefactoryChange methodsFor: 'printing' stamp: 'dvf 9/16/2001 00:56'!
printOn: aStream 
	name ifNotNil: [aStream nextPutAll: name] ifNil: [aStream nextPutAll: 'a CompositeRefactoringChange']! !

!CompositeRefactoryChange methodsFor: 'accessing' stamp: ''!
changeForClass: aRBClass selector: aSelector 
	changes reverseDo: 
			[:each | 
			| change |
			change := each changeForClass: aRBClass selector: aSelector.
			change notNil ifTrue: [^change]].
	^nil! !

!CompositeRefactoryChange class methodsFor: 'instance creation' stamp: ''!
named: aString 
	^(self new)
		name: aString;
		yourself! !

!CompositeRefactoryChange methodsFor: 'user interface' stamp: 'bh 11/8/2000 13:45'!
inspect
	"CompositeRefactoryChangeInspector openOn: self"
	self needsWork.
	^super inspect.! !

!CompositeRefactoryChange methodsFor: 'accessing' stamp: ''!
renameChangesForClass: aClassName to: newClassName 
	^(self copy)
		changes: (self changes 
					collect: [:each | each renameChangesForClass: aClassName to: newClassName]);
		yourself! !

CompositeRefactoryChange subclass: #RenameVariableChange
	instanceVariableNames: 'className isMeta oldName newName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!RenameVariableChange methodsFor: 'private' stamp: ''!
copyOldValuesToNewVariable
	self subclassResponsibility! !

!RenameVariableChange methodsFor: 'accessing' stamp: ''!
changeClassName
	^className! !

!RenameVariableChange methodsFor: 'private' stamp: ''!
removeOldVariable
	self subclassResponsibility! !

!RenameVariableChange methodsFor: 'printing' stamp: ''!
displayClassName
	^isMeta 
		ifTrue: [self changeClassName , ' class']
		ifFalse: [self changeClassName asString]! !

!RenameVariableChange methodsFor: 'accessing' stamp: ''!
changeClassName: aSymbol 
	className := aSymbol.
	isMeta isNil ifTrue: [isMeta := false]! !

!RenameVariableChange methodsFor: 'private' stamp: ''!
isMeta
	^isMeta! !

!RenameVariableChange methodsFor: 'accessing' stamp: ''!
changeClass: aBehavior 
	isMeta := aBehavior isMeta.
	className := isMeta 
				ifTrue: [aBehavior soleInstance name]
				ifFalse: [aBehavior name]! !

!RenameVariableChange class methodsFor: 'instance creation' stamp: ''!
rename: oldName to: newName in: aClass 
	^(self new)
		oldName: oldName;
		newName: newName;
		changeClass: aClass;
		yourself! !

!RenameVariableChange methodsFor: 'accessing' stamp: ''!
changeClass
	| class |
	class := Smalltalk at: self changeClassName ifAbsent: [^nil].
	^isMeta ifTrue: [class class] ifFalse: [class]! !

RenameVariableChange subclass: #RenameClassVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!RenameClassVariableChange methodsFor: 'private' stamp: ''!
removeOldVariable
	(RemoveClassVariableChange remove: oldName from: self changeClass) execute! !

!RenameClassVariableChange methodsFor: 'private' stamp: ''!
addNewVariable
	(AddClassVariableChange add: newName to: self changeClass) execute! !

!RenameClassVariableChange methodsFor: 'private' stamp: ''!
copyOldValuesToNewVariable
	| oldValue |
	oldValue := self changeClass classPool at: oldName ifAbsent: [].
	self changeClass classPool at: newName asSymbol put: oldValue! !

!RenameVariableChange methodsFor: 'accessing' stamp: ''!
newName
	^newName! !

RenameVariableChange subclass: #RenameInstanceVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!RenameInstanceVariableChange methodsFor: 'private' stamp: ''!
removeOldVariable
	(RemoveInstanceVariableChange remove: oldName from: self changeClass) 
		execute! !

!RenameInstanceVariableChange methodsFor: 'private' stamp: ''!
addNewVariable
	(AddInstanceVariableChange add: newName to: self changeClass) execute! !

!RenameInstanceVariableChange methodsFor: 'private' stamp: ''!
copyOldValuesToNewVariable
	| newIndex oldIndex |
	oldIndex := self changeClass allInstVarNames indexOf: oldName asString.
	newIndex := self changeClass allInstVarNames indexOf: newName asString.
	self changeClass withAllSubclasses do: 
			[:each | 
			each allInstances 
				do: [:inst | inst instVarAt: newIndex put: (inst instVarAt: oldIndex)]]! !

!RenameVariableChange methodsFor: 'private' stamp: ''!
addNewVariable
	self subclassResponsibility! !

!RenameVariableChange methodsFor: 'comparing' stamp: ''!
hash
	^(self changeClassName hash bitXor: self oldName hash) 
		bitXor: self newName hash! !

!RenameVariableChange methodsFor: 'printing' stamp: ''!
changeString
	^'Rename ' , oldName , ' to ' , newName! !

!RenameVariableChange methodsFor: 'accessing' stamp: ''!
oldName
	^oldName! !

!RenameVariableChange methodsFor: 'printing' stamp: ''!
printOn: aStream
	aStream nextPutAll: self displayString! !

!RenameVariableChange methodsFor: 'private' stamp: ''!
executeNotifying: aBlock 
	| undo |
	self addNewVariable.
	self copyOldValuesToNewVariable.
	undo := super executeNotifying: aBlock.
	undo
		oldName: newName;
		newName: oldName.
	self removeOldVariable.
	^undo! !

!RenameVariableChange methodsFor: 'private' stamp: ''!
newName: aString 
	newName := aString! !

!RenameVariableChange methodsFor: 'private' stamp: ''!
oldName: aString
	oldName := aString! !

!RenameVariableChange methodsFor: 'comparing' stamp: ''!
= aRenameVariableChange 
	self class = aRenameVariableChange class ifFalse: [^false].
	^className = aRenameVariableChange changeClassName and: 
			[isMeta = aRenameVariableChange isMeta and: 
					[oldName = aRenameVariableChange oldName 
						and: [newName = aRenameVariableChange newName]]]! !

!CompositeRefactoryChange methodsFor: 'refactory-changes' stamp: ''!
removeClassVariable: variableName from: aClass 
	^self 
		addChange: (RemoveClassVariableChange remove: variableName from: aClass)! !

!CompositeRefactoryChange methodsFor: 'private' stamp: ''!
flattenOnto: aCollection 
	changes do: [:each | each flattenOnto: aCollection]! !

!CompositeRefactoryChange methodsFor: 'refactory-changes' stamp: ''!
removeInstanceVariable: variableName from: aClass 
	^self 
		addChange: (RemoveInstanceVariableChange remove: variableName from: aClass)! !

!CompositeRefactoryChange methodsFor: 'private-inspector accessing' stamp: ''!
removeChange: aChange 
	changes remove: aChange ifAbsent: []! !

!CompositeRefactoryChange methodsFor: 'refactory-changes' stamp: ''!
removeMethod: aSelector from: aClass 
	^self addChange: (RemoveMethodChange remove: aSelector from: aClass)! !

!CompositeRefactoryChange methodsFor: 'refactory-changes' stamp: ''!
renameClass: class to: newName 
	^self addChange: (RenameClassChange rename: class name to: newName)! !

!CompositeRefactoryChange methodsFor: 'copying' stamp: ''!
postCopy
	super postCopy.
	changes := changes collect: [:each | each copy]! !

!RefactoryChange methodsFor: 'private' stamp: ''!
flattenOnto: aCollection 
	aCollection add: self! !

!RefactoryChange methodsFor: 'copying' stamp: 'dvf 9/21/2003 16:35'!
postCopy
	^self! !

!RefactoryChange methodsFor: 'initialize-release' stamp: ''!
name: aString
	name := aString! !

!RefactoryChange methodsFor: 'performing-changes' stamp: ''!
execute
	^self executeNotifying: []! !

Object subclass: #SmalllintResultEditor
	instanceVariableNames: 'label results resultsList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Lint'!

Object subclass: #SmalllintContext
	instanceVariableNames: 'class selector parseTree literals literalSemaphore literalProcess selectors compiledMethod selfMessages superMessages messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Lint'!

!SmalllintContext methodsFor: 'private' stamp: ''!
computeMessages
	| searcher |
	selfMessages := Set new.
	superMessages := Set new.
	messages := Set new.
	searcher := ParseTreeSearcher new.
	searcher
		matches: 'self `@message: ``@args'
			do: [:aNode :answer | selfMessages add: aNode selector];
		matches: 'super `@message: ``@args'
			do: [:aNode :answer | superMessages add: aNode selector];
		matches: '``@receiver `@message: ``@args'
			do: [:aNode :answer | messages add: aNode selector].
	searcher executeTree: self parseTree initialAnswer: nil! !

!SmalllintContext methodsFor: 'private' stamp: ''!
computeLiterals
	literalSemaphore := Semaphore new.
	literalProcess := [self primitiveComputeLiterals] fork! !

!SmalllintContext methodsFor: 'private' stamp: 'dvf 8/27/2003 14:35'!
primitiveComputeLiterals
	| semaphore |
	literals := IdentitySet new: 25000.
	literals addAll: self specialSelectors keys.
	selectors := IdentitySet new.
	SystemNavigation new allBehaviorsDo: [:aClass | self computeLiteralsForClass: aClass].
	semaphore := literalSemaphore.
	literalSemaphore := nil.
	self signalProcesses: semaphore.
	^literalProcess := nil! !

!SmalllintContext methodsFor: 'testing' stamp: ''!
uses: anObject 
	^self literals includes: anObject! !

!SmalllintContext methodsFor: 'testing' stamp: ''!
isAbstract: aClass 
	^(aClass isMeta or: 
			[(self literals includes: aClass name)
				or: [self literals includes: (Smalltalk associationAt: aClass name)]])
		not! !

!SmalllintContext methodsFor: 'private' stamp: ''!
checkLiteral: aLiteral 
	(aLiteral isSymbol or: [aLiteral isVariableBinding])
		ifTrue: [literals add: aLiteral]
		ifFalse: 
			[aLiteral class == Array
				ifTrue: [aLiteral do: [:each | self checkLiteral: each]]]! !

!SmalllintContext class methodsFor: 'instance creation' stamp: ''!
newNoCache
	^self basicNew! !

!SmalllintContext methodsFor: 'initialize-release' stamp: ''!
initialize
	self computeLiterals! !

!SmalllintContext methodsFor: 'accessing' stamp: ''!
selectedClass: anObject 
	class := anObject.
	self selector: nil! !

!SmalllintContext methodsFor: 'accessing' stamp: ''!
selectedClass
	^class! !

!SmalllintContext methodsFor: 'private' stamp: ''!
computeLiteralsForClass: aClass 
	(selectors addAll: aClass selectors) do: 
			[:sel | 
			self computeLiteralsForSelector: sel in: aClass.
			Processor yield]! !

!SmalllintContext methodsFor: 'accessing' stamp: ''!
parseTree
	^parseTree isNil
		ifTrue: [parseTree := self buildParseTree]
		ifFalse: [parseTree]! !

!SmalllintContext methodsFor: 'accessing' stamp: ''!
protocol
	^self selectedClass whichCategoryIncludesSelector: self selector! !

!SmalllintContext methodsFor: 'accessing' stamp: ''!
superMessages
	superMessages isNil ifTrue: [self computeMessages].
	^superMessages! !

!SmalllintContext methodsFor: 'accessing' stamp: ''!
selector: anObject 
	selector := anObject.
	parseTree := compiledMethod := selfMessages := superMessages := messages := nil! !

!SmalllintContext methodsFor: 'private' stamp: ''!
addLiteralsFor: aCompiledMethod 
	aCompiledMethod withAllBlockMethodsDo: 
			[:each | 
			each literalsDo: [:literal | self checkLiteral: literal]]! !

!SmalllintContext methodsFor: 'private' stamp: ''!
signalProcesses: aSemaphore 
	aSemaphore isNil ifTrue: [^self].
	[aSemaphore isEmpty] whileFalse: [aSemaphore signal]! !

!SmalllintContext methodsFor: 'accessing' stamp: ''!
selfMessages
	selfMessages isNil ifTrue: [self computeMessages].
	^selfMessages! !

!SmalllintContext methodsFor: 'private' stamp: ''!
computeLiteralsForSelector: aSelector in: aClass 
	| method |
	method := aClass compiledMethodAt: aSelector ifAbsent: [nil].
	method isNil ifTrue: [^self].
	self addLiteralsFor: method! !

!SmalllintContext methodsFor: 'private' stamp: ''!
buildParseTree
	| tree |
	tree := self selectedClass parseTreeFor: self selector.
	tree isNil ifTrue: [^RBParser parseMethod: 'method'].
	^tree! !

!SmalllintContext methodsFor: 'accessing' stamp: ''!
instVarNames
	^self selectedClass allInstVarNames! !

!SmalllintContext methodsFor: 'initialize-release' stamp: ''!
release
	literalProcess notNil ifTrue: [literalProcess terminate].
	super release! !

!SmalllintContext methodsFor: 'accessing' stamp: ''!
selectors
	literalSemaphore isNil
		ifTrue: 
			[selectors isNil ifTrue: 
					[self computeLiterals.
					literalSemaphore wait]]
		ifFalse: [literalSemaphore wait].
	^selectors! !

!SmalllintContext methodsFor: 'private' stamp: 'dvf 9/15/2001 17:39'!
specialSelectors
	| answer |
	answer := IdentityDictionary new.
	(Smalltalk specialSelectors select: [:sel | sel isSymbol]) do:
		[:sel | answer at: sel put: nil.].
	^answer.! !

!SmalllintContext methodsFor: 'accessing' stamp: ''!
literals
	literalSemaphore isNil
		ifTrue: 
			[literals isNil ifTrue: 
					[self computeLiterals.
					literalSemaphore wait]]
		ifFalse: [literalSemaphore wait].
	^literals! !

!SmalllintContext methodsFor: 'testing' stamp: ''!
implements: aSelector 
	^self selectors includes: aSelector! !

!SmalllintContext methodsFor: 'accessing' stamp: ''!
compiledMethod
	^compiledMethod notNil
		ifTrue: [compiledMethod]
		ifFalse: [compiledMethod := class compiledMethodAt: selector]! !

!SmalllintContext methodsFor: 'accessing' stamp: ''!
selector
	^selector! !

!SmalllintContext methodsFor: 'accessing' stamp: ''!
protocols
	^Array with: self protocol! !

!SmalllintContext methodsFor: 'accessing' stamp: ''!
messages
	messages isNil ifTrue: [self computeMessages].
	^messages! !

!Object methodsFor: '*Refactory-RBAddonsMaybeSuperflous' stamp: 'bh 3/16/2000 15:17'!
errorSignal
	"Answer the Signal used for miscellaneous errors
	(self error:)."
	^self class errorSignal! !

Object subclass: #RBProgramNodeVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Visitors'!

!RBProgramNodeVisitor commentStamp: 'md 9/24/2004 12:36' prior: 0!
Here is a short Tutorial.

We want to parse an expression:

tree := RBParser parseExpression: '3 + 4'

Now we have the AST (Abstrakt syntax tree). Have a look at it with the ObjectExplorerer:

tree explore

We can easyly walk across the tree using the RBProgramNodeVisitor:

RBProgramNodeVisitor new visitNode: tree.

Of course, nothing happens, as all the visitor-methods are only stubs in this class.
So you need to subclass that to do anything usefull.
As an example, we would like to walk the tree and get all Literals back.

So we make a subclass:

RBProgramNodeVisitor subclass: #TestVisitor
	instanceVariableNames: 'literals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-AST-Visitors'

initialize
	literals := Set new.

literals
	^literals

acceptLiteralNode: aLiteralNode
	literals add: aLiteralNode value.
	 

(TestVisitor new visitNode: tree) literals
!

RBProgramNodeVisitor subclass: #RBReadBeforeWrittenTester
	instanceVariableNames: 'read checkNewTemps scopeStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-ParseTree Matching'!

!RBReadBeforeWrittenTester methodsFor: 'visitor-double dispatching' stamp: 'bh 3/15/2000 16:47'!
acceptVariableNode: aVariableNode 
	self variableRead: aVariableNode! !

!RBReadBeforeWrittenTester methodsFor: 'private' stamp: 'bh 3/15/2000 16:45'!
variableWritten: aNode 
	(self currentScope includesKey: aNode variable name) ifTrue: 
			[(self currentScope at: aNode variable name) isNil
				ifTrue: [self currentScope at: aNode variable name put: false]]! !

!RBReadBeforeWrittenTester class methodsFor: 'accessing' stamp: 'bh 3/15/2000 16:49'!
readBeforeWritten: varNames in: aParseTree 
	^(self new)
		checkNewTemps: false;
		initializeVars: varNames;
		executeTree: aParseTree;
		read! !

!RBReadBeforeWrittenTester methodsFor: 'private' stamp: ''!
currentScope
	^scopeStack last! !

!RBReadBeforeWrittenTester methodsFor: 'private' stamp: 'bh 3/15/2000 16:44'!
variableRead: aNode 
	(self currentScope includesKey: aNode name) ifTrue: 
			[(self currentScope at: aNode name) isNil
				ifTrue: [self currentScope at: aNode name put: true]]! !

!RBReadBeforeWrittenTester methodsFor: 'private' stamp: ''!
createScope
	scopeStack add: (self copyDictionary: scopeStack last)! !

!RBReadBeforeWrittenTester methodsFor: 'private' stamp: ''!
removeScope
	^scopeStack removeLast! !

!RBReadBeforeWrittenTester methodsFor: 'visitor-double dispatching' stamp: 'bh 3/15/2000 16:45'!
acceptAssignmentNode: anAssignmentNode 
	self visitNode: anAssignmentNode value.
	self variableWritten: anAssignmentNode! !

!RBReadBeforeWrittenTester methodsFor: 'private' stamp: 'bh 3/15/2000 16:42'!
processIfTrueIfFalse: aNode 
	| trueScope falseScope |
	self createScope.
	self executeTree: aNode arguments first body.
	trueScope := self removeScope.
	self createScope.
	self executeTree: aNode arguments last body.
	falseScope := self removeScope.
	self currentScope keysAndValuesDo: 
			[:key :value | 
			value isNil 
				ifTrue: 
					[(trueScope at: key) == (falseScope at: key) 
						ifTrue: [self currentScope at: key put: (trueScope at: key)]
						ifFalse: 
							[((trueScope at: key) == true or: [(falseScope at: key) == true]) 
								ifTrue: [self currentScope at: key put: true]]]]! !

!RBReadBeforeWrittenTester methodsFor: 'initialize-release' stamp: ''!
checkNewTemps: aBoolean 
	checkNewTemps := aBoolean! !

!RBReadBeforeWrittenTester methodsFor: 'private' stamp: 'bh 3/15/2000 16:41'!
processBlock: aNode 
	| newScope |
	self createScope.
	self executeTree: aNode body.
	newScope := self removeScope.
	newScope keysAndValuesDo: 
			[:key :value | 
			(value == true and: [(self currentScope at: key) isNil]) 
				ifTrue: [self currentScope at: key put: value]]! !

!RBReadBeforeWrittenTester class methodsFor: 'accessing' stamp: 'bh 3/15/2000 16:49'!
variablesReadBeforeWrittenIn: aParseTree 
	^(self new)
		executeTree: aParseTree;
		read! !

!RBReadBeforeWrittenTester methodsFor: 'visitor-double dispatching' stamp: 'bh 3/15/2000 16:46'!
acceptBlockNode: aBlockNode 
	self processBlock: aBlockNode.! !

!RBReadBeforeWrittenTester methodsFor: 'initialize-release' stamp: 'bh 3/15/2000 16:37'!
initialize
	scopeStack _ OrderedCollection with: Dictionary new.
	read _ Set new.
	checkNewTemps _ true.
! !

!RBReadBeforeWrittenTester methodsFor: 'visitor-double dispatching' stamp: 'bh 3/15/2000 16:46'!
acceptMessageNode: aMessageNode 
	((#(#whileTrue: #whileFalse: #whileTrue #whileFalse) 
		includes: aMessageNode selector) and: [aMessageNode receiver isBlock]) 
		ifTrue: [self executeTree: aMessageNode receiver body]
		ifFalse: 
			[(aMessageNode isCascaded not or: [aMessageNode isFirstCascaded]) 
				ifTrue: [self visitNode: aMessageNode receiver]].
	((#(#ifTrue:ifFalse: #ifFalse:ifTrue:) includes: aMessageNode selector) 
		and: 
			[(aMessageNode arguments detect: [:each | each isBlock not] ifNone: [nil]) 
				isNil]) 
			ifTrue: [^self processIfTrueIfFalse: aMessageNode].
	aMessageNode arguments do: [:each | self visitNode: each]! !

!RBReadBeforeWrittenTester methodsFor: 'private' stamp: 'bh 3/15/2000 16:42'!
processStatementNode: aNode 
	| temps |
	(checkNewTemps not or: [aNode temporaries isEmpty]) 
		ifTrue: 
			[aNode statements do: [:each | self executeTree: each].
			^self].
	self createScope.
	temps := aNode temporaries collect: [:each | each name].
	self initializeVars: temps.
	aNode statements do: [:each | self executeTree: each].
	self removeScope keysAndValuesDo: 
			[:key :value | 
			(temps includes: key) 
				ifTrue: [value == true ifTrue: [read add: key]]
				ifFalse: 
					[(self currentScope at: key) isNil 
						ifTrue: [self currentScope at: key put: value]]]! !

!RBReadBeforeWrittenTester methodsFor: 'private' stamp: 'bh 3/15/2000 16:40'!
copyDictionary: aDictionary 
	"We could send aDictionary the copy message, but that doesn't copy the associations."

	| newDictionary |
	newDictionary := Dictionary new: aDictionary size.
	aDictionary
		keysAndValuesDo: [:key :value | newDictionary at: key put: value].
	^newDictionary! !

!RBReadBeforeWrittenTester class methodsFor: 'accessing' stamp: 'bh 3/15/2000 16:49'!
isVariable: aString writtenBeforeReadIn: aBRProgramNode 
	^(self readBeforeWritten: (Array with: aString) in: aBRProgramNode) 
		isEmpty! !

!RBReadBeforeWrittenTester methodsFor: 'accessing' stamp: 'bh 3/15/2000 16:39'!
executeTree: aParseTree 
	^self visitNode: aParseTree! !

!RBReadBeforeWrittenTester methodsFor: 'visitor-double dispatching' stamp: 'bh 3/15/2000 16:46'!
acceptSequenceNode: aSequenceNode 
	self processStatementNode: aSequenceNode! !

!RBReadBeforeWrittenTester methodsFor: 'initialize-release' stamp: ''!
initializeVars: varNames 
	varNames do: [:each | self currentScope at: each put: nil]! !

!RBReadBeforeWrittenTester methodsFor: 'accessing' stamp: 'bh 3/15/2000 16:39'!
read
	self currentScope
		keysAndValuesDo: [:key :value | value == true ifTrue: [read add: key]].
	^read! !

!RBReadBeforeWrittenTester class methodsFor: 'accessing' stamp: 'bh 3/15/2000 16:48'!
isVariable: aString readBeforeWrittenIn: aBRProgramNode 
	^(self isVariable: aString writtenBeforeReadIn: aBRProgramNode) not! !

!RBProgramNodeVisitor methodsFor: 'visitor-double dispatching' stamp: ''!
acceptBlockNode: aBlockNode 
	self visitArguments: aBlockNode arguments.
	self visitNode: aBlockNode body! !

!RBProgramNodeVisitor methodsFor: 'visitor-double dispatching' stamp: ''!
acceptSequenceNode: aSequenceNode 
	self visitArguments: aSequenceNode temporaries.
	aSequenceNode statements do: [:each | self visitNode: each]! !

!RBProgramNodeVisitor methodsFor: 'visitor-double dispatching' stamp: ''!
acceptLiteralNode: aLiteralNode! !

RBProgramNodeVisitor subclass: #ParseTreeSearcher
	instanceVariableNames: 'searches answer argumentSearches context messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-ParseTree Matching'!

!ParseTreeSearcher methodsFor: 'accessing' stamp: ''!
executeTree: aParseTree 
	"Save our current context, in case someone is performing another search inside a match."

	| oldContext |
	oldContext := context.
	context := RBSmallDictionary new.
	self visitNode: aParseTree.
	context := oldContext.
	^answer! !

!ParseTreeSearcher class methodsFor: 'private' stamp: ''!
buildSelectorTree: aSelector 
	aSelector isEmpty ifTrue: [^nil].
	^RBParser parseRewriteExpression: '``@receiver ' 
				, (self buildSelectorString: aSelector)
		onError: [:err :pos | ^nil]! !

!ParseTreeSearcher methodsFor: 'private' stamp: ''!
foundMatch! !

!ParseTreeSearcher class methodsFor: 'private' stamp: ''!
buildTree: aString method: aBoolean 
	^aBoolean 
		ifTrue: [RBParser parseRewriteMethod: aString]
		ifFalse: [RBParser parseRewriteExpression: aString]! !

!ParseTreeSearcher methodsFor: 'accessing' stamp: ''!
addArgumentRules: ruleCollection 
	ruleCollection do: [:each | self addArgumentRule: each]! !

!ParseTreeSearcher methodsFor: 'accessing' stamp: ''!
answer
	^answer! !

!ParseTreeSearcher methodsFor: 'searching' stamp: ''!
matchesArgumentTree: aBRProgramNode do: aBlock 
	self 
		addArgumentRule: (RBSearchRule searchForTree: aBRProgramNode thenDo: aBlock)! !

!ParseTreeSearcher methodsFor: 'private' stamp: ''!
lookForMoreMatchesInContext: oldContext 
	oldContext keysAndValuesDo: 
			[:key :value | 
			(key isString not and: [key recurseInto]) 
				ifTrue: [value do: [:each | self visitNode: each]]]! !

!ParseTreeSearcher class methodsFor: 'instance creation' stamp: ''!
getterMethod: aVarName 
	^(self new)
		matchesMethod: '`method ^' , aVarName do: [:aNode :ans | aNode selector];
		yourself! !

!ParseTreeSearcher class methodsFor: 'instance creation' stamp: ''!
justSendsSuper
	^(self new)
		matchesAnyMethodOf: 
				#('`@method: `@Args ^super `@method: `@Args' 
				'`@method: `@Args super `@method: `@Args')
			do: [:aNode :ans | true];
		yourself! !

!ParseTreeSearcher methodsFor: 'visiting' stamp: ''!
visitNode: aNode 
	| value |
	value := self performSearches: searches on: aNode.
	^value isNil 
		ifTrue: 
			[aNode acceptVisitor: self.
			aNode]
		ifFalse: [value]! !

!ParseTreeSearcher methodsFor: 'private' stamp: ''!
recusivelySearchInContext
	"We need to save the matched context since the other searches might overwrite it."

	| oldContext |
	oldContext := context.
	context := RBSmallDictionary new.
	self lookForMoreMatchesInContext: oldContext.
	context := oldContext! !

!ParseTreeSearcher class methodsFor: 'accessing' stamp: ''!
treeMatching: aString in: aParseTree 
	(self new)
		matches: aString do: [:aNode :answer | ^aNode];
		executeTree: aParseTree.
	^nil! !

!ParseTreeSearcher methodsFor: 'accessing' stamp: ''!
executeMethod: aParseTree initialAnswer: anObject 
	answer := anObject.
	searches detect: [:each | (each performOn: aParseTree) notNil] ifNone: [].
	^answer! !

!ParseTreeSearcher methodsFor: 'accessing' stamp: ''!
addArgumentRule: aParseTreeRule 
	argumentSearches add: aParseTreeRule.
	aParseTreeRule owner: self! !

!ParseTreeSearcher methodsFor: 'testing' stamp: ''!
canMatchMethod: aCompiledMethod 
	^self messages isEmpty or: 
			[(self messages detect: [:each | aCompiledMethod sendsSelector: each]
				ifNone: [nil]) notNil]! !

!ParseTreeSearcher methodsFor: 'private' stamp: ''!
performSearches: aSearchCollection on: aNode 
	| value |
	1 to: aSearchCollection size
		do: 
			[:i | 
			value := (aSearchCollection at: i) performOn: aNode.
			value notNil 
				ifTrue: 
					[self foundMatch.
					^value]].
	^nil! !

!ParseTreeSearcher class methodsFor: 'accessing' stamp: ''!
treeMatchingStatements: aString in: aParseTree 
	| notifier tree lastIsReturn |
	notifier := self new.
	tree := RBParser parseExpression: aString.
	lastIsReturn := tree lastIsReturn.
	notifier matches: (lastIsReturn 
				ifTrue: ['| `@temps | `@.S1. ' , tree formattedCode]
				ifFalse: ['| `@temps | `@.S1. ' , tree formattedCode , '. `@.S2'])
		do: [:aNode :answer | ^tree].
	notifier executeTree: aParseTree.
	^nil! !

!ParseTreeSearcher methodsFor: 'searching' stamp: ''!
matchesAnyOf: aStringCollection do: aBlock 
	aStringCollection do: [:each | self matches: each do: aBlock]! !

!ParseTreeSearcher methodsFor: 'searching' stamp: ''!
matchesTree: aBRProgramNode do: aBlock 
	self addRule: (RBSearchRule searchForTree: aBRProgramNode thenDo: aBlock)! !

!ParseTreeSearcher methodsFor: 'searching' stamp: ''!
matchesAnyTreeOf: treeCollection do: aBlock 
	treeCollection do: [:each | self matchesTree: each do: aBlock]! !

!ParseTreeSearcher methodsFor: 'searching' stamp: ''!
matchesAnyArgumentOf: stringCollection do: aBlock 
	stringCollection do: [:each | self matchesArgument: each do: aBlock]! !

!ParseTreeSearcher methodsFor: 'searching' stamp: ''!
matchesAnyMethodOf: aStringCollection do: aBlock 
	aStringCollection do: [:each | self matchesMethod: each do: aBlock]! !

!ParseTreeSearcher methodsFor: 'searching' stamp: ''!
matches: aString do: aBlock 
	self addRule: (RBSearchRule searchFor: aString thenDo: aBlock)! !

!ParseTreeSearcher methodsFor: 'accessing' stamp: ''!
addRules: ruleCollection 
	ruleCollection do: [:each | self addRule: each]! !

!ParseTreeSearcher methodsFor: 'accessing' stamp: ''!
context
	^context! !

!ParseTreeSearcher methodsFor: 'visiting' stamp: ''!
visitArgument: aNode 
	| value |
	value := self performSearches: argumentSearches on: aNode.
	^value isNil 
		ifTrue: 
			[aNode acceptVisitor: self.
			aNode]
		ifFalse: [value]! !

!ParseTreeSearcher methodsFor: 'accessing' stamp: ''!
addRule: aParseTreeRule 
	searches add: aParseTreeRule.
	aParseTreeRule owner: self! !

!ParseTreeSearcher methodsFor: 'initialize-release' stamp: ''!
answer: anObject
	answer := anObject! !

!ParseTreeSearcher methodsFor: 'searching' stamp: ''!
matchesMethod: aString do: aBlock 
	self addRule: (RBSearchRule searchForMethod: aString thenDo: aBlock)! !

!ParseTreeSearcher class methodsFor: 'instance creation' stamp: ''!
returnSetterMethod: aVarName 
	^(self new)
		matchesMethod: '`method: `Arg ^' , aVarName , ' := `Arg'
			do: [:aNode :ans | aNode selector];
		yourself! !

!ParseTreeSearcher methodsFor: 'accessing' stamp: ''!
messages
	messages notNil ifTrue: [^messages].
	argumentSearches isEmpty ifFalse: [^messages := #()].
	messages := Set new.
	searches do: 
			[:each | 
			| searchMessages |
			searchMessages := each sentMessages.
			RBProgramNode optimizedSelectors 
				do: [:sel | searchMessages remove: sel ifAbsent: []].
			searchMessages isEmpty ifTrue: [^messages := #()].
			messages addAll: searchMessages].
	^messages := messages asArray! !

!ParseTreeSearcher methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	context := RBSmallDictionary new.
	searches := OrderedCollection new.
	argumentSearches := OrderedCollection new: 0.
	answer := nil! !

!ParseTreeSearcher methodsFor: 'accessing' stamp: ''!
executeTree: aParseTree initialAnswer: aValue 
	answer := aValue.
	^self executeTree: aParseTree! !

!ParseTreeSearcher class methodsFor: 'private' stamp: ''!
buildSelectorString: aSelector 
	| stream keywords |
	aSelector numArgs = 0 ifTrue: [^aSelector].
	stream := WriteStream on: String new.
	keywords := aSelector keywords.
	1 to: keywords size
		do: 
			[:i | 
			stream nextPutAll: (keywords at: i);
				nextPutAll: ' ``@arg';
				nextPutAll: i printString;
				nextPut: $ ].
	^stream contents! !

!ParseTreeSearcher class methodsFor: 'instance creation' stamp: ''!
setterMethod: aVarName 
	^(self new)
		matchesAnyMethodOf: (Array with: '`method: `Arg ' , aVarName , ' := `Arg'
					with: '`method: `Arg ^' , aVarName , ' := `Arg')
			do: [:aNode :ans | aNode selector];
		yourself! !

!ParseTreeSearcher methodsFor: 'searching' stamp: ''!
matchesArgument: aString do: aBlock 
	self addArgumentRule: (RBSearchRule searchFor: aString thenDo: aBlock)! !

ParseTreeSearcher subclass: #ParseTreeRewriter
	instanceVariableNames: 'tree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-ParseTree Matching'!

!ParseTreeRewriter methodsFor: 'replacing' stamp: ''!
replace: searchString withValueFrom: replaceBlock when: conditionBlock 
	self addRule: (RBBlockReplaceRule 
				searchFor: searchString
				replaceWith: replaceBlock
				when: conditionBlock)! !

!ParseTreeRewriter class methodsFor: 'accessing' stamp: ''!
replace: code with: newCode in: aParseTree 
	^(self 
		replace: code
		with: newCode
		method: false)
		executeTree: aParseTree;
		tree! !

!ParseTreeRewriter class methodsFor: 'instance creation' stamp: ''!
rename: varName to: newVarName handler: aBlock 
	"Rename varName to newVarName, evaluating aBlock if there is a 
	temporary variable with the same name as newVarName. This 
	does not change temporary variables with varName."

	| rewriteRule |
	rewriteRule := self new.
	rewriteRule
		replace: varName with: newVarName;
		replaceArgument: newVarName
			withValueFrom: 
				[:aNode | 
				aBlock value.
				aNode].
	^rewriteRule! !

!ParseTreeRewriter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptMessageNode: aMessageNode 
	aMessageNode receiver: (self visitNode: aMessageNode receiver).
	aMessageNode 
		arguments: (aMessageNode arguments collect: [:each | self visitNode: each])! !

!ParseTreeRewriter class methodsFor: 'instance creation' stamp: ''!
replaceLiteral: literal with: newLiteral 
	| rewriteRule |
	rewriteRule := self new.
	rewriteRule 
		replace: '`#literal'
		withValueFrom: [:aNode | aNode]
		when: 
			[:aNode | 
			self 
				replaceLiteral: literal
				with: newLiteral
				inToken: aNode token].
	^rewriteRule! !

!ParseTreeRewriter class methodsFor: 'instance creation' stamp: ''!
classVariable: aVarName getter: getMethod setter: setMethod 
	^self 
		variable: aVarName
		getter: getMethod
		setter: setMethod
		receiver: 'self class'! !

!ParseTreeRewriter methodsFor: 'replacing' stamp: ''!
replace: searchString with: replaceString 
	self addRule: (RBStringReplaceRule searchFor: searchString
				replaceWith: replaceString)! !

!ParseTreeRewriter methodsFor: 'replacing' stamp: ''!
replaceTree: searchTree withTree: replaceTree 
	self addRule: (RBStringReplaceRule searchForTree: searchTree
				replaceWith: replaceTree)! !

!ParseTreeRewriter methodsFor: 'replacing' stamp: ''!
replaceArgument: searchString withValueFrom: replaceBlock when: conditionBlock 
	self addArgumentRule: (RBBlockReplaceRule 
				searchFor: searchString
				replaceWith: replaceBlock
				when: conditionBlock)! !

!ParseTreeRewriter methodsFor: 'accessing' stamp: ''!
tree
	^tree! !

!ParseTreeRewriter methodsFor: 'replacing' stamp: ''!
replace: searchString withValueFrom: replaceBlock 
	self addRule: (RBBlockReplaceRule searchFor: searchString
				replaceWith: replaceBlock)! !

!ParseTreeRewriter methodsFor: 'replacing' stamp: ''!
replace: searchString with: replaceString when: aBlock 
	self addRule: (RBStringReplaceRule 
				searchFor: searchString
				replaceWith: replaceString
				when: aBlock)! !

!ParseTreeRewriter methodsFor: 'replacing' stamp: ''!
replaceTree: searchTree withTree: replaceTree when: aBlock 
	self addRule: (RBStringReplaceRule 
				searchForTree: searchTree
				replaceWith: replaceTree
				when: aBlock)! !

!ParseTreeRewriter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptMethodNode: aMethodNode 
	aMethodNode arguments: (self visitArguments: aMethodNode arguments).
	aMethodNode body: (self visitNode: aMethodNode body)! !

!ParseTreeRewriter class methodsFor: 'private' stamp: ''!
replaceLiteral: literal with: newLiteral inToken: literalToken 
	| value |
	value := literalToken realValue.
	(value class = literal class and: [value = literal]) 
		ifTrue: 
			[literalToken 
				value: newLiteral
				start: nil
				stop: nil.
			^true].
	^value class == Array and: 
			[literalToken value inject: false
				into: 
					[:bool :each | 
					bool | (self 
								replaceLiteral: literal
								with: newLiteral
								inToken: each)]]! !

!ParseTreeRewriter methodsFor: 'private' stamp: ''!
lookForMoreMatchesInContext: oldContext 
	oldContext keysAndValuesDo: 
			[:key :value | 
			(key isString not and: [key recurseInto]) 
				ifTrue: 
					[oldContext at: key put: (value collect: [:each | self visitNode: each])]]! !

!ParseTreeRewriter methodsFor: 'replacing' stamp: ''!
replaceArgument: searchString withValueFrom: replaceBlock 
	self addArgumentRule: (RBBlockReplaceRule searchFor: searchString
				replaceWith: replaceBlock)! !

!ParseTreeRewriter methodsFor: 'replacing' stamp: ''!
replaceArgument: searchString with: replaceString when: aBlock 
	self addArgumentRule: (RBStringReplaceRule 
				searchFor: searchString
				replaceWith: replaceString
				when: aBlock)! !

!ParseTreeRewriter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptBlockNode: aBlockNode 
	aBlockNode arguments: (self visitArguments: aBlockNode arguments).
	aBlockNode body: (self visitNode: aBlockNode body)! !

!ParseTreeRewriter class methodsFor: 'accessing' stamp: ''!
replaceStatements: code with: newCode in: aParseTree onInterval: anInterval 
	| tree searchStmt replaceStmt |
	tree := self buildTree: code method: false.
	tree lastIsReturn
		ifTrue: 
			[searchStmt := '| `@temps | `@.Statements. ' , code.
			replaceStmt := '| `@temps | `@.Statements. ^' , newCode]
		ifFalse: 
			[searchStmt := '| `@temps | `@.Statements1. ' , code , '.  `@.Statements2'.
			replaceStmt := '| `@temps | `@.Statements1. ' , newCode , '.  `@.Statements2'].
	^self
		replace: searchStmt
		with: replaceStmt
		in: aParseTree
		onInterval: anInterval! !

!ParseTreeRewriter class methodsFor: 'instance creation' stamp: ''!
replace: code with: newCode method: aBoolean 
	| rewriteRule |
	rewriteRule := self new.
	aBoolean 
		ifTrue: [rewriteRule replaceMethod: code with: newCode]
		ifFalse: [rewriteRule replace: code with: newCode].
	^rewriteRule! !

!ParseTreeRewriter class methodsFor: 'instance creation' stamp: ''!
rename: varName to: newVarName 
	| rewriteRule |
	rewriteRule := self new.
	rewriteRule
		replace: varName with: newVarName;
		replaceArgument: varName with: newVarName.
	^rewriteRule! !

!ParseTreeRewriter class methodsFor: 'instance creation' stamp: ''!
variable: aVarName getter: getMethod setter: setMethod 
	^self 
		variable: aVarName
		getter: getMethod
		setter: setMethod
		receiver: 'self'! !

!ParseTreeRewriter class methodsFor: 'accessing' stamp: ''!
replace: code with: newCode in: aParseTree onInterval: anInterval 
	| rewriteRule |
	rewriteRule := self new.
	^rewriteRule
		replace: code
			with: newCode
			when: [:aNode | aNode intersectsInterval: anInterval];
		executeTree: aParseTree;
		tree! !

!ParseTreeRewriter methodsFor: 'replacing' stamp: ''!
replaceMethod: searchString with: replaceString 
	self addRule: (RBStringReplaceRule searchForMethod: searchString
				replaceWith: replaceString)! !

!ParseTreeRewriter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptCascadeNode: aCascadeNode 
	| newMessages notFound |
	newMessages := OrderedCollection new: aCascadeNode messages size.
	notFound := OrderedCollection new: aCascadeNode messages size.
	aCascadeNode messages do: 
			[:each | 
			| newNode |
			newNode := self performSearches: searches on: each.
			newNode isNil 
				ifTrue: 
					[newNode := each.
					notFound add: newNode].
			newNode isMessage 
				ifTrue: [newMessages add: newNode]
				ifFalse: 
					[newNode isCascade 
						ifTrue: [newMessages addAll: newNode messages]
						ifFalse: 
							[Transcript
								show: 'Cannot replace message node inside of cascaded node with non-message node.';
								cr.
							newMessages add: each]]].
	notFound size == aCascadeNode messages size 
		ifTrue: 
			[| receiver |
			receiver := self visitNode: aCascadeNode messages first receiver.
			newMessages do: [:each | each receiver: receiver]].
	notFound 
		do: [:each | each arguments: (each arguments collect: [:arg | self visitNode: arg])].
	aCascadeNode messages: newMessages! !

!ParseTreeRewriter class methodsFor: 'instance creation' stamp: ''!
variable: aVarName getter: getMethod setter: setMethod receiver: aString 
	| rewriteRule |
	rewriteRule := self new.
	rewriteRule
		replace: aVarName , ' := ``@object'
			with: aString , ' ' , setMethod , ' ``@object';
		replace: aVarName with: aString , ' ' , getMethod.
	^rewriteRule! !

!ParseTreeRewriter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptSequenceNode: aSequenceNode 
	aSequenceNode temporaries: (self visitArguments: aSequenceNode temporaries).
	aSequenceNode statements: (aSequenceNode statements collect: [:each | self visitNode: each])! !

!ParseTreeRewriter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptAssignmentNode: anAssignmentNode 
	anAssignmentNode variable: (self visitNode: anAssignmentNode variable).
	anAssignmentNode value: (self visitNode: anAssignmentNode value)! !

!ParseTreeRewriter methodsFor: 'accessing' stamp: ''!
executeTree: aParseTree 
	| oldContext |
	oldContext := context.
	context := RBSmallDictionary new.
	answer := false.
	tree := self visitNode: aParseTree.
	context := oldContext.
	^answer! !

!ParseTreeRewriter methodsFor: 'replacing' stamp: ''!
replaceMethod: searchString withValueFrom: replaceBlock 
	self addRule: (RBBlockReplaceRule searchForMethod: searchString
				replaceWith: replaceBlock)! !

!ParseTreeRewriter methodsFor: 'visiting' stamp: ''!
visitArguments: aNodeCollection 
	^aNodeCollection collect: [:each | self visitArgument: each]! !

!ParseTreeRewriter methodsFor: 'replacing' stamp: ''!
replaceMethod: searchString with: replaceString when: aBlock 
	self addRule: (RBStringReplaceRule 
				searchForMethod: searchString
				replaceWith: replaceString
				when: aBlock)! !

!ParseTreeRewriter methodsFor: 'replacing' stamp: ''!
replaceMethod: searchString withValueFrom: replaceBlock when: conditionBlock 
	self addRule: (RBBlockReplaceRule 
				searchForMethod: searchString
				replaceWith: replaceBlock
				when: conditionBlock)! !

!ParseTreeRewriter methodsFor: 'replacing' stamp: ''!
replaceArgument: searchString with: replaceString 
	self addArgumentRule: (RBStringReplaceRule searchFor: searchString
				replaceWith: replaceString)! !

!ParseTreeRewriter methodsFor: 'private' stamp: ''!
foundMatch
	answer := true! !

!ParseTreeRewriter class methodsFor: 'instance creation' stamp: ''!
removeTemporaryNamed: aName 
	| rewriteRule |
	rewriteRule := self new.
	rewriteRule replace: '| `@temps1 ' , aName , ' `@temps2 | ``@.Statements'
		with: '| `@temps1  `@temps2 | ``@.Statements'.
	^rewriteRule! !

!ParseTreeRewriter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptOptimizedNode: anOptimizedNode 
	anOptimizedNode body: (self visitNode: anOptimizedNode body)! !

!ParseTreeRewriter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptReturnNode: aReturnNode 
	aReturnNode value: (self visitNode: aReturnNode value)! !

!RBProgramNodeVisitor methodsFor: 'visitor-double dispatching' stamp: 'ls 1/24/2000 00:31'!
acceptArrayNode: anArrayNode 
	anArrayNode children do: [:each | self visitNode: each]! !

!RBProgramNodeVisitor methodsFor: 'visiting' stamp: ''!
visitArgument: each 
	"Here to allow subclasses to detect arguments or temporaries."

	^self visitNode: each! !

!RBProgramNodeVisitor methodsFor: 'visitor-double dispatching' stamp: ''!
acceptCascadeNode: aCascadeNode 
	aCascadeNode messages do: [:each | self visitNode: each]! !

!RBProgramNodeVisitor methodsFor: 'copying' stamp: ''!
postCopy! !

!RBProgramNodeVisitor methodsFor: 'visitor-double dispatching' stamp: ''!
acceptMethodNode: aMethodNode 
	self visitArguments: aMethodNode arguments.
	self visitNode: aMethodNode body! !

!RBProgramNodeVisitor methodsFor: 'visitor-double dispatching' stamp: ''!
acceptAssignmentNode: anAssignmentNode 
	self visitNode: anAssignmentNode variable.
	self visitNode: anAssignmentNode value! !

!RBProgramNodeVisitor methodsFor: 'initialize-release' stamp: ''!
initialize! !

RBProgramNodeVisitor subclass: #RBFormatter
	instanceVariableNames: 'codeStream lineStart firstLineLength tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-Visitors'!

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptOptimizedNode: anOptimizedNode 
	codeStream nextPutAll: '##('.
	self visitNode: anOptimizedNode body.
	codeStream nextPut: $)! !

!RBFormatter methodsFor: 'private' stamp: ''!
needsParenthesisFor: aNode 
	| parent grandparent |
	aNode isValue ifFalse: [^false].
	parent := aNode parent.
	parent isNil ifTrue: [^false].
	(aNode isMessage and: [parent isMessage and: [parent receiver == aNode]])
		ifTrue: 
			[grandparent := parent parent.
			(grandparent notNil and: [grandparent isCascade]) ifTrue: [^true]].
	aNode precedence < parent precedence ifTrue: [^false].
	aNode isAssignment & parent isAssignment ifTrue: [^false].
	aNode isAssignment | aNode isCascade ifTrue: [^true].
	aNode precedence == 0 ifTrue: [^false].
	aNode isMessage ifFalse: [^true].
	aNode precedence = parent precedence ifFalse: [^true].
	aNode isUnary ifTrue: [^false].
	aNode isKeyword ifTrue: [^true].
	parent receiver == aNode ifFalse: [^true].
	^self precedenceOf: parent selector greaterThan: aNode selector! !

!RBFormatter methodsFor: 'private' stamp: ''!
precedenceOf: parentSelector greaterThan: childSelector 
	"Put parenthesis around things that are preceived to have 'lower' precedence. For example, 'a + b * c' 
	-> '(a + b) * c' but 'a * b + c' -> 'a * b + c'"

	| childIndex parentIndex operators |
	operators := #(#($| $& $?) #($= $~ $< $>) #($- $+) #($* $/ $% $\) #($@)).
	childIndex := 0.
	parentIndex := 0.
	1 to: operators size
		do: 
			[:i | 
			((operators at: i) includes: parentSelector first) ifTrue: [parentIndex := i].
			((operators at: i) includes: childSelector first) ifTrue: [childIndex := i]].
	^childIndex < parentIndex! !

!RBFormatter methodsFor: 'private-formatting' stamp: ''!
newLinesFor: aString startingAt: anIndex 
	| count cr lf index char |
	cr := Character value: 13.
	lf := Character value: 10.
	count := 0.
	index := anIndex - 1.
	[index > 0 and: 
			[char := aString at: index.
			char isSeparator]] 
		whileTrue: 
			[char == lf 
				ifTrue: 
					[count := count + 1.
					(aString at: (index - 1 max: 1)) == cr ifTrue: [index := index - 1]].
			char == cr ifTrue: [count := count + 1].
			index := index - 1].
	^count! !

!RBFormatter methodsFor: 'private-formatting' stamp: ''!
formatMethodCommentFor: aNode indentBefore: aBoolean 
	| source |
	source := aNode source.
	source isNil ifTrue: [^self].
	aNode comments do: 
			[:each | 
			aBoolean ifTrue: [self indent].
			codeStream nextPutAll: (aNode source copyFrom: each first to: each last);
				cr.
			aBoolean ifFalse: [self indent]]! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptVariableNode: aVariableNode 
	codeStream nextPutAll: aVariableNode name! !

!RBFormatter methodsFor: 'private' stamp: ''!
indent
	firstLineLength isNil ifTrue: [firstLineLength := codeStream position].
	codeStream cr.
	tabs timesRepeat: [codeStream tab].
	lineStart := codeStream position! !

!RBFormatter methodsFor: 'private-formatting' stamp: ''!
formatMessageSelector: selectorParts withArguments: formattedArgs multiline: multiLine 
	formattedArgs isEmpty 
		ifTrue: [codeStream nextPutAll: selectorParts first value]
		ifFalse: 
			[1 to: formattedArgs size
				do: 
					[:i | 
					i ~~ 1 & multiLine not ifTrue: [codeStream nextPut: $ ].
					codeStream 
						nextPutAll: (selectorParts at: i) value;
						nextPut: $ ;
						nextPutAll: (formattedArgs at: i).
					(multiLine and: [i < formattedArgs size]) ifTrue: [self indent]]]! !

!RBFormatter methodsFor: 'private' stamp: ''!
selectorsToLeaveOnLine
	^#(#to:do: #to:by: #to:by:do:)! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: 'ls 1/24/2000 00:37'!
acceptArrayNode: anArrayNode 
	codeStream nextPutAll: '{ '.
	self indent: 1 while: [
		self indent.
		self formatStatementsFor: anArrayNode.
	].
	codeStream nextPutAll: '}'.! !

!RBFormatter methodsFor: 'private' stamp: ''!
maxLineSize
	^75! !

!RBFormatter methodsFor: 'accessing' stamp: ''!
isMultiLine
	^firstLineLength notNil! !

!RBFormatter methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	codeStream := WriteStream on: (String new: 60).
	tabs := 0.
	lineStart := 0! !

!RBFormatter methodsFor: 'private' stamp: ''!
lineLength
	^codeStream position - lineStart! !

!RBFormatter methodsFor: 'private-formatting' stamp: ''!
formatStatementCommentFor: aNode 
	| source |
	source := aNode source.
	source isNil ifTrue: [^self].
	aNode comments do: 
			[:each | 
			| crs |
			crs := self newLinesFor: source startingAt: each first.
			(crs - 1 max: 0) timesRepeat: [codeStream cr].
			crs == 0 ifTrue: [codeStream tab] ifFalse: [self indent].
			codeStream nextPutAll: (source copyFrom: each first to: each last)]! !

!RBFormatter methodsFor: 'private-formatting' stamp: ''!
formatTagFor: aMethodNode 
	| primitiveSources |
	primitiveSources := aMethodNode primitiveSources.
	primitiveSources do: 
			[:each | 
			codeStream nextPutAll: each.
			self indent]! !

!RBFormatter methodsFor: 'private-formatting' stamp: ''!
formatMessage: aMessageNode cascade: cascadeBoolean 
	| selectorParts arguments multiLine formattedArgs indentFirst firstArgLength length |
	selectorParts := aMessageNode selectorParts.
	arguments := aMessageNode arguments.
	formattedArgs := OrderedCollection new.
	multiLine := aMessageNode selector numArgs > self maximumArgumentsPerLine.
	length := aMessageNode selector size + arguments size + 1.
	firstArgLength := 0.
	self indentWhile: 
			[1 to: arguments size
				do: 
					[:i | 
					| formatter string |
					formatter := (self copy) 
								lineStart: (selectorParts at: i) length negated;
								yourself.
					string := formatter format: (arguments at: i).
					formattedArgs add: string.
					i == 1 ifTrue: [firstArgLength := formatter firstLineLength].
					length := length + string size.
					multiLine := multiLine or: [formatter isMultiLine]]].
	multiLine := multiLine or: [length + self lineLength > self maxLineSize].
	indentFirst := cascadeBoolean not and: 
					[multiLine and: 
							[(self startMessageSendOnNewLine: aMessageNode) or: 
									[self lineLength + selectorParts first length + 2 + firstArgLength 
										> self maxLineSize]]].
	indentFirst ifTrue: [self indent].
	self 
		formatMessageSelector: selectorParts
		withArguments: formattedArgs
		multiline: multiLine! !

!RBFormatter methodsFor: 'accessing' stamp: ''!
firstLineLength
	^firstLineLength isNil
		ifTrue: [codeStream position]
		ifFalse: [firstLineLength]! !

!RBFormatter methodsFor: 'private-formatting' stamp: 'md 8/26/2004 18:34'!
formatSymbol: aSymbol 
	"Format the symbol, if its not a selector then we must put quotes around it. The and: case below, 
	handles the VisualWorks problem of not accepting two bars as a symbol."

	codeStream nextPut: $#.
	((Scanner isLiteralSymbol: aSymbol) and: [aSymbol ~~ #'||']) 
		ifTrue: [codeStream nextPutAll: aSymbol]
		ifFalse: [aSymbol asString printOn: codeStream]
	

"	((RBScanner isSelector: aSymbol) and: [aSymbol ~~ #'||']) 
		ifTrue: [codeStream nextPutAll: aSymbol]
		ifFalse: [aSymbol asString printOn: codeStream]"! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptMethodNode: aMethodNode 
	self formatMethodPatternFor: aMethodNode.
	self indentWhile: 
			[self formatMethodCommentFor: aMethodNode indentBefore: true.
			self indent.
			self tagBeforeTemporaries ifTrue: [self formatTagFor: aMethodNode].
			aMethodNode body statements isEmpty 
				ifFalse: [self visitNode: aMethodNode body]]! !

!RBFormatter methodsFor: 'private-formatting' stamp: ''!
formatLiteral: aValue 
	| isArray |
	(isArray := aValue class == Array) | (aValue class == ByteArray) ifTrue: 
			[codeStream nextPutAll: (isArray ifTrue: ['#('] ifFalse: ['#[']).
			self for: aValue
				do: [:each | self formatLiteral: each]
				separatedBy: [codeStream nextPut: $ ].
			codeStream nextPut: (isArray ifTrue: [$)] ifFalse: [$]]).
			^self].
	aValue isSymbol ifTrue: 
			[self formatSymbol: aValue.
			^self].
	aValue class == Character ifTrue: 
			[codeStream nextPut: $$;
				nextPut: aValue.
			^self].
	aValue storeOn: codeStream! !

!RBFormatter methodsFor: 'private' stamp: ''!
for: aValue do: doBlock separatedBy: separatorBlock 
	"This is implemented here since IBM Smalltalk doesn't implement a do:separatedBy: method"

	aValue isEmpty ifTrue: [^self].
	1 to: aValue size - 1
		do: 
			[:i | 
			doBlock value: (aValue at: i).
			separatorBlock value].
	doBlock value: aValue last! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptMessageNode: aMessageNode 
	| newFormatter code |
	newFormatter := self copy.
	code := newFormatter format: aMessageNode receiver.
	codeStream nextPutAll: code.
	codeStream nextPut: $ .
	newFormatter isMultiLine
		ifTrue: [lineStart := codeStream position - newFormatter lastLineLength].
	self indent: (newFormatter isMultiLine ifTrue: [2] ifFalse: [1])
		while: [self formatMessage: aMessageNode cascade: false]! !

!RBFormatter methodsFor: 'private' stamp: ''!
maximumArgumentsPerLine
	^2! !

!RBFormatter methodsFor: 'accessing' stamp: ''!
lastLineLength
	^codeStream position - (lineStart max: 0)! !

!RBFormatter methodsFor: 'private-formatting' stamp: ''!
formatStatementsFor: aSequenceNode 
	| statements |
	statements := aSequenceNode statements.
	statements isEmpty ifTrue: [^self].
	1 to: statements size - 1
		do: 
			[:i | 
			self visitNode: (statements at: i).
			codeStream nextPut: $..
			self formatStatementCommentFor: (statements at: i).
			self indent].
	self visitNode: statements last.
	self formatStatementCommentFor: statements last! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptReturnNode: aReturnNode 
	codeStream nextPut: $^.
	self visitNode: aReturnNode value! !

!RBFormatter methodsFor: 'testing' stamp: ''!
startMessageSendOnNewLine: aMessageNode 
	(self selectorsToStartOnNewLine includes: aMessageNode selector) 
		ifTrue: [^true].
	(self selectorsToLeaveOnLine includes: aMessageNode selector) ifTrue: [^false].
	^aMessageNode selector numArgs > self maximumArgumentsPerLine! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptCascadeNode: aCascadeNode 
	| messages |
	messages := aCascadeNode messages.
	self visitNode: messages first receiver.
	self indentWhile: 
			[self 
				for: messages
				do: 
					[:each | 
					self
						indent;
						indentWhile: [self formatMessage: each cascade: true]]
				separatedBy: [codeStream nextPut: $;]]! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptSequenceNode: aSequenceNode 
	self formatMethodCommentFor: aSequenceNode indentBefore: false.
	self formatTemporariesFor: aSequenceNode.
	self tagBeforeTemporaries ifFalse: 
			[| parent |
			parent := aSequenceNode parent.
			(parent notNil and: [parent isMethod]) ifTrue: [self formatTagFor: parent]].
	self formatStatementsFor: aSequenceNode! !

!RBFormatter methodsFor: 'visiting' stamp: ''!
visitNode: aNode 
	| parenthesis |
	parenthesis := self needsParenthesisFor: aNode.
	parenthesis ifTrue: [codeStream nextPut: $(].
	aNode acceptVisitor: self.
	parenthesis ifTrue: [codeStream nextPut: $)]! !

!RBFormatter methodsFor: 'private' stamp: ''!
indentWhile: aBlock 
	self indent: 1 while: aBlock! !

!RBFormatter methodsFor: 'private-formatting' stamp: ''!
formatMethodPatternFor: aMethodNode 
	| selectorParts arguments |
	selectorParts := aMethodNode selectorParts.
	arguments := aMethodNode arguments.
	arguments isEmpty
		ifTrue: [codeStream nextPutAll: selectorParts first value]
		ifFalse: 
			[selectorParts with: arguments
				do: 
					[:selector :arg | 
					codeStream nextPutAll: selector value;
						nextPut: $ .
					self visitArgument: arg.
					codeStream nextPut: $ ]]! !

!RBFormatter methodsFor: 'accessing' stamp: ''!
format: aNode 
	self visitNode: aNode.
	^codeStream contents! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptBlockNode: aBlockNode 
	| seqNode multiline formattedBody formatter |
	seqNode := aBlockNode body.
	formatter := (self copy) lineStart: 0;
				yourself.
	formattedBody := formatter format: seqNode.
	multiline := self lineLength + formattedBody size > self maxLineSize
				or: [formatter isMultiLine].
	multiline ifTrue: [self indent].
	codeStream nextPut: $[.
	aBlockNode arguments do: 
			[:each | 
			codeStream nextPut: $:.
			self visitNode: each.
			codeStream nextPut: $ ].
	aBlockNode arguments isEmpty ifFalse: 
			[codeStream nextPutAll: '| '.
			multiline ifTrue: [self indent]].
	codeStream nextPutAll: formattedBody;
		nextPut: $]! !

!RBFormatter methodsFor: 'private-formatting' stamp: ''!
formatTemporariesFor: aSequenceNode 
	| temps |
	temps := aSequenceNode temporaries.
	temps isEmpty ifTrue: [^self].
	codeStream nextPutAll: '| '.
	temps do: 
			[:each | 
			self visitArgument: each.
			codeStream nextPut: $ ].
	codeStream nextPut: $|.
	self indent! !

!RBFormatter methodsFor: 'copying' stamp: ''!
postCopy
	super postCopy.
	lineStart := self lineLength negated.
	codeStream := WriteStream on: (String new: 60).
	firstLineLength := nil! !

!RBFormatter methodsFor: 'testing' stamp: 'md 8/26/2004 18:29'!
tagBeforeTemporaries
	^false
	"^RBParser isVisualWorks"! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptAssignmentNode: anAssignmentNode 
	self indent: 2
		while: 
			[self visitNode: anAssignmentNode variable.
			codeStream nextPutAll: ' := '.
			self visitNode: anAssignmentNode value]! !

!RBFormatter methodsFor: 'visitor-double dispatching' stamp: ''!
acceptLiteralNode: aLiteralNode 
	^self formatLiteral: aLiteralNode value! !

!RBFormatter methodsFor: 'private' stamp: ''!
selectorsToStartOnNewLine
	^#(#ifTrue:ifFalse: #ifFalse:ifTrue: #ifTrue: #ifFalse:)! !

!RBFormatter methodsFor: 'private' stamp: ''!
lineStart: aPosition 
	lineStart := aPosition! !

!RBFormatter methodsFor: 'private' stamp: ''!
indent: anInteger while: aBlock 
	tabs := tabs + anInteger.
	aBlock value.
	tabs := tabs - anInteger! !

!RBProgramNodeVisitor methodsFor: 'visitor-double dispatching' stamp: ''!
acceptOptimizedNode: anOptimizedNode 
	self visitNode: anOptimizedNode body! !

!RBProgramNodeVisitor methodsFor: 'visiting' stamp: ''!
visitNode: aNode 
	^aNode acceptVisitor: self! !

!RBProgramNodeVisitor methodsFor: 'visiting' stamp: ''!
visitArguments: aNodeCollection 
	^aNodeCollection do: [:each | self visitArgument: each]! !

!RBProgramNodeVisitor methodsFor: 'copying' stamp: ''!
copy
	"Here since IBM doesn't do postCopy's"

	^self shallowCopy postCopy! !

!RBProgramNodeVisitor methodsFor: 'visitor-double dispatching' stamp: ''!
acceptMessageNode: aMessageNode 
	(aMessageNode isCascaded not or: [aMessageNode isFirstCascaded]) 
		ifTrue: [self visitNode: aMessageNode receiver].
	aMessageNode arguments do: [:each | self visitNode: each]! !

!RBProgramNodeVisitor methodsFor: 'visitor-double dispatching' stamp: ''!
acceptReturnNode: aReturnNode 
	self visitNode: aReturnNode value! !

!RBProgramNodeVisitor methodsFor: 'visitor-double dispatching' stamp: ''!
acceptVariableNode: aVariableNode! !

Object subclass: #RBMethod
	instanceVariableNames: 'class compiledMethod source selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Model'!

!RBMethod methodsFor: 'testing' stamp: ''!
refersToVariable: aString 
	| searcher tree |
	tree := self parseTree.
	((tree defines: aString) or: [tree body defines: aString]) 
		ifTrue: [^false].
	searcher := ParseTreeSearcher new.
	searcher
		matches: aString do: [:node :answer | true];
		matches: '[:`@vars | | `@temps | `@.Stmts]'
			do: 
				[:node :answer | 
				answer or: 
						[((node defines: aString) or: [node body defines: aString]) not 
							and: [searcher executeTree: node body initialAnswer: false]]].
	^searcher executeTree: self parseTree initialAnswer: false! !

!RBMethod methodsFor: 'accessing' stamp: ''!
modelClass
	^class! !

!RBMethod methodsFor: 'testing' stamp: ''!
refersToClassNamed: aSymbol 
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher matches: aSymbol asString do: [:node :answer | true].
	^(searcher executeTree: self parseTree initialAnswer: false) 
		or: [self refersToSymbol: aSymbol]! !

!RBMethod methodsFor: 'accessing' stamp: ''!
method
	^compiledMethod! !

!RBMethod methodsFor: 'accessing' stamp: ''!
source: aString 
	source := aString! !

!RBMethod methodsFor: 'accessing' stamp: ''!
parseTree
	^RBParser parseMethod: self source onError: [:str :pos | ^nil]! !

!RBMethod methodsFor: 'accessing' stamp: ''!
selector
	^selector! !

!RBMethod methodsFor: 'private' stamp: ''!
literal: anObject containsReferenceTo: aSymbol 
	anObject = aSymbol ifTrue: [^true].
	anObject class = Array ifFalse: [^false].
	anObject 
		do: [:each | (self literal: each containsReferenceTo: aSymbol) ifTrue: [^true]].
	^false! !

!RBMethod methodsFor: 'accessing' stamp: 'dvf 11/8/2003 15:02'!
source
	^source isNil 
		ifTrue: [source := (class realClass sourceCodeAt: selector) string]
		ifFalse: [source]! !

!RBMethod class methodsFor: 'instance creation' stamp: ''!
for: aRBClass source: aString selector: aSelector 
	^(self new)
		modelClass: aRBClass;
		selector: aSelector;
		source: aString;
		yourself! !

!RBMethod methodsFor: 'testing' stamp: 'dvf 9/17/2001 00:46'!
refersToSymbol: aSymbol 
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher
		matches: aSymbol printString do: [:node :answer | true];
		matches: '`#literal'
			do: [:node :answer | answer or: [self literal: node value containsReferenceTo: aSymbol]].
	(RBScanner isSelector: aSymbol) 
		ifTrue: 
			[searcher 
				matches: '`@object ' , (ParseTreeSearcher buildSelectorString: aSymbol)
				do: [:node :answer | true]].
	^searcher executeTree: self parseTree initialAnswer: false! !

!RBMethod methodsFor: 'accessing' stamp: ''!
method: aCompiledMethod 
	compiledMethod := aCompiledMethod! !

!RBMethod methodsFor: 'accessing' stamp: ''!
modelClass: aRBClass
	class := aRBClass! !

!RBMethod methodsFor: 'printing' stamp: ''!
printOn: aStream 
	class printOn: aStream.
	aStream
		nextPutAll: '>>';
		nextPutAll: self selector! !

!RBMethod class methodsFor: 'instance creation' stamp: ''!
for: aRBClass fromMethod: aCompiledMethod andSelector: aSymbol 
	^(self new)
		modelClass: aRBClass;
		method: aCompiledMethod;
		selector: aSymbol;
		yourself! !

!RBMethod methodsFor: 'accessing' stamp: ''!
selector: aSymbol 
	selector := aSymbol! !

!Object class methodsFor: '*Refactory-RBAddonsMaybeSuperflous' stamp: 'bh 3/16/2000 15:18'!
errorSignal
	"Answer the Signal used for miscellaneous errors (self error:)."

	^Error! !

Object subclass: #RBMethodName
	instanceVariableNames: 'selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Support'!

!RBMethodName methodsFor: 'accessing' stamp: ''!
selector
	^selector! !

!RBMethodName methodsFor: 'accessing' stamp: ''!
arguments: nameCollection 
	arguments := nameCollection.
	self changed: #arguments! !

!RBMethodName methodsFor: 'accessing' stamp: ''!
selector: aSymbol 
	selector := aSymbol.
	self changed: #selector! !

!RBMethodName methodsFor: 'accessing' stamp: ''!
moveArgument: aName before: anotherName 
	arguments remove: aName ifAbsent: [^self].
	arguments add: aName before: anotherName.
	self changed: #arguments! !

!RBMethodName class methodsFor: 'instance creation' stamp: ''!
selector: aSymbol arguments: stringCollection 
	^(self new)
		selector: aSymbol;
		arguments: stringCollection;
		yourself! !

!RBMethodName methodsFor: 'accessing' stamp: ''!
arguments
	^arguments! !

!RBMethodName methodsFor: 'testing' stamp: ''!
isValid
	^(RBCondition checkMethodName: self selector in: self class) 
		and: [self selector numArgs == self arguments size]! !

Object subclass: #RBParseTreeRule
	instanceVariableNames: 'searchTree owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-ParseTree Matching'!

!RBParseTreeRule methodsFor: 'matching' stamp: ''!
canMatch: aProgramNode 
	^true! !

!RBParseTreeRule class methodsFor: 'instance creation' stamp: ''!
search: aString 
	^(self new)
		searchString: aString;
		yourself! !

!RBParseTreeRule methodsFor: 'initialize-release' stamp: ''!
searchString: aString 
	searchTree := RBParser parseRewriteExpression: aString! !

RBParseTreeRule subclass: #RBSearchRule
	instanceVariableNames: 'answerBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-ParseTree Matching'!

!RBSearchRule class methodsFor: 'instance creation' stamp: ''!
searchForMethod: aString thenDo: aBlock 
	^self new searchForMethod: aString thenDo: aBlock! !

!RBSearchRule class methodsFor: 'instance creation' stamp: ''!
searchFor: aString thenDo: aBlock 
	^self new searchFor: aString thenDo: aBlock! !

!RBSearchRule methodsFor: 'testing' stamp: 'bh 4/29/2000 18:15'!
canMatch: aProgramNode 
	self needsWork.
	"testing #copy to attempt to fix block closure issue"
	owner answer: (answerBlock copy value: aProgramNode value: owner answer).
	^ true! !

!RBSearchRule class methodsFor: 'instance creation' stamp: ''!
searchForTree: aBRProgramNode thenDo: aBlock 
	^self new searchForTree: aBRProgramNode thenDo: aBlock! !

!RBSearchRule methodsFor: 'initialize-release' stamp: ''!
searchForMethod: aString thenDo: aBlock 
	self methodSearchString: aString.
	answerBlock := aBlock! !

!RBSearchRule methodsFor: 'initialize-release' stamp: ''!
searchFor: aString thenDo: aBlock 
	self searchString: aString.
	answerBlock := aBlock! !

!RBSearchRule methodsFor: 'initialize-release' stamp: ''!
searchForTree: aBRProgramNode thenDo: aBlock 
	searchTree := aBRProgramNode.
	answerBlock := aBlock! !

!RBParseTreeRule methodsFor: 'accessing' stamp: ''!
sentMessages
	^searchTree sentMessages! !

!RBParseTreeRule methodsFor: 'initialize-release' stamp: ''!
owner: aParseTreeSearcher
	owner := aParseTreeSearcher! !

!RBParseTreeRule methodsFor: 'matching' stamp: ''!
performOn: aProgramNode 
	self context empty.
	^((searchTree match: aProgramNode inContext: self context) 
		and: [self canMatch: aProgramNode]) 
			ifTrue: 
				[owner recusivelySearchInContext.
				self foundMatchFor: aProgramNode]
			ifFalse: [nil]! !

!RBParseTreeRule methodsFor: 'matching' stamp: ''!
foundMatchFor: aProgramNode
	^aProgramNode! !

!RBParseTreeRule class methodsFor: 'instance creation' stamp: ''!
methodSearch: aString 
	^(self new)
		methodSearchString: aString;
		yourself! !

RBParseTreeRule subclass: #RBReplaceRule
	instanceVariableNames: 'verificationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-ParseTree Matching'!

!RBReplaceRule methodsFor: 'matching' stamp: ''!
canMatch: aProgramNode 
	^verificationBlock value: aProgramNode! !

!RBReplaceRule methodsFor: 'matching' stamp: ''!
foundMatchFor: aProgramNode 
	self subclassResponsibility! !

!RBReplaceRule methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	verificationBlock := [:aNode | true]! !

RBReplaceRule subclass: #RBBlockReplaceRule
	instanceVariableNames: 'replaceBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-ParseTree Matching'!

!RBBlockReplaceRule class methodsFor: 'instance creation' stamp: ''!
searchForTree: searchString replaceWith: replaceBlock when: aBlock 
	^self new 
		searchFor: searchString
		replaceWith: replaceBlock
		when: aBlock! !

!RBBlockReplaceRule class methodsFor: 'instance creation' stamp: ''!
searchFor: searchString replaceWith: replaceBlock when: aBlock 
	^self new 
		searchFor: searchString
		replaceWith: replaceBlock
		when: aBlock! !

!RBBlockReplaceRule methodsFor: 'matching' stamp: ''!
foundMatchFor: aProgramNode 
	^replaceBlock value: aProgramNode! !

!RBBlockReplaceRule class methodsFor: 'instance creation' stamp: ''!
searchFor: searchString replaceWith: replaceBlock 
	^self new searchFor: searchString replaceWith: replaceBlock! !

!RBBlockReplaceRule methodsFor: 'initialize-release' stamp: ''!
searchForMethod: searchString replaceWith: replBlock when: verifyBlock 
	self searchForMethod: searchString replaceWith: replBlock.
	verificationBlock := verifyBlock! !

!RBBlockReplaceRule methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	replaceBlock := [:aNode | aNode]! !

!RBBlockReplaceRule methodsFor: 'initialize-release' stamp: ''!
searchForTree: aBRProgramNode replaceWith: replBlock when: verifyBlock 
	self searchForTree: aBRProgramNode replaceWith: replBlock.
	verificationBlock := verifyBlock! !

!RBBlockReplaceRule methodsFor: 'initialize-release' stamp: ''!
searchForMethod: searchString replaceWith: aBlock 
	self methodSearchString: searchString.
	replaceBlock := aBlock! !

!RBBlockReplaceRule methodsFor: 'initialize-release' stamp: ''!
searchForTree: aBRProgramNode replaceWith: aBlock 
	searchTree := aBRProgramNode.
	replaceBlock := aBlock! !

!RBBlockReplaceRule class methodsFor: 'instance creation' stamp: ''!
searchForMethod: searchString replaceWith: replaceBlock when: aBlock 
	^self new 
		searchForMethod: searchString
		replaceWith: replaceBlock
		when: aBlock! !

!RBBlockReplaceRule methodsFor: 'initialize-release' stamp: ''!
searchFor: searchString replaceWith: replBlock when: verifyBlock 
	self searchFor: searchString replaceWith: replBlock.
	verificationBlock := verifyBlock! !

!RBBlockReplaceRule class methodsFor: 'instance creation' stamp: ''!
searchForTree: searchString replaceWith: replaceBlock 
	^self new searchForTree: searchString replaceWith: replaceBlock! !

!RBBlockReplaceRule class methodsFor: 'instance creation' stamp: ''!
searchForMethod: searchString replaceWith: replaceBlock 
	^self new searchForMethod: searchString replaceWith: replaceBlock! !

!RBBlockReplaceRule methodsFor: 'initialize-release' stamp: ''!
searchFor: searchString replaceWith: aBlock 
	self searchString: searchString.
	replaceBlock := aBlock! !

RBReplaceRule subclass: #RBStringReplaceRule
	instanceVariableNames: 'replaceTree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-ParseTree Matching'!

!RBStringReplaceRule methodsFor: 'initialize-release' stamp: ''!
methodReplaceString: replaceString 
	replaceTree := RBParser parseRewriteMethod: replaceString! !

!RBStringReplaceRule methodsFor: 'initialize-release' stamp: ''!
searchForMethod: searchString replaceWith: replaceString 
	self methodSearchString: searchString.
	self methodReplaceString: replaceString! !

!RBStringReplaceRule methodsFor: 'initialize-release' stamp: ''!
searchFor: searchString replaceWith: replaceString 
	self searchString: searchString.
	self replaceString: replaceString! !

!RBStringReplaceRule methodsFor: 'initialize-release' stamp: ''!
searchForTree: aBRProgramNode replaceWith: replaceNode 
	searchTree := aBRProgramNode.
	replaceTree := replaceNode! !

!RBStringReplaceRule methodsFor: 'initialize-release' stamp: ''!
replaceString: replaceString 
	replaceTree := RBParser parseRewriteExpression: replaceString.
	searchTree isSequence = replaceTree isSequence 
		ifFalse: 
			[searchTree isSequence 
				ifTrue: [replaceTree := RBSequenceNode statements: (Array with: replaceTree)]
				ifFalse: [searchTree := RBSequenceNode statements: (Array with: searchTree)]]! !

!RBStringReplaceRule class methodsFor: 'instance creation' stamp: ''!
searchForTree: searchString replaceWith: replaceString 
	^self new searchForTree: searchString replaceWith: replaceString! !

!RBStringReplaceRule class methodsFor: 'instance creation' stamp: ''!
searchForTree: searchString replaceWith: replaceString when: aBlock 
	^self new 
		searchForTree: searchString
		replaceWith: replaceString
		when: aBlock! !

!RBStringReplaceRule methodsFor: 'initialize-release' stamp: ''!
searchFor: searchString replaceWith: replaceString when: aBlock 
	self searchFor: searchString replaceWith: replaceString.
	verificationBlock := aBlock! !

!RBStringReplaceRule class methodsFor: 'instance creation' stamp: ''!
searchFor: searchString replaceWith: replaceString 
	^self new searchFor: searchString replaceWith: replaceString! !

!RBStringReplaceRule class methodsFor: 'instance creation' stamp: ''!
searchForMethod: searchString replaceWith: replaceString when: aBlock 
	^self new 
		searchForMethod: searchString
		replaceWith: replaceString
		when: aBlock! !

!RBStringReplaceRule class methodsFor: 'instance creation' stamp: ''!
searchFor: searchString replaceWith: replaceString when: aBlock 
	^self new 
		searchFor: searchString
		replaceWith: replaceString
		when: aBlock! !

!RBStringReplaceRule class methodsFor: 'instance creation' stamp: ''!
searchForMethod: searchString replaceWith: replaceString
	^self new searchForMethod: searchString replaceWith: replaceString! !

!RBStringReplaceRule methodsFor: 'matching' stamp: ''!
foundMatchFor: aProgramNode 
	| newTree |
	newTree := replaceTree copyInContext: self context.
	newTree copyCommentsFrom: aProgramNode.
	^newTree! !

!RBStringReplaceRule methodsFor: 'initialize-release' stamp: ''!
searchForTree: aBRProgramNode replaceWith: replaceString when: aBlock 
	self searchForTree: aBRProgramNode replaceWith: replaceString.
	verificationBlock := aBlock! !

!RBStringReplaceRule methodsFor: 'initialize-release' stamp: ''!
searchForMethod: searchString replaceWith: replaceString when: aBlock 
	self searchForMethod: searchString replaceWith: replaceString.
	verificationBlock := aBlock! !

!RBParseTreeRule methodsFor: 'initialize-release' stamp: ''!
initialize! !

!RBParseTreeRule methodsFor: 'initialize-release' stamp: ''!
methodSearchString: aString 
	searchTree := RBParser parseRewriteMethod: aString! !

!RBParseTreeRule methodsFor: 'private' stamp: ''!
context
	^owner context! !

Object subclass: #RefactoryChangeManager
	instanceVariableNames: 'undo redo isPerformingRefactoring'
	classVariableNames: 'UndoSize Instance'
	poolDictionaries: ''
	category: 'Refactory-Change Objects'!

!RefactoryChangeManager methodsFor: 'updating' stamp: ''!
update: anAspectSymbol with: aParameter from: aSender 
	| changeType |
	(aSender == ChangeSet and: [isPerformingRefactoring not]) ifFalse: [^self].
	anAspectSymbol == #reorganizeClass: ifTrue: [^self].
	changeType := (anAspectSymbol isString 
				ifTrue: [anAspectSymbol asString]
				ifFalse: ['class']) asLowercase.
	(changeType indexOfSubCollection: 'class' startingAt: 1) 
		+ (changeType indexOfSubCollection: 'selector' startingAt: 1) > 0 
		ifTrue: [self clearUndoRedoList]! !

!RefactoryChangeManager class methodsFor: 'instance creation' stamp: ''!
new
	^self shouldNotImplement! !

!RefactoryChangeManager methodsFor: 'initialize-release' stamp: ''!
initialize
	undo := OrderedCollection new.
	redo := OrderedCollection new.
	isPerformingRefactoring := false.
	self connectToChanges! !

!RefactoryChangeManager methodsFor: 'initialize-release' stamp: ''!
release
	super release.
	self disconnectFromChanges! !

!RefactoryChangeManager class methodsFor: 'instance creation' stamp: ''!
instance
	Instance isNil 
		ifTrue: 
			[Instance := self basicNew.
			Instance initialize].
	^Instance! !

!RefactoryChangeManager methodsFor: 'public access' stamp: ''!
addUndo: aRefactoringChange 
	undo addLast: aRefactoringChange.
	undo size > UndoSize ifTrue: [undo removeFirst].
	redo := OrderedCollection new! !

!RefactoryChangeManager methodsFor: 'initialize-release' stamp: ''!
connectToChanges
	ChangeSet addDependent: self! !

!RefactoryChangeManager methodsFor: 'public access' stamp: ''!
undoChange
	^undo last! !

!RefactoryChangeManager methodsFor: 'public access' stamp: ''!
redoChange
	^redo last! !

!RefactoryChangeManager class methodsFor: 'class initialization' stamp: ''!
initialize
	self nuke.
	UndoSize := 5! !

!RefactoryChangeManager methodsFor: 'testing' stamp: ''!
hasRedoableOperations
	^redo isEmpty not! !

!RefactoryChangeManager methodsFor: 'public access' stamp: ''!
performChange: aRefactoringChange 
	self ignoreChangesWhile: [self addUndo: aRefactoringChange execute]! !

!RefactoryChangeManager methodsFor: 'public access' stamp: ''!
ignoreChangesWhile: aBlock 
	isPerformingRefactoring ifTrue: [^aBlock value].
	isPerformingRefactoring := true.
	aBlock ensure: [isPerformingRefactoring := false]! !

!RefactoryChangeManager class methodsFor: 'class initialization' stamp: ''!
undoSize: anInteger 
	UndoSize := anInteger max: 0! !

!RefactoryChangeManager methodsFor: 'testing' stamp: ''!
hasUndoableOperations
	^undo isEmpty not! !

!RefactoryChangeManager methodsFor: 'initialize-release' stamp: ''!
disconnectFromChanges
	ChangeSet removeDependent: self! !

!RefactoryChangeManager class methodsFor: 'public access' stamp: ''!
nuke
	Instance notNil ifTrue: [Instance release].
	Instance := nil! !

!RefactoryChangeManager class methodsFor: 'class initialization' stamp: ''!
undoSize
	^UndoSize! !

!RefactoryChangeManager methodsFor: 'private' stamp: ''!
clearUndoRedoList
	undo := OrderedCollection new.
	redo := OrderedCollection new! !

!RefactoryChangeManager methodsFor: 'public access' stamp: ''!
undoOperation
	undo isEmpty ifTrue: [^self].
	self ignoreChangesWhile: 
			[| change |
			change := undo removeLast.
			redo add: change execute]! !

!RefactoryChangeManager methodsFor: 'public access' stamp: ''!
redoOperation
	redo isEmpty ifTrue: [^self].
	self ignoreChangesWhile: 
			[| change |
			change := redo removeLast.
			undo add: change execute]! !

Object subclass: #RefactoryTyper
	instanceVariableNames: 'model class variableTypes bestGuesses variableMessages bindings backpointers methodName selectorLookup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Support'!

!RefactoryTyper methodsFor: 'accessing' stamp: ''!
guessTypesFor: anInstVarName in: aClass 
	class = aClass ifFalse: [self runOn: aClass].
	^bestGuesses at: anInstVarName
		ifAbsent: [self typesFor: anInstVarName in: aClass]! !

!RefactoryTyper methodsFor: 'equivalence classes' stamp: ''!
processNode: aNode 
	(aNode isVariable and: [class instanceVariableNames includes: aNode name]) 
		ifTrue: [^self merge: aNode name].
	(aNode isMessage 
		and: [aNode receiver isVariable and: [aNode receiver name = 'self']]) 
			ifTrue: [^self merge: aNode selector].
	aNode isAssignment 
		ifTrue: 
			[self
				processNode: aNode value;
				processNode: aNode variable].
	(aNode isMessage and: 
			[#(#ifTrue: #ifFalse: #ifTrue:ifFalse: #ifFalse:ifTrue:) 
				includes: aNode selector]) 
		ifTrue: 
			[aNode arguments do: 
					[:each | 
					each isBlock 
						ifTrue: 
							[each body statements isEmpty 
								ifFalse: [self processNode: each body statements last]]]]! !

!RefactoryTyper methodsFor: 'computing types' stamp: ''!
findTypeFor: selectorCollection 
	^selectorCollection inject: model rootClasses
		into: 
			[:classes :each | 
			self refineTypes: classes
				with: (selectorLookup at: each ifAbsentPut: [self implementorsOf: each])]! !

!RefactoryTyper methodsFor: 'selectors-collections' stamp: ''!
processCollectionMessagesFor: variableName in: aParseTree 
	| parent block |
	aParseTree isMessage ifFalse: [^self].
	(#(#first #at: #last) includes: aParseTree selector) 
		ifTrue: 
			[parent := aParseTree parent.
			(parent notNil and: [parent isMessage]) ifFalse: [^self].
			aParseTree == parent receiver ifFalse: [^self].
			(variableMessages at: (self collectionNameFor: variableName)
				ifAbsentPut: [Set new]) add: parent selector.
			self processCollectionMessagesFor: (self collectionNameFor: variableName)
				in: parent].
	(#(#do: #do:separatedBy: #collect: #reject: #select: #detect: #detect:ifNone:) 
		includes: aParseTree selector) 
			ifTrue: 
				[block := aParseTree arguments first.
				block isBlock ifFalse: [^self].
				self 
					processCollectionFor: variableName
					messagesTo: block arguments first name
					in: block].
	#inject:into: == aParseTree selector 
		ifTrue: 
			[block := aParseTree arguments last.
			block isBlock ifFalse: [^self].
			self 
				processCollectionFor: variableName
				messagesTo: block arguments last name
				in: block]! !

!RefactoryTyper methodsFor: 'assignments' stamp: 'bh 4/3/2000 11:52'!
typeFor: anObject 
	'' class == anObject class ifTrue: [^String].
	^( {true. false} includes: anObject) 
		ifTrue: [Boolean]
		ifFalse: [anObject class]! !

!RefactoryTyper methodsFor: 'equivalence classes' stamp: 'rr 3/15/2004 14:06'!
merge: aName 
	"rr 3/15/2004 14:05 add: the ifAbsent: keyword in the last line, as I encountered a failing case"
	| set1 set2 |
	set1 := backpointers at: methodName ifAbsent: [nil].
	set2 := backpointers at: aName ifAbsent: [nil].
	(set1 isNil or: [set2 isNil or: [set1 == set2]]) ifTrue: [^self].
	set1 addAll: set2.
	set2 do: [:each | backpointers at: each put: set1].
	bindings remove: set2 ifAbsent: [] ! !

!RefactoryTyper methodsFor: 'computing types' stamp: ''!
computeTypes
	variableMessages
		keysAndValuesDo: [:key :value | variableTypes at: key put: (self findTypeFor: value)]! !

!RefactoryTyper methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPutAll: class name;
		cr.
	class instanceVariableNames do: 
			[:each | 
			aStream
				tab;
				nextPutAll: each;
				tab;
				nextPut: $<.
			self printTypeFor: each on: aStream.
			aStream
				nextPut: $>;
				cr]! !

!RefactoryTyper methodsFor: 'printing' stamp: ''!
printTypeFor: aString on: aStream 
	| types |
	types := (self guessTypesFor: aString) 
				asSortedCollection: [:a :b | a name < b name].
	1 to: types size
		do: 
			[:i | 
			i == 1 ifFalse: [aStream nextPutAll: ' | '].
			self 
				printType: (types at: i)
				for: aString
				on: aStream]! !

!RefactoryTyper methodsFor: 'accessing' stamp: ''!
selectedClass: aClass 
	class := model classFor: aClass! !

!RefactoryTyper class methodsFor: 'instance creation' stamp: ''!
newFor: aRBNamespace 
	^(self new)
		model: aRBNamespace;
		yourself! !

!RefactoryTyper methodsFor: 'printing' stamp: ''!
printType: aClass for: aString on: aStream 
	| name colTypes |
	colTypes := #().
	name := self collectionNameFor: aString.
	(aClass includesClass: (model classFor: Collection))
		ifTrue: [colTypes := self guessTypesFor: name].
	colTypes isEmpty ifFalse: [aStream nextPut: $(].
	aClass printOn: aStream.
	colTypes isEmpty
		ifFalse: 
			[aStream nextPutAll: ' of: '.
			colTypes size > 1 ifTrue: [aStream nextPut: $(].
			self printTypeFor: name on: aStream.
			colTypes size > 1 ifTrue: [aStream nextPut: $)]].
	colTypes isEmpty ifFalse: [aStream nextPut: $)]! !

!RefactoryTyper methodsFor: 'selectors-collections' stamp: ''!
processCollectionFor: key messagesTo: aName in: aBlock 
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher matches: aName , ' `@message: ``@args'
		do: 
			[:aNode :answer | 
			self processCollectionMessagesFor: key in: aNode.
			answer
				add: aNode selector;
				yourself].
	searcher executeTree: aBlock
		initialAnswer: (variableMessages at: (self collectionNameFor: key)
				ifAbsentPut: [Set new])! !

!RefactoryTyper methodsFor: 'equivalence classes' stamp: ''!
computeEquivalenceClassesForMethodsAndVars
	| searcher |
	bindings := Set new.
	backpointers := Dictionary new.
	class instanceVariableNames 
		do: [:each | backpointers at: each put: (bindings add: (Set with: each))].
	class withAllSubclasses do: 
			[:sub | 
			sub selectors 
				do: [:each | backpointers at: each put: (bindings add: (Set with: each))]].
	searcher := ParseTreeSearcher new.
	searcher matches: '^``@object'
		do: [:aNode :answer | self processNode: aNode value].
	self executeSearch: searcher! !

!RefactoryTyper methodsFor: 'private' stamp: ''!
model: aRBSmalltalk
	model := aRBSmalltalk! !

!RefactoryTyper class methodsFor: 'accessing' stamp: ''!
typesFor: variableName in: aParseTree model: aRBSmalltalk 
	| searcher messages |
	searcher := ParseTreeSearcher new.
	searcher matches: variableName , ' `@message: ``@args'
		do: 
			[:aNode :answer | 
			answer
				add: aNode selector;
				yourself].
	messages := searcher executeTree: aParseTree initialAnswer: Set new.
	^(self new)
		model: aRBSmalltalk;
		findTypeFor: messages! !

!RefactoryTyper methodsFor: 'computing types' stamp: ''!
refineTypes: aClassCollection with: anotherClassCollection 
	| classSet |
	classSet := Set new.
	aClassCollection do: 
			[:each | 
			anotherClassCollection do: 
					[:cls | 
					(cls includesClass: each) 
						ifTrue: [classSet add: cls]
						ifFalse: [(each includesClass: cls) ifTrue: [classSet add: each]]]].
	^classSet! !

!RefactoryTyper methodsFor: 'initialize-release' stamp: ''!
initialize
	model := RBNamespace new.
	class := model classFor: Object.
	variableTypes := Dictionary new.
	variableMessages := Dictionary new.
	selectorLookup := IdentityDictionary new.
	bestGuesses := Dictionary new! !

!RefactoryTyper methodsFor: 'accessing' stamp: ''!
runOn: aClass 
	variableTypes := Dictionary new.
	variableMessages := Dictionary new.
	bestGuesses := Dictionary new.
	class := model classFor: aClass.
	class instanceVariableNames isEmpty ifTrue: [^self].
	self
		selectedClass: aClass;
		computeEquivalenceClassesForMethodsAndVars;
		computeMessagesSentToVariables;
		computeTypes;
		refineTypesByLookingAtAssignments! !

!RefactoryTyper methodsFor: 'assignments' stamp: ''!
refineTypesByLookingAtAssignments
	| searcher needsSearch |
	needsSearch := false.
	searcher := ParseTreeSearcher new.
	variableTypes keysAndValuesDo: 
			[:key :value | 
			(key first == $-) 
				ifFalse: 
					[needsSearch := true.
					searcher matches: key , ' := ``@object'
						do: [:aNode :answer | self guessTypeFromAssignment: aNode]]].
	needsSearch ifTrue: [self executeSearch: searcher]! !

!RefactoryTyper methodsFor: 'private' stamp: ''!
model
	^model! !

!RefactoryTyper methodsFor: 'selectors' stamp: ''!
computeMessagesSentToVariables
	| searcher |
	variableMessages := Dictionary new.
	class instanceVariableNames 
		do: [:each | variableMessages at: each put: Set new].
	searcher := ParseTreeSearcher new.
	class instanceVariableNames do: 
			[:each | 
			| block |
			block := 
					[:aNode :answer | 
					(variableMessages at: each ifAbsentPut: [Set new]) add: aNode selector.
					self processCollectionMessagesFor: each in: aNode].
			searcher matches: each , ' `@messageName: ``@args' do: block.
			(backpointers at: each) do: 
					[:sel | 
					sel isSymbol 
						ifTrue: 
							[searcher 
								matches: ('(self <1s>) `@messageName: ``@args' 
										expandMacrosWith: (ParseTreeSearcher buildSelectorString: sel)) asString
								do: block]]].
	searcher answer: variableMessages.
	self executeSearch: searcher! !

!RefactoryTyper methodsFor: 'computing types' stamp: ''!
implementorsOf: aSelector 
	| classes |
	classes := OrderedCollection new.
	model rootClasses do: 
			[:each | 
			self 
				implementorsOf: aSelector
				in: each
				storeIn: classes].
	^classes! !

!RefactoryTyper methodsFor: 'computing types' stamp: ''!
implementorsOf: aSelector in: aClass storeIn: classes 
	(aClass directlyDefinesMethod: aSelector) 
		ifTrue: 
			[classes add: aClass.
			^self].
	aClass subclasses do: 
			[:each | 
			self 
				implementorsOf: aSelector
				in: each
				storeIn: classes]! !

!RefactoryTyper methodsFor: 'accessing' stamp: ''!
typesFor: anInstVarName in: aClass 
	class = aClass ifFalse: [self runOn: aClass].
	^variableTypes at: anInstVarName ifAbsent: [Set new]! !

!RefactoryTyper methodsFor: 'accessing' stamp: ''!
typesFor: anInstVarName 
	^variableTypes at: anInstVarName ifAbsent: [Set new]! !

!RefactoryTyper methodsFor: 'assignments' stamp: ''!
guessTypeFromAssignment: aNode 
	| type set newType |
	type := nil.
	aNode value isAssignment 
		ifTrue: 
			[^self guessTypeFromAssignment: (RBAssignmentNode variable: aNode variable
						value: aNode value value)].
	aNode value isBlock ifTrue: [type := model classFor: [] class].
	aNode value isLiteral 
		ifTrue: 
			[aNode value value isNil ifTrue: [^self].
			type := model classFor: (self typeFor: aNode value value)].
	aNode value isMessage 
		ifTrue: 
			[aNode value receiver isVariable 
				ifTrue: [type := model classNamed: aNode value receiver name asSymbol].
			aNode value selector == #asValue 
				ifTrue: [type := model classNamed: #ValueHolder].
			(#(#and: #or: #= #== #~= #~~ #<= #< #~~ #> #>=) 
				includes: aNode value selector) ifTrue: [type := model classFor: Boolean]].
	type isNil ifTrue: [^self].
	set := variableTypes at: aNode variable name.
	newType := set detect: [:each | type includesClass: each] ifNone: [nil].
	newType isNil ifTrue: [^self].
	newType = (model classFor: Object) ifTrue: [newType := type].
	(bestGuesses at: aNode variable name ifAbsentPut: [Set new]) add: newType! !

!RefactoryTyper methodsFor: 'private' stamp: ''!
executeSearch: searcher 
	class withAllSubclasses do: 
			[:each | 
			each selectors do: 
					[:sel | 
					| parseTree |
					methodName := sel.
					parseTree := each parseTreeFor: sel.
					parseTree notNil ifTrue: [searcher executeTree: parseTree]]]! !

!RefactoryTyper methodsFor: 'printing' stamp: ''!
collectionNameFor: aString 
	^'-<1s>-' expandMacrosWith: aString! !

!RefactoryTyper methodsFor: 'private' stamp: ''!
rootClasses
	^Class rootsOfTheWorld! !

!RefactoryTyper methodsFor: 'accessing' stamp: ''!
guessTypesFor: anInstVarName 
	^bestGuesses at: anInstVarName ifAbsent: [self typesFor: anInstVarName]! !

Object subclass: #SmalllintChecker
	instanceVariableNames: 'rule environment context methodBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Lint'!

!SmalllintChecker methodsFor: 'accessing' stamp: ''!
context: aSmalllintContext 
	context := aSmalllintContext! !

!SmalllintChecker methodsFor: 'accessing' stamp: ''!
environment: aBrowserEnvironment 
	environment := aBrowserEnvironment! !

!SmalllintChecker class methodsFor: 'instance creation' stamp: 'nk 11/12/2002 13:12'!
runRule: aLintRule
	(self new)
		rule: aLintRule;
		run.
	^aLintRule! !

!SmalllintChecker methodsFor: 'accessing' stamp: ''!
rule: aLintRule 
	rule := aLintRule! !

!SmalllintChecker methodsFor: 'initialize-release' stamp: ''!
initialize
	methodBlock := [].
	environment := SelectorEnvironment new.
	context := SmalllintContext newNoCache! !

!SmalllintChecker methodsFor: 'private' stamp: ''!
checkMethodsForClass: aClass 
	^environment selectorsForClass: aClass
		do: 
			[:each | 
			context selector: each.
			rule checkMethod: context.
			methodBlock value]! !

!SmalllintChecker class methodsFor: 'instance creation' stamp: ''!
runRule: aLintRule onEnvironment: aBrowserEnvironment 
	(self new)
		rule: aLintRule;
		environment: aBrowserEnvironment;
		run.
	^aLintRule! !

!SmalllintChecker methodsFor: 'accessing' stamp: ''!
methodBlock: aBlock 
	methodBlock := aBlock! !

!SmalllintChecker methodsFor: 'initialize-release' stamp: ''!
release
	context release.
	super release! !

!SmalllintChecker methodsFor: 'private' stamp: ''!
checkClass: aClass 
	context selectedClass: aClass.
	(environment definesClass: aClass) ifTrue: [rule checkClass: context]! !

!SmalllintChecker methodsFor: 'actions' stamp: ''!
run
	rule resetResult.
	environment classesDo: 
			[:aClass | 
			self checkClass: aClass.
			self checkMethodsForClass: aClass]! !

!SmalllintChecker class methodsFor: 'instance creation' stamp: ''!
newWithContext
	^(self new)
		context: SmalllintContext new;
		yourself! !

Object subclass: #RBAbstractCondition
	instanceVariableNames: 'errorMacro'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Conditions'!

RBAbstractCondition subclass: #RBConjunctiveCondition
	instanceVariableNames: 'left right failed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Conditions'!

!RBConjunctiveCondition methodsFor: 'private' stamp: ''!
leftFailed
	^left errorStringFor: false! !

!RBConjunctiveCondition methodsFor: 'private' stamp: ''!
unknownFailed
	^(left errorStringFor: false) , ' OR ' , (right errorStringFor: false)! !

!RBConjunctiveCondition methodsFor: 'private' stamp: ''!
neitherFailed
	^(left errorStringFor: true) , ' AND ' , (right errorStringFor: true)! !

!RBConjunctiveCondition methodsFor: 'private' stamp: ''!
rightFailed
	^right errorStringFor: false! !

!RBConjunctiveCondition methodsFor: 'private' stamp: ''!
longMacro
	^'(' , left errorMacro , ') <1?AND:OR> (' , right errorMacro , ')'! !

!RBConjunctiveCondition methodsFor: 'checking' stamp: ''!
check
	left check
		ifFalse: 
			[failed := #leftFailed.
			^false].
	right check
		ifFalse: 
			[failed := #rightFailed.
			^false].
	^true! !

!RBConjunctiveCondition methodsFor: 'initialize-release' stamp: ''!
left: aCondition right: aCondition2 
	left := aCondition.
	right := aCondition2.
	failed := #unknownFailed! !

!RBConjunctiveCondition methodsFor: 'private' stamp: ''!
errorStringFor: aBoolean 
	^aBoolean
		ifTrue: [self neitherFailed]
		ifFalse: [self perform: failed]! !

!RBConjunctiveCondition methodsFor: 'private' stamp: ''!
errorBlockFor: aBoolean 
	^aBoolean
		ifTrue: [nil]
		ifFalse: 
			[failed == #leftFailed ifTrue: [left errorBlock] ifFalse: [right errorBlock]]! !

!RBConjunctiveCondition methodsFor: 'printing' stamp: 'bh 4/10/2001 16:52'!
printOn: aStream 
	aStream nextPutAll: left asString;
		nextPutAll: ' & ';
		nextPutAll: right asString
! !

!RBConjunctiveCondition methodsFor: 'private' stamp: ''!
errorMacro
	^errorMacro isNil
		ifTrue: [self longMacro]
		ifFalse: [super errorMacro]! !

!RBAbstractCondition methodsFor: 'logical operations' stamp: ''!
& aCondition 
	^RBConjunctiveCondition new left: self right: aCondition! !

!RBAbstractCondition methodsFor: 'logical operations' stamp: ''!
| aCondition 
	"(A | B) = (A not & B not) not"

	^(self not & aCondition not) not! !

!RBAbstractCondition methodsFor: 'accessing' stamp: ''!
errorString
	^self errorStringFor: false! !

!RBAbstractCondition methodsFor: 'private' stamp: ''!
errorStringFor: aBoolean
	^self errorMacro expandMacrosWith: aBoolean! !

RBAbstractCondition subclass: #RBCondition
	instanceVariableNames: 'block type errorBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Conditions'!

!RBCondition class methodsFor: 'instance creation' stamp: ''!
isValidClassName: aString
	^self new
		type: (Array with: #validClassName with: aString)
		block: [self validClassName: aString]
		errorString: aString , ' is <1?:not >a valid class name'! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
directlyDefinesClassVariable: aString in: aClass 
	^self new 
		type: (Array with: #directlyDefinesClassVar with: aClass with: aString)
		block: [aClass directlyDefinesClassVariable: aString]
		errorString: aClass printString 
				, ' <1?:does not >directly define<1?s:> class variable ' , aString! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
hasSuperclass: aClass 
	^self new 
		type: (Array with: #hasSuperclass with: aClass)
		block: [aClass superclass isNil not]
		errorString: aClass printString , ' has <1?a:no> superclass'! !

!RBCondition class methodsFor: 'utilities' stamp: ''!
methodDefiningTemporary: aString in: aClass ignore: aBlock 
	| searcher method |
	searcher := ParseTreeSearcher new.
	method := nil.	"Shut-up the warning"
	searcher matches: aString do: [:aNode :answer | ^method].
	aClass withAllSubclasses do: 
			[:class | 
			class selectors do: 
					[:each | 
					(aBlock value: class value: each) 
						ifFalse: 
							[| parseTree |
							method := class methodFor: each.
							parseTree := class parseTreeFor: each.
							parseTree notNil ifTrue: [searcher executeTree: parseTree]]]].
	^nil! !

!RBCondition methodsFor: 'printing' stamp: 'bh 4/10/2001 16:51'!
printOn: aStream 
	aStream nextPutAll: type asString! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
definesTempVar: aString in: aClass ignoreClass: subclass 
	| condition |
	condition := self new.
	condition 
		type: (Array with: #definesTempVarIgnoring with: aClass with: aString with: subclass)
		block: 
			[| method |
			method := self 
						methodDefiningTemporary: aString
						in: aClass
						ignore: [:class :aSelector | class includesClass: subclass].
			method notNil 
				ifTrue: 
					[condition errorMacro: method printString , ' defines variable ' , aString].
			method notNil]
		errorString: aClass printString 
				, ' <1?:does not >define<1?s:> temporary variable ' , aString.
	^condition! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
hasSubclasses: aClass
	^self new
		type: (Array with: #hasSubclasses with: aClass)
		block: [aClass subclasses isEmpty not]
		errorString: aClass printString , ' has <1?:no >subclasses'! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
definesInstanceVariable: aString in: aClass 
	^self new 
		type: (Array 
				with: #definesInstVar
				with: aClass
				with: aString)
		block: [aClass definesInstanceVariable: aString]
		errorString: aClass printString 
				, ' <1?:does not >define<1?s:> instance variable ' , aString! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
isSymbol: aString
	^self new
		type: (Array with: #isSymbol with: aString)
		block: [aString isSymbol]
		errorString: aString , ' is <1?:not >a symbol'! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
hierarchyOf: aClass definesVariable: aString 
	^self new 
		type: (Array 
				with: #hierarchyDefinesInstVar
				with: aClass
				with: aString)
		block: [aClass hierarchyDefinesVariable: aString]
		errorString: aClass printString 
				, ' or one of its subclasses <1?:does not >define<1?s:> variable ' 
					, aString! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
isAbstractClass: aClass 
	^self new 
		type: (Array with: #IsAbstractClass with: aClass)
		block: [aClass isAbstract]
		errorString: aClass printString , ' is <1?:not >an abstract class'! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
referencesInstanceVariable: aString in: aClass 
	^self new 
		type: (Array with: #referencesInstVar with: aClass with: aString)
		block: [(aClass whichSelectorsReferToInstanceVariable: aString) isEmpty not]
		errorString: aClass printString 
				, ' <1?:does not >reference<1?s:> instance variable ' , aString! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
directlyDefinesInstanceVariable: aString in: aClass 
	^self new 
		type: (Array with: #directlyDefinesInstanceVariable with: aClass with: aString)
		block: [aClass directlyDefinesInstanceVariable: aString]
		errorString: aClass printString 
				, ' <1?:does not >directly define<1?s:> instance variable ' , aString! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
subclassesOf: aClass referToSelector: aSelector 
	^self new 
		type: (Array 
				with: #subclassReferences
				with: aClass
				with: aSelector)
		block: 
			[(aClass subclasses detect: 
					[:each | 
					(each selectors detect: 
							[:sel | 
							| tree |
							tree := each parseTreeFor: sel.
							tree notNil and: [tree superMessages includes: aSelector]]
						ifNone: [nil]) notNil]
				ifNone: [nil]) notNil]
		errorString: '<1?:no:a> subclass of ' , aClass printString , ' refers to ' 
				, aSelector printString! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
isValidInstanceVariableName: aString for: aClass 
	^self new 
		type: (Array 
				with: #validInstVarName
				with: aString
				with: aClass)
		block: [self checkInstanceVariableName: aString in: aClass]
		errorString: aString , ' is <1?:not >a valid instance variable name'! !

!RBCondition class methodsFor: 'utilities' stamp: ''!
validClassName: aString 
	"Class names and class variable names have the same restrictions"

	^self checkClassVarName: aString in: self! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
withBlock: aBlock errorString: aString 
	^self new type: #unknown
		block: aBlock
		errorString: aString! !

!RBCondition class methodsFor: 'utilities' stamp: ''!
checkInstanceVariableName: aName in: aClass 
	| string |
	aName isString ifFalse: [^false].
	string := aName asString.
	string isEmpty ifTrue: [^false].
	(self reservedNames includes: string) ifTrue: [^false].
	string first isUppercase ifTrue: [^false].
	^RBScanner isVariable: string! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
isEmptyClass: anObject 
	^self new type: (Array with: #IsEmptyClass with: anObject)
		block: 
			[anObject classVariableNames isEmpty
				and: [anObject instanceVariableNames isEmpty and: [anObject selectors isEmpty]]]
		errorString: anObject printString , ' is <1?:not > empty'! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
empty
	"Returns an empty condition"

	^self new 
		type: (Array with: #empty)
		block: [true]
		errorString: 'Empty'! !

!RBCondition class methodsFor: 'utilities' stamp: ''!
checkMethodName: aName in: aClass 
	^aName isString and: [RBScanner isSelector: aName]! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
isImmediateSubclass: subclass of: superClass
	^self new
		type: (Array with: #immediateSubclass with: superClass with: subclass)
		block: [subclass superclass = superClass]
		errorString: subclass printString , ' is <1?:not >an immediate subclass of ' , superClass printString! !

!RBCondition methodsFor: 'initialize-release' stamp: ''!
withBlock: aBlock 
	block := aBlock.
	type := #(#generic)! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
withBlock: aBlock
	^self new withBlock: aBlock! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
isValidClassVarName: aString for: aClass
	^self new
		type: (Array with: #validClassVarName with: aString with: aClass)
		block: [self checkClassVarName: aString in: aClass]
		errorString: aString , ' is <1?:not >a valid class variable name'! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
definesSelector: aSelector in: aClass 
	^self new
		type: (Array with: #definesSelector with: aClass with: aSelector)
		block: [aClass directlyDefinesMethod: aSelector]
		errorString: aClass printString , ' <1?:does not >define<1?s:> ' , aSelector printString! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
isMetaclass: anObject 
	^self new type: (Array with: #IsMetaclass with: anObject)
		block: [anObject isMeta]
		errorString: anObject printString , ' is <1?:not >a metaclass'! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
isClass: anObject
	^self new
		type: (Array with: #IsClass with: anObject)
		block: [anObject isBehavior]
		errorString: anObject printString , ' is <1?:not >a behavior'! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
definesClassVariable: aString in: aClass 
	^self new 
		type: (Array 
				with: #definesClassVar
				with: aClass
				with: aString)
		block: [aClass definesClassVariable: aString]
		errorString: aClass printString 
				, ' <1?:does not >define<1?s:> class variable ' , aString! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
isValidMethodName: aString for: aClass
	^self new
		type: (Array with: #validMethodName with: aString with: aClass)
		block: [self checkMethodName: aString in: aClass]
		errorString: aString printString , ' is <1?:not >a valid method name'! !

!RBCondition class methodsFor: 'utilities' stamp: ''!
checkClassVarName: aName in: aClass 
	| string |
	aName isString ifFalse: [^false].
	string := aName asString.
	(self reservedNames includes: string) ifTrue: [^false].
	string isEmpty ifTrue: [^false].
	string first isUppercase ifFalse: [^false].
	^RBScanner isVariable: string! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
canUnderstand: aSelector in: aClass
	^self new
		type: (Array with: #understandsSelector with: aClass with: aSelector)
		block: [aClass definesMethod: aSelector]
		errorString: aClass printString , ' <1?:does not >understand<1?s:> ' , aSelector printString! !

!RBCondition methodsFor: 'initialize-release' stamp: 'dvf 11/24/2001 13:14'!
type: aSymbol block: aBlock errorString: aString 

	self needsWork.  "replaced value with fixTemps. This should simulate closures well enough, we hope."
	type := aSymbol.
	block := aBlock fixTemps.
	self errorMacro: aString! !

!RBCondition methodsFor: 'accessing' stamp: ''!
errorBlockFor: aBoolean
	^errorBlock! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
hierarchyOf: aClass referencesInstanceVariable: aString 
	^self new 
		type: (Array 
				with: #hierarchyReferencesInstVar
				with: aClass
				with: aString)
		block: 
			[(aClass withAllSubclasses 
				detect: [:each | (each whichSelectorsReferToInstanceVariable: aString) isEmpty not]
				ifNone: [nil]) notNil]
		errorString: aClass printString 
				, ' or subclass <1?:does not >reference<1?s:> instance variable ' , aString! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
hierarchyOf: aClass canUnderstand: aSelector
	^self new
		type: (Array with: #hierarchyUnderstandsSelector with: aClass with: aSelector)
		block: [aClass hierarchyDefinesMethod: aSelector]
		errorString: aClass printString , ' <1?or a subclass:and all subclasses do not> understand<1?s:> ' , aSelector printString! !

!RBCondition methodsFor: 'initialize-release' stamp: ''!
errorBlock: anObject
	errorBlock := anObject! !

!RBCondition methodsFor: 'checking' stamp: ''!
check
	^block value! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
isGlobal: aString in: aRBSmalltalk 
	^self new 
		type: (Array with: #isGlobal with: aString)
		block: [aRBSmalltalk includesGlobal: aString asSymbol]
		errorString: aString , ' is <1?:not >a class or global variable'! !

!RBCondition class methodsFor: 'utilities' stamp: ''!
reservedNames
	^#('self' 'true' 'false' 'nil' 'thisContext' 'super')! !

!RBCondition class methodsFor: 'instance creation' stamp: ''!
definesTemporaryVariable: aString in: aClass 
	| condition |
	condition := self new.
	condition 
		type: (Array with: #definesTempVar with: aClass with: aString)
		block: 
			[| method |
			method := self 
						methodDefiningTemporary: aString
						in: aClass
						ignore: [:class :selector | false].
			method notNil 
				ifTrue: 
					[condition errorMacro: method printString , ' defines variable ' , aString].
			method notNil]
		errorString: aClass printString 
				, ' <1?:does not >define<1?s:> temporary variable ' , aString.
	^condition! !

!RBAbstractCondition methodsFor: 'accessing' stamp: ''!
errorBlock
	^self errorBlockFor: false! !

!RBAbstractCondition methodsFor: 'logical operations' stamp: ''!
not
	^RBNegationCondition on: self! !

!RBAbstractCondition methodsFor: 'checking' stamp: ''!
check
	self subclassResponsibility! !

!RBAbstractCondition methodsFor: 'private' stamp: ''!
errorMacro: aString 
	errorMacro := aString! !

!RBAbstractCondition methodsFor: 'private' stamp: ''!
errorMacro
	^errorMacro isNil
		ifTrue: ['unknown']
		ifFalse: [errorMacro]! !

RBAbstractCondition subclass: #RBNegationCondition
	instanceVariableNames: 'condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Conditions'!

!RBNegationCondition methodsFor: 'private' stamp: ''!
errorStringFor: aBoolean 
	^condition errorStringFor: aBoolean not! !

!RBNegationCondition methodsFor: 'initialize-release' stamp: ''!
condition: aCondition 
	condition := aCondition.
	self errorMacro: condition errorMacro! !

!RBNegationCondition methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream nextPutAll: 'NOT ';
		print: condition! !

!RBNegationCondition methodsFor: 'private' stamp: ''!
errorBlockFor: aBoolean 
	^condition errorBlockFor: aBoolean not! !

!RBNegationCondition class methodsFor: 'instance creation' stamp: ''!
on: aCondition
	^self new condition: aCondition! !

!RBNegationCondition methodsFor: 'checking' stamp: ''!
check
	^condition check not! !

!RBAbstractCondition methodsFor: 'private' stamp: ''!
errorBlockFor: aBoolean 
	^nil! !

Object subclass: #ReceiverAndSelector
	instanceVariableNames: 'receiver selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Refactorings'!

!ReceiverAndSelector methodsFor: 'as yet unclassified' stamp: 'bh 11/5/2000 00:01'!
value

	^receiver perform: selector.! !

!ReceiverAndSelector class methodsFor: 'as yet unclassified' stamp: 'bh 11/4/2000 23:59'!
forReceiver:anObject andSelector:aSymbol

	^self new initializeReceiver:anObject andSelector:aSymbol.! !

!ReceiverAndSelector methodsFor: 'as yet unclassified' stamp: 'bh 11/5/2000 00:01'!
value: firstArgument value: secondArgument

	^receiver perform: selector with: firstArgument with: secondArgument.! !

!ReceiverAndSelector methodsFor: 'as yet unclassified' stamp: 'bh 11/5/2000 00:00'!
initializeReceiver:anObject andSelector:aSymbol

	receiver _ anObject.
	selector _ aSymbol.! !

!ReceiverAndSelector methodsFor: 'as yet unclassified' stamp: 'bh 11/5/2000 00:01'!
value: firstArgument

	^receiver perform: selector with: firstArgument.! !

RectangleMorph subclass: #ChooserMorph
	instanceVariableNames: 'response done cancelBlock list listSelections values isMultipleSelect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-UserInterface'!

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'bh 11/8/2000 16:30'!
cancel

	response _ cancelBlock value.
	done _ true.! !

!ChooserMorph class methodsFor: 'as yet unclassified' stamp: 'dvf 9/8/2001 15:25'!
choose: messageString multipleSelect: multiSelectBoolean fromList: listCollection values: listValues cancel: aBlock 
	^self 
		choose: messageString
		multipleSelect: multiSelectBoolean
		fromList: listCollection
		values: listValues
		cancel: aBlock
		initialSelections: #()! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'bh 11/8/2000 16:30'!
color

	^Color white.! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'dvf 9/8/2001 02:13'!
addButtonRow

	| b spacer buttonRow |
	b _ SimpleButtonMorph new target: self; color: Color veryLightGray.
	spacer _ AlignmentMorph newSpacer: self color.
	buttonRow _ AlignmentMorph newRow
		borderWidth: 1;
		color: self color;
		width: self innerBounds width;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		position: self innerBounds left@self lastSubmorph bottom.
	buttonRow
		addMorphBack: spacer fullCopy;
		addMorphBack: (b fullCopy label: 'OK'; actionSelector: #accept);
		addMorphBack: spacer fullCopy;
		addMorphBack: (b fullCopy label: 'Cancel'; actionSelector: #cancel);
		addMorphBack: spacer fullCopy.
	self addMorphBack: buttonRow.! !

!ChooserMorph class methodsFor: 'as yet unclassified' stamp: 'dvf 9/8/2001 15:24'!
choose: messageString multipleSelect: multiSelectBoolean fromList: listCollection values: listValues cancel: aBlock initialSelections: initialSelectionCollection 
	^self new 
		choose: messageString
		multipleSelect: multiSelectBoolean
		fromList: listCollection
		values: listValues
		cancel: aBlock
		initialSelections: initialSelectionCollection! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'bh 11/8/2000 16:29'!
addLine

	| line |
	line _ RectangleMorph new color: Color black;
		extent: self width@borderWidth;
		position: self left@self lastSubmorph bottom.
	self addMorphBack: line.! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'bh 11/8/2000 16:32'!
listSelectionAt: anInteger put: aBoolean


	^listSelections at: anInteger put: aBoolean.! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'dvf 9/30/2001 01:57'!
choose: messageString multipleSelect: multiSelectBoolean fromList: listCollection values: listValues cancel: aBlock initialSelections: initialSelectionCollection 
	isMultipleSelect := multiSelectBoolean.
	listSelections := listCollection collect: [:each | false].
	values := listValues.
	list := listCollection collect: [:each | each asString].
	cancelBlock := aBlock.
	done := false.
	self openShowing: messageString.
	self setInitialSelections: initialSelectionCollection.
	^self getUserResponse! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'bh 11/8/2000 16:32'!
response: aText
	"Sent when text pane accepts."

	response _ aText asString.
	done _ true.
	^ true
! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'dvf 9/30/2001 01:57'!
openShowing: messageString 
	| listPane |
	World addMorph: self centeredNear: Sensor cursorPoint.
	self removeAllMorphs.
	self extent: 200 @ 70.
	self addLabel: messageString.
	self width: (self width max: self firstSubmorph width + (2 * borderWidth)).
	self addLine.
	listPane := (isMultipleSelect 
				ifTrue: [PluggableListMorphOfMany]
				ifFalse: [PluggableListMorph]) 
					on: self
					list: #list
					selected: #listIndex
					changeSelected: #toggleListIndex:
					menu: #codePaneMenu:shifted:
					keystroke: nil.
	listPane
		color: self color;
		extent: self innerBounds width @ 70;
		position: self innerBounds left @ self lastSubmorph bottom.
	self addMorphBack: listPane.
	self addLine.
	self addButtonRow.
	self 
		height: (self height max: self lastSubmorph bottom - self top + borderWidth)! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'bh 11/8/2000 17:05'!
listIndex
	^ listSelections indexOf: true.! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'dvf 9/8/2001 02:12'!
addLabel: queryString

	| lines queryMorph |
	lines _ queryString asString findTokens: String cr.
	queryMorph _ AlignmentMorph newColumn
		borderWidth: 1;
		color: self color;
		width: self innerBounds width;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		position: self innerBounds topLeft.
	lines do: [:s | queryMorph addMorphBack: (StringMorph contents: s)].
	self addMorph: queryMorph.
! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'bh 11/8/2000 16:31'!
listSelectionAt: anInteger


	^listSelections at: anInteger.! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'bh 11/8/2000 17:13'!
toggleListIndex: newListIndex

	listSelections _ listSelections collect:[:each| false].
	listSelections at: newListIndex put: true.
	self changed: #listIndex.! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'bh 11/8/2000 20:31'!
setInitialSelections: aCollection

	list doWithIndex:
		[:item :index|
		(aCollection includes: item)
			ifTrue:[self listSelectionAt: index put:true.].
		].

	self changed: #listIndex.! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'dvf 9/30/2001 02:08'!
accept
	response := OrderedCollection new.
	listSelections 
		doWithIndex: [:selection :index | selection ifTrue: [response add: (values at: index)]].
	response := response asArray.
	isMultipleSelect 
		ifFalse: [response := response ifEmpty: [nil] ifNotEmpty: [:col | col first]].
	done := true! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'bh 11/8/2000 16:31'!
list
	^ list! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'bh 11/8/2000 16:32'!
response

	^ response
! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'dvf 9/30/2001 01:58'!
getUserResponse
	"Wait for the user to accept or cancel, and answer the result string. Answers the empty string if the user cancels."

	| w |
	w := self world.
	w ifNil: [^response].
	done := false.
	[done] whileFalse: [w doOneCycle].
	self delete.
	w doOneCycle.
	^response! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'bh 11/8/2000 16:30'!
delete

	self breakDependents.
	^ super delete! !

!ChooserMorph methodsFor: 'as yet unclassified' stamp: 'dvf 9/8/2001 15:25'!
choose: messageString multipleSelect: multiSelectBoolean fromList: listCollection values: listValues cancel: aBlock 
	^self 
		choose: messageString
		multipleSelect: multiSelectBoolean
		fromList: listCollection
		values: listValues
		cancel: aBlock
		initialSelections: #()! !

!ChangeSet methodsFor: '*Refactory-RBAddons' stamp: ''!
changed: anAspectSymbol with: aParameter 
	"Allow objects to depend on the ChangeSet class instead of a particular instance 
	of ChangeSet (which may be switched using projects)."

	ChangeSet changed: anAspectSymbol with: aParameter.
	super changed: anAspectSymbol with: aParameter! !

!Exception methodsFor: '*Refactory-RBAddonsMaybeSuperflous' stamp: 'bh 3/12/2000 15:29'!
raiseSignal:aString

	^self signal:aString.! !

!Exception methodsFor: '*Refactory-RBAddonsMaybeSuperflous' stamp: 'bh 3/17/2000 12:56'!
raiseSignal
	^ self signal! !

!Exception methodsFor: '*Refactory-RBAddons' stamp: 'ajh 2/16/2003 17:37'!
searchFrom: aContext
	" Set the context where the handler search will start. "

	signalContext := aContext contextTag! !

!Exception methodsFor: '*Refactory-RBAddonsMaybeSuperflous' stamp: 'bh 3/25/2000 01:17'!
proceed

	^self resume.! !

!Exception class methodsFor: '*Refactory-RBAddonsMaybeSuperflous' stamp: 'bh 3/15/2000 17:08'!
raiseSignal: aString 
	^ self signal: aString! !

!Exception methodsFor: '*Refactory-RBAddonsMaybeSuperflous' stamp: 'bh 3/25/2000 01:18'!
proceedWith: anObject

	^self resume: anObject.! !

Exception subclass: #RefactoringWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Support'!

!RefactoringWarning methodsFor: 'private - actions' stamp: ''!
defaultAction
	"Proceed through warnings"

	^nil! !

!RefactoringWarning methodsFor: 'description' stamp: 'dvf 11/12/2002 00:47'!
isResumable

	^true.! !

TestCase subclass: #SentNotImplementedTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-Tests'!

!SentNotImplementedTestCase methodsFor: 'running' stamp: 'bh 3/13/2000 12:40'!
checkerForSentNotImplemented
	^ CompositeLintRule rules: (OrderedCollection new add: BlockLintRule sentNotImplemented;
		 yourself)! !

!SentNotImplementedTestCase methodsFor: 'running' stamp: 'dvf 9/28/2001 22:40'!
checkerForAllRules
	^ CompositeLintRule rules: (OrderedCollection new addAll: 
	(((BlockLintRule class methodDictionary keys asArray select: [:sel | sel 
	numArgs == 0]) 
	collect: [:sel | BlockLintRule perform: sel]) 
	select: [:each | each isKindOf: LintRule]); 
	 addAll: (((ParseTreeLintRule class methodDictionary keys asArray 
	select: [:sel | sel numArgs == 0]) 
	collect: [:sel | ParseTreeLintRule perform: sel]) 
	select: [:each | each isKindOf: LintRule]); 
	 yourself)! !

!SentNotImplementedTestCase methodsFor: 'running' stamp: 'bh 3/13/2000 12:41'!
classesForRefactoryClasses
	^ Object withAllSubclasses select: [:class | class theNonMetaClass category asString beginsWith: 'Refactory']! !

!SentNotImplementedTestCase methodsFor: 'running' stamp: 'bh 3/13/2000 12:38'!
checkerForBugs
	^CompositeLintRule ruleFor:BasicLintRule protocol:'bugs'.! !

!SentNotImplementedTestCase methodsFor: 'running' stamp: 'bh 3/13/2000 12:41'!
classesForObject
	^ {Object}! !

!SentNotImplementedTestCase methodsFor: 'running' stamp: 'bh 3/13/2000 12:39'!
checkerForSpecific
	^CompositeLintRule rules:(OrderedCollection new       
	        add:BlockLintRule sentNotImplemented;      
	        add:BlockLintRule subclassResponsibilityNotDefined;      
	        add:BlockLintRule usesTrue ;      
	        add:BlockLintRule overridesSpecialMessage;      
	        add:ParseTreeLintRule booleanPrecedence ;      
	        add:BlockLintRule definesEqualNotHash ;      
	        add:BlockLintRule undeclaredReference ;      
	        yourself).! !

!SentNotImplementedTestCase methodsFor: 'running' stamp: 'bh 9/16/2001 22:06'!
classes
	self needsWork. "for complete testing, be sure to uncomment classesForAllClasses line.  This is very slow though."

	^ self classesForAllClasses.
"	^ self classesForObject.
	^ self classesForRefactoryClasses"
! !

!SentNotImplementedTestCase methodsFor: 'running' stamp: 'bh 4/29/2000 17:33'!
test
	| checker context |
	checker _ self checker.
	context _ SmalllintContext newNoCache.
	checker resetResult.
	self classes do: 
		[:aClass | 
		Transcript show: aClass printString;
		 cr.
		context selectedClass: aClass.
		checker checkClass: context.
		aClass methodDictionary keys do: [:each | (ExtraParsingAndFormattingTests methodsNotToTest includes: aClass >> each)
				| (each = #DoIt)
				ifFalse: 
					[context selector: each.
					checker checkMethod: context]]].
	checker isEmpty ifTrue: ['Nobody' inspect].
	Transcript cr;cr;cr.
	(checker rules select: [:rule | rule result isEmpty not])
		do: [:rule | rule result logOrInspect]! !

!SentNotImplementedTestCase methodsFor: 'running' stamp: 'bh 3/13/2000 12:41'!
classesForAllClasses
	^ Object withAllSubclasses
! !

!SentNotImplementedTestCase methodsFor: 'running' stamp: 'bh 3/12/2000 13:35'!
setUp

	! !

!SentNotImplementedTestCase methodsFor: 'running' stamp: 'bh 4/29/2000 21:41'!
checker
	"^ self checkerForAllRules"
	"^ self checkerForSentNotImplemented"

	^ CompositeLintRule rules: (OrderedCollection new add: BlockLintRule utilityMethods;
		 yourself)! !

TestCase subclass: #RefactoringBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

RefactoringBrowserTest subclass: #ExtraParsingAndFormattingTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!ExtraParsingAndFormattingTests class methodsFor: 'testing' stamp: 'dvf 9/16/2003 15:40'!
methodsNotToTest
	^ {"WonderlandCamera >> #destroy:. 
	Parser >> #externalFunctionDeclaration. 
	BalloonEngineSimulation >> #circleSinTable. 
	BalloonEngineSimulation >> #circleCosTable.
	PlayWithMe1 >> #listPane2NewSelection:. 
	PlayWithMe1 >> #listPane1NewSelection:." 
	AssignmentTileMorph >> #arrowAction:. 
	Interval >> #valuesInclude:. 
	Float class >> #initialize }! !

!ExtraParsingAndFormattingTests methodsFor: 'testing' stamp: 'bh 9/16/2001 22:21'!
testParsingAndFormattingEverything

	self needsWork. "commented to speed regression testing.  be sure to uncomment."
	"Smalltalk allBehaviorsDo: 
		[:class | Transcript cr; show:class name.
		class selectors do: 
			[:sel | (self methodsNotToTest includes: class >> sel) ifFalse: 
				[| source tree1 tree2| 
				tree2 _ RBParser parseMethod: (tree1 _ RBParser parseMethod: (class sourceCodeAt: sel)) formattedCode.
				self assert:tree1 = tree2]]]"! !

!ExtraParsingAndFormattingTests methodsFor: 'testing' stamp: 'bh 4/29/2000 17:34'!
methodsNotToTest
	^ self class methodsNotToTest.! !

RefactoringBrowserTest subclass: #SmalllintTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!SmalllintTest methodsFor: 'tests' stamp: ''!
testSizeCheck
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testBooleanPrecedence
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testToDoWithIncrement
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'set up' stamp: ''!
parseTreeRuleFor: aSelector plusSelectors: symbolCollection 
	| returnedEnvironment testSelector rule |
	testSelector := aSelector asString copyFrom: 5 to: aSelector size.
	testSelector at: 1 put: testSelector first asLowercase.
	testSelector := testSelector asSymbol.
	SmalllintChecker 
		runRule: (rule := ParseTreeLintRule perform: testSelector)
		onEnvironment: self refactoryTestAppEnvironment.
	returnedEnvironment := SelectorEnvironment new.
	returnedEnvironment addClass: RefactoryTestDataApp selector: testSelector.
	symbolCollection 
		do: [:each | returnedEnvironment addClass: RefactoryTestDataApp selector: each].
	self checkRule: rule isEqualTo: returnedEnvironment! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testEqualNotUsed
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testIfTrueReturns
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'set up' stamp: ''!
currentSelector
	^thisContext sender selector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testLiteralArrayCharacters
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'set up' stamp: ''!
checkRule: aLintRule isEqualTo: anEnvironment 
	| returnedEnvironment |
	returnedEnvironment := aLintRule result.
	self compare: returnedEnvironment to: anEnvironment.
	self compare: anEnvironment to: returnedEnvironment! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testMinMax
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testSendsDifferentSuper
	self blockRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testDetectContains
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testReturnsIfTrue
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'set up' stamp: ''!
parseTreeRuleFor: aSelector 
	self parseTreeRuleFor: aSelector plusSelectors: #()! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testToDoCollect
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testSearchingLiteral
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'set up' stamp: ''!
refactoryTestAppEnvironment
	| classEnvironment |
	classEnvironment := ClassEnvironment new.
	classEnvironment addClass: RefactoryTestDataApp.
	^classEnvironment! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testPrecedence
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testEqualsTrue
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testExtraBlock
	self parseTreeRuleFor: self currentSelector plusSelectors: #(#testMethod1)! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testEquivalentSuperclassMethods
	| returnedEnvironment rule |
	SmalllintChecker 
		runRule: (rule := BlockLintRule equivalentSuperclassMethods)
		onEnvironment: self refactoryTestAppEnvironment.
	returnedEnvironment := SelectorEnvironment new.
	returnedEnvironment addClass: RefactoryTestDataApp selector: #isLiteral.
	self checkRule: rule isEqualTo: returnedEnvironment! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testAssignmentInIfTrue
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testSuperSends
	| rule returnedEnvironment |
	SmalllintChecker runRule: (rule := BlockLintRule superSends)
		onEnvironment: self refactoryTestAppEnvironment.
	returnedEnvironment := SelectorEnvironment new.
	returnedEnvironment addClass: RefactoryTestDataApp selector: #release.
	self checkRule: rule isEqualTo: returnedEnvironment! !

!SmalllintTest methodsFor: 'set up' stamp: ''!
blockRuleFor: aSelector 
	self blockRuleFor: aSelector plusSelectors: #()! !

!SmalllintTest methodsFor: 'set up' stamp: ''!
compare: subEnvironment to: superEnvironment 
	subEnvironment classesDo: 
			[:each | 
			(subEnvironment selectorsForClass: each) 
				do: [:sel | self assert: (superEnvironment includesSelector: sel in: each)]]! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testCollectSelectNotUsed
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testLongMethods
	self blockRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testTempsReadBeforeWritten
	self blockRuleFor: self currentSelector
		plusSelectors: #(#inlineTemporary #noMoveDefinition #tempsReadBeforeWritten #equalNotUsed #fileBlocks #referencesConditionFor:)! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testEndTrueFalse
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testThreeElementPoint
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testToDo
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testCollectionProtocol
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testAtIfAbsent
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: 'bh 4/8/2000 19:06'!
testFullBlocks
	"skip this test in squeak"

"	self blockRuleFor: self currentSelector
		plusSelectors: #(#caller1 #fullBlocks #detectContains #fileBlocks #moveDefinition #caller #assignmentInBlock #equalNotUsed #stringConcatenation #noMoveDefinition #referencesConditionFor: #returnInEnsure)"! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testYourselfNotUsed
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testTempVarOverridesInstVar
	self blockRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testFileBlocks
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testStringConcatenation
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testReturnInEnsure
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testAssignmentInBlock
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'set up' stamp: ''!
blockRuleFor: aSelector plusSelectors: symbolCollection 
	| rule returnedEnvironment testSelector |
	testSelector := aSelector asString copyFrom: 5 to: aSelector size.
	testSelector at: 1 put: testSelector first asLowercase.
	testSelector := testSelector asSymbol.
	(BlockLintRule class includesSelector: testSelector) ifFalse: [^self].
	SmalllintChecker runRule: (rule := BlockLintRule perform: testSelector)
		onEnvironment: self refactoryTestAppEnvironment.
	returnedEnvironment := SelectorEnvironment new.
	returnedEnvironment addClass: RefactoryTestDataApp selector: testSelector.
	symbolCollection 
		do: [:each | returnedEnvironment addClass: RefactoryTestDataApp selector: each].
	self checkRule: rule isEqualTo: returnedEnvironment! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testModifiesCollection
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testConsistencyCheck
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testGuardingClause
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testUsesAdd
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testRefersToClass
	self blockRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testAsOrderedCollectionNotNeeded
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testCollectionMessagesToExternalObject
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testIfTrueBlocks
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testContains
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testMissingYourself
	self parseTreeRuleFor: self currentSelector plusSelectors: #(#inlineMethod)! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testWhileTrue
	self parseTreeRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testBadMessage
	self blockRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testReturnsBooleanAndOther
	self blockRuleFor: self currentSelector! !

!SmalllintTest methodsFor: 'tests' stamp: ''!
testJustSendsSuper
	self blockRuleFor: self currentSelector! !

!RefactoringBrowserTest methodsFor: 'private' stamp: ''!
objectClassVariable
	^Object classPool keys detect: [:each | true]! !

RefactoringBrowserTest subclass: #ReferenceFinderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!ReferenceFinderTest methodsFor: 'tests' stamp: 'bh 4/29/2000 18:17'!
testPathToInstance
	self needsWork. "slows, then hangs (100% CPU) on or after level 5 - 4551 objects to search.
		is this because Squeak can't handle large collections efficiently?"

"	| path |
	path _ ReferenceFinder findPathToInstanceOf: RefactoringManager.
	self assert: path last class == RefactoringManager.
	self assert: path first == Smalltalk"
! !

!ReferenceFinderTest methodsFor: 'tests' stamp: 'bh 4/29/2000 18:17'!
testFound

	self needsWork. "slows, then hangs (100% CPU) on or after level 5 - 4551 objects to search.
		is this because Squeak can't handle large collections efficiently?"

"	| path |
	path _ ReferenceFinder findPathTo: RefactoringManager instance.
	self assert: path last == RefactoringManager instance.
	self assert: (path at: path size - 1) isVariableBinding.
	self assert: (path at: path size - 1) key == #Instance.
	self assert: path first == Smalltalk"

! !

!ReferenceFinderTest methodsFor: 'tests' stamp: 'bh 4/29/2000 18:16'!
testAllPathsToInstance
	self needsWork. "slows, then hangs (100% CPU) on or after level 5 - 4551 objects to search.
		is this because Squeak can't handle large collections efficiently?"

"	| paths |     
	paths _ ReferenceFinder findAllPathsToInstanceOf: RefactoringManager. 
	    self deny: paths isEmpty.     
	paths do:      
	[:each |      
	self assert: each last class == RefactoringManager.     
	self assert: each first == Smalltalk]"
! !

!ReferenceFinderTest methodsFor: 'tests' stamp: 'bh 4/29/2000 18:16'!
testAllPaths

	self needsWork. "slows, then hangs (100% CPU) on or after level 5 - 4551 objects to search.
		is this because Squeak can't handle large collections efficiently?"

"	| paths |
	paths _ ReferenceFinder findAllPathsTo: RefactoringManager instance.
	self deny: paths isEmpty.
	paths do: 
		[:each | 
		self assert: each last == RefactoringManager instance.
		self assert: each first == Smalltalk]"
! !

!ReferenceFinderTest methodsFor: 'tests' stamp: 'bh 4/29/2000 18:17'!
testNotFound

	self needsWork. "slows, then hangs (100% CPU) on or after level 5 - 4551 objects to search.
		is this because Squeak can't handle large collections efficiently?"

"	| path |
	path _ ReferenceFinder findPathTo: Object new.
	self assert: path isNil"
! !

!RefactoringBrowserTest methodsFor: 'private' stamp: ''!
convertInterval: anInterval for: aString 
	"Convert the interval to ignore differences in end of line conventions."

	^anInterval! !

RefactoringBrowserTest subclass: #RefactoringTest
	instanceVariableNames: 'manager changeSet model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

RefactoringTest subclass: #TemporaryToInstanceVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!TemporaryToInstanceVariableTest methodsFor: 'set up' stamp: ''!
setUp
	super setUp.
	model := Compiler evaluate: (self readFile: 'AbstractVariableTestData.st')! !

!TemporaryToInstanceVariableTest methodsFor: 'tests' stamp: ''!
testTemporaryToInstanceVariable
	| refactoring class |
	refactoring := TemporaryToInstanceVariableRefactoring 
				class: LintRuleTest
				selector: #displayName
				variable: 'nameStream'.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #LintRuleTest.
	self 
		assert: (class parseTreeFor: #displayName) = (RBParser 
						parseMethod: 'displayName
								nameStream := WriteStream on: (String new: 64).
								nameStream
									nextPutAll: self name;
									nextPutAll: '' (''.
								self problemCount printOn: nameStream.
								nameStream nextPut: $).
								^nameStream contents').
	self assert: (class directlyDefinesInstanceVariable: 'nameStream')! !

!TemporaryToInstanceVariableTest methodsFor: 'failure tests' stamp: ''!
testNonExistantName
	self
		shouldFail: (TemporaryToInstanceVariableRefactoring 
					class: BasicLintRuleTest
					selector: #checkClass:
					variable: 'asdf');
		shouldFail: (TemporaryToInstanceVariableRefactoring 
					class: BasicLintRuleTest
					selector: #checkClass1:
					variable: 'aSmalllintContext')! !

!TemporaryToInstanceVariableTest methodsFor: 'failure tests' stamp: ''!
testRedefinedTemporary
	| class |
	class := model classNamed: #Foo.
	class 
		compile: 'someMethod | instVarName1 | instVarName1 := 4. ^instVarName1'
		classified: #(#accessing).
	self shouldFail: (TemporaryToInstanceVariableRefactoring 
				class: class
				selector: #someMethod
				variable: 'instVarName1')! !

RefactoringTest subclass: #InlineTemporaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!InlineTemporaryTest methodsFor: 'tests' stamp: ''!
testInlineTemporaryMutlipleAssignment
	self shouldFail: (InlineTemporaryRefactoring 
				inline: (self convertInterval: (60 to: 83)
						for: (RefactoryTestDataApp sourceCodeAt: #moveDefinition))
				from: #moveDefinition
				in: RefactoryTestDataApp)! !

!InlineTemporaryTest methodsFor: 'tests' stamp: ''!
testInlineTemporaryBadInterval
	self shouldFail: (InlineTemporaryRefactoring 
				inline: (self convertInterval: (29 to: 100)
						for: (RefactoryTestDataApp sourceCodeAt: #moveDefinition))
				from: #moveDefinition
				in: RefactoryTestDataApp)! !

!InlineTemporaryTest methodsFor: 'tests' stamp: ''!
testInlineTemporary
	| refactoring |
	refactoring := InlineTemporaryRefactoring 
				inline: (self convertInterval: (24 to: 72)
						for: (RefactoryTestDataApp sourceCodeAt: #inlineMethod))
				from: #inlineMethod
				in: RefactoryTestDataApp.
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #inlineMethod) = (RBParser 
							parseMethod: 'inlineMethod
										^self
													foo;
													inlineMethod;
													bar')! !

!InlineTemporaryTest methodsFor: 'tests' stamp: ''!
testInlineTemporaryReadBeforeWritten
	self shouldFail: (InlineTemporaryRefactoring 
				inline: (self convertInterval: (48 to: 56)
						for: (RefactoryTestDataApp sourceCodeAt: #inlineTemporary))
				from: #inlineTemporary
				in: RefactoryTestDataApp)! !

!RefactoringTest methodsFor: 'set up' stamp: ''!
setupMethodNameFor: aRefactoring toReturn: aSelector 
	| options |
	options := aRefactoring options copy.
	options at: #methodName
		put: 
			[:ref :aMethodName | 
			aMethodName
				selector: aSelector;
				yourself].
	aRefactoring options: options! !

RefactoringTest subclass: #InlineParameterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!InlineParameterTest methodsFor: 'tests' stamp: ''!
testInlineLiteralArray
	| refactoring class |
	refactoring := InlineParameterRefactoring 
				inlineParameter: 'aSymbol'
				in: RefactoryTestDataApp
				selector: ('inline' , 'ParameterMethod:') asSymbol.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #RefactoryTestDataApp.
	self 
		assert: (class parseTreeFor: #inlineParameterMethod) = (RBParser 
						parseMethod: 'inlineParameterMethod | aSymbol | aSymbol := #(asdf). ^aSymbol isSymbol').
	self 
		assert: (class parseTreeFor: #sendInlineParameterMethod) = (RBParser 
						parseMethod: 'sendInlineParameterMethod ^self inlineParameterMethod').
	self deny: (class 
				directlyDefinesMethod: ('inline' , 'ParameterMethod:') asSymbol)! !

!InlineParameterTest methodsFor: 'failure tests' stamp: ''!
testInlineBlockFailure
	self shouldFail: (InlineParameterRefactoring 
				inlineParameter: 'aBlock'
				in: RefactoryTestDataApp
				selector: ('inline' , 'Foo:') asSymbol)! !

RefactoringTest subclass: #PushUpMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!PushUpMethodTest methodsFor: 'failure tests' stamp: ''!
testPushUpReferencesInstVar
	self shouldFail: (PushUpMethodRefactoring pushUp: #(#checkClass:)
				from: BasicLintRuleTest)! !

!PushUpMethodTest methodsFor: 'failure tests' stamp: 'bh 11/8/2000 14:11'!
testPushUpWithSuperSendThatCannotBeCopiedDown
	| class |
	model 
		defineClass: 'Object subclass: #SomeClass instanceVariableNames: '''' classVariableNames: ''Foo'' poolDictionaries: '''' category: #''Refactory-Test data'''.
	(model classNamed: #Object) compile: 'foo ^3' classified: #(#accessing).
	model 
		defineClass: 'SomeClass subclass: #Subclass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	(model classNamed: #Subclass) compile: 'foo ^super foo'
		classified: #(#accessing).
	model 
		defineClass: 'Subclass subclass: #Foo1 instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	model 
		defineClass: 'Subclass subclass: #Foo2 instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	(class := model classNamed: #Foo2) compile: 'foo ^1'
		classified: #(#accessing).
	self shouldFail: (PushUpMethodRefactoring 
				model: model
				pushUp: #(#foo)
				from: class)! !

!PushUpMethodTest methodsFor: 'failure tests' stamp: 'bh 11/8/2000 14:11'!
testPushUpWithMethodThatCannotBePushedDown
	model 
		defineClass: 'Object subclass: #SomeClass instanceVariableNames: '''' classVariableNames: ''Foo'' poolDictionaries: '''' category: #''Refactory-Test data'''.
	(model classNamed: #SomeClass) compile: 'yourself ^54'
		classified: #(#accessing).
	self shouldFail: (PushUpMethodRefactoring 
				model: model
				pushUp: #(#yourself)
				from: (model classNamed: #SomeClass))! !

!PushUpMethodTest methodsFor: 'failure tests' stamp: 'bh 11/8/2000 14:11'!
testPushUpWithInvalidSuperSend
	| class |
	model 
		defineClass: 'Object subclass: #SomeClass instanceVariableNames: '''' classVariableNames: ''Foo'' poolDictionaries: '''' category: #''Refactory-Test data'''.
	model 
		defineClass: 'SomeClass subclass: #Subclass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	model 
		defineClass: 'Subclass subclass: #Foo1 instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	model 
		defineClass: 'Subclass subclass: #Foo2 instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	(model classNamed: #Foo2) compile: 'yourself ^super yourself + 1'
		classified: #(#accessing).
	class := model classNamed: #Foo1.
	class compile: 'yourself ^1' classified: #(#accessing).
	self shouldFail: (PushUpMethodRefactoring 
				model: model
				pushUp: #(#yourself)
				from: class)! !

!PushUpMethodTest methodsFor: 'tests' stamp: 'bh 11/8/2000 14:11'!
testPushUpAndCopyDown
	| class |
	model 
		defineClass: 'Object subclass: #SomeClass instanceVariableNames: '''' classVariableNames: ''Foo'' poolDictionaries: '''' category: #''Refactory-Test data'''.
	model 
		defineClass: 'SomeClass subclass: #Subclass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	model 
		defineClass: 'Subclass subclass: #Foo1 instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	model 
		defineClass: 'Subclass subclass: #Foo2 instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	class := model classNamed: #Foo1.
	class compile: 'yourself ^1' classified: #(#accessing).
	self executeRefactoring: (PushUpMethodRefactoring 
				model: model
				pushUp: #(#yourself)
				from: class).
	self assert: (class superclass parseTreeFor: #yourself) 
				= (RBParser parseMethod: 'yourself ^1').
	self deny: (class directlyDefinesMethod: #yourself).
	class := model classNamed: #Foo2.
	self assert: (class directlyDefinesMethod: #yourself).
	self assert: (class parseTreeFor: #yourself) 
				= ((model classNamed: #Object) parseTreeFor: #yourself)! !

!PushUpMethodTest methodsFor: 'tests' stamp: ''!
testPushUpMethodWithCopyOverriddenMethodsDown
	| refactoring |
	self proceedThroughWarning: 
			[refactoring := PushUpMethodRefactoring pushUp: #(#isComposite)
						from: CompositeLintRuleTest.
			self executeRefactoring: refactoring].
	self 
		assert: ((refactoring model classNamed: #BasicLintRuleTest) 
				parseTreeFor: #isComposite) = (RBParser parseMethod: 'isComposite ^false').
	self 
		assert: ((refactoring model classNamed: ('Foo' , 'LintRuleTest') asSymbol) 
				parseTreeFor: #isComposite) = (RBParser parseMethod: 'isComposite ^false').
	self 
		assert: ((refactoring model classNamed: #LintRuleTest) 
				parseTreeFor: #isComposite) = (RBParser parseMethod: 'isComposite ^true').
	self deny: ((refactoring model classNamed: #CompositeLintRuleTest) 
				directlyDefinesMethod: #isComposite)! !

!PushUpMethodTest methodsFor: 'failure tests' stamp: ''!
testPushUpClassMethod
	| class |
	class := model classNamed: #Object.
	class addClassVariable: #Foo.
	class metaclass compile: 'foo ^Foo' classified: #(#accessing).
	self shouldFail: (PushUpMethodRefactoring 
				model: model
				pushUp: #(#foo)
				from: class metaclass)! !

RefactoringTest subclass: #PullUpClassVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!PullUpClassVariableTest methodsFor: 'tests' stamp: ''!
testPullUpClassVariable
	| refactoring |
	refactoring := PullUpClassVariableRefactoring variable: #RecursiveSelfRule
				class: LintRuleTest.
	self executeRefactoring: refactoring.
	self assert: ((refactoring model classNamed: #LintRuleTest) 
				directlyDefinesClassVariable: #RecursiveSelfRule).
	self deny: ((refactoring model classNamed: #TransformationRuleTest) 
				directlyDefinesClassVariable: #RecursiveSelfRule)! !

!PullUpClassVariableTest methodsFor: 'failure tests' stamp: ''!
testMetaClassFailure
	self 
		shouldFail: (PullUpClassVariableRefactoring variable: #RecursiveSelfRule
				class: LintRuleTest class)! !

!PullUpClassVariableTest methodsFor: 'failure tests' stamp: ''!
testNonExistantName
	self shouldFail: (PullUpClassVariableRefactoring variable: #Foo
				class: LintRuleTest)! !

RefactoringTest subclass: #RenameClassVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!RenameClassVariableTest methodsFor: 'failure tests' stamp: ''!
testNonExistantName
	self shouldFail: (RenameClassVariableRefactoring 
				rename: #foo
				to: #newFoo
				in: BasicLintRuleTest)! !

!RenameClassVariableTest methodsFor: 'failure tests' stamp: ''!
testAlreadyExistingName
	self shouldFail: (RenameClassVariableRefactoring 
				rename: #RecursiveSelfRule
				to: self objectClassVariable
				in: TransformationRuleTest)! !

!RenameClassVariableTest methodsFor: 'failure tests' stamp: ''!
testMetaClassFailure
	self shouldFail: (RenameClassVariableRefactoring 
				rename: #RecursiveSelfRule
				to: #Foo
				in: TransformationRuleTest class)! !

!RenameClassVariableTest methodsFor: 'tests' stamp: ''!
testRenameClassVar
	| refactoring class |
	refactoring := RenameClassVariableRefactoring 
				rename: #RecursiveSelfRule
				to: #RSR
				in: TransformationRuleTest.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #TransformationRuleTest.
	self assert: (class directlyDefinesClassVariable: #RSR).
	self deny: (class directlyDefinesClassVariable: #RecursiveSelfRule).
	self 
		assert: (class metaclass parseTreeFor: #initializeAfterLoad1) = (RBParser 
						parseMethod: 'initializeAfterLoad1
								RSR := ParseTreeSearcher new.
								RSR
									addMethodSearches: #(''`@methodName: `@args | `@temps | self `@methodName: `@args'' ''`@methodName: `@args | `@temps | ^self `@methodName: `@args'')
											-> [:aNode :answer | true]').
	self assert: (class metaclass parseTreeFor: #nuke) 
				= (RBParser parseMethod: 'nuke
								RSR := nil').
	self 
		assert: (class parseTreeFor: #checkMethod:) = (RBParser 
						parseMethod: 'checkMethod: aSmalllintContext 
								class := aSmalllintContext selectedClass.
								(rewriteRule executeTree: aSmalllintContext parseTree) ifTrue: 
										[(RSR executeTree: rewriteRule tree initialAnswer: false)
											ifFalse: 
												[builder compile: rewriteRule tree printString
													in: class
													classified: aSmalllintContext protocols]]')! !

!RefactoringTest methodsFor: 'set up' stamp: ''!
tearDown
	super tearDown.
	RefactoringManager instance release.
	(RefactoringManager classPool associationAt: #Instance
		ifAbsent: [RefactoringManager classPool associationAt: 'Instance']) 
			value: manager! !

RefactoringTest subclass: #RenameClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!RenameClassTest methodsFor: 'failure tests' stamp: ''!
testBadName
	self
		shouldFail: (RenameClassRefactoring rename: LintRuleTest
					to: self objectClassVariable);
		shouldFail: (RenameClassRefactoring rename: LintRuleTest to: #'Ob ject')! !

!RenameClassTest methodsFor: 'failure tests' stamp: ''!
testExistingName
	self shouldFail: (RenameClassRefactoring rename: self class to: #Object)! !

!RenameClassTest methodsFor: 'tests' stamp: ''!
testRenameClass
	| refactoring class |
	refactoring := RenameClassRefactoring 
				rename: (Smalltalk at: ('Class' , 'ToRename') asSymbol)
				to: 'New' , 'ClassName' asSymbol.
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model classNamed: ('New' , 'ClassName') asSymbol) 
				parseTreeFor: #method1) = (RBParser parseMethod: 'method1
	^self method2').
	self deny: (refactoring model 
				includesClassNamed: ('Class' , 'ToRename') asSymbol).
	class := refactoring model 
				classNamed: ('Subclass' , 'OfClassToRename') asSymbol.
	self assert: class superclass 
				= (refactoring model classNamed: ('New' , 'ClassName') asSymbol).
	self assert: (class parseTreeFor: #symbolReference) 
				= (RBParser parseMethod: 'symbolReference
								^#NewClassName').
	self assert: (class parseTreeFor: #reference) 
				= (RBParser parseMethod: 'reference
								^NewClassName new')! !

!RenameClassTest methodsFor: 'failure tests' stamp: ''!
testMetaClassFailure
	self 
		shouldFail: (RenameClassRefactoring rename: self class class to: #Foo)! !

!RenameClassTest methodsFor: 'tests' stamp: 'bh 11/8/2000 14:13'!
testModelRenameClass
	| refactoring class |
	model 
		defineClass: 'Object subclass: #Foo instanceVariableNames: ''a'' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	class := model classNamed: #Foo.
	class
		compile: 'foo	^Object' classified: #(#accessing);
		compile: 'objectName ^#(Object)' classified: #(#accessing).
	refactoring := RenameClassRefactoring 
				model: model
				rename: Object
				to: #Thing.
	self executeRefactoring: refactoring.
	self assert: (model includesClassNamed: #Thing).
	self deny: (model includesClassNamed: #Object).
	self 
		assert: (class parseTreeFor: #foo) = (RBParser parseMethod: 'foo ^Thing').
	self assert: (class parseTreeFor: #objectName) 
				= (RBParser parseMethod: 'objectName ^#(Thing)').
	self assert: class superclass name = #Thing! !

!RefactoringTest methodsFor: 'tests' stamp: 'bh 4/2/2000 22:28'!
testConditions
	| condition newCondition |
	condition := RBCondition new 
				type: #false
				block: [false]
				errorString: 'false'.
	condition errorMacro: '<1?true:false>'.
	self deny: condition check.
	self assert: condition errorString = 'false'.
	self assert: condition not check.
	self assert: condition printString = 'false'.
	self assert: condition not printString = 'NOT false'.
	self deny: (condition not & condition) check.
	self 
		assert: (condition not & condition) printString = 'NOT false & false'.
	self assert: (condition & condition) not check.
	self assert: (condition | condition not) check.
	self deny: (newCondition := condition | condition) check.
	self assert: newCondition errorString = 'false AND false'.
	self assert: (condition not | condition not) check.
	self deny: (newCondition := condition & condition) check.
	self assert: newCondition errorString = 'false'.
	self assert: (condition not & condition not) check.
	self assert: (condition & condition) errorString = 'false OR false'! !

!RefactoringTest methodsFor: 'set up' stamp: ''!
setupInlineExpressionFor: aRefactoring toReturn: aBoolean 
	| options |
	options := aRefactoring options copy.
	options at: #inlineExpression put: [:ref :string | aBoolean].
	aRefactoring options: options! !

RefactoringTest subclass: #RemoveParameterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!RemoveParameterTest methodsFor: 'failure tests' stamp: ''!
testPrimitiveMethods
	| refactoring |
	(model classNamed: #Object) 
		compile: 'foo123: a <primitive: 100> ^#() primitiveFailed'
		classified: #(#accessing).
	refactoring := RemoveParameterRefactoring 
				model: model
				removeParameter: 'a'
				in: Object
				selector: #foo123:.
	self shouldFail: refactoring! !

!RemoveParameterTest methodsFor: 'failure tests' stamp: ''!
testNonExistantName
	self
		shouldFail: (RemoveParameterRefactoring 
					removeParameter: 'asdf'
					in: BasicLintRuleTest
					selector: #checkClass:);
		shouldFail: (RemoveParameterRefactoring 
					removeParameter: 'aSmalllintContext'
					in: BasicLintRuleTest
					selector: #checkClass1:)! !

!RemoveParameterTest methodsFor: 'tests' stamp: ''!
testRemoveParameter
	| refactoring class |
	refactoring := RemoveParameterRefactoring 
				removeParameter: 'anArg'
				in: RefactoryTestDataApp
				selector: ('rename' , 'ThisMethod:') asSymbol.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #RefactoryTestDataApp.
	self assert: (class parseTreeFor: #renameThisMethod) 
				= (RBParser parseMethod: 'renameThisMethod
								^self').
	self assert: (class parseTreeFor: #callMethod) 
				= (RBParser parseMethod: 'callMethod
								^(self renameThisMethod)').
	self 
		deny: (class directlyDefinesMethod: ('rename' , 'ThisMethod:') asSymbol)! !

RefactoringTest subclass: #RenameTemporaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!RenameTemporaryTest methodsFor: 'tests' stamp: 'bh 4/29/2000 21:21'!
testRenameTemporary
	| refactoring |
	refactoring := RenameTemporaryRefactoring 
				renameTemporaryFrom: (self convertInterval: (15 to: 19)
						for: (LintRuleTest sourceCodeAt: #openEditor))
				to: 'asdf'
				in: LintRuleTest
				selector: #openEditor.
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model classNamed: #LintRuleTest) 
				parseTreeFor: #openEditor) = (RBParser 
							parseMethod: 'openEditor
								| asdf |
								asdf := self failedRules.
								asdf isEmpty ifTrue: [^self].
								asdf size == 1 ifTrue: [^asdf first viewResults].
								SmalllintResultEditor openOn: self label: name')! !

!RenameTemporaryTest methodsFor: 'failure tests' stamp: ''!
testBadInterval
	self shouldFail: (RenameTemporaryRefactoring 
				renameTemporaryFrom: (self convertInterval: (14 to: 17)
						for: (RefactoryTestDataApp sourceCodeAt: #testMethod))
				to: 'asdf'
				in: RefactoryTestDataApp
				selector: #testMethod)! !

!RenameTemporaryTest methodsFor: 'failure tests' stamp: ''!
testBadName
	self
		shouldFail: (RenameTemporaryRefactoring 
					renameTemporaryFrom: (self convertInterval: (15 to: 19)
							for: (LintRuleTest sourceCodeAt: #openEditor))
					to: 'name'
					in: LintRuleTest
					selector: #openEditor);
		shouldFail: (RenameTemporaryRefactoring 
					renameTemporaryFrom: (self convertInterval: (15 to: 19)
							for: (LintRuleTest sourceCodeAt: #openEditor))
					to: 'rules'
					in: LintRuleTest
					selector: #openEditor);
		shouldFail: (RenameTemporaryRefactoring 
					renameTemporaryFrom: (self convertInterval: (15 to: 19)
							for: (LintRuleTest sourceCodeAt: #openEditor))
					to: 'DependentFields'
					in: LintRuleTest
					selector: #openEditor);
		shouldFail: (RenameTemporaryRefactoring 
					renameTemporaryFrom: (self convertInterval: (15 to: 19)
							for: (LintRuleTest sourceCodeAt: #openEditor))
					to: 'a b'
					in: LintRuleTest
					selector: #openEditor)! !

!RenameTemporaryTest methodsFor: 'failure tests' stamp: ''!
testModelBadName
	| class |
	model := RBNamespace new.
	class := model classNamed: #Object.
	class 
		compile: 'aMethod: temp1 ^[| temp2 | temp2 := [:temp3 | temp3 = 5] value: 5. temp2] value'
		classified: #(#accessing).
	self
		shouldFail: (RenameTemporaryRefactoring 
					renameTemporaryFrom: (20 to: 24)
					to: 'temp3'
					in: class
					selector: #aMethod:);
		shouldFail: (RenameTemporaryRefactoring 
					renameTemporaryFrom: (20 to: 24)
					to: 'temp1'
					in: class
					selector: #aMethod:)! !

RefactoringTest subclass: #AbstractInstanceVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!AbstractInstanceVariableTest methodsFor: 'set up' stamp: ''!
setUp
	super setUp.
	model := Compiler evaluate: (self readFile: 'AbstractVariableTestData.st')! !

!AbstractInstanceVariableTest methodsFor: 'failure tests' stamp: ''!
testNonExistantName
	self shouldFail: (AbstractInstanceVariableRefactoring variable: 'foo'
				class: BasicLintRuleTest)! !

!AbstractInstanceVariableTest methodsFor: 'tests' stamp: ''!
testAbstractWithAssignmentUsed
	| refactoring class |
	class := model classNamed: #Foo.
	refactoring := AbstractInstanceVariableRefactoring 
				model: model
				variable: 'instVarName2'
				class: class.
	self executeRefactoring: refactoring.
	self assert: (class parseTreeFor: #foo) 
				= (RBParser parseMethod: 'foo
						^self instVarName21: 3').
	self 
		assert: (class parseTreeFor: #instVarName2:) = (RBParser 
						parseMethod: 'instVarName2: anObject
						self instVarName21: anObject').
	self 
		assert: (class parseTreeFor: #instVarName21:) = (RBParser 
						parseMethod: 'instVarName21: anObject
						^instVarName2 := anObject').
	self assert: (class parseTreeFor: #instVarName2) 
				= (RBParser parseMethod: 'instVarName2
						^instVarName2').
	self 
		assert: ((model classNamed: #Bar) parseTreeFor: #foo) = (RBParser 
						parseMethod: 'foo
						instVarName1 := instVarName1 + self instVarName2 + ClassVarName1')! !

!AbstractInstanceVariableTest methodsFor: 'tests' stamp: ''!
testAbstractWithDefaultNamesUsed
	| refactoring class |
	class := model classNamed: #Foo.
	refactoring := AbstractInstanceVariableRefactoring 
				model: model
				variable: 'instVarName1'
				class: class.
	self executeRefactoring: refactoring.
	self 
		assert: (class parseTreeFor: #bar) = (RBParser 
						parseMethod: 'bar
						"Add one to instVarName1"

						self instVarName11: self instVarName11 + 1').
	self 
		assert: (class parseTreeFor: #instVarName11:) = (RBParser 
						parseMethod: 'instVarName11: anObject
						instVarName1 := anObject').
	self assert: (class parseTreeFor: #instVarName11) 
				= (RBParser parseMethod: 'instVarName11
						^instVarName1').
	self 
		assert: ((model classNamed: #Bar) parseTreeFor: #foo) = (RBParser 
						parseMethod: 'foo
						self instVarName11: self instVarName11 + instVarName2 + ClassVarName1')! !

!AbstractInstanceVariableTest methodsFor: 'tests' stamp: ''!
testMetaclassInstanceVariables
	| refactoring class |
	class := model metaclassNamed: #Foo.
	class addInstanceVariable: 'foo'.
	class compile: 'zzz ^foo := foo + foo * 2' classified: #(#testing).
	refactoring := AbstractInstanceVariableRefactoring 
				model: model
				variable: 'foo'
				class: class.
	self executeRefactoring: refactoring.
	self assert: (class parseTreeFor: #foo1) 
				= (RBParser parseMethod: 'foo1
						^foo').
	self assert: (class parseTreeFor: #foo:) 
				= (RBParser parseMethod: 'foo: anObject
						^foo := anObject').
	self assert: (class parseTreeFor: #zzz) 
				= (RBParser parseMethod: 'zzz ^self foo: self foo1 + self foo1 * 2')! !

!AbstractInstanceVariableTest methodsFor: 'failure tests' stamp: ''!
testInheritedName
	self shouldFail: (AbstractInstanceVariableRefactoring variable: 'name'
				class: BasicLintRuleTest)! !

!AbstractInstanceVariableTest methodsFor: 'tests' stamp: ''!
testAbstractInstanceVariable
	| refactoring class |
	refactoring := AbstractInstanceVariableRefactoring variable: 'class'
				class: TransformationRuleTest.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #TransformationRuleTest.
	self assert: (class parseTreeFor: #class1) 
				= (RBParser parseMethod: 'class1 ^class').
	self assert: (class parseTreeFor: #class:) 
				= (RBParser parseMethod: 'class: anObject
	class := anObject').
	self 
		assert: (class parseTreeFor: #superSends) = (RBParser 
						parseMethod: 'superSends
	| rule |
	rule := ParseTreeRewriter new.
	rule addSearch: ''super `@message: ``@args'' 
				-> (
					[:aNode | 
					(self class1 withAllSubclasses 
						detect: [:each | each includesSelector: aNode selector]
						ifNone: [nil]) isNil] 
							-> ''self `@message: ``@args'').
	self rewriteUsing: rule').
	self 
		assert: (class parseTreeFor: #checkMethod:) = (RBParser 
						parseMethod: 'checkMethod: aSmalllintContext 
	self class: aSmalllintContext selectedClass.
	(rewriteRule executeTree: aSmalllintContext parseTree) 
		ifTrue: 
			[(RecursiveSelfRule executeTree: rewriteRule tree initialAnswer: false) 
				ifFalse: 
					[builder 
						compile: rewriteRule tree printString
						in: self class1
						classified: aSmalllintContext protocols]]')! !

RefactoringTest subclass: #AbstractClassVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!AbstractClassVariableTest methodsFor: 'tests' stamp: ''!
testAbstractClassVariable
	| refactoring meta class |
	refactoring := AbstractClassVariableRefactoring 
				variable: 'RecursiveSelfRule'
				class: TransformationRuleTest.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #TransformationRuleTest.
	meta := class metaclass.
	self assert: (meta parseTreeFor: #recursiveSelfRule) 
				= (RBParser parseMethod: 'recursiveSelfRule ^RecursiveSelfRule').
	self 
		assert: (meta parseTreeFor: #recursiveSelfRule:) = (RBParser 
						parseMethod: 'recursiveSelfRule: anObject RecursiveSelfRule := anObject').
	self assert: (meta parseTreeFor: #nuke) 
				= (RBParser parseMethod: 'nuke
							self recursiveSelfRule: nil').
	self 
		assert: (meta parseTreeFor: #initializeAfterLoad1) = (RBParser 
						parseMethod: 'initializeAfterLoad1
							self recursiveSelfRule: ParseTreeSearcher new.
							self recursiveSelfRule
								addMethodSearches: #(''`@methodName: `@args | `@temps | self `@methodName: `@args'' ''`@methodName: `@args | `@temps | ^self `@methodName: `@args'')
										-> [:aNode :answer | true]').
	self 
		assert: (class parseTreeFor: #checkMethod:) = (RBParser 
						parseMethod: 'checkMethod: aSmalllintContext 
							class := aSmalllintContext selectedClass.
							(rewriteRule executeTree: aSmalllintContext parseTree) ifTrue: 
									[(self class recursiveSelfRule executeTree: rewriteRule tree initialAnswer: false)
										ifFalse: 
											[builder compile: rewriteRule tree printString
												in: class
												classified: aSmalllintContext protocols]]')! !

!AbstractClassVariableTest methodsFor: 'failure tests' stamp: ''!
testNonExistantName
	self shouldFail: (AbstractClassVariableRefactoring variable: #Foo
				class: BasicLintRuleTest)! !

!AbstractClassVariableTest methodsFor: 'failure tests' stamp: ''!
testMetaClassFailure
	self 
		shouldFail: (AbstractClassVariableRefactoring variable: #RecursiveSelfRule
				class: TransformationRuleTest class)! !

!AbstractClassVariableTest methodsFor: 'tests' stamp: ''!
testModelAbstractClassVariable
	| refactoring meta class |
	class := model classNamed: #Foo.
	meta := class metaclass.
	refactoring := AbstractClassVariableRefactoring 
				model: model
				variable: 'ClassVarName1'
				class: class.
	self executeRefactoring: refactoring.
	self assert: (meta parseTreeFor: #classVarName1) 
				= (RBParser parseMethod: 'classVarName1 ^ClassVarName1').
	self 
		assert: (meta parseTreeFor: #classVarName1:) = (RBParser 
						parseMethod: 'classVarName1: anObject ^ClassVarName1 := anObject').
	self 
		assert: (meta parseTreeFor: #foo) = (RBParser 
						parseMethod: 'foo
					^self classVarName1: self classVarName1 * self classVarName1 * self classVarName1').
	self assert: (class parseTreeFor: #classVarName1) 
				= (RBParser parseMethod: 'classVarName1
							^self class classVarName1').
	self 
		assert: (class parseTreeFor: #classVarName1:) = (RBParser 
						parseMethod: 'classVarName1: anObject
							^self class classVarName1: anObject').
	self 
		assert: (class parseTreeFor: #asdf) = (RBParser 
						parseMethod: 'asdf
						^self classVarName1: (self class classVarName1: self class classVarName1 + 1)').
	self 
		assert: ((model classNamed: #Bar) parseTreeFor: #foo) = (RBParser 
						parseMethod: 'foo
					instVarName1 := instVarName1 + instVarName2 + self class classVarName1').
	self 
		assert: ((model classNamed: #Bar) parseTreeFor: #foo) = (RBParser 
						parseMethod: 'foo
						instVarName1 := instVarName1 + instVarName2 + self class classVarName1')! !

!AbstractClassVariableTest methodsFor: 'tests' stamp: ''!
testModelAbstractClassVariableOverridenMethodsInSubclass
	| refactoring meta class |
	class := model classNamed: #Foo.
	meta := class metaclass.
	refactoring := AbstractClassVariableRefactoring 
				model: model
				variable: 'ClassVarName2'
				class: class.
	self executeRefactoring: refactoring.
	self assert: (meta parseTreeFor: #classVarName21) 
				= (RBParser parseMethod: 'classVarName21 ^ClassVarName2').
	self 
		assert: (meta parseTreeFor: #classVarName21:) = (RBParser 
						parseMethod: 'classVarName21: anObject ClassVarName2 := anObject')! !

!AbstractClassVariableTest methodsFor: 'failure tests' stamp: ''!
testInheritedName
	self 
		shouldFail: (AbstractClassVariableRefactoring variable: #DependentsFields
				class: BasicLintRuleTest)! !

!AbstractClassVariableTest methodsFor: 'set up' stamp: ''!
setUp
	super setUp.
	model := Compiler evaluate: (self readFile: 'AbstractVariableTestData.st')! !

!RefactoringTest methodsFor: 'private' stamp: ''!
shouldWarn: aRefactoring 
	self should: [self executeRefactoring: aRefactoring]
		raise: RefactoringWarning! !

RefactoringTest subclass: #InlineMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!InlineMethodTest methodsFor: 'failure tests' stamp: ''!
testNonExistantSelector
	self shouldFail: (InlineMethodRefactoring 
				inline: (14 to: 17)
				inMethod: #checkClass1:
				forClass: RefactoryTestDataApp)! !

!InlineMethodTest methodsFor: 'failure tests' stamp: ''!
testReturn
	self shouldFail: (InlineMethodRefactoring 
				inline: (self convertInterval: (418 to: 485)
						for: (BasicLintRuleTest class sourceCodeAt: #utilityMethods))
				inMethod: #utilityMethods
				forClass: BasicLintRuleTest class)! !

!InlineMethodTest methodsFor: 'tests' stamp: ''!
testInlineMethod4
	| refactoring |
	refactoring := InlineMethodRefactoring 
				inline: (self convertInterval: (31 to: 112)
						for: (RefactoryTestDataApp sourceCodeAt: #inlineJunk))
				inMethod: #inlineJunk
				forClass: RefactoryTestDataApp.
	self setupInlineExpressionFor: refactoring toReturn: false.
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #inlineJunk) = (RBParser 
							parseMethod: 'inlineJunk
										| asdf bar1 baz1 asdf1 |
										bar1 := 
												[:each | 
												| temp |
												temp := each.
												temp , temp] value: self.
										baz1 := bar1 + bar1.
										asdf1 := baz1 + bar1.
										asdf := asdf1.
										^asdf foo: 
												[:bar | 
												| baz |
												baz := bar.
												baz * baz]')! !

!InlineMethodTest methodsFor: 'failure tests' stamp: ''!
testPrimitive
	self shouldFail: (InlineMethodRefactoring 
				inline: (self convertInterval: (14 to: 23)
						for: (RefactoryTestDataApp sourceCodeAt: #testMethod))
				inMethod: #testMethod
				forClass: RefactoryTestDataApp)! !

!InlineMethodTest methodsFor: 'failure tests' stamp: ''!
testOverriden
	self shouldWarn: (InlineMethodRefactoring 
				inline: (self convertInterval: (15 to: 26)
						for: (LintRuleTest sourceCodeAt: #failedRules))
				inMethod: #failedRules
				forClass: LintRuleTest)! !

!InlineMethodTest methodsFor: 'tests' stamp: ''!
testInlineMethod1
	| refactoring |
	refactoring := InlineMethodRefactoring 
				inline: (self convertInterval: (39 to: 84)
						for: (RefactoryTestDataApp sourceCodeAt: #caller))
				inMethod: #caller
				forClass: RefactoryTestDataApp.
	self setupInlineExpressionFor: refactoring toReturn: false.
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #caller) = (RBParser 
							parseMethod: 'caller 
									| anObject anObject1 | 
									anObject := 5.
									anObject1 := anObject + 1.
									Transcript
										show: anObject1 printString;
										cr.
									^anObject')! !

!InlineMethodTest methodsFor: 'tests' stamp: ''!
testInlineMethodForSuperSend
	| refactoring |
	model := Compiler evaluate: (self readFile: 'InlineMethodTest.st').
	(model classNamed: #RenameVariableChange) removeMethod: #executeNotifying:.
	refactoring := InlineMethodRefactoring 
				model: model
				inline: (self convertInterval: (102 to: 131)
						for: ((model classNamed: #RenameInstanceVariableChange) 
								sourceCodeFor: #executeNotifying:))
				inMethod: #executeNotifying:
				forClass: (model classNamed: #RenameInstanceVariableChange).
	self executeRefactoring: refactoring.
	self 
		assert: ((model classNamed: #RenameInstanceVariableChange) 
				parseTreeFor: #executeNotifying:) = (RBParser 
							parseMethod: 'executeNotifying: aBlock 
									| undo undos undo1 |
									self addNewVariable.
									self copyOldValuesToNewVariable.
									undos := changes collect: [:each | each executeNotifying: aBlock].
									undo1 := self copy.
									undo1 changes: undos reverse.
									undo := undo1.
									self removeOldVariable.
									^undo')! !

!InlineMethodTest methodsFor: 'tests' stamp: ''!
testInlineMethod5
	| refactoring |
	refactoring := InlineMethodRefactoring 
				inline: (self convertInterval: (53 to: 64)
						for: (RefactoryTestDataApp sourceCodeAt: #inlineLast))
				inMethod: #inlineLast
				forClass: RefactoryTestDataApp.
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #inlineLast) = (RBParser 
							parseMethod: 'inlineLast
									5 = 3 ifTrue: [^self caller] ifFalse: [^	(1 to: 10) inject: 1 into: [:sum :each | sum * (self foo: each)]]')! !

!InlineMethodTest methodsFor: 'tests' stamp: ''!
testModelInlineRecursiveMethod
	| refactoring class |
	class := model classNamed: #Object.
	class compile: 'foo self bar. self foo. self bar' classified: #(#accessing).
	refactoring := InlineMethodRefactoring 
				model: model
				inline: (15 to: 23)
				inMethod: #foo
				forClass: class.
	self executeRefactoring: refactoring.
	self 
		assert: (class parseTreeFor: #foo) = (RBParser 
						parseMethod: 'foo self bar. self bar. self foo. self bar. self bar')! !

!InlineMethodTest methodsFor: 'tests' stamp: ''!
testInlineMethod
	| refactoring |
	refactoring := InlineMethodRefactoring 
				inline: (self convertInterval: (455 to: 504)
						for: (BasicLintRuleTest class 
								sourceCodeAt: #sentNotImplementedInApplication))
				inMethod: #sentNotImplementedInApplication
				forClass: BasicLintRuleTest class.
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model metaclassNamed: #BasicLintRuleTest) 
				parseTreeFor: #sentNotImplementedInApplication) = (RBParser 
							parseMethod: 'sentNotImplementedInApplication
									| detector |
									detector := self new.
									detector name: ''Messages sent but not implemented in application''.
									detector methodBlock: 
											[:context :result | 
											| message class block |
											message := context messages 
														detect: [:each | (context isItem: each in: context application) not]
														ifNone: [nil].
											class := context selectedClass.
											block := 
													[:each | 
													| app methodApp root |
													app := context application.
													((class canUnderstand: each) 
														ifTrue: 
															[root := app rootApplication.
															methodApp := ((class whichClassIncludesSelector: each) 
																		compiledMethodAt: each) application 
																		rootApplication.
															methodApp == root or: [root isBasedOn: methodApp]]
														ifFalse: [false]) not].
											message isNil 
												ifTrue: [message := context selfMessages detect: block ifNone: [nil]].
											message isNil 
												ifTrue: 
													[class := class superclass.
													class isNil 
														ifTrue: 
															[context superMessages isEmpty 
																ifFalse: [message := context superMessages asArray first]]
														ifFalse: [message := context superMessages detect: block ifNone: [nil]]].
											message notNil 
												ifTrue: 
													[result addSearchString: message.
													result addClass: context selectedClass selector: context selector]].
									^detector')! !

!InlineMethodTest methodsFor: 'tests' stamp: ''!
testInlineMethod3
	| refactoring |
	refactoring := InlineMethodRefactoring 
				inline: (self convertInterval: (58 to: 73)
						for: (RefactoryTestDataApp sourceCodeAt: #caller2))
				inMethod: #caller2
				forClass: RefactoryTestDataApp.
	self setupInlineExpressionFor: refactoring toReturn: false.
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #caller2) = (RBParser 
							parseMethod: 'caller2
								^(1 to: 10) inject: 1 into: [:sum :each | sum * ((1 to: 10) inject: each into: [:sum1 :each1 | sum1 + each1])]	')! !

!InlineMethodTest methodsFor: 'tests' stamp: ''!
testInlineMethod2
	| refactoring |
	refactoring := InlineMethodRefactoring 
				inline: (self convertInterval: (40 to: 120)
						for: (RefactoryTestDataApp sourceCodeAt: #caller1))
				inMethod: #caller1
				forClass: RefactoryTestDataApp.
	self setupInlineExpressionFor: refactoring toReturn: false.
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #caller1) = (RBParser 
							parseMethod: 'caller1 
								| anObject each1 anObject1 | 
								anObject := 5.
								anObject1 := anObject + 1.
								each1 := anObject1 printString.
								Transcript
									show: each1;
									cr.
								[:each | each printString. ^anObject] value: each1')! !

!InlineMethodTest methodsFor: 'tests' stamp: ''!
testInlineRecursiveCascadedMethod
	| refactoring |
	refactoring := InlineMethodRefactoring 
				inline: (self convertInterval: (33 to: 62)
						for: (RefactoryTestDataApp sourceCodeAt: #inlineMethod))
				inMethod: #inlineMethod
				forClass: RefactoryTestDataApp.
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #inlineMethod) = (RBParser 
							parseMethod: 'inlineMethod
									| temp temp1 |
									self foo.
									temp1 := self foo; inlineMethod; bar.
									temp := self bar.
									^temp')! !

!InlineMethodTest methodsFor: 'failure tests' stamp: ''!
testBadInterval
	self
		shouldFail: (InlineMethodRefactoring 
					inline: (self convertInterval: (13 to: 23)
							for: (RefactoryTestDataApp sourceCodeAt: #testMethod))
					inMethod: #testMethod
					forClass: RefactoryTestDataApp);
		shouldFail: (InlineMethodRefactoring 
					inline: (self convertInterval: (14 to: 17)
							for: (RefactoryTestDataApp sourceCodeAt: #testMethod))
					inMethod: #testMethod
					forClass: RefactoryTestDataApp);
		shouldFail: (InlineMethodRefactoring 
					inline: (self convertInterval: (24 to: 30)
							for: (RefactoryTestDataApp sourceCodeAt: #testMethod))
					inMethod: #testMethod
					forClass: RefactoryTestDataApp);
		shouldFail: (InlineMethodRefactoring 
					inline: (self convertInterval: (1 to: 30)
							for: (RefactoryTestDataApp sourceCodeAt: #testMethod))
					inMethod: #testMethod
					forClass: RefactoryTestDataApp)! !

!InlineMethodTest methodsFor: 'failure tests' stamp: ''!
testInlineMethodForSuperSendThatAlsoSendsSuper
	| refactoring |
	model := Compiler evaluate: (self readFile: 'InlineMethodTest.st').
	refactoring := InlineMethodRefactoring 
				inline: (102 to: 131)
				inMethod: #executeNotifying:
				forClass: (model classNamed: #RenameInstanceVariableChange).
	self shouldFail: refactoring! !

!RefactoringTest methodsFor: 'set up' stamp: 'bh 3/14/2000 13:09'!
readFile: aString 
	"^ aString asFilename contentsOfEntireFile"
	| file |
	file _ FileStream readOnlyFileNamed: aString.
	^ [file contentsOfEntireFile]
		ensure: [file close]! !

RefactoringTest subclass: #PushDownMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!PushDownMethodTest methodsFor: 'failure tests' stamp: ''!
testPushDownMethodOnNonAbstractClass
	| refactoring |
	refactoring := PushDownMethodRefactoring pushDown: #(#yourself)
				from: Object.
	self shouldFail: refactoring! !

!PushDownMethodTest methodsFor: 'tests' stamp: ''!
testPushDownMethod
	| refactoring class |
	refactoring := PushDownMethodRefactoring pushDown: #(#name:)
				from: LintRuleTest.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #LintRuleTest.
	self deny: (class directlyDefinesMethod: #name:).
	class subclasses do: 
			[:each | 
			self assert: (each parseTreeFor: #name:) 
						= (RBParser parseMethod: 'name: aString name := aString')]! !

!PushDownMethodTest methodsFor: 'failure tests' stamp: ''!
testPushDownNonExistantMenu
	| refactoring |
	refactoring := PushDownMethodRefactoring 
				pushDown: #(#someMethodThatDoesNotExist)
				from: LintRuleTest.
	self shouldFail: refactoring! !

!PushDownMethodTest methodsFor: 'tests' stamp: 'bh 3/17/2000 13:33'!
testPushDownMethodThatReferencesPoolDictionary
	| refactoring class parseTree |
	parseTree _ LintRuleTest parseTreeFor: #junk.
	self
		proceedThroughWarning: 
			[refactoring _ PushDownMethodRefactoring pushDown: #(junk ) from: LintRuleTest.
			self executeRefactoring: refactoring].
	class _ refactoring model classNamed: #LintRuleTest.
	self deny: (class directlyDefinesMethod: #junk).
	class subclasses do: 
		[:each | 
		self assert: (each parseTreeFor: #junk)
				= parseTree.
		self assert: (each directlyDefinesPoolDictionary: 'TextConstants' asSymbol)]! !

RefactoringTest subclass: #PushUpInstanceVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!PushUpInstanceVariableTest methodsFor: 'tests' stamp: ''!
testPullUpInstVar
	| refactoring |
	self proceedThroughWarning: 
			[refactoring := PullUpInstanceVariableRefactoring variable: 'result'
						class: LintRuleTest.
			self executeRefactoring: refactoring].
	self assert: ((refactoring model classNamed: #LintRuleTest) 
				directlyDefinesInstanceVariable: 'result').
	self deny: ((refactoring model classNamed: #BasicLintRuleTest) 
				directlyDefinesInstanceVariable: 'result')! !

!PushUpInstanceVariableTest methodsFor: 'failure tests' stamp: ''!
testPullUpVariableNotDefined
	self shouldFail: (PullUpInstanceVariableRefactoring 
				variable: 'notDefinedVariable'
				class: LintRuleTest)! !

!RefactoringTest methodsFor: 'set up' stamp: ''!
setUp
	| assoc |
	super setUp.
	assoc := RefactoringManager classPool associationAt: #Instance
				ifAbsent: [RefactoringManager classPool associationAt: 'Instance'].
	manager := assoc value.
	assoc value: nil.
	model := RBNamespace new! !

!RefactoringTest methodsFor: 'set up' stamp: ''!
setupImplementorToInlineFor: aRefactoring toReturn: anObject 
	| options |
	options := aRefactoring options copy.
	options at: #implementorToInline put: [:ref :imps | anObject].
	aRefactoring options: options! !

RefactoringTest subclass: #ExtractMethodToComponentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!ExtractMethodToComponentTest methodsFor: 'tests' stamp: ''!
testMoveWithoutSelfReference
	| refactoring class selectorsSize |
	refactoring := ExtractMethodToComponentRefactoring 
				extract: (self convertInterval: (118 to: 285)
						for: (RBReadBeforeWrittenTester sourceCodeAt: #copyDictionary:))
				from: #copyDictionary:
				in: RBReadBeforeWrittenTester.
	self setupMethodNameFor: refactoring toReturn: #copyWithAssociations.
	self setupVariableToMoveToFor: refactoring toReturn: 'aDictionary'.
	self setupVariableTypesFor: refactoring
		toReturn: (Array with: (refactoring model classNamed: #Dictionary)).
	class := refactoring model classNamed: #RBReadBeforeWrittenTester.
	selectorsSize := class selectors size.
	self executeRefactoring: refactoring.
	self 
		assert: (class parseTreeFor: #copyDictionary:) = (RBParser 
						parseMethod: 'copyDictionary: aDictionary ^aDictionary copyWithAssociations').
	self 
		assert: ((refactoring model classNamed: #Dictionary) 
				parseTreeFor: #copyWithAssociations) = (RBParser 
							parseMethod: 'copyWithAssociations 
							| newDictionary |
							newDictionary := Dictionary new: self size.
							self
								keysAndValuesDo: [:key :value | newDictionary at: key put: value].
							^newDictionary').
	self assert: class selectors size = selectorsSize! !

!ExtractMethodToComponentTest methodsFor: 'failure tests' stamp: ''!
testExtractFailure
	self
		shouldFail: (ExtractMethodToComponentRefactoring 
					extract: (self convertInterval: (80 to: 269)
							for: (BasicLintRuleTest class sourceCodeAt: #subclassOf:overrides:))
					from: #subclassOf:overrides:
					in: BasicLintRuleTest class);
		shouldFail: (ExtractMethodToComponentRefactoring 
					extract: (self convertInterval: (53 to: 56)
							for: (BasicLintRuleTest class sourceCodeAt: #subclassOf:overrides:))
					from: #subclassOf:overrides:
					in: BasicLintRuleTest class);
		shouldFail: (ExtractMethodToComponentRefactoring 
					extract: (self convertInterval: (77 to: 222)
							for: (BasicLintRuleTest class 
									sourceCodeAt: #subclassResponsibilityNotDefined))
					from: #subclassResponsibilityNotDefined
					in: BasicLintRuleTest class)! !

!ExtractMethodToComponentTest methodsFor: 'tests' stamp: 'bh 3/16/2000 12:14'!
testExtractMethodAtEndOfMethodThatNeedsReturn
	| refactoring class selectorsSize |
	refactoring := ExtractMethodToComponentRefactoring 
				extract: (self convertInterval: (52 to: 182)
						for: (LintRuleTest sourceCodeAt: #openEditor))
				from: #openEditor
				in: LintRuleTest.
	self setupMethodNameFor: refactoring toReturn: #foo:.
	self setupSelfArgumentNameFor: refactoring toReturn: 'asdf'.
	self setupVariableToMoveToFor: refactoring toReturn: 'rules'.
	self setupVariableTypesFor: refactoring
		toReturn: (Array with: (refactoring model classNamed: #Collection)).
	class := refactoring model classNamed: #LintRuleTest.
	selectorsSize := class selectors size.
	self proceedThroughWarning: [self executeRefactoring: refactoring].
	self 
		assert: (class parseTreeFor: #openEditor) = (RBParser 
						parseMethod: 'openEditor
								| rules |
								rules := self failedRules.
								^rules foo: self').
	self 
		assert: ((refactoring model classNamed: #Collection) parseTreeFor: #foo:) 
				= (RBParser 
						parseMethod: 'foo: asdf
								self isEmpty ifTrue: [^asdf].
								self size == 1 ifTrue: [^self first viewResults].
								SmalllintResultEditor openOn: asdf label: asdf name.
								^asdf').
	self assert: class selectors size = selectorsSize! !

!ExtractMethodToComponentTest methodsFor: 'failure tests' stamp: ''!
testNonExistantSelector
	self shouldFail: (ExtractMethodToComponentRefactoring 
				extract: (10 to: 20)
				from: #checkClass1:
				in: BasicLintRuleTest)! !

!ExtractMethodToComponentTest methodsFor: 'failure tests' stamp: ''!
testBadInterval
	self
		shouldFail: (ExtractMethodToComponentRefactoring 
					extract: (self convertInterval: (24 to: 30)
							for: (RefactoryTestDataApp sourceCodeAt: #testMethod))
					from: #testMethod
					in: RefactoryTestDataApp);
		shouldFail: (ExtractMethodToComponentRefactoring 
					extract: (self convertInterval: (80 to: 147)
							for: (BasicLintRuleTest class sourceCodeAt: #subclassOf:overrides:))
					from: #subclassOf:overrides:
					in: BasicLintRuleTest class)! !

!RefactoringTest methodsFor: 'set up' stamp: ''!
setupVariableTypesFor: aRefactoring toReturn: anObject 
	| options |
	options := aRefactoring options copy.
	options at: #variableTypes put: [:ref :ignore1 :ignore2 | anObject].
	aRefactoring options: options! !

RefactoringTest subclass: #InlineAllMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!InlineAllMethodTest methodsFor: 'tests' stamp: ''!
testInlineMethodWithMultipleSendersInMethod
	| refactoring |
	refactoring := InlineAllSendersRefactoring sendersOf: #caller2
				in: RefactoryTestDataApp.
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #inlineLast) = (RBParser 
							parseMethod: 'inlineLast
	5 = 3 ifTrue: [^self caller] ifFalse: [^(1 to: 10) inject: 1 into: [:sum :each | sum * (self foo: each)]] ').
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #multipleCalls) = (RBParser 
							parseMethod: 'multipleCalls
	(1 to: 10) inject: 1 into: [:sum :each | sum * (self foo: each)].
	(1 to: 10) inject: 1 into: [:sum1 :each1 | sum1 * (self foo: each1)]')! !

!InlineAllMethodTest methodsFor: 'tests' stamp: ''!
testRecursiveMethod
	| class |
	model := RBNamespace new.
	class := model classNamed: self class name.
	class
		compile: 'foo ^self foo' classified: #(#accessing);
		compile: 'bar ^self foo' classified: #(#accessing).
	self executeRefactoring: (InlineAllSendersRefactoring 
				model: model
				sendersOf: #foo
				in: class).
	self assert: (class parseTreeFor: #foo) 
				= (RBParser parseMethod: 'foo ^self foo').
	self assert: (class parseTreeFor: #bar) 
				= (RBParser parseMethod: 'bar ^self foo')! !

RefactoringTest subclass: #RenameMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!RenameMethodTest methodsFor: 'failure tests' stamp: ''!
testExistingSelector
	self shouldFail: (RenameMethodRefactoring 
				renameMethod: #checkClass:
				in: BasicLintRuleTest
				to: #runOnEnvironment:
				permuation: (1 to: 1))! !

!RenameMethodTest methodsFor: 'failure tests' stamp: ''!
testMultipleSelectors
	self shouldWarn: (RenameMethodRefactoring 
				renameMethod: #checkClass:
				in: BasicLintRuleTest
				to: #foo:
				permuation: (1 to: 1))! !

!RenameMethodTest methodsFor: 'tests' stamp: ''!
testRenameTestMethod1
	| refactoring class |
	refactoring := RenameMethodRefactoring 
				renameMethod: ('test' , 'Method1') asSymbol
				in: RefactoryTestDataApp
				to: #testMethod2
				permuation: (1 to: 0).
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #RefactoryTestDataApp.
	self 
		assert: (class parseTreeFor: #testMethod2) = (RBParser 
						parseMethod: 'testMethod2
	^self testMethod2 , ([:each | each testMethod2] value: #(#(#testMethod2) 2 #testMethod2))').
	self 
		assert: ((refactoring model classNamed: #BasicLintRuleTest) 
				parseTreeFor: #classBlock:) = (RBParser 
							parseMethod: 'classBlock: aBlock
	classBlock := aBlock testMethod2').
	self deny: (class directlyDefinesMethod: ('test' , 'Method1') asSymbol)! !

!RenameMethodTest methodsFor: 'tests' stamp: ''!
testRenameTestMethod
	| refactoring class |
	refactoring := RenameMethodRefactoring 
				renameMethod: ('rename' , 'ThisMethod:') asSymbol
				in: RefactoryTestDataApp
				to: #renameThisMethod2:
				permuation: (1 to: 1).
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #RefactoryTestDataApp.
	self assert: (class parseTreeFor: #renameThisMethod2:) 
				= (RBParser parseMethod: 'renameThisMethod2: anArg
	^self').
	self assert: (class parseTreeFor: #callMethod) 
				= (RBParser parseMethod: 'callMethod
	^(self renameThisMethod2: 5)').
	self 
		assert: (class parseTreeFor: #symbolReference) = (RBParser 
						parseMethod: 'symbolReference
		^ #(#renameThisMethod2: #(4 #renameThisMethod2:))').
	self 
		deny: (class directlyDefinesMethod: ('rename' , 'ThisMethod:') asSymbol)! !

!RenameMethodTest methodsFor: 'tests' stamp: ''!
testRenamePrimitive
	| refactoring count |
	count := 0.
	model allReferencesTo: #basicAt:put: do: [:method | count := count + 1].
	refactoring := RenameMethodRefactoring 
				model: model
				renameMethod: #basicAt:put:
				in: Object
				to: ('at:' , 'bar:') asSymbol
				permuation: (1 to: 2).
	self proceedThroughWarning: [self executeRefactoring: refactoring].
	model allReferencesTo: #basicAt:put:
		do: 
			[:method | 
			count := count - 1.
			self assert: method source isNil].
	model allReferencesTo: ('at:' , 'bar:') asSymbol
		do: [:method | count := count - 1].
	self assert: count = 0! !

!RenameMethodTest methodsFor: 'tests' stamp: ''!
testRenamePermuteArgs
	| refactoring class |
	refactoring := RenameMethodRefactoring 
				renameMethod: ('rename:' , 'two:') asSymbol
				in: RefactoryTestDataApp
				to: ('rename:' , 'two:') asSymbol
				permuation: #(2 1).
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #RefactoryTestDataApp.
	self 
		assert: (class parseTreeFor: ('rename:' , 'two:') asSymbol) = (RBParser 
						parseMethod: 'rename: argumentMethod two: this ^self printString, this, argumentMethod').
	self assert: (class parseTreeFor: #exampleCall) 
				= (RBParser parseMethod: 'exampleCall ^self rename: 2 two: 1')! !

RefactoringTest subclass: #ChildrenToSiblingsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!ChildrenToSiblingsTest methodsFor: 'tests' stamp: ''!
testModelChildrenToSibling
	| refactoring class subclass superclass |
	class := model classNamed: #ConcreteSuperclass.
	subclass := model classNamed: #ConcreteSubclass.
	refactoring := ChildrenToSiblingsRefactoring 
				model: model
				name: #AbstractSuperclass
				class: class
				subclasses: (Array with: subclass).
	self executeRefactoring: refactoring.
	superclass := refactoring model classNamed: #AbstractSuperclass.
	self assert: class superclass = superclass.
	self assert: class metaclass superclass = superclass metaclass.
	self assert: subclass superclass = superclass.
	self assert: subclass metaclass superclass = superclass metaclass.
	self 
		assert: (superclass parseTreeFor: #same) = (RBParser 
						parseMethod: 'same ^self initialize isKindOf: AbstractSuperclass').
	self assert: (superclass parseTreeFor: #different) 
				= (RBParser parseMethod: 'different self subclassResponsibility').
	self 
		assert: (superclass parseTreeFor: #initialize) = (RBParser 
						parseMethod: 'initialize
							instVarName1 := instVarName2 := ClassVarName1 := ClassVarName2 := 0').
	self assert: (superclass directlyDefinesInstanceVariable: 'instVarName1').
	self assert: (superclass directlyDefinesInstanceVariable: 'instVarName2').
	self assert: (superclass directlyDefinesClassVariable: 'ClassVarName1').
	self assert: (superclass directlyDefinesClassVariable: 'ClassVarName2').
	self assert: (superclass metaclass 
				directlyDefinesInstanceVariable: 'classInstVarName1').
	self 
		assert: (superclass metaclass parseTreeFor: #foo) = (RBParser 
						parseMethod: 'foo
							^classInstVarName1 + ClassVarName1 + ClassVarName2').
	self assert: (superclass metaclass parseTreeFor: #new) 
				= (RBParser parseMethod: 'new
							^super new initialize').
	self assert: (superclass metaclass parseTreeFor: #bar) 
				= (RBParser parseMethod: 'bar
							self subclassResponsibility').
	self deny: (class directlyDefinesInstanceVariable: 'instVarName1').
	self deny: (class directlyDefinesInstanceVariable: 'instVarName2').
	self deny: (class directlyDefinesClassVariable: 'ClassVarName1').
	self deny: (class directlyDefinesClassVariable: 'ClassVarName2').
	self 
		deny: (class metaclass directlyDefinesInstanceVariable: 'classInstVarName1').
	self deny: (class directlyDefinesMethod: #same).
	self deny: (class directlyDefinesMethod: #initialize).
	self deny: (class metaclass directlyDefinesMethod: #new).
	self assert: (class parseTreeFor: #different) 
				= (RBParser parseMethod: 'different
							^instVarName1 + instVarName2').
	self assert: (class metaclass parseTreeFor: #bar) 
				= (RBParser parseMethod: 'bar
							^self printString')! !

!ChildrenToSiblingsTest methodsFor: 'failure tests' stamp: ''!
testInvalidSubclass
	self shouldFail: (ChildrenToSiblingsRefactoring 
				name: #Foo
				class: LintRuleTest
				subclasses: (Array with: BasicLintRule with: CompositeLintRule))! !

!ChildrenToSiblingsTest methodsFor: 'failure tests' stamp: ''!
testExistingName
	self
		shouldFail: (ChildrenToSiblingsRefactoring 
					name: #Object
					class: LintRuleTest
					subclasses: (Array with: BasicLintRuleTest with: CompositeLintRuleTest));
		shouldFail: (ChildrenToSiblingsRefactoring 
					name: #Processor
					class: LintRuleTest
					subclasses: (Array with: BasicLintRuleTest with: CompositeLintRuleTest))! !

!ChildrenToSiblingsTest methodsFor: 'failure tests' stamp: ''!
testBadName
	self shouldFail: (ChildrenToSiblingsRefactoring 
				name: #'Obje ct'
				class: LintRuleTest
				subclasses: (Array with: BasicLintRuleTest with: CompositeLintRuleTest))! !

!ChildrenToSiblingsTest methodsFor: 'failure tests' stamp: ''!
testMetaClassFailure
	self shouldFail: (ChildrenToSiblingsRefactoring 
				name: #Foo
				class: LintRuleTest class
				subclasses: (Array with: BasicLintRuleTest class
						with: CompositeLintRuleTest class))! !

!ChildrenToSiblingsTest methodsFor: 'set up' stamp: ''!
setUp
	super setUp.
	model := Compiler evaluate: (self readFile: 'ChildrenToSiblingTest.st')! !

RefactoringTest subclass: #PushDownClassVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!PushDownClassVariableTest methodsFor: 'failure tests' stamp: 'bh 11/8/2000 14:09'!
testModelNonExistantName
	model 
		defineClass: 'Object subclass: #SomeClass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	self shouldFail: (PushDownClassVariableRefactoring 
				model: model
				variable: #Foo
				class: (model classNamed: #SomeClass))! !

!PushDownClassVariableTest methodsFor: 'tests' stamp: 'bh 11/8/2000 14:10'!
testModelPushDownVariableToMultipleClassesInSameHierarchy
	| class |
	model 
		defineClass: 'Object subclass: #SomeClass instanceVariableNames: '''' classVariableNames: ''Foo'' poolDictionaries: '''' category: #''Refactory-Test data'''.
	model 
		defineClass: 'SomeClass subclass: #Subclass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	class := model classNamed: #Subclass.
	class compile: 'foo ^Foo' classified: #(#accessing).
	model 
		defineClass: 'Subclass subclass: #AnotherSubclass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	(model metaclassNamed: #AnotherSubclass) compile: 'bar ^Foo'
		classified: #(#accessing).
	self executeRefactoring: (PushDownClassVariableRefactoring 
				model: model
				variable: #Foo
				class: class superclass).
	self deny: (class superclass directlyDefinesClassVariable: #Foo).
	self assert: (class directlyDefinesClassVariable: #Foo)! !

!PushDownClassVariableTest methodsFor: 'failure tests' stamp: ''!
testNonExistantName
	self shouldFail: (PushDownClassVariableRefactoring variable: #Foo
				class: BasicLintRuleTest)! !

!PushDownClassVariableTest methodsFor: 'failure tests' stamp: 'bh 11/8/2000 14:09'!
testModelPushDownToMultipleSubclassesFailure
	model 
		defineClass: 'Object subclass: #SomeClass instanceVariableNames: '''' classVariableNames: ''Foo'' poolDictionaries: '''' category: #''Refactory-Test data'''.
	model 
		defineClass: 'SomeClass subclass: #Subclass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	(model classNamed: #Subclass) compile: 'foo ^Foo' classified: #(#accessing).
	model 
		defineClass: 'SomeClass subclass: #AnotherSubclass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	(model metaclassNamed: #AnotherSubclass) compile: 'bar ^Foo'
		classified: #(#accessing).
	self shouldFail: (PushDownClassVariableRefactoring 
				model: model
				variable: #Foo
				class: (model classNamed: #SomeClass))! !

!PushDownClassVariableTest methodsFor: 'tests' stamp: ''!
testPushDownClassVariable
	| refactoring |
	refactoring := PushDownClassVariableRefactoring variable: #Foo1
				class: LintRuleTest.
	self assert: ((refactoring model classNamed: #LintRuleTest) 
				directlyDefinesClassVariable: #Foo1).
	self executeRefactoring: refactoring.
	(refactoring model classNamed: #LintRuleTest) withAllSubclasses 
		do: [:each | self deny: (each directlyDefinesClassVariable: #Foo1)]! !

!PushDownClassVariableTest methodsFor: 'tests' stamp: 'bh 11/8/2000 14:09'!
testModelPushDownVariable
	| class |
	model 
		defineClass: 'Object subclass: #SomeClass instanceVariableNames: '''' classVariableNames: ''Foo'' poolDictionaries: '''' category: #''Refactory-Test data'''.
	model 
		defineClass: 'SomeClass subclass: #Subclass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	class := model classNamed: #Subclass.
	class compile: 'foo ^Foo' classified: #(#accessing).
	self executeRefactoring: (PushDownClassVariableRefactoring 
				model: model
				variable: #Foo
				class: class superclass).
	self deny: (class superclass directlyDefinesClassVariable: #Foo).
	self assert: (class directlyDefinesClassVariable: #Foo)! !

!PushDownClassVariableTest methodsFor: 'tests' stamp: 'bh 11/8/2000 14:10'!
testModelRemoveUnusedVariable
	model 
		defineClass: 'Object subclass: #SomeClass instanceVariableNames: '''' classVariableNames: ''Foo'' poolDictionaries: '''' category: #''Refactory-Test data'''.
	self 
		assert: ((model classNamed: #SomeClass) directlyDefinesVariable: #Foo).
	model 
		defineClass: 'SomeClass subclass: #Subclass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	self executeRefactoring: (PushDownClassVariableRefactoring 
				model: model
				variable: #Foo
				class: (model classNamed: #SomeClass)).
	self deny: ((model classNamed: #SomeClass) directlyDefinesVariable: #Foo).
	self deny: ((model classNamed: #Subclass) directlyDefinesVariable: #Foo)! !

!PushDownClassVariableTest methodsFor: 'tests' stamp: 'bh 11/8/2000 14:09'!
testModelPushDownVariableToClassDownTwoLevels
	| class |
	model 
		defineClass: 'Object subclass: #SomeClass instanceVariableNames: '''' classVariableNames: ''Foo'' poolDictionaries: '''' category: #''Refactory-Test data'''.
	model 
		defineClass: 'SomeClass subclass: #Subclass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	model 
		defineClass: 'Subclass subclass: #AnotherSubclass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	class := model metaclassNamed: #AnotherSubclass.
	class compile: 'bar ^Foo' classified: #(#accessing).
	class := class nonMetaclass.
	self executeRefactoring: (PushDownClassVariableRefactoring 
				model: model
				variable: #Foo
				class: class superclass superclass).
	self 
		deny: (class superclass superclass directlyDefinesClassVariable: #Foo).
	self deny: (class superclass directlyDefinesClassVariable: #Foo).
	self assert: (class directlyDefinesClassVariable: #Foo)! !

RefactoringTest subclass: #RemoveInstanceVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!RemoveInstanceVariableTest methodsFor: 'failure tests' stamp: ''!
testReferencedVariable
	self shouldFail: (RemoveInstanceVariableRefactoring variable: 'name'
				class: LintRuleTest)! !

!RemoveInstanceVariableTest methodsFor: 'tests' stamp: 'bh 11/8/2000 14:13'!
testModelRemoveInstanceVariable
	| class |
	model 
		defineClass: 'nil subclass: #Object instanceVariableNames: ''foo1'' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	class := model classNamed: #Object.
	self assert: (class definesInstanceVariable: 'foo1').
	self executeRefactoring: (RemoveInstanceVariableRefactoring 
				model: model
				variable: 'foo1'
				class: class).
	self deny: (class definesInstanceVariable: 'foo1')! !

!RemoveInstanceVariableTest methodsFor: 'failure tests' stamp: ''!
testNonExistantName
	self shouldFail: (RemoveInstanceVariableRefactoring variable: 'name1'
				class: LintRuleTest)! !

!RemoveInstanceVariableTest methodsFor: 'tests' stamp: ''!
testRemoveInstVar
	| refactoring class |
	refactoring := RemoveInstanceVariableRefactoring variable: 'foo1'
				class: LintRuleTest.
	class := refactoring model classNamed: #LintRuleTest.
	self assert: (class definesInstanceVariable: 'foo1').
	self executeRefactoring: refactoring.
	self deny: (class definesInstanceVariable: 'foo1')! !

RefactoringTest subclass: #AddParameterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!AddParameterTest methodsFor: 'failure tests' stamp: ''!
testModelNonExistantName
	| refactoring |
	(model classNamed: #LintRuleTest) removeMethod: #name.
	refactoring := AddParameterRefactoring 
				model: model
				addParameterToMethod: #name
				in: LintRuleTest
				newSelector: #nameNew:
				initializer: 'nil'.
	self shouldFail: refactoring! !

!AddParameterTest methodsFor: 'failure tests' stamp: ''!
testModelBadInitializationCode
	| refactoring |
	model removeClassNamed: #Refactoring.
	refactoring := AddParameterRefactoring 
				model: model
				addParameterToMethod: #name1
				in: LintRuleTest
				newSelector: #name1:
				initializer: 'AddParameterRefactoring new'.
	self shouldFail: refactoring! !

!AddParameterTest methodsFor: 'tests' stamp: ''!
testAddParameterThatReferencesModelGlobal
	| refactoring class |
	refactoring := AddParameterRefactoring 
				model: model
				addParameterToMethod: ('test' , 'Foo:') asSymbol
				in: RefactoryTestDataApp
				newSelector: #testFoo:bar:
				initializer: 'Bar new'.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #RefactoryTestDataApp.
	self 
		assert: (class parseTreeFor: #testFoo:bar:) = (RBParser 
						parseMethod: 'testFoo: anObject bar: anObject1
								^self class + anObject').
	self assert: (class parseTreeFor: #callFoo) 
				= (RBParser parseMethod: 'callFoo ^self testFoo: 5 bar: (Bar new)').
	self deny: (class directlyDefinesMethod: ('test' , 'Foo:') asSymbol)! !

!AddParameterTest methodsFor: 'tests' stamp: 'bh 3/14/2000 18:15'!
testAddParameterThatReferencesSelf
	| refactoring class |
	refactoring _ AddParameterRefactoring
				addParameterToMethod: ('test' , 'Foo:') asSymbol
				in: RefactoryTestDataApp
				newSelector: #testFoo:bar:
				initializer: 'self printString'.
	self executeRefactoring: refactoring.
	class _ refactoring model classNamed: #RefactoryTestDataApp.
	self assert: (class parseTreeFor: #testFoo:bar:)
			= (RBParser parseMethod: 'testFoo: anObject bar: anObject1
								^self class + anObject').
	self assert: (class parseTreeFor: #callFoo)
			= (RBParser parseMethod: 'callFoo ^self testFoo: 5 bar: (self printString)').
	self deny: (class directlyDefinesMethod: ('test' , 'Foo:') asSymbol)! !

!AddParameterTest methodsFor: 'failure tests' stamp: ''!
testNonExistantName
	self shouldFail: (AddParameterRefactoring 
				addParameterToMethod: #name1
				in: LintRuleTest
				newSelector: #name1:
				initializer: 'nil')! !

!AddParameterTest methodsFor: 'set up' stamp: ''!
setUp
	super setUp.
	model := Compiler evaluate: (self readFile: 'AbstractVariableTestData.st')! !

!AddParameterTest methodsFor: 'failure tests' stamp: ''!
testBadInitializationCode
	self
		shouldFail: (AddParameterRefactoring 
					addParameterToMethod: #name
					in: LintRuleTest
					newSelector: #name:
					initializer: 'foo:');
		shouldFail: (AddParameterRefactoring 
					addParameterToMethod: #name
					in: LintRuleTest
					newSelector: #name:
					initializer: 'foo')! !

!AddParameterTest methodsFor: 'failure tests' stamp: ''!
testPrimitiveMethods
	| refactoring |
	(model classNamed: #Object) 
		compile: 'foo <primitive: 100> ^#() primitiveFailed'
		classified: #(#accessing).
	refactoring := AddParameterRefactoring 
				model: model
				addParameterToMethod: #foo
				in: Object
				newSelector: #foo123124321s:
				initializer: '1'.
	self shouldFail: refactoring.
	refactoring := AddParameterRefactoring 
				addParameterToMethod: #at:
				in: Object
				newSelector: #at:foo:
				initializer: '1'.
	self shouldFail: refactoring.
	! !

!AddParameterTest methodsFor: 'tests' stamp: ''!
testAddParameterForTwoArgumentMessage
	| refactoring class |
	refactoring := AddParameterRefactoring 
				addParameterToMethod: ('called:' , 'on:') asSymbol
				in: RefactoryTestDataApp
				newSelector: #called:bar:on:
				initializer: '#(1.0)'.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #RefactoryTestDataApp.
	self 
		assert: (class parseTreeFor: #called:bar:on:) = (RBParser 
						parseMethod: 'called: anObject bar: aBlock on: anObject1
							Transcript
								show: anObject printString;
								cr.
								aBlock value').
	self 
		assert: (class parseTreeFor: #caller) = (RBParser 
						parseMethod: 'caller
							| anObject |
							anObject := 5.
							self 
								called: anObject + 1
								bar: [^anObject] on: #(1.0)').
	self deny: (class directlyDefinesMethod: ('called:' , 'on:') asSymbol)! !

!AddParameterTest methodsFor: 'tests' stamp: ''!
testAddParameterThatReferencesGlobalAndLiteral
	| refactoring class |
	refactoring := AddParameterRefactoring 
				addParameterToMethod: ('test' , 'Foo:') asSymbol
				in: RefactoryTestDataApp
				newSelector: #testFoo:bar:
				initializer: 'OrderedCollection new: 5'.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #RefactoryTestDataApp.
	self 
		assert: (class parseTreeFor: #testFoo:bar:) = (RBParser 
						parseMethod: 'testFoo: anObject bar: anObject1
								^self class + anObject').
	self 
		assert: (class parseTreeFor: #callFoo) = (RBParser 
						parseMethod: 'callFoo ^self testFoo: 5 bar: (OrderedCollection new: 5)').
	self deny: (class directlyDefinesMethod: ('test' , 'Foo:') asSymbol)! !

RefactoringTest subclass: #RemoveMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!RemoveMethodTest methodsFor: 'tests' stamp: ''!
testRemoveMethod
	| refactoring selectors |
	selectors := Array with: ('selectorNot' , 'Referenced') asSymbol.
	refactoring := RemoveMethodRefactoring removeMethods: selectors
				from: RefactoryTestDataApp.
	self assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				directlyDefinesMethod: selectors first).
	self executeRefactoring: refactoring.
	self deny: ((refactoring model classNamed: #RefactoryTestDataApp) 
				directlyDefinesMethod: selectors first)! !

!RemoveMethodTest methodsFor: 'failure tests' stamp: ''!
testRemoveReferenced
	self shouldFail: (RemoveMethodRefactoring removeMethods: #(#checkClass:)
				from: BasicLintRuleTest)! !

!RemoveMethodTest methodsFor: 'tests' stamp: ''!
testModelRecursiveMethodThatIsNotReferencedFromOtherMethods
	| class otherClass |
	class := model classNamed: #Object.
	class compile: 'someMethodThatIsNotReferenced ^2' classified: #(#accessing).
	self assert: (class definesMethod: #someMethodThatIsNotReferenced).
	otherClass := model metaclassNamed: self class superclass name.
	otherClass 
		compile: 'someMethodThatIsNotReferenced ^3 someMethodThatIsNotReferenced'
		classified: #(#accessing).
	model removeClassNamed: self class name.
	self executeRefactoring: (RemoveMethodRefactoring 
				model: model
				removeMethods: #(#someMethodThatIsNotReferenced)
				from: class).
	self deny: (class definesMethod: #someMethodThatIsNotReferenced)! !

!RemoveMethodTest methodsFor: 'failure tests' stamp: ''!
testRemoveSameMethodButSendsSuper
	self shouldWarn: (RemoveMethodRefactoring removeMethods: #(#new)
				from: BasicLintRuleTest class)! !

RefactoringTest subclass: #AddClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!AddClassTest methodsFor: 'set up' stamp: ''!
setUp
	super setUp.
	model := Compiler evaluate: (self readFile: 'AbstractVariableTestData.st')! !

!AddClassTest methodsFor: 'tests' stamp: 'bh 3/27/2000 22:39'!
testModelAddClass
	| refactoring newClass superClass subclass |
	subclass := model classNamed: #Bar.
	superClass := model classNamed: #Foo.
	refactoring := AddClassRefactoring 
				model: model
				addClass: #FooTest
				superclass: superClass
				subclasses: (Array with: subclass)
				category: #'Refactory-Testing'.
	self executeRefactoring: refactoring.
	newClass := model classNamed: #FooTest.

	self assert: newClass superclass = superClass.
	self assert: (superClass subclasses includes: newClass).
	self assert: newClass metaclass superclass = superClass metaclass.
	self 
		assert: (superClass metaclass subclasses includes: newClass metaclass).
	self assert: subclass superclass = newClass.
	self assert: (newClass subclasses includes: subclass).
	self assert: subclass metaclass superclass = newClass metaclass.
	self assert: (newClass metaclass subclasses includes: subclass metaclass)! !

!AddClassTest methodsFor: 'failure tests' stamp: ''!
testMetaClassFailure
	self shouldFail: (AddClassRefactoring 
				addClass: #Foo
				superclass: self class class
				subclasses: #()
				category: #'Refactory-Testing')! !

!AddClassTest methodsFor: 'failure tests' stamp: ''!
testModelInvalidSubclass
	| refactoring |
	refactoring := AddClassRefactoring 
				model: model
				addClass: #Foo2
				superclass: Object
				subclasses: (Array with: (model classNamed: #Bar))
				category: #'Refactory-Tesing'.
	self shouldFail: refactoring! !

!AddClassTest methodsFor: 'failure tests' stamp: ''!
testExistingName
	self shouldFail: (AddClassRefactoring 
				addClass: #Object
				superclass: self class
				subclasses: #()
				category: #'Refactory-Testing')! !

!AddClassTest methodsFor: 'tests' stamp: ''!
testAddClass
	| refactoring newClass superClass classTest |
	refactoring := AddClassRefactoring 
				addClass: #FooTest
				superclass: RefactoringTest
				subclasses: (Array with: self class)
				category: #'Refactory-Testing'.
	self executeRefactoring: refactoring.
	newClass := refactoring model classNamed: #FooTest.
	superClass := refactoring model classNamed: #RefactoringTest.
	classTest := refactoring model classNamed: self class name.
	self assert: newClass superclass = superClass.
	self assert: (superClass subclasses includes: newClass).
	self assert: newClass metaclass superclass = superClass metaclass.
	self 
		assert: (superClass metaclass subclasses includes: newClass metaclass).
	self assert: classTest superclass = newClass.
	self assert: (newClass subclasses includes: classTest).
	self assert: classTest metaclass superclass = newClass metaclass.
	self assert: (newClass metaclass subclasses includes: classTest metaclass)! !

!AddClassTest methodsFor: 'failure tests' stamp: ''!
testInvalidSubclass
	self shouldFail: (AddClassRefactoring 
				addClass: #Foo
				superclass: CompositeLintRuleTest
				subclasses: (Array with: BasicLintRuleTest)
				category: #'Refactory-Tesing')! !

!AddClassTest methodsFor: 'failure tests' stamp: ''!
testModelExistingName
	| refactoring |
	refactoring := AddClassRefactoring 
				model: model
				addClass: #Foo
				superclass: Object
				subclasses: #()
				category: #'Refactory-Testing'.
	self shouldFail: refactoring! !

!RefactoringTest methodsFor: 'private' stamp: ''!
shouldFail: aRefactoring 
	self proceedThroughWarning: 
			[self should: [self executeRefactoring: aRefactoring]
				raise: RefactoringError]! !

RefactoringTest subclass: #RenameInstanceVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!RenameInstanceVariableTest methodsFor: 'failure tests' stamp: ''!
testNonExistantName
	self shouldFail: (RenameInstanceVariableRefactoring 
				rename: 'foo'
				to: 'newFoo'
				in: BasicLintRuleTest)! !

!RenameInstanceVariableTest methodsFor: 'tests' stamp: ''!
testRenameInstVar
	| refactoring class |
	refactoring := RenameInstanceVariableRefactoring 
				rename: 'classBlock'
				to: 'asdf'
				in: BasicLintRuleTest.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #BasicLintRuleTest.
	self assert: (class directlyDefinesInstanceVariable: 'asdf').
	self deny: (class directlyDefinesInstanceVariable: 'classBlock').
	self 
		assert: (class parseTreeFor: #checkClass:) = (RBParser 
						parseMethod: 'checkClass: aSmalllintContext 
								^asdf value: aSmalllintContext value: result').
	self 
		assert: (class parseTreeFor: #classBlock:) = (RBParser 
						parseMethod: 'classBlock: aBlock
								asdf := aBlock testMethod1').
	self 
		assert: (class parseTreeFor: #initialize) = (RBParser 
						parseMethod: 'initialize
								super initialize.
								asdf := [:context :aResult | ].
								methodBlock := [:context :aResult | ].
								self resultClass: SelectorEnvironment.')! !

!RenameInstanceVariableTest methodsFor: 'failure tests' stamp: ''!
testAlreadyExistingName
	self shouldFail: (RenameInstanceVariableRefactoring 
				rename: 'classBlock'
				to: 'name'
				in: BasicLintRuleTest)! !

RefactoringTest subclass: #ExtractMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!ExtractMethodTest methodsFor: 'failure tests' stamp: ''!
testBadInterval
	self
		shouldFail: (ExtractMethodRefactoring 
					extract: (self convertInterval: (24 to: 30)
							for: (RefactoryTestDataApp sourceCodeAt: #testMethod))
					from: #testMethod
					in: RefactoryTestDataApp);
		shouldFail: (ExtractMethodRefactoring 
					extract: (self convertInterval: (80 to: 147)
							for: (BasicLintRuleTest class sourceCodeAt: #subclassOf:overrides:))
					from: #subclassOf:overrides:
					in: BasicLintRuleTest class)! !

!ExtractMethodTest methodsFor: 'failure tests' stamp: ''!
testExtractFailure
	self
		shouldFail: (ExtractMethodRefactoring 
					extract: (self convertInterval: (80 to: 269)
							for: (BasicLintRuleTest class sourceCodeAt: #subclassOf:overrides:))
					from: #subclassOf:overrides:
					in: BasicLintRuleTest class);
		shouldFail: (ExtractMethodRefactoring 
					extract: (self convertInterval: (53 to: 56)
							for: (BasicLintRuleTest class sourceCodeAt: #subclassOf:overrides:))
					from: #subclassOf:overrides:
					in: BasicLintRuleTest class);
		shouldFail: (ExtractMethodRefactoring 
					extract: (self convertInterval: (77 to: 222)
							for: (BasicLintRuleTest class 
									sourceCodeAt: #subclassResponsibilityNotDefined))
					from: #subclassResponsibilityNotDefined
					in: BasicLintRuleTest class)! !

!ExtractMethodTest methodsFor: 'tests' stamp: ''!
testModelExtractMethodWithTemporariesSelected
	| class refactoring |
	model := RBNamespace new.
	class := model classNamed: self class name.
	class compile: 'foo [| temp | temp := 5. temp * temp] value'
		classified: #(#accessing).
	refactoring := ExtractMethodRefactoring 
				model: model
				extract: (6 to: 36)
				from: #foo
				in: class.
	self setupMethodNameFor: refactoring toReturn: #foobar.
	self executeRefactoring: refactoring.
	self assert: (class parseTreeFor: #foo) 
				= (RBParser parseMethod: 'foo [self foobar] value').
	self assert: (class parseTreeFor: #foobar) 
				= (RBParser parseMethod: 'foobar |temp | temp := 5. ^temp * temp')! !

!ExtractMethodTest methodsFor: 'tests' stamp: 'bh 9/16/2001 21:06'!
testModelExtractMethodWithTemporaryAssigned
	| class refactoring |
	model := RBNamespace new.
	class := model classNamed: self class name.
	class 
		compile: 'foo 				| temp bar | 				bar := 5. 				temp := bar * bar. 				Transcript show: temp printString; cr. 				^temp * temp'
		classified: #(#accessing).
	refactoring := ExtractMethodRefactoring 
				model: model
				extract: (26 to: 102)
				from: #foo
				in: class.
	self setupMethodNameFor: refactoring toReturn: #foobar.
	self executeRefactoring: refactoring.
	self assert: (class parseTreeFor: #foo) 
				= (RBParser parseMethod: 'foo | temp | temp := self foobar. ^temp * temp').
	self 
		assert: ((class parseTreeFor: #foobar) = (RBParser 
						parseMethod: 'foobar | bar temp | bar := 5. temp := bar * bar. Transcript show: temp printString; cr. ^temp.')) |
				((class parseTreeFor: #foobar) = (RBParser 
						parseMethod: 'foobar | temp bar | bar := 5. temp := bar * bar. Transcript show: temp printString; cr. ^temp.'))! !

!ExtractMethodTest methodsFor: 'failure tests' stamp: ''!
testNonExistantSelector
	self shouldFail: (ExtractMethodRefactoring 
				extract: (10 to: 20)
				from: #checkClass1:
				in: BasicLintRuleTest)! !

!ExtractMethodTest methodsFor: 'tests' stamp: ''!
testExtractMethodThatMovesTemporaryVariable
	| refactoring class |
	refactoring := ExtractMethodRefactoring 
				extract: (self convertInterval: (22 to: 280)
						for: (TransformationRuleTest sourceCodeAt: #superSends))
				from: #superSends
				in: TransformationRuleTest.
	self setupMethodNameFor: refactoring toReturn: #foo.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #TransformationRuleTest.
	self 
		assert: (class parseTreeFor: #superSends) = (RBParser 
						parseMethod: 'superSends
	| rule |
	rule := self foo.
	self rewriteUsing: rule').
	self 
		assert: (class parseTreeFor: #foo) = (RBParser 
						parseMethod: 'foo | rule | 	rule := ParseTreeRewriter new.
	rule addSearch: ''super `@message: ``@args''
				-> (
					[:aNode | 
					(class withAllSubclasses
						detect: [:each | each includesSelector: aNode selector]
						ifNone: [nil]) isNil]
							-> ''self `@message: ``@args'').
		^rule')! !

!ExtractMethodTest methodsFor: 'tests' stamp: 'bh 3/16/2000 12:13'!
testExtractMethodAtEndOfMethodThatNeedsReturn
	| refactoring class |
	refactoring := ExtractMethodRefactoring 
				extract: (self convertInterval: (52 to: 182)
						for: (LintRuleTest sourceCodeAt: #openEditor))
				from: #openEditor
				in: LintRuleTest.
	self setupMethodNameFor: refactoring toReturn: #foo:.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #LintRuleTest.
	self 
		assert: (class parseTreeFor: #openEditor) = (RBParser 
						parseMethod: 'openEditor
	| rules |
	rules := self failedRules.
	^self foo: rules').
	self 
		assert: (class parseTreeFor: #foo:) = (RBParser 
						parseMethod: 'foo: rules
	rules isEmpty ifTrue: [^self].
	rules size == 1 ifTrue: [^rules first viewResults].
	SmalllintResultEditor openOn: self label: name')! !

!ExtractMethodTest methodsFor: 'tests' stamp: ''!
testExtractMethodThatNeedsTemporaryVariable
	| refactoring class |
	refactoring := ExtractMethodRefactoring 
				extract: (self convertInterval: (78 to: 197)
						for: (LintRuleTest sourceCodeAt: #displayName))
				from: #displayName
				in: LintRuleTest.
	self setupMethodNameFor: refactoring toReturn: #foo:.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #LintRuleTest.
	self 
		assert: (class parseTreeFor: #displayName) = (RBParser 
						parseMethod: 'displayName
	| nameStream |
	nameStream := WriteStream on: (String new: 64).
	self foo: nameStream.
	^nameStream contents').
	self 
		assert: (class parseTreeFor: #foo:) = (RBParser 
						parseMethod: 'foo: nameStream 	nameStream nextPutAll: self name;
		nextPutAll: '' (''.
	self problemCount printOn: nameStream.
	nameStream nextPut: $).')! !

!ExtractMethodTest methodsFor: 'tests' stamp: ''!
testExtractMethodThatNeedsArgument
	| refactoring class |
	refactoring := ExtractMethodRefactoring 
				extract: (self convertInterval: (145 to: 343)
						for: (TransformationRuleTest sourceCodeAt: #checkMethod:))
				from: #checkMethod:
				in: TransformationRuleTest.
	self setupMethodNameFor: refactoring toReturn: #foo:.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #TransformationRuleTest.
	self 
		assert: (class parseTreeFor: #checkMethod:) = (RBParser 
						parseMethod: 'checkMethod: aSmalllintContext 
	class := aSmalllintContext selectedClass.
	(rewriteRule executeTree: aSmalllintContext parseTree) ifTrue: 
			[self foo: aSmalllintContext]').
	self 
		assert: (class parseTreeFor: #foo:) = (RBParser 
						parseMethod: 'foo: aSmalllintContext (RecursiveSelfRule executeTree: rewriteRule tree initialAnswer: false)
				ifFalse: 
					[builder compile: rewriteRule tree printString
						in: class
						classified: aSmalllintContext protocols]')! !

!RefactoringTest methodsFor: 'set up' stamp: ''!
setupMethodNameFor: aRefactoring toReturn: aSelector withArguments: stringCollection 
	| options |
	options := aRefactoring options copy.
	options at: #methodName
		put: 
			[:ref :aMethodName | 
			aMethodName
				selector: aSelector;
				arguments: stringCollection;
				yourself].
	aRefactoring options: options! !

!RefactoringTest methodsFor: 'set up' stamp: ''!
setupSelfArgumentNameFor: aRefactoring toReturn: aString 
	| options |
	options := aRefactoring options copy.
	options at: #selfArgumentName put: [:ref | aString].
	aRefactoring options: options! !

!RefactoringTest methodsFor: 'set up' stamp: ''!
setupVariableToMoveToFor: aRefactoring toReturn: aString 
	| options |
	options := aRefactoring options copy.
	options at: #selectVariableToMoveTo put: [:ref :class :selector | aString].
	aRefactoring options: options! !

RefactoringTest subclass: #RemoveClassVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!RemoveClassVariableTest methodsFor: 'failure tests' stamp: ''!
testNonExistantName
	self 
		shouldFail: (RemoveClassVariableRefactoring variable: #RecursiveSelfRule1
				class: TransformationRuleTest)! !

!RemoveClassVariableTest methodsFor: 'tests' stamp: ''!
testRemoveClassVar
	| refactoring class |
	refactoring := RemoveClassVariableRefactoring variable: 'Foo1'
				class: LintRuleTest.
	class := refactoring model classNamed: #LintRuleTest.
	self assert: (class definesClassVariable: 'Foo1').
	self executeRefactoring: refactoring.
	self deny: (class definesClassVariable: 'Foo1')! !

!RemoveClassVariableTest methodsFor: 'failure tests' stamp: ''!
testReferencedVariable
	self 
		shouldFail: (RemoveClassVariableRefactoring variable: #RecursiveSelfRule
				class: TransformationRuleTest)! !

RefactoringTest subclass: #InlineMethodFromComponentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!InlineMethodFromComponentTest methodsFor: 'tests' stamp: ''!
testInlineComponentMethodMax
	| refactoring |
	self proceedThroughWarning: 
			[| class |
			refactoring := InlineMethodFromComponentRefactoring 
						inline: (self convertInterval: (47 to: 58)
								for: (RefactoryTestDataApp sourceCodeAt: #inlineMax))
						inMethod: #inlineMax
						forClass: RefactoryTestDataApp.
			self setupInlineExpressionFor: refactoring toReturn: true.
			class := refactoring model classNamed: #Magnitude.
			class 
				compile: 'max: aMagnitude 
					"Answer the receiver or the argument, whichever has the greater magnitude."

					self > aMagnitude
						ifTrue: [^self]
						ifFalse: [^aMagnitude]'
				classified: #(#accessing).
			self setupImplementorToInlineFor: refactoring toReturn: class.
			self executeRefactoring: refactoring].
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #inlineMax) = (RBParser 
							parseMethod: 'inlineMax
								| x y q |
								x := 5.
								y := 10.
								q := x + 1 > y
									ifTrue: [x + 1]
									ifFalse: [y].
								^q')! !

!InlineMethodFromComponentTest methodsFor: 'tests' stamp: ''!
testModelInlineMethodWithSameVariableNames2
	| class refactoring |
	model := RBNamespace new.
	class := model classNamed: self class name.
	class compile: 'a9: a b9: b ^self + a + b' classified: #(#accessing).
	(model classNamed: #Object) 
		compile: 'foo | a b c | a := InlineMethodFromComponentTest new. b := 1. c := 2. ^c a9: b b9: a'
		classified: #(#accessing).
	self proceedThroughWarning: 
			[refactoring := InlineMethodFromComponentRefactoring 
						model: model
						inline: (72 to: 84)
						inMethod: #foo
						forClass: (model classNamed: #Object).
			self setupInlineExpressionFor: refactoring toReturn: false.
			self executeRefactoring: refactoring].
	self assert: ((refactoring model classNamed: #Object) parseTreeFor: #foo) 
				= (RBParser 
						parseMethod: 'foo | a b c | a := InlineMethodFromComponentTest new. b := 1. c := 2. ^c + b + a')! !

!InlineMethodFromComponentTest methodsFor: 'tests' stamp: ''!
testModelInlineMethodWithSameVariableNames1
	| class refactoring |
	model := RBNamespace new.
	class := model classNamed: #Rectangle.
	class 
		compile: 'rectangleRelativeTo: aRectangle ^self origin extent: aRectangle extent'
		classified: #(#accessing).
	(model classNamed: #Object) 
		compile: 'foo | aRectangle temp | aRectangle := 0@0 corner: 1@1. temp := aRectangle. ^aRectangle rectangleRelativeTo: temp'
		classified: #(#accessing).
	self proceedThroughWarning: 
			[refactoring := InlineMethodFromComponentRefactoring 
						model: model
						inline: (77 to: 112)
						inMethod: #foo
						forClass: (model classNamed: #Object).
			self setupInlineExpressionFor: refactoring toReturn: false.
			self setupImplementorToInlineFor: refactoring toReturn: class.
			self executeRefactoring: refactoring].
	self assert: ((refactoring model classNamed: #Object) parseTreeFor: #foo) 
				= (RBParser 
						parseMethod: 'foo | aRectangle temp | aRectangle := 0@0 corner: 1@1. temp := aRectangle. ^aRectangle origin extent: temp extent')! !

!InlineMethodFromComponentTest methodsFor: 'tests' stamp: ''!
testInlineComponentIntoCascadedMessage
	| refactoring |
	self proceedThroughWarning: 
			[refactoring := InlineMethodFromComponentRefactoring 
						inline: (self convertInterval: (35 to: 79)
								for: (RefactoryTestDataApp sourceCodeAt: #inlineComponent))
						inMethod: #inlineComponent
						forClass: RefactoryTestDataApp.
			(refactoring model classNamed: #Behavior) 
				compile: 'hasImmediateInstances ^self format = 0'
				classified: #(#accessing).
			self setupInlineExpressionFor: refactoring toReturn: false.
			self executeRefactoring: refactoring].
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #inlineComponent) = (RBParser 
							parseMethod: 'inlineComponent
	| a aBehavior |
	a := 5.
	aBehavior := a class.
	aBehavior superclass.
	aBehavior format = 0.
	^aBehavior yourself')! !

!InlineMethodFromComponentTest methodsFor: 'failure tests' stamp: ''!
testInlineMethodFromComponentFailure
	self shouldFail: (InlineMethodFromComponentRefactoring 
				inline: (self convertInterval: (50 to: 64)
						for: (RefactoryTestDataApp sourceCodeAt: #inlineFailed))
				inMethod: #inlineFailed
				forClass: RefactoryTestDataApp)! !

!InlineMethodFromComponentTest methodsFor: 'tests' stamp: ''!
testModelInlineMethodWithSameVariableNames
	| class refactoring |
	model := RBNamespace new.
	class := model classNamed: self class name.
	class compile: 'a9: a b9: b ^self + a + b' classified: #(#accessing).
	(model classNamed: #Object) 
		compile: 'foo | a b c | a := InlineMethodFromComponentTest new. b := 1. c := 2. ^a a9: b b9: c'
		classified: #(#accessing).
	self proceedThroughWarning: 
			[refactoring := InlineMethodFromComponentRefactoring 
						model: model
						inline: (72 to: 84)
						inMethod: #foo
						forClass: (model classNamed: #Object).
			self setupInlineExpressionFor: refactoring toReturn: false.
			self executeRefactoring: refactoring].
	self assert: ((refactoring model classNamed: #Object) parseTreeFor: #foo) 
				= (RBParser 
						parseMethod: 'foo | a b c | a := InlineMethodFromComponentTest new. b := 1. c := 2. ^a + b + c')! !

!InlineMethodFromComponentTest methodsFor: 'tests' stamp: ''!
testInlineEmptyComponentMethod
	| refactoring |
	self proceedThroughWarning: 
			[refactoring := InlineMethodFromComponentRefactoring 
						inline: (self convertInterval: (35 to: 91)
								for: (RefactoryTestDataApp sourceCodeAt: #inlineComponent))
						inMethod: #inlineComponent
						forClass: RefactoryTestDataApp.
			self setupInlineExpressionFor: refactoring toReturn: false.
			self executeRefactoring: refactoring].
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #inlineComponent) = (RBParser 
							parseMethod: 'inlineComponent
	| a anObject |
	a := 5.
	anObject := a class.
	anObject superclass.
	anObject hasImmediateInstances.
	^anObject')! !

RefactoringTest subclass: #AddMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!AddMethodTest methodsFor: 'tests' stamp: ''!
testModelAddMethod
	| refactoring class |
	class := model metaclassNamed: #Bar.
	refactoring := AddMethodRefactoring 
				model: model
				addMethod: 'printString1 ^super printString'
				toClass: class
				inProtocols: #(#accessing).
	self executeRefactoring: refactoring.
	self assert: (class parseTreeFor: #printString1) 
				= (RBParser parseMethod: 'printString1 ^super printString')! !

!AddMethodTest methodsFor: 'failure tests' stamp: ''!
testModelInheritedSelector
	| refactoring |
	refactoring := AddMethodRefactoring 
				model: model
				addMethod: 'printString ^super printString'
				toClass: (model classNamed: #Bar)
				inProtocols: #(#accessing).
	self shouldFail: refactoring! !

!AddMethodTest methodsFor: 'set up' stamp: ''!
setUp
	super setUp.
	model := Compiler evaluate: (self readFile: 'AbstractVariableTestData.st')! !

!AddMethodTest methodsFor: 'failure tests' stamp: ''!
testExistingSelector
	self shouldFail: (AddMethodRefactoring 
				addMethod: 'printString ^super printString'
				toClass: BasicLintRuleTest
				inProtocols: #(#accessing))! !

!AddMethodTest methodsFor: 'tests' stamp: ''!
testAddMethod
	| refactoring |
	refactoring := AddMethodRefactoring 
				addMethod: 'printString1 ^super printString'
				toClass: BasicLintRuleTest
				inProtocols: #(#accessing).
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model classNamed: #BasicLintRuleTest) 
				parseTreeFor: #printString1) 
					= (RBParser parseMethod: 'printString1 ^super printString')! !

!AddMethodTest methodsFor: 'failure tests' stamp: ''!
testModelExistingSelector
	| refactoring |
	refactoring := AddMethodRefactoring 
				model: model
				addMethod: 'classVarName1 ^super printString'
				toClass: (model classNamed: #Bar)
				inProtocols: #(#accessing).
	self shouldFail: refactoring! !

!AddMethodTest methodsFor: 'failure tests' stamp: ''!
testBadMethod
	self shouldFail: (AddMethodRefactoring 
				addMethod: 'asdf ^super ^printString'
				toClass: BasicLintRuleTest
				inProtocols: #(#accessing))! !

RefactoringTest subclass: #PushDownInstanceVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!PushDownInstanceVariableTest methodsFor: 'tests' stamp: 'bh 11/8/2000 14:10'!
testModelPushDownToMultipleSubclasses
	model 
		defineClass: 'Object subclass: #SomeClass instanceVariableNames: ''foo'' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	model 
		defineClass: 'SomeClass subclass: #Subclass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	(model classNamed: #Subclass) compile: 'foo ^foo' classified: #(#accessing).
	model 
		defineClass: 'SomeClass subclass: #AnotherSubclass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	(model classNamed: #AnotherSubclass) compile: 'bar ^foo'
		classified: #(#accessing).
	self executeRefactoring: (PushDownInstanceVariableRefactoring 
				model: model
				variable: 'foo'
				class: (model classNamed: #SomeClass)).
	self deny: ((model classNamed: #SomeClass) directlyDefinesVariable: 'foo').
	self 
		assert: ((model classNamed: #Subclass) directlyDefinesVariable: 'foo').
	self assert: ((model classNamed: #AnotherSubclass) 
				directlyDefinesVariable: 'foo')! !

!PushDownInstanceVariableTest methodsFor: 'tests' stamp: ''!
testPushDownInstanceVariable
	| refactoring |
	refactoring := PushDownInstanceVariableRefactoring variable: 'foo1'
				class: LintRuleTest.
	self executeRefactoring: refactoring.
	(refactoring model classNamed: #LintRuleTest) withAllSubclasses 
		do: [:each | self deny: (each directlyDefinesInstanceVariable: 'foo1')]! !

!PushDownInstanceVariableTest methodsFor: 'tests' stamp: 'bh 11/8/2000 14:10'!
testModelRemoveUnusedVariable
	model 
		defineClass: 'Object subclass: #SomeClass instanceVariableNames: ''foo'' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	model 
		defineClass: 'SomeClass subclass: #Subclass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	self executeRefactoring: (PushDownInstanceVariableRefactoring 
				model: model
				variable: 'foo'
				class: (model classNamed: #SomeClass)).
	self deny: ((model classNamed: #SomeClass) directlyDefinesVariable: 'foo').
	self deny: ((model classNamed: #Subclass) directlyDefinesVariable: 'foo')! !

!PushDownInstanceVariableTest methodsFor: 'tests' stamp: 'bh 11/8/2000 14:10'!
testModelPushDownToMetaclass
	model 
		defineClass: 'Object subclass: #SomeClass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	(model metaclassNamed: #SomeClass) addInstanceVariable: 'foo'.
	model 
		defineClass: 'SomeClass subclass: #Subclass instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: #''Refactory-Test data'''.
	(model metaclassNamed: #Subclass) compile: 'foo ^foo'
		classified: #(#accessing).
	self executeRefactoring: (PushDownInstanceVariableRefactoring 
				model: model
				variable: 'foo'
				class: (model metaclassNamed: #SomeClass)).
	self 
		deny: ((model metaclassNamed: #SomeClass) directlyDefinesVariable: 'foo').
	self 
		assert: ((model metaclassNamed: #Subclass) directlyDefinesVariable: 'foo')! !

!PushDownInstanceVariableTest methodsFor: 'failure tests' stamp: ''!
testNonExistantName
	self shouldFail: (PushDownInstanceVariableRefactoring variable: 'foo'
				class: BasicLintRuleTest)! !

RefactoringTest subclass: #RemoveClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!RemoveClassTest methodsFor: 'failure tests' stamp: ''!
testRemoveReferenced
	self 
		shouldFail: (RemoveClassRefactoring classNames: #(#BasicLintRuleTest))! !

!RemoveClassTest methodsFor: 'failure tests' stamp: ''!
testBadName
	self 
		shouldFail: (RemoveClassRefactoring classNames: #(#RecursiveSelfRule))! !

!RemoveClassTest methodsFor: 'tests' stamp: ''!
testRemoveClass
	| refactoring |
	refactoring := RemoveClassRefactoring 
				classNames: (Array with: ('Foo' , 'LintRuleTest') asSymbol).
	self executeRefactoring: refactoring.
	self 
		assert: (refactoring model classNamed: ('Foo' , 'LintRuleTest') asSymbol) 
				isNil.
	self 
		assert: (refactoring model classNamed: #TransformationRuleTest) superclass 
				= (refactoring model classNamed: #LintRuleTest)! !

RefactoringTest subclass: #AddClassVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!AddClassVariableTest methodsFor: 'set up' stamp: ''!
setUp
	super setUp.
	model := Compiler evaluate: (self readFile: 'AbstractVariableTestData.st')! !

!AddClassVariableTest methodsFor: 'tests' stamp: ''!
testAddClassVariable
	| refactoring |
	refactoring := AddClassVariableRefactoring variable: 'Asdf'
				class: TransformationRuleTest.
	self executeRefactoring: refactoring.
	self assert: ((refactoring model classNamed: #TransformationRuleTest) 
				directlyDefinesClassVariable: #Asdf)! !

!AddClassVariableTest methodsFor: 'failure tests' stamp: ''!
testAlreadyExistingName
	self
		shouldFail: (AddClassVariableRefactoring variable: #RecursiveSelfRule
					class: TransformationRuleTest);
		shouldFail: (AddClassVariableRefactoring variable: self objectClassVariable
					class: TransformationRuleTest)! !

!AddClassVariableTest methodsFor: 'failure tests' stamp: ''!
testMetaclass
	| refactoring |
	refactoring := AddClassVariableRefactoring variable: #ClassVarName3
				class: (model classNamed: #Object) metaclass.
	refactoring model: model.
	self shouldFail: refactoring! !

!AddClassVariableTest methodsFor: 'tests' stamp: ''!
testModelAddClassVariable
	| refactoring |
	refactoring := AddClassVariableRefactoring 
				model: model
				variable: #ClassVarName3
				class: (model classNamed: #Bar).
	self executeRefactoring: refactoring.
	self assert: ((model classNamed: #Bar) 
				directlyDefinesClassVariable: #ClassVarName3)! !

!AddClassVariableTest methodsFor: 'failure tests' stamp: ''!
testModelAlreadyExistingName
	| refactoring |
	refactoring := AddClassVariableRefactoring 
				model: model
				variable: #ClassVarName2
				class: (model classNamed: #Bar).
	self shouldFail: refactoring! !

!AddClassVariableTest methodsFor: 'failure tests' stamp: ''!
testModelMetaclass
	| refactoring |
	refactoring := AddClassVariableRefactoring 
				model: model
				variable: #ClassVarName3
				class: (model classNamed: #Bar) metaclass.
	self shouldFail: refactoring! !

!AddClassVariableTest methodsFor: 'failure tests' stamp: ''!
testMetaClassFailure
	self shouldFail: (AddClassVariableRefactoring variable: #VariableName
				class: TransformationRuleTest class)! !

RefactoringTest subclass: #ExtractToTemporaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!ExtractToTemporaryTest methodsFor: 'failure tests' stamp: ''!
testBadName
	self shouldFail: (ExtractToTemporaryRefactoring 
				extract: (self convertInterval: (14 to: 23)
						for: (RefactoryTestDataApp sourceCodeAt: #testMethod))
				to: 'a sdf'
				from: #testMethod
				in: RefactoryTestDataApp)! !

!ExtractToTemporaryTest methodsFor: 'failure tests' stamp: ''!
testBadInterval
	self
		shouldFail: (ExtractToTemporaryRefactoring 
					extract: (self convertInterval: (24 to: 30)
							for: (RefactoryTestDataApp sourceCodeAt: #testMethod))
					to: 'asdf'
					from: #testMethod
					in: RefactoryTestDataApp);
		shouldFail: (ExtractToTemporaryRefactoring 
					extract: (self convertInterval: (14 to: 105)
							for: (RefactoryTestDataApp sourceCodeAt: #testMethod1))
					to: 'asdf'
					from: #testMethod1
					in: RefactoryTestDataApp);
		shouldFail: (ExtractToTemporaryRefactoring 
					extract: (self convertInterval: (61 to: 101)
							for: (RefactoryTestDataApp sourceCodeAt: #noMoveDefinition))
					to: 'asdf'
					from: #noMoveDefinition
					in: RefactoryTestDataApp)! !

!ExtractToTemporaryTest methodsFor: 'tests' stamp: ''!
testExtractToTemporaryForLastStatementInBlock
	| refactoring |
	refactoring := ExtractToTemporaryRefactoring 
				extract: (self convertInterval: (52 to: 73)
						for: (RefactoryTestDataApp sourceCodeAt: #caller2))
				to: 'temp'
				from: #caller2
				in: RefactoryTestDataApp.
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #caller2) = (RBParser 
							parseMethod: 'caller2
	^(1 to: 10) inject: 1 into: [:sum :each | | temp | temp := sum * (self foo: each). temp]')! !

!ExtractToTemporaryTest methodsFor: 'tests' stamp: ''!
testExtractToTemporaryInsideBlock
	| refactoring |
	refactoring := ExtractToTemporaryRefactoring 
				extract: (self convertInterval: (133 to: 141)
						for: (RefactoryTestDataApp sourceCodeAt: #noMoveDefinition))
				to: 'asdf'
				from: #noMoveDefinition
				in: RefactoryTestDataApp.
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #noMoveDefinition) = (RBParser 
							parseMethod: 'noMoveDefinition
	| temp |
	^(self collect: 
			[:each | 
			temp := each printString.
			temp , temp]) 
		select: [:each | | asdf | asdf := each size. temp := asdf + temp]')! !

!ExtractToTemporaryTest methodsFor: 'failure tests' stamp: ''!
testNonExistantSelector
	self shouldFail: (ExtractToTemporaryRefactoring 
				extract: (14 to: 23)
				to: 'asdf'
				from: #checkClass1:
				in: RefactoryTestDataApp)! !

RefactoringTest subclass: #CreateAccessorsForVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!CreateAccessorsForVariableTest methodsFor: 'set up' stamp: ''!
setUp
	super setUp.
	model := Compiler evaluate: (self readFile: 'AbstractVariableTestData.st')! !

!CreateAccessorsForVariableTest methodsFor: 'tests' stamp: ''!
testExistingInstanceVariableAccessors
	| ref |
	ref := CreateAccessorsForVariableRefactoring 
				variable: 'name'
				class: LintRuleTest
				classVariable: false.
	self executeRefactoring: ref.
	self assert: ref changes changes isEmpty.
	self assert: ref setterMethod == #name:.
	self assert: ref getterMethod == #name! !

!CreateAccessorsForVariableTest methodsFor: 'tests' stamp: ''!
testNewInstanceVariableAccessors
	| ref class |
	ref := CreateAccessorsForVariableRefactoring 
				variable: 'foo1'
				class: LintRuleTest
				classVariable: false.
	self executeRefactoring: ref.
	class := ref model classNamed: #LintRuleTest.
	self deny: ref changes changes isEmpty.
	self assert: ref setterMethod == #foo1:.
	self assert: ref getterMethod == #foo1.
	self 
		assert: (class parseTreeFor: #foo1) = (RBParser parseMethod: 'foo1 ^foo1').
	self assert: (class parseTreeFor: #foo1:) 
				= (RBParser parseMethod: 'foo1: anObject foo1 := anObject')! !

!CreateAccessorsForVariableTest methodsFor: 'tests' stamp: ''!
testNewClassVariableAccessors
	| ref class |
	ref := CreateAccessorsForVariableRefactoring 
				variable: 'Foo1'
				class: LintRuleTest
				classVariable: true.
	self executeRefactoring: ref.
	class := ref model metaclassNamed: #LintRuleTest.
	self deny: ref changes changes isEmpty.
	self assert: ref setterMethod == #foo1:.
	self assert: ref getterMethod == #foo1.
	self 
		assert: (class parseTreeFor: #foo1) = (RBParser parseMethod: 'foo1 ^Foo1').
	self assert: (class parseTreeFor: #foo1:) 
				= (RBParser parseMethod: 'foo1: anObject Foo1 := anObject')! !

!CreateAccessorsForVariableTest methodsFor: 'failure tests' stamp: ''!
testNonExistantName
	self
		shouldFail: (CreateAccessorsForVariableRefactoring 
					variable: #Foo
					class: BasicLintRuleTest
					classVariable: true);
		shouldFail: (CreateAccessorsForVariableRefactoring 
					variable: 'foo'
					class: BasicLintRuleTest
					classVariable: true)! !

RefactoringTest subclass: #MoveVariableDefinitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!MoveVariableDefinitionTest methodsFor: 'tests' stamp: ''!
testMoveDefinition
	| refactoring |
	refactoring := MoveVariableDefinitionRefactoring 
				bindTight: (self convertInterval: (19 to: 22)
						for: (RefactoryTestDataApp sourceCodeAt: #moveDefinition))
				in: RefactoryTestDataApp
				selector: #moveDefinition.
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #moveDefinition) = (RBParser 
							parseMethod: 'moveDefinition
								^(self collect: 
										[:each | 
										| temp |
										temp := each printString.
										temp , temp]) 
									select: 
										[:each | 
										| temp |
										temp := each size.
										temp odd]')! !

!MoveVariableDefinitionTest methodsFor: 'tests' stamp: ''!
testNoMoveDefinition
	self shouldFail: (MoveVariableDefinitionRefactoring 
				bindTight: (self convertInterval: (21 to: 24)
						for: (RefactoryTestDataApp sourceCodeAt: #moveDefinition))
				in: RefactoryTestDataApp
				selector: #noMoveDefinition)! !

!MoveVariableDefinitionTest methodsFor: 'tests' stamp: ''!
testMoveDefinitionIntoBlockThatIsAReceiverOfACascadedMessage
	| refactoring |
	refactoring := MoveVariableDefinitionRefactoring 
				bindTight: (self convertInterval: (48 to: 58)
						for: (RefactoryTestDataApp sourceCodeAt: #referencesConditionFor:))
				in: RefactoryTestDataApp
				selector: #referencesConditionFor:.
	self executeRefactoring: refactoring.
	self 
		assert: ((refactoring model classNamed: #RefactoryTestDataApp) 
				parseTreeFor: #referencesConditionFor:) = (RBParser 
							parseMethod: 'referencesConditionFor: aClass 
								| environment  |
								^(RBCondition withBlock: 
										[| association |association := Smalltalk associationAt: aClass name
													ifAbsent: [self refactoringError: ''Could not find class''].
										environment := (self environment referencesTo: association) 
													| (self environment referencesTo: aClass name).
										environment isEmpty])
									errorMacro: aClass , '' is referenced.<n>Browse references?'';
									errorBlock: [environment openEditor];
									yourself')! !

!MoveVariableDefinitionTest methodsFor: 'tests' stamp: ''!
testNonExistantName
	self
		shouldFail: (MoveVariableDefinitionRefactoring 
					bindTight: (1 to: 10)
					in: LintRuleTest
					selector: #name1);
		shouldFail: (MoveVariableDefinitionRefactoring 
					bindTight: (self convertInterval: (44 to: 54)
							for: (LintRuleTest sourceCodeAt: #displayName))
					in: LintRuleTest
					selector: #displayName);
		shouldFail: (MoveVariableDefinitionRefactoring 
					bindTight: (self convertInterval: (16 to: 25)
							for: (LintRuleTest sourceCodeAt: #displayName))
					in: LintRuleTest
					selector: #displayName)! !

!RefactoringTest methodsFor: 'tests' stamp: ''!
testPrintRefactoringManager
	Transcript
		show: RefactoringManager instance printString;
		cr;
		flush! !

RefactoringTest subclass: #ProtectInstanceVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!ProtectInstanceVariableTest methodsFor: 'tests' stamp: ''!
testProtectInstanceVariable
	| refactoring class |
	refactoring := ProtectInstanceVariableRefactoring 
				variable: 'rewrite' , 'Rule1'
				class: SubclassOfClassToRename.
	self executeRefactoring: refactoring.
	class := refactoring model classNamed: #SubclassOfClassToRename.
	self 
		assert: (class parseTreeFor: #calls1) = (RBParser 
						parseMethod: 'calls1
								^rewriteRule1 := (rewriteRule1 := self calls)').
	self 
		assert: (class parseTreeFor: #calls) = (RBParser 
						parseMethod: 'calls
								^rewriteRule1 := rewriteRule1 , rewriteRule1').
	self deny: (class directlyDefinesMethod: ('rewrite' , 'Rule1') asSymbol).
	self deny: (class directlyDefinesMethod: ('rewrite' , 'Rule1:') asSymbol)! !

!ProtectInstanceVariableTest methodsFor: 'failure tests' stamp: 'bh 4/29/2000 21:33'!
testVariableNotDefined
	| refactoring |
	refactoring _ ProtectInstanceVariableRefactoring variable: 'rewrite' class: SubclassOfClassToRename.
	self shouldFail: refactoring.
! !

RefactoringTest subclass: #MoveMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!MoveMethodTest methodsFor: 'tests' stamp: ''!
testMoveMethodIntoArgument
	| refactoring class |
	self proceedThroughWarning: 
			[refactoring := MoveMethodRefactoring 
						selector: #checkMethod:
						class: TransformationRuleTest
						variable: 'aSmalllintContext'.
			self setupSelfArgumentNameFor: refactoring toReturn: 'transformationRule'.
			self setupVariableTypesFor: refactoring
				toReturn: (Array with: (refactoring model classNamed: #SmalllintContext)).
			self setupMethodNameFor: refactoring toReturn: #foo:.
			self executeRefactoring: refactoring].
	class := refactoring model classNamed: #TransformationRuleTest.
	self 
		assert: (class parseTreeFor: #checkMethod:) = (RBParser 
						parseMethod: 'checkMethod: aSmalllintContext aSmalllintContext foo: self').
	self 
		assert: ((refactoring model classNamed: #SmalllintContext) 
				parseTreeFor: #foo:) = (RBParser 
							parseMethod: 'foo: transformationRule
	transformationRule class: self selectedClass.
	(transformationRule rewriteRule executeTree: self parseTree) ifTrue: 
			[(transformationRule class recursiveSelfRule executeTree: transformationRule rewriteRule tree initialAnswer: false)
				ifFalse: 
					[transformationRule builder compile: transformationRule rewriteRule tree printString
						in: transformationRule class1
						classified: self protocols]]').
	self assert: (class parseTreeFor: #class1) 
				= (RBParser parseMethod: 'class1 ^class').
	self assert: (class parseTreeFor: #class:) 
				= (RBParser parseMethod: 'class: anObject class := anObject').
	self 
		assert: (class metaclass parseTreeFor: #recursiveSelfRule:) = (RBParser 
						parseMethod: 'recursiveSelfRule: anObject RecursiveSelfRule := anObject').
	self assert: (class metaclass parseTreeFor: #recursiveSelfRule) 
				= (RBParser parseMethod: 'recursiveSelfRule ^RecursiveSelfRule').
	self assert: (class parseTreeFor: #builder) 
				= (RBParser parseMethod: 'builder ^builder').
	self assert: (class parseTreeFor: #builder:) 
				= (RBParser parseMethod: 'builder: anObject builder := anObject').
	self assert: (class parseTreeFor: #rewriteRule) 
				= (RBParser parseMethod: 'rewriteRule ^rewriteRule').
	self assert: (class parseTreeFor: #rewriteRule:) 
				= (RBParser parseMethod: 'rewriteRule: anObject rewriteRule := anObject')! !

!MoveMethodTest methodsFor: 'failure tests' stamp: ''!
testMovePrimitiveMethod
	| refactoring |
	(model classNamed: #Object) 
		compile: 'foo <primitive: 100> ^#() primitiveFailed'
		classified: #(#accessing).
	refactoring := MoveMethodRefactoring 
				model: model
				selector: #foo
				class: Object
				variable: 'OrderedCollection'.
	self shouldFail: refactoring! !

!MoveMethodTest methodsFor: 'tests' stamp: 'bh 5/1/2000 00:09'!
testMoveMethodThatReferencesPoolDictionary
	| refactoring class |
	self
		proceedThroughWarning: 
			[refactoring _ MoveMethodRefactoring
						selector: #junk
						class: LintRuleTest
						variable: 'RefactoryTestDataApp'.
			self setupSelfArgumentNameFor: refactoring toReturn: 'transformationRule'.
			self setupVariableTypesFor: refactoring toReturn: (Array with: (refactoring model classNamed: 'RefactoryTestDataApp class' asSymbol)).
			self setupMethodNameFor: refactoring toReturn: #junk1.
			self executeRefactoring: refactoring].
	class _ refactoring model classNamed: #LintRuleTest.
	self assert: (class parseTreeFor: #junk)
			= (RBParser parseMethod: 'junk ^RefactoryTestDataApp junk1').
	self assert: ((refactoring model metaclassNamed: #RefactoryTestDataApp)
			parseTreeFor: #junk1)
			= (RBParser parseMethod: 'junk1
	^self printString copyFrom: 1 to: CR').
	self assert: (class directlyDefinesPoolDictionary: 'TextConstants' asSymbol)! !

!MoveMethodTest methodsFor: 'tests' stamp: ''!
testMoveMethodIntoClassVariable
	| refactoring class |
	self proceedThroughWarning: 
			[refactoring := MoveMethodRefactoring 
						selector: #checkMethod:
						class: TransformationRuleTest
						variable: 'RecursiveSelfRule'.
			self setupSelfArgumentNameFor: refactoring toReturn: 'transformationRule'.
			self setupVariableTypesFor: refactoring
				toReturn: (Array with: (refactoring model classNamed: #ParseTreeSearcher)).
			self 
				setupMethodNameFor: refactoring
				toReturn: #foo:foo:
				withArguments: #('transformationRule' 'aSmalllintContext').
			self executeRefactoring: refactoring].
	class := refactoring model classNamed: #TransformationRuleTest.
	self 
		assert: (class parseTreeFor: #checkMethod:) = (RBParser 
						parseMethod: 'checkMethod: aSmalllintContext RecursiveSelfRule foo: self foo: aSmalllintContext').
	self 
		assert: ((refactoring model classNamed: #ParseTreeSearcher) 
				parseTreeFor: #foo:foo:) = (RBParser 
							parseMethod: 'foo: transformationRule foo: aSmalllintContext
	transformationRule class: aSmalllintContext selectedClass.
	(transformationRule rewriteRule executeTree: aSmalllintContext parseTree) ifTrue: 
			[(self executeTree: transformationRule rewriteRule tree initialAnswer: false)
				ifFalse: 
					[transformationRule builder compile: transformationRule rewriteRule tree printString
						in: transformationRule class1
						classified: aSmalllintContext protocols]]').
	self assert: (class parseTreeFor: #class1) 
				= (RBParser parseMethod: 'class1 ^class').
	self assert: (class parseTreeFor: #class:) 
				= (RBParser parseMethod: 'class: anObject class := anObject').
	self assert: (class parseTreeFor: #builder) 
				= (RBParser parseMethod: 'builder ^builder').
	self assert: (class parseTreeFor: #builder:) 
				= (RBParser parseMethod: 'builder: anObject builder := anObject').
	self assert: (class parseTreeFor: #rewriteRule) 
				= (RBParser parseMethod: 'rewriteRule ^rewriteRule').
	self assert: (class parseTreeFor: #rewriteRule:) 
				= (RBParser parseMethod: 'rewriteRule: anObject rewriteRule := anObject')! !

!MoveMethodTest methodsFor: 'tests' stamp: ''!
testMoveMethodIntoInstanceVariable
	| refactoring class |
	self proceedThroughWarning: 
			[refactoring := MoveMethodRefactoring 
						selector: #checkMethod:
						class: TransformationRuleTest
						variable: 'rewriteRule'.
			self setupSelfArgumentNameFor: refactoring toReturn: 'transformationRule'.
			self setupVariableTypesFor: refactoring
				toReturn: (Array with: (refactoring model classNamed: #ParseTreeRewriter)).
			self 
				setupMethodNameFor: refactoring
				toReturn: #foo:foo:
				withArguments: #('transformationRule' 'aSmalllintContext').
			self executeRefactoring: refactoring].
	class := refactoring model classNamed: #TransformationRuleTest.
	self 
		assert: (class parseTreeFor: #checkMethod:) = (RBParser 
						parseMethod: 'checkMethod: aSmalllintContext rewriteRule foo: self foo: aSmalllintContext').
	self 
		assert: ((refactoring model classNamed: #ParseTreeRewriter) 
				parseTreeFor: #foo:foo:) = (RBParser 
							parseMethod: 'foo: transformationRule foo: aSmalllintContext
	transformationRule class: aSmalllintContext selectedClass.
	(self executeTree: aSmalllintContext parseTree) ifTrue: 
			[(transformationRule class recursiveSelfRule executeTree: self tree initialAnswer: false)
				ifFalse: 
					[transformationRule builder compile: self tree printString
						in: transformationRule class1
						classified: aSmalllintContext protocols]]').
	self assert: (class parseTreeFor: #class1) 
				= (RBParser parseMethod: 'class1 ^class').
	self assert: (class parseTreeFor: #class:) 
				= (RBParser parseMethod: 'class: anObject class := anObject').
	self 
		assert: (class metaclass parseTreeFor: #recursiveSelfRule:) = (RBParser 
						parseMethod: 'recursiveSelfRule: anObject RecursiveSelfRule := anObject').
	self assert: (class metaclass parseTreeFor: #recursiveSelfRule) 
				= (RBParser parseMethod: 'recursiveSelfRule ^RecursiveSelfRule').
	self assert: (class parseTreeFor: #builder) 
				= (RBParser parseMethod: 'builder ^builder').
	self assert: (class parseTreeFor: #builder:) 
				= (RBParser parseMethod: 'builder: anObject builder := anObject')! !

RefactoringTest subclass: #AddInstanceVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!AddInstanceVariableTest methodsFor: 'failure tests' stamp: 'bh 11/8/2000 14:07'!
testNewExistingName
	| refactoring |
	model := RBNamespace new.
	model name: 'Add instance variable'.
	model 
		defineClass: 'Object subclass: #FOOBAR 
				instanceVariableNames: ''asdf'' 	
				classVariableNames: ''''
				poolDictionaries: ''''
				category: #''Refactory-Test data'''.
	refactoring := AddInstanceVariableRefactoring 
				model: model
				variable: 'asdf'
				class: (model classNamed: #FOOBAR).
	self shouldFail: refactoring! !

!AddInstanceVariableTest methodsFor: 'tests' stamp: 'bh 11/8/2000 14:07'!
testAddToModel
	| refactoring |
	model := RBNamespace new.
	model name: 'Add instance variable'.
	model 
		defineClass: 'Object subclass: #FOOBAR 
				instanceVariableNames: ''fdsa'' 	
				classVariableNames: ''''
				poolDictionaries: ''''
				category: #''Refactory-Test data'''.
	refactoring := AddInstanceVariableRefactoring 
				model: model
				variable: 'asdf'
				class: (model classNamed: #FOOBAR).
	self executeRefactoring: refactoring.
	self assert: ((refactoring model classNamed: #FOOBAR) 
				directlyDefinesInstanceVariable: 'asdf')! !

!AddInstanceVariableTest methodsFor: 'failure tests' stamp: 'bh 11/8/2000 14:07'!
testNewHierarchyExistingName
	| refactoring |
	model := RBNamespace new.
	model name: 'Add instance variable'.
	model 
		defineClass: 'Object subclass: #FOOBAR 
				instanceVariableNames: ''asdf'' 	
				classVariableNames: ''''
				poolDictionaries: ''''
				category: #''Refactory-Test data'''.
	model 
		defineClass: 'FOOBAR subclass: #BARFOO 
				instanceVariableNames: '''' 	
				classVariableNames: ''''
				poolDictionaries: ''''
				category: ''Refactory-Test data'''.
	refactoring := AddInstanceVariableRefactoring 
				model: model
				variable: 'asdf'
				class: (model classNamed: #BARFOO).
	self shouldFail: refactoring! !

!AddInstanceVariableTest methodsFor: 'set up' stamp: ''!
setUp
	super setUp.
	model := Compiler evaluate: (self readFile: 'AbstractVariableTestData.st')! !

!AddInstanceVariableTest methodsFor: 'failure tests' stamp: ''!
testModelAlreadyExistingName
	| refactoring |
	refactoring := AddInstanceVariableRefactoring 
				model: model
				variable: 'instVarName1'
				class: (model classNamed: #Bar).
	self shouldFail: refactoring! !

!AddInstanceVariableTest methodsFor: 'failure tests' stamp: ''!
testAlreadyExistingName
	self
		shouldFail: (AddInstanceVariableRefactoring variable: 'class'
					class: TransformationRuleTest);
		shouldFail: (AddInstanceVariableRefactoring variable: 'name'
					class: TransformationRuleTest)! !

!AddInstanceVariableTest methodsFor: 'tests' stamp: ''!
testAddInstanceVariable
	| refactoring |
	refactoring := AddInstanceVariableRefactoring variable: 'asdf'
				class: TransformationRuleTest.
	self executeRefactoring: refactoring.
	self assert: ((refactoring model classNamed: #TransformationRuleTest) 
				directlyDefinesInstanceVariable: 'asdf')! !

!AddInstanceVariableTest methodsFor: 'failure tests' stamp: ''!
testModelMetaclassAlreadyExistingName
	| refactoring |
	(model metaclassNamed: #Foo) addInstanceVariable: 'instVarName1'.
	refactoring := AddInstanceVariableRefactoring 
				model: model
				variable: 'instVarName1'
				class: (model classNamed: #Bar).
	self shouldFail: refactoring! !

RefactoringBrowserTest subclass: #BrowserEnvironmentTest
	instanceVariableNames: 'browser universalEnvironment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!BrowserEnvironmentTest methodsFor: 'BrowserEnvironment tests' stamp: ''!
testSelectorEnvironment
	| printString |
	printString := BrowserEnvironment new referencesTo: #printString.
	self universalTestFor: printString.
	self assert: printString numberSelectors 
				= (printString referencesTo: #printString) numberSelectors.
	self assert: printString numberClasses 
				= (printString referencesTo: #printString) numberClasses! !

!BrowserEnvironmentTest methodsFor: 'universal tests' stamp: ''!
copyFor: aBrowserEnvironment 
	| newEnvironment |
	newEnvironment := aBrowserEnvironment copy.
	self assert: newEnvironment numberSelectors 
				= aBrowserEnvironment numberSelectors.
	self 
		assert: (newEnvironment not & aBrowserEnvironment) numberSelectors = 0! !

!BrowserEnvironmentTest methodsFor: 'set up' stamp: ''!
setUp
	super setUp.
	universalEnvironment := BrowserEnvironment new! !

!BrowserEnvironmentTest methodsFor: 'BrowserEnvironment tests' stamp: ''!
testMatches
	| envEnvironment environmentEnvironment |
	envEnvironment := BrowserEnvironment new matches: '*env*'.
	environmentEnvironment := BrowserEnvironment new 
				referencesTo: #environment.
	self assert: (envEnvironment referencesTo: #environment) numberSelectors 
				= environmentEnvironment numberSelectors! !

!BrowserEnvironmentTest methodsFor: 'BrowserEnvironment tests' stamp: 'dvf 8/27/2003 15:02'!
testAllClassesDo
	| allClasses aBrowserEnvironment |
	aBrowserEnvironment := BrowserEnvironment new.
	allClasses := Set new.
	aBrowserEnvironment classesDo: [:each | allClasses add: each].
	SystemNavigation new allBehaviorsDo: [:each | allClasses remove: each].
	self assert: allClasses isEmpty! !

!BrowserEnvironmentTest methodsFor: 'BrowserEnvironment tests' stamp: ''!
testCategoryEnvironment
	| aCategoryEnvironment |
	aCategoryEnvironment := CategoryEnvironment 
				onEnvironment: BrowserEnvironment new
				categories: #(#'Kernel-Objects').
	self universalTestFor: aCategoryEnvironment.
	self assert: (aCategoryEnvironment implementorsOf: #printString) numberSelectors = 1! !

!BrowserEnvironmentTest methodsFor: 'AndEnvironment tests' stamp: 'bh 4/10/2001 16:29'!
testAndEnvironment
	| originalEnvironment objectPrintStringEnvironment andEnvironment |
	originalEnvironment := universalEnvironment referencesTo: #printOn:.
	objectPrintStringEnvironment := universalEnvironment forClass: Object
				selectors: #(#fullPrintString).
	andEnvironment := objectPrintStringEnvironment & originalEnvironment.
	self universalTestFor: andEnvironment.
	self assert: andEnvironment numberSelectors = 1.
	self assert: andEnvironment classNames asArray = #(#Object).
	self assert: (andEnvironment protocolsFor: Object) size = 1.
	andEnvironment := originalEnvironment 
				& (universalEnvironment referencesTo: #printString).
	self assert: andEnvironment numberSelectors 
				= (originalEnvironment referencesTo: #printString) numberSelectors.
	self assert: andEnvironment classNames asSortedCollection 
				= (originalEnvironment referencesTo: #printString) classNames 
						asSortedCollection! !

!BrowserEnvironmentTest methodsFor: 'universal tests' stamp: ''!
numberSelectorsFor: aBrowserEnvironment 
	self 
		assert: aBrowserEnvironment numberSelectors 
				+ aBrowserEnvironment not numberSelectors 
					= BrowserEnvironment new numberSelectors.
	self 
		assert: (aBrowserEnvironment & aBrowserEnvironment not) numberSelectors = 0.
	self assert: (universalEnvironment & aBrowserEnvironment) numberSelectors 
				= aBrowserEnvironment numberSelectors.
	self assert: (aBrowserEnvironment & universalEnvironment) numberSelectors 
				= aBrowserEnvironment numberSelectors! !

!BrowserEnvironmentTest methodsFor: 'BrowserEnvironment tests' stamp: ''!
classesFor: aBrowserEnvironment 
	| allClasses |
	allClasses := aBrowserEnvironment classes asSet.
	allClasses addAll: aBrowserEnvironment not classes.
	BrowserEnvironment new classesDo: [:each | allClasses remove: each].
	self assert: allClasses isEmpty! !

!BrowserEnvironmentTest methodsFor: 'BrowserEnvironment tests' stamp: ''!
testConstructedClassEnvironment
	| environment |
	environment := ClassEnvironment new.
	environment
		addClass: Object;
		addClass: OrderedCollection;
		addClass: Collection.
	self assert: (environment includesClass: Object).
	self assert: (environment includesClass: OrderedCollection).
	self assert: (environment includesClass: Collection).
	self deny: (environment includesClass: Object class).
	environment removeClass: Collection.
	self assert: (environment includesClass: Object).
	self assert: (environment includesClass: OrderedCollection).
	self deny: (environment includesClass: Collection).
	self assert: environment numberClasses = 2.
	environment addClass: Object class.
	self assert: environment numberClasses = 2.
	self assert: (environment includesClass: Object class).
	environment removeClass: self class.
	self assert: environment numberClasses = 2! !

!BrowserEnvironmentTest methodsFor: 'universal tests' stamp: ''!
universalTestFor: aBrowserEnvironment 
	self uniqueClassesIn: aBrowserEnvironment.
	self numberSelectorsFor: aBrowserEnvironment.
	self storeStringFor: aBrowserEnvironment.
	self classNamesFor: aBrowserEnvironment.
	self copyFor: aBrowserEnvironment.
	self categoriesFor: aBrowserEnvironment.
	self classesFor: aBrowserEnvironment.
	self keysFor: aBrowserEnvironment.
	self 
		assert: aBrowserEnvironment problemCount = 0 = aBrowserEnvironment isEmpty! !

!BrowserEnvironmentTest methodsFor: 'NotEnvironment tests' stamp: 'dvf 9/19/2001 20:41'!
testNotEnvironment
	| notPrintStringEnvironment printStringEnvironment |
	printStringEnvironment := universalEnvironment referencesTo: #printString.
	notPrintStringEnvironment := printStringEnvironment not.
	self universalTestFor: notPrintStringEnvironment.
	self 
		assert: (notPrintStringEnvironment referencesTo: #printString) isEmpty.
	self assert: (notPrintStringEnvironment not includesClass: BrowserEnvironmentTest).
	self assert: (notPrintStringEnvironment not 
				includesSelector: #testNotEnvironment
				in: BrowserEnvironmentTest)! !

!BrowserEnvironmentTest methodsFor: 'BrowserEnvironment tests' stamp: ''!
classNamesFor: anEnvironment 
	| classNames |
	classNames := (anEnvironment classNames asSet)
				addAll: anEnvironment not classNames;
				yourself.
	self assert: classNames asSortedCollection 
				= BrowserEnvironment new classNames asSortedCollection.
	self assert: (anEnvironment & anEnvironment not) classNames isEmpty.
	self 
		assert: (anEnvironment | anEnvironment not) classNames asSortedCollection 
				= BrowserEnvironment new classNames asSortedCollection! !

!BrowserEnvironmentTest methodsFor: 'OrEnvironment tests' stamp: 'bh 9/17/2001 02:02'!
testOrEnvironment
	| env1 env2 orEnvironment |
	self needsWork. "the following line is temporary, to help a SUnit test pass.  Literal strings withing literal arrays don't show up as references for some reason."
	env2 := #printOn:.
	env2 := universalEnvironment forClass: Object selectors: #(#fullPrintString).
	env1 := universalEnvironment forClass: Object selectors: #(#printOn:).
	self assert: (env1 | env2) numberSelectors = 2.
	self assert: (env2 | env1) numberSelectors = 2.
	self universalTestFor: env1 | env2.
	self assert: (env1 | env1) numberSelectors = 1.
	orEnvironment := env1 | env1 not.
	self universalTestFor: orEnvironment.
	self assert: orEnvironment numberSelectors 
				= universalEnvironment numberSelectors.
	self assert: orEnvironment classNames asSortedCollection 
				= universalEnvironment classNames asSortedCollection.
	self assert: (orEnvironment protocolsFor: Object) 
				= ((universalEnvironment protocolsFor: Object) reject: [:each| (Object allMethodsInCategory: each) isEmpty ])
! !

!BrowserEnvironmentTest methodsFor: 'BrowserEnvironment tests' stamp: ''!
testBrowserEnvironment
	self universalTestFor: BrowserEnvironment new! !

!BrowserEnvironmentTest methodsFor: 'BrowserEnvironment tests' stamp: ''!
testImplementorsMatching
	| print |
	print := BrowserEnvironment new implementorsMatching: '*print*'.
	self universalTestFor: print.
	self assert: (print implementorsOf: #printString) numberSelectors 
				= (BrowserEnvironment new implementorsOf: #printString) numberSelectors.
	print 
		classesAndSelectorsDo: [:class :sel | self assert: ('*print*' match: sel)]! !

!BrowserEnvironmentTest methodsFor: 'universal tests' stamp: ''!
categoriesFor: anEnvironment 
	| allCategories |
	allCategories := Set withAll: BrowserEnvironment new categories.
	allCategories removeAll: anEnvironment categories.
	anEnvironment not categories 
		do: [:each | allCategories remove: each ifAbsent: []].
	allCategories 
		do: [:each | self assert: (BrowserEnvironment new classNamesFor: each) isEmpty]! !

!BrowserEnvironmentTest methodsFor: 'BrowserEnvironment tests' stamp: ''!
testEnvironmentWrapper
	| printString wrapper |
	printString := BrowserEnvironment new referencesTo: #printString.
	wrapper := BrowserEnvironmentWrapper onEnvironment: printString.
	self assert: wrapper numberSelectors = printString numberSelectors.
	self assert: wrapper numberClasses = printString numberClasses.
	self assert: wrapper environment == printString! !

!BrowserEnvironmentTest methodsFor: 'BrowserEnvironment tests' stamp: ''!
testSelectMethods
	| environment |
	environment := BrowserEnvironment new selectMethods: [:each | false].
	self assert: environment numberSelectors = 0.
	self assert: environment numberClasses = 0.
	environment := BrowserEnvironment new selectMethods: [:each | true].
	self assert: environment numberSelectors 
				= BrowserEnvironment new numberSelectors.
	environment := BrowserEnvironment new 
				selectMethods: [:each | each refersToLiteral: #environment].
	self assert: environment numberSelectors 
				= (BrowserEnvironment new referencesTo: #environment) numberSelectors! !

!BrowserEnvironmentTest methodsFor: 'BrowserEnvironment tests' stamp: ''!
testRemoveSelectorByAndAndNot
	| aBrowserEnvironment objectPrintString |
	aBrowserEnvironment := BrowserEnvironment new.
	objectPrintString := SelectorEnvironment 
				onEnvironment: aBrowserEnvironment.
	objectPrintString addClass: Object selector: #printString.
	self assert: aBrowserEnvironment numberSelectors - 1 
				= (aBrowserEnvironment & objectPrintString not) numberSelectors.
	self universalTestFor: aBrowserEnvironment & objectPrintString not! !

BrowserEnvironmentTest subclass: #VariableEnvironmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!VariableEnvironmentTest methodsFor: 'tests' stamp: ''!
testAddRemove
	| refs |
	refs := VariableEnvironment new.
	refs addClass: RefactoringManager instanceVariable: 'refactorings'.
	self assert: refs numberSelectors > 0.
	self assert: refs numberClasses = 1.
	refs removeClass: RefactoringManager instanceVariable: 'refactorings'.
	self assert: refs numberSelectors = 0.
	self assert: refs numberClasses = 0.
	refs addClass: RefactoringManager instanceVariableReader: 'refactorings'.
	self assert: refs numberSelectors > 0.
	self assert: refs numberClasses = 1.
	refs removeClass: RefactoringManager instanceVariableReader: 'refactorings'.
	self assert: refs numberSelectors = 0.
	self assert: refs numberClasses = 0.
	refs addClass: RefactoringManager instanceVariableWriter: 'refactorings'.
	self assert: refs numberSelectors > 0.
	self assert: refs numberClasses = 1.
	refs removeClass: RefactoringManager instanceVariableWriter: 'refactorings'.
	self assert: refs numberSelectors = 0.
	self assert: refs numberClasses = 0! !

!VariableEnvironmentTest methodsFor: 'tests' stamp: ''!
testInstVars
	| refs writers readers |
	refs := VariableEnvironment referencesToInstanceVariable: 'refactorings'
				in: RefactoringManager.
	writers := VariableEnvironment writersOfInstanceVariable: 'refactorings'
				in: RefactoringManager.
	readers := VariableEnvironment readersOfInstanceVariable: 'refactorings'
				in: RefactoringManager.
	self universalTestFor: refs.
	self universalTestFor: writers.
	self universalTestFor: readers.
	self assert: refs numberSelectors = (writers | readers) numberSelectors! !

!BrowserEnvironmentTest methodsFor: 'universal tests' stamp: ''!
storeStringFor: aBrowserEnvironment
	| newEnvironment |
	newEnvironment := Compiler evaluate: aBrowserEnvironment storeString.
	self assert: newEnvironment numberSelectors = aBrowserEnvironment numberSelectors.
	self assert: (newEnvironment not & aBrowserEnvironment) numberSelectors = 0
	! !

!BrowserEnvironmentTest methodsFor: 'universal tests' stamp: ''!
keysFor: aBrowserEnvironment 
	| allKeys |
	allKeys := Set withAll: aBrowserEnvironment keys.
	allKeys addAll: aBrowserEnvironment not keys.
	allKeys removeAll: Smalltalk keys.
	self assert: allKeys isEmpty! !

!BrowserEnvironmentTest methodsFor: 'universal tests' stamp: ''!
uniqueClassesIn: aBrowserEnvironment 
	| allClasses |
	allClasses := Set new.
	aBrowserEnvironment 
		classesDo: [:each | self deny: (allClasses includes: each)]! !

!BrowserEnvironmentTest methodsFor: 'BrowserEnvironment tests' stamp: ''!
testProtocolEnvironment
	| aProtocolEnvironment size |
	aProtocolEnvironment := ProtocolEnvironment 
				onEnvironment: BrowserEnvironment new
				class: Object
				protocols: #(#printing #testing).
	self universalTestFor: aProtocolEnvironment.
	self 
		assert: (aProtocolEnvironment implementorsOf: #printString) numberSelectors 
				= 1.
	size := 0.
	aProtocolEnvironment classesDo: [:each | size := size + 1].
	self assert: size = 1.
	aProtocolEnvironment selectorsForClass: Object
		do: 
			[:each | 
			self assert: (#(#printing #testing) 
						includes: (BrowserEnvironment new whichProtocolIncludes: each in: Object))]! !

!BrowserEnvironmentTest methodsFor: 'BrowserEnvironment tests' stamp: ''!
testClassEnvironment
	| aClassEnvironment |
	aClassEnvironment := ClassEnvironment 
				onEnvironment: BrowserEnvironment new
				classes: (Array with: Object with: Object class).
	self universalTestFor: aClassEnvironment.
	self assert: (aClassEnvironment implementorsOf: #printString) numberSelectors = 1! !

!BrowserEnvironmentTest methodsFor: 'BrowserEnvironment tests' stamp: ''!
testConstructedSelectorEnvironment
	| environment newEnvironment |
	environment := SelectorEnvironment new.
	environment
		addClass: Object selector: #printString;
		addClass: OrderedCollection selector: #add:;
		addClass: Collection.
	self assert: (environment includesClass: Object).
	self assert: (environment selectorsForClass: Object) size = 1.
	self assert: (environment includesClass: OrderedCollection).
	self assert: (environment selectorsForClass: OrderedCollection) size = 1.
	self assert: (environment includesClass: Collection).
	self assert: (environment selectorsForClass: Collection) size 
				= Collection selectors size.
	self deny: (environment includesClass: Object class).
	newEnvironment := environment copy.
	newEnvironment
		removeClass: OrderedCollection;
		addClass: Object selector: #printOn:;
		removeClass: Object selector: #printString.
	self assert: (newEnvironment includesClass: Object).
	self deny: (newEnvironment includesSelector: #printString in: Object).
	self deny: (newEnvironment includesClass: OrderedCollection).
	self assert: (newEnvironment includesClass: Collection).
	self assert: newEnvironment numberClasses = 2.
	self 
		assert: newEnvironment numberSelectors + 1 = environment numberSelectors.
	newEnvironment addClass: Object class.
	self assert: newEnvironment numberClasses = 2.
	self assert: (newEnvironment includesClass: Object class).
	newEnvironment removeClass: self class.
	self assert: newEnvironment numberClasses = 2! !

RefactoringBrowserTest subclass: #VariableTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!VariableTypeTest methodsFor: 'tests' stamp: 'bh 4/4/2000 09:32'!
testCompositeLintRuleTypes
	| typer types |
	typer := RefactoryTyper new runOn: CompositeLintRuleTest.
	types := typer guessTypesFor: 'rules'.
	self assert: types size = 1.
	self assert: (types includes: (typer model classFor: Collection)).
	types := typer typesFor: '-rules-'.
	self assert: types size = 2.
	self assert: (types includes: (typer model classFor: LintRule)).
	self assert: (types includes: (typer model classFor: LintRuleTest)).
	self assert: (typer guessTypesFor: 'asdf') isEmpty.
	typer printString! !

!VariableTypeTest methodsFor: 'tests' stamp: ''!
testLintRuleTypes
	| typer types |
	typer := RefactoryTyper new.
	types := typer guessTypesFor: 'name' in: LintRuleTest.
	self assert: types size = 1.
	self assert: (types includes: (typer model classFor: String))! !

!VariableTypeTest methodsFor: 'tests' stamp: ''!
testParseTreeTypes
	| types model |
	model := RBNamespace new.
	types := RefactoryTyper 
				typesFor: 'foo'
				in: (RBParser 
						parseExpression: 'foo printString; testBasicLintRuleTypes; testParseTreeTypes')
				model: model.
	self assert: types size = 1.
	self assert: (types includes: (model classFor: self class))! !

!VariableTypeTest methodsFor: 'tests' stamp: ''!
testBasicLintRuleTypes
	| typer types |
	typer := RefactoryTyper new.
	types := typer guessTypesFor: 'classBlock' in: BasicLintRuleTest.
	"self assert: types size = 1."
	self 
		assert: ([] class withAllSuperclasses 
				detect: [:each | types includes: (typer model classFor: each)]
				ifNone: [nil]) notNil.
	types := typer typesFor: 'methodBlock' in: (typer model classFor: BasicLintRuleTest).
	"self should: [types size = 2]."
	self 
		assert: ([] class withAllSuperclasses 
				detect: [:each | types includes: (typer model classFor: each)]
				ifNone: [nil]) notNil.
	"self should: [types includes: MessageChannel]."
	typer printString! !

RefactoringBrowserTest subclass: #RBNamespaceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!RBNamespaceTest methodsFor: 'class tests' stamp: ''!
testRemoveClassChange
	| st |
	st := RBNamespace new.
	st removeClassNamed: self class name.
	self deny: (st includesClassNamed: self class name).
	self assert: (st classNamed: self class name) isNil! !

!RBNamespaceTest methodsFor: 'class tests' stamp: 'bh 11/8/2000 14:13'!
testRedefineClassChange
	| st |
	st _ RBNamespace new.
	st defineClass: 'nil subclass: #Object
				instanceVariableNames: ''a''
				classVariableNames: ''A''
				poolDictionaries: ''TextConstants''
				category: #''Refactory-Testing'''.
	self assert: (st includesClassNamed: #Object).
	self assert: (st classNamed: #Object) notNil! !

!RBNamespaceTest methodsFor: 'class tests' stamp: ''!
testReferencesPrintOnAfterRemove
	| hasFoundObject hasFoundSelf st |
	hasFoundObject := false.
	hasFoundSelf := false.
	st := RBNamespace new.
	(st classNamed: #Object) removeMethod: #printString.
	st allReferencesTo: #printOn:
		do: 
			[:each | 
			hasFoundObject := hasFoundObject or: 
							[each selector = #printString 
								and: [each modelClass = (st classNamed: #Object)]].
			hasFoundSelf := hasFoundSelf or: 
							[each selector = #testReferencesPrintOnAfterRemove 
								and: [each modelClass = (st classNamed: self class name)]]].
	self deny: hasFoundObject.
	self assert: hasFoundSelf! !

!RBNamespaceTest methodsFor: 'class tests' stamp: ''!
testIncludesClass
	self assert: (RBNamespace new includesClassNamed: #Object).
	self deny: (RBNamespace new includesClassNamed: #Object1).
	self 
		deny: ((RBNamespace 
				onEnvironment: (ClassEnvironment onEnvironment: BrowserEnvironment new
						classes: (Array with: Object))) 
					includesClassNamed: #OrderedCollection)! !

!RBNamespaceTest methodsFor: 'class tests' stamp: 'bh 11/8/2000 14:13'!
testDefineClassChange
	| st |
	st := RBNamespace new.
	st 
		defineClass: 'RefactoringBrowserTest subclass: #SmalltalkTestXXX
				instanceVariableNames: ''''
				classVariableNames: ''''
				poolDictionaries: ''''
				category: #''Refactory-Testing'''.
	self assert: (st includesClassNamed: #SmalltalkTestXXX).
	self assert: (st classNamed: #SmalltalkTestXXX) notNil! !

!RBNamespaceTest methodsFor: 'class tests' stamp: ''!
testDefineClassAfterDeletedChange
	| st |
	st := RBNamespace new.
	st removeClassNamed: self class name.
	self deny: (st includesClassNamed: self class name).
	st defineClass: self class definition.
	self assert: (st includesClassNamed: self class name).
	self assert: (st classNamed: self class name) notNil! !

!RBNamespaceTest methodsFor: 'class tests' stamp: ''!
testReparentSuperclassChange
	| st superclass subclasses |
	st := RBNamespace new.
	superclass := st classFor: TestCase superclass.
	subclasses := TestCase subclasses collect: [:each | st classFor: each].
	st reparentClasses: subclasses to: superclass.
	subclasses do: [:each | self assert: each superclass = superclass]! !

!RBNamespaceTest methodsFor: 'class tests' stamp: 'bh 4/10/2001 16:21'!
testReferencesPrintOn
	| hasFoundObject hasFoundSelf st |
	hasFoundObject := false.
	hasFoundSelf := false.
	st := RBNamespace new.
	st allReferencesTo: #printOn:
		do: 
			[:each | 
			hasFoundObject := hasFoundObject or: 
							[each selector = #fullPrintString 
								and: [each modelClass = (st classNamed: #Object)]].
			hasFoundSelf := hasFoundSelf or: 
							[each selector = #testReferencesPrintOn 
								and: [each modelClass = (st classNamed: self class name)]]].
	self assert: hasFoundObject.
	self assert: hasFoundSelf! !

!RBNamespaceTest methodsFor: 'class tests' stamp: ''!
testAllClassesDo
	| model classes |
	classes := 0.
	model := RBNamespace new.
	model allClassesDo: 
			[:each | 
			each name = #Object ifTrue: [each allSubclasses].
			classes := classes + 1].
	BrowserEnvironment new classesDo: [:each | classes := classes - 1].
	self assert: classes = 0! !

!RBNamespaceTest methodsFor: 'class tests' stamp: 'bh 9/17/2001 02:03'!
testModelImplementorsSenders
	| model class modelImps refs found |
	model := RBNamespace new.
	model 
		defineClass: 'Object subclass: #Asdf
			instanceVariableNames: ''''
			classVariableNames: ''''
			poolDictionaries: ''''
			category: #''Refactory-Testing'''.
	class := model classNamed: #Asdf.
	class compile: 'storeOn: aStream ^super storeOn: aStream'
		classified: #(#printing).
	modelImps := model allImplementorsOf: #storeOn:.
	self assert: (modelImps includes: class).
	self assert: modelImps size - 1 
				= (BrowserEnvironment new implementorsOf: #storeOn:) numberSelectors.
	refs := BrowserEnvironment new referencesTo: #storeOn:.
	found := false.
	model allReferencesTo: #storeOn:
		do: 
			[:each | 
			each modelClass = class 
				ifTrue: [found := true]
				ifFalse: 
					[self 
						assert: (refs includesSelector: each selector in: each modelClass realClass)]].
	self assert: found
! !

!RBNamespaceTest methodsFor: 'class tests' stamp: ''!
testImplementors
	| st |
	st := RBNamespace new.
	self assert: ((st allImplementorsOf: #printString) 
				includes: (st classNamed: #Object)).
	(st classNamed: #Object) removeMethod: #printString.
	self deny: ((st allImplementorsOf: #printString) 
				includes: (st classNamed: #Object))! !

!RBNamespaceTest methodsFor: 'class tests' stamp: 'bh 4/3/2000 15:47'!
testRoots
	| model |
	model := RBNamespace new.
	self 
		assert: (model rootClasses asSortedCollection: [:a :b | a name < b name]) 
				asArray 
					= ((Class rootsOfTheWorld collect: [:each | model classFor: each]) 
							asSortedCollection: [:a :b | a name < b name]) asArray! !

!RefactoringBrowserTest methodsFor: 'private' stamp: ''!
executeRefactoring: aRefactoring 
	aRefactoring primitiveExecute.
	RBParser parseExpression: aRefactoring storeString! !

!RefactoringBrowserTest methodsFor: 'private' stamp: ''!
proceedThroughWarning: aBlock 
	aBlock on: RefactoringWarning do: [:ex | ex proceed]! !

RefactoringBrowserTest subclass: #ParserTest
	instanceVariableNames: 'currentSelector classSearches rewrites'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!ParserTest methodsFor: 'private' stamp: ''!
setupAsIBMWhile: aBlock 
	(RBParser classPool associationAt: #ParserType) value: #IBM.
	aBlock ensure: [RBParser initialize]! !

!ParserTest methodsFor: 'tests' stamp: ''!
testIsA
	| nodes types |
	nodes := Bag new.
	types := Set new.
	#(#(#isAssignment 1) #(#isBlock 1) #(#isCascade 1) #(#isLiteral 1) #(#isMessage 3) #(#isMethod 1) #(#isReturn 1) #(#isSequence 2) #(#isValue 14) #(#isVariable 7) #(#isUsed 9) #(#isDirectlyUsed 8) #(#hasParentheses 1) #(#isBinary 0) #(#isPrimitive 0) #(#isImmediate 9)) 
		do: 
			[:each | 
			each last timesRepeat: [nodes add: each first].
			types add: each first].
	self treeWithEverything nodesDo: 
			[:each | 
			types do: 
					[:sel | 
					((each respondsTo: sel) and: [each perform: sel]) 
						ifTrue: [nodes remove: sel]]].
	self assert: nodes isEmpty! !

!ParserTest methodsFor: 'tests' stamp: ''!
testSearching
	| searcher |
	searcher := ParseTreeSearcher new.
	searcher matches: '``@rcv at: ``@arg `sel: ``@arg1'
		do: [:aNode :answer | answer + 1].
	self 
		assert: (searcher executeTree: (RBParser 
						parseExpression: 'self at: 1 put: 2; at: 2 ifAbsent: []; ifAbsent: 2 at: 1; at: 4; foo')
				initialAnswer: 0) = 2.
	searcher := ParseTreeSearcher new.
	searcher matches: '``@rcv `at: ``@arg1 `at: ``@arg2'
		do: [:aNode :answer | answer + 1].
	self 
		assert: (searcher executeTree: (RBParser 
						parseExpression: 'self at: 1 at: 3; at: 1 put: 32; at: 2; foo; at: 1 at: 1 at: 2')
				initialAnswer: 0) = 1.
	searcher := ParseTreeSearcher new.
	searcher matchesMethod: 'at: `object `put: `o1 ``@rcv `put: 1'
		do: [:aNode :answer | true].
	self assert: (searcher 
				executeTree: (RBParser parseMethod: 'at: a put: b self foo put: 1')
				initialAnswer: false)! !

!ParserTest methodsFor: 'tests' stamp: ''!
testModifying
	| tree |
	tree := RBParser 
				parseMethod: 'foo: a bar: b | c | self first. self second. a + b + c'.
	self deny: tree lastIsReturn.
	self deny: (tree body statements at: 2) isUsed.
	self assert: tree body statements last arguments first isUsed.
	self assert: (tree isLast: tree body statements last).
	self deny: (tree isLast: tree body statements first).
	self assert: (tree defines: 'a').
	self deny: (tree defines: 'c').
	self assert: (tree body defines: 'c').
	self deny: (tree body defines: 'a').
	tree
		addReturn;
		selector: #bar:foo:.
	(tree body)
		addTemporaryNamed: 'd';
		removeTemporaryNamed: 'c'.
	self compare: tree
		to: (RBParser 
				parseMethod: 'bar: a foo: b | d | self first. self second. ^a + b + c').
	self 
		assert: ((tree argumentNames asSet)
				removeAll: #('a' 'b');
				yourself) isEmpty.
	self 
		assert: ((tree allDefinedVariables asSet)
				removeAll: #('a' 'b' 'd');
				yourself) isEmpty.
	tree := RBParser parseExpression: 'self foo: 0'.
	tree selector: #+.
	self compare: tree to: (RBParser parseExpression: 'self + 0').
	self should: [tree selector: #foo] raise: self errorSignal! !

!ParserTest methodsFor: 'tests' stamp: ''!
testCascadeReplacement
	| cascade |
	cascade := RBParser parseExpression: 'self foo; bar; baz'.
	(cascade messages at: 2) 
		replaceWith: (RBParser parseExpression: 'self bar: 2').
	self compare: cascade
		to: (RBParser parseExpression: 'self foo; bar: 2; baz')! !

!ParserTest methodsFor: 'tests' stamp: ''!
testParserErrors
	#(#('self foo. + 3' 11) #('#(' 2) #('self 0' 6) #('self asdf;;asfd' 11)) 
		do: [:each | self parseError: each]! !

!ParserTest methodsFor: 'accessing' stamp: ''!
buildArgumentSearch
	self 
		createArgumentSearchWith: 'aSmalllintContext'
		selectors: #(#checkMethod: #checkClass:)
		inClass: BasicLintRuleTest! !

!ParserTest methodsFor: 'tests' stamp: ''!
testLiteralIntevals
	| tree |
	tree := RBParser parseExpression: '#(#a b #( c ))'.
	self assert: tree token value first start = 3.
	self assert: tree token value first stop = 4.
	self assert: tree token value last value first start = 11! !

!ParserTest methodsFor: 'accessing' stamp: ''!
buildMethodSearch
	"Simple forwarders"

	self 
		createMethodSearchWith: '`@methodName: `@args ^`@object `@methodName: `@args'
		selectors: #(#problemCount isEmpty)
		inClass: TransformationRuleTest! !

!ParserTest methodsFor: 'tests' stamp: ''!
testAllSearches
	classSearches keysAndValuesDo: 
			[:class :searches | 
			class selectors do: 
					[:sel | 
					currentSelector := sel.
					searches 
						do: [:each | each executeTree: (class parseTreeFor: sel) initialAnswer: each answer]]].
	classSearches 
		do: [:searches | searches do: [:each | self assert: each answer isEmpty]]! !

!ParserTest methodsFor: 'accessing' stamp: ''!
createArgumentSearchWith: aCodeString selectors: selectorCollection inClass: aClass 
	| search |
	search := ParseTreeSearcher new.
	search matchesAnyArgumentOf: (Array with: aCodeString)
		do: 
			[:aNode :answer | 
			answer
				remove: self currentSelector ifAbsent: [self error: 'failed'];
				yourself].
	search answer: selectorCollection asBag.
	(classSearches at: aClass ifAbsentPut: [Set new]) add: search! !

!ParserTest methodsFor: 'tests' stamp: 'dfv 9/29/2001 02:01'!
testNumberParsing
	2 to: 32
		do: 
			[:radix | 
			0 to: 72
				do: 
					[:i | 
					self 
						assert: (RBParser 
								parseExpression: (i radix: radix)) 
									value = i]]! !

!ParserTest methodsFor: 'accessing' stamp: ''!
createMethodSearchWith: aCodeString selectors: selectorCollection inClass: aClass 
	| search |
	search := ParseTreeSearcher new.
	search matchesAnyMethodOf: (Array with: aCodeString)
		do: 
			[:aNode :answer | 
			answer
				remove: self currentSelector ifAbsent: [self error: 'failed'];
				yourself].
	search answer: selectorCollection asBag.
	(classSearches at: aClass ifAbsentPut: [Set new]) add: search! !

!ParserTest methodsFor: 'tests' stamp: ''!
testPositions
	| blockNode |
	blockNode := RBParser parseExpression: '[:a :b | ]'.
	self assert: blockNode left = 1.
	self assert: blockNode right = 10.
	self assert: blockNode bar = 8.
	self assert: blockNode sourceInterval = (1 to: 10).
	self assert: blockNode size = 1.	"test dummy collection protocol"
	blockNode printString.	"coverage"
	self deny: (blockNode isLast: (RBVariableNode named: 'b')).
	self compare: blockNode
		to: (RBBlockNode 
				arguments: (OrderedCollection with: (RBVariableNode named: 'a')
						with: (RBVariableNode named: 'b'))
				body: (RBSequenceNode statements: #())).
	self setupAsIBMWhile: 
			[| optimized |
			optimized := RBParser parseExpression: '(##(| a | a := 5. a * a))'.
			self assert: optimized startWithoutParentheses = 2.
			self assert: optimized stopWithoutParentheses = 24.
			self assert: (optimized 
						equalTo: (RBParser parseExpression: '##(| b | b := 5. b * b)')
						exceptForVariables: #()).
			self assert: optimized isImmediate.
			RBProgramNodeVisitor new visitNode: optimized.	"coverage"
			optimized body 
				replaceWith: (RBParser parseExpression: '| c | c := 5. c * 45').
			self compare: optimized
				to: (RBParser parseExpression: '##(| c | c := 5. c * 45)')]! !

!ParserTest methodsFor: 'tests' stamp: ''!
testSmallDictionary
	| dictionary total |
	dictionary := RBSmallDictionary new: 100.
	dictionary
		add: 1 -> 3;
		at: 2 put: 4;
		at: 1 put: 4.
	self assert: dictionary size = 2.
	self assert: (dictionary inject: 0 into: [:sum :each | sum + each]) = 8.
	self assert: (dictionary includesKey: 1).
	self deny: (dictionary includesKey: 3).
	total := 0.
	dictionary keysDo: [:each | total := total + each].
	self assert: total = 3.
	dictionary removeKey: 2.
	dictionary copy associationsDo: [:each | dictionary remove: each].
	self assert: dictionary size = 0! !

!ParserTest methodsFor: 'tests' stamp: ''!
testComparingTrees
	| class |
	class := BasicLintRuleTest class.
	class selectors 
		do: [:each | self compare: (class parseTreeFor: each) to: (class parseTreeFor: each)]! !

!ParserTest methodsFor: 'long running' stamp: 'dvf 8/27/2003 15:01'!
verifyParser
	SystemNavigation new allBehaviorsDo: 
			[:each | 
			each compilerClass = Compiler 
				ifTrue: [each selectors do: [:sel | self verifySelector: sel inClass: each]]]! !

!ParserTest methodsFor: 'private' stamp: ''!
treeWithEverything
	^RBParser 
		parseMethod: 'method: arg1 | temps | temps := #(10). temps foo; foo. ^(temps collect: [:e | ])'! !

!ParserTest methodsFor: 'tests' stamp: ''!
testQuerying
	| tree aNode arg1Node bNode |
	tree := RBParser 
				parseMethod: ('test: a`	| b |`	b := (self foo: a; bar) baz.`	b := super test: b.`	^[:arg1 | self foa1 + (super foo: arg1 foo: a foo: b)]' 
						copyReplaceAll: '`'
						with: (String with: (Character value: 13))).
	self 
		assert: tree selfMessages asSortedCollection asArray = #(#bar #foa1 #foo:).
	self assert: tree superMessages asSortedCollection asArray 
				= #(#foo:foo:foo: #test:).
	aNode := tree whichNodeIsContainedBy: (112 to: 112).
	self assert: aNode name = 'a'.
	bNode := tree whichNodeIsContainedBy: (119 to: 119).
	self assert: bNode name = 'b'.
	arg1Node := tree whichNodeIsContainedBy: (102 to: 105).
	self assert: arg1Node name = 'arg1'.
	self assert: (arg1Node statementNode isMessage 
				and: [arg1Node statementNode selector = #+]).
	self assert: (arg1Node whoDefines: 'arg1') isBlock.
	self assert: (aNode whoDefines: 'a') isMethod.
	self assert: (aNode whoDefines: 'b') isSequence.
	self assert: (tree whichNodeIsContainedBy: (91 to: 119)) selector 
				= #foo:foo:foo:.
	self assert: (tree whichNodeIsContainedBy: (69 to: 121)) isBlock.
	self assert: (tree whichNodeIsContainedBy: (69 to: 118)) isNil.
	self assert: aNode blockVariables asSortedCollection asArray = #('arg1').
	self assert: aNode temporaryVariables asSortedCollection asArray = #('b').
	self assert: tree allDefinedVariables asSortedCollection asArray 
				= #('a' 'arg1' 'b').
	self assert: tree allArgumentVariables asSortedCollection asArray 
				= #('a' 'arg1').
	self 
		assert: tree allTemporaryVariables asSortedCollection asArray = #('b')! !

!ParserTest methodsFor: 'accessing' stamp: ''!
setUp
	super setUp.
	classSearches := Dictionary new.
	self
		buildMethodSearch;
		buildSimpleVariableSearch;
		buildSimpleLiteralSearch;
		buildMessageSearch;
		buildStatementSearch;
		buildArgumentSearch;
		buildMethodTitleSearch;
		buildMethodArgumentSearch! !

!ParserTest methodsFor: 'tests' stamp: ''!
testPatternCascade
	| rewriter |
	rewriter := ParseTreeRewriter new.
	rewriter replace: 'self `;messages; foo: 4; `;messages1'
		with: 'self `;messages1; bar: 4; `;messages'.
	self compare: (rewriter
				executeTree: (RBParser 
							parseExpression: 'self foo; printString; foo: 4; bar. self foo: 4');
				tree)
		to: (RBParser 
				parseExpression: 'self bar; bar: 4; foo; printString. self foo:4')! !

!ParserTest methodsFor: 'tests' stamp: ''!
testCopy
	| tree |
	tree := self treeWithEverything.
	self compare: tree to: tree copy! !

!ParserTest methodsFor: 'accessing' stamp: ''!
buildMethodTitleSearch
	self 
		createMethodSearchWith: 'initialize | `@temps | `@.Stmts'
		selectors: #(#initialize)
		inClass: BasicLintRuleTest! !

!ParserTest methodsFor: 'tests' stamp: ''!
testReadBeforeWritten1
	self 
		assert: (RBReadBeforeWrittenTester variablesReadBeforeWrittenIn: (RBParser 
						parseMethod: 'addAll: aCollection 
	"Answer aCollection, having added all elements
	 of aCollection to the receiver.

	 Fail if aCollection is not a kind of
	 Collection."

	| newSize elementsSize growSize |
	(newSize := aCollection size * 2) > elements size ifTrue: [self rehash: newSize].
	elementsSize := elements size.
	growSize := elementsSize // 2.
	aCollection do: 
			[:newObject | 
			| hashIndex element |
			newObject == nil ifFalse: 
					[hashIndex := self hashIndexFor: newObject.
					
					[(element := elements at: hashIndex) == nil
						ifTrue: 
							[elements at: hashIndex put: newObject.
							(elementCount := elementCount + 1) > growSize ifTrue: 
									[self expand.
									elementsSize := elements size.
									growSize := elementsSize // 2].
							true]
						ifFalse: [element == newObject]]
							whileFalse: 
								[(hashIndex := hashIndex + 1) > elementsSize ifTrue: [hashIndex := 1]]]].
	^aCollection')) 
				isEmpty! !

!ParserTest methodsFor: 'tests' stamp: ''!
testParsingLiteralMessages
	self assert: (RBParser parseExpression: 'self nil') isMessage.
	self assert: (RBParser parseExpression: 'self true') isMessage.
	self assert: (RBParser parseExpression: 'self false') isMessage.
	self assert: (RBParser parseExpression: 'self -1') isMessage! !

!ParserTest methodsFor: 'tests' stamp: ''!
testCreationProtocol
	| messageNode |
	self compare: (RBMessageNode 
				receiver: (RBVariableNode named: 'self')
				selector: #+
				arguments: (Array with: (RBLiteralNode value: 0)))
		to: (RBParser parseExpression: 'self + 0').
	messageNode := RBMessageNode receiver: (RBVariableNode named: 'self')
				selector: #foo.
	self compare: (RBMethodNode selector: #bar
				body: (RBSequenceNode statements: (Array 
								with: (RBCascadeNode messages: (Array with: messageNode with: messageNode)))))
		to: (RBParser parseMethod: 'bar self foo; foo')! !

!ParserTest methodsFor: 'tests' stamp: ''!
testIBM
	self setupAsIBMWhile: 
			[| tree searcher |
			tree := RBParser 
						parseMethod: 'test ##(Array with: 1 with: 2 with: #literal) at: ##esatom'.
			searcher := ParseTreeRewriter new.
			searcher 
				replace: '##(`@object with: `#literal1 with: `#literal2 with: `#literal3)'
				with: '##(`@object with: `#literal3 with: `#literal2 with: `#literal1)'.
			searcher executeTree: tree.
			tree := searcher tree.
			searcher := ParseTreeRewriter new.
			searcher replace: '2' with: '2.5'.
			searcher executeTree: tree.
			self 
				assert: (RBParser parseMethod: searcher tree formattedCode) = (RBParser 
								parseMethod: 'test ##(Array with: #literal with: 2.5 with: 1) at: ##esatom')]! !

!ParserTest methodsFor: 'private' stamp: ''!
parseError: each 
	RBParser parseExpression: each first
		onError: [:string :pos | ^self assert: pos = each last].
	self error: 'Parser didn''t fail'! !

!ParserTest methodsFor: 'tests' stamp: ''!
testRewriteMethods
	#(#('arg1: a arg2: b | temp1 temp2 | self stmt1 ifTrue: [^a]. self arg1: a arg2: b' 'arg2: a arg1: b | temp1 temp2 | self stmt1 ifTrue: [^a]. self arg2: b arg2: a' '`arg1: `var1 `arg2: `var2 | `@temps | ``@.stmts. self `arg1: `var1 `arg2: `var2. `@.stmts1' '`arg2: `var1 `arg1: `var2 | `@temps | ``@.stmts. self `arg2: `var2 `arg2: `var1. `@.stmts1') #('arg1: a arg2: b | temp1 temp2 | self stmt1. self arg1: a arg2: b' 'arg1: a arg2: b | temp1 temp2 | [self stmt1] repeat' '`@args: `@vars | `@temps | `@.stmts. self `@args: `@vars' '`@args: `@vars | `@temps | [`@.stmts] repeat') #('+ a | temps | ^self primitiveValue' '- a | temps | ^self primitiveValue' '+ `temp | `@tmps | `@.stmts' '- `temp | `@tmps | `@.stmts') #('a self stmt1. self stmt2' 'a self stmt1. self stmt2' 'b | `@temps | `@.stmts' 'c | `@temps | `@.stmts')) 
		do: 
			[:each | 
			| rewrite |
			rewrite := ParseTreeRewriter new.
			rewrite replaceMethod: (each at: 3) with: each last.
			self compare: (RBParser 
						parseMethod: (rewrite
								executeTree: (RBParser parseMethod: each first);
								tree) formattedCode)
				to: (RBParser parseMethod: (each at: 2)).
			rewrite := ParseTreeRewriter new.
			rewrite replaceTree: (RBParser parseRewriteMethod: (each at: 3))
				withTree: (RBParser parseRewriteMethod: each last).
			self compare: (RBParser 
						parseMethod: (rewrite
								executeTree: (RBParser parseMethod: each first);
								tree) formattedCode)
				to: (RBParser parseMethod: (each at: 2))]! !

!ParserTest methodsFor: 'private' stamp: 'bh 4/8/2000 19:22'!
verifySelector: aSelector inClass: aClass 
	| myTree otherTree source |
	source := aClass sourceCodeAt: aSelector.
	source isNil ifTrue: [^self].
	myTree := aClass parseTreeFor: aSelector.
	otherTree := Parser new 
				parse: (ReadStream on: source)
				class: aClass
				noPattern: false
				context: nil
				notifying: "SilentCompilerErrorHandler new" nil
				ifFail: [^self].
	self assert: (myTree notNil or: [otherTree isNil]).
	"self should: 
			["
	((Compiler new 
		compile: myTree formattedCode
		in: aClass
		notifying: nil
		ifFail: [self assert: false]) generate 
		isEqualTo: (Compiler new 
				compile: otherTree formattedCode
				in: aClass
				notifying: nil
				ifFail: [self assert: false]) generate) 
			ifFalse: [self halt]
	"]"! !

!ParserTest methodsFor: 'tests' stamp: ''!
testNodesDo
	| size |
	size := 0.
	self treeWithEverything nodesDo: [:e | size := size + 1].
	self assert: size = 18! !

!ParserTest methodsFor: 'accessing' stamp: ''!
buildSimpleVariableSearch
	self 
		createSearchWith: 'result'
		selectors: #(#checkClass: #checkMethod: #isEmpty #problemCount #resetResult #resetResult #resetResult #result #result: #resultClass: #viewResults)
		inClass: BasicLintRuleTest! !

!ParserTest methodsFor: 'tests' stamp: 'bh 3/16/2000 23:16'!
testRewrites
	#(('[:c | |a| a foo1; foo2]' '[:c | |a| b foo1; foo2]' 'a' 'b' ) ('self foo: 1. bar foo1 foo: 2. (self foo: a) foo: (b foo: c)' 'self bar: 1. bar foo1 bar: 2. (self bar: a) bar: (b bar: c)' '``@rcvr foo: ``@arg1' '``@rcvr bar: ``@arg1' ) ('3 + 4' '4 + 4' '3' '4' ) ('a := self a' 'b := self a' 'a' 'b' ) ('^self at: 1 put: 2' '^self put: 1 put: 2' '^`@rcvr `at: `@arg1 put: `@arg2' '^`@rcvr put: `@arg1 put: `@arg2' ) ('1 + 2 + 3' '0 + 0 + 0' '`#literal' '0' ) ('1 + 2 + 3. 3 foo: 4' '3 + (2 + 1). 4 foo: 3' '``@rcvr `msg: ``@arg' '``@arg `msg: ``@rcvr' ) ('self foo: a bar: b. 1 foo: a bar: b' '2 foo: a bar: b. 1 foo: a bar: b' 'self `@msg: `@args' '2 `@msg: `@args' ) ('a := b. a := c + d' 'b := a. a := c + d' '`var1 := `var2' '`var2 := `var1' ) ('^self foo value: 1' 'self return: (self foo value: 1)' '^`@anything' 'self return: `@anything' ) ('self first; second. self first; second. self a. self b' '2 timesRepeat: [self first; second]. self a. self b' '`.Stmt1. `.Stmt1. `@.stmts' '2 timesRepeat: [`.Stmt1]. `@.stmts' ) ('[:a | self a: 1 c: 2; b]' '[:a | self d: 2 e: 1; f. self halt]' '`@rcvr `msg1: `@arg1 `msg2: `@arg2; `msg' '`@rcvr d: `@arg2 e: `@arg1; f. self halt' )  ) do: 
		[:each | 
		| rewrite | 
		rewrite _ ParseTreeRewriter new.
		rewrite replace: (each at: 3)
			with: each last.
		self compare: (RBParser parseExpression: (rewrite executeTree: (RBParser parseExpression: each first);
				 tree) formattedCode)
			to: (RBParser parseExpression: (each at: 2))]! !

!ParserTest methodsFor: 'tests' stamp: ''!
testBestNodeFor
	| tree |
	tree := self treeWithEverything.
	tree nodesDo: 
			[:each | 
			each sourceInterval isEmpty 
				ifFalse: 
					[self assert: ((tree bestNodeFor: each sourceInterval) = each 
								or: [each parent isCascade and: [each parent messages last = each]])]]! !

!ParserTest methodsFor: 'tests' stamp: ''!
testReplacingNodes
	| tree search block |
	tree := RBParser 
				parseMethod: '+ a | a b | self ifTrue: [a] ifFalse: [b := c]. a := b. [:b :c :a | a foo: a; foo1: a; foo2: a foo: b]. ^a'.
	search := ParseTreeSearcher new.
	block := [:aNode :answer | aNode replaceWith: (RBVariableNode named: 'q')].
	search
		matches: 'a' do: block;
		matchesArgument: 'a' do: block.
	search executeTree: tree.
	self 
		assert: tree = (RBParser 
						parseMethod: '+ q | q b | self ifTrue: [q] ifFalse: [b := c]. q := b. [:b :c :q | q foo: q; foo1: q; foo2: q foo: b]. ^q').
	self 
		assert: tree removeDeadCode = (RBParser 
						parseMethod: '+ q | q b | self ifTrue: [] ifFalse: [b := c]. q := b. ^q')! !

!ParserTest methodsFor: 'tests' stamp: ''!
testBlockRewrites
	| rewriter tree |
	tree := RBParser 
				parseMethod: 'method: asdf
	<primitive: 1>
	<primitive: 2>
	^asdf + self foo + asdf'.
	rewriter := ParseTreeRewriter new.
	rewriter 
		replace: 'asdf'
		with: 'fdsa'
		when: [:aNode | aNode parent parent isReturn].
	rewriter replace: 'self foo'
		withValueFrom: [:aNode | RBVariableNode named: aNode selector asString].
	rewriter 
		replaceArgument: 'asdf'
		withValueFrom: [:aNode | RBVariableNode named: 'xxx']
		when: [:aNode | false].
	rewriter executeTree: tree.
	self compare: tree
		to: (RBParser 
				parseMethod: 'method: asdf
	<primitive: 1>
	<primitive: 2>
	^asdf +  foo + fdsa')! !

!ParserTest methodsFor: 'tests' stamp: ''!
testEquality
	self setupAsIBMWhile: 
			[| strings |
			strings := #('test test1; test2; test3: arg1' 'test test1; test2; test3: arg2' '[:arg1 | stmt1. stmt2. stmt3]' '[:arg2 | stmt1. stmt2. stmt3]' '[:arg1 | stmt1. stmt2. stmt3. stmt4]' 'a' 'b' '#literal' '''literal''' '##(Array new)' '##(Array new: 0)' '#(1 2 3)' '#[1 2 3]' '$a' '#''literal string''').
			1 to: strings size
				do: 
					[:i | 
					1 to: strings size
						do: 
							[:j | 
							self 
								deny: ((RBParser parseExpression: (strings at: i)) 
										= (RBParser parseExpression: (strings at: j)) xor: i = j)]]]! !

!ParserTest methodsFor: 'tests' stamp: ''!
testIntervals
	| tree |
	tree := self treeWithEverything.
	tree nodesDo: 
			[:each | 
			(each parent isNil or: [each parent isCascade not]) 
				ifTrue: 
					[| newNode source |
					source := tree source copyFrom: each start to: each stop.
					newNode := each isMethod 
								ifTrue: [RBParser parseMethod: source]
								ifFalse: [RBParser parseExpression: source].
					self compare: each to: newNode]]! !

!ParserTest methodsFor: 'tests' stamp: 'bh 3/15/2000 13:41'!
testPrimitives
	self assert: (Object parseTreeFor: #basicAt:) isPrimitive.
	#(('foo ^true' false ) ('foo <some tag> ^true' false ) (' foo <some tag> <primitive: 123> ^true' true ) ) do: [:each | self assert: (RBParser parseMethod: each first) isPrimitive = each last asBoolean]! !

!ParserTest methodsFor: 'tests' stamp: ''!
testLiterals
	self assert: (RBLiteralNode value: #(1 2 #(#asdf))) formattedCode 
				= '#(1 2 #(#asdf))'! !

!ParserTest methodsFor: 'accessing' stamp: ''!
buildSimpleLiteralSearch
	| search |
	search := ParseTreeSearcher new.
	search 
		matchesAnyTreeOf: (Array with: (RBParser 
						parseExpression: '#(''bugs'' ''possible bugs'' ''unnecessary code'' ''intention revealing'' ''miscellaneous'')'))
		do: 
			[:aNode :answer | 
			answer
				remove: self currentSelector ifAbsent: [self error: 'failed'];
				yourself].
	search answer: #(#protocols) asBag.
	(classSearches at: BasicLintRuleTest class ifAbsentPut: [Set new]) 
		add: search! !

!ParserTest methodsFor: 'tests' stamp: ''!
testTokens
	self setupAsIBMWhile: 
			[| tokens |
			tokens := (RBScanner 
						on: '#foo foo: bar := [ ##( + foo::bar::baz' readStream) contents.
			tokens printString.	"coverage"
			tokens with: #(4 4 3 2 1 3 1 13)
				do: [:token :length | self assert: token length = length]]! !

!ParserTest methodsFor: 'accessing' stamp: ''!
currentSelector
	^currentSelector! !

!ParserTest methodsFor: 'tests' stamp: ''!
testMethodPatterns
	#(#('+ a ^self + a' #+) #('foo ^self foo' #foo) #('foo: a bar: b ^a + b' #foo:bar:)) 
		do: [:each | self assert: (RBParser parseMethodPattern: each first) == each last]! !

!ParserTest methodsFor: 'tests' stamp: 'bh 3/15/2000 13:47'!
testEquivalentExceptRenaming
	#(('a 3-4' 'a 4-3' false ) ('a #[3 4]' 'a #(3 4)' false ) ('a variable1 ~~ "comment" variable2' 'a variable1 ~~ variable2' true ) ('a variable1' 'a variable2' false ) ('a [:a :b | a + b]' 'a [:b :a | a + b]' false ) ('a | a b | a + b' 'a | b a | a + b' true ) ('a | a | a msg1; msg2' 'a | b | b msg2; msg2' false ) ('a c' 'a d' true ) ('a | a b | a := b. ^b msg1' 'a | a b | b := a. ^a msg1' true ) ('a | a b | a := b. ^b msg1: a' 'a | a b | b := a. ^b msg1: a' false ) ('a: b b + 4' 'a: e e + 4' true ) ('a: b b + 4' 'b: b b + 4' false ) ('a: b b: c b + c' 'a: c b: b c + b' true ) ('a: a b: b a + b' 'a: b b: a a + b' false ) ) do: [:each | self assert: ((RBParser parseMethod: each first)
				equalTo: (RBParser parseMethod: (each at: 2))
				exceptForVariables: #('c' ))
				== each last asBoolean]! !

!ParserTest methodsFor: 'accessing' stamp: ''!
buildMethodArgumentSearch
	"Two argument methods"

	self 
		createMethodSearchWith: '`arg1: `arg1 `arg2: `arg2 | `@temps | `@.Stmts'
		selectors: #(#subclassOf:overrides: #createMatcherFor:method: #createParseTreeRule:name:)
		inClass: BasicLintRuleTest class! !

!ParserTest methodsFor: 'tests' stamp: ''!
testFormatter
	| class |
	class := BasicLintRuleTest class.
	class selectors do: 
			[:each | 
			self compare: (class parseTreeFor: each)
				to: (RBParser parseMethod: (class parseTreeFor: each) printString)]! !

!ParserTest methodsFor: 'accessing' stamp: ''!
buildStatementSearch
	"Two or more statements"

	self 
		createSearchWith: '| `@temps | ``@.Stmts1. ``.Stmt1. ``@.Stmts2. ``.Stmt2. ``@.Stmts3'
		selectors: #(#checkMethod: #rewriteUsing: #viewResults #superSends)
		inClass: TransformationRuleTest! !

!ParserTest methodsFor: 'tests' stamp: ''!
testMultimatch
	| rewriter count |
	count := 0.
	rewriter := ParseTreeRewriter new.
	rewriter 
		replace: '``@object at: ``@foo'
		with: '``@object foo: ``@foo'
		when: [:aNode | (count := count + 1) == 2].
	self compare: (rewriter
				executeTree: (RBParser parseExpression: 'self at: (bar at: 3)');
				tree)
		to: (RBParser parseExpression: 'self at: (bar foo: 3)')! !

!ParserTest methodsFor: 'accessing' stamp: ''!
createSearchWith: aCodeString selectors: selectorCollection inClass: aClass 
	| search |
	search := ParseTreeSearcher new.
	search matches: aCodeString
		do: 
			[:aNode :answer | 
			answer
				remove: self currentSelector ifAbsent: [self error: 'failed'];
				yourself].
	search answer: selectorCollection asBag.
	(classSearches at: aClass ifAbsentPut: [Set new]) add: search! !

!ParserTest methodsFor: 'accessing' stamp: ''!
buildMessageSearch
	self 
		createSearchWith: '``@receiver -> ``@arg'
		selectors: #(superSends superSends)
		inClass: TransformationRuleTest! !

!ParserTest methodsFor: 'accessing' stamp: ''!
compare: anObject to: anotherObject 
	self assert: anObject hash = anotherObject hash.
	self assert: anObject = anotherObject! !

!ParserTest methodsFor: 'tests' stamp: 'bh 3/16/2000 17:10'!
testReadBeforeWritten
	#(('a ifTrue: [^self]' true ) ('self foo. a := b' false ) ('condition ifTrue: [a := b] ifFalse: [self foo: a]' true ) ('condition ifTrue: [a := b] ifFalse: [self foo]. a isNil' true ) ('condition ifTrue: [a := b]. a := c' false ) ('[a := b] whileFalse: [a isNil]' false ) ('self foo: b' false ) ) do: 
		[:each | 
		self assert: ((RBReadBeforeWrittenTester readBeforeWritten: #('a' ) in: (RBParser parseExpression: each first))
				includes: 'a')
				== each last asBoolean.
		self assert: (RBReadBeforeWrittenTester isVariable: 'a' readBeforeWrittenIn: (RBParser parseExpression: each first))
				= each last asBoolean].
	#('| temp read written written1 |
			read ifTrue: [^self].
			written1 := self foo ifFalse: [written := true] ifTrue: [written := false].
			[temp := true] whileTrue: [temp notNil & written].
			^temp' '| read written |
			self foo ifTrue: [written := true] ifFalse: [written := false].
			self foo ifTrue: [read := true].
			^read' '| read written |
			self foo do: [:i | i].
			[| i | i := 1. i == 1] whileFalse: [read notNil]' '| written |
			[written := 2] whileFalse.
			self do: [:each | | read | each & read]' '| read |
			self do: [:each | read := each].
			self do: [:each | each & read]' ) do: 
		[:each | 
		| read | 
		read _ RBReadBeforeWrittenTester variablesReadBeforeWrittenIn: (RBParser parseExpression: each).
		self assert: (read size = 1 and: [read includes: 'read'])]! !

RefactoringBrowserTest subclass: #RBClassTest
	instanceVariableNames: 'objectClass newClass messageNodeClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Testing'!

!RBClassTest methodsFor: 'method tests' stamp: 'bh 4/3/2000 22:22'!
testDefinesPoolDictionary
	self deny: (objectClass definesPoolDictionary: #OpcodePool).
	self assert: (newClass definesPoolDictionary: #TextConstants).
	self deny: (messageNodeClass definesPoolDictionary: #OpcodePool).
	self assert: ((RBNamespace new classNamed: #Text) 
				definesPoolDictionary: #TextConstants)! !

!RBClassTest methodsFor: 'method tests' stamp: ''!
testDefinesMethod
	self assert: (objectClass definesMethod: #printString).
	self assert: (newClass definesMethod: #printString).
	self assert: (messageNodeClass definesMethod: #printString)! !

!RBClassTest methodsFor: 'method tests' stamp: ''!
testDefinesClassVariable
	self deny: (objectClass definesClassVariable: #ClassVariable1).
	self assert: (objectClass definesClassVariable: self objectClassVariable).
	self assert: (newClass definesClassVariable: #ClassVariable1).
	self deny: (messageNodeClass definesClassVariable: #ClassVariable1).
	self 
		assert: (messageNodeClass definesClassVariable: self objectClassVariable)! !

!RBClassTest methodsFor: 'set up' stamp: 'bh 11/8/2000 14:12'!
setUp
	| st |
	super setUp.
	st _ RBNamespace new.
	objectClass _ st classNamed: #Object.
	messageNodeClass _ st classNamed: #RBMessageNode.
	st defineClass: 'Object subclass: #SomeClassName
	instanceVariableNames: ''instanceVariable1 instanceVariable2''
	classVariableNames: ''ClassVariable1''
	poolDictionaries: ''TextConstants''
	category: #''Refactory-Testing'''.
	newClass _ st classNamed: #SomeClassName! !

!RBClassTest methodsFor: 'method tests' stamp: ''!
testHierarchy
	| meta |
	meta := objectClass metaclass.
	self assert: (objectClass withAllSubclasses includes: meta).
	self assert: (meta withAllSuperclasses includes: objectClass)! !

!RBClassTest methodsFor: 'method tests' stamp: ''!
testDefinesInstanceVariable
	self deny: (objectClass definesInstanceVariable: 'instanceVariable1').
	self assert: (newClass definesInstanceVariable: 'instanceVariable1').
	self deny: (messageNodeClass definesInstanceVariable: 'instanceVariable1').
	self assert: (messageNodeClass definesInstanceVariable: 'parent').
	self assert: (messageNodeClass definesInstanceVariable: 'selector')! !

Stream subclass: #RBScanner
	instanceVariableNames: 'stream buffer tokenStart currentCharacter characterType classificationTable numberType separatorsInLiterals extendedLiterals extendedSymbols comments extendedLanguage errorBlock nameSpaceCharacter'
	classVariableNames: 'ClassificationTable PatternVariableCharacter'
	poolDictionaries: ''
	category: 'Refactory-AST-RBParser'!

!RBScanner methodsFor: 'accessing' stamp: ''!
flush! !

!RBScanner methodsFor: 'private-scanning' stamp: 'bh 4/29/2000 17:59'!
scanNumberVisualWorks
	| number |
	stream skip: -1.
	number _ Number readSmalltalkSyntaxFrom: stream.
	self step.
	^ number! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanNumberIBM
	| number isNegative |
	isNegative := false.
	currentCharacter == $- 
		ifTrue: 
			[isNegative := true.
			self step].
	number := self scanNumberWithoutExponent.
	^(isNegative ifTrue: [number negated] ifFalse: [number]) 
		* self scanExponentMultipler! !

!RBScanner methodsFor: 'initialize-release' stamp: 'ls 1/30/2000 19:14'!
initializeForSqueak
	numberType := #scanNumberIBM.
	separatorsInLiterals := true.
	extendedLiterals := true.
	extendedSymbols := true.
	nameSpaceCharacter := nil.! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanExponentMultipler
	| exponent isExpNegative position |
	currentCharacter == $e
		ifTrue: 
			[position := stream position.
			self step.
			(isExpNegative := currentCharacter == $-) ifTrue: [self step].
			exponent := self scanNumberOfBase: 10.
			exponent isNil
				ifTrue: 
					["Did not read a valid exponent, e must be start of a message send"

					stream position: position - 1.
					self step.
					exponent := 0]
				ifFalse: [isExpNegative ifTrue: [exponent := exponent negated]]]
		ifFalse: [exponent := 0].
	^10 raisedToInteger: exponent! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanNamespaceName
	extendedLiterals 
		ifTrue: 
			[stream peek == $: ifFalse: [^nil].
			buffer next: 2 put: $:.
			self step]
		ifFalse: 
			[(stream atEnd or: [(self classify: stream peek) ~~ #alphabetic]) 
				ifTrue: [^nil].
			buffer nextPut: $.].
	self step.
	self scanName.
	currentCharacter == nameSpaceCharacter ifTrue: [self scanNamespaceName].
	^RBIdentifierToken value: buffer contents start: tokenStart! !

!RBScanner methodsFor: 'accessing' stamp: ''!
nextPut: anObject 
	"Provide an error notification that the receiver does not
	implement this message."

	self shouldNotImplement! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanIdentifierOrKeyword
	| tokenType token name |
	self scanName.
	currentCharacter == nameSpaceCharacter 
		ifTrue: 
			[token := self scanNamespaceName.
			token notNil ifTrue: [^token]].
	(currentCharacter == $: and: [stream peek ~~ $=]) 
		ifTrue: 
			[buffer nextPut: currentCharacter.
			self step.	":"
			tokenType := RBKeywordToken]
		ifFalse: [tokenType := RBIdentifierToken].
	name := buffer contents.
	name = 'true' 
		ifTrue: 
			[^RBLiteralToken 
				value: true
				start: tokenStart
				stop: self previousStepPosition].
	name = 'false' 
		ifTrue: 
			[^RBLiteralToken 
				value: false
				start: tokenStart
				stop: self previousStepPosition].
	name = 'nil' 
		ifTrue: 
			[^RBLiteralToken 
				value: nil
				start: tokenStart
				stop: self previousStepPosition].
	^tokenType value: name start: tokenStart! !

!RBScanner class methodsFor: 'instance creation' stamp: ''!
on: aStream 
	| str |
	str := self basicNew on: aStream.
	str
		step;
		stripSeparators.
	^str! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanStringSymbol
	| literalToken |
	literalToken := self scanLiteralString.
	literalToken value: literalToken value asSymbol.
	^literalToken! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanLiteralCharacter
	| token |
	self step.	"$"
	token := RBLiteralToken 
				value: currentCharacter
				start: tokenStart
				stop: stream position.
	self step.	"char"
	^token! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanNumber
	^RBLiteralToken 
		value: (self perform: numberType)
		start: tokenStart
		stop: self previousStepPosition! !

!RBScanner methodsFor: 'private' stamp: ''!
step
	stream atEnd ifTrue: 
			[characterType := #eof.
			^currentCharacter := nil].
	currentCharacter := stream next.
	characterType := self classify: currentCharacter.
	^currentCharacter! !

!RBScanner class methodsFor: 'class initialization' stamp: ''!
initializeChars: characters to: aSymbol 
	characters do: [:c | ClassificationTable at: c asInteger put: aSymbol]! !

!RBScanner methodsFor: 'accessing' stamp: ''!
extendedLanguage: aBoolean 
	extendedLanguage := aBoolean! !

!RBScanner methodsFor: 'private-scanning' stamp: 'ls 1/21/2000 22:38'!
scanSpecialCharacter
	| character |
	currentCharacter == $: ifTrue: 
			[self step.
			^currentCharacter == $=
				ifTrue: 
					[self step.
					RBAssignmentToken start: tokenStart]
				ifFalse: [RBSpecialCharacterToken value: $: start: tokenStart]].
	currentCharacter = $_ ifTrue:
		[ self step.  ^RBShortAssignmentToken start: tokenStart ].

	character := currentCharacter.
	self step.
	^RBSpecialCharacterToken value: character start: tokenStart! !

!RBScanner methodsFor: 'accessing' stamp: ''!
contents
	| contentsStream |
	contentsStream := WriteStream on: (Array new: 50).
	self do: [:each | contentsStream nextPut: each].
	^contentsStream contents! !

!RBScanner methodsFor: 'initialize-release' stamp: 'ls 1/30/2000 19:14'!
initializeForIBM
	numberType := #scanNumberIBM.
	separatorsInLiterals := false.
	extendedLiterals := true.
	extendedSymbols := false.
	nameSpaceCharacter := $:! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanLiteralArrayParts
	currentCharacter == $# ifTrue: [^self scanLiteral].
	characterType == #alphabetic 
		ifTrue: 
			[| token value |
			token := self scanSymbol.
			value := token value.
			value == #nil ifTrue: [token value: nil].
			value == #true ifTrue: [token value: true].
			value == #false ifTrue: [token value: false].
			^token].
	(characterType == #digit 
		or: [currentCharacter == $- and: [(self classify: stream peek) == #digit]]) 
			ifTrue: [^self scanNumber].
	characterType == #binary 
		ifTrue: [^(self scanBinary: RBLiteralToken) stop: self previousStepPosition].
	currentCharacter == $' ifTrue: [^self scanLiteralString].
	currentCharacter == $$ ifTrue: [^self scanLiteralCharacter].
	currentCharacter == $( ifTrue: [^self scanLiteralArray].
	currentCharacter == $[ ifTrue: [^self scanByteArray].
	^self scannerError: 'Unknown character in literal array'! !

!RBScanner methodsFor: 'accessing' stamp: ''!
errorBlock: aBlock 
	errorBlock := aBlock! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanByteArray
	| byteStream number |
	byteStream := WriteStream on: (ByteArray new: 100).
	self step.
	
	[self stripSeparators.
	characterType == #digit] whileTrue: 
				[number := self scanNumber value.
				(number isInteger and: [number between: 0 and: 255]) 
					ifFalse: [self scannerError: 'Expecting 8-bit integer'].
				byteStream nextPut: number].
	currentCharacter == $] ifFalse: [self scannerError: ''']'' expected'].
	self step.	"]"
	^RBLiteralToken 
		value: byteStream contents
		start: tokenStart
		stop: self previousStepPosition! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanNumberWithoutExponent
	"Scan an IBM number with the radix -- don't scan the exponent though"

	| number base |
	base := self scanNumberOfBase: 10.
	(currentCharacter == $r and: [base isInteger])
		ifTrue: 
			[| position |
			position := stream position.
			self step.
			number := self scanNumberOfBase: base.
			number isNil ifTrue: 
					["Did not read a correct number, r must be start of a message send."

					stream position: position - 1.
					self step.
					number := base]]
		ifFalse: [number := base].
	^number! !

!RBScanner class methodsFor: 'testing' stamp: ''!
isVariable: aString 
	| scanner token |
	aString isString ifFalse: [^false].
	aString isEmpty ifTrue: [^false].
	(ClassificationTable at: aString first asInteger) == #alphabetic
		ifFalse: [^false].
	scanner := self basicNew.
	scanner on: (ReadStream on: aString asString).
	scanner errorBlock: [:s :p | ^false].
	scanner step.
	token := scanner scanIdentifierOrKeyword.
	token isKeyword ifTrue: [^false].
	^scanner atEnd! !

!RBScanner methodsFor: 'private-scanning' stamp: 'bh 4/29/2000 18:01'!
scanQualifier
	| nameStream qualifierClass |
	qualifierClass _ Smalltalk at: #QualifiedName ifAbsent: [].
	qualifierClass isNil ifTrue: [^ self scannerError: 'Unknown character'].
	self step.
	"{"
	nameStream _ WriteStream on: (String new: 10).
	[currentCharacter == $}]
		whileFalse: 
			[nameStream nextPut: currentCharacter.
			self step].
	self step.
	"}"
	^ RBLiteralToken
		value: (qualifierClass pathString: nameStream contents)
		start: tokenStart
		stop: self previousStepPosition! !

!RBScanner methodsFor: 'private-scanning' stamp: 'dvf 9/17/2001 00:18'!
scanExtendedLiterals
	| token |
	self step.
	separatorsInLiterals ifTrue: [self stripSeparators].
	token := characterType == #alphabetic 
				ifTrue: [self scanSymbol]
				ifFalse: 
					[characterType == #binary 
						ifTrue: [(self scanBinary: RBLiteralToken) stop: self previousStepPosition]
						ifFalse: 
							[currentCharacter == $' 
								ifTrue: [self scanStringSymbol]
								ifFalse: 
									[currentCharacter == $( 
										ifTrue: 
											[self step.
											^RBOptimizedToken start: tokenStart]]]].
	token isNil ifTrue: [self scannerError: 'Expecting a extended literal'].
	token value: (Symbol intern: token value asString).
	^token! !

!RBScanner class methodsFor: 'instance creation' stamp: ''!
on: aStream errorBlock: aBlock 
	| str |
	str := self basicNew on: aStream.
	str
		errorBlock: aBlock;
		step;
		stripSeparators.
	^str! !

!RBScanner methodsFor: 'private-scanning' stamp: 'ls 1/30/2000 19:16'!
scanLiteral
	self step.
	separatorsInLiterals ifTrue: [self stripSeparators].
	characterType == #alphabetic ifTrue: [^self scanSymbol].
	characterType == #binary 
		ifTrue: [^(self scanBinary: RBLiteralToken) stop: self previousStepPosition].
	currentCharacter == $' ifTrue: [^self scanStringSymbol].
	currentCharacter == $( ifTrue: [^self scanLiteralArray].
	currentCharacter == $[ ifTrue: [^self scanByteArray].
	(extendedSymbols and: [ '._' includes: currentCharacter ])
		ifTrue: [^self scanExtendedSymbol ].
	(separatorsInLiterals and: [currentCharacter == ${]) 
		ifTrue: [^self scanQualifier].
	(extendedLiterals and: [currentCharacter == $#]) 
		ifTrue: [^self scanExtendedLiterals].
	self scannerError: 'Expecting a literal type'! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanLiteralString
	self step.
	
	[currentCharacter isNil 
		ifTrue: [self scannerError: 'Unmatched '' in string literal.'].
	currentCharacter == $' and: [self step ~~ $']] 
			whileFalse: 
				[buffer nextPut: currentCharacter.
				self step].
	^RBLiteralToken 
		value: buffer contents
		start: tokenStart
		stop: self previousStepPosition! !

!RBScanner class methodsFor: 'instance creation' stamp: ''!
rewriteOn: aStream 
	| str |
	str := self basicNew on: aStream.
	str
		extendedLanguage: true;
		step;
		stripSeparators.
	^str! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanName
	[characterType == #alphabetic or: [characterType == #digit]] whileTrue: 
			[buffer nextPut: currentCharacter.
			self step]! !

!RBScanner methodsFor: 'private' stamp: ''!
classify: aCharacter 
	| index |
	aCharacter isNil ifTrue: [^nil].
	index := aCharacter asInteger.
	index == 0 ifTrue: [^#separator].
	index > 255 ifTrue: [^nil].
	^classificationTable at: index! !

!RBScanner class methodsFor: 'accessing' stamp: ''!
patternVariableCharacter
	^PatternVariableCharacter! !

!RBScanner methodsFor: 'testing' stamp: ''!
isReadable
	^true! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanNumberOfBase: anInteger 
	"Scan a number. Return the number or nil if the current input isn't a valid number."

	| number digits fraction isFloat succeeded |
	digits := '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ' copyFrom: 1 to: anInteger.
	number := 0.
	succeeded := false.
	[digits includes: currentCharacter] whileTrue: 
			[number := number * anInteger + (digits indexOf: currentCharacter) - 1.
			self step.
			succeeded := true].
	succeeded ifFalse: [^nil].
	isFloat := false.
	(currentCharacter == $. and: [digits includes: stream peek]) ifTrue: 
			[self step.
			isFloat := true.
			fraction := 1 / anInteger.
			[digits includes: currentCharacter] whileTrue: 
					[number := number + (((digits indexOf: currentCharacter) - 1) * fraction).
					fraction := fraction / anInteger.
					self step]].
	^isFloat ifTrue: [number asFloat] ifFalse: [number]! !

!RBScanner methodsFor: 'testing' stamp: ''!
atEnd
	^characterType == #eof! !

!RBScanner methodsFor: 'error handling' stamp: ''!
errorPosition
	^stream position! !

!RBScanner methodsFor: 'error handling' stamp: ''!
errorBlock
	^errorBlock isNil
		ifTrue: [[:message :position | ]]
		ifFalse: [errorBlock]! !

!RBScanner class methodsFor: 'accessing' stamp: ''!
classificationTable
	ClassificationTable isNil ifTrue: [self initialize].
	^ClassificationTable! !

!RBScanner methodsFor: 'accessing' stamp: ''!
getComments
	| oldComments |
	comments isEmpty ifTrue: [^nil].
	oldComments := comments.
	comments := OrderedCollection new: 1.
	^oldComments! !

!RBScanner methodsFor: 'initialize-release' stamp: 'ls 1/24/2000 02:21'!
on: aStream 
	buffer := WriteStream on: (String new: 60).
	stream := aStream.
	classificationTable := self class classificationTable.
	extendedLanguage := false.
	comments := OrderedCollection new.
	RBParser isIBM 
		ifTrue: [self initializeForIBM].
	RBParser isVisualWorks
		ifTrue: [self initializeForVisualWorks].
	RBParser isSqueak
		ifTrue: [ self initializeForSqueak].! !

!RBScanner methodsFor: 'accessing' stamp: 'bh 3/7/2000 02:17'!
scanToken
	"fast-n-ugly. Don't write stuff like this. Has been found to cause cancer in laboratory rats. Basically a 
	case statement. Didn't use Dictionary because lookup is pretty slow."

	characterType == #alphabetic ifTrue: [^self scanIdentifierOrKeyword].
	(characterType == #digit 
		or: [currentCharacter == $- and: [(self classify: stream peek) == #digit]]) 
			ifTrue: [^self scanNumber].
	characterType == #binary ifTrue: [^self scanBinary: RBBinarySelectorToken].
	characterType == #special ifTrue: [^self scanSpecialCharacter].
	currentCharacter == $' ifTrue: [^self scanLiteralString].
	currentCharacter == $# ifTrue: [^self scanLiteral].
	currentCharacter == $$ ifTrue: [^self scanLiteralCharacter].
	extendedLanguage 
		ifTrue: 
			[currentCharacter == PatternVariableCharacter 
				ifTrue: [^self scanPatternVariable].
			currentCharacter == $} ifTrue: [^self scanSpecialCharacter]].
	^self scannerError: 'Unknown character'! !

!RBScanner methodsFor: 'initialize-release' stamp: 'ls 1/30/2000 19:14'!
initializeForVisualWorks
	numberType := #scanNumberVisualWorks.
	separatorsInLiterals := true.
	extendedLiterals := false.
	extendedSymbols := false.
	(Smalltalk includesKey: #QualifiedName) ifTrue: [nameSpaceCharacter := $.]! !

!RBScanner methodsFor: 'private' stamp: ''!
previousStepPosition
	^characterType == #eof 
		ifTrue: [stream position]
		ifFalse: [stream position - 1]! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanBinary: aClass 
	"This doesn't parse according to the ANSI draft. It only parses 1 or 2 letter binary tokens."

	| val |
	buffer nextPut: currentCharacter.
	self step.
	(characterType == #binary and: [currentCharacter ~~ $-]) ifTrue: 
			[buffer nextPut: currentCharacter.
			self step].
	val := buffer contents.
	val := val asSymbol.
	^aClass value: val start: tokenStart! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanSymbol
	| lastPosition hasColon value startPosition |
	hasColon := false.
	startPosition := lastPosition := stream position.
	[characterType == #alphabetic] whileTrue: 
			[self scanName.
			currentCharacter == $: 
				ifTrue: 
					[buffer nextPut: $:.
					hasColon := true.
					lastPosition := stream position.
					self step]].
	value := buffer contents.
	(hasColon and: [value last ~~ $:]) 
		ifTrue: 
			[stream position: lastPosition.
			self step.
			value := value copyFrom: 1 to: lastPosition - startPosition + 1].
	^RBLiteralToken 
		value: value asSymbol
		start: tokenStart
		stop: self previousStepPosition! !

!RBScanner methodsFor: 'error handling' stamp: ''!
scannerError: aString 
	"Evaluate the block. If it returns raise an error"

	self errorBlock value: aString value: self errorPosition.
	self error: aString! !

!RBScanner methodsFor: 'accessing' stamp: ''!
extendedLanguage
	^extendedLanguage! !

!RBScanner methodsFor: 'accessing' stamp: ''!
next
	| token |
	buffer reset.
	tokenStart := stream position.
	characterType == #eof ifTrue: [^RBToken start: tokenStart + 1].	"The EOF token should occur after the end of input"
	token := self scanToken.
	self stripSeparators.
	^token! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
stripComment
	| start stop |
	start := stream position.
	[self step == $"] whileFalse: 
			[characterType == #eof
				ifTrue: [self scannerError: 'Unmatched " in comment.']].
	stop := stream position.
	self step.
	comments add: (start to: stop)! !

!RBScanner class methodsFor: 'instance creation' stamp: ''!
rewriteOn: aStream errorBlock: aBlock 
	| str |
	str := self basicNew on: aStream.
	str
		extendedLanguage: true;
		errorBlock: aBlock;
		step;
		stripSeparators.
	^str! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanPatternVariable
	buffer nextPut: currentCharacter.
	self step.
	currentCharacter == ${ 
		ifTrue: 
			[self step.
			^RBPatternBlockToken value: '`{' start: tokenStart].
	[characterType == #alphabetic] whileFalse: 
			[characterType == #eof 
				ifTrue: [self scannerError: 'Meta variable expected'].
			buffer nextPut: currentCharacter.
			self step].
	^self scanIdentifierOrKeyword! !

!RBScanner methodsFor: 'accessing' stamp: ''!
classificationTable: anObject
	classificationTable := anObject! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanLiteralArray
	| arrayStream start |
	arrayStream := WriteStream on: (Array new: 10).
	self step.
	start := tokenStart.
	
	[self stripSeparators.
	tokenStart := stream position.
	currentCharacter == $)] 
			whileFalse: 
				[arrayStream nextPut: self scanLiteralArrayParts.
				buffer reset].
	self step.
	^RBLiteralToken 
		value: arrayStream contents
		start: start
		stop: self previousStepPosition! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
stripSeparators
	
	[[characterType == #separator]
		whileTrue: [self step].
	currentCharacter == $"]
		whileTrue: [self stripComment]! !

!RBScanner methodsFor: 'private-scanning' stamp: 'ls 1/30/2000 19:21'!
scanExtendedSymbol
	"scan symbols like #. which are allowed by Squeak but aren't standard"

	| token |
	token := RBLiteralToken value: (currentCharacter asString asSymbol) start: tokenStart stop: stream position.
	self step.
	^token
! !

!RBScanner methodsFor: 'private-scanning' stamp: ''!
scanAnySymbol
	characterType == #alphabetic ifTrue: [^self scanSymbol].
	characterType == #binary ifTrue: [^self scanBinary: RBLiteralToken].
	^RBToken new! !

!RBScanner methodsFor: 'testing' stamp: ''!
isWritable
	^false! !

!RBScanner class methodsFor: 'testing' stamp: ''!
isSelector: aSymbol 
	| scanner token |
	scanner := self basicNew.
	scanner on: (ReadStream on: aSymbol asString).
	scanner step.
	token := scanner scanAnySymbol.
	token isLiteral ifFalse: [^false].
	token value isEmpty ifTrue: [^false].
	^scanner atEnd! !

!RBScanner class methodsFor: 'class initialization' stamp: 'ls 3/20/2004 14:17'!
initialize
	PatternVariableCharacter := $`.
	ClassificationTable := Array new: 255.
	self initializeChars: 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ' to: #alphabetic.
	self initializeChars: (128 to: 255) asByteArray asString to: #alphabetic.
	self initializeChars: '01234567890' to: #digit.
	self initializeChars: '!!!!%&*+,-/<=>?@\~|' to: #binary.
	ClassificationTable at: 177 put: #binary.	"plus-or-minus"
	ClassificationTable at: 183 put: #binary.	"centered dot"
	ClassificationTable at: 215 put: #binary.	"times"
	ClassificationTable at: 247 put: #binary.	"divide"
	self initializeChars: '().:;[]^{}_' to: #special.
	#(9 10 12 13 26 32) do: [:i | ClassificationTable at: i put: #separator]! !

!SelectorBrowser methodsFor: '*Refactory-override' stamp: 'sw 10/9/1998 08:26'!
classListIndex: anInteger

	classListIndex _ anInteger.
	classListIndex > 0 ifTrue:
		[self dependents do:
			[:dep | ((dep isKindOf: PluggableListView) and:
				[dep setSelectionSelectorIs: #classListIndex:])
					ifTrue: [dep controller controlTerminate]].
		Browser fullOnClass: self selectedClass selector: self selectedMessageName.
		"classListIndex _ 0"]
! !

Dictionary subclass: #RBSmallDictionary
	instanceVariableNames: 'keys values size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-AST-ParseTree Matching'!

!RBSmallDictionary methodsFor: 'removing' stamp: ''!
removeKey: key ifAbsent: aBlock 
	| index value |
	index := self findIndexFor: key.
	index == 0 ifTrue: [^aBlock value].
	value := values at: index.
	index to: size - 1
		do: 
			[:i | 
			keys at: i put: (keys at: i + 1).
			values at: i put: (values at: i + 1)].
	keys at: size put: nil.
	values at: size put: nil.
	size := size - 1.
	^value! !

!RBSmallDictionary methodsFor: 'private' stamp: ''!
growTo: aSize 
	| newKeys newValues |
	newKeys := Array new: aSize.
	newValues := Array new: aSize.
	1 to: size
		do: 
			[:i | 
			newKeys at: i put: (keys at: i).
			newValues at: i put: (values at: i)].
	keys := newKeys.
	values := newValues! !

!RBSmallDictionary methodsFor: 'enumerating' stamp: ''!
associationsDo: aBlock 
	self keysAndValuesDo: [:key :value | aBlock value: key -> value]! !

!RBSmallDictionary methodsFor: 'accessing' stamp: ''!
size
	^size! !

!RBSmallDictionary methodsFor: 'private' stamp: ''!
findIndexFor: aKey 
	1 to: size do: [:i | (keys at: i) = aKey ifTrue: [^i]].
	^0! !

!RBSmallDictionary methodsFor: 'initialize-release' stamp: ''!
initialize
	keys := Array new: 2.
	values := Array new: 2.
	size := 0! !

!RBSmallDictionary methodsFor: 'enumerating' stamp: ''!
do: aBlock 
	1 to: size do: [:i | aBlock value: (values at: i)]! !

!RBSmallDictionary methodsFor: 'removing' stamp: 'bh 3/14/2000 22:59'!
remove:anAssociation

	self removeKey:anAssociation key.! !

!RBSmallDictionary methodsFor: 'accessing' stamp: ''!
at: key ifAbsentPut: aBlock 
	| index |
	index := self findIndexFor: key.
	^index == 0 
		ifTrue: [self privateAt: key put: aBlock value]
		ifFalse: [values at: index]! !

!RBSmallDictionary methodsFor: 'enumerating' stamp: ''!
keysDo: aBlock 
	1 to: size do: [:i | aBlock value: (keys at: i)]! !

!RBSmallDictionary methodsFor: 'adding' stamp: ''!
at: key put: value 
	| index |
	index := self findIndexFor: key.
	^index == 0 
		ifTrue: [self privateAt: key put: value]
		ifFalse: [values at: index put: value]! !

!RBSmallDictionary methodsFor: 'copying' stamp: 'bh 3/11/2000 02:18'!
copy
	^ self shallowCopy postCopy.! !

!RBSmallDictionary methodsFor: 'accessing' stamp: ''!
empty
	size := 0! !

!RBSmallDictionary methodsFor: 'enumerating' stamp: ''!
keysAndValuesDo: aBlock 
	1 to: size do: [:i | aBlock value: (keys at: i) value: (values at: i)]! !

!RBSmallDictionary class methodsFor: 'instance creation' stamp: ''!
new: aSize 
	"Ignore the size"

	^self basicNew initialize! !

!RBSmallDictionary methodsFor: 'private' stamp: ''!
privateAt: key put: value 
	size == keys size ifTrue: [self growKeysAndValues].
	size := size + 1.
	keys at: size put: key.
	^values at: size put: value! !

!RBSmallDictionary methodsFor: 'private' stamp: ''!
growKeysAndValues
	self growTo: size * 2! !

!RBSmallDictionary methodsFor: 'testing' stamp: ''!
includesKey: aKey 
	^(self findIndexFor: aKey) ~~ 0! !

!RBSmallDictionary methodsFor: 'removing' stamp: ''!
remove: oldObject ifAbsent: anExceptionBlock 
	self removeKey: oldObject key ifAbsent: anExceptionBlock.
	^oldObject! !

!RBSmallDictionary methodsFor: 'adding' stamp: ''!
add: anAssociation 
	self at: anAssociation key put: anAssociation value.
	^anAssociation! !

!RBSmallDictionary class methodsFor: 'instance creation' stamp: ''!
new
	^self basicNew initialize! !

!RBSmallDictionary methodsFor: 'accessing' stamp: ''!
at: key ifAbsent: aBlock 
	| index |
	index := self findIndexFor: key.
	^index == 0 ifTrue: [aBlock value] ifFalse: [values at: index]! !

!RBSmallDictionary methodsFor: 'copying' stamp: ''!
postCopy
	keys := keys copy.
	values := values copy! !

!Dictionary methodsFor: '*Refactory-RBAddonsReasonable' stamp: ''!
bindingFor: varName
	"Look up varName in this pool.  If it is there,
	answer the variable binding, else answer nil."

	"This should be defined only for PoolDictionary and like classes,
	but is defined here to temporarily accomodate clients that use
	Dictionaries as pools."

	^self associationAt: varName ifAbsent: []! !

!BlockContext methodsFor: '*Refactory-RBAddonsProblem' stamp: 'bh 3/13/2000 17:39'!
isEqualTo:aBlockClosure

	self method isEqualTo:aBlockClosure method.! !

PackageInfo subclass: #RefactoryInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Info'!

!RefactoryInfo methodsFor: 'as yet unclassified' stamp: 'dvf 11/2/2002 19:42'!
postNewVersion
	| sd compressedFile packagedFileName fileVersion |
	fileVersion _ FillInTheBlank request: 'File number?'.
	packagedFileName _ self name, FileDirectory dot, fileVersion, FileDirectory dot, 'sar'.
	SARPackageDumper  fileOutPackage: self as: packagedFileName.
	compressedFile _ FileDirectory default readOnlyFileNamed: packagedFileName.
	sd _ ServerDirectory new.
	sd  user: 'dvf';
	server: 'modules.squeakfoundation.org';
	password: (FillInTheBlank request: 'password?');
	directory: 'Packages/';
	putFile:  compressedFile named:  packagedFileName.
! !

!RefactoryInfo methodsFor: 'as yet unclassified' stamp: 'dvf 11/3/2002 00:16'!
additionalFiles
	^#('AbstractVariableTestData.st'
		'ChildrenToSiblingTest.st'
		'InlineMethodTest.st')
! !

Object subclass: #LintRuleTest
	instanceVariableNames: 'name foo1'
	classVariableNames: 'Foo1'
	poolDictionaries: 'TextConstants'
	category: 'Refactory-Test data'!

!LintRuleTest methodsFor: 'private' stamp: ''!
failedRules
	^self isEmpty
		ifTrue: [#()]
		ifFalse: [Array with: self]! !

!LintRuleTest methodsFor: 'testing' stamp: 'bh 4/3/2000 22:39'!
junk
	^RefactoryTestDataApp printString copyFrom: 1 to: CR! !

LintRuleTest subclass: #BasicLintRuleTest
	instanceVariableNames: 'classBlock methodBlock result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Test data'!

!BasicLintRuleTest class methodsFor: 'bugs' stamp: ''!
subclassResponsibilityNotDefined
	| detector subclassResponsibilitySymbol |
	detector := self new.
	subclassResponsibilitySymbol := 'subclassResponsibility' asSymbol.
	detector name: 'Subclass responsibility not defined'.
	detector classBlock: 
			[:context :result | 
			(context selectedClass whichSelectorsReferTo: subclassResponsibilitySymbol)
				do: 
					[:each | 
					(context selectedClass withAllSubclasses detect: 
							[:class | 
							class subclasses isEmpty
								and: [(class whichClassIncludesSelector: each) == context selectedClass]]
						ifNone: [nil]) notNil
						ifTrue: [result addClass: context selectedClass selector: each]]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'miscellaneous' stamp: ''!
assignmentInBlock
	^self createParseTreeRule: #(
			'`@cursor showWhile: [| `@temps | `@.Statements1. `var := `@object]' 
			'`@cursor showWhile: [| `@temps | `@.Statements1. ^`@object]' 
			'[| `@temps | `@.Statements. `var := `@object] valueNowOrOnUnwindDo: `@block' 
			'[| `@temps | `@.Statements. ^`@object] valueNowOrOnUnwindDo: `@block' 
			'[| `@temps | `@.Statements. `var := `@object] valueOnUnwindDo: `@block' 
			'[| `@temps | `@.Statements. ^`@object] valueOnUnwindDo: `@block' ) 
		name: 'Unnecessary assignment or return in block'! !

!BasicLintRuleTest class methodsFor: 'private' stamp: ''!
superMessages
	^#(#release #postCopy #postBuildWith: #preBuildWith: #postOpenWith: #noticeOfWindowClose: #initialize)! !

!BasicLintRuleTest class methodsFor: 'miscellaneous' stamp: ''!
precedence
	| detector matcher |
	detector := self new.
	detector name: 'Inspect instances of "A + B * C" might be "A + (B * C)"'.
	matcher := ParseTreeSearcher new.
	matcher addSearches: #('``@A + ``@B * ``@C' '``@A - ``@B * ``@C')
				-> [:aNode :answer | answer or: [aNode receiver parentheses isEmpty]].
	detector methodBlock: 
			[:context :result | 
			(matcher executeTree: context parseTree initialAnswer: false)
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'private' stamp: ''!
classShouldNotOverride
	^#(#== #class)! !

!BasicLintRuleTest class methodsFor: 'intention revealing' stamp: ''!
sizeCheck
	^self createParseTreeRule: (#(#do: #collect: #reject: #select:) collect: 
					[:each | 
					'`@object size > 0 ifTrue: [`@object ' , each
						, ' [:`each | | `@temps | `@.Statements1]. `@.Statements2]'])
				, (#(#do: #collect: #reject: #select:) collect: 
							[:each | 
							'`@object isEmpty ifFalse: [`@object ' , each
								, ' [:`each | | `@temps | `@.Statements1]. `@.Statements2]'])
		name: 'Unnecessary size check'! !

!BasicLintRuleTest methodsFor: 'testing' stamp: ''!
isEmpty
	^result isEmpty! !

!BasicLintRuleTest class methodsFor: 'intention revealing' stamp: ''!
missingSubclassResponsibility
	| detector |
	detector := self new.
	detector name: 'Method defined in all subclasses, but not in superclass'.
	detector resultClass: MultiEnvironment.
	detector classBlock: 
			[:context :result | 
			| subs |
			subs := context selectedClass subclasses.
			subs size > 1 & context selectedClass isMetaclass not ifTrue: 
					[| sels |
					sels := Bag new.
					subs do: [:each | sels addAll: each selectors].
					sels asSet do: 
							[:each | 
							((sels occurrencesOf: each) == subs size
								and: [(context selectedClass canUnderstand: each) not]) ifTrue: 
										[| envName |
										envName := context selectedClass name , '>>', each.
										subs do: 
												[:subClass | 
												result addClass: subClass
													selector: each
													into: envName]]]]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'miscellaneous' stamp: ''!
refersToClass
	| detector |
	detector := self new.
	detector name: 'Refers to class name instead of "self class"'.
	detector classBlock: 
			[:context :result | 
			| sels className |
			className := (context selectedClass isMetaclass
						ifTrue: [context selectedClass primaryInstance]
						ifFalse: [context selectedClass]) name.
			sels := context selectedClass
						whichSelectorsReferTo: (Smalltalk associationAt: className).
			sels isEmpty ifFalse: 
					[result addSearchString: className.
					sels do: [:each | result addClass: context selectedClass selector: each]]].
	^detector! !

!BasicLintRuleTest methodsFor: 'initialize-release' stamp: ''!
result: aResult 
	result := aResult copyEmpty! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: ''!
tempsReadBeforeWritten
	| detector |
	detector := self new.
	detector name: 'Temporaries read before written'.
	detector methodBlock: 
			[:context :result | 
			| variables |
			variables := ParseTreeSearcher nonBlockTempsIn: context parseTree.
			variables isEmpty 
				ifFalse: 
					[(RBReadBeforeWrittenTester variablesReadBeforeWrittenIn: context parseTree) 
						do: 
							[:each | 
							result addClass: context selectedClass selector: context selector.
							result addSearchString: each]]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'unnecessary code' stamp: ''!
extraBlock
	^self
		createParseTreeRule: (#('value' 'value: `@value' 'value: `@value1 value: `@value2' 'value: `@value1 value: `value2 value: `@value3' 'valueWithArguments: `@values')
				collect: [:each | '[:`@params | | `@temps | `@.statements] ' , each])
		name: 'Block immediately evaluated'! !

!BasicLintRuleTest class methodsFor: 'private' stamp: ''!
badSelectors
	^#(#become: #isKindOf: #changeClassToThatOf: #respondsTo: #isMemberOf: #performMethod: #performMethod:arguments: #performMethod:with: #performMethod:with:with: #performMethod:with:with:with: #allOwners #allOwnersWeakly: #firstOwner #instVarAt: #instVarAt:put: #nextInstance #nextObject #ownerAfter: #primBecome:  #halt)! !

!BasicLintRuleTest class methodsFor: 'unnecessary code' stamp: ''!
equivalentSuperclassMethods
	| detector |
	detector := self new.
	detector name: 'Methods equivalently defined in superclass'.
	detector methodBlock: 
			[:context :result | 
			context selectedClass superclass notNil ifTrue: 
					[(context selectedClass superclass canUnderstand: context selector)
						ifTrue: 
							[(((context selectedClass superclass
								whichClassIncludesSelector: context selector)
									compiledMethodAt: context selector)
									equivalentTo: context compiledMethod)
									ifTrue: [result addClass: context selectedClass selector: context selector]]]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'miscellaneous' stamp: ''!
utilityMethods
	| detector |
	detector := self new.
	detector name: 'Utility methods'.
	detector methodBlock: 
			[:context :result | 
			(context selectedClass isMetaclass | (context selector numArgs == 0) or: 
					[(context protocols detect: 
							[:each | 
							(self utilityProtocols detect: [:protocol | protocol match: each]
								ifNone: [nil]) notNil]
						ifNone: [nil]) notNil])
				ifFalse: 
					[(self subclassOf: context selectedClass overrides: context selector)
						ifFalse: 
							[(context superMessages isEmpty and: [context selfMessages isEmpty]) ifTrue: 
									[(ParseTreeSearcher
										references: context selectedClass allInstVarNames
												, context selectedClass allClassVarNames asArray , #('self')
										in: context parseTree) isEmpty
										ifTrue: [result addClass: context selectedClass selector: context selector]]]]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'instance creation' stamp: ''!
createParseTreeRule: codeStrings name: aName 
	^self createParseTreeRule: codeStrings
		method: false
		name: aName! !

!BasicLintRuleTest methodsFor: 'accessing' stamp: 'bh 4/3/2000 10:19'!
foobar

	^#( true false )! !

!BasicLintRuleTest class methodsFor: 'miscellaneous' stamp: ''!
longMethods
	| detector matcher |
	detector := self new.
	detector name: 'Long methods'.
	matcher := ParseTreeSearcher new.
	matcher
		addSearch: '`.Stmt' -> 
					[:aNode :answer | 
					(aNode children inject: answer
						into: [:sum :each | matcher executeTree: each initialAnswer: sum]) + 1].
	detector methodBlock: 
			[:context :result | 
			(matcher executeTree: context parseTree initialAnswer: 0)
				>= self longMethodSize
					ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'private' stamp: ''!
subclassOf: aClass overrides: aSelector 
	| subs |
	subs := aClass subclasses.
	1 to: subs size
		do: 
			[:i | 
			| each |
			each := subs at: i.
			(each includesSelector: aSelector) ifTrue: [^true].
			(self subclassOf: each overrides: aSelector) ifTrue: [^true]].
	^false! !

!BasicLintRuleTest class methodsFor: 'miscellaneous' stamp: ''!
yourselfNotUsed
	| detector addSearcher |
	detector := self new.
	detector name: 'Doesn''t use the result of a yourself message'.
	addSearcher := ParseTreeSearcher new.
	addSearcher addSearch: '`@object yourself'
				-> [:aNode :answer | answer or: [aNode isUsed not]].
	detector methodBlock: 
			[:context :result | 
			(addSearcher executeTree: context parseTree initialAnswer: false)
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'bugs' stamp: ''!
overridesSpecialMessage
	| detector |
	detector := self new.
	detector name: 'Overrides a "special" message'.
	detector resultClass: ClassEnvironment.
	detector classBlock: 
			[:context :result | 
			((context selectedClass isMetaclass
				ifTrue: [self metaclassShouldNotOverride]
				ifFalse: [self classShouldNotOverride]) detect: 
						[:each | 
						context selectedClass superclass notNil and: 
								[(context selectedClass superclass canUnderstand: each)
									and: [context selectedClass includesSelector: each]]]
					ifNone: [nil]) notNil ifTrue: [result addClass: context selectedClass]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'miscellaneous' stamp: ''!
instVarInSubclasses
	| detector |
	detector := self new.
	detector name: 'Instance variables defined in all subclasses'.
	detector result: nil pullUpInstVar.
	detector classBlock: 
			[:context :result | 
			| subs |
			subs := context selectedClass subclasses.
			subs size > 1 ifTrue: 
					[| sels |
					sels := Bag new.
					subs do: [:each | sels addAll: each instVarNames].
					sels asSet do: 
							[:val | 
							(sels occurrencesOf: val) == subs size
								ifTrue: [result addInstVar: val for: context selectedClass]]]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'unnecessary code' stamp: ''!
variableReferencedOnce
	| detector |
	detector := self new.
	detector 
		name: 'Variable referenced in only one method and always assigned first'.
	detector classBlock: 
			[:context :result | 
			| allSubclasses |
			allSubclasses := context selectedClass withAllSubclasses.
			context selectedClass instVarNames do: 
					[:each | 
					| defClass selector |
					(allSubclasses inject: 0
						into: 
							[:sum :class | 
							| sels |
							sels := class whichSelectorsAccess: each.
							sels size == 1 
								ifTrue: 
									[selector := sels asArray first.
									defClass := class].
							sum + sels size]) 
							== 1 
							ifTrue: 
								[| tree |
								tree := defClass parseTreeFor: selector.
								tree notNil 
									ifTrue: 
										[(RBReadBeforeWrittenTester readBeforeWritten: (Array with: each) in: tree) 
											isEmpty 
												ifTrue: 
													[result addClass: defClass selector: selector.
													result addSearchString: each]]]]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'unnecessary code' stamp: ''!
implementedNotSent
	| detector |
	detector := self new.
	detector name: 'Methods implemented but not sent'.
	detector methodBlock: 
			[:context :result | 
			(context uses: context selector)
				ifFalse: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: ''!
tempVarOverridesInstVar
	| detector matcher vars varName |
	detector := self new.
	detector name: 'Instance variable overridden by temporary variable'.
	matcher := (ParseTreeSearcher new) addArgumentSearch: '`xxxvar' -> 
								[:aNode :answer | 
								answer or: 
										[varName := aNode name.
										vars includes: varName]];
				yourself.
	detector methodBlock: 
			[:context :result | 
			vars := context instVarNames.
			(matcher executeTree: context parseTree initialAnswer: false) ifTrue: 
					[result addClass: context selectedClass selector: context selector.
					result addSearchString: varName]].
	^detector! !

!BasicLintRuleTest methodsFor: 'accessing' stamp: ''!
checkMethod: aSmalllintContext 
	^methodBlock value: aSmalllintContext value: result! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: ''!
threeElementPoint
	| detector matcher |
	detector := self new.
	detector name: 'Possible three element point (e.g., x @ y + q @ r)'.
	matcher := (ParseTreeSearcher new) addSearch: '``@x @ ``@y' -> 
								[:aNode :answer | 
								answer or: 
										[| current |
										current := aNode parent.
										[current isNil or: 
												[current isMessage
													and: [current selector == #@ or: [current selector isInfix not]]]]
											whileFalse: [current := current parent].
										(current isNil or: [current isMessage and: [current selector isInfix not]])
											not]];
				yourself.
	detector methodBlock: 
			[:context :result | 
			(matcher executeTree: context parseTree initialAnswer: false)
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'intention revealing' stamp: ''!
toDo
	| detector matcher |
	detector := self new.
	detector name: 'Uses to:do: instead of do:, with:do: or timesRepeat:'.
	matcher := ParseTreeSearcher new.
	matcher
		addSearch: '1 to: ``@object size do: [:`each | | `@temps | `@.Statements]' -> 
					[:aNode :answer | 
					answer or: 
							[| varName variableMatcher |
							varName := aNode arguments last arguments first name. "`each"
							variableMatcher := ParseTreeSearcher new.
							variableMatcher addSearch: varName
										-> [:node :ans | ans and: [node parent isMessage and: [node parent selector == #at:]]].
							variableMatcher executeTree: aNode arguments last body initialAnswer: true]].
	detector methodBlock: 
			[:context :result | 
			(matcher executeTree: context parseTree initialAnswer: false)
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: ''!
returnsIfTrue
	^self createParseTreeRule: 
				#('^`@condition ifTrue: [| `@temps | `@.statements]' 
				'^`@condition ifFalse: [| `@temps | `@.statements]') 
		name: 'Returns value of ifTrue:/ifFalse: without ifFalse:/ifTrue: block'! !

!BasicLintRuleTest class methodsFor: 'intention revealing' stamp: ''!
detectContains
	^self createParseTreeRule: 
			#('`@collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifFalse: [| `@BlockTemps | `@.BlockStatements1. ^`each]. 
					`@.Statements2]' 
			'`@collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifTrue: [| `@BlockTemps | `@.BlockStatements1.  ^`each]. 
					`@.Statements2]' 
			'`@collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifFalse: [| `@BlockTemps | `@.BlockStatements1. ^true]. 
					`@.Statements2]' 
			'`@Collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifTrue: [| `@BlockTemps | `@.BlockStatements1.  ^true]. 
					`@.Statements2]' 
			'`@collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifFalse: [| `@BlockTemps | `@.BlockStatements1. ^false]. 
					`@.Statements2]' 
			'`@collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifTrue: [| `@BlockTemps | `@.BlockStatements1.  ^false]. 
					`@.Statements2]') 
		name: 'Uses do: instead of contains: or detect:''s'! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: ''!
abstractClass
	| detector subclassResponsibilitySymbol |
	detector := self new.
	detector name: 'References an abstract class'.
	detector resultClass: ClassEnvironment.
	subclassResponsibilitySymbol := 'subclassResponsibility' asSymbol.
	detector classBlock: 
			[:context :result | 
			(context selectedClass whichSelectorsReferTo: subclassResponsibilitySymbol)
				isEmpty ifFalse: 
						[(context
							uses: (Smalltalk associationAt: context selectedClass name ifAbsent: [nil]))
								ifTrue: [result addClass: context selectedClass]]].
	^detector! !

!BasicLintRuleTest methodsFor: 'accessing' stamp: ''!
result
	^result! !

!BasicLintRuleTest class methodsFor: 'bugs' stamp: ''!
sentNotImplemented
	| detector |
	detector := self new.
	detector name: 'Messages sent but not implemented'.
	detector methodBlock: 
			[:context :result | 
			| message |
			message := context messages detect: [:each | (context implements: each) not]
						ifNone: [nil].
			message isNil ifTrue: 
					[message := context superMessages detect: 
									[:each | 
									context selectedClass superclass isNil
										or: [(context selectedClass superclass canUnderstand: each) not]]
								ifNone: [nil].
					message isNil ifTrue: 
							[message := context selfMessages
										detect: [:each | (context selectedClass canUnderstand: each) not]
										ifNone: [nil]]].
			message notNil ifTrue: 
					[result addSearchString: message.
					result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'intention revealing' stamp: ''!
contains
	^self createParseTreeRule: 
			#('(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) isNil' 
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) notNil' 
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) = nil' 
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) == nil' 
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) ~= nil' 
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) ~~ nil' 
			'`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [| `@temps1 | `@.Statements2. ^`@anything]') 
		name: 'Uses detect:ifNone: instead of contains:'! !

!BasicLintRuleTest class methodsFor: 'accessing' stamp: ''!
protocols
	^#('bugs' 'possible bugs' 'unnecessary code' 'intention revealing' 'miscellaneous')! !

!BasicLintRuleTest class methodsFor: 'unnecessary code' stamp: ''!
justSendsSuper
	| detector matcher |
	detector := self new.
	detector name: 'Method just sends super message'.
	matcher := ParseTreeSearcher justSendsSuper.
	detector methodBlock: 
			[:context :result | 
			(context parseTree tag isNil
				and: [matcher executeMethod: context parseTree initialAnswer: false])
					ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'private' stamp: ''!
canCall: aSelector in: aClass from: anApplication 
	| methodApp root |
	(aClass canUnderstand: aSelector) ifFalse: [^false].
	root := anApplication rootApplication.
	methodApp := ((aClass whichClassIncludesSelector: aSelector) compiledMethodAt: aSelector)
				application rootApplication.
	^methodApp == root or: [root isBasedOn: methodApp]! !

!BasicLintRuleTest class methodsFor: 'intention revealing' stamp: ''!
collectionMessagesToExternalObject
	| detector matcher |
	detector := self new.
	detector name: 'Sends add:/remove: to external collection'.
	matcher := ParseTreeSearcher new.
	matcher
		addSearches: (#(#add: #remove: #addAll: #removeAll:)
				collect: [:each | ('(`@Object `@message: `@args) <1s> `@Arg' expandMacrosWith: each) asString])
					-> 
						[:aNode :answer | 
						answer or: 
								[(aNode receiver selector copyFrom: 1 to: (aNode receiver selector size min: 2))
									~= 'as' and: 
											[| receiver |
											receiver := aNode receiver receiver.
											receiver isVariable not or: 
													[((#('self' 'super') includes: receiver name)
														or: [Smalltalk includesKey: receiver name asSymbol]) not]]]].
	detector methodBlock: 
			[:context :result | 
			(matcher executeTree: context parseTree initialAnswer: false)
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'private' stamp: ''!
createMatcherFor: codeStrings method: aBoolean 
	| matcher |
	matcher := ParseTreeSearcher new.
	aBoolean
		ifTrue: [matcher addMethodSearches: codeStrings -> [:aNode :answer | true]]
		ifFalse: [matcher addSearches: codeStrings -> [:aNode :answer | true]].
	^matcher! !

!BasicLintRuleTest methodsFor: 'accessing' stamp: ''!
problemCount
	^result problemCount! !

!BasicLintRuleTest class methodsFor: 'intention revealing' stamp: ''!
minMax
	| detector matcher |
	detector := self new.
	detector name: 'Uses ifTrue:/ifFalse: instead of min: or max:'.
	matcher := ParseTreeSearcher new.
	matcher
		addSearches: #('(`x `message: `@y) `ifTrue: [`x := `@y]' '(`@x `message: `@y) `ifTrue: [`@x] `ifFalse: [`@y]')
				-> 
					[:aNode :answer | 
					answer or: 
							[(#(#ifTrue: #ifFalse: #ifTrue:ifFalse: #ifFalse:ifTrue:)
								includes: aNode selector)
									and: [#(#< #<= #> #>=) includes: aNode receiver selector]]].
	detector methodBlock: 
			[:context :result | 
			(matcher executeTree: context parseTree initialAnswer: false)
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: ''!
missingYourself
	| detector matcher |
	detector := self new.
	detector name: 'Possible missing "; yourself"'.
	matcher := ParseTreeSearcher new.
	matcher
		addSearch: '``@xobject `@messages: ``@args' -> 
					[:aNode :answer | 
					answer or: 
							[aNode parent isCascade
								and: [aNode isDirectlyUsed and: [aNode selector ~~ #yourself]]]].
	detector methodBlock: 
			[:context :result | 
			(matcher executeTree: context parseTree initialAnswer: false)
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'miscellaneous' stamp: ''!
stringConcatenation
	| detector matcher concatenationMatcher |
	detector := self new.
	detector name: 'String concatenation instead of streams'.
	matcher := ParseTreeSearcher new.
	concatenationMatcher := ParseTreeSearcher new.
	concatenationMatcher
		addSearch: '`@receiver , `@argument' -> [:aNode :answer | true].
	matcher
		addSearches: #('``@collection do: [:`each | | `@temps | ``@.Statements]' '``@collection do: [:`each | | `@temps | ``@.Statements] separatedBy: [| `@temps1 | ``@.Statements1]' '``@number to: ``@endNumber do: [:`i | | `@temps | ``@.Statements]' '``@collection detect: [:`each | | `@temps | ``@.Statements]' '``@collection detect: [:`each | | `@temps | ``@.Statements] ifNone: [| `@temps1 | ``@.Statements1]' '``@collection select: [:`each | | `@temps | ``@.Statements]' '``@collection inject: ``@value into: [:`each | | `@temps | ``@.Statements]')
				-> 
					[:aNode :answer | 
					answer or: 
							[(aNode arguments detect: 
									[:each | 
									each isBlock
										and: [concatenationMatcher executeTree: each initialAnswer: false]]
								ifNone: [nil]) notNil]].
	detector methodBlock: 
			[:context :result | 
			(matcher executeTree: context parseTree initialAnswer: false)
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'private' stamp: ''!
metaclassShouldNotOverride
	^#(#name #comment)! !

!BasicLintRuleTest class methodsFor: 'miscellaneous' stamp: ''!
variableAssignedLiteral
	| detector |
	detector := self new.
	detector name: 'Variable is only assigned a single literal value'.
	detector result: nil references.
	detector classBlock: 
			[:context :result | 
			| allSubclasses |
			allSubclasses := context selectedClass withAllSubclasses.
			context selectedClass instVarNames do: 
					[:each | 
					| defClass selector |
					(allSubclasses inject: 0
						into: 
							[:sum :class | 
							| sels |
							sels := class whichSelectorsWrite: each.
							sels size == 1 ifTrue: 
									[selector := sels asArray first.
									defClass := class].
							sum + sels size])
							== 1 ifTrue: 
								[| tree searcher |
								searcher := ParseTreeSearcher new.
								searcher addSearch: (each , ' := ``@object')
											-> [:aNode :answer | answer isNil and: [aNode value isLiteral]].
								tree := defClass parseTreeFor: selector.
								tree notNil ifTrue: 
										[(searcher executeTree: tree initialAnswer: nil) == true
											ifTrue: [result addInstVar: each for: context selectedClass]]]]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: ''!
addRemoveDependents
	| detector |
	detector := self new.
	detector resultClass: ClassEnvironment.
	detector name: 'Number of addDependent: messages > removeDependent:'.
	detector classBlock: 
			[:context :result | 
			| count |
			count := 0.
			((Set
				withAll: (context selectedClass whichSelectorsReferTo: #addDependent:))
					addAll: (context selectedClass whichSelectorsReferTo: #removeDependent:);
				yourself) do: 
					[:sel | 
					(context selectedClass compiledMethodAt: sel) messagesDo: 
							[:each | 
							each == #addDependent: ifTrue: [count := count + 1].
							each == #removeDependent: ifTrue: [count := count - 1]]].
			count > 0 ifTrue: [result addClass: context selectedClass]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: ''!
superSends
	| detector |
	detector := self new.
	detector name: 'Missing super sends'.
	detector methodBlock: 
			[:context :result | 
			(context selectedClass isMetaclass not
				and: [self superMessages includes: context selector]) ifTrue: 
						[(context selectedClass superclass notNil
							and: [context selectedClass superclass canUnderstand: context selector])
								ifTrue: 
									[(context superMessages includes: context selector)
										ifFalse: [result addClass: context selectedClass selector: context selector]]]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: ''!
collectionCopyEmpty
	| detector |
	detector := self new.
	detector
		name: 'Subclass of collection that has instance variable but doesn''t define copyEmpty'.
	detector resultClass: ClassEnvironment.
	detector classBlock: 
			[:context :result | 
			(context selectedClass isVariable 
					and: [(context selectedClass includesSelector: #copyEmpty:) not 
						and: [context selectedClass instVarNames isEmpty not
							and: [context selectedClass inheritsFrom: Collection]]])
				ifTrue: [result addClass: context selectedClass]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'private' stamp: ''!
new
	^super new initialize! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: ''!
modifiesCollection
	| detector addSearcher |
	detector := self new.
	detector name: 'Modifies collection while iterating over it'.
	addSearcher := ParseTreeSearcher modifiesCollection.
	detector methodBlock: 
			[:context :result | 
			addSearcher executeTree: context parseTree initialAnswer: false.
			addSearcher answer
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'bugs' stamp: ''!
booleanPrecedence
	^self createParseTreeRule: 
			#('`@object1 | `@object2 = `@object3'
			'`@object1 | `@object2 == `@object3'
			'`@object1 & `@object2 = `@object3'
			'`@object1 & `@object2 == `@object3'
			'`@object1 | `@object2 ~= `@object3'
			'`@object1 | `@object2 ~~ `@object3'
			'`@object1 & `@object2 ~= `@object3'
			'`@object1 & `@object2 ~~ `@object3')
		name: 'Uses A | B = C instead of A | (B = C)'! !

!BasicLintRuleTest class methodsFor: 'unnecessary code' stamp: ''!
onlyReadOrWritten
	| detector |
	detector := self new.
	detector name: 'Instance variables not read AND written'.
	detector result: nil references.
	detector classBlock: 
			[:context :result | 
			| allSubclasses |
			allSubclasses := context selectedClass withAllSubclasses.
			context selectedClass instVarNames do: 
					[:each | 
					| reads writes |
					reads := false.
					writes := false.
					allSubclasses detect: 
							[:class | 
							reads ifFalse: [reads := (class whichSelectorsRead: each) isEmpty not].
							writes ifFalse: [writes := (class whichSelectorsWrite: each) isEmpty not].
							reads & writes]
						ifNone: [result addInstVar: each for: context selectedClass]]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'miscellaneous' stamp: ''!
badMessage
	| detector badMessages |
	detector := self new.
	detector name: 'Sends "questionable" message'.
	badMessages := self badSelectors.
	detector classBlock: 
			[:context :result | 
			| selectors |
			selectors := badMessages inject: Set new
						into: 
							[:set :each | 
							set addAll: (context selectedClass whichSelectorsReferTo: each);
								yourself].
			selectors do: [:each | result addClass: context selectedClass selector: each].
			selectors isEmpty ifFalse: [result searchStrings: badMessages]].
	^detector! !

!BasicLintRuleTest methodsFor: 'initialize-release' stamp: ''!
methodBlock: aBlock
	methodBlock := aBlock! !

!BasicLintRuleTest class methodsFor: 'intention revealing' stamp: ''!
atIfAbsent
	^self createParseTreeRule: 
				#('`@object 
						at: `@atArg 
						ifAbsent: [| `@temps | `@.Statements. `@object at: `@atArg put: `@putArg]' 
				'`@object 
						at: `@atArg 
						ifAbsent: [| `@temps | 
								`@.Statements. 
								`@object at: `@atArg put: `@putArg. 
								`@.xStatements1. 
								`@putArg]') 
		name: 'Uses at:ifAbsent: instead of at:ifAbsentPut:'! !

!BasicLintRuleTest methodsFor: 'private' stamp: ''!
viewResults
	result openEditor! !

!BasicLintRuleTest class methodsFor: 'intention revealing' stamp: ''!
whileTrue
	^self createParseTreeRule: 
			#('| `@temps | 
				`@.Statements1. 
				[`index <= `@stop] 
					whileTrue: 
						[| `@blockTemps | 
						`@.BlockStmts1. 
						`index := `index + 1].
				`@.Statements2' 
			'| `@temps | 
				`@.Statements1. 
				[`index < `@stop] 
					whileTrue: 
						[| `@blockTemps | 
						`@.BlockStmts1. 
						`index := `index + 1].
				`@.Statements2'
			'| `@temps | 
				`@.Statements1. 
				[`index >= `@stop] 
					whileTrue: 
						[| `@blockTemps | 
						`@.BlockStmts1. 
						`index := `index - 1].
				`@.Statements2' 
			'| `@temps | 
				`@.Statements1. 
				[`index > `@stop] 
					whileTrue: 
						[| `@blockTemps | 
						`@.BlockStmts1. 
						`index := `index - 1].
				`@.Statements2') 
		name: 'Uses whileTrue: instead of to:do:'! !

!BasicLintRuleTest class methodsFor: 'miscellaneous' stamp: ''!
classNameInSelector
	| detector |
	detector := self new.
	detector name: 'Redundant class name in selector'.
	detector methodBlock: 
			[:context :result | 
			(context selectedClass isMetaclass and: 
					[(context selector
						indexOfSubCollection: context selectedClass primaryInstance name
						startingAt: 1) > 0])
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: ''!
sentNotImplementedInApplication
	| detector |
	detector := self new.
	detector name: 'Messages sent but not implemented in application'.
	detector methodBlock: 
			[:context :result | 
			| message class block |
			message := context messages
						detect: [:each | (context isItem: each in: context application) not]
						ifNone: [nil].
			class := context selectedClass.
			block := 
					[:each | 
					| app |
					app := context application.
					(self canCall: each
						in: class
						from: app) not].
			message isNil ifTrue: [message := context selfMessages detect: block ifNone: [nil]].
			message isNil ifTrue: 
					[class := class superclass.
					class isNil
						ifTrue: 
							[context superMessages isEmpty ifFalse: [message := context superMessages asArray first]]
						ifFalse: [message := context superMessages detect: block ifNone: [nil]]].
			message notNil ifTrue: 
					[result addSearchString: message.
					result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'intention revealing' stamp: ''!
consistencyCheck
	^self createParseTreeRule: 
				#('`@object size == 0' 
				'`@object size = 0' 
				'`@object size > 0' 
				'`@object size >= 1' 
				'`@object == nil' 
				'`@object = nil') 
		name: 'Uses "size = 0" or "= nil" instead of "isEmpty" or "isNil"'! !

!BasicLintRuleTest class methodsFor: 'private' stamp: ''!
utilityProtocols
	"If a method is defined in one of these protocols, then don't check if its a utility method."

	^#('*utilit*')! !

!BasicLintRuleTest class methodsFor: 'intention revealing' stamp: ''!
assignmentInIfTrue
	^self createParseTreeRule: 
			#('`@boolean 
					ifTrue: [| `@temps1 | `@.Statements1. `var := `@object1] 
					ifFalse: [| `@temps2 | `@.Statements2. `var := `@object2]' 
			'`@boolean 
					ifFalse: [| `@temps1 | `@.Statements1. `var := `@object1] 
					ifTrue: [| `@temps2 | `@.Statements2. `var := `@object2]') 
		name: 'Assignment to same variable and end of ifTrue:ifFalse: blocks'! !

!BasicLintRuleTest methodsFor: 'initialize-release' stamp: ''!
resetResult
	result := result copyEmpty.
	result label: name! !

!BasicLintRuleTest methodsFor: 'initialize-release' stamp: ''!
resultClass: aClass 
	result := aClass new! !

!BasicLintRuleTest class methodsFor: 'instance creation' stamp: ''!
createParseTreeRule: codeStrings method: aBoolean name: aName 
	| detector matcher |
	detector := self new.
	detector name: aName.
	matcher := self createMatcherFor: codeStrings method: aBoolean.
	detector methodBlock: 
			[:context :result | 
			(matcher executeTree: context parseTree initialAnswer: false)
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: ''!
sendsDifferentSuper
	| detector |
	detector := self new.
	detector name: 'Sends different super message'.
	detector methodBlock: 
			[:context :result | 
			| message |
			(message := context superMessages detect: [:each | each ~= context selector]
						ifNone: [nil]) notNil ifTrue: 
					[result addSearchString: message.
					result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: ''!
usesAdd
	| detector addSearcher |
	detector := self new.
	detector name: 'Uses the result of an add: message'.
	addSearcher := ParseTreeSearcher usesResultOfAdd.
	detector methodBlock: 
			[:context :result | 
			(addSearcher executeTree: context parseTree initialAnswer: false)
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: ''!
definesEqualNotHash
	| detector |
	detector := self new.
	detector name: 'Defines = but not hash'.
	detector resultClass: ClassEnvironment.
	detector classBlock: 
			[:context :result | 
			((context selectedClass includesSelector: #=)
				and: [(context selectedClass includesSelector: #hash) not])
				ifTrue: [result addClass: context selectedClass]].
	^detector! !

!BasicLintRuleTest methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	classBlock := [:context :aResult | ].
	methodBlock := [:context :aResult | ].
	self resultClass: SelectorEnvironment! !

!BasicLintRuleTest class methodsFor: 'unnecessary code' stamp: ''!
unreferencedVariables
	| detector |
	detector := self new.
	detector name: 'Variables not referenced'.
	detector result: nil unreferenced.
	detector classBlock: 
			[:context :result | 
			| allSubclasses |
			allSubclasses := context selectedClass withAllSubclasses.
			context selectedClass instVarNames do: 
					[:each | 
					allSubclasses
						detect: [:class | (class whichSelectorsAccess: each) isEmpty not]
						ifNone: [result addInstVar: each for: context selectedClass]].
			context selectedClass isMetaclass ifFalse: 
					[context selectedClass classPool associationsDo: 
							[:each | 
							(context uses: each)
								ifFalse: [result addClassVar: each key for: context selectedClass]]]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'unnecessary code' stamp: ''!
classNotReferenced
	| detector |
	detector := self new.
	detector name: 'Class not referenced'.
	detector resultClass: ClassEnvironment.
	detector classBlock: 
			[:context :result | 
			(context selectedClass isMetaclass
				or: [context isApplication
				or: [context selectedClass subclasses isEmpty not]])
					ifFalse: 
						[| assoc |
						assoc := Smalltalk associationAt: context selectedClass name.
						((context uses: assoc) or: [context uses: context selectedClass name])
							ifFalse: 
								[result addClass: context selectedClass;
									addClass: context selectedClass class]]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'private' stamp: ''!
longMethodSize
	^10! !

!BasicLintRuleTest class methodsFor: 'intention revealing' stamp: ''!
guardingClause
	^self
		createParseTreeRule: 
				#('`@MethodName: `@args 
						| `@temps | 
						`@.Statements. 
						`@condition ifTrue: [| `@BlockTemps | `.Statement1. `.Statement2. `@.BStatements]' 
				'`@MethodName: `@args 
						| `@temps | 
						`@.Statements. 
						`@condition ifFalse: [| `@BlockTemps | `.Statement1. `.Statement2. `@.BStatements]')
		method: true
		name: 'Guarding clauses'! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: ''!
fileBlocks
	^self createParseTreeRule: 
				#('[| `@temps | 
					`var := `@object.  
					`@.statements] 
							valueNowOrOnUnwindDo: 
								[`var `@messages: `@args]' 
				'[| `@temps | 
					`var := `@object.  
					`@.statements] 
							valueOnUnwindDo: 
								[`var `@messages: `@args]') 
		name: 'Assignment inside unwind blocks should be outside.'! !

!BasicLintRuleTest class methodsFor: 'unnecessary code' stamp: ''!
endTrueFalse
	| detector matcher |
	detector := self new.
	detector name: 'Check for same statements at end of ifTrue:ifFalse: blocks'.
	matcher := (ParseTreeSearcher new) addSearches: 
				#('`@object 
						ifTrue: [| `@temps1 | `@.Statements1. `.Statement] 
						ifFalse: [| `@temps2 | `@.Statements2. `.Statement]' 
				'`@object 
						ifTrue: [| `@temps1 | `.Statement. `@.Statements1] 
						ifFalse: [| `@temps2 | `.Statement. `@.Statements2]' 
				'`@object 
						ifFalse: [| `@temps1 | `@.Statements1. `.Statement] 
						ifTrue: [| `@temps2 | `@.Statements2. `.Statement]' 
				'`@object 
						ifFalse: [| `@temps1 | `.Statement. `@.Statements1] 
						ifTrue: [| `@temps2 | `.Statement. `@.Statement2]') 
			-> [:aNode :answer | answer
						or: 
							[| node |
							node := aNode arguments first body statements last.
							(node isVariable and: [node = aNode arguments last body statements last]) not]]; yourself.
	detector methodBlock: [:context :result | (matcher executeTree: context parseTree initialAnswer: false)
			ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'intention revealing' stamp: ''!
collectionProtocol
	^self createParseTreeRule: 
			#('`@collection do: [:`each | | `@temps | `@.Statements1. `@object add: `@arg. `@.Statements2]' 
			'`@collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifTrue: [| `@blockTemps | 
							`@.BlockStatements1. 
							`@object add: `each. 
							`@.BlockStatements2]. 
					`@.Statements2]' 
			'`@collection do: [:`each | | `@temps | 
					`@.Statements1. 
					`@condition ifFalse: [| `@blockTemps | 
							`@.BlockStatements1. 
							`@object add: `each. 
							`@.BlockStatements2]. 
					`@.Statements2]') 
		name: 'Uses do: instead of collect: or select:''s'! !

!BasicLintRuleTest class methodsFor: 'miscellaneous' stamp: 'bh 4/8/2000 19:05'!
fullBlocks

"skip this test in squeak."

"	| detector |
	detector := self new.
	detector name: 'Method with full blocks'.
	detector methodBlock: 
			[:context :result | 
			context compiledMethod withAllBlockMethodsDo: 
					[:method | 
					method needsHybridFrame
						ifTrue: [result addClass: context selectedClass selector: context selector]]].
	^detector"! !

!BasicLintRuleTest methodsFor: 'initialize-release' stamp: ''!
classBlock: aBlock
	classBlock := aBlock testMethod1! !

!BasicLintRuleTest class methodsFor: 'miscellaneous' stamp: ''!
ifTrueBlocks
	| detector matcher |
	detector := self new.
	detector name: 'Non-blocks in ifTrue:/ifFalse: messages'.
	matcher := ParseTreeSearcher new.
	matcher
		addSearches: #('``@condition ifTrue: ``@block' '``@condition ifFalse: ``@block' '``@condition ifTrue: ``@block1 ifFalse: ``@block2' '``@condition ifFalse: ``@block1 ifTrue: ``@block2')
				-> 
					[:aNode :answer | 
					answer or: 
							[(aNode arguments detect: [:each | each isBlock not] ifNone: [nil]) notNil]].
	detector methodBlock: 
			[:context :result | 
			(matcher executeTree: context parseTree initialAnswer: false)
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'possible bugs' stamp: 'bh 4/3/2000 11:54'!
returnsBooleanAndOther
	| detector matcher |
	detector := self new.
	detector name: 'Returns a boolean and non boolean'.
	matcher := ParseTreeSearcher new.
	matcher addSearch: '^``@xObject' -> 
					[:aNode :answer | 
					answer add: aNode value;
						yourself].
	detector methodBlock: 
			[:context :result | 
			| hasBool hasSelf |
			hasBool := false.
			hasSelf := context parseTree lastIsReturn not.
			(matcher executeTree: context parseTree initialAnswer: Set new) do: 
					[:each | 
					hasBool := hasBool or: 
									[(each isLiteral and: [{true. false} includes: each value])
										or: [each isMessage and: [#(#and: #or:) includes: each selector]]].
					hasSelf := hasSelf or: 
									[(each isVariable and: [each name = 'self'])
										or: [each isLiteral and: [({true. false} includes: each value) not]]]].
			hasSelf & hasBool
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'bugs' stamp: ''!
usesTrue
	| detector trueBinding falseBinding |
	detector := self new.
	trueBinding := Smalltalk associationAt: #True.
	falseBinding := Smalltalk associationAt: #False.
	detector name: 'Uses True/False instead of true/false'.
	detector methodBlock: 
			[:context :result | 
			| method |
			method := context compiledMethod.
			((method referencesLiteral: trueBinding)
				or: [method referencesLiteral: falseBinding]) ifTrue: 
						[result addClass: context selectedClass selector: context selector.
						result searchStrings: #('True' 'False')]].
	^detector! !

!BasicLintRuleTest class methodsFor: 'intention revealing' stamp: 'bh 4/3/2000 11:51'!
ifTrueReturns
	| detector matcher |
	detector := self new.
	detector name: 'ifTrue:/ifFalse: returns instead of and:/or:''s'.
	matcher := ParseTreeSearcher new.
	matcher addSearches:
		#('| `@temps | ``@.Statements. ``@object ifTrue: [^``@value1]. ^``@value2' 
		'| `@temps | ``@.Statements. ``@object ifFalse: [^``@value1]. ^``@value2') 
			-> [:aNode :answer | answer
				or: 
					[| node |
					node := (aNode statements at: aNode statements size - 1) arguments first body statements last value. "``@value1"
					(node isLiteral and: [{true. false} includes: node value])
						or: 
							[node := aNode statements last value.
							node isLiteral and: [{true. false} includes: node value]]]].
	detector methodBlock: [:context :result | (matcher executeTree: context parseTree initialAnswer: false)
			ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!BasicLintRuleTest methodsFor: 'accessing' stamp: ''!
checkClass: aSmalllintContext 
	^classBlock value: aSmalllintContext value: result! !

!BasicLintRuleTest class methodsFor: 'unnecessary code' stamp: ''!
equalsTrue
	| detector matcher |
	detector := self new.
	detector name: 'Unnecessary "= true"'.
	matcher := (ParseTreeSearcher new) addSearches: #('true' 'false') -> 
								[:aNode :answer | 
								answer or: 
										[aNode parent isMessage
											and: [#(#= #== #~= #~~) includes: aNode parent selector]]];
				yourself.
	detector methodBlock: 
			[:context :result | 
			(matcher executeTree: context parseTree initialAnswer: false)
				ifTrue: [result addClass: context selectedClass selector: context selector]].
	^detector! !

!LintRuleTest methodsFor: 'accessing' stamp: ''!
name
	^name! !

!LintRuleTest methodsFor: 'initialize-release' stamp: ''!
resetResult! !

!LintRuleTest methodsFor: 'accessing' stamp: 'bh 3/25/2000 02:00'!
openEditor
	| rules |
	rules := self failedRules.
	rules isEmpty ifTrue: [^self].
	rules size == 1 ifTrue: [^rules first viewResults].
	SmalllintResultEditor openOn: self label: name! !

!LintRuleTest methodsFor: 'private' stamp: ''!
viewResults
	self subclassResponsibility! !

!LintRuleTest methodsFor: 'accessing' stamp: ''!
problemCount
	^self subclassResponsibility! !

!LintRuleTest methodsFor: 'accessing' stamp: ''!
runOnEnvironment: anEnvironment 
	^Object printOn: self onEnvironment: anEnvironment! !

!LintRuleTest methodsFor: 'initialize-release' stamp: ''!
initialize
	name := ''! !

LintRuleTest subclass: #FooLintRuleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Test data'!

FooLintRuleTest subclass: #TransformationRuleTest
	instanceVariableNames: 'rewriteRule builder class'
	classVariableNames: 'RecursiveSelfRule'
	poolDictionaries: ''
	category: 'Refactory-Test data'!

!TransformationRuleTest methodsFor: 'accessing' stamp: ''!
resetResult
	builder := CompositeRefactoryChange new! !

!TransformationRuleTest class methodsFor: 'transformations' stamp: ''!
superSends
	^(self new)
		name: 'Rewrite super messages to self messages when both refer to same method';
		superSends;
		yourself! !

!TransformationRuleTest class methodsFor: 'class initialization' stamp: ''!
nuke
	RecursiveSelfRule := nil! !

!TransformationRuleTest class methodsFor: 'transformations' stamp: ''!
showWhileBlocks
	^self
		rewrite: #(
			#('``@cursor showWhile: [| `@temps | ``@.Statements. `var := ``@object]'
				"->"	'`var := ``@cursor showWhile: [| `@temps | ``@.Statements. ``@object]') 
			#('``@cursor showWhile: [| `@temps | ``@.Statements. ^``@object]'
				"->"	'^``@cursor showWhile: [| `@temps | ``@.Statements. ``@object]'))
		methods: false
		name: 'Move assignment out of showWhile: blocks'! !

!TransformationRuleTest methodsFor: 'accessing' stamp: ''!
checkMethod: aSmalllintContext 
	class := aSmalllintContext selectedClass.
	(rewriteRule executeTree: aSmalllintContext parseTree) ifTrue: 
			[(RecursiveSelfRule executeTree: rewriteRule tree initialAnswer: false)
				ifFalse: 
					[builder compile: rewriteRule tree printString
						in: class
						classified: aSmalllintContext protocols]]! !

!TransformationRuleTest methodsFor: 'private' stamp: ''!
viewResults
	"I reset the result so that we don't fill up memory with methods to compile in the builder."

	builder inspect.
	self resetResult! !

!TransformationRuleTest class methodsFor: 'instance creation' stamp: ''!
rewrite: stringArrays methods: aBoolean name: aName 
	| rewriteRule |
	rewriteRule := ParseTreeRewriter new.
	stringArrays do: 
			[:each | 
			aBoolean
				ifTrue: [rewriteRule addMethodSearch: each first -> each last]
				ifFalse: [rewriteRule addSearch: each first -> each last]].
	^(self new) name: aName;
		rewriteUsing: rewriteRule;
		yourself! !

!TransformationRuleTest methodsFor: 'testing' stamp: ''!
hasConflicts
	^true! !

!TransformationRuleTest class methodsFor: 'transformations' stamp: ''!
equalNil
	^self
		rewrite: #(
			#('``@object = nil'	"->"	'``@object isNil') 
			#('``@object == nil'	"->"	'``@object isNil') 
			#('``@object ~= nil'	"->"	'``@object notNil') 
			#('``@object ~~ nil'	"->"	'``@object notNil'))
		methods: false
		name: '= nil -> isNil AND ~= nil -> notNil'! !

!TransformationRuleTest class methodsFor: 'transformations' stamp: ''!
unwindBlocks
	^self
		rewrite: #(
			#('[| `@temps | ``@.Statements. `var := ``@object] valueNowOrOnUnwindDo: ``@block'
				"->"	'`var := [| `@temps | ``@.Statements. ``@object] valueNowOrOnUnwindDo: ``@block') 
			#('[| `@temps | ``@.Statements. ^``@object] valueNowOrOnUnwindDo: ``@block'
				"->"	'^[| `@temps | ``@.Statements. ``@object] valueNowOrOnUnwindDo: ``@block') 
			#('[| `@temps | ``@.Statements. `var := ``@object] valueOnUnwindDo: ``@block'
				"->"	'`var := [| `@temps | ``@.Statements. ``@object] valueOnUnwindDo: ``@block') 
			#('[| `@temps | ``@.Statements. ^``@object] valueOnUnwindDo: ``@block'
				"->"	'^[| `@temps | ``@.Statements. ``@object] valueOnUnwindDo: ``@block'))
		methods: false
		name: 'Move assignment out of valueNowOrUnwindDo: blocks'! !

!TransformationRuleTest class methodsFor: 'transformations' stamp: ''!
minMax
	^self rewrite: #(
			#('``@a < ``@b ifTrue: [``@a] ifFalse: [``@b]'	"->"	'``@a min: ``@b')
			#('``@a <= ``@b ifTrue: [``@a] ifFalse: [``@b]'	"->"	'``@a min: ``@b')
			#('``@a > ``@b ifTrue: [``@a] ifFalse: [``@b]'	"->"	'``@a max: ``@b')
			#('``@a >= ``@b ifTrue: [``@a] ifFalse: [``@b]'	"->"	'``@a max: ``@b')
			#('``@a < ``@b ifTrue: [``@b] ifFalse: [``@a]'	"->"	'``@a max: ``@b')
			#('``@a <= ``@b ifTrue: [``@b] ifFalse: [``@a]'	"->"	'``@a max: ``@b')
			#('``@a > ``@b ifTrue: [``@b] ifFalse: [``@a]'	"->"	'``@a min: ``@b')
			#('``@a >= ``@b ifTrue: [``@b] ifFalse: [``@a]'	"->"	'``@a min: ``@b')
			#('`a < ``@b ifTrue: [`a := ``@b]'				"->"	'`a := `a max: ``@b')
			#('`a <= ``@b ifTrue: [`a := ``@b]'				"->"	'`a := `a max: ``@b')
			#('`a < ``@b ifFalse: [`a := ``@b]'				"->"	'`a := `a min: ``@b')
			#('`a <= ``@b ifFalse: [`a := ``@b]'			"->"	'`a := `a min: ``@b')
			#('`a > ``@b ifTrue: [`a := ``@b]'				"->"	'`a := `a min: ``@b')
			#('`a >= ``@b ifTrue: [`a := ``@b]'				"->"	'`a := `a min: ``@b')
			#('`a > ``@b ifFalse: [`a := ``@b]'				"->"	'`a := `a max: ``@b')
			#('`a >= ``@b ifFalse: [`a := ``@b]'			"->"	'`a := `a max: ``@b')
			#('``@b < `a ifTrue: [`a := ``@b]'				"->"	'`a := `a min: ``@b')
			#('``@b <= `a ifTrue: [`a := ``@b]'				"->"	'`a := `a min: ``@b')
			#('``@b < `a ifFalse: [`a := ``@b]'				"->"	'`a := `a max: ``@b')
			#('``@b <= `a ifFalse: [`a := ``@b]'			"->"	'`a := `a max: ``@b')
			#('``@b > `a ifTrue: [`a := ``@b]'				"->"	'`a := `a max: ``@b')
			#('``@b >= `a ifTrue: [`a := ``@b]'				"->"	'`a := `a max: ``@b')
			#('``@b > `a ifFalse: [`a := ``@b]'				"->"	'`a := `a min: ``@b')
			#('``@b >= `a ifFalse: [`a := ``@b]'			"->"	'`a := `a min: ``@b'))
		methods: false
		name: 'Rewrite ifTrue:ifFalse: using min:/max:'! !

!TransformationRuleTest class methodsFor: 'class initialization' stamp: ''!
initializeAfterLoad1
	RecursiveSelfRule := ParseTreeSearcher new.
	RecursiveSelfRule
		addMethodSearches: #('`@methodName: `@args | `@temps | self `@methodName: `@args' '`@methodName: `@args | `@temps | ^self `@methodName: `@args')
				-> [:aNode :answer | true]! !

!TransformationRuleTest class methodsFor: 'transformations' stamp: ''!
notElimination
	^self
		rewrite: #(
			#('``@object not not'	"->"	'``@object') 
			#('``@object not ifTrue: ``@block' 	"->"	'``@object ifFalse: ``@block') 
			#('``@object not ifFalse: ``@block'	"->"	'``@object ifTrue: ``@block') 
			#('``@collection select: [:`each | | `@temps | ``@.Statements. ``@object not]'
				"->"	'``@collection reject: [:`each | | `@temps | ``@.Statements. ``@object]')
			#('``@collection reject: [:`each | | `@temps | ``@.Statements. ``@object not]'
				"->"	'``@collection select: [:`each | | `@temps | ``@.Statements. ``@object]')
			#('[| `@temps | ``@.Statements. ``@object not] whileTrue: ``@block'
				"->"	'[| `@temps | ``@.Statements. ``@object] whileFalse: ``@block')
			#('[| `@temps | ``@.Statements. ``@object not] whileFalse: ``@block'
				"->"	'[| `@temps | ``@.Statements. ``@object] whileTrue: ``@block')
			#('[| `@temps | ``@.Statements. ``@object not] whileTrue'
				"->"	'[| `@temps | ``@.Statements. ``@object] whileFalse')
			#('[| `@temps | ``@.Statements. ``@object not] whileFalse'
				"->"	'[| `@temps | ``@.Statements. ``@object] whileTrue')
			#('(``@a <= ``@b) not' "->" '``@a > ``@b')
			#('(``@a < ``@b) not' "->" '``@a >= ``@b')
			#('(``@a = ``@b) not' "->" '``@a ~= ``@b')
			#('(``@a == ``@b) not' "->" '``@a ~~ ``@b')
			#('(``@a ~= ``@b) not' "->" '``@a = ``@b')
			#('(``@a ~~ ``@b) not' "->" '``@a == ``@b')
			#('(``@a >= ``@b) not' "->" '``@a < ``@b')
			#('(``@a > ``@b) not' "->" '``@a <= ``@b'))			
		methods: false
		name: 'Eliminate unnecessary not''s'! !

!TransformationRuleTest class methodsFor: 'transformations' stamp: ''!
guardClause
	^self
		rewrite: #(
			#('`@methodName: `@args 
					| `@temps | 
					`@.Statements. 
					`@condition ifTrue: [| `@trueTemps | `.Statement1. `.Statement2. `@.Statements1]'
			"->"
			'`@methodName: `@args
					| `@temps `@trueTemps |
					`@.Statements.
					`@condition ifFalse: [^self].
					`.Statement1.
					`.Statement2.
					`@.Statements1') 
			#('`@methodName: `@args 
					| `@temps | 
					`@.Statements. 
					`@condition ifFalse: [| `@falseTemps | `.Statement1. `.Statement2. `@.Statements1]'
			"->"
			'`@methodName: `@args
					| `@temps `@falseTemps |
					`@.Statements.
					`@condition ifTrue: [^self].
					`.Statement1.
					`.Statement2.
					`@.Statements1'))
		methods: true
		name: 'Eliminate guarding clauses'! !

!TransformationRuleTest methodsFor: 'initialize-release' stamp: ''!
rewriteUsing: searchReplacer 
	rewriteRule := searchReplacer.
	self resetResult! !

!TransformationRuleTest methodsFor: 'testing' stamp: ''!
isEmpty
	^builder changes isEmpty! !

!TransformationRuleTest class methodsFor: 'transformations' stamp: ''!
betweenAnd
	^self rewrite: #(
			#('``@a >= ``@b and: [``@a <= ``@c]' "->" '``@a between: ``@b and: ``@c')
			#('``@a >= ``@b & (``@a <= ``@c)' "->" '``@a between: ``@b and: ``@c')
			#('``@b <= ``@a and: [``@a <= ``@c]' "->" '``@a between: ``@b and: ``@c')
			#('``@b <= ``@a & (``@a <= ``@c)' "->" '``@a between: ``@b and: ``@c')
			#('``@a <= ``@c and: [``@a >= ``@b]' "->" '``@a between: ``@b and: ``@c')
			#('``@a <= ``@c & (``@a >= ``@b)' "->" '``@a between: ``@b and: ``@c')
			#('``@c >= ``@a and: [``@a >= ``@b]' "->" '``@a between: ``@b and: ``@c')
			#('``@c >= ``@a & (``@a >= ``@b)' "->" '``@a between: ``@b and: ``@c')
			#('``@a >= ``@b and: [``@c >= ``@a]' "->" '``@a between: ``@b and: ``@c')
			#('``@a >= ``@b & (``@c >= ``@a)' "->" '``@a between: ``@b and: ``@c')
			#('``@b <= ``@a and: [``@c >= ``@a]' "->" '``@a between: ``@b and: ``@c')
			#('``@b <= ``@a & (``@c >= ``@a)' "->" '``@a between: ``@b and: ``@c')
			#('``@a <= ``@c and: [``@b <= ``@a]' "->" '``@a between: ``@b and: ``@c')
			#('``@a <= ``@c & (``@b <= ``@a)' "->" '``@a between: ``@b and: ``@c')
			#('``@c >= ``@a and: [``@b <= ``@a]' "->" '``@a between: ``@b and: ``@c')
			#('``@c >= ``@a & (``@b <= ``@a)' "->" '``@a between: ``@b and: ``@c'))
		methods: false
		name: '"a >= b and: [a <= c]" -> "a between: b and: c"'! !

!TransformationRuleTest class methodsFor: 'transformations' stamp: ''!
assignmentInIfTrue
	^self rewrite: #(
			#('``@Boolean ifTrue: [`variable := ``@true] ifFalse: [`variable := ``@false]'
			"->"
			'`variable := ``@Boolean ifTrue: [``@true] ifFalse: [``@false]')
			#('``@Boolean ifFalse: [`variable := ``@true] ifTrue: [`variable := ``@false]'
			"->"
			'`variable := ``@Boolean ifFalse: [``@true] ifTrue: [``@false]'))
		methods: false
		name: 'Move variable assignment outside of single statement ifTrue:ifFalse: blocks'! !

!TransformationRuleTest methodsFor: 'accessing' stamp: ''!
problemCount
	^builder problemCount! !

!TransformationRuleTest class methodsFor: 'transformations' stamp: ''!
detectIfNone
	^self rewrite: #(
			#('(``@collection detect: [:`each | | `@temps | ``@.Statements] ifNone: [nil]) isNil'
				"->"	'(``@collection contains: [:`each | | `@temps | ``@.Statements]) not')
			#('(``@collection detect: [:`each | | `@temps | ``@.Statements] ifNone: [nil]) = nil'
				"->"	'(``@collection contains: [:`each | | `@temps | ``@.Statements]) not')
			#('(``@collection detect: [:`each | | `@temps | ``@.Statements] ifNone: [nil]) == nil'
				"->"	'(``@collection contains: [:`each | | `@temps | ``@.Statements]) not')
			#('(``@collection detect: [:`each | | `@temps | ``@.Statements] ifNone: [nil]) notNil'
				"->"	'``@collection contains: [:`each | | `@temps | ``@.Statements]')
			#('(``@collection detect: [:`each | | `@temps | ``@.Statements] ifNone: [nil]) ~= nil'
				"->"	'``@collection contains: [:`each | | `@temps | ``@.Statements]')
			#('(``@collection detect: [:`each | | `@temps | ``@.Statements] ifNone: [nil]) ~~ nil'
				"->"	'``@collection contains: [:`each | | `@temps | ``@.Statements]'))
		methods: false
		name: 'detect:ifNone: -> contains:'! !

!TransformationRuleTest class methodsFor: 'transformations' stamp: ''!
atIfAbsent
	^self rewrite: #(
			#('``@dictionary at: ``@key 
					ifAbsent: [| `@temps | 
							``@.Statements1.
							``@dictionary at: ``@key put: ``@object.
							``@.Statements2.
							``@object]'
			"->"
			'``@dictionary at: ``@key
					ifAbsentPut: [| `@temps |
							``@.Statements1.
							``@.Statements2.
							``@object]')
			#('``@dictionary at: ``@key
					ifAbsent: [| `@temps |
							``@.Statements.
							``@dictionary at: ``@key put: ``@object]'
			"->"
			'``@dictionary at: ``@key
					ifAbsentPut: [| `@temps |
							``@.Statements.
							``@object]'))
		methods: false
		name: 'at:ifAbsent: -> at:ifAbsentPut:'! !

!TransformationRuleTest methodsFor: 'rules' stamp: ''!
superSends
	| rule |
	rule := ParseTreeRewriter new.
	rule addSearch: 'super `@message: ``@args'
				-> (
					[:aNode | 
					(class withAllSubclasses
						detect: [:each | each includesSelector: aNode selector]
						ifNone: [nil]) isNil]
							-> 'self `@message: ``@args').
	self rewriteUsing: rule! !

!LintRuleTest methodsFor: 'accessing' stamp: ''!
name: aString 
	name := aString! !

!LintRuleTest methodsFor: 'testing' stamp: ''!
hasConflicts
	^false! !

!LintRuleTest methodsFor: 'accessing' stamp: ''!
checkMethod: aSmalllintContext! !

!LintRuleTest methodsFor: 'accessing' stamp: ''!
checkClass: aSmalllintContext! !

!LintRuleTest methodsFor: 'accessing' stamp: ''!
run
	^Object printOn: self! !

!LintRuleTest methodsFor: 'accessing' stamp: ''!
displayName
	| nameStream |
	nameStream := WriteStream on: (String new: 64).
	nameStream nextPutAll: self name;
		nextPutAll: ' ('.
	self problemCount printOn: nameStream.
	nameStream nextPut: $).
	^nameStream contents! !

!LintRuleTest methodsFor: 'printing' stamp: ''!
printOn: aStream 
	name isNil
		ifTrue: [super printOn: aStream]
		ifFalse: [aStream nextPutAll: name]! !

!LintRuleTest methodsFor: 'testing' stamp: ''!
isEmpty
	self subclassResponsibility! !

LintRuleTest subclass: #CompositeLintRuleTest
	instanceVariableNames: 'rules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Test data'!

!CompositeLintRuleTest class methodsFor: 'all checks' stamp: ''!
transformations
	^self ruleFor: TransformationRuleTest protocol: 'transformations'! !

!CompositeLintRuleTest class methodsFor: 'instance creation' stamp: ''!
allRules
	^self ruleFor: self protocol: 'all checks'! !

!CompositeLintRuleTest methodsFor: 'accessing' stamp: ''!
rules
	^rules! !

!CompositeLintRuleTest methodsFor: 'testing' stamp: ''!
hasConflicts
	^(rules detect: [:each | each hasConflicts] ifNone: [nil]) notNil! !

!CompositeLintRuleTest methodsFor: 'accessing' stamp: ''!
failedRules
	^rules inject: OrderedCollection new into: [:oc :each | oc addAll: each failedRules; yourself]! !

!CompositeLintRuleTest methodsFor: 'testing' stamp: ''!
isComposite
	^true! !

!CompositeLintRuleTest methodsFor: 'accessing' stamp: ''!
problemCount
	^rules inject: 0 into: [:count :each | count + each problemCount]! !

!CompositeLintRuleTest methodsFor: 'private' stamp: ''!
viewResults
	rules do: [:each | each viewResults]! !

!CompositeLintRuleTest methodsFor: 'initialize-release' stamp: ''!
rules: aCollection
	rules := aCollection! !

!CompositeLintRuleTest methodsFor: 'accessing' stamp: ''!
checkMethod: aSmalllintContext 
	rules do: 
			[:each | 
			each checkMethod: aSmalllintContext.
			Processor yield]! !

!CompositeLintRuleTest methodsFor: 'initialize-release' stamp: ''!
resetResult
	rules do: [:each | each resetResult]! !

!CompositeLintRuleTest methodsFor: 'accessing' stamp: ''!
checkClass: aSmalllintContext 
	rules do: 
			[:each | 
			each checkClass: aSmalllintContext.
			Processor yield]! !

!CompositeLintRuleTest class methodsFor: 'instance creation' stamp: ''!
rules: aCollection name: aString 
	^(self new) rules: aCollection;
		name: aString;
		yourself! !

!CompositeLintRuleTest class methodsFor: 'instance creation' stamp: ''!
ruleFor: aClass protocol: aProtocol 
	^self
		rules: (((BrowserEnvironment new selectorsFor: aProtocol asSymbol in: aClass class)
				collect: [:selector | aClass perform: selector])
					asSortedCollection: [:a :b | a name < b name])
		name: ((aProtocol asString copy) at: 1 put: aProtocol first asUppercase;
				yourself)! !

!CompositeLintRuleTest class methodsFor: 'all checks' stamp: ''!
lintChecks
	^self rules: (BasicLintRuleTest protocols
				collect: [:each | self ruleFor: BasicLintRuleTest protocol: each])
		name: 'Lint checks'! !

!CompositeLintRuleTest methodsFor: 'testing' stamp: ''!
isEmpty
	^(rules detect: [:each | each isEmpty not] ifNone: [nil]) isNil! !

!CompositeLintRuleTest class methodsFor: 'instance creation' stamp: ''!
rules: aCollection 
	^self new rules: aCollection! !

!LintRuleTest methodsFor: 'testing' stamp: ''!
isComposite
	^false! !

!HierarchyBrowser class methodsFor: '*Refactory-override' stamp: 'dew 9/15/2001 16:19'!
newFor: aClass
	"Open a new HierarchyBrowser on the given class"
	|  newBrowser |
	newBrowser _ HierarchyBrowser new initHierarchyForClass: aClass.
	Browser openBrowserView: (newBrowser openSystemCatEditString: nil)
		label: newBrowser labelString

"HierarchyBrowser newFor: Boolean"! !

!HierarchyBrowser class methodsFor: '*Refactory-override' stamp: 'sw 10/23/2000 18:20'!
newFor: aClass labeled: aLabel
	"Open a new HierarchyBrowser on the given class, using aLabel as the window title."

	|  newBrowser |
	newBrowser _ HierarchyBrowser new initHierarchyForClass: aClass.
	Browser openBrowserView: (newBrowser openSystemCatEditString: nil)
		label: aLabel

"HierarchyBrowser newFor: Boolean labeled: 'Testing'"! !

Browser subclass: #SelectorEnvironmentBrowser
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-UserInterface'!

SelectorEnvironmentBrowser subclass: #ClassEnvironmentBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-UserInterface'!

!ClassEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 6/10/2000 16:59'!
initializeOnEnvironment: aBrowserEnvironment

	environment _ aBrowserEnvironment asSelectorEnvironment.! !

SelectorEnvironmentBrowser subclass: #VariableEnvironmentBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-UserInterface'!

!VariableEnvironmentBrowser class methodsFor: 'as yet unclassified' stamp: 'bh 5/16/2000 22:52'!
newOnEnvironment: aBrowserEnvironment


	^self new initializeOnEnvironment: aBrowserEnvironment.! !

!VariableEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/16/2000 23:12'!
messageList

	self selectedClass 
		ifNil:[ ^Array new ].
	^(self instanceMessagesIndicated
		ifTrue:[ environment instanceVariableSelectorsFor: self selectedClass ]
		ifFalse:[ environment classVariableSelectorsFor: self selectedClass ]) asSortedCollection.! !

!VariableEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/16/2000 23:06'!
classList

	^environment classNamesWithVariables asSortedCollection.! !

!VariableEnvironmentBrowser class methodsFor: 'as yet unclassified' stamp: 'bh 5/16/2000 22:52'!
openOnEnvironment: aBrowserEnvironment
	
	^(self newOnEnvironment: aBrowserEnvironment) open.! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/17/2000 18:54'!
compileMessage: aText notifying: aController

"
	self needsWork.
	self error:'cannot accept methods yet.  Sorry.'"

	^super compileMessage: aText notifying: aController.! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 20:30'!
open

	World ifNotNil: [^ self openAsMorph].
	self error: self class name asString, ' only works in Morphic so far.'.! !

!SelectorEnvironmentBrowser class methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 20:27'!
openOnEnvironment: aBrowserEnvironment
	
	^(self newOnEnvironment: aBrowserEnvironment) open.! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 10/3/2001 01:37'!
openAsMorph
	| window switches codePane aListMorph baseline |
	window _ (SystemWindow labelled: environment label) model: self.

	window addMorph: (PluggableListMorph on: self list: #classList
			selected: #classListIndex changeSelected: #classListIndex:
			menu: #classListMenu:shifted: keystroke: #classListKey:from:)
		frame: (0@0 extent: 0.5@0.3).
	switches _ self buildMorphicSwitches.
	window addMorph: switches frame: (0@0.3 extent: 0.5@0.1).
	switches borderWidth: 0.
	aListMorph _ PluggableListMorph on: self list: #messageList
			selected: #messageListIndex changeSelected: #messageListIndex:
			menu: #messageListMenu:shifted:
			keystroke: #messageListKey:from:.
	aListMorph menuTitleSelector: #messageListSelectorTitle.
	window addMorph: aListMorph
		frame: (0.5@0 extent: 0.5@0.4).
	
	baseline _ 0.4.

	codePane _ PluggableTextMorph on: self text: #contents accept: #contents:notifying:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:.

	window addMorph: codePane
		frame: (0 @ baseline corner: 1 @ 1).

	window setUpdatablePanesFrom: #(classList messageList).
	^ window! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 22:02'!
messageListKey: aChar from: view ! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 21:59'!
classListKey: aChar from: view ! !

!SelectorEnvironmentBrowser class methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 20:27'!
newOnEnvironment: aBrowserEnvironment


	^self new initializeOnEnvironment: aBrowserEnvironment.! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 23:18'!
contents
	|method|

	(method _ self selectedMethod) ifNil:[ ^''].
	^method parseTree formattedCode.

! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 23:20'!
selectedMethod

	| nonMetaClass selector class |

	(nonMetaClass _ self selectedClass) ifNil:[ ^nil ].
	(selector _ self selectedMessageName) ifNil:[ ^nil ].
	class _ self classMessagesIndicated ifTrue:[ nonMetaClass class ] ifFalse:[ nonMetaClass ].

	^class >> selector.! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 22:45'!
contents: input notifying: aController 
	| aText |
	aText _ input asText.
	
	^ self okayToAccept
		ifFalse: [false]
		ifTrue: [self compileMessage: aText notifying: aController]! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 22:00'!
classListMenu: aMenu 
^ aMenu! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 21:10'!
defaultBackgroundColor

	^ Color white! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 21:55'!
selectedClass
	"Answer the class that is currently selected. Answer nil if no selection 
	exists."

	| name |
	(name _ self selectedClassName) ifNil: [^ nil].
	^ Smalltalk at: name! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 23:14'!
messageList

	self selectedClass 
		ifNil:[ ^Array new ].
	^(self instanceMessagesIndicated
		ifTrue:[ environment privateSelectorsForClass: self selectedClass ]
		ifFalse:[ environment privateSelectorsForClass: self selectedClass class ]) asSortedCollection.
! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/15/2000 21:30'!
contentsSelection
	"Return the interval of text in the code pane to select when I set the pane's contents"

	^(environment selectionIntervalFor:self contents) ifNil:[1 to: 0].
 

! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 23:13'!
messageListIndex: anInteger 
	"Set the selected message selector to be the one indexed by anInteger."

	messageListIndex _ anInteger.
	contents _ nil.
self needsWork.
	self changed: #messageListIndex.
	self contentsChanged! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2004 22:04'!
buildMorphicSwitches

	| instanceSwitch classSwitch row aColor |
	instanceSwitch _ PluggableButtonMorph
		on: self
		getState: #instanceMessagesIndicated
		action: #indicateInstanceMessages.
	instanceSwitch
		label: 'instance';
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		askBeforeChanging: true.
	classSwitch _ PluggableButtonMorph
		on: self
		getState: #classMessagesIndicated
		action: #indicateClassMessages.
	classSwitch
		label: 'class';
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		askBeforeChanging: true.
	row _ AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderColor: Color transparent;
		layoutInset: 0;
		borderWidth: 0;
		addMorphBack: instanceSwitch;
		addMorphBack: classSwitch.

	aColor _ Color colorFrom: self defaultBackgroundColor.
	row submorphs do:
		[:m | m color: aColor.
		m onColor: aColor darker offColor: aColor].

	^ row! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 20:28'!
initializeOnEnvironment: aBrowserEnvironment

	environment _ aBrowserEnvironment.! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/17/2000 18:47'!
selectedMessageCategoryName 
	"Answer the name of the selected message category or nil."
	messageListIndex = 0 ifTrue: [^ nil].
	^ self selectedClassOrMetaClass organization categoryOfElement: self selectedMessageName! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 23:13'!
classListIndex: anInteger 
	"Set anInteger to be the index of the current class selection."

	classListIndex _ anInteger.
	messageListIndex _ 0.
	contents _ nil.

self needsWork.
	self changed: #classSelectionChanged.
	self changed: #classListIndex.	
	self changed: #messageList.
	self changed: #contents.
! !

!SelectorEnvironmentBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/14/2000 21:48'!
classList

	^environment classNames! !

Browser subclass: #RefactoringBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-UserInterface'!

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 14:37'!
classVariableMenu
	^(MenuMorph new)
		defaultTarget: self;
		add: 'references...' action: #browseClassVarRefs;
		add: 'rename class variable...' action: #renameClassVar;
		add: 'push up' action: #pushUpSelectedClassVar;
		add: 'create accessors' action: #createClassVarAccessors;
		add: 'abstract' action: #abstractClassVar;
		yourself! !

!RefactoringBrowser methodsFor: 'message pane' stamp: 'dvf 9/1/2001 19:04'!
addParameter
	| newSelector aCollection |
	messageListIndex = 0 ifTrue: [^self].
	self okToChange ifFalse: [^self].
	newSelector := self addParameterTo: self selector
				in: self selectedClassOrMetaClass.
	newSelector isNil ifTrue: [^self].
	aCollection := Array with: newSelector.
	self changed: #messageList.
	self changedSelector.
	self beep! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 5/19/2000 23:18'!
selectedVariableName
	| node |
	node := self findNode.
	^(node notNil and: [node isVariable]) ifTrue: [node name] ifFalse: [nil]! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'dvf 9/8/2001 19:58'!
checkProtocolMatchFor: aSelector in: aClass 

	self needsWork.
	self error:'not yet implemented'.

[ "comment block"
	| protocol superClass superProtocol patchClass |
	protocol := aClass organization categoryOfElement: aSelector.
	protocol isNil ifTrue: [^false].
	superClass := aClass superclass whichClassIncludesSelector: aSelector.
	superClass isNil ifTrue: [^false].
	superProtocol := superClass organization categoryOfElement: aSelector.
	superProtocol == protocol ifTrue: [^false].
	superProtocol isNil ifTrue: [^false].
	patchClass := self 
				choose: (aSelector printString , ' is classified under "' , protocol 
						, '" in ' , aClass name 
						, '\and under "' , superProtocol 
						, '" in ' , superClass name 
						, '. Patch?') withCRs
				labels: (Array 
						with: aClass name asString
						with: superClass name asString
						with: 'neither')
				values: (Array 
						with: aClass
						with: superClass
						with: nil)
				default: aClass.
	patchClass isNil ifTrue: [^false].
	patchClass == aClass 
		ifTrue: 
			[self 
				moveMethods: (Array with: aSelector)
				to: superProtocol
				in: aClass]
		ifFalse: 
			[self 
				moveMethods: (Array with: aSelector)
				to: protocol
				in: superClass].
	^true
].! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 10:48'!
browseReferencesTo: aLiteral 
	self
		showWaitCursorWhile: [(self environment referencesTo: aLiteral) openEditor]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/29/2001 18:13'!
selectedClassInCode
	^Smalltalk classNamed: self findNode name asSymbol! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:06'!
selectInstVarSupers: supersBoolean subs: subsBoolean

	(supersBoolean & subsBoolean) ifTrue:[^self error:'cannot select ivars from subs and supers yet. sorry.'].
	(supersBoolean | subsBoolean) ifFalse:[self selectedClassOrMetaClass chooseThisClassInstVarThenDo:[:ivar| ^ivar]. ^''].
	supersBoolean ifTrue:[^self selectInstVar].
	subsBoolean ifTrue:[^self selectSubclassInstVar].
! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 5/12/2000 22:14'!
changedSelector

	self changed: #contents.! !

!RefactoringBrowser methodsFor: 'message pane' stamp: 'bh 5/12/2000 21:58'!
removeMethodsSafe: sels from: cls 
	self
		handleError: [(RemoveMethodRefactoring removeMethods: sels from: cls) execute]
! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 00:59'!
browseInstVarReaders
	| name |
	name := self selectInstVar.
	name notNil 
		ifTrue: [self navigator browseGlobalInstVarReadersTo: name in: self selectedClassOrMetaClass]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/12/2000 23:05'!
removeClassesSafe: classCollection 
	self handleError: 
			[(RemoveClassRefactoring 
				classNames: (classCollection collect: [:each | each name])) execute]
! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'rga 9/16/2001 22:06'!
browseInstVarRefs
	"first handle situation where no class selected"
	| name |
	self selectedClass
		ifNil: [^ self inform: 'Nothing selected.'].
	name _ self selectInstVar.
	"then handle the situation where no ivar selected"
	name isEmpty
		ifFalse: [self navigator browseGlobalInstVarRefsTo: name in: self selectedClassOrMetaClass]! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 5/19/2000 23:13'!
convertToSourceInterval: anInterval 
	"Convert the selected interval from our text widget, to the interval in the stored source code.
	For this widget, we don't need to do anything."

	^anInterval! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 11/7/2000 23:01'!
requestClassName
	| name |
	name := self request: 'Enter a class name:'.
	^name isEmpty ifTrue: [nil] ifFalse: [name]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/30/2001 18:12'!
pushDownClassVar
	| classVar |
	self changeRequest ifFalse: [^self].
	classVar := self selectClassVarSupers: false subs: false.
	classVar isNil ifTrue: [^self].
	self handleError: 
			[(PushDownClassVariableRefactoring variable: classVar
				class: self nonMetaClass) execute.
			self changedClass].

self needsWork.
! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/26/2001 17:02'!
renameInstVar: oldName in: aClass 
	| newName |
	newName := self requestInstVarName: oldName.
	newName isNil ifTrue: [^self].
	self handleError: 
			[(RenameInstanceVariableRefactoring rename: oldName
				to: newName
				in: aClass) execute]! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 5/12/2000 23:13'!
newClassList:aCollection

	self changed: #classList.! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/26/2001 18:22'!
extractMethodToComponent
	messageListIndex = 0 ifTrue: [^self].
	self okToChange ifFalse: [^self].
	self performRefactoring: (ExtractMethodToComponentRefactoring
				extract: self selectedInterval
				from: self selectedMessageName
				in: self selectedClassOrMetaClass).
	self beep.! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 00:58'!
browseSelectedInstVarWriters
	| name |
	name := self selectedVariableName.
	name notNil 
		ifTrue: [self navigator browseGlobalInstVarWritersTo: name in: self selectedClassOrMetaClass]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/2/2001 00:20'!
renameMethod: aSelector in: aClass 
	| oldMethodName newMethodName oldArguments argumentPermutation |
	oldArguments := (RBParser parseMethod: self selectedMessage) argumentNames.
	oldMethodName := RBMethodName selector: aSelector arguments: oldArguments.
	(newMethodName := MethodNameEditor forMethodName: oldMethodName) 
		ifNil: [^nil].
	argumentPermutation := newMethodName arguments 
				collect: [:e | oldArguments indexOf: e].
	^self handleError: 
			[(RenameMethodRefactoring 
				renameMethod: aSelector
				in: aClass
				to: newMethodName selector
				permuation: argumentPermutation) execute.
			newMethodName selector]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/30/2001 01:15'!
performRefactoring: aRefactoring 
	aRefactoring isNil ifTrue: [^self].
	self handleError: 
			[aRefactoring execute.
			self changed: #messageList.
			self changed: #contents]


! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 11/8/2000 10:47'!
isMeta

	^self metaClassIndicated.! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 11:04'!
browseInstVarReadersTo: instVar in: aClass 
	self showWaitCursorWhile: 
			[(self environment instVarReadersTo: instVar in: aClass) openEditor]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/29/2001 17:44'!
inlineSelfSends
	messageListIndex = 0 ifTrue: [^self].
	self handleError: 
			[| refactoring aCollection |
			refactoring := InlineAllSendersRefactoring sendersOf: self selector
						in: self selectedClassOrMetaClass.
			refactoring execute.
			refactoring messagesNotReplaced > 0 
				ifTrue: 
					[self warn: ('<1p> message sends were not replaced' 
								expandMacrosWith: refactoring messagesNotReplaced)].
			self changed: #messageList. 
			self changedSelector].
	self beep! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 10/15/2000 21:04'!
nonMetaClasses

	^{self selectedClassOrMetaClass}.! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:02'!
bindTight
	self performRefactoring: (MoveVariableDefinitionRefactoring 
				bindTight: (self convertToSourceInterval: self selectedInterval)
				in: self selectedClassOrMetaClass
				selector: self selector)! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 00:56'!
createInstVarAccessors
	| name |
	name := self selectInstVar.
	name isNil ifTrue: [^self].
	self createAccessorsForInstVar: name
! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 5/12/2000 22:10'!
selector

	^self selectedMessageName.! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/8/2001 21:03'!
selectSubclassesOf: aClass 
	| subclasses |
	subclasses := aClass subclasses 
				asSortedCollection: [:a :b | a name < b name].
	subclasses isEmpty ifTrue: [^#()].
	^ChooserMorph 
		choose: 'Choose subclasses:'
		multipleSelect: true
		fromList: subclasses
		values: subclasses
		cancel: [nil]! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 5/19/2000 23:37'!
showWaitCursorWhile: aBlock

	^Cursor execute showWhile:aBlock.
! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 6/14/2000 10:30'!
changed: aSymbol with:anObject

	"Temporary"
	aSymbol == #category ifTrue: [ self changed: #categoryList ].
	! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 14:37'!
pushUpSelectedClassVar
	| name |
	name := self selectClassVar.
	name isNil ifTrue: [^self].
	self pushUpClassVar: name! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:03'!
createInstVar
	self performRefactoring: (TemporaryToInstanceVariableRefactoring 
				class: self selectedClassOrMetaClass
				selector: self selector
				variable: self selectedText)! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 18:55'!
extractMethod
	| currentSelector |
	messageListIndex = 0 ifTrue: [^self].
	self okToChange ifFalse: [^self].
	currentSelector _ self selectedMessageName.
	self performRefactoring: (ExtractMethodRefactoring 
				extract: self selectedInterval
				from: self selectedMessageName
				in: self selectedClassOrMetaClass).
	self messageListIndex: (self messageList indexOf: currentSelector).
	self beep.! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/19/2000 23:49'!
pushUpClassVar: aString 
	self performRefactoring: (PullUpClassVariableRefactoring 
				variable: aString asSymbol
				class: (self nonMetaClass whichClassDefinesClassVar: aString) superclass)! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:07'!
renameInstVar: aString 
	self navigator renameInstVar: aString
		in: (self selectedClassOrMetaClass whichClassDefinesInstVar: aString).
	self updateContents! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 14:36'!
pushUpSelectedInstVar
	| instVar |
	self changeRequest ifFalse: [^self].
	instVar := self selectedVariableName.
	instVar isNil ifTrue: [^self].
	self handleError: 
			[(PullUpInstanceVariableRefactoring variable: instVar
				class: self selectedClassOrMetaClass) execute.
			self changedClass].
	self beep! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 14:45'!
pullUpClassVar
	| classVar |
	self changeRequest ifFalse: [^self].
	classVar := self selectSubclassClassVar.
	classVar isNil ifTrue: [^self].
	self pullUpClassVar: self nonMetaClass in: classVar.! !

!RefactoringBrowser methodsFor: 'message pane' stamp: 'dvf 9/1/2001 19:26'!
renameMethod
	| newSelector |
	messageListIndex = 0 ifTrue: [^self].
	self okToChange ifFalse: [^self].
	newSelector := self renameMethod: self selector
				in: self selectedClassOrMetaClass.
	newSelector isNil ifTrue: [^self].
	self changed: #messageList.
	self messageListIndex: (self messageList indexOf: newSelector).
	self changedSelector.
	self beep! !

!RefactoringBrowser methodsFor: 'menus' stamp: 'nk 10/27/2002 09:39'!
messageListMenu: aMenu shifted: shifted
	^ shifted ifFalse: [aMenu labels:
'browse full (b)
fileOut
printOut
senders of... (n)
implementors of... (m)
method inheritance (h)
versions (v)
inst var refs...
inst var defs...
class var refs...
class variables
class refs (N)
remove
RB - safe remove
RB - add parameter
RB - rename method
RB - inline all self sends
RB - push up
RB - push down
more...'
	lines: #(3 7 12)
	selections:
		#(browseMethodFull fileOutMessage printOutMessage
		browseSendersOfMessages browseMessages methodHierarchy browseVersions
		browseInstVarRefs browseInstVarDefs browseClassVarRefs 
			browseClassVariables browseClassRefs
		removeMessage removeMethodSafe addParameter renameMethod inlineSelfSends pushUpMethod pushDownMethod shiftedYellowButtonActivity )]

	ifTrue: [aMenu labels: 'browse class hierarchy
browse class
browse method (O)
make stand-alone method pane
toggle diffing
implementors of sent messages
local senders of...
local implementors of...
change sets with this method
inspect instances
inspect subinstances
remove from this browser
change category...
revert to previous version
remove from current change set
revert and forget
fetch documentation
more...' 
	lines:  #(5 8 11 13 16)
	selections: #(classHierarchy browseClass 
		openSingleMessageBrowser makeIsolatedCodePane toggleDiffing browseAllMessages 
browseLocalSendersOfMessages browseLocalImplementors findMethodInChangeSets 
		inspectInstances inspectSubInstances
		removeMessageFromBrowser 
		changeCategory
		revertToPreviousVersion 
		removeFromCurrentChanges revertAndForget 
		fetchDocPane
		unshiftedYellowButtonActivity)]! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 11:10'!
removeInstVar: instVar fromClass: cls 
	self handleError: 
			[(RemoveInstanceVariableRefactoring variable: instVar class: cls) execute]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 00:39'!
abstractInstVar
	| name |
	name := self selectInstVar.
	name isEmpty ifTrue: [^self].
	self abstractInstVar: name! !

!RefactoringBrowser methodsFor: 'menus' stamp: 'dvf 9/29/2001 18:15'!
valueNodeMenuFor: aNode 

	^MenuMorph new
		defaultTarget:self;
		add: 'extract to temporary...' action: #extractToTemp;
		yourself! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 11/8/2000 11:21'!
convertToSibling

	| name subclasses |
self needsWork.  "Still not right."

	name := self request: 'Enter name for new parent class'.
	name isEmpty ifTrue: [^self].
	subclasses := self selectSubclassesOf: self nonMetaClass.
	subclasses isNil ifTrue: [^self].
	self handleError: 
			[(ChildrenToSiblingsRefactoring name: name
				class: self nonMetaClass
				subclasses: subclasses) execute.
			self selectClasses: (Array with: name asSymbol)
				meta: self isMeta
				categories: self categories]! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 10:17'!
addClassVar
	self changeRequest ifFalse: [^self].
	self addClassVarIn: self nonMetaClass.
	self changedClass! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 11:07'!
rbRenameClass
	self changeRequest ifFalse: [^self].
	self renameClass: self nonMetaClass! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 11:09'!
removeClassVar
	| classVar |
	self changeRequest ifFalse: [^self].
	classVar := self selectClassVarSupers: false subs: false.
	classVar isNil ifTrue: [^self].
	self handleError: 
			[(RemoveClassVariableRefactoring variable: classVar
				class: self nonMetaClass) execute.
			self changedClass]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/8/2001 21:03'!
selectClassVariables
	| variables |
	variables := self nonMetaClass classVarNames asSortedCollection.
	variables isEmpty ifTrue: [^#()].
	^ChooserMorph 
		choose: 'Choose variables:'
		multipleSelect: true
		fromList: variables
		values: variables
		cancel: [#()]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:03'!
inlineParameter
	self handleError: 
			[| ref |
			ref := InlineParameterRefactoring 
						inlineParameter: self selectedText
						in: self selectedClassOrMetaClass
						selector: self selector.
			ref execute.
			"codeModel setSelector: ref newSelector"]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/19/2000 23:45'!
renameClassVar: aString 
	self navigator renameClassVar: aString asSymbol
		in: (self nonMetaClass whichClassDefinesClassVar: aString).
	self updateContents! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:04'!
inlineTemporary
	| node |
	self updateRequest ifFalse: [^self].
	node := self findNode.
	(node isNil or: [node isAssignment not]) 
		ifTrue: [^self warn: 'Could not find the node'].
	self performRefactoring: (InlineTemporaryRefactoring 
				inline: (self convertToSourceInterval: node sourceInterval)
				from: self selector
				in: self selectedClassOrMetaClass)! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 00:58'!
browseInstVarWriters
	| name |
	name := self selectInstVar.
	name notNil 
		ifTrue: [self navigator browseGlobalInstVarWritersTo: name in: self selectedClassOrMetaClass]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/30/2001 02:18'!
extractToTemp
	| newName node |
	self updateRequest ifFalse: [^self].
	node := self findNode.
	(node isNil or: [node isValue not]) 
		ifTrue: [^self warn: 'Could not find the node'].
	newName := self request: 'Enter name for Temporary:'.
	newName isEmpty ifTrue: [^self].
	self performRefactoring: (ExtractToTemporaryRefactoring 
				extract: (self convertToSourceInterval: node sourceInterval)
				to: newName
				from: self selector
				in: self selectedClassOrMetaClass)! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:04'!
protectInstVar: aString 
	self 
		performRefactoring: (ProtectInstanceVariableRefactoring variable: aString
				class: (self selectedClassOrMetaClass whichClassDefinesInstVar: aString))! !

!RefactoringBrowser methodsFor: 'message pane' stamp: 'bh 5/20/2000 11:29'!
browseImplementors
	| node |
	node := self findNode.
	(node isNil or: [node isMessage not]) ifTrue: [^self].
	(BrowserEnvironment new implementorsOf: node selector) openEditor! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 19:07'!
temporaryMenuFor: aNode 

	aNode parent ifNil:[^self noMenu].
	^aNode parent isMethod
		ifTrue:[self parameterMenu]
		ifFalse:[self temporaryMenu].! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 00:59'!
browseSelectedClassVarRefs
	| name association |
	name := self selectedVariableName.
	association := self navigator findAssociationForClassVariable: name.
	self navigator browseGlobalReferencesTo: association in: self nonMetaClass! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 14:44'!
pullUpClassVar: class in: classVar 
	| refactoring |
	refactoring := PullUpClassVariableRefactoring variable: classVar
				class: class.
	self performClassRefactoring: refactoring! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 00:43'!
protectInstVar
	| name |
	name := self selectInstVar.
	name isNil ifTrue: [^self].
	self protectInstVar: name! !

!RefactoringBrowser methodsFor: 'menus' stamp: 'dvf 9/29/2001 19:20'!
classListMenu: aMenu shifted: shifted

	super classListMenu: aMenu shifted: shifted.
	self addClassSubMenuTo: aMenu.
	self addClassVariableSubMenuTo: aMenu.
	self addInstanceVariableSubMenuTo: aMenu.

	^aMenu! !

!RefactoringBrowser methodsFor: 'menus' stamp: 'ich. 3/26/2004 20:34'!
systemCategoryMenu: aMenu
	| newMenu |
	newMenu _ super systemCategoryMenu: aMenu.
	newMenu addLine.
	newMenu add: 'find code like...' target: self selector: #finderOnClassCategory argument: nil.
	newMenu add: 'find code in package like...' target: self selector: #finderOnPackageWithClassCategory argument: nil.
	^newMenu! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 5/19/2000 23:31'!
navigator

	^self.! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:02'!
abstractInstVar: aString 
	self 
		performRefactoring: (AbstractInstanceVariableRefactoring variable: aString
				class: (self selectedClassOrMetaClass whichClassDefinesInstVar: aString))! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 11:03'!
findReferencePathToInstance

	self needsWork.
	self error:'ReferenceFinder does not work yet, sorry.'.

	"self showWaitCursorWhile: 
			[| path |
			path := ReferenceFinder findPathToInstanceOf: self selectedClass.
			path notNil 
				ifTrue: [path inspect]
				ifFalse: [self warn: 'No reference paths exist']]"! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 00:55'!
renameSelectedClassVar
	| name |
	name := self selectedVariableName.
	name isNil ifTrue: [^self].
	self renameClassVar: name
! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:06'!
selectSubclassInstVar

	self selectedClassOrMetaClass chooseSubclassesInstVarThenDo:[:ivar| ^ivar].
	^''.! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 01:11'!
renameClassVar
	| name |
	name := self selectClassVar.
	name isNil ifTrue: [^self].
	self renameClassVar: name
! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 6/14/2000 10:19'!
addClassVarIn: aClass 
	| newName |
	newName := self requestClassVarName: ''.
	newName isNil ifTrue: [^self].
	self handleError: 
			[(AddClassVariableRefactoring variable: newName class: aClass) execute]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/12/2000 23:15'!
removeClassSafe
	classListIndex = 0 ifTrue: [^self].
	self changeRequest ifFalse: [^self].
	self removeClassesSafe: self nonMetaClasses.
	self newClassList: self classNames.
	self changedClass! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'hboon 11/26/2004 11:27'!
browseClassVarRefs
	| name association |
	name := self selectClassVar.
	name isEmptyOrNil ifTrue: [^self].
association := self navigator findAssociationForClassVariable: name.
			self navigator browseGlobalReferencesTo: association in: self nonMetaClass! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'dvf 9/8/2001 20:06'!
request: aString
	^FillInTheBlank request: aString! !

!RefactoringBrowser methodsFor: 'menus' stamp: 'dvf 9/29/2001 18:21'!
parameterMenu
	"MenuEditor new openOnClass: self andSelector: #temporaryMenu"

	^MenuMorph new
		defaultTarget:self;
		add: 'remove parameter' action: #removeParameter;
		add: 'inline parameter' action: #inlineParameter;
		add: 'rename...' action: #renameTemporary;
		yourself

"Things that used to be here -
#(#MenuItem #rawLabel: 'con&vert to instance variable' #value: #createInstVar) 
#(#MenuItem #rawLabel: 'move to inner &scope' #value: #bindTight)) #(5) nil) 
		decodeAsLiteralArray"! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 5/12/2000 22:35'!
selectors

	^{self selectedMessageName}! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 5/12/2000 22:29'!
changeRequest

	^self okToChange.! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 00:40'!
abstractClassVar
	| name |
	name := self selectClassVar.
	name isEmpty ifTrue: [^self].
	self abstractClassVar: name! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/26/2001 17:02'!
renameInstVar
	| name |
	name := self selectInstVarSupers: false subs: false.
	name isNil ifTrue: [^self].
	self renameInstVar: name! !

!RefactoringBrowser methodsFor: 'message pane' stamp: 'bh 10/15/2000 21:05'!
pushUpMethod

	messageListIndex = 0 ifTrue: [^self].
	self okToChange ifFalse: [^self].
	self handleError: 
			[(PushUpMethodRefactoring pushUp: {self selectedMessageName} from: self selectedClassOrMetaClass)
				execute.
			self changed: #messageList.
			self changed: #contents.
			].
	self beep.
! !

!RefactoringBrowser methodsFor: 'message pane' stamp: 'bh 10/15/2000 21:05'!
pushDownMethod

	messageListIndex = 0 ifTrue: [^self].
	self okToChange ifFalse: [^self].
	self handleError: 
			[(PushDownMethodRefactoring pushDown: {self selectedMessageName} from: self selectedClassOrMetaClass)
				execute.
			self changed: #messageList.
			self changed: #contents.
			].
	self beep.
! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/16/2001 12:53'!
temporaryMenu
	"MenuEditor new openOnClass: self andSelector: #temporaryMenu"

	^MenuMorph new
		defaultTarget:self;
		add: 'convert to instance variable' action:#createInstVar;
		add: 'rename...' action: #renameTemporary;
		add: 'move to inner scope' action: #bindTight;
		yourself
! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'dvf 8/26/2001 16:33'!
updateContents

	self changedClass.! !

!RefactoringBrowser methodsFor: 'menus' stamp: 'ich. 3/26/2004 20:41'!
addClassSubMenuTo: aMenu
	World ifNotNil: 
			[aMenu defaultTarget: aMenu.
			aMenu add: 'RB - class'
				subMenu: ((MenuMorph new)
						defaultTarget: self;
						add: 'find code like...' action: #finderOnClass;
						add: 'find code in package like...' target: self action: #finderOnPackageWithClassCategory;
						add: 'references...' action: #classRefs;
						add: 'create subclass...' action: #createSubclass;
						add: 'rename as...' action: #rbRenameClass;
						add: 'remove...' action: #removeClass;
						add: 'safe remove' action: #removeClassSafe;
						add: 'convert to sibling' action: #convertToSibling;
						add: 'inspect all instances...' action: #inspectAllInstances;
						add: 'find reference path to an instance...'
							action: #findReferencePathToInstance;
						add: 'find all reference paths to an instance...'
							action: #findAllReferencesToInstances;
						add: 'check protocols...' action: #checkProtocols;
						yourself)]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 6/14/2000 10:33'!
changeClassCategoryFor: classCollection 

	self needsWork.
	self error:'not yet implemented.'.

	"| dialog newCategory oldCategory changeClasses |
	classCollection isEmpty ifTrue: [^self].
	oldCategory := self environment whichCategoryIncludes: classCollection first name.
	dialog := CategoryDialog new.
	dialog organizer: Smalltalk organization.
	dialog currentCategory: oldCategory.
	dialog open ifFalse: [^self].
	newCategory := dialog categoryName asSymbol.
	changeClasses := classCollection
				select: [:each | (self environment whichCategoryIncludes: each name) ~= newCategory].
	changeClasses isEmpty ifTrue: [^self].
	changeClasses do: 
			[:each | 
			Smalltalk organization classify: each name under: newCategory.
			ChangeSet current changeClass: each]"! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 11:05'!
browseInstVarWritersTo: instVar in: aClass 
	self showWaitCursorWhile: 
			[(self environment instVarWritersTo: instVar in: aClass) openEditor]! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 10/15/2000 21:04'!
instVarReaders
	| instVar |
	instVar := self selectInstVarSupers: true subs: false.
	instVar notNil
		ifTrue: [self browseInstVarReadersTo: instVar in: self selectedClassOrMetaClass]! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 5/19/2000 23:12'!
updateRequest

	^true.! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'dvf 9/8/2001 19:58'!
checkProtocols
	self changeRequest ifFalse: [^self].
	Cursor wait showWhile: 
			[(self nonMetaClasses inject: false
				into: 
					[:changed :class | 
					changed | (self checkProtocolsFor: class)
						| (self checkProtocolsFor: class class)])
					ifTrue: [self setState: self getState updateClasses: true]
					ifFalse: [self warn: 'No changes made.']]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:05'!
pushDownInstVar
	| instVar |
	self changeRequest ifFalse: [^self].
	instVar := self selectInstVarSupers: false subs: false.
	instVar isNil ifTrue: [^self].
	self handleError: 
			[(PushDownInstanceVariableRefactoring variable: instVar
				class: self selectedClassOrMetaClass) execute.
			self changedClass]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'ich. 3/26/2004 20:41'!
addInstanceVariableSubMenuTo: aMenu

	World ifNotNil:
		[aMenu defaultTarget: aMenu.
		aMenu add: 'RB - instance variables' subMenu:
			(MenuMorph new
				defaultTarget:self;
				add:'references...' action:#instVarRefs ;
				add:'readers...' action:#instVarReaders ;
				add:'writers...' action:#instVarWriters ;
				add:'add...' action:#addInstVar ;
				add:'rename as...' action:#renameInstVar ;
				add:'remove...' action:#removeInstVar ;
				add:'push down...' action:#pushDownInstVar ;
				add:'pull up...' action:#pullUpInstVar ;
				add:'create accessors...' action:#createInstVarAccessors ;
				add:'abstract...' action:#abstractInstVar ;
				add:'protect/concrete...' action:#protectInstVar ;
				yourself)].
! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 10/15/2000 21:02'!
addInstVar
	self changeRequest ifFalse: [^self].
	self addInstVarIn: self selectedClassOrMetaClass.
	self changedClass! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 11/5/2000 22:06'!
className

	^self selectedClassName.! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/20/2000 11:15'!
browseGlobalInstVarReadersTo: instVar in: aClass 
	self showWaitCursorWhile: 
			[(BrowserEnvironment new instVarReadersTo: instVar in: aClass) openEditor]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/17/2000 21:12'!
selectMenu
	| node |
	node := self findNode.
	node isNil ifTrue: [^self noMenu].
	node isVariable ifTrue: [^self selectVariableMenuFor: node].
	node isMessage ifTrue: [^self messageMenuFor: node].
	node isAssignment ifTrue: [^self assignmentMenuFor: node].
	node isValue ifTrue: [^self valueNodeMenuFor: node].
	^self noMenu! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/19/2000 23:57'!
browseReferencesToGlobal
	| name association |
	name := self selectedVariableName.
	name isNil ifTrue: [^self].
	association := Smalltalk associationAt: name asSymbol ifAbsent: [^self].
	self navigator browseGlobalReferencesTo: association! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 10:47'!
classRefs
	self browseReferencesTo: (self environment associationAt: self className)! !

!RefactoringBrowser methodsFor: 'menus' stamp: 'dvf 9/29/2001 18:58'!
codePaneMenu: aMenu shifted: shifted

	super codePaneMenu: aMenu shifted: shifted.
	aMenu add: 'RB - extract method' action: #extractMethod.
	aMenu add: 'RB - extract method to component' action: #extractMethodToComponent.
	self addSelectionSubMenuTo: aMenu.
	^aMenu! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'dvf 10/3/2001 18:18'!
checkProtocolFor: aSelector in: aClass 
	| exp1 exp2 exp3 exp4 |
	self needsWork.
	self error:'not yet implemented'.
 {exp1.
 [exp2].
 exp3.
 [exp4]} allTrue
"	| protocol |
	protocol := aClass organization categoryOfElement: aSelector.
	^protocol isNil 
		ifTrue: 
			[(Dialog confirm: aSelector asString 
						, ' is not classified under a protocol.\Do you want to classify it?' 
								withCRs) 
				ifTrue: 
					[protocol := Dialog 
								request: 'Enter a protocol name for ' asText 
										, (aSelector asText emphasizeAllWith: #(#italic)) , ':'.
					protocol isEmpty 
						ifFalse: 
							[self 
								moveMethods: (Array with: aSelector)
								to: protocol
								in: aClass]].
			true]
		ifFalse: [false]"! !

!RefactoringBrowser class methodsFor: 'as yet unclassified' stamp: 'dvf 8/27/2003 14:40'!
unload
	"Called when the class is being removed"

	TheWorldMenu unregisterOpenCommandWithReceiver: self! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/8/2001 21:03'!
selectInstanceVariables
	| variables |
	variables := self selectedClass instVarNames asSortedCollection.
	variables isEmpty ifTrue: [^#()].
	^ChooserMorph 
		choose: 'Choose variables:'
		multipleSelect: true
		fromList: self selectedClass instVarNames
		values: self selectedClass instVarNames
		cancel: [#()]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/28/2001 23:46'!
navigateToClass: foundClass 
	self selectCategoryForClass: foundClass.
	self selectClass: foundClass! !

!RefactoringBrowser class methodsFor: 'as yet unclassified' stamp: 'md 11/17/2004 17:23'!
initialize
	"self initialize"
	TheWorldMenu registerOpenCommand: {'Refactoring Browser'. {self. #openBrowser}}.
	self registerInAppRegistry.! !

!RefactoringBrowser methodsFor: 'menus' stamp: 'dvf 9/29/2001 17:37'!
assignmentMenuFor: aNode 

	^MenuMorph new
		defaultTarget:self;
		add: 'inline temporary' action: #inlineTemporary;
		yourself! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'nk 9/17/2003 14:26'!
finderOnPackageWithClassCategory
	| tool |
	tool _ (self selectedEnvironment 
		ifNil: [FinderTool new] 
		ifNotNil: [ FinderTool onPackageWithClassCategory: self selectedSystemCategoryName ]).
	tool ifNotNil: [ tool openAsMorph ]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/17/2000 22:38'!
globalVariableMenuFor: aNode 
	^MenuMorph new
		defaultTarget:self;
		add: 'navigate to' action: #navigateToClass;
		add: 'open browser on...' action: #openBrowserForClass;
		add: 'browse references...' action: #browseReferencesToGlobal;
		yourself! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 10/15/2000 21:04'!
instVarWriters
	| instVar |
	instVar := self selectInstVarSupers: true subs: false.
	instVar notNil
		ifTrue: [self browseInstVarWritersTo: instVar in: self selectedClassOrMetaClass]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/29/2001 18:13'!
openBrowserForClass
	self class fullOnClass: self selectedClassInCode! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:06'!
selectSubclassClassVar

	self selectedClassOrMetaClass chooseSubclassesClassVarThenDo:[:ivar| ^ivar].
	^''.! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'ich. 3/26/2004 20:41'!
addClassVariableSubMenuTo: aMenu

	World ifNotNil: 
		[aMenu defaultTarget: aMenu.
		aMenu add: 'RB - class variables' subMenu:
			(MenuMorph new
				defaultTarget:self;
				add: 'references...' action: #classVarRefs ; 
				add: 'add...' action: #addClassVar ; 
				add: 'rename as...' action: #renameClassVar ; 
				add: 'remove...' action: #removeClassVar ; 
				add: 'push down...' action: #pushDownClassVar ; 
				add: 'pull up...' action: #pullUpClassVar ; 
				add: 'create accessors...' action: #createClassVarAccessors ; 
				add: 'abstract...' action: #abstractClassVar ;
				yourself)].
! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'dvf 8/27/2003 14:25'!
renameSelectedInstVar
	| name |
	name := self selectedVariableName.
	name isNil ifTrue: [^self].
	self renameInstVar: name
! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 00:59'!
browseSelectedInstVarReaders
	| name |
	name := self selectedVariableName.
	name notNil 
		ifTrue: [self navigator browseGlobalInstVarReadersTo: name in: self selectedClassOrMetaClass]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/29/2001 00:04'!
finderOnClass
	self selectedClass ifNil: [^self finderOnClassCategory].
	(FinderTool onClass: self selectedClass) openAsMorph ! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 00:58'!
createClassVarAccessors
	| name |
	name := self selectClassVar.
	name isNil ifTrue: [^self].
	self createAccessorsForClassVar: name! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'hboon 11/12/2004 15:29'!
changedClass
	self changed: #categoryList.
	self changed: #messageList.
	self changed: #classList.! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 01:00'!
abstractSelectedInstVar
	| name |
	name := self selectedVariableName.
	name isEmpty ifTrue: [^self].
	self abstractInstVar: name! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 5/19/2000 23:33'!
findAssociationForClassVariable: classVar 
	| association definingClass name |
self needsWork. "well, maybe not work, but needs testing."
	definingClass := self nonMetaClass.
	association := nil.
	
	[definingClass notNil and: 
			[name := definingClass classPool keys 
						detect: [:each | each asString = classVar asString]
						ifNone: [nil].
			association := definingClass classPool associationAt: name ifAbsent: [nil].
			association isNil]] 
			whileTrue: [definingClass := definingClass superclass].
	^association! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 5/19/2000 23:34'!
browseGlobalReferencesTo: aLiteral in: aClass 
	self showWaitCursorWhile: 
			[(BrowserEnvironment new referencesTo: aLiteral in: aClass) openEditor]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/20/2000 11:15'!
browseGlobalInstVarWritersTo: instVar in: aClass 
	self showWaitCursorWhile: 
			[(BrowserEnvironment new instVarWritersTo: instVar in: aClass) openEditor]! !

!RefactoringBrowser class methodsFor: 'as yet unclassified' stamp: 'md 11/17/2004 17:23'!
openBrowser
	"Create and schedule a BrowserView with label 'System Browser'. The 
	view consists of five subviews, starting with the list view of system 
	categories of SystemOrganization. The initial text view part is empty."
	self openBrowserView: (self new openEditString: nil)
			label: 'RB'
! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/15/2000 22:12'!
inspectAllInstances
	(self nonMetaClass allInstances) inspect! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 10:21'!
addInstVarIn: aClass 
	| newName |
	newName := self requestInstVarName: ''.
	newName isNil ifTrue: [^self].
	self handleError: 
			[(AddInstanceVariableRefactoring variable: newName class: aClass) execute]! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 11/8/2000 20:37'!
createSubclass
	| class |
	self changeRequest ifFalse: [^self].
	class := self createSubclassOf: self nonMetaClass.
	class isNil ifTrue: [^self].
	self selectClass: class.
	"self updateCategoryList"! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 14:36'!
instanceVariableMenu
	^(MenuMorph new)
		defaultTarget: self;
		add: 'references...' action: #browseSelectedInstVarRefs;
		add: 'readers...' action: #browseSelectedInstVarReaders;
		add: 'writers...' action: #browseSelectedInstVarWriters;
		add: 'rename instance variable...' action: #renameSelectedInstVar;
		add: 'pull up' action: #pushUpSelectedInstVar;
		add: 'create accessors' action: #createSelectedInstVarAccessors;
		add: 'abstract' action: #abstractSelectedInstVar;
		add: 'protect/concrete' action: #protectSelectedInstVar;
		yourself! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 5/19/2000 23:47'!
requestClassVarName: oldName 
	| name |
	name := self request: 'Enter a class variable name:' initialAnswer: oldName.
	(name isEmpty or: [oldName = name]) ifTrue: [^nil].
	^name! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 10/15/2000 21:04'!
instVarRefs
	| instVar |
	instVar := self selectInstVarSupers: true subs: false.
	instVar notNil
		ifTrue: [self browseInstVarRefsTo: instVar in: self selectedClassOrMetaClass]! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 10/15/2000 21:05'!
removeInstVar
	| instVar |
	self changeRequest ifFalse: [^self].
	instVar := self selectInstVarSupers: false subs: false.
	instVar isNil ifTrue: [^self].
	self removeInstVar: instVar fromClass: self selectedClassOrMetaClass.
	self changedClass! !

!RefactoringBrowser methodsFor: 'message pane' stamp: 'bh 10/15/2000 21:07'!
removeParameter
	self handleError: 
			[| ref |
			ref := RemoveParameterRefactoring 
						removeParameter: self selectedText
						in: self selectedClassOrMetaClass
						selector: self selector.
			ref execute.
			"codeModel setSelector: ref newSelector"]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 00:56'!
createSelectedInstVarAccessors
	| name |
	name := self selectedVariableName.
	name isNil ifTrue: [^self].
	self createAccessorsForInstVar: name
! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 10:35'!
checkProtocolsFor: aClass 
	^(self environment selectorsForClass: aClass) inject: false
		into: 
			[:bool :each | 
			bool | (self checkProtocolFor: each in: aClass)
				| (self checkProtocolMatchFor: each in: aClass)]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/17/2000 21:58'!
messageMenuFor: aNode 
	"add: stuff action: bar"
	^MenuMorph new
		defaultTarget:self;
		add: 'senders...' action: #browseSenders;
		add: 'implementors...' action: #browseImplementors;
		add: 'inline message' action: #inlineMethod;
		add: 'extract to temporary...' action: #extractToTemp;
		yourself! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/29/2001 17:53'!
navigateToClass
	self navigateToClass: self selectedClassInCode! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/17/2000 21:23'!
noMenu
	^MenuMorph new
		add: 'no selection' action: #printString;
		yourself! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/17/2000 22:33'!
browseSenders
	| node |

	node := self findNode.
	(node isNil or: [node isMessage not]) ifTrue: [^self].
	(BrowserEnvironment new referencesTo: node selector) openEditor! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 14:41'!
performClassRefactoring: refactoring 
	self handleError: 
			[refactoring execute.
			self changedClass]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/28/2001 23:47'!
navigateToClassNamed: className 
	| foundClass |
	foundClass := Smalltalk at: className asSymbol.
	self navigateToClass: foundClass! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 11:05'!
browseInstVarRefsTo: instVar in: aClass 
	self showWaitCursorWhile: 
			[(self environment instVarRefsTo: instVar in: aClass) openEditor]! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 5/12/2000 23:14'!
classNames

	^{self selectedClassName}! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 10:50'!
browseReferencesTo: aLiteral in: aClass 
	self showWaitCursorWhile: 
			[(self environment referencesTo: aLiteral in: aClass) openEditor]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/20/2000 00:01'!
browseGlobalInstVarRefsTo: instVar in: aClass 
	self showWaitCursorWhile: 
			[(BrowserEnvironment new instVarRefsTo: instVar in: aClass) openEditor]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 11/8/2000 10:53'!
selectClasses: classCollection meta: aBoolean categories: categoriesCollection

	classCollection ifNotEmpty:
		[ :col |
		self selectClass: classCollection first ].! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:03'!
createAccessorsForInstVar: aString 
	self performRefactoring: (CreateAccessorsForVariableRefactoring 
				variable: aString
				class: (self selectedClassOrMetaClass whichClassDefinesInstVar: aString)
				classVariable: false)! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 10:28'!
changeClassCategory
	| state |
	self changeRequest ifFalse: [^self].
	state := self getState.
	self changeClassCategoryFor: self nonMetaClasses.
	self setState: state updateClasses: true.
	self changed: #category with: self category! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'dvf 11/2/2002 18:54'!
renameClass: aClass 

	| aString newName |
	aString := self request: 'Enter new ClassName' initialAnswer: aClass name.
	aString isEmpty ifTrue: [^self].
	newName := aString asSymbol.
	self handleError: 
			[(RenameClassRefactoring rename: aClass to: newName) execute.
			self selectClasses: (Array with: aString asSymbol)
				meta: self isMeta
				categories: self categories.
			self changedClass]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:07'!
renameTemporary
	| newName node |
	node := self findNode.
	(node isNil or: [node isVariable not]) 
		ifTrue: [^self warn: 'Could not find the node'].
	newName := self request: 'Enter new name:' initialAnswer: node name.
	newName isEmpty ifTrue: [^self].
	self performRefactoring: (RenameTemporaryRefactoring 
				renameTemporaryFrom: (self convertToSourceInterval: node sourceInterval)
				to: newName
				in: self selectedClassOrMetaClass
				selector: self selector)! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:06'!
selectInstVar

	self selectedClassOrMetaClass chooseInstVarThenDo:[:ivar| ^ivar].
	^''.! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 10:54'!
findAllReferencesToInstances

	self needsWork.
	self error:'ReferenceFinder does not work yet. Sorry.'.

	"self showWaitCursorWhile: 
			[| paths |
			paths := ReferenceFinder findAllPathsToInstanceOf: self selectedClass.
			paths isEmpty 
				ifTrue: [self warn: 'No reference paths exist']
				ifFalse: [paths inspect]]"! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 5/16/2000 23:22'!
requestInstVarName: oldName 
	| name |
	name := self request: 'Enter a instance variable name:' initialAnswer: oldName.
	(name isEmpty or: [oldName = name]) ifTrue: [^nil].
	^name! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 01:01'!
protectSelectedInstVar
	| name |
	name := self selectedVariableName.
	name isNil ifTrue: [^self].
	self protectInstVar: name! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 6/14/2000 10:26'!
setState: aNavigatorState updateClasses: aBoolean 

	self changedClass.! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 00:58'!
browseSelectedInstVarRefs
	| name |
	name := self selectedVariableName.
	name notNil 
		ifTrue: [self navigator browseGlobalInstVarRefsTo: name in: self selectedClassOrMetaClass]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:07'!
selectClassVarSupers: supersBoolean subs: subsBoolean

	(supersBoolean & subsBoolean) ifTrue:[^self error:'cannot select cvars from subs and supers yet. sorry.'].
	(supersBoolean | subsBoolean) ifFalse:[self selectedClassOrMetaClass chooseThisClassClassVarThenDo:[:ivar| ^ivar]. ^''].
	supersBoolean ifTrue:[^self selectClassVar].
	subsBoolean ifTrue:[^self selectSubclassClassVar].
! !

!RefactoringBrowser methodsFor: 'message pane' stamp: 'dvf 9/7/2001 23:40'!
removeMethodSafe
	messageListIndex = 0 ifTrue: [^self].
	self okToChange ifFalse: [^self].
	self removeMethodsSafe: self selectors from: self selectedClassOrMetaClass.
	self changed: #messageList.
	self changedSelector.
	self beep! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:06'!
selectVariableMenuFor: aNode 
	(aNode whoDefines: aNode name) notNil 
		ifTrue: [^self temporaryMenuFor: aNode].
	(self selectedClassOrMetaClass allInstVarNames includes: aNode name) 
		ifTrue: [^self instanceVariableMenu].
	(self nonMetaClass allClassVarNames 
		detect: [:each | each asString = aNode name]
		ifNone: [nil]) notNil 
		ifTrue: [^self classVariableMenu].
	^(Smalltalk includesKey: aNode name asSymbol) 
		ifTrue: 
			[self globalVariableMenuFor: (Smalltalk associationAt: aNode name asSymbol)]
		ifFalse: [self noMenu]! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'dvf 9/15/2001 17:43'!
createSubclassOf: aClass 

	| name subclasses  aCategory |
	
	name := self requestClassName.
	name isNil ifTrue: [^nil].
	subclasses := self selectSubclassesOf: aClass.
	subclasses isNil ifTrue: [^nil].
	aCategory _ (SelectionMenu selections: Smalltalk organization categories) startUpWithCaption: 'Choose a class category:'.
	^self handleError: 
			[(AddClassRefactoring addClass: name
				superclass: aClass
				subclasses: subclasses
				category: aCategory) execute.
			Smalltalk at: name asSymbol ifAbsent: [nil]]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/19/2000 23:50'!
createAccessorsForClassVar: aString 
	self performRefactoring: (CreateAccessorsForVariableRefactoring 
				variable: aString asSymbol
				class: (self nonMetaClass whichClassDefinesClassVar: aString)
				classVariable: true)! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/19/2000 23:52'!
abstractClassVar: aString 
	self performRefactoring: (AbstractClassVariableRefactoring 
				variable: aString asSymbol
				class: (self nonMetaClass whichClassDefinesClassVar: aString))! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/19/2000 23:57'!
browseGlobalReferencesTo: aLiteral 
	self showWaitCursorWhile: 
			[(BrowserEnvironment new referencesTo: aLiteral) openEditor]! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 11/5/2000 22:05'!
environment

	self needsWork. "what do we want for here? a selector environment with everything in the whole image?"
	"self error:'not yet implemented'."

	^BrowserEnvironment new.! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 6/14/2000 10:26'!
getState

	"do nothing, this is temporary"! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'nk 9/17/2003 12:32'!
finderOnClassCategory
	(self selectedEnvironment 
		ifNil: [FinderTool new] 
		ifNotNil: [(FinderTool onClassCategory: self selectedSystemCategoryName)]) openAsMorph ! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 8/29/2001 00:57'!
createSelectedClassVarAccessors
	| name |
	name := self selectedVariableName.
	name isNil ifTrue: [^self].
	self createAccessorsForClassVar: name! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'dvf 9/8/2001 19:57'!
handleError: aBlock 
	^[Cursor execute showWhile: aBlock] on: Refactoring preconditionSignal
		do: 
			[:ex | 
			ex isResumable 
				ifTrue: 
					[(self confirm: (ex messageText last == $? 
								ifTrue: [ex messageText]
								ifFalse: [ex messageText , '\Do you want to proceed?' withCRs])) 
						ifTrue: [ex resume]]
				ifFalse: 
					[ex parameter notNil 
						ifTrue: [(self confirm: ex messageText) ifTrue: [ex parameter value]]
						ifFalse: [self warn: ex messageText]].
			ex return: nil]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:03'!
inlineMethod
	| node |
	node := self findNode.
	(node isNil or: [node isMessage not]) 
		ifTrue: [^self warn: 'Could not find message send'].
	(node receiver isVariable 
		and: [#('self' 'super') includes: node receiver name]) 
			ifTrue: 
				[self performRefactoring: (InlineMethodRefactoring 
							inline: (self convertToSourceInterval: node sourceInterval)
							inMethod: self selector
							forClass: self selectedClassOrMetaClass)]
			ifFalse: 
				[self performRefactoring: (InlineMethodFromComponentRefactoring 
							inline: (self convertToSourceInterval: node sourceInterval)
							inMethod: self selector
							forClass: self selectedClassOrMetaClass)]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:04'!
pullUpInstVar
	| instVar |
	self changeRequest ifFalse: [^self].
	instVar := self selectSubclassInstVar.
	instVar isNil ifTrue: [^self].
	self handleError: 
			[(PullUpInstanceVariableRefactoring variable: instVar class: self selectedClassOrMetaClass)
				execute.
			self changedClass].
	self beep.
! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 10/15/2000 21:07'!
selectClassVar

	self selectedClassOrMetaClass chooseClassVarThenDo:[:ivar| ^ivar].
	^''.! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'bh 10/15/2000 21:04'!
nonMetaClass

	^self selectedClassOrMetaClass.! !

!RefactoringBrowser methodsFor: 'compatibility' stamp: 'dvf 9/8/2001 19:57'!
warn: aString

	^PopUpMenu notify:aString.! !

!RefactoringBrowser methodsFor: 'accessing' stamp: 'bh 6/14/2000 10:49'!
classVarRefs
	| classVar association |
	classVar := self selectClassVarSupers: true subs: false.
	classVar isNil ifTrue: [^self].
	association := self findAssociationForClassVariable: classVar.
	self browseReferencesTo: association in: self nonMetaClass! !

!RefactoringBrowser methodsFor: 'message pane' stamp: 'dvf 9/30/2001 02:16'!
addParameterTo: aSelector in: aClass 
	| initializer newSelector initialAnswer |
	initialAnswer := aSelector numArgs == 0 
				ifTrue: [aSelector , ':']
				ifFalse: [aSelector].
	newSelector := self request: 'Enter new selector:'
				initialAnswer: initialAnswer.
	newSelector isEmpty ifTrue: [^nil].
	initializer := self request: 'Enter default value for parameter:'
				initialAnswer: 'nil'.
	initializer isEmpty ifTrue: [^nil].
	^self handleError: 
			[(AddParameterRefactoring 
				addParameterToMethod: aSelector
				in: aClass
				newSelector: newSelector asSymbol
				initializer: initializer) execute.
			newSelector]! !

!RefactoringBrowser methodsFor: 'menus' stamp: 'ich. 3/26/2004 20:40'!
addSelectionSubMenuTo: aMenu

	| title subMenu |
	World ifNotNil: 
		[aMenu defaultTarget: aMenu.
		title _ 'RB - selection'.
		subMenu _ self selectMenu. 
		aMenu add: title subMenu: subMenu]! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 11/8/2000 15:26'!
categories

	^#().! !

!RefactoringBrowser methodsFor: 'as yet unclassified' stamp: 'bh 5/19/2000 23:46'!
renameClassVar: oldName in: aClass 
	| newName |
	newName := self requestClassVarName: oldName.
	newName isNil ifTrue: [^self].
	self handleError: 
			[(RenameClassVariableRefactoring rename: oldName
				to: newName
				in: aClass) execute]! !

!Symbol class methodsFor: '*Refactory-RBAddonsReasonable' stamp: ''!
findInterned:aString

	self hasInterned:aString ifTrue:[:symbol| ^symbol].
	^nil.! !

!Class class methodsFor: '*Refactory-RBAddons' stamp: 'bh 3/12/2000 15:18'!
rootsOfTheWorld

	^ProtoObject subclasses.! !

!CompiledMethod methodsFor: '*Refactory-RBAddonsProblem' stamp: 'dvf 11/12/2002 00:45'!
withAllBlockMethodsDo: aOneArgumentBlock 

	self needsWork.
	aOneArgumentBlock value: self! !

!CompiledMethod methodsFor: '*Refactory-RBAddonsReasonable' stamp: 'dvf 8/7/2003 22:02'!
equivalentTo: aCompiledMethod 
	^ self = aCompiledMethod
		or: [self class == aCompiledMethod class
				and: [self numArgs == aCompiledMethod numArgs
						and: 
							[| selfParseTree methodParseTree selfMethodClass otherMethodClass | 
							selfMethodClass _ self methodClass.
							otherMethodClass _ aCompiledMethod methodClass.
							selfParseTree _ selfMethodClass decompilerClass new
										decompile: (self defaultSelector)
										in: selfMethodClass
										method: self.
							methodParseTree _ otherMethodClass decompilerClass new
										decompile: (aCompiledMethod defaultSelector)
										in: otherMethodClass
										method: aCompiledMethod.
							selfParseTree = methodParseTree]]]! !

!CompiledMethod methodsFor: '*Refactory-RBAddonsReasonable' stamp: 'dvf 11/12/2002 00:44'!
literalsDo: aOneArgumentBlock

	^self literals do:aOneArgumentBlock.! !

!CompiledMethod methodsFor: '*Refactory-RBAddonsReasonable' stamp: 'dvf 11/12/2002 00:44'!
refersToLiteral:aLiteral

	^self hasLiteral: aLiteral.! !

!CompiledMethod methodsFor: '*Refactory-RBAddonsReasonable' stamp: 'dvf 11/12/2002 00:44'!
allLiterals

	^ self literals.! !

!CompiledMethod methodsFor: '*Refactory-RBAddonsProblem' stamp: 'dvf 11/12/2002 00:45'!
withAllBlockMethods

	self needsWork.
	^ {self}! !

!CompiledMethod methodsFor: '*Refactory-RBAddonsReasonable' stamp: ''!
getSource
	^ self getSourceFor: self selector in:self methodClass.! !

!CompiledMethod methodsFor: '*Refactory-RBAddonsReasonable' stamp: ''!
methodClass

	^self who first.! !

!CompiledMethod methodsFor: '*Refactory-RBAddonsReasonable' stamp: 'dvf 11/8/2003 15:01'!
parseTree
	^ RBParser parseMethod: self getSource asString.! !

!CompiledMethod methodsFor: '*Refactory-RBAddonsReasonable' stamp: 'dvf 11/12/2002 00:44'!
messagesDo: aBlock 

	^ self messages do:aBlock.! !

!CompiledMethod methodsFor: '*Refactory-RBAddonsReasonable' stamp: 'dvf 11/12/2002 00:44'!
sendsSelector: aSymbol 

	^ self messages includes: aSymbol! !

!CompiledMethod methodsFor: '*Refactory-RBAddonsProblem' stamp: 'bh 4/29/2000 18:13'!
needsHybridFrame
	self needsWork.
	^false.! !

!ClassDescription methodsFor: '*Refactory-RBUI' stamp: 'bh 5/16/2000 23:39'!
chooseThisClassClassVarThenDo: aBlock 
	| allVars index labelStream |

	allVars := self classVarNames asSortedCollection.
	allVars isEmpty ifTrue:[^self inform: 'There are no class variables.'].
	labelStream _ WriteStream on: (String new: 200).
	allVars do: [:var| labelStream nextPutAll:var;cr].
	
	index _ (PopUpMenu labels: labelStream contents lines: #()) startUpWithCaption: 'Select class variable:'.
	index = 0 ifTrue: [^ self].
	aBlock value:(allVars at: index).! !

!ClassDescription methodsFor: '*Refactory-RBUI' stamp: 'bh 5/16/2000 23:36'!
chooseClassVarThenDo: aBlock 

	| lines labelStream vars allVars index count offerAlpha |
	(count _ self allClassVarNames size) = 0 ifTrue: 
		[^ self inform: 'There are no
class variables.'].

	allVars _ OrderedCollection new.
	lines _ OrderedCollection new.
	labelStream _ WriteStream on: (String new: 200).

	(offerAlpha _ count > 5)
		ifTrue:
			[lines add: 1.
			allVars add: 'show alphabetically'.
			labelStream nextPutAll: allVars first; cr].
	self withAllSuperclasses reverseDo:
		[:class |
		vars _ class classVarNames.
		vars do:
			[:var |
			labelStream nextPutAll: var; cr.
			allVars add: var].
		vars isEmpty ifFalse: [lines add: allVars size]].
	labelStream skip: -1 "cut last CR".
	(lines size > 0 and: [lines last = allVars size]) ifTrue:
		[lines removeLast].  "dispense with inelegant line beneath last item"
	index _ (PopUpMenu labels: labelStream contents lines: lines)
startUpWithCaption: 'Class variables in
', self name.
	index = 0 ifTrue: [^ self].
	(index = 1 and: [offerAlpha]) ifTrue: [^ self
chooseClassVarAlphabeticallyThenDo: aBlock].
	aBlock value: (allVars at: index)! !

!ClassDescription methodsFor: '*Refactory-RBUI' stamp: 'bh 5/16/2000 23:37'!
chooseClassVarAlphabeticallyThenDo: aBlock
	| allVars index |

	allVars _ self allClassVarNames asSortedArray.
	allVars isEmpty ifTrue: [^ self inform: 'There are no
class variables'].

	index _ (PopUpMenu labelArray: allVars lines: #()) startUpWithCaption: 'Class variables in
', self name.
	index = 0 ifTrue: [^ self].
	aBlock value: (allVars at: index)! !

!ClassDescription methodsFor: '*Refactory-RBUI' stamp: 'bh 5/16/2000 22:25'!
chooseSubclassesInstVarThenDo: aBlock 
	"Put up a menu of all the instance variables in the receiver, and when
the user chooses one, evaluate aBlock with the chosen variable as its
parameter.  If the list is 6 or larger, then offer an alphabetical
formulation as an alternative. triggered by a 'show alphabetically' item
at the top of the list."

	| allVars index labelStream |

	allVars := self allSubclasses inject:SortedCollection new into:
		[:answer :each|
		answer addAll:each instVarNames; yourself.].
	allVars isEmpty ifTrue:[^self inform: 'There are no instance variables in subclasses.'].
	labelStream _ WriteStream on: (String new: 200).
	allVars do: [:var| labelStream nextPutAll:var;cr].
	
	index _ (PopUpMenu labels: labelStream contents lines: #()) startUpWithCaption: 'Select instance variable:'.
	index = 0 ifTrue: [^ self].
	aBlock value:(allVars at: index).! !

!ClassDescription methodsFor: '*Refactory-RBUI' stamp: 'bh 5/16/2000 23:38'!
chooseSubclassesClassVarThenDo: aBlock 

	| allVars index labelStream |

	allVars := self allSubclasses inject:SortedCollection new into:
		[:answer :each|
		answer addAll:each classVarNames; yourself.].
	allVars isEmpty ifTrue:[^self inform: 'There are no class variables in subclasses.'].
	labelStream _ WriteStream on: (String new: 200).
	allVars do: [:var| labelStream nextPutAll:var;cr].
	
	index _ (PopUpMenu labels: labelStream contents lines: #()) startUpWithCaption: 'Select class variable:'.
	index = 0 ifTrue: [^ self].
	aBlock value:(allVars at: index).! !

!ClassDescription methodsFor: '*Refactory-RBUI' stamp: 'bh 5/16/2000 22:45'!
chooseThisClassInstVarThenDo: aBlock 
	"Put up a menu of all the instance variables in the receiver, and when
the user chooses one, evaluate aBlock with the chosen variable as its
parameter.  If the list is 6 or larger, then offer an alphabetical
formulation as an alternative. triggered by a 'show alphabetically' item
at the top of the list."

	| allVars index labelStream |

	allVars := self instVarNames asSortedCollection.
	allVars isEmpty ifTrue:[^self inform: 'There are no instance variables.'].
	labelStream _ WriteStream on: (String new: 200).
	allVars do: [:var| labelStream nextPutAll:var;cr].
	
	index _ (PopUpMenu labels: labelStream contents lines: #()) startUpWithCaption: 'Select instance variable:'.
	index = 0 ifTrue: [^ self].
	aBlock value:(allVars at: index).! !

!OrderedCollection methodsFor: '*Refactory-RBAddons' stamp: 'dvf 11/12/2002 00:46'!
removeAtIndex: index 

	^ self removeAt: index! !

!String methodsFor: '*Refactory-RBAddonsProblem' stamp: 'bh 3/16/2000 12:44'!
expandMacrosWith: anObject 
	^self expandMacrosWithArguments: (Array with: anObject)! !

!String methodsFor: '*Refactory-RBAddonsReasonable' stamp: ''!
string

	^self.! !

!String methodsFor: '*Refactory-RBAddonsProblem' stamp: 'bh 3/16/2000 12:44'!
expandMacrosWith: anObject with: anotherObject 
	^self expandMacrosWithArguments: (Array with: anObject with: anotherObject)! !

!String methodsFor: '*Refactory-RBAddonsProblem' stamp: 'bh 3/16/2000 12:42'!
expandMacrosWithArguments: anArray 
	| newStream readStream char index |
	newStream := WriteStream on: (String new: self size).
	readStream := ReadStream on: self.
	[readStream atEnd] whileFalse: 
			[char := readStream next.
			char == $<
				ifTrue: 
					[| nextChar |
					nextChar := readStream next asUppercase.
					nextChar == $N ifTrue: [newStream cr].
					nextChar == $T ifTrue: [newStream tab].
					nextChar isDigit ifTrue: 
							[index := nextChar digitValue.
							
							[readStream atEnd
								or: [(nextChar := readStream next asUppercase) isDigit not]]
									whileFalse: [index := index * 10 + nextChar digitValue]].
					nextChar == $? ifTrue: 
							[| trueString falseString |
							trueString := readStream upTo: $:.
							falseString := readStream upTo: $>.
							readStream position: readStream position - 1.
							newStream
								nextPutAll: ((anArray at: index) ifTrue: [trueString] ifFalse: [falseString])].
					nextChar == $P ifTrue: [newStream nextPutAll: (anArray at: index) printString].
					nextChar == $S ifTrue: [newStream nextPutAll: (anArray at: index)].
					readStream skipTo: $>]
				ifFalse: 
					[newStream nextPut: (char == $% ifTrue: [readStream next] ifFalse: [char])]].
	^newStream contents! !

!String class methodsFor: '*Refactory-RBAddonsProblem' stamp: 'bh 3/6/2000 01:27'!
expandMacro: macroType  argument: argument  withExpansions: expansions
	macroType = $s ifTrue: [
		^(expansions at: argument)].
	macroType = $p ifTrue: [
		^(expansions at: argument) printString ].
	macroType = $n ifTrue: [
		^String cr ].
	macroType = $t ifTrue: [
		^String tab ].

	self error: 'unknown expansion type'

! !

!String methodsFor: '*Refactory-RBAddonsProblem' stamp: 'bh 3/16/2000 12:43'!
expandMacrosWith: anObject with: anotherObject with: thirdObject with: fourthObject 
	^self expandMacrosWithArguments: (Array
			with: anObject
			with: anotherObject
			with: thirdObject
			with: fourthObject)! !

!String methodsFor: '*Refactory-RBAddonsProblem' stamp: 'bh 3/16/2000 12:43'!
expandMacrosWith: anObject with: anotherObject with: thirdObject 
	^self expandMacrosWithArguments: (Array
			with: anObject
			with: anotherObject
			with: thirdObject)! !

!String methodsFor: '*Refactory-RBAddonsProblem' stamp: 'bh 3/16/2000 12:44'!
expandMacros
	^self expandMacrosWithArguments: #()! !

!Collection methodsFor: '*Refactory-vwcompat' stamp: ''!
contains: aBlock
	"VW compatibility"
	^self anySatisfy: aBlock! !

Model subclass: #LintDialog
	instanceVariableNames: 'testCategories tests classCategories classes results'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Lint'!

!LintDialog class methodsFor: 'instance creation' stamp: 'dvf 11/24/2001 14:04'!
prototypicalToolWindow
	"Answer an example of myself seen in a tool window, for the benefit of parts-launching tools"

	^self new initialize lintWindow! !

!LintDialog methodsFor: 'accessing' stamp: 'MPH 10/21/2000 12:13'!
testsFromCategory: aCategory
	^(self testsFromCategory: aCategory inClass: BlockLintRule) , (self testsFromCategory: aCategory inClass: ParseTreeLintRule)! !

!LintDialog methodsFor: 'actions' stamp: 'bh 11/5/2000 01:02'!
run

	self canRun ifFalse:[^self].
	Cursor wait showWhile:
		[ results _ self runOnEnvironment: self selectedClassEnvironment ].
	self resultsDialog! !

!LintDialog methodsFor: 'accessing' stamp: 'MPH 10/21/2000 12:17'!
testsFromCategories
	^testCategories selectedItems inject: Array new into:
		[:partialList :each | (self testsFromCategory: each) , partialList].
! !

!LintDialog methodsFor: 'accessing' stamp: 'MPH 10/19/2000 12:24'!
returnZero
	^0! !

!LintDialog class methodsFor: 'instance creation' stamp: 'dvf 8/27/2003 14:40'!
unload
	"Called when the class is being removed"

	TheWorldMenu unregisterOpenCommandWithReceiver: self! !

!LintDialog methodsFor: 'displaying' stamp: 'ab 8/25/2002 09:57'!
listMorphFor: aPluggableListOfManyArray 
	| list |
	list _ PluggableListMorphOfMany
				on: aPluggableListOfManyArray
				list: #list
				primarySelection: nil
				changePrimarySelection: nil
				listSelection: #listSelectionAt:
				changeListSelection: #listSelectionAt:put:
				menu: #menu:.
	list color: Color paleGreen.
	^ list! !

!LintDialog methodsFor: 'displaying' stamp: 'MPH 10/22/2000 22:46'!
resultsListMorph
| list |
	list _ PluggableListMorph
		on: self
		list: #resultsAsText
		selected: #returnZero
		changeSelected: #makeResultDialogOn:.
	list color: Color paleGreen.
	^list! !

!LintDialog methodsFor: 'actions' stamp: 'MPH 10/21/2000 11:57'!
update: anObject
	self changed.! !

!LintDialog methodsFor: 'accessing' stamp: 'MPH 10/19/2000 12:36'!
resultsAsText
	^results collect:[:each| each asString , ' [' , each result problemCount asString , ']']! !

!LintDialog methodsFor: 'displaying' stamp: 'dvf 9/29/2001 14:17'!
makeResultDialogOn: aNumber
	| environment |
	aNumber = 0 ifTrue: [^self].
	environment _ (results at: aNumber) result.
	environment openEditor.! !

!LintDialog methodsFor: 'accessing' stamp: 'MPH 10/23/2000 15:30'!
selectedClassEnvironment

	^ClassEnvironment new
		classes: (classes selectedItems collect: [:each | Smalltalk at: each]);
		yourself! !

!LintDialog class methodsFor: 'instance creation' stamp: 'MPH 10/21/2000 11:09'!
open
	^self new initialize open! !

!LintDialog methodsFor: 'actions' stamp: 'ab 8/25/2002 10:33'!
runOnEnvironment: anEnvironment 
	| allResults progress addAmount |
	progress _ ProgressMorph label: 'SLint progress'.
	progress openInWorld.
	addAmount _ 1.0 / tests selectedItems size.
	allResults _ tests selectedItems
				collect: [:each | 
					progress subLabel: each name.
					progress incrDone: addAmount.
					SmalllintChecker runRule: each onEnvironment: anEnvironment].
	progress delete.
	^ allResults
		select: [:each | each result problemCount > 0]! !

!LintDialog methodsFor: 'initialize-release' stamp: 'MPH 10/22/2000 22:50'!
initialize
	tests _ MultipleSelectionModel
		withList: #()
		withMessage: #testsFromCategories.
	self addDependent: tests.
	classCategories _ MultipleSelectionModel withList: SystemOrganization categories.
	classCategories addDependent: self.
	testCategories _ MultipleSelectionModel withList: self determineTestCategories.
	testCategories addDependent: self.
	classes _ MultipleSelectionModel 
		withList: #()
		withMessage: #classesFromCategories.
	self addDependent: classes.! !

!LintDialog methodsFor: 'displaying' stamp: 'dvf 11/24/2001 14:04'!
lintWindow
	^(SystemWindow labelled: 'SmallLint')
		color: Color paleGreen;
		addMorph: (self listMorphFor: testCategories)
			frame: (0.0 @ 0.0 extent: 0.33 @ 0.2);
		addMorph: (self listMorphFor: tests) frame: (0.0 @ 0.2 extent: 0.33 @ 0.64);
		addMorph: (self listMorphFor: classCategories)
			frame: (0.33 @ 0.0 extent: 0.33 @ 0.84);
		addMorph: (self listMorphFor: classes)
			frame: (0.66 @ 0.0 extent: 0.34 @ 0.84);
		addMorph: self runButton frame: (0.0 @ 0.84 extent: 0.2 @ 0.16)! !

!LintDialog methodsFor: 'displaying' stamp: 'MPH 10/19/2000 12:20'!
resultsDialog
	(SystemWindow labelled: 'SmallLint Results')
		color: Color paleGreen;
		addMorph: (self resultsListMorph) frame:(0@0 extent: 1@1);
		openInWorld.! !

!LintDialog methodsFor: 'displaying' stamp: 'MPH 10/18/2000 10:35'!
runButton
	|button|
	button _ PluggableButtonMorph
				on: self
				getState: #canRun
				action: #run.
	button label: 'Run'.
	^button! !

!LintDialog methodsFor: 'actions' stamp: 'MPH 10/20/2000 20:32'!
canRun
	^tests anySelected and: [classes anySelected]! !

!LintDialog class methodsFor: 'instance creation' stamp: 'dvf 8/27/2003 14:32'!
initialize

	TheWorldMenu registerOpenCommand: {'Lint'. {self. #open}}! !

!LintDialog methodsFor: 'initialize-release' stamp: 'MPH 10/23/2000 16:12'!
determineTestCategories
	^Set new
		addAll: BlockLintRule class organization categories;
		addAll: ParseTreeLintRule class organization categories;
		removeAllFoundIn: #(#'instance creation' #private);
		asArray
	! !

!LintDialog methodsFor: 'accessing' stamp: 'MPH 10/22/2000 21:44'!
classesFromCategories

	^classCategories trueIndexes inject: SortedCollection new into:
		[:partialList :each | partialList addAll: (SystemOrganization listAtCategoryNumber: each).
		partialList].
! !

!LintDialog methodsFor: 'displaying' stamp: 'dvf 11/24/2001 14:04'!
open
	self lintWindow openInWorld! !

!LintDialog methodsFor: 'accessing' stamp: 'bh 11/4/2000 22:22'!
testsFromCategory: aSymbol inClass: aClass
	| classTests |
	classTests _ aClass class organization listAtCategoryNamed: aSymbol.
	^classTests collect:[: each | aClass perform: each].! !

Model subclass: #MethodNameEditor
	instanceVariableNames: 'argumentListIndex methodName accepted modalView bodyPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-UserInterface'!

!MethodNameEditor methodsFor: 'accessing' stamp: 'dvf 9/29/2001 14:52'!
modalView
	^modalView! !

!MethodNameEditor methodsFor: 'action' stamp: 'dvf 9/30/2001 01:51'!
addArgumentListTo: window 
	| anArgumentListMorph |
	(anArgumentListMorph := PluggableListMorph new) 
		on: self
		list: #argumentList
		selected: #argumentListIndex
		changeSelected: #argumentListIndex:
		menu: nil
		keystroke: nil.
	window addMorph: anArgumentListMorph frame: (0 @ 0.1 corner: 0.9 @ 0.7)! !

!MethodNameEditor methodsFor: 'action' stamp: 'dvf 9/30/2001 01:52'!
addDownButtonTo: window 
	window addMorph: ((PluggableButtonMorph 
				on: self
				getState: #downActivated
				action: #down)
				label: 'down';
				setBalloonText: 'move argument down';
				onColor: Color white offColor: Color lightGray)
		frame: (0.9 @ 0.4 corner: 1 @ 0.7)! !

!MethodNameEditor methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 13:21'!
argumentListIndex: anInteger
	argumentListIndex _ anInteger.
	self selectionChanged.! !

!MethodNameEditor methodsFor: 'action' stamp: 'dvf 9/1/2001 20:44'!
cancel
	self modalView delete.! !

!MethodNameEditor methodsFor: 'action' stamp: 'vd 5/19/2004 18:07'!
addSelectorPaneTo: window 
	
	bodyPane := PluggableTextMorph 
				on: self
				text: #selector
				accept: #selector:
				readSelection: nil
				menu: nil.
	bodyPane acceptOnCR: true.
	window addMorph: bodyPane frame: (0 @ 0 corner: 1.0 @ 0.1)! !

!MethodNameEditor methodsFor: 'action' stamp: 'dvf 9/30/2001 01:52'!
addPreviewPaneTo: window 
	| methodPreview |
	methodPreview := PluggableTextMorph 
				on: self
				text: #methodPreview
				accept: nil
				readSelection: nil
				menu: nil.
	window addMorph: methodPreview frame: (0 @ 0.7 corner: 1.0 @ 0.8)! !

!MethodNameEditor methodsFor: 'testing' stamp: 'dvf 9/1/2001 20:09'!
upActivated
	| newIndex |
	newIndex := argumentListIndex - 1.
	^newIndex between: 1 and: self arguments size! !

!MethodNameEditor methodsFor: 'accessing' stamp: 'dvf 9/1/2001 14:14'!
selector: aString 
	methodName selector: aString asString.
	self changed: #selector.
	self changed: #methodPreview.
	^true.! !

!MethodNameEditor methodsFor: 'as yet unclassified' stamp: 'mga 8/27/2001 01:12'!
methodName: aSelector
	methodName _ aSelector! !

!MethodNameEditor methodsFor: 'action' stamp: 'dvf 9/30/2001 01:53'!
openAsMorph
	"self new openAsMorph"

	| window |
	window := (SystemWindow labelled: 'Selector editor') model: self.
	self addSelectorPaneTo: window.
	self addArgumentListTo: window.
	self addUpButtonTo: window.
	self addDownButtonTo: window.
	self addPreviewPaneTo: window.
	self addOkButtonTo: window.
	self addCancelButtonTo: window.
	window
		center: Display center;
		extent: 100 @ 100.
	self selectionChanged.
	window openInWorld.
	window setProperty: #methodNameEditorModel toValue: self.
	^window! !

!MethodNameEditor methodsFor: 'accessing' stamp: 'dvf 9/1/2001 20:44'!
accepted
	^accepted! !

!MethodNameEditor class methodsFor: 'instance creation' stamp: 'dvf 9/1/2001 18:51'!
for: aMethodName 
	| editor newMethodName |
	newMethodName := aMethodName deepCopy.
	newMethodName arguments 
		ifNil: [newMethodName arguments: OrderedCollection new].
	newMethodName selector
		ifNil: [newMethodName selector: String new].
	editor := self new.
	editor for: newMethodName.
	^editor! !

!MethodNameEditor methodsFor: 'action' stamp: 'vd 5/19/2004 18:07'!
ok
	self okEnabled 
		ifFalse: 
			[self modalView flash.
			^self].
	self accepted: true.
	self modalView delete! !

!MethodNameEditor class methodsFor: '-- all --' stamp: 'dvf 9/1/2001 20:43'!
modalEditorForMethodName: aMethodName 
	| editor window |
	editor := self for: aMethodName.
	window := editor openAsMorph.
	editor modalView: window.
	[window world notNil] 
		whileTrue: [window outermostWorldMorph doOneCycleNow].
	^editor accepted ifFalse: [nil] ifTrue: [(window valueOfProperty: #methodNameEditorModel) methodName]! !

!MethodNameEditor methodsFor: 'action' stamp: 'dvf 9/30/2001 01:52'!
addOkButtonTo: window 
	window addMorph: ((PluggableButtonMorph 
				on: self
				getState: #okEnabled
				action: #ok)
				label: 'ok';
				setBalloonText: 'accept selector as shown in the preview';
				onColor: Color white offColor: Color lightGray)
		frame: (0 @ 0.8 corner: 0.5 @ 1)! !

!MethodNameEditor methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 20:00'!
up
	self upActivated ifFalse: [^self].
	self argumentList swap: argumentListIndex with: argumentListIndex - 1.
	self argumentListIndex: self argumentListIndex - 1.
	self selectionChanged! !

!MethodNameEditor class methodsFor: 'examples' stamp: 'mga 8/27/2001 01:36'!
example
	self new
		argumentList: #('1' '2');
		argumentListIndex: 1;
		openAsMorph
! !

!MethodNameEditor methodsFor: 'accessing' stamp: 'dvf 9/1/2001 20:46'!
methodPreview
	| stream |
	stream := String new writeStream.
	self selector numArgs > 0 
		ifTrue: 
			[self selector keywords with: self argumentList
				do: 
					[:keyword :arg | 
					stream
						nextPutAll: keyword;
						nextPut: $ ;
						nextPutAll: arg;
						nextPut: $ ]]
		ifFalse: [stream nextPutAll: self selector].
	^stream contents! !

!MethodNameEditor methodsFor: 'action' stamp: 'dvf 9/30/2001 01:53'!
addCancelButtonTo: window 
	window addMorph: ((PluggableButtonMorph 
				on: self
				getState: nil
				action: #cancel)
				label: 'cancel';
				onColor: Color white offColor: Color white)
		frame: (0.5 @ 0.8 corner: 1 @ 1)! !

!MethodNameEditor methodsFor: 'accessing' stamp: 'mga 8/27/2001 15:20'!
modalView: aSystemWindow
	modalView _ aSystemWindow
	! !

!MethodNameEditor methodsFor: 'as yet unclassified' stamp: 'mga 8/27/2001 01:12'!
methodName
	^methodName! !

!MethodNameEditor methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 02:35'!
argumentList: aCollection
	methodName argumentList: aCollection! !

!MethodNameEditor methodsFor: 'as yet unclassified' stamp: 'mga 8/27/2001 00:57'!
argumentListIndex
	^argumentListIndex! !

!MethodNameEditor methodsFor: 'action' stamp: 'dvf 9/30/2001 01:52'!
addUpButtonTo: window 
	window addMorph: ((PluggableButtonMorph 
				on: self
				getState: #upActivated
				action: #up)
				label: 'up';
				setBalloonText: 'move argument up';
				onColor: Color white offColor: Color lightGray)
		frame: (0.9 @ 0.1 corner: 1 @ 0.4)! !

!MethodNameEditor methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 20:41'!
initialize
	argumentListIndex _ 1.
	accepted _ false! !

!MethodNameEditor class methodsFor: 'instance creation' stamp: 'mga 8/27/2001 17:23'!
forMethodName: aMethodName
	^self modalEditorForMethodName: aMethodName ! !

!MethodNameEditor methodsFor: 'accessing' stamp: 'dvf 9/1/2001 02:36'!
selector
	^methodName selector! !

!MethodNameEditor methodsFor: 'as yet unclassified' stamp: 'mga 8/27/2001 11:08'!
selectionChanged
	self 
		changed: #argumentListIndex;
		changed: #argumentList;
		changed: #upActivated;
		changed: #downActivated;
		changed: #methodPreview
	! !

!MethodNameEditor methodsFor: 'accessing' stamp: 'dvf 9/1/2001 02:34'!
arguments
	^methodName arguments! !

!MethodNameEditor methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 02:32'!
for: aMethodName 
	self methodName: aMethodName! !

!MethodNameEditor methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 02:40'!
argumentList
	^ methodName arguments! !

!MethodNameEditor methodsFor: 'as yet unclassified' stamp: 'dvf 9/1/2001 20:02'!
down
	self downActivated ifFalse: [^self].
	self argumentList swap: argumentListIndex with: argumentListIndex + 1.
	self argumentListIndex: self argumentListIndex + 1.
	self selectionChanged! !

!MethodNameEditor methodsFor: 'testing' stamp: 'dvf 9/1/2001 20:10'!
downActivated
	| newIndex |
	newIndex := argumentListIndex + 1.
	^newIndex between: 1 and: self arguments size! !

!MethodNameEditor methodsFor: 'action' stamp: 'dvf 9/1/2001 20:04'!
okEnabled
	^self selector isEmpty not and: [self methodName isValid]! !

!MethodNameEditor methodsFor: 'accessing' stamp: 'vd 5/19/2004 18:08'!
accepted: anObject
	bodyPane accept.	
	accepted := anObject! !

Model variableSubclass: #MultipleSelectionModel
	instanceVariableNames: 'list selection getList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-SqueakRB-UserInterface'!

!MultipleSelectionModel methodsFor: '*Refactory-RBAddons' stamp: 'MPH 10/18/2000 17:03'!
list
	^list collect:[:each| each asString]! !

!MultipleSelectionModel methodsFor: '*Refactory-RBAddons' stamp: 'ls 11/8/2003 16:20'!
selectionsChanged
	self changed: #allSelections.
! !

!MultipleSelectionModel methodsFor: '*Refactory-RBAddons' stamp: 'MPH 10/18/2000 16:57'!
trueIndexes
	| indexList |
	indexList _ Set new.
	selection keysAndValuesDo:[:eachKey :eachValue | eachValue ifTrue: [indexList add: eachKey]].
	^indexList! !

!MultipleSelectionModel methodsFor: '*Refactory-RBAddons' stamp: 'MPH 10/23/2000 15:16'!
menu: aMenu 
	^aMenu
		add: 'Select All' action: #selectAll;
		add: 'Select None' action: #selectNone;
		yourself! !

!MultipleSelectionModel methodsFor: '*Refactory-RBAddons' stamp: 'MPH 10/22/2000 22:31'!
selectAll
	1 to: list size do:[:each | selection at: each put: true].
	self changed: #allSelections.! !

!MultipleSelectionModel methodsFor: '*Refactory-RBAddons' stamp: 'MPH 10/17/2000 21:08'!
doNothing

	^0! !

!MultipleSelectionModel methodsFor: '*Refactory-RBAddons' stamp: 'MPH 10/22/2000 21:37'!
update: anObject
	| newSelection oldSelection newList index |
	newSelection _ Dictionary new.
	newList _ anObject perform: getList.
	oldSelection _ self selectedItems collect: [:each | each asString].
	index _ 0.
	(newList collect: [:each | each asString]) do:
		[:each | index _ index + 1.
		(oldSelection includes: each) ifTrue: [newSelection at: index put: true]].
	list _ newList.
	selection _ newSelection.
	self changed: #list.
! !

!MultipleSelectionModel methodsFor: '*Refactory-RBAddons' stamp: 'MPH 10/17/2000 21:05'!
doNothing: aUselessValue! !

!MultipleSelectionModel methodsFor: '*Refactory-RBAddons' stamp: 'MPH 10/21/2000 11:51'!
list: aList message:  aSelector selection: anArray
	list _ aList.
	getList _ aSelector.
	selection _ anArray! !

!MultipleSelectionModel class methodsFor: '*Refactory-RBAddons' stamp: 'MPH 10/21/2000 11:48'!
withList: aList withMessage: aSelector

	^super new list: aList message: aSelector selection: Dictionary new! !

!MultipleSelectionModel methodsFor: '*Refactory-RBAddons' stamp: 'MPH 10/22/2000 22:23'!
perform: selector orSendTo: otherTarget

	^self perform: selector! !

!MultipleSelectionModel methodsFor: '*Refactory-RBAddons' stamp: 'MPH 10/19/2000 11:43'!
selectedItems
	| index |
	index _ 0.
	^list select:
		[:each | index _ index + 1.
		 self listSelectionAt: index]! !

!MultipleSelectionModel methodsFor: '*Refactory-RBAddons' stamp: 'MPH 10/18/2000 16:12'!
listSelectionAt: anIndex

	^selection at: anIndex ifAbsent:[^false]! !

!MultipleSelectionModel methodsFor: '*Refactory-RBAddons' stamp: 'ls 11/8/2003 16:20'!
listSelectionAt: anIndex put: aValue 
	selection at: anIndex put: aValue.
	self selectionsChanged! !

!MultipleSelectionModel methodsFor: '*Refactory-RBAddons' stamp: 'MPH 10/18/2000 18:34'!
anySelected
	^selection includes:true.! !

!MultipleSelectionModel class methodsFor: '*Refactory-RBAddons' stamp: 'MPH 10/21/2000 11:49'!
withList: aList

	^super new list: aList message: nil selection: Dictionary new! !

!MultipleSelectionModel methodsFor: '*Refactory-RBAddons' stamp: 'MPH 10/22/2000 22:30'!
selectNone
	selection _ Dictionary new.
	self changed: #allSelections.! !

Model subclass: #ClassToRename
	instanceVariableNames: 'rewriteRule builder class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Test data'!

ClassToRename class
	instanceVariableNames: 'notUsed'!

!ClassToRename methodsFor: 'performing' stamp: ''!
method2
	^self method1! !

!ClassToRename methodsFor: 'performing' stamp: ''!
method1
	^self method2! !

ClassToRename subclass: #SubclassOfClassToRename
	instanceVariableNames: 'rewriteRule1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactory-Test data'!

!SubclassOfClassToRename methodsFor: 'performing' stamp: ''!
reference
	^ClassToRename new! !

!SubclassOfClassToRename methodsFor: 'accessing' stamp: ''!
name
	^rewriteRule1! !

!SubclassOfClassToRename methodsFor: 'accessing' stamp: ''!
calls1
	^self rewriteRule1: (self rewriteRule1: self calls)! !

!SubclassOfClassToRename methodsFor: 'accessing' stamp: ''!
rewriteRule1: anObject
	^rewriteRule1 := anObject! !

!SubclassOfClassToRename methodsFor: 'accessing' stamp: ''!
calls
	^self rewriteRule1: self name , self rewriteRule1! !

!SubclassOfClassToRename methodsFor: 'accessing' stamp: ''!
rewriteRule1
	^rewriteRule1! !

!SubclassOfClassToRename methodsFor: 'performing' stamp: ''!
symbolReference
	^#ClassToRename! !

!SystemDictionary methodsFor: '*Refactory-RBAddonsReasonable' stamp: ''!
keyNotFoundError: aKey

	self error:'key ',aKey printString,' was not found'.! !

!Behavior methodsFor: '*Refactory-RBBehaviorQueries' stamp: 'dvf 9/17/2001 00:18'!
whichClassDefinesClassVar: aString 
	^self whichSuperclassSatisfies: 
			[:aClass | 
			(aClass classVarNames collect: [:each | each asString]) 
				includes: aString asString]! !

!Behavior methodsFor: '*Refactory-RBAddons' stamp: 'dvf 11/12/2002 00:44'!
bindingFor: aString 

	aString ifNil:[^nil].
	^ self classPool associationAt: aString asSymbol ifAbsent: [self classPool associationAt: aString asString ifAbsent: []]! !

!Behavior methodsFor: '*Refactory-RBBehaviorQueries' stamp: 'bh 3/6/2000 00:51'!
whichSelectorsAssign: instVarName 
	"Answer a Set of selectors whose methods store into the argument, 
	instVarName, as a named instance variable."
	^self whichSelectorsStoreInto: instVarName! !

!Behavior methodsFor: '*Refactory-RBBehaviorQueries' stamp: 'dvf 9/17/2001 00:18'!
whichClassDefinesInstVar: aString 
	^self 
		whichSuperclassSatisfies: [:aClass | aClass instVarNames includes: aString]! !

!Behavior methodsFor: '*Refactory-RBModel' stamp: ''!
parseTreeFor: aSymbol 
	^RBParser parseMethod: (self sourceCodeAt: aSymbol)
		onError: [:aString :pos | ^nil]! !

!Behavior methodsFor: '*Refactory-RBAddons' stamp: 'bh 3/17/2000 00:36'!
fullBindingFor: varName
	"Look up varName in this class, its superclasses, and its environment.  If it is there,
	answer the variable binding, else answer nil."

	| assoc |
	assoc := self bindingFor: varName.
	assoc == nil ifFalse: [^assoc].
	^self environment bindingFor: varName! !

!Behavior methodsFor: '*Refactory-RBBehaviorQueries' stamp: 'bh 3/6/2000 00:52'!
whichSelectorsRead: instVarName 
	"Answer a Set of selectors whose methods access the argument, 
	instVarName, as a named instance variable."
	^self whichSelectorsAccess: instVarName! !

!Behavior methodsFor: '*Refactory-RBBehaviorQueries' stamp: 'dvf 9/17/2001 00:18'!
whichSuperclassSatisfies: aBlock 
	(aBlock value: self) ifTrue: [^self].
	^superclass isNil 
		ifTrue: [nil]
		ifFalse: [superclass whichSuperclassSatisfies: aBlock]! !

!SharedPool class methodsFor: '*Refactory-DictionaryCompatibility' stamp: 'dvf 9/17/2003 03:10'!
keys
	^self classPool keys! !

!TranscriptStream methodsFor: '*Refactory-RBAddons' stamp: 'dvf 11/12/2002 00:47'!
flush

	"do nothing"
! !
RBParser initialize!
RBAbstractClass initialize!
FinderTool initialize!
RefactoryChangeManager initialize!
RBScanner initialize!
RefactoringBrowser initialize!
LintDialog initialize!
